package gov.va.capri;

import java.io.File;
import java.util.concurrent.Callable;

public class AuthTask implements Callable<Boolean> {

    private ProcessBuilder processBuilder;
    private Process process;

	public AuthTask(ProcessBuilder processBuilder) {
		this.processBuilder = processBuilder;
    }

	public Boolean call() throws Exception {
		if (processBuilder == null)
            return false;

		ProxyServlet.log.debug("Executing Authorization... " + System.currentTimeMillis());

        process = processBuilder.start();
        int exitCode = process.waitFor();

        ProxyServlet.log.debug("Authorization Done... " + System.currentTimeMillis());

		return exitCode == 0;
	}

    public Process getProcess() {
        return process;
    }

}