unit MainForm;

interface

uses
  System.Classes
  , Vcl.Forms
  , Vcl.ExtCtrls
  ;

type
  TfrmMain = class(TForm)
    SelfFailureCloseTimer: TTimer;
    SelfSuccessCloseTimer: TTimer;
    SelfFailureForceCloseTimer: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure SelfFailureCloseTimerTimer(Sender: TObject);
    procedure SelfSuccessCloseTimerTimer(Sender: TObject);
    procedure SelfFailureForceCloseTimerTimer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

uses
  uBrokerMethods;

procedure TfrmMain.FormCreate(Sender: TObject);
var
  SecToken: String;
  ix : smallint;
begin
  // ExitCode := 0;  Default
  SecToken := ParamStr(1);
  for ix := 1 to ParamCount - 1 do begin
    SecToken := SecToken + '^' + ParamStr(ix+1)
  end;

  self.Caption := SecToken;
  Self.SelfFailureCloseTimer.Enabled := true;
  Self.SelfFailureForceCloseTimer.Enabled := true;

  if not IsTokenValidu(SecToken) then ExitCode := 1;  // Return exit code from of 0 is success and anything else is failure.
  // LMS - Observations from the field.. sometimes, this is just timing out, even on valid requests and valid server.
  // TODO: So a retry to a second VistA server would be very helpful.

  //self.SelfSuccessCloseTimer.Enabled := true;
  Application.Terminate; // This cleans up enough
end;

procedure TfrmMain.SelfFailureCloseTimerTimer(Sender: TObject);
begin
  ExitCode := 1;
  //Application.messagebox('Sample delay', 'Above login dialog or not?');
  Application.Terminate;
end;

procedure TfrmMain.SelfFailureForceCloseTimerTimer(Sender: TObject);
begin
  System.Halt(1);    // first timer did not kill the app.
end;

procedure TfrmMain.SelfSuccessCloseTimerTimer(Sender: TObject);
begin
  Application.Terminate;
end;

end.
