unit uBrokerMethods;

interface
  function IsTokenValidu(SecToken: string) : boolean;

implementation

uses
  Trpcb
  , SysUtils
  , IniFiles
  // , ShellAPI
  // , forms
  ;
const
  VLERAUTHKEY: String = 'The universe is equally as expansive within as without';
  //CLMNSKEY: String = 'Action is the real measure of intelligence. -- Napolean Hill';
  WAIT_Time_ForLoginSuccess : Integer = 30000;  // 30 seconds

var
  RemoteBroker : TRPCBroker ;
  ApplicationExeName : string;


Procedure SetupRemoteBroker(RemoteBroker: TRPCBroker );
var
  ini: TIniFile;
  ClaimsServer, TestClaimsServer, TempStr: String;
  ClaimsPort, TestClaimsPort: Integer;
  IsProductionServer: Boolean;
begin
  ini := TIniFile.Create(System.Copy(ApplicationExeName, 0, Length(ApplicationExeName) - 4) + '.ini');
  try
    ClaimsServer := ini.ReadString('Servers', 'ClaimsServer', 'claims.forum.domain');
    TestClaimsServer := ini.ReadString('Servers', 'TestClaimsServer', 'vista.server.domain.ext');
    TempStr := ini.ReadString('Servers', 'ClaimsPort', '9400');
    ClaimsPort := StrToInt(TempStr);
    TempStr := ini.ReadString('Servers', 'TestClaimsPort', '9401');
    TestClaimsPort := StrToInt(TempStr);
    IsProductionServer := ini.ReadBool('Machine', 'IsProductionServer', False);

    with  RemoteBroker do
    if IsProductionServer then
      begin
        Server := ClaimsServer;
        ListenerPort := ClaimsPort;
      end
    else
      begin
        Server := TestClaimsServer;
        ListenerPort := TestClaimsPort;
      end;
  finally
    ini.Free;
  end;
end;

function IsTokenValidu(SecToken: string) : boolean;
begin
  Result := false;
  ApplicationExeName := ParamStr(0);
  try
    RemoteBroker := TRPCBroker.Create(nil);     // it's owner has to be the thread
    try
      RemoteBroker.Connected := false;

      RemoteBroker.ClearParameters := true;
      RemoteBroker.ClearResults := true;
      RemoteBroker.IsBackwardCompatibleConnection := false;
      RemoteBroker.OldConnectionOnly := false;

      RemoteBroker.ShowErrorMsgs := semQuiet;

      RemoteBroker.KernelLogIn := true;
      RemoteBroker.LogIn.Mode := lmAVCodes;
      RemoteBroker.LogIn.PromptDivision := false;

      SetupRemoteBroker(RemoteBroker);
      RemoteBroker.SecurityPhrase := VLERAUTHKEY + '^' + SecToken;

      RemoteBroker.Connected := True;

      if RemoteBroker.Connected then Result := true;

    finally
      RemoteBroker.Free;
    end;
  except
    on E: Exception do
  end;

end;
end.
