unit FiveZeroEightMessages;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  ComCtrls,
  Tabnotbk,
  CAPRISupport,
  OleServer,
  SpeechLib_TLB;

type
  Tfrm508Messages = class(TForm)
    ButtonCancel: TButton;
    Button1: TButton;
    TabbedNotebook1: TTabbedNotebook;
    Label4: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    Label10: TLabel;
    MemoHelpCurrentDialog: TMemo;
    MemoAutoCurrentDialog: TMemo;
    MemoAutoCurrentControl: TMemo;
    EditCurrentControl: TEdit;
    EditCurrentDialog: TEdit;
    MemoHelpCurrentControl: TMemo;
    RichEditRaw508Messages: TRichEdit;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    SpVoice1: TSpVoice;
    procedure Button1Click(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ClearExtraLines;
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure AddMessages;
    procedure FindMatchForControls;
    procedure FindandRemoveMatchForControls;
  end;

var
  frm508Messages: Tfrm508Messages;

implementation

uses main;

{$R *.DFM}

procedure Tfrm508Messages.ClearExtraLines;
var
  x: integer;
begin
  //Clear Extra Lines
  if MemoHelpCurrentDialog.Text <> '' then
    for x := MemoHelpCurrentDialog.Lines.Count - 1 downto 0 do
      if MemoHelpCurrentDialog.Lines[x] = '' then
        MemoHelpCurrentDialog.Lines.Delete(x)
      else
        break;
  if MemoAutoCurrentDialog.Text <> '' then
    for x := MemoAutoCurrentDialog.Lines.Count - 1 downto 0 do
      if MemoAutoCurrentDialog.Lines[x] = '' then
        MemoAutoCurrentDialog.Lines.Delete(x)
      else
        break;
  if MemoHelpCurrentControl.Text <> '' then
    for x := MemoHelpCurrentControl.Lines.Count - 1 downto 0 do
      if MemoHelpCurrentControl.Lines[x] = '' then
        MemoHelpCurrentControl.Lines.Delete(x)
      else
        break;
  if MemoAutoCurrentControl.Text <> '' then
    for x := MemoAutoCurrentControl.Lines.Count - 1 downto 0 do
      if MemoAutoCurrentControl.Lines[x] = '' then
        MemoAutoCurrentControl.Lines.Delete(x)
      else
        break;
end;

procedure Tfrm508Messages.AddMessages;
var
  //x: integer;
  //tempstring: string;
  endstring: string;
begin
  // EditCurrentControl
  // EditCurrentDialog

  // MemoHelpCurrentDialog
  // MemoAutoCurrentDialog

  // MemoHelpCurrentControl
  // MemoAutoCurrentControl

  // AMC = Auto Message, Control
  // AMD = Auto Message, Dialog
  // HMC = Help Message, Control
  // HMD = Help Message, Dialog

  ClearExtraLines;

  endString := '!@#$END$#@!';

  if MemoHelpCurrentDialog.Text <> '' then begin
    RichEditRaw508Messages.Lines.Add('HMD.' + EditCurrentDialog.Text);
    RichEditRaw508Messages.Lines.Add(MemoHelpCurrentDialog.Text);
    RichEditRaw508Messages.Lines.Add(endString);
  end;
  if MemoAutoCurrentDialog.Text <> '' then begin
    RichEditRaw508Messages.Lines.Add('AMD.' + EditCurrentDialog.Text);
    RichEditRaw508Messages.Lines.Add(MemoAutoCurrentDialog.Text);
    RichEditRaw508Messages.Lines.Add(endString);
  end;
  if MemoHelpCurrentControl.Text <> '' then begin
    RichEditRaw508Messages.Lines.Add('HMC.' + EditCurrentDialog.Text + '.' + EditCurrentControl.Text);
    RichEditRaw508Messages.Lines.Add(MemoHelpCurrentControl.Text);
    RichEditRaw508Messages.Lines.Add(endString);
  end;
  if MemoAutoCurrentControl.Text <> '' then begin
    RichEditRaw508Messages.Lines.Add('AMC.' + EditCurrentDialog.Text + '.' + EditCurrentControl.Text);
    RichEditRaw508Messages.Lines.Add(MemoAutoCurrentControl.Text);
    RichEditRaw508Messages.Lines.Add(endString);
  end;

end;

procedure Tfrm508Messages.FindMatchForControls;
var
  x: integer;
  tempstring: string;
  endstring: string;
begin
  // EditCurrentControl
  // EditCurrentDialog

  // MemoHelpCurrentDialog
  // MemoAutoCurrentDialog

  // MemoHelpCurrentControl
  // MemoAutoCurrentControl

  // AMC = Auto Message, Control
  // AMD = Auto Message, Dialog
  // HMC = Help Message, Control
  // HMD = Help Message, Dialog

  endString := '!@#$END$#@!';

  if RichEditRaw508Messages.Lines.Count > 0 then begin
    x := 0;
    repeat
      tempstring := RichEditRaw508Messages.Lines[x];
      if (Uppercase(Piece(tempstring, '.', 1)) = 'AMD') and (Uppercase(Piece(tempstring, '.', 2)) = Uppercase(EditCurrentDialog.Text)) then begin
        repeat
          inc(x);
          tempstring := RichEditRaw508Messages.Lines[x];
          if tempstring <> endstring then
            MemoAutoCurrentDialog.Lines.Add(tempstring);
        until tempstring = endstring;
      end;
      if (Uppercase(Piece(tempstring, '.', 1)) = 'HMD') and (Uppercase(Piece(tempstring, '.', 2)) = Uppercase(EditCurrentDialog.Text)) then begin
        repeat
          inc(x);
          tempstring := RichEditRaw508Messages.Lines[x];
          if tempstring <> endstring then
            MemoHelpCurrentDialog.Lines.Add(tempstring);
        until tempstring = endstring;
      end;
      if (Uppercase(Piece(tempstring, '.', 1)) = 'AMC') and (Uppercase(Piece(tempstring, '.', 2)) = Uppercase(EditCurrentDialog.Text)) and (Uppercase(Piece(tempstring, '.', 3)) = Uppercase(EditCurrentControl.Text)) then begin
        repeat
          inc(x);
          tempstring := RichEditRaw508Messages.Lines[x];
          if tempstring <> endstring then
            MemoAutoCurrentControl.Lines.Add(tempstring);
        until tempstring = endstring;
      end;
      if (Uppercase(Piece(tempstring, '.', 1)) = 'HMC') and (Uppercase(Piece(tempstring, '.', 2)) = Uppercase(EditCurrentDialog.Text)) and (Uppercase(Piece(tempstring, '.', 3)) = Uppercase(EditCurrentControl.Text)) then begin
        repeat
          inc(x);
          tempstring := RichEditRaw508Messages.Lines[x];
          if tempstring <> endstring then
            MemoHelpCurrentControl.Lines.Add(tempstring);
        until tempstring = endstring;
      end;
      inc(x);
    until x >= RichEditRaw508Messages.Lines.Count;
  end;

  ClearExtraLines;

end;

procedure Tfrm508Messages.FindAndRemoveMatchForControls;
var
  x: integer;
  tempstring: string;
  endstring: string;
begin
  // EditCurrentControl
  // EditCurrentDialog

  // MemoHelpCurrentDialog
  // MemoAutoCurrentDialog

  // MemoHelpCurrentControl
  // MemoAutoCurrentControl

  // AMC = Auto Message, Control
  // AMD = Auto Message, Dialog
  // HMC = Help Message, Control
  // HMD = Help Message, Dialog

  endString := '!@#$END$#@!';

  if RichEditRaw508Messages.Lines.Count > 0 then begin
    x := 0;
    repeat
      tempstring := RichEditRaw508Messages.Lines[x];
      if (Uppercase(Piece(tempstring, '.', 1)) = 'AMD') and (Uppercase(Piece(tempstring, '.', 2)) = Uppercase(EditCurrentDialog.Text)) then begin
        repeat
          RichEditRaw508Messages.Lines.Delete(x);
          tempstring := RichEditRaw508Messages.Lines[x];
        until tempstring = endstring;
        RichEditRaw508Messages.Lines.Delete(x);
        dec(x);
      end;
      if (Uppercase(Piece(tempstring, '.', 1)) = 'HMD') and (Uppercase(Piece(tempstring, '.', 2)) = Uppercase(EditCurrentDialog.Text)) then begin
        repeat
          RichEditRaw508Messages.Lines.Delete(x);
          tempstring := RichEditRaw508Messages.Lines[x];
        until tempstring = endstring;
        RichEditRaw508Messages.Lines.Delete(x);
        dec(x);
      end;
      if (Uppercase(Piece(tempstring, '.', 1)) = 'AMC') and (Uppercase(Piece(tempstring, '.', 2)) = Uppercase(EditCurrentDialog.Text)) and (Uppercase(Piece(tempstring, '.', 3)) = Uppercase(EditCurrentControl.Text)) then begin
        repeat
          RichEditRaw508Messages.Lines.Delete(x);
          tempstring := RichEditRaw508Messages.Lines[x];
        until tempstring = endstring;
        RichEditRaw508Messages.Lines.Delete(x);
        dec(x);
      end;
      if (Uppercase(Piece(tempstring, '.', 1)) = 'HMC') and (Uppercase(Piece(tempstring, '.', 2)) = Uppercase(EditCurrentDialog.Text)) and (Uppercase(Piece(tempstring, '.', 3)) = Uppercase(EditCurrentControl.Text)) then begin
        repeat
          RichEditRaw508Messages.Lines.Delete(x);
          tempstring := RichEditRaw508Messages.Lines[x];
        until tempstring = endstring;
        RichEditRaw508Messages.Lines.Delete(x);
        dec(x);
      end;
      inc(x);
    until x >= RichEditRaw508Messages.Lines.Count;
  end;
end;

procedure Tfrm508Messages.Button1Click(Sender: TObject);
begin
  FindAndRemoveMatchForControls;
  AddMessages;
  ModalResult := idOK;
end;

procedure Tfrm508Messages.ButtonCancelClick(Sender: TObject);
begin
  ModalResult := idCancel;
end;

procedure Tfrm508Messages.FormHide(Sender: TObject);
begin
  frm508Messages.RichEditRaw508Messages.Lines.SaveToFile(extractfilepath(application.exename) + 'CAPRI508Messages.txt');
end;

procedure Tfrm508Messages.FormShow(Sender: TObject);
begin
  MemoHelpCurrentDialog.Lines.Clear;
  MemoAutoCurrentDialog.Lines.Clear;
  MemoHelpCurrentControl.Lines.Clear;
  MemoAutoCurrentControl.Lines.Clear;
  FindMatchForControls;
end;

procedure Tfrm508Messages.Button2Click(Sender: TObject);
begin
  frmMain.SPVoice1.Speak(MemoHelpCurrentDialog.Text, SVSFlagsAsync + SVSFPurgeBeforeSpeak);
end;

procedure Tfrm508Messages.Button3Click(Sender: TObject);
begin
  frmMain.SPVoice1.Speak(MemoAutoCurrentDialog.Text, SVSFlagsAsync + SVSFPurgeBeforeSpeak);
end;

procedure Tfrm508Messages.Button4Click(Sender: TObject);
begin
  frmMain.SPVoice1.Speak(MemoHelpCurrentControl.Text, SVSFlagsAsync + SVSFPurgeBeforeSpeak);
end;

procedure Tfrm508Messages.Button5Click(Sender: TObject);
begin
  frmMain.SPVoice1.Speak(MemoAutoCurrentControl.Text, SVSFlagsAsync + SVSFPurgeBeforeSpeak);
end;

end.
