{**********************************************************************}
{ File archived using GP-Version                                       }
{ GP-Version is Copyright 1999 by Quality Software Components Ltd      }
{                                                                      }
{ For further information / comments, visit our WEB site at            }
{ http://www.qsc.co.uk                                                 }
{**********************************************************************}
{}
{ $Log:  F:\Program Files\GP Version\Archives\ISIS\Delphi\MemForm.paV
{
{   Rev 1.0    3/12/00 4:08:43 AM  Wayne
{ Changed the primary key display fields so that they are
{ fkdata in the ds and the ProviderFlag of the ds is false.
{ Further, made all the display fields writable and updated on
{ all edits.
}
{}
UNIT MemForm;

INTERFACE

USES
   Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
   Grids, ExtCtrls, StdCtrls, Buttons, lmdclass, LMDCustomComponent, LMDSysInfo;

TYPE
   TfrmMemStatus = CLASS(TForm)
      StringGrid1: TStringGrid;
      Timer1: TTimer;
      StringGrid2: TStringGrid;
      btnClose: TBitBtn;
      StaticText1: TStaticText;
      StaticText2: TStaticText;
      LMDSysInfo: TLMDSysInfo;
      PROCEDURE FormCreate(Sender: TObject);
      PROCEDURE Timer1Timer(Sender: TObject);
      PROCEDURE BtnStringClick(Sender: TObject);
      PROCEDURE BtnStringListClick(Sender: TObject);
      PROCEDURE BtnFormClick(Sender: TObject);
      PROCEDURE BtnSmallAllocClick(Sender: TObject);
      PROCEDURE BtnBigAllocClick(Sender: TObject);
      PROCEDURE btnCloseClick(Sender: TObject);
      PROCEDURE FormClose(Sender: TObject; VAR Action: TCloseAction);
      PROCEDURE FormDestroy(Sender: TObject);
   PRIVATE
      PROCEDURE UpdateStatus;
   PUBLIC
      s: STRING;
      sl: TStringList;
      f: TForm;
   END;

VAR
   frmMemStatus: TfrmMemStatus;

IMPLEMENTATION

{$R *.DFM}

PROCEDURE TfrmMemStatus.UpdateStatus;
VAR
   MemStatus: TMemoryStatus;
   HeapStatus: THeapStatus;
BEGIN
   MemStatus.dwLength := sizeof(TMemoryStatus);
   GlobalMemoryStatus(MemStatus);
   WITH MemStatus DO BEGIN
      // load
      StringGrid1.Cells[1, 0] := IntToStr(dwMemoryLoad) + '%';

      // RAM (total, free, load)
      StringGrid1.Cells[1, 1] := FloatToStrF(
         dwTotalPhys / 1024,
         ffNumber, 20, 0) + ' Kbytes';
      StringGrid1.Cells[1, 2] := FloatToStrF(
         dwAvailPhys / 1024,
         ffNumber, 20, 0) + ' Kbytes';
      StringGrid1.Cells[1, 3] := IntToStr(100 -
         dwAvailPhys DIV (dwTotalPhys DIV 100)) + '%';

      // page file (total, free, load)
      StringGrid1.Cells[1, 4] := FloatToStrF(
         dwTotalPageFile / 1024,
         ffNumber, 20, 0) + ' Kbytes';
      StringGrid1.Cells[1, 5] := FloatToStrF(
         dwAvailPageFile / 1024,
         ffNumber, 20, 0) + ' Kbytes';
      StringGrid1.Cells[1, 6] := IntToStr(100 -
         dwAvailPageFile DIV (dwTotalPageFile DIV 100)) + '%';

      // page file (total, used, free)
  //    StringGrid1.Cells[1, 7] := FloatToStrF(
  //      dwTotalVirtual / 1024,
  //      ffNumber, 20, 0) + ' Kbytes';
  //    StringGrid1.Cells[1, 8] := FloatToStrF(
  //      dwAvailVirtual / 1024,
  //      ffNumber, 20, 0) + ' Kbytes';
  //    StringGrid1.Cells[1, 9] := FloatToStrF(
  //      (dwTotalVirtual - dwAvailVirtual) / 1024,
  //      ffNumber, 20, 0) + ' Kbytes';

      StringGrid1.Cells[1, 7] := LMDSysInfo.FreeGdiRes;
      StringGrid1.Cells[1, 8] := LMDSysInfo.FreeUsrRes;
      StringGrid1.Cells[1, 9] := LMDSysInfo.FreeSysRes;

   END;   // with MemStatus

   HeapStatus := GetHeapStatus;
   WITH HeapStatus DO BEGIN
      StringGrid2.Cells[1, 0] := FloatToStrF(
         TotalAddrSpace DIV 1024,
         ffNumber, 20, 0) + ' Kbytes';
      StringGrid2.Cells[1, 1] := FloatToStrF(
         TotalUncommitted DIV 1024,
         ffNumber, 20, 0) + ' Kbytes';
      StringGrid2.Cells[1, 2] := FloatToStrF(
         TotalCommitted DIV 1024,
         ffNumber, 20, 0) + ' Kbytes';
      StringGrid2.Cells[1, 3] := FloatToStrF(
         TotalFree DIV 1024,
         ffNumber, 20, 0) + ' Kbytes';
      StringGrid2.Cells[1, 4] := FloatToStrF(
         TotalAllocated DIV 1024,
         ffNumber, 20, 0) + ' Kbytes';
      StringGrid2.Cells[1, 5] := IntToStr(
         TotalAllocated DIV (TotalAddrSpace DIV 100)) + '%';
      StringGrid2.Cells[1, 6] := FloatToStrF(
         FreeSmall DIV 1024,
         ffNumber, 20, 0) + ' Kbytes';
      StringGrid2.Cells[1, 7] := FloatToStrF(
         FreeBig DIV 1024,
         ffNumber, 20, 0) + ' Kbytes';
      StringGrid2.Cells[1, 8] := FloatToStrF(
         Unused DIV 1024,
         ffNumber, 20, 0) + ' Kbytes';
      StringGrid2.Cells[1, 9] := FloatToStrF(
         Overhead DIV 1024,
         ffNumber, 20, 0) + ' Kbytes';
   END;
END;

PROCEDURE TfrmMemStatus.FormCreate(Sender: TObject);
BEGIN
   StringGrid1.Cells[0, 0] := 'Memory load';
   StringGrid1.Cells[0, 1] := 'Physical memory';
   StringGrid1.Cells[0, 2] := 'Free physical memory';
   StringGrid1.Cells[0, 3] := 'RAM load';
   StringGrid1.Cells[0, 4] := 'Maximum size of paging file';
   StringGrid1.Cells[0, 5] := 'Available in paging file';
   StringGrid1.Cells[0, 6] := 'Paging file load';
   StringGrid1.Cells[0, 7] := 'GDI Resourses Available';
   StringGrid1.Cells[0, 8] := 'User Resources Available ';
   StringGrid1.Cells[0, 9] := 'System Resources Available';

   StringGrid2.Cells[0, 0] := 'Available address space ';
   StringGrid2.Cells[0, 1] := 'Uncommitted portion';
   StringGrid2.Cells[0, 2] := 'Committed portion';
   StringGrid2.Cells[0, 3] := 'Free portion';
   StringGrid2.Cells[0, 4] := 'Allocated portion';
   StringGrid2.Cells[0, 5] := 'Address space load';
   StringGrid2.Cells[0, 6] := 'Total small free blocks';
   StringGrid2.Cells[0, 7] := 'Total big free blocks';
   StringGrid2.Cells[0, 8] := 'Other unused blocks';
   StringGrid2.Cells[0, 9] := 'Total overhead';

   UpdateStatus;
END;

PROCEDURE TfrmMemStatus.Timer1Timer(Sender: TObject);
BEGIN
   UpdateStatus;
END;

PROCEDURE TfrmMemStatus.BtnStringClick(Sender: TObject);
BEGIN
   // 10 megabytes
   SetLength(s, 10000000);
   UpdateStatus;
END;

PROCEDURE TfrmMemStatus.BtnStringListClick(Sender: TObject);
VAR
   I      : Integer;
BEGIN
   sl := TStringList.Create;
   // add one thousand strings
   FOR I := 0 TO 1000 DO
      sl.Add('hello');
   // destroy some of them
   FOR I := 300 DOWNTO 1 DO
      sl.Delete(I * 3);
   UpdateStatus;
END;

PROCEDURE TfrmMemStatus.BtnFormClick(Sender: TObject);
VAR
   I      : Integer;
BEGIN
   // create ten forms
   FOR I := 1 TO 10 DO
      F := TForm.Create(Application);
   UpdateStatus;
END;

PROCEDURE TfrmMemStatus.BtnSmallAllocClick(Sender: TObject);
VAR
   P      : Pointer;
BEGIN
   GetMem(P, 100);
   Integer(P^) := 10;
   UpdateStatus;
END;

PROCEDURE TfrmMemStatus.BtnBigAllocClick(Sender: TObject);
VAR
   P      : Pointer;
BEGIN
   GetMem(P, 100000);
   Integer(P^) := 10;
   UpdateStatus;
END;

PROCEDURE TfrmMemStatus.btnCloseClick(Sender: TObject);
BEGIN
   Close;
END;      { BitBtn1Click }

PROCEDURE TfrmMemStatus.FormClose(Sender: TObject;
   VAR Action: TCloseAction);
BEGIN
   Action := caFree;
END;      { FormClose }

PROCEDURE TfrmMemStatus.FormDestroy(Sender: TObject);
BEGIN
   frmMemStatus := NIL;
END;      { FormDestroy }

END.

