unit VlerDasClientThread;

interface

uses Classes, VlerDasClient, XMLIntf, SysUtils, ActiveX;

type
  TVlerDasClientThread = class(TThread)
    private
      FVlerDasClient: TfVlerDasClient;
      FXmlDocument: IXMLDocument;
      FDocumentIdentificationID: String;
      FVlerDasClientResult: TStringList;
      FException: Exception;
    protected
      procedure Execute; override;
    public
      constructor Create(vlerDasClient: TfVlerDasClient); 
      destructor Destroy; override;

      property VlerDasClient: TfVlerDasClient read FVlerDasClient;
      property XmlDocument: IXMLDocument read FXmlDocument write FXmlDocument;
      property DocumentIdentificationID: String read FDocumentIdentificationID write FDocumentIdentificationID;
      property VlerDasClientResult: TStringList read FVlerDasClientResult write FVlerDasClientResult;
      property AnException: Exception read FException;
  end;

implementation

constructor TVlerDasClientThread.Create(vlerDasClient: TfVlerDasClient);
begin
  inherited Create(True);
  FVlerDasClient := vlerDasClient;
  FreeOnTerminate := False;
end;

destructor TVlerDasClientThread.Destroy;
begin
  inherited;
end;

procedure TVlerDasClientThread.Execute;
begin
  try
    CoInitialize(Nil);

    try
      VlerDasClient.Show;
      VlerDasClient.BringToFront;
      VlerDasClient.Repaint;
      VlerDasClientResult.Text := VlerDasClient.ProvideAndRegisterDocumentSetRequest(XmlDocument, DocumentIdentificationID);
      VlerDasClient.Close;
    except
      on E: Exception do
      begin
        FException := Exception.Create(E.Message);
      end;
    end;

    if VlerDasClient.Showing then
      VlerDasClient.Close;

  finally
    CoUninitialize;
  end;
end;

end.
