unit XsdComplexType;

interface

uses Classes, SysUtils;

type
  TXsdComplexType = class
    private

    public
      XmlTag: String;

      CodeAttribute: String;
      CodeSystemAttribute: String;
      VersionAttribute: String;
      SourceAttribute: String;
      RequiredXml: Boolean;

      function toXsdEngineValue: String;
    published
      constructor Create(valueFromXsdEngine: String); overload;

  end;

implementation

constructor TXsdComplexType.Create(valueFromXsdEngine: String);
var
  StringList: TStringList;
begin
  if Length(valueFromXsdEngine) = 0 then
    Exit;

  StringList := TStringList.Create;
  StringList.Delimiter := '^';
  StringList.StrictDelimiter := True;
  StringList.DelimitedText := valueFromXsdEngine;

  XmlTag := StringList[0];
  CodeAttribute := StringList[1];
  CodeSystemAttribute := StringList[2];
  VersionAttribute := StringList[3];
  SourceAttribute := StringList[4];

  if StringList.Count >= 6 then
    RequiredXml := StrToBool(StringList[5])
  else
    RequiredXml := False;
end;

function TXsdComplexType.toXsdEngineValue: String;
const
  DELIMETER = '^';
begin
  Result := XmlTag + DELIMETER + CodeAttribute + DELIMETER +
              CodeSystemAttribute + DELIMETER + VersionAttribute + DELIMETER +
              SourceAttribute + DELIMETER + BoolToStr(RequiredXml);
end;

end.

