Unit alerts;

Interface

Uses
  Windows,
  Buttons,
  Classes,
  Controls,
  Dialogs,
  DialogsCAPRI,
  ExtCtrls,
  Forms,
  Graphics,
  Grids,
  Messages,
  StdCtrls,
  SysUtils,
  Trpcb;

Type
  TfrmAlerts = Class(TForm)
    BitBtnContinue  : TBitBtn;
    ButtonResolve   : TButton;
    ButtonReview    : TButton;
    ButtonUncosigned: TButton;
    ButtonUnsigned  : TButton;
    EditResolve     : TEdit;
    EditReview      : TEdit;
    EditUncosigned  : TEdit;
    EditUnsigned1   : TEdit;
    EditUnsigned2   : TEdit;
    EditUnsigned3   : TEdit;
    Shape1          : TShape;
    Shape2          : TShape;
    Shape3          : TShape;
    shpResolve: TShape;
    btnManifests: TButton;
    edtManifests: TEdit;
    shpManifests: TShape;
    Procedure BitBtnContinueClick(Sender: TObject);
    Procedure ButtonResolveClick(Sender: TObject);
    Procedure ButtonReviewClick(Sender: TObject);
    Procedure ButtonUncosignedClick(Sender: TObject);
    Procedure ButtonUnsignedClick(Sender: TObject);
    procedure btnManifestsClick(Sender: TObject);
  Private
    { Private declarations }
  Public
    { Public declarations }
  End;

Var
  frmAlerts: TfrmAlerts;

Implementation

Uses
  main,
  tiucosignature,
  uncosignedutility,
  unsigned,
  manifests,
  CCOWRPCBrokerCAPRI;

{$R *.DFM}

Procedure TfrmAlerts.ButtonUnsignedClick(Sender: TObject);
Var
  unsigneddraft    : integer;
  unsignedsentback : integer;
  unsignedsignature: integer;
  x                : integer;
Begin
  If ANURemoteProcedureCallInProgress Then
    exit;

  UnsignedView.Visible := False;
  If (sender <> frmMain) Then
  Begin
    UnsignedView.Button5Click(Application);
    UnsignedView.ShowModal;
    //rebuild the list in case someone changed the list on UnsignedView
    UnsignedView.Button5Click(Application);
  End;

  If UnsignedView.FMListBoxIPR1.Items.Count = 0 Then
  Begin
    frmAlerts.EditUnsigned1.enabled := false;
    frmAlerts.EditUnsigned2.enabled := false;
    frmAlerts.EditUnsigned3.enabled := false;
    frmAlerts.EditUnsigned1.Text := 'You have no draft templates.';
    frmAlerts.EditUnsigned2.Text := 'You have no templates awaiting signature.';
    frmAlerts.EditUnsigned3.Text := 'You have no templates sent back from the reviewer.';
    frmAlerts.buttonUnsigned.enabled := False;
  End;

  frmAlerts.EditUnsigned1.Text := 'You have no draft templates.';
  frmAlerts.EditUnsigned2.Text := 'You have no templates awaiting signature.';
  frmAlerts.EditUnsigned3.Text := 'You have no templates sent back from the reviewer.';

  unsignedsentback := 0;
  unsignedsignature := 0;
  unsigneddraft := 0;
  If ((UnsignedView.FMListBoxIPR1.Items.Count > 0) And (ReadOnlyMode = False)) Then
  Begin
    For x := 0 To UnsignedView.FMListBoxIPR1.Items.Count - 1 Do
      If Copy(UnsignedView.FMListBoxIPR1.Items[x], 1, 1) <> '!' Then
      Begin
        If Pos('  SENT BACK', UnsignedView.FMListBoxIPR1.Items[x]) = Length(UnsignedView.FMListBoxIPR1.Items[x]) - 11 Then
          inc(unsignedsentback)
        Else
          If Pos('  AWAITING SIGNATURE', UnsignedView.FMListBoxIPR1.Items[x]) = Length(UnsignedView.FMListBoxIPR1.Items[x]) - 20 Then
            inc(unsignedsignature)
          Else
            inc(unsigneddraft);
      End;
    If unsigneddraft > 1 Then
      frmAlerts.EditUnsigned1.Text := 'You have ' + inttostr(unsigneddraft) + ' draft templates.';
    If unsigneddraft = 1 Then
      frmAlerts.EditUnsigned1.Text := 'You have 1 draft template.';
    If unsignedsignature > 1 Then
      frmAlerts.EditUnsigned2.Text := 'You have ' + inttostr(unsignedsignature) + ' templates awaiting signature.';
    If unsignedsignature = 1 Then
      frmAlerts.EditUnsigned2.Text := 'You have 1 template awaiting signature.';
    If unsignedsentback > 1 Then
      frmAlerts.EditUnsigned3.Text := 'You have ' + inttostr(unsignedsentback) + ' templates sent back from the reviewer.';
    If unsignedsentback = 1 Then
      frmAlerts.EditUnsigned3.Text := 'You have 1 template sent back from the reviewer.';

    If unsigneddraft > 0 Then
      frmAlerts.EditUnsigned1.enabled := true
    Else
      frmAlerts.EditUnsigned1.enabled := false;
    If unsignedsignature > 0 Then
      frmAlerts.EditUnsigned2.enabled := true
    Else
      frmAlerts.EditUnsigned2.enabled := false;
    If unsignedsentback > 0 Then
      frmAlerts.EditUnsigned3.enabled := true
    Else
      frmAlerts.EditUnsigned3.enabled := false;

    frmAlerts.buttonUnsigned.enabled := True;
  End;
End;

Procedure TfrmAlerts.ButtonReviewClick(Sender: TObject);
Var
  x, zz: integer;
Begin
  If ANURemoteProcedureCallInProgress Then
    exit;

  UnsignedView.Visible := False;

  If (Sender = ButtonReview) Then
  Begin
    UnsignedView.Button4Click(Application);
    UnsignedView.ShowModal;
    //rebuild the list in case someone changed the list on UnsignedView
    UnsignedView.Button4Click(Application);
  End;

  If UnsignedView.FMListBoxIPR1.Items.Count = 0 Then
  Begin
    frmAlerts.EditReview.enabled := false;
    frmAlerts.EditReview.Text := 'There are no templates requiring review.';
    frmAlerts.buttonReview.enabled := False;
  End;

  If ((UnsignedView.FMListBoxIPR1.Items.Count > 0) And (ReadOnlyMode = False)) Then
  Begin
    If UnsignedView.FMListBoxIPR1.Items.Count = 1 Then
      frmAlerts.EditReview.Text := 'There is 1 template requiring review.'
    Else
    Begin
      zz := 0;
      For x := 0 To UnsignedView.FMListBoxIPR1.Items.Count - 1 Do
        If Copy(UnsignedView.FMListBoxIPR1.Items[x], 1, 1) <> '!' Then
          inc(zz);

      If zz > 1 Then
        frmAlerts.EditReview.Text := 'There are ' + inttostr(zz) + ' templates requiring review.';
      If zz = 1 Then
        frmAlerts.EditReview.Text := 'There is 1 template requiring review.';

      frmAlerts.buttonReview.enabled := True;
      frmAlerts.EditReview.enabled := True;
    End;
  End;
End;

Procedure TfrmAlerts.BitBtnContinueClick(Sender: TObject);
Begin
  close;
End;

procedure TfrmAlerts.btnManifestsClick(Sender: TObject);
var
  frmManifests : TFrmManifests;
begin
  Application.CreateForm(TFrmManifests, frmManifests);
  if frmManifests <> nil then begin
    try
      frmManifests.ShowModal;
    finally
      frmManifests.Free;
      frmManifests := nil;
    end;
  end;
end;

Procedure TfrmAlerts.ButtonResolveClick(Sender: TObject);
Begin
  If ANURemoteProcedureCallInProgress Then
    exit;

  If Not assigned(frmUncosigned) Then
  Begin
    frmUncosigned := TfrmUncosigned.Create(frmMain);
    frmUncosigned.buttonSearchClick(Application);
  End;

  frmUncosigned.ShowModal;
  // Check for documents ready to be transferred from TIU to AMIE
  If frmMain.piece(frmUncosigned.labelReady.caption, ' ', 1) = '0' Then
  Begin
    frmAlerts.EditResolve.Text := 'There are no CPRS co-signed documents ready for transfer to AMIE.';
    frmAlerts.EditResolve.Enabled := False;
    frmAlerts.ButtonResolve.Enabled := False;
  End
  Else
    If frmMain.piece(frmUncosigned.labelReady.caption, ' ', 1) = '1' Then
    Begin
      frmAlerts.EditResolve.Text := 'There is 1 CPRS co-signed document ready for transfer to AMIE.';
      frmAlerts.EditResolve.Enabled := True;
      frmAlerts.ButtonResolve.Enabled := True;
    End
    Else
    Begin
      frmAlerts.EditResolve.Text := 'There are ' + frmMain.piece(frmUncosigned.labelReady.caption, ' ', 1) + ' CPRS co-signed documents ready for transfer to AMIE.';
      frmAlerts.EditResolve.Enabled := True;
      frmAlerts.ButtonResolve.Enabled := True;
    End;
  frmUncosigned.Release;
  frmUncosigned := Nil;
End;

Procedure TfrmAlerts.ButtonUncosignedClick(Sender: TObject);
Begin
  If ANURemoteProcedureCallInProgress Then
    exit;

  frmTIUCosign.GetCosignatureAlerts;
  frmTIUCosign.showModal;
End;

End.
