Unit auditold;

Interface

Uses
  Windows,
  Buttons,
  CAPRISupport,
  CheckLst,
  Classes,
  ComCtrls,
  ComObj,
  Controls,
  Db,
  DBCtrls,
  Diaccess,
  Dialogs,
  ExtCtrls,
  Fmcmpnts,
  Fmcntrls,
  Forms,
  Graphics,
  Grids,
  kbmMemTable,
  Messages,
  OleServer,
  ORCtrls,
  ORDtTm,
  ORFn,
  StdCtrls,
  SysUtils,
  Trpcb,
  CCOWRPCBrokerCAPRI;

Type
  TfrmAuditTrailOld = Class(TForm)
    Button1                         : TButton;
    ButtonGenerateReport            : TButton;
    DataSource1                     : TDataSource;
    FMListBoxNewPerson              : TFMListBox;
    GroupBox1                       : TGroupBox;
    GroupBoxSBY                     : TGroupBox;
    kbmMemTableNewPerson            : TkbmMemTable;
    kbmMemTableNewPersonDivisionName: TStringField;
    kbmMemTableNewPersonDivisionNbr : TStringField;
    kbmMemTableNewPersonUserIEN     : TStringField;
    kbmMemTableNewPersonUserName    : TStringField;
    Label3                          : TLabel;
    Label4                          : TLabel;
    ListBoxItemsToEvaluate          : TListBox;
    ListBoxUserInfo                 : TListBox;
    MemoListBoxAudit                : TMemo;
    MemoNewPerson                   : TMemo;
    ORComboBoxUsers                 : TORComboBox;
    ORDateComboStart                : TORDateCombo;
    ORDateComboStop                 : TORDateCombo;
    ORListBoxDivisions              : TORListBox;
    Panel1                          : TPanel;
    RadioButtonAllusers             : TRadioButton;
    RadioButtonDivision             : TRadioButton;
    RadioButtonUser                 : TRadioButton;
    RadioGroupReportType            : TRadioGroup;
    StatusBar1                      : TStatusBar;
    Procedure ButtonGenerateReportClick(Sender: TObject);
    Procedure CheckListBoxDivisionsClick(Sender: TObject);
    Procedure ComboBoxUsersChange(Sender: TObject);
    Procedure FormActivate(Sender: TObject);
    Procedure FormClose(Sender: TObject; Var Action: TCloseAction);
    Procedure FormCloseQuery(Sender: TObject; Var CanClose: Boolean);
    Procedure FormCreate(Sender: TObject);
    Procedure ListBoxDivisionsClick(Sender: TObject);
    Procedure ORComboBoxUsersChange(Sender: TObject);
    Procedure ORListBoxDivisionsClick(Sender: TObject);
    Procedure RadioButtonAllusersClick(Sender: TObject);
    Procedure RadioButtonDivisionClick(Sender: TObject);
    Procedure RadioButtonUserClick(Sender: TObject);
  Private
    { Private declarations }
    FPreviewWindowCount: integer;
    Function AuditReportsBrokerCall(begdt, enddt: String; rtype, sby: integer; xuser, division, divnbr: String; Dest: TStrings): boolean;
    Function LongReportWarning: boolean;
    Function ORDate2MDateConvert(month, day, year: integer): String;
    Procedure GetUsersAndDivisions;
    Procedure NewPersonBrokerCall(Dest: TStrings);
    Procedure PreviewAuditReport(ReportTitle: String);
    Procedure RPCBrokerCall;
  Protected
    { Protected declarations }
    Function PopulateNewPersonTable: integer;
  Public
    { Public declarations }
    Property PreviewWindowCount: integer Read FPreviewWindowCount Write FPreviewWindowCount Default 0;
  End;

  // Value to determine how long is long for a report range
Const
  LONG_REPORT_RANGE = 30; // in Days
Var
  frmAuditTrailOld: TfrmAuditTrailOld;

Implementation

Uses
  AuditReport,
  main;

{$R *.DFM}

{$ASSERTIONS ON} // ON/OFF	Set to OFF after debug

Procedure TfrmAuditTrailOld.GetUsersAndDivisions;
Var
  temptext: String;
  uniqueDivisions: integer;
  uniqueUsers: integer;
Begin

  If ORComboBoxUsers.Items.Count > 0 Then
    exit;

  StatusBar1.SimpleText := 'Getting user list';

{$IFDEF DEBUG}
  // Manually populate the NewPerson MemoBox
  With MemoNewPerson Do
  Begin
    For i := 1 To 100 Do
    Begin
      UserIEN := IntToStr(i);
      UserName := 'UserName ' + IntToStr(i);
      DivisionNbr := IntToStr(i * 1000);
      DivisionName := 'Div ' + IntToStr(i * 1000);
      tempString := UserIEN + '^' + UserName + '^' + DivisionNbr + '^' + DivisionName;
      Lines.Add(tempString);
    End;
  End;
{$ELSE}
  NewPersonBrokerCall(MemoNewPerson.Lines); // get Newperson data
{$ENDIF}

  // Add Unique Users
  StatusBar1.SimpleText := 'Finding unique users';

  kbmMemTableNewPerson.First;
  uniqueUsers := 0;
  With kbmMemTableNewPerson Do
  Begin
    While Not EOF Do
    Begin
      temptext := FieldByName('UserName').AsString + '^' + FieldByName('UserIEN').AsString;
      If Length(trim(temptext)) > 1 Then
        If ORComboBoxUsers.Items.IndexOf(temptext) < 0 Then
        Begin
          ORComboBoxUsers.Items.Add(temptext);
          Inc(uniqueUsers);
        End;
      Next;
      Application.ProcessMessages;
    End;
  End;

  // Add Unique Divisions
  StatusBar1.SimpleText := 'Finding unique divisions';

  MemoNewPerson.Clear;
  kbmMemTableNewPerson.First;
  uniqueDivisions := 0;
  With kbmMemTableNewPerson Do
  Begin
    While Not EOF Do
    Begin
      temptext := FieldByName('DivisionName').AsString + '^' + FieldByName('DivisionNbr').AsString;
      If Length(trim(temptext)) > 1 Then
        If MemoNewPerson.Lines.IndexOf(trim(temptext)) < 0 Then
        Begin
          MemoNewPerson.Lines.Add(trim(temptext));
          Inc(uniqueDivisions);
        End;
      Next;
      Application.ProcessMessages;
    End;
    ORListBoxDivisions.Items.AddStrings(MemoNewPerson.Lines);
  End;

  StatusBar1.SimpleText := IntToStr(uniqueUsers) + ' users/' + IntToStr(uniqueDivisions) + ' divisions';
  Panel1.Enabled := True;

End; //GetUsersAndDivisions

Procedure TfrmAuditTrailOld.FormCloseQuery(Sender: TObject;
  Var CanClose: Boolean);
Begin
  modalresult := mrOk;
End;

Procedure TfrmAuditTrailOld.FormActivate(Sender: TObject);
Begin
  Panel1.Enabled := True;
  GetUsersAndDivisions;
End;

Procedure TfrmAuditTrailOld.RadioButtonAllusersClick(Sender: TObject);
Begin
  RadioGroupReportType.ItemIndex := -1;
  RadioGroupReportType.Items.Clear;
  RadioGroupReportType.Items.Add('All requests');
  RadioGroupReportType.Items.Add('Access of sensitive records');
  RadioGroupReportType.Items.Add('>15 requests for same SSN');
  RadioGroupReportType.Items.Add('> than 1 user accessing same pt.');
End;

Procedure TfrmAuditTrailOld.RadioButtonDivisionClick(Sender: TObject);
Begin
  RadioGroupReportType.ItemIndex := -1;
  RadioGroupReportType.Items.Clear;
  RadioGroupReportType.Items.Add('All requests');
  RadioGroupReportType.Items.Add('Access of sensitive records');
  RadioGroupReportType.Items.Add('>15 requests for same SSN');
  RadioGroupReportType.Items.Add('> than 1 user accessing same pt.');
  Screen.Cursor := crHourGlass;
  Screen.Cursor := crDefault;
End;

Procedure TfrmAuditTrailOld.RadioButtonUserClick(Sender: TObject);
Begin
  RadioGroupReportType.ItemIndex := -1;
  RadioGroupReportType.Items.Clear;
  RadioGroupReportType.Items.Add('All requests');
  RadioGroupReportType.Items.Add('Access of sensitive records');
  RadioGroupReportType.Items.Add('>15 requests for same SSN');
  Screen.Cursor := crHourGlass;
  Screen.Cursor := crDefault;
End;

Procedure TfrmAuditTrailOld.CheckListBoxDivisionsClick(Sender: TObject);
Begin
  RadioButtonDivision.Checked := True;
  RadioButtonDivisionClick(Application);
End;

Procedure TfrmAuditTrailOld.ComboBoxUsersChange(Sender: TObject);
Begin
  RadioButtonUser.Checked := True;
  RadioButtonUserClick(Application);
End;

Function ValidDate(dtpick: TORDateCombo): boolean;
Begin
  Result := True;
  Try
    If EncodeDate(Word(dtpick.Year), Word(dtpick.Month), Word(dtpick.Day)) = now() Then
      Result := True;
  Except
    On E: EConvertError Do
      Result := False;
  End;
End;

Procedure TfrmAuditTrailOld.ButtonGenerateReportClick(Sender: TObject);
Var
  BEGDT: String;
  DIVISION: String;
  DIVNBR: String;
  ENDDT: String;
  ReportTitle: String;
  RTYPE: integer;
  SBY: integer; //SearchBy 1=All Requests, 2=User, 3= Division
  tempstring: String;
  USER: String;
Begin
  SBY := 1; // as default initialization

  If Not LongReportWarning Then
    exit;
  StatusBar1.SimpleText := '';
  If Not ValidDate(ORDateComboStart) Then
  Begin
    Showmessage('Select a complete start date.');
    ORDateComboStart.SetFocus;
    exit;
  End;
  If Not ValidDate(ORDateComboStop) Then
  Begin
    Showmessage('Select a complete stop date.');
    ORDateComboStop.SetFocus;
    exit;
  End;
  If ORDateComboStart.FMDate > ORDateComboStop.FMDate Then
  Begin
    Showmessage('Start date cannot be greater than stop date.');
    self.SetFocusedControl(ORDateComboStart);
    exit;
  End;
  If (RadioButtonAllUsers.Checked = False) And (RadioButtonUser.Checked = False) And
    (RadioButtonDivision.Checked = False) Then
  Begin
    Showmessage('Select a search criteria.');
    exit;
  End;
  If RadioGroupReportType.ItemIndex = -1 Then
  Begin
    Showmessage('Select a report type.');
    exit;
  End;
  If RadioButtonUser.Checked Then
    If ORComboBoxUsers.ItemIndex < 0 Then
    Begin
      Showmessage('Select a user.');
      exit;
    End;
  If RadioButtonDivision.Checked Then
    If ORListBoxDivisions.ItemIndex < 0 Then
    Begin
      Showmessage('Select a division.');
      exit;
    End;

  ListBoxItemsToEvaluate.Items.Clear;

  // Set the report type from the RadioGroup
  RTYPE := RadioGroupReportType.ItemIndex + 1;

  // Set SBY , USER and DIVISION
  If RadioButtonAllusers.Checked Then
  Begin
    SBY := 1; // All Users
    ReportTitle := 'All Users';
  End;
  If RadioButtonUser.Checked Then
  Begin
    SBY := 2; // A User
    tempstring := '';
    tempstring := Piece(ORComboBoxUsers.Items[ORComboBoxUsers.ItemIndex], '^', 2);
    USER := tempstring;
    ReportTitle := 'User: ' + Piece(ORComboBoxUsers.Text, '^', 1) + ' (' + USER + ')';
  End
  Else
    USER := '';
  If RadioButtonDivision.Checked Then
  Begin
    SBY := 3; // A Division
    tempstring := '';
    tempstring := Piece(ORListBoxDivisions.Items[ORListBoxDivisions.ItemIndex], '^', 1);
    DIVISION := TempString;

    tempstring := '';
    tempstring := Piece(ORListBoxDivisions.Items[ORListBoxDivisions.ItemIndex], '^', 2);
    DIVNBR := TempString;

    ReportTitle := 'Division: ' + DIVISION + ' (' + DIVNBR + ')';
  End
  Else
  Begin
    DIVISION := '';
    DIVNBR := '';
  End;

  Case RTYPE Of
    1: ReportTitle := ReportTitle + ' for All requests ';
    2: ReportTitle := ReportTitle + ' for Access of sensitive records ';
    3: ReportTitle := ReportTitle + ' for >15 req for same SSN ';
    4: ReportTitle := ReportTitle + ' for >1 user accessing same patient ';
  End;

  // Get entered Date values
  If Length(Trim(ORDateComboStart.DateText)) > 0 Then
    BEGDT := ORDate2MDateConvert(ORDateComboStart.Month, ORDateComboStart.Day, ORDateComboStart.Year);
  If Length(Trim(ORDateComboStop.DateText)) > 0 Then
    ENDDT := ORDate2MDateConvert(ORDateComboStop.Month, ORDateComboStop.Day, ORDateComboStop.Year);

  ReportTitle := ReportTitle + 'during ' + ORDateComboStart.DateText + ' to ' + ORDateComboStop.DateText;

  Try
    Screen.Cursor := crHourGlass;
    // Now get the audit data

{$IFDEF DEBUG}
    With MemoListBoxAudit Do
    Begin
      For i := 0 To 1000 Do
      Begin
        UserIEN := IntToStr(i);
        UserName := 'User ' + IntToStr(i);
        UserSSN := Copy(Piece(Lines[i], '^', 3), 6, 4);
        UserDivision := IntToStr(i * 1000);
        UserTitle := 'Computer Specialist';
        If i Mod 20 = 0 Then
        Begin
          PatientName := 'Patient ' + IntToStr(100);
          PatientICN := IntToStr(100);
          PatientSSN := '100-00-1001';
          Location := 'VA Test Hospital';
        End
        Else
        Begin
          PatientName := 'Patient ' + IntToStr(i);
          PatientICN := IntToStr(i);
          PatientSSN := '999-88-7777';
          Location := 'Some Other VA Test Hospital';
        End;
        Date_Time := FMDateTimeConvert('3020106');
        If i Mod 10 = 0 Then
          Sensitive := 'Yes'
        Else
          Sensitive := 'No';
        ClaimNbr := IntToStr(i * 425);

        tempString := UserIEN + '^' + UserName + '^' + UserSSN + '^' +
          UserDivision + '^' + UserTitle + '^' + PatientName + '^' + PatientICN + '^' +
          PatientSSN + '^' + Location + '^' + Date_Time + '^' + Sensitive + '^' +
          ClaimNbr;

        Lines.Add(tempString);
      End;
    End;
{$ELSE}
    If AuditReportsBrokerCall(BEGDT, // BEGDT
      ENDDT, // ENDDT
      RTYPE, // RTYPE
      SBY, // SBY
      USER, // USER
      DIVISION, // DIVISION
      DIVNBR, // DIVNBR (Division Number)
      MemoListBoxAudit.Lines) {// destination} Then
{$ENDIF}
      PreviewAuditReport(ReportTitle); // populate the report

  Finally
    Screen.Cursor := crDefault;
  End;
  StatusBar1.SimpleText := '';
  exit;

  Showmessage('That report type is not yet coded.');

End;

Procedure TfrmAuditTrailOld.RPCBrokerCall;
Var
  x: integer;
Begin
  TimeSinceLastBrokerCall := 0;
  If ANURemoteProcedureCallInProgress = True Then
    Repeat
      Begin
        TimeSinceLastBrokerCall := 0;
        For x := 1 To 50 Do
          application.processmessages;
    End Until ANURemoteProcedureCallInProgress = False;
End;

Function TfrmAuditTrailOld.AuditReportsBrokerCall(begdt, enddt: String; rtype, sby: integer; xuser, division, divnbr: String; Dest: TStrings): boolean;
Begin
  With frmMain.RPCBroker1 Do
  Begin
    frmMain.RPCBroker1.Results.Clear;
    RemoteProcedure := 'DVBAB AUDIT REPORTS';

    // BEGDT
    Assert(Length(Trim(begdt)) > 0, 'Must supply a beginning date; how do we pass no date choice to M?');
    Param[0].Value := begdt + '.0000'; //'3030117'
    Param[0].PType := literal;

    // ENDDT
    Assert(Length(Trim(begdt)) > 0, 'Must supply a ending date; how do we pass no date choice to M?');
    Param[1].Value := enddt + '.2359'; //'3030121';
    Param[1].PType := literal;

    // RTYPE
    Assert(((rtype >= 1) Or (rtype <= 4)), 'Must choose a Report Type');
    Param[2].Value := IntToStr(rtype); // 1=All Requests, 2=Sensitive Records,3=>15 req for same SSN,4=>1 user accessing same patient
    Param[2].PType := literal;

    // SBY
    Assert(((sby >= 1) Or (sby <= 3)), 'Must choose a ''Search'' By criteria');
    Param[3].Value := IntToStr(sby); // 1=All Users, 2=User, 3= Division
    Param[3].PType := literal;

    // USER
    Param[4].Value := xuser; // User IEN
    Param[4].PType := literal;

    // DIV
    Param[5].Value := divnbr; // the Division number
    Param[5].PType := literal;

    {
        // DIVNBR
        Param[6].Value := division    // the Division Name
        Param[6].PType := literal;
    }
    RPCBrokerCall;
    Try
      frmMain.RPCBroker1.Call;
      QuickCopy(frmMain.RPCBroker1.Results, Dest);
      Result := True;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        //tfrmMain.AnimateLogo(False);
        StatusBar1.Panels[0].Text := 'DVBAB AUDIT REPORTS could not be accessed!';
        StatusBar1.Repaint;
        Application.Processmessages;
        ShowMessage('DVBAB AUDIT REPORTS could not be accessed!');
        Result := False;
        ShowMessage('I''m sorry, but this application must now exit as VistA session is in an unusable state.');
        //frmMain.ExitCapriApplication;
        application.terminate;
        exit;
      End;
    End;

  End;
End;

Procedure TfrmAuditTrailOld.NewPersonBrokerCall(Dest: TStrings);
Begin
  With frmMain.RPCBroker1 Do
  Begin
    frmMain.RPCBroker1.Results.Clear;
    RemoteProcedure := 'DVBAB NEW PERSON FILE';
    RPCBrokerCall;
    Try
      Screen.Cursor := crHourGlass;
      Try
        frmMain.RPCBroker1.Call;
        QuickCopy(frmMain.RPCBroker1.Results, Dest);
      Except
        On EBrokerError Do
        Begin
          ANURemoteProcedureCallInProgress := False;
          //tfrmMain.AnimateLogo(False);
          StatusBar1.Panels[0].Text := 'DVBAB NEW PERSON FILE could not be accessed!';
          StatusBar1.Repaint;
          Application.Processmessages;
          ShowMessage('DVBAB NEW PERSON FILE could not be accessed!');
          ShowMessage('I''m sorry, but this application must now exit as VistA session is in an unusable state.');
          //frmMain.ExitCapriApplication;
          application.terminate;
          exit;
        End;
      End;
    Finally
      Screen.Cursor := crDefault;
    End;
  End;
End;

Procedure TfrmAuditTrailOld.PreviewAuditReport(ReportTitle: String);
Var
  ClaimNbr   : String;
  Date_Time  : String;
  i          : integer;
  Location   : String;
  PatientICN : String;
  PatientName: String;
  PatientSSN : String;
  Sensitive  : String;
  UserIEN    : String;
  UserName   : String;
  UserSSN    : String;
  UserTitle  : String;
Begin
  frmAuditReport := TfrmAuditReport.Create(Self);
  Try
    Screen.Cursor := crHourGlass;
    With frmAuditReport Do
    Begin

      frmAuditReport.kbmMemTable1.CreateTable;
      frmAuditReport.kbmMemTable1.Active := true;
      frmAuditReport.kbmMemTable1.EmptyTable;

      With MemoListBoxAudit Do
      Begin
        For i := 0 To Lines.Count Do
        Begin
          UserIEN := Piece(Lines[i], '^', 1);
          UserName := Piece(Lines[i], '^', 2);
          UserSSN := Copy(Piece(Lines[i], '^', 3), 6, 4);
          UserDivision := Piece(Lines[i], '^', 4);
          UserTitle := Piece(Lines[i], '^', 5);
          PatientName := Piece(Lines[i], '^', 6);
          PatientICN := Piece(Lines[i], '^', 7);
          PatientSSN := Piece(Lines[i], '^', 8);
          Location := Piece(Lines[i], '^', 9);
          Date_Time := FMDateTimeConvert(Piece(Lines[i], '^', 10));
          Sensitive := Piece(Lines[i], '^', 11);
          ClaimNbr := Piece(Lines[i], '^', 12);

          // Populate memory dataset
          With frmAuditReport.kbmMemTable1 Do
          Begin
            Append;
            FieldByName('UserIEN').Value := UserIEN;
            FieldByName('UserName').Value := UserName;
            FieldByName('UserSSN').Value := UserSSN;
            FieldByName('UserDivision').Value := UserDivision;
            FieldByName('UserTitle').Value := UserTitle;
            FieldByName('PatientName').Value := PatientName;
            FieldByName('PatientICN').Value := PatientICN;
            FieldByName('PatientSSN').Value := PatientSSN;
            FieldByName('Location').Value := Location;
            FieldByName('Date_Time').Value := Date_Time;
            FieldByName('Sensitive').Value := Sensitive;
            FieldByName('ClaimNbr').Value := ClaimNbr;
            Post;
          End;

        End;
      End;
      frmAuditReport.QuickRep1.Prepare;

      With frmAuditReport.kbmMemTable1 Do
      Begin
        First;
        While Not EOF Do
        Begin
          Edit;
          FieldByName('PageCount').Value := frmAuditReport.QuickRep1.Printer.PageCount;
          Post;
          Next;
        End;
      End;

      If frmAuditReport.QuickRep1.RecordCount <= 1 Then
      Begin
        If MessageDlg('Report returns no records, print anyway?', mtConfirmation, [mbYes, mbNo], 0) = mrYes Then
        Begin
          frmAuditReport.QuickRep1.ReportTitle := ReportTitle;
          Screen.Cursor := crDefault;
          PreviewWindowCount := PreviewWindowCount + 1;
          frmAuditReport.QuickRep1.PreviewModal;
        End;
      End
      Else
      Begin
        frmAuditReport.QuickRep1.ReportTitle := ReportTitle;
        Screen.Cursor := crDefault;
        PreviewWindowCount := PreviewWindowCount + 1;
        frmAuditReport.QuickRep1.PreviewModal;
      End;
    End;
  Finally
    frmAuditReport.Release;
    frmAuditReport := Nil;
    MemoListBoxAudit.Lines.Clear;
    Screen.Cursor := crDefault;
  End;
End;

Function TfrmAuditTrailOld.PopulateNewPersonTable(): integer;
Var
  DivisionName: String;
  DivisionNbr : String;
  i           : integer;
  UserIEN     : String;
  UserName    : String;
Begin

  Try
    With frmAuditReport Do
    Begin

      kbmMemTableNewPerson.CreateTable;
      kbmMemTableNewPerson.Active := true;
      kbmMemTableNewPerson.EmptyTable;

      With MemoNewPerson Do
      Begin
        For i := 0 To Lines.Count Do
        Begin
          UserIEN := Piece(Lines[i], '^', 1);
          UserName := Piece(Lines[i], '^', 2);
          DivisionNbr := Piece(Lines[i], '^', 3);
          DivisionName := Piece(Lines[i], '^', 4);

          // Populate memory dataset
          With kbmMemTableNewPerson Do
          Begin
            Append;
            FieldByName('UserIEN').Value := UserIEN;
            FieldByName('UserName').Value := UserName;
            FieldByName('DivisionNbr').Value := DivisionNbr;
            FieldByName('DivisionName').Value := DivisionName;
            Post;
          End;
        End;
      End;
      Result := kbmMemTableNewPerson.RecordCount;
    End;
  Finally
    MemoNewPerson.Lines.Clear;
  End;
End;

Function TfrmAuditTrailOld.ORDate2MDateConvert(month, day, year: integer): String;
Var
  stMonth, stDay, stYear, stYear2: String;
Begin
  stMonth := Format('%.2d', [month]);
  stDay := Format('%.2d', [day]);
  stYear := IntToStr(year);
  stYear2 := stYear[1] + stYear[2] + '00';
  Result := IntToStr((StrToInt(stYear2) - 1700) Div 100);
  Result := Result + stYear[3] + styear[4] + stMonth + stDay;
End;

Procedure TfrmAuditTrailOld.FormCreate(Sender: TObject);
Var
  day: Word;
  month: Word;
  year: Word;
Begin
  DecodeDate(Date, year, month, day);
  ORDateComboStop.Year := Word(year);
  ORDateComboStop.Month := Word(month);
  ORDateComboStop.Day := Word(day);

  // set default to beginning of last month
  DecodeDate(IncMonth(Date, -1), year, month, day);
  ORDateComboStart.Year := Integer(year);
  ORDateComboStart.Month := Integer(month);
  ORDateComboStart.Day := 1;
  PreviewWindowCount := 0;
End;

Procedure TfrmAuditTrailOld.ListBoxDivisionsClick(Sender: TObject);
Begin
  RadioButtonDivision.Checked := True;
  RadioButtonDivisionClick(Application);
End;

Procedure TfrmAuditTrailOld.ORListBoxDivisionsClick(Sender: TObject);
Begin
  RadioButtonDivision.Checked := True;
  RadioButtonDivisionClick(Application);
End;

Procedure TfrmAuditTrailOld.ORComboBoxUsersChange(Sender: TObject);
Begin
  RadioButtonUser.Checked := True;
  RadioButtonUserClick(Application);
End;

Function TfrmAuditTrailOld.LongReportWarning(): boolean;
Var
  StartDate, StopDate: TDateTime;
Begin
  StartDate := EncodeDate(Word(ORDateComboStart.Year), Word(ORDateComboStart.Month), Word(ORDateComboStart.Day));
  StopDate := EncodeDate(Word(ORDateComboStop.Year), Word(ORDateComboStop.Month), Word(ORDateComboStop.Day));
  Result := True;
  Try
    If ((StopDate - StartDate - 1) > (LONG_REPORT_RANGE)) Then
      If MessageDlg('You have selected more than ' + IntToStr(LONG_REPORT_RANGE) + ' days on which to report.  It may take a wile to process this report. Is this okay?',
        mtConfirmation,
        [mbYes, mbNo],
        0) = mrNo Then
        Result := False;
  Except
  End;
End;

Procedure TfrmAuditTrailOld.FormClose(Sender: TObject;
  Var Action: TCloseAction);
Begin
  Action := caFree;
End;

End.
