Unit browsetemplates;

Interface

Uses
  Windows,
  Buttons,
  CAPRISupport,
  Classes,
  ClipBrd,
  ComCtrls,
  Controls,
  Diaccess,
  Dialogs,
  DialogsCAPRI,
  ExtCtrls,
  Fmcmpnts,
  Fmcntrls,
  Forms,
  Gauges,
  Graphics,
  main,
  MergePScripts,
  Messages,
  ORCtrls,
  OrFN,
  PNCSMain,
  StdCtrls,
  SysUtils,
  Trpcb,
  UUCode,
  wait,
  ZipMcpt,
  CCOWRPCBrokerCAPRI,
  ComputableCoordinator,
  XsdEngineLite,
  XmlConfig;

Type
  TfrmBrowseTemplates = Class(TForm)
    btnmovedown              : TBitBtn;
    btnMoveUp                : TBitBtn;
    Button1                  : TButton;
    ButtonAdd                : TButton;
    ButtonCancel             : TButton;
    ButtonGenerateTemplate   : TButton;
    buttonRemoveThisOne      : TBitBtn;
    CCOWTimer                : TTimer;
    CheckBoxMedicalOpinion   : TCheckBox;
    FMCommentsMemo           : TFMMemo;
    FMEditScriptStyle        : TFMEdit;
    FMGetsTemplateInfo       : TFMGets;
    FMListBoxAllTemplates    : TFMListBox;
    FMListBoxTemplates       : TFMListBox;
    FMListerTemplates        : TFMLister;
    FMMemoFormDefinition     : TRIchEdit;
    FMMemoReportDefinition   : TRichEdit;
    FMMemoScriptDefinition   : TRichEdit;
    FMMemoXmlDefinition      : TRichEdit;
    Gauge1                   : TGauge;
    Label1                   : TLabel;
    Label2                   : TLabel;
    Label3                   : TLabel;
    Label4                   : TLabel;
    Label7                   : TLabel;
    ListBoxSelectedTemplates : TORListBox;
    ListBoxTemplates         : TORListBox;
    MiniZip1                 : TMiniZip;
    RichEditPScript          : TRichEdit;
    RichEditReport           : TRichEdit;
    RichEditTemplatesUtilized: TRichEdit;
    Procedure btnmovedownClick(Sender: TObject);
    Procedure btnMoveUpClick(Sender: TObject);
    Procedure Button1Click(Sender: TObject);
    Procedure ButtonAddClick(Sender: TObject);
    Procedure ButtonCancelClick(Sender: TObject);
    Procedure ButtonGenerateTemplateClick(Sender: TObject);
    Procedure ButtonRemoveThisOneClick(Sender: TObject);
    Procedure CCOWTimerTimer(Sender: TObject);
    Procedure FormActivate(Sender: TObject);
    Procedure FormCreate(Sender: TObject);
    Procedure ListBoxSelectedTemplatesClick(Sender: TObject);
    Procedure ListBoxSelectedTemplatesDblClick(Sender: TObject);
    Procedure ListBoxTemplatesClick(Sender: TObject);
    Procedure ListBoxTemplatesDblClick(Sender: TObject);
    Procedure ListBoxTemplatesDrawItem(Control: TWinControl;Index: Integer; Rect: TRect; State: TOwnerDrawState);
  Private
    { Private declarations }
    Procedure UpdateSelectedTemplates;  //CodeCR220 - rpm 2/16/12
  Public
    { Public declarations }
    SelectedTemplates: TStringList;
  End;

Var
  frmBrowseTemplates   : TfrmBrowseTemplates;
  MedicalOpinionPointer: String;
  resourcecount        : integer;
  ScriptStyle          : String;

Implementation

{$R *.DFM}
Uses CPWMObjects;

Procedure TfrmBrowseTemplates.ButtonCancelClick(Sender: TObject);
Begin
  ContextorChangeMessage := '';
  ModalResult := mrCancel;
End;

Procedure TfrmBrowseTemplates.ButtonGenerateTemplateClick(Sender: TObject);
Var
  codeLines          : TStrings;
  fileLines          : TStrings;
  formfilename       : String;
  formfilenamehandle : integer;
  formToMergeIEN     : String;
  FoundMedicalOpinion: Boolean;
  PScript            : TStrings;
  totalcount         : integer;
  x                  : integer;
  xx                 : integer;
  y                  : integer;

  xmlMapFile         : TStringList;
  xmlConfigFile      : TStringList;
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;
  If (ListBoxTemplates.ItemIndex > -1) And (ListBoxSelectedTemplates.Items.Count > 0) Then
  Begin
    If MessageDlgCAPRI('You''ve clicked a template but not added it to the selected templates list.  Do you want to include ' + Piece(ListBoxTemplates.Items[ListBoxTemplates.ItemIndex], '^', 1) +
      ' in your form?',
      mtConfirmation, [mbYes, mbNo], 0) = mrYes Then
    Begin
      ButtonAddClick(Application);
    End;
  End
  Else
    If (ListBoxTemplates.ItemIndex > -1) And (ListBoxSelectedTemplates.Items.Count = 0) Then
      // There aren't any selected templates, so use the clicked one.
      ButtonAddClick(Application);

  resourceCount := 0;

  FoundMergeFlag := 0;
  RichEditReport.Lines.Clear;
  RichEditTemplatesUtilized.Lines.Clear;

  InfoComment := '';

  WaitForm.Visible := True;
  waitform.imagenetwork.visible := True;
  waitform.imagenetwork.repaint;
  waitform.repaint;
  WaitForm.BringToFront;
  WaitForm.Repaint;
  y := -1;
  totalcount := 0;

  If CheckBoxMedicalOpinion.Checked = True Then
  Begin
    // Don't add Medical Opinion if already selected
    FoundMedicalOpinion := False;
    For x := 0 To ListBoxSelectedTemplates.Items.Count - 1 Do
      If Piece(ListBoxSelectedTemplates.Items[x], '^', 1) = 'MEDICAL OPINION' Then
        FoundMedicalOpinion := True;
    If FoundMedicalOpinion = False Then
      ListBoxSelectedTemplates.Items.Add(MedicalOpinionPointer);
  End;

  If ListBoxSelectedTemplates.Items.Count = 0 Then
  Begin
    ButtonGenerateTemplate.Enabled := False;
    exit;
  End;

  PScript := TStringList.Create;
  PScript.Clear;

  For x := 0 To ListBoxSelectedTemplates.items.Count - 1 Do
  Begin
    FMGetsTemplateInfo.IENS := Piece(ListBoxSelectedTemplates.Items[x], '^', 2);
    FMGetsTemplateInfo.GetAndFill;
    If FMEditScriptStyle.Text <> 'PASCAL SCRIPT' Then
      FMEditScriptStyle.Text := '';

    InfoComment := InfoComment + Uppercase(Piece(ListBoxSelectedTemplates.Items[x], '^', 1)) + ':' + char(13);
    If FMCommentsMemo.Lines.Count > 0 Then
    Begin
      For xx := 0 To FMCommentsMemo.Lines.Count - 1 Do
        InfoComment := InfoComment + FMCommentsMemo.Lines[xx] + char(13);
    End
    Else
    Begin
      InfoComment := InfoComment + '[NO COMMENT FOUND]' + char(13);
    End;
    InfoComment := InfoComment + 'Object Count: ' + Piece(ListBoxSelectedTemplates.Items[x], '^', 3) + char(13);
    InfoComment := InfoComment + char(13);
    totalcount := totalcount + strToInt(Piece(ListBoxSelectedTemplates.Items[x], '^', 3));

    //FMListBoxSelectedTemplates.ItemIndex:=x;
    Inc(FoundMergeFlag);
    RichEditTemplatesUtilized.Lines.Add(Piece(ListBoxSelectedTemplates.Items[x], '^', 2) + '^' + Piece(ListBoxSelectedTemplates.Items[x], '^', 1));

    WaitForm.BringToFront;
    WaitForm.Label1.Caption := 'Loading ' + Piece(ListBoxSelectedTemplates.Items[x], '^', 1);
    formtomergeIEN := Piece(ListBoxSelectedTemplates.Items[x], '^', 2);

    // Check for existing file in cache
    // If there, then use it
    // If not, download and save it
    // Filename is .01 field + last update date in internal format + .zip
    // Also quit deleting the unzipped files to save that processing time.
    // TempDir+TempFileName+'.zip');

    WaitForm.Repaint;

    FMGetsTemplateInfo.IENS := formToMergeIEN;
    FMGetsTemplateInfo.GetData;

    formfilename := TempDir;
    formfilename := formfilename + FMGetsTemplateInfo.GetField('.01').FMDBExternal + '^';
    formfilename := formfilename + FMGetsTemplateInfo.GetField('5').FMDBInternal + '.zip';

    //ShowmessageCAPRI(formfilename);

    If fileexists(formfilename) = false Then
    Begin
      waitform.imagenetwork.visible := True;
      waitform.imagenetwork.repaint;
      waitform.repaint;

      frmMain.RPCBroker1.RemoteProcedure := 'DVBAB TEMPLATE DEFINITION';
      frmMain.RPCBroker1.Param[0].Value := formToMergeIEN;
      frmMain.RPCBroker1.Param[0].PType := literal;
      frmMain.RPCBroker1.Param[1].Value := '1';
      frmMain.RPCBroker1.Param[1].PType := literal;
      //frmMain.RPCBrokerCall; frmMain.RPCBroker1.Call;
      WaitForm.StaticText1.Caption := 'Loading definition...';
      Waitform.StaticText1.Repaint;
      frmMain.RPCBrokerCall;
      Try
        frmMain.RPCBroker1.Call;
      Except
        On EBrokerError Do
        Begin
          ANURemoteProcedureCallInProgress := False;
          frmMain.AnimateLogo(False);
          frmMain.StatusBarLoadPt.Caption := 'DVBAB TEMPLATE DEFINITION could not be accessed!';
          frmMain.StatusBarLoadPt.Repaint;
          Application.Processmessages;
          ShowMessageCAPRI('DVBAB TEMPLATE DEFINITION could not be accessed!');
        End;
      End;
      //frmMain.FMMemoFormDefinitionChange(FMMemoFormDefinition);

      If frmMain.RPCBroker1.Results.Count = 0 Then
      Begin
        ShowmessageCAPRI('The template definition needed for ' + Piece(ListBoxSelectedTemplates.Items[x], '^', 2) + '^' + Piece(ListBoxSelectedTemplates.Items[x], '^', 1) + ' (IEN #' + formToMergeIEN
          + ') is no longer available in the file.');
        exit;
      End;

      screen.cursor := crhourglass;
      WaitForm.StaticText1.Caption := 'Decoding...';
      Waitform.StaticText1.Repaint;
      TempFileName := Copy(frmMain.RPCBroker1.Results[0], 11, 999);
      If TempFileName = '' Then
      Begin
        ShowMessageCAPRI('There was a problem with the definition file.  Exiting CAPRI.');
        application.terminate;
        exit;
      End;

      If FileExists(TempDir + TempFileName + '.uue') Then
      Begin
        Try
        DeleteFile(TempDir + TempFileName + '.uue')Except
          Begin
            ShowMessageCAPRI('You have an outdated definition that cannot be deleted.  Exiting CAPRI.');
            application.terminate;
          End;
        End;
      End;

      If FileExists(TempDir + TempFileName) Then
      Begin
        Try
        DeleteFile(TempDir + TempFileName)Except
          Begin
            ShowMessageCAPRI('You have an outdated definition that cannot be deleted.  Exiting CAPRI.');
            application.terminate;
          End;
        End;
      End;
      frmMain.RPCBroker1.Results.SaveToFile(TempDir + TempFileName + '.uue');
      UUDecode(TempDir + TempFileName + '.uue');
      DeleteFile(TempDir + TempFileName + '.uue');
      renamefile(TempDir + TempFileName, formfilename);
      MiniZip1.UnZipFile := formfilename;
      MiniZip1.UnzipAllTo(TempDir);
      MiniZip1.UnZipFile := '';
      TempFileName := Piece(TempFilename, '.', 1);

      RenameFile(TempDir + TempFileName + '.pnl.frm', formfilename + '.pnl.frm');
      RenameFile(TempDir + TempFileName + '.pnl.cde', formfilename + '.pnl.cde');
      RenameFile(TempDir + TempFileName + '.pnl.rep', formfilename + '.pnl.rep');

      if FileExists(TempDir + TempFileName + TXsdEngineLite.FILE_EXTENSION) then
      begin
        RenameFile(TempDir + TempFileName + TXsdEngineLite.FILE_EXTENSION, formfilename + TXsdEngineLite.FILE_EXTENSION);
      end;

      if FileExists(TempDir + TempFileName + TXmlConfig.FILE_EXTENSION) then
      begin
        RenameFile(TempDir + TempFileName + TXmlConfig.FILE_EXTENSION, formfilename + TXmlConfig.FILE_EXTENSION);
      end;

      // TODO insert pnl.xmlconfig
    End;
    // Touch form date/time
    formFileNameHandle := FileOpen(formFileName, fmOpenReadWrite);
    If formfileNamehandle > -1 Then
      FileSetDate(formfilenamehandle, DateTimeToFileDate(now));
    FileClose(formFileNameHandle);

    FMMemoFormDefinition.Lines.LoadFromFile(formfilename + '.pnl.frm');
    FMMemoScriptDefinition.Lines.LoadFromFile(formfilename + '.pnl.cde');
    FMMemoReportDefinition.Lines.LoadFromFile(formfilename + '.pnl.rep');

    if FileExists(formfilename + TXsdEngineLite.FILE_EXTENSION) then
    begin
      xmlMapFile := TStringList.Create;
      xmlMapFile.LoadFromFile(formfilename + TXsdEngineLite.FILE_EXTENSION);
    end;

    if FileExists(formfilename + TXmlConfig.FILE_EXTENSION) then
    begin
      xmlConfigFile := TStringList.Create;
      xmlConfigFile.LoadFromFile(formfilename + TXmlConfig.FILE_EXTENSION);
    end;

    // Store off the script style
    PNCSForm.zzzzEditScriptStyle.text := ScriptStyle;

    // Might need to convert to Pascal
    If FMMemoReportDefinition.Lines.Count > 0 Then
      If Pos('PROGRAM ', Trim(Uppercase(FMMemoReportDefinition.Lines[0]))) <> 1 Then
      Begin
        PNCSForm.ConvertOldStyleScriptToPascalScript(FMMemoReportDefinition);
      End;

    If ANURemoteProcedureCallInProgress = True Then
      Repeat application.processmessages Until
      ANURemoteProcedureCallInProgress = False;

    WaitForm.StaticText1.Caption := 'Initializing...';
    Waitform.StaticText1.Repaint;
    waitform.repaint;
    fileLines := TStringList.Create;
    codeLines := TStringList.Create;
    Try
      QuickCopy(FMMemoFormDefinition, fileLines);   // copy form
      QuickCopy(FMMemoScriptDefinition, codeLines); // copy script

      If POS('PROGRAM ', trim(uppercase(CodeLines[0]))) = 1 Then
      Begin
        MergePScript(PScript, CodeLines);
        codelines.clear;
        codelines.add('');
        codelines.add('');
      End;
                          //form def, script def, temp file name
      pncsForm.LoadBaseExam(fileLines, codeLines, TempFileName,
                            xmlMapFile, xmlConfigFile);

    Finally
      fileLines.Free;
      codeLines.Free;
      xmlMapFile := Nil;
      xmlConfigFile := Nil;
      
    End;

    // End of ED section

    pncsForm.localExam := pncsForm.Exams[0];

    pncsForm.xOutputDesign.Lines.Add('// // // //!@#$FORMSTART$#@!');
    // Apppend the report to the existing one
    pncsForm.xOutputDesign.Lines.Add(FMMemoreportDefinition.Lines.Text);
    pncsForm.xOutputDesign.Lines.Add('// // // //!@#$FORMEND$#@!');

    inc(y);

    If y = 0 Then
      pncsForm.localExam.Merge(Nil) // Merge with nothing
    Else
      pncsForm.localExam.Merge(pncsForm.Exams[y]);

  End;
  InfoComment := InfoComment + char(13);
  InfoComment := InfoComment + 'Total Object Count: ' + inttostr(totalcount) + char(13);

  WaitForm.StaticText1.Caption := 'Initializing...';
  Waitform.StaticText1.Repaint;

  screen.cursor := crHourglass;
  //Check foundflag here
  ContextorChangeMessage := '';

  If PScript.Count > 0 Then
  Begin
    For x := 0 To PScript.Count - 1 Do
      RichEditPScript.Lines.Add(PScript[x]);
    pncsForm.zzzzEditScriptStyle.text := 'PASCAL SCRIPT';
  End;
  PScript.Free;

  If FoundMergeFlag > 0 Then
    ModalResult := mrOK
  Else
    ModalResult := mrCancel;
End;

Procedure TfrmBrowseTemplates.ListBoxTemplatesClick(Sender: TObject);
Var
  x: integer;
Begin

  FMEditScriptStyle.Text := '';

  btnMoveUp.Enabled := False;
  btnMoveDown.Enabled := False;
  buttonRemoveThisOne.Enabled := False;

  resourceCount := 0;

  If listBoxSelectedTemplates.Items.Count > 0 Then
    For x := 0 To listBoxSelectedTemplates.Items.Count - 1 Do
    Begin
      resourcecount := resourcecount + strtoint(piece(listBoxSelectedTemplates.items[x], '^', 3));
    End;

  gauge1.progress := resourcecount;

  If ListBoxTemplates.ItemIndex = -1 Then
    exit;
  ListBoxSelectedTemplates.ItemIndex := -1;

  If resourcecount + strtoint(piece(listBoxTemplates.items[ListBoxTemplates.ItemIndex], '^', 3)) > gauge1.MaxValue Then
  Begin
    buttonAdd.Enabled := False;
    ShowMessageCAPRI('There''s not enough space left to add that template.  Please remove other templates and try again.');
    exit;
  End;

  FMGetsTemplateInfo.IENS := Piece(ListBoxTemplates.Items[ListBoxTemplates.ItemIndex], '^', 2);
  FMGetsTemplateInfo.GetAndFill;
  If FMEditScriptStyle.Text <> 'PASCAL SCRIPT' Then
    FMEditScriptStyle.Text := '';

  If ScriptStyle <> '[NULL]' Then
    If FMEditScriptStyle.Text <> ScriptStyle Then
    Begin
      FMCommentsMemo.Lines.Clear;
      FMCommentsMemo.Lines.Add('The script is incompatible with your other selections.');
      ListBoxTemplates.ItemIndex := -1;
      exit;
    End;

  If ListBoxTemplates.ItemIndex = -1 Then
  Begin
    ButtonAdd.Enabled := False;
  End
  Else
  Begin
    ButtonAdd.Enabled := True;
    ButtonGenerateTemplate.Enabled := True;
  End;

  ListBoxTemplates.Repaint;

  {
    (Re)Build the list of selected exams. This is because the ItemIndex property
      is not reliable and was leading to incorrect choice for pncsForm caption.
  }

End;

Procedure TfrmBrowseTemplates.FormCreate(Sender: TObject);
Begin
  SelectedTemplates := TStringList.Create;
  Gauge1.MaxValue := 9000;
  ScriptStyle := '[NULL]';
  RichEditPScript.Lines.Clear;
End;

Procedure TfrmBrowseTemplates.ListBoxTemplatesDrawItem(
  Control: TWinControl; Index: Integer; Rect: TRect;
  State: TOwnerDrawState);
Var
  TempText: String;
Begin
  Inherited;
  With (Control As TListBox).Canvas Do { draw on control canvas, not on the form }
  Begin
    Font.Color := clWindowText; {Set to default color}
    TempText := Piece((Control As TListBox).Items[Index], '^', 1);
    If StrToInt(Piece((Control As TListBox).Items[Index], '^', 3)) = 0 Then
    Begin
      Font.Color := clRed;
    End;
    Brush.Color := clWindow;
    If state = [odSelected, odFocused] Then
      Brush.Color := clBtnFace;
    If (Control As TListBox).Selected[index] = True Then
      Brush.Color := clBtnFace;
    FillRect(Rect); { clear the rectangle }
    TextOut(Rect.Left + 2, Rect.Top, TempText); { display the text }
  End;

End;

Procedure TfrmBrowseTemplates.CCOWTimerTimer(Sender: TObject);
Begin
  If ShutdownCAPRIModalDialogs = true Then
  Begin
    CCOWTimer.Enabled := False;
    frmBrowseTemplates.Visible := False;
    buttonCancelClick(application);
  End;
End;

Procedure TfrmBrowseTemplates.FormActivate(Sender: TObject);
Var
  x: integer;
Begin
  CCOWTimer.Enabled := True;
  // Check if add button should be on or off
  If ListBoxTemplates.ItemIndex = -1 Then
    ButtonAdd.Enabled := False;
  If ListBoxTemplates.Items.Count > 0 Then
    For x := ListBoxTemplates.Items.Count - 1 Downto 0 Do
      If Piece(ListBoxTemplates.Items[x], '^', 1) = 'MEDICAL OPINION' Then
      Begin
        MedicalOpinionPointer := ListBoxTemplates.Items[x];
        // ListBoxTemplates.Items.Delete(x);
      End;
End;

Procedure TfrmBrowseTemplates.ListBoxSelectedTemplatesDblClick(
  Sender: TObject);
Begin
  If ListBoxSelectedTemplates.ItemIndex = -1 Then
    exit;
  ButtonRemoveThisOneClick(Application);
  BtnMoveDown.Enabled := False;
  ButtonRemoveThisOne.Enabled := False;
  ListBoxSelectedTemplates.ItemIndex := -1;
  BtnMoveUp.Enabled := False;
  BtnMoveDown.Enabled := False;
  BtnMoveDown.Enabled := False;
End;

Procedure TfrmBrowseTemplates.ListBoxSelectedTemplatesClick(
  Sender: TObject);
Begin
  FMCommentsMemo.Lines.Clear;

  ButtonRemoveThisOne.Enabled := True;
  ListBoxTemplates.ItemIndex := -1;
  ButtonAdd.Enabled := False;

  FMGetsTemplateInfo.IENS := Piece(ListBoxSelectedTemplates.Items[ListBoxSelectedTemplates.ItemIndex], '^', 2);
  FMGetsTemplateInfo.GetAndFill;
  If FMEditScriptStyle.Text <> 'PASCAL SCRIPT' Then
    FMEditScriptStyle.Text := '';

  If ListBoxSelectedTemplates.ItemIndex > 0 Then
    btnMoveUp.Enabled := True
  Else
    btnMoveUp.Enabled := False;
  If ListBoxSelectedTemplates.ItemIndex < ListBoxSelectedTemplates.Items.Count - 1 Then
  Begin
    If ListBoxSelectedTemplates.ItemIndex > -1 Then
      btnMoveDown.Enabled := True
  End
  Else
    btnMoveDown.Enabled := False;

End;

Procedure TfrmBrowseTemplates.ButtonRemoveThisOneClick(Sender: TObject);
Begin
  ListBoxTemplates.Items.Add(ListBoxSelectedTemplates.items[ListBoxSelectedTemplates.itemindex]);
  ListBoxSelectedTemplates.Items.Delete(ListBoxSelectedTemplates.itemindex);
  ButtonRemoveThisOne.Enabled := False;
  ListBoxTemplatesClick(Application);
  FMCommentsMemo.Lines.Clear;
  If ListBoxSelectedTemplates.Items.Count > 0 Then
    ButtonGenerateTemplate.Enabled := True
  Else
    ButtonGenerateTemplate.enabled := false;
  btnMoveUp.Enabled := False;
  btnMoveDown.Enabled := False;
  If ListBoxSelectedTemplates.Items.Count = 0 Then
    ScriptStyle := '[NULL]';

  UpdateSelectedTemplates;  //CodeCR220 - rpm 2/16/12
End;

Procedure TfrmBrowseTemplates.ButtonAddClick(Sender: TObject);
Begin
  If ListBoxTemplates.ItemIndex = -1 Then
    exit;

  If ScriptStyle = '[NULL]' Then
  Begin
    ScriptStyle := FMEditScriptStyle.Text;
  End;

  If ScriptStyle <> '[NULL]' Then
    If Scriptstyle <> FMEditScriptStyle.Text Then
      exit;

  // showmessage(ListBoxTemplates.items[ListBoxTemplates.itemindex]);
  ListBoxSelectedTemplates.Items.Add(ListBoxTemplates.items[ListBoxTemplates.itemindex]);
  ListBoxTemplates.Items.Delete(ListBoxTemplates.itemindex);

  UpdateSelectedTemplates;  //CodeCR220 - rpm 2/16/12

  ButtonAdd.Enabled := False;
  ListBoxTemplatesClick(Application);
  ListBoxSelectedTemplates.ItemIndex := -1;
  ButtonRemoveThisOne.Enabled := False;
  FMCommentsMemo.Lines.Clear;
  If ListBoxSelectedTemplates.Items.Count > 0 Then
    ButtonGenerateTemplate.Enabled := True
  Else
    ButtonGenerateTemplate.enabled := false;

End;

Procedure TfrmBrowseTemplates.ListBoxTemplatesDblClick(Sender: TObject);
Begin

  If ListBoxTemplates.ItemIndex = -1 Then
    exit;

  ListBoxTemplates.Enabled := False;
  ANURemoteProcedureCallInProgress := False;
  FMGetsTemplateInfo.IENS := Piece(ListBoxTemplates.Items[ListBoxTemplates.ItemIndex], '^', 2);
  FMGetsTemplateInfo.GetAndFill;
  If FMEditScriptStyle.Text <> 'PASCAL SCRIPT' Then
    FMEditScriptStyle.Text := '';

  ListBoxTemplates.Enabled := True;

  ButtonAddClick(Application);
  ListBoxTemplates.ItemIndex := -1;
  ButtonAdd.Enabled := False;
End;

Procedure TfrmBrowseTemplates.btnMoveUpClick(Sender: TObject);
Var
  oldspot, newspot: integer;
  tempstring: String;
Begin
  oldspot := ListBoxSelectedTemplates.ItemIndex;
  NewSpot := OldSpot - 1;
  TempString := ListBoxSelectedTemplates.Items[OldSpot];
  ListBoxSelectedTemplates.Items.Delete(OldSpot);
  ListBoxSelectedTemplates.Items.Insert(NewSpot, TempString);
  ListBoxSelectedTemplates.ItemIndex := NewSpot;
  ListBoxSelectedTemplatesClick(Application);
End;

Procedure TfrmBrowseTemplates.btnmovedownClick(Sender: TObject);
Var
  oldspot, newspot: integer;
  tempstring: String;
Begin
  oldspot := ListBoxSelectedTemplates.ItemIndex;
  NewSpot := OldSpot + 1;
  TempString := ListBoxSelectedTemplates.Items[OldSpot];
  ListBoxSelectedTemplates.Items.Delete(OldSpot);
  If NewSpot < ListBoxSelectedTemplates.Items.Count Then
    ListBoxSelectedTemplates.Items.Insert(NewSpot, TempString)
  Else
    ListBoxSelectedTemplates.Items.Add(TempString);
  //ListBoxSelectedTemplates.Items.Delete(OldSpot);
  ListBoxSelectedTemplates.ItemIndex := NewSpot;
  ListBoxSelectedTemplatesClick(Application);
End;

Procedure TfrmBrowseTemplates.Button1Click(Sender: TObject);
Var
  x: integer;
Begin
  FMCommentsMemo.Lines.Clear;
  For x := 0 To FMListBoxTemplates.Items.Count - 1 Do
    FMCommentsMemo.Lines.Add(FMListBoxTemplates.Items[x]);
  FMCommentsMemo.Lines.SaveToFile('c:\temp.txt');
End;

{========================================================= UpdateSelectedTemplates
This procedure synchronizes the SelectedTemplates string list with
the ListBoxSelectedTemplates.

//CodeCR220 - rpm 2/16/2012
======================================}
procedure TfrmBrowseTemplates.UpdateSelectedTemplates;
var
  I: Integer;
begin
  SelectedTemplates.Clear;
  if ListBoxSelectedTemplates.Items.Count > 0 then
    for I := 0 to ListBoxSelectedTemplates.Items.Count - 1 do
      SelectedTemplates.Add(Piece(ListBoxSelectedTemplates.Items[i], '^', 1));
end;

End.
