unit cls2507Info;

interface

uses Windows, Classes, SysUtils, ComCtrls, DateUtils, clsPatientInfo, CCOWRPCBroker,
     Fmcmpnts, Fmcntrls, MFunStr, untAddtnlMMthds, Dialogs, Trpcb;

type
  T2507Info = class(TObject)
  private
  { Private Declarations }
    _PtntInfo: TPatientInfo;
    _CCOWBrkr: TCCOWRPCBroker;
    _fmRqstExamFiler: TFMFiler;
    _fmInfoGets: TFMGets;
    _fmLstrExams: TFMLister;
    _fmLstrRqsts: TFMLister;
    //procedure DeleteEmptyParentNodes(Tree: TTreeView);
    procedure Get2507Requests(fmCmbBxRqsts: TFMComboBox; numRec: String = '*');
    procedure InitCntrls;
    procedure ResetTFMCmpnt(cmpnt: TComponent);
    function FindNode(Tree: TTreeView; srchVal: String): TTreeNode;
    function Get2507DsplyScreen(strParams, strFile: String): String;
    function GetVistACurrentDate(): String;
  public
  { Public Declarations }
    constructor Create(PtntInfo: TPatientInfo; CCOWBrkr: TCCOWRPCBroker);
    destructor Destroy; override;
    function CheckInExam(ExamIEN, ChkInDte: String; fmMemoExamRslts: TFMMemo): Boolean;
    function CheckOutExam(ExamIEN, CntrctrIEN, ChkOutDTM: String): Boolean;
    function EditExamCheckIn(ExamIEN, ChkInDte: String): Boolean;
    function Get2507Exams(rqstIEN: String): TFMLister;
    function UpdtRqstStatus(RqstIEN: String; StsVal: String): Boolean;
    function HasAvailableRequests(): Boolean;
    function IsSchdlgCmpltd(RqstIEN: String): Boolean;
    function UpdtRqstToSchld(RqstIEN: String; StsVal: String; DteSCmpltd: String;
         GetPrevStsVal: Boolean = False): Boolean;
    procedure ChangePatient(PtntInfo: TPatientInfo);
    procedure GetPatient2507Info(treeViewDisplay: TTreeView; strParams: String);
    procedure GetPatient2507Rqsts(fmCmbBxRqsts: TFMComboBox; numRec: String = '*'); overload;
    procedure GetPatient2507Rqsts(fmCmbBxRqsts: TFMComboBox; frmDTM: String;
         toDTM: String); overload;
    procedure Get2507WPInfo(FileNum, FldNum, IEN: String; fmMemoCmpnt: TFMMemo);
  end;

implementation

{ CUSTOM SORT CALLBACK FUNCTION }
function CustomSortProc(Node1, Node2: TTreeNode; Data: Integer): Integer; stdcall;
  { INLINE FUNCTION BEGIN }
  function ConvertCalendarDateToDelphiDate(DateTimeST: String): String;
  var
    Month, Day, Year: String;
  begin
    Month := Uppercase(Piece(DateTimeST, ' ', 1));
    Day := Piece(Piece(DateTimeST, ' ', 2), ',', 1);
    Year := Piece(DateTimeST, ' ', 3);
    if Pos(Month, 'JAN') = 1 then
      Month := '01';
    if Pos(Month, 'FEB') = 1 then
      Month := '02';
    if Pos(Month, 'MAR') = 1 then
      Month := '03';
    if Pos(Month, 'APR') = 1 then
      Month := '04';
    if Pos(Month, 'MAY') = 1 then
      Month := '05';
    if Pos(Month, 'JUN') = 1 then
      Month := '06';
    if Pos(Month, 'JUL') = 1 then
      Month := '07';
    if Pos(Month, 'AUG') = 1 then
      Month := '08';
    if Pos(Month, 'SEP') = 1 then
      Month := '09';
    if Pos(Month, 'OCT') = 1 then
      Month := '10';
    if Pos(Month, 'NOV') = 1 then
      Month := '11';
    if Pos(Month, 'DEC') = 1 then
      Month := '12';
    if Length(Day) = 1 then
      Day := '0' + Day;
    Result := Month + '/' + Day + '/' + Year;
  end;

  function IsADateTime(Node: TTreeNode): Boolean;
  var
    str: String;
    dtm: TDateTime;
  begin
    str := ConvertCalendarDateToDelphiDate(Piece(Node.Text, '@')) + ' ' +
           Piece(node.Text, '@', 2);
    Result := TryStrToDateTime(str, dtm);
  end;

  function GetDateTime(Node: TTreeNode): TDateTime;
  var
    dtm: TDateTime;
  begin
    dtm := StrToDateTime(ConvertCalendarDateToDelphiDate(Piece(Node.Text, '@')) +
           ' ' + Piece(node.Text, '@', 2));
    Result := dtm;
  end;
  { INLINE FUNCTION END }
begin
  if (IsADateTime(Node1) and IsADateTime(Node2)) then
    Result := CompareDateTime(GetDateTime(Node1), GetDateTime(Node2))
  else if (IsADateTime(Node1) and (Not IsADateTime(Node2))) then
    Result := -1  { DateTime before Exams }
  else if (IsADateTime(Node1) and (Not IsADateTime(Node2))) then
    Result := 1  { Exams before DateTime }
  else
    Result := AnsiStrIComp(PChar(Node1.Text), PChar(Node2.Text));
end;

{ Public }

constructor T2507Info.Create(PtntInfo: TPatientInfo; CCOWBrkr: TCCOWRPCBroker);
begin
  _PtntInfo := PtntInfo;
  _CCOWBrkr := CCOWBrkr;
  InitCntrls;
end;

destructor T2507Info.Destroy;
begin
  _fmLstrRqsts.Free;
  _fmLstrExams.Free;
  _fmRqstExamFiler.Free;
  _fmInfoGets.Free;
end;

procedure T2507Info.ChangePatient(PtntInfo: TPatientInfo);
begin
  _PtntInfo := PtntInfo;
end;

procedure T2507Info.GetPatient2507Info(treeViewDisplay: TTreeView; strParams: string);
var
  i, ii: Integer;
  node: TTreeNode;
  recIEN, exmIEN, exmScrn, ndeChkIn: String;
begin
  ResetTFMCmpnt(_fmLstrRqsts);
  ResetTFMCmpnt(_fmLstrExams);
  { Setup Lister that will retrieve results. 2 Listers required so that
    an RPC call is not required, this will ensure that future modifications
    can be made to the GUI without making changes to the VistA environment.
    List's should be fairly small, so performance should not be an issue. }
  _fmLstrRqsts.FieldNumbers.Add('1');
  _fmLstrRqsts.Screen := Get2507DsplyScreen(strParams, '396.3');
  _fmLstrRqsts.PartList.Add(_PtntInfo.PatientName);
  _fmLstrExams.FieldNumbers.Add('.03');  { Exam Type }
  _fmLstrExams.FieldNumbers.Add('100');  { Contractor }
  _fmLstrExams.FieldNumbers.Add('101');  { Date Transferred to Contractor }
  _fmLstrExams.FieldNumbers.Add('102');  { Date Received from Contractor }
  exmScrn := Get2507DsplyScreen(strParams, '396.4');
  _fmLstrExams.PartList.Add(_PtntInfo.PatientName);
  _fmLstrRqsts.GetList(nil);  { Retrieve Requests }
  treeViewDisplay.Items.BeginUpdate;  { Freeze tree until fully populated }
  treeViewDisplay.Items.Clear;  { Clear Tree Contents }
  { Create Tree }
  for i := 0 to _fmLstrRqsts.Results.Count - 1 do
  begin
    recIEN := _fmLstrRqsts.Results[i];
    { Get Exams for Requests }
    _fmLstrExams.Screen := exmScrn + '&($P(DVBX,"^",2)=' + recIEN + ')';
    _fmLstrExams.GetList(nil);
    { Request only added if exams for it exist }
    if _fmLstrExams.Results.Count > 0 then
    begin
      { Add Requests : PARENT TREE NODES }
      node := treeViewDisplay.Items.Add(nil,
           _fmLstrRqsts.GetRecord(recIEN).GetField('1').FMDBExternal);
      { Add Exams : CHILD TREE NODES }
      for ii := 0 to _fmLstrExams.Results.Count - 1 do
      begin
        exmIEN := _fmLstrExams.Results[ii];
        ndeChkIn := _fmLstrExams.GetRecord(exmIEN).GetField('102').FMDBExternal;
        { Add Pipe seperator between dates if Check-In date exists }
        if (Not SameText(ndeChkIn, '')) then
          ndeChkIn := ' | ' + ndeChkIn;
        treeViewDisplay.Items.AddChild(node,
             _fmLstrExams.GetRecord(exmIEN).GetField('.03').FMDBExternal +
             ' [' + _fmLstrExams.GetRecord(exmIEN).GetField('100').FMDBExternal +
             ': ' + _fmLstrExams.GetRecord(exmIEN).GetField('101').FMDBExternal +
             ndeChkIn + ']');
      end;  { End Exam Loop }
    end;  { End If Exams Returned for Request IEN }
  end;  { End Request For Loop }
  treeViewDisplay.CustomSort(@CustomSortProc, 0);  { Sort Tree }
  treeViewDisplay.Items.EndUpdate;
end;

procedure T2507Info.GetPatient2507Rqsts(fmCmbBxRqsts: TFMComboBox; numRec: String = '*');
begin
  ResetTFMCmpnt(_fmLstrRqsts);  { Reset properties for FMLister Control }
  { Request should be for requested patient and its status should be Pending Reported
    or Scheduled, New or New Transferred In }
  _fmLstrRqsts.Screen := 'I +^(0)=' + _PtntInfo.PatientDFN +
    ',$P(^(0),U,18)]"","P|N|NT|S"[$P(^(0),U,18)';
  Get2507Requests(fmCmbBxRqsts, numRec);
end;

{ Supports the ADMIN Edit Check-In Functionality (frmContractedAdminCheckIn)
    fmCmbBxRqsts: Component to store results in
    frmDTM: From Date range in VistA FMInternal Format
    toDTM: To Date range in VistA FMInternal Format }
procedure T2507Info.GetPatient2507Rqsts(fmCmbBxRqsts: TFMComboBox; frmDTM: string; toDTM: string);
begin
  ResetTFMCmpnt(_fmLstrRqsts);  { Reset properties for FMLister Control }
  { Request should be for requested patient, fall within requested date range
    and its status should be Pending Reported or Scheduled, New,
    New Transferred In, Completed, Printed By RO or Release to RO, Not Printed }
  _fmLstrRqsts.Screen := 'N DVBS S DVBS=$P($G(^(0)),"^",18) I (+$G(^(0))=' +
       _PtntInfo.PatientDFN + ')&(($P($G(^(0)),"^",2)>=' + frmDTM + ')&' +
       '($P($G(^(0)),"^",2)<=' + toDTM + '))&'+
       '((DVBS="P")!(DVBS="N")!(DVBS="NT")!(DVBS="S")!(DVBS="C")!(DVBS="R"))';
  Get2507Requests(fmCmbBxRqsts, '*');
end;

procedure T2507Info.Get2507WPInfo(FileNum: string; FldNum: String; IEN: string;
     fmMemoCmpnt: TFMMemo);
begin
  fmMemoCmpnt.Lines.Clear;
  fmMemoCmpnt.FMGets := _fmInfoGets;
  _fmInfoGets.IENS := IEN;
  _fmInfoGets.FieldNumbers.Clear;
  _fmInfoGets.FieldNumbers.Add(FldNum);
  _fmInfoGets.FileNumber := FileNum;
  _fmInfoGets.GetAndFill;
end;

function T2507Info.Get2507Exams(rqstIEN: string): TFMLister;
begin
  ResetTFMCmpnt(_fmLstrExams);  { Reset FMLister Properties }
  _fmLstrExams.Screen := 'I $P($G(^(0)),"^",2)=' + rqstIEN;
  _fmLstrExams.PartList.Add(_PtntInfo.PatientName);  { Narrows retrieval of Exams }
  _fmLstrExams.FieldNumbers.Add('.03');   { Exam Type (396.6) }
  _fmLstrExams.FieldNumbers.Add('.04');   { Status }
  _fmLstrExams.FieldNumbers.Add('90I');  { Date Transcription Complete }
  _fmLstrExams.FieldNumbers.Add('100I');   { Contractor - Return IEN }
  _fmLstrExams.FieldNumbers.Add('101I');   { Date Transferred to Contractor }
  _fmLstrExams.FieldNumbers.Add('102I');   { Date Received from Contractor }
  _fmLstrExams.GetList(nil);
  Result := _fmLstrExams;
end;

function T2507Info.HasAvailableRequests(): Boolean;
begin
  Result := False;
  { Only 1 record is needed to satisfy boolean result }
  GetPatient2507Rqsts(nil, '1');
  if _fmLstrRqsts.Results.Count > 0 then
    Result := True;
end;

function T2507Info.CheckInExam(ExamIEN: string; ChkInDte: string;
     fmMemoExamRslts: TFMMemo): Boolean;
var
  exmSts, exmPlce, exmPhyscn, exmTransDTM: String;
begin
  fmMemoExamRslts.FMFile := '396.4';
  fmMemoExamRslts.IENS := ExamIEN;
  fmMemoExamRslts.FMFiler := _fmRqstExamFiler;
  exmSts := 'C';  { Completed }
  exmPlce := 'F';  { Fee Location }
  exmPhyscn := 'VENDOR EXAMINER';  { Examining Physician }
  exmTransDTM := GetVistACurrentDate(); { Transcription Complete DateTime }
  if SameText(ChkInDte, '@') then
  begin
    exmSts := 'O';  { Open }
    exmPlce := '@';
    exmPhyscn := '@';
    exmTransDTM := '@';
  end;  { End If Check-In process to be deleted }
  _fmRqstExamFiler.Clear;  { Clears any residual change requests in filer }
  _fmRqstExamFiler.AddChgdControl(fmMemoExamRslts);  { Exam Results }
  { Update Exam's Check-In Date when info received from Contractor }
  _fmRqstExamFiler.AddFDA('396.4', ExamIEN, '102', ChkInDte);
  _fmRqstExamFiler.AddFDA('396.4', ExamIEN, '.04', exmSts);  { Exam Status }
  _fmRqstExamFiler.AddFDA('396.4', ExamIEN, '.07', exmPhyscn);  { Examing Physician }
  _fmRqstExamFiler.AddFDA('396.4', ExamIEN, '.09', exmPlce);  { Exam Place }
  // _fmRqstExamFiler.AddFDA('396.4', ExamIEN, '90', exmTransDTM);  { Transcription Complete DateTime }  // DONE: LMS Commenting this line out because updating this field is being seen as setting that the exam is "Transcribed"Date" and as a result not allowed to "auto-release". See code referring to field 90 in tiusign.pas and uncosignedutility.pas units... also see referred code section in demTranMain.pas.
  Result := _fmRqstExamFiler.Update;
end;

function T2507Info.CheckOutExam(ExamIEN: string; CntrctrIEN: string;
     ChkOutDTM: string): Boolean;
begin
  _fmRqstExamFiler.Clear;  { Clears any residual change requests in filer }
  { Update Exam's Contractor and Date/Time it was sent to the Contractor }
  _fmRqstExamFiler.AddFDA('396.4', ExamIEN, '100', CntrctrIEN);
  _fmRqstExamFiler.AddFDA('396.4', ExamIEN, '101', ChkOutDTM);
  Result := _fmRqstExamFiler.Update;
end;

function T2507Info.EditExamCheckIn(ExamIEN: string; ChkInDte: string): Boolean;
begin
  _fmRqstExamFiler.Clear;  { Clears any residual change requests in filer }
  { Update Exam's Check-In Date when info received from Contractor }
  _fmRqstExamFiler.AddFDA('396.4', ExamIEN, '102', ChkInDte);
  Result := _fmRqstExamFiler.Update;
end;

function T2507Info.IsSchdlgCmpltd(RqstIEN: string): Boolean;
begin
  Result := Not SameText(_fmLstrRqsts.GetRecord(RqstIEN).GetField('5').FMDBExternal, '');
end;

function T2507Info.UpdtRqstToSchld(RqstIEN: string; StsVal: string;
     DteSCmpltd: string; GetPrevStsVal: Boolean = False): Boolean;
begin
  if GetPrevStsVal then  { Value exists in LISTER }
    StsVal := _fmLstrRqsts.GetRecord(RqstIEN).GetField('17').FMDBExternal;
  _fmRqstExamFiler.Clear;  { Clears any residual change requests in filer }
  { Update Request's Status and Date/Time Scheduling was Completed }
  _fmRqstExamFiler.AddFDA('396.3', RqstIEN, '5', DteSCmpltd);
  _fmRqstExamFiler.AddFDA('396.3', RqstIEN, '17', StsVal);
  Result := _fmRqstExamFiler.Update;
end;

function T2507Info.UpdtRqstStatus(RqstIEN: String; StsVal: String): Boolean;
begin
  _fmRqstExamFiler.Clear;  { Clears any residual change requests in filer }
  { Update Request's Status - All Exams for request are either completed or
    cancelled if set to "P", else if disapproved will be set back to "S". }
  _fmRqstExamFiler.AddFDA('396.3', RqstIEN, '17', StsVal);
  Result := _fmRqstExamFiler.Update;
end;

{ Private }

procedure T2507Info.InitCntrls;
begin
  _fmLstrRqsts := TFMLister.Create(_fmLstrRqsts);
  _fmLstrRqsts.RPCBroker := _CCOWBrkr;
  _fmLstrRqsts.FileNumber := '396.3';
  _fmLstrRqsts.FMIndex := 'B';
  _fmLstrExams := TFMLister.Create(_fmLstrExams);
  _fmLstrExams.RPCBroker := _CCOWBrkr;
  _fmLstrExams.FileNumber := '396.4';
  _fmLstrExams.FMIndex := 'C';
  _fmRqstExamFiler := TFMFiler.Create(_fmRqstExamFiler);
  _fmRqstExamFiler.RPCBroker := _CCOWBrkr;
  _fmInfoGets := TFMGets.Create(_fmInfoGets);
  _fmInfoGets.RPCBroker := _CCOWBrkr;
end;

(*
procedure T2507Info.DeleteEmptyParentNodes(Tree: TTreeView);
var
  i: Integer;
  nde: TTreeNode;
  nodeList : TStringList;
begin
  // TODO: LMS - Never called?  And a possible memory leak if it is called.
  nodeList := TStringList.Create;
  nde := Tree.Items.GetFirstNode;  { Start at top of tree }
  while nde <> nil do
  begin
    if Not Assigned(nde.Parent) then  { Check for Parent Node }
      if Not nde.HasChildren then
        nodeList.AddObject(nde.Text, nde);  { Add Node To List for Deletion }
    nde := nde.GetNext;
  end;  { End While Tree Traverse }
  for i := 0 to nodeList.Count - 1 do  { Delete all nodes in list }
    Tree.Items.Delete(TTreeNode(nodeList.Objects[i]));
end;
*)

procedure T2507Info.ResetTFMCmpnt(cmpnt: TComponent);
begin
  if (cmpnt is TFMLister) then
  begin
    TFMLister(cmpnt).DisplayFields.Clear;
    TFMLister(cmpnt).FieldNumbers.Clear;
    TFMLister(cmpnt).PartList.Clear;
    TFMLister(cmpnt).ListerFlags := [];
    TFMLister(cmpnt).IENS := '';
    TFMLister(cmpnt).Number := '*';
  end  { End If TFMLister Component }
  else if (cmpnt is TFMGets) then
  begin
    TFMGets(cmpnt).FieldNumbers.Clear;
    TFMGets(cmpnt).IENS := '';
  end;  { End If TFMGets Component }
end;

function T2507Info.FindNode(Tree: TTreeView; srchVal: string): TTreeNode;
var
  nde: TTreeNode;
begin
  Result := nil;
  nde := Tree.Items.GetFirstNode;  { Start at top of tree for search }
  while nde <> nil do  { Search through tree nodes }
  begin
    if Not Assigned(nde.Parent) then
      if SameText(nde.Text, srchVal) then
      begin
        Result := nde;
        break;
      end;  { End If Node Search Value Found }
    nde := nde.GetNext;  { Get Next Node in Tree To Evaluate }
  end;  { End While Tree Search }
end;

function T2507Info.Get2507DsplyScreen(strParams, strFile: string): String;
{ strParams consists of 3 '^' delimitted pieces
   1. Exam Type
   2. From Date
   3. To Date }
begin
  if SameText(strFile, '396.3') then  { Exam Type ignored }
  begin
    { Ensure current patient's request - Results narrowed by PARTSLIST }
    Result := 'I (+$G(^(0))=' + _PtntInfo.PatientDFN + ')';
//     Append Date Range Filter Removed jltp 01/25/2013
    // DONE: LMS blank date value handling. Now caller must ensure valid date values.
    Result := Result + '&(($P($G(^(0)),"^",2)>=' +
              DelphiDateToFMInternal(StrToDate(Piece(strParams,'^',2))) +
              ')&($P($G(^(0)),"^",2)<=' +
              DelphiDateToFMInternal(StrToDate(Piece(strParams,'^',3))) + '))';
  end  { End If File is 2507 Request }
  else if SameText(strFile, '396.4') then
  begin
    { Request IEN will be used in PartsList to narrow results to applicable recs }
    { Ensure current patient's request - Handled in Request Retrieval }
    { Append Date Range Filter - Handled in Request Retrieval }
    { Append Contracted Type Filter }
    Result := 'N DVBC,DVBX S DVBX=$G(^(0)),DVBC=$G(^("CNTRCTR")) ';
    { Ensure exam NOT Cancelled when looking for OPEN exams to display }
    if SameText(UpperCase(Piece(strParams,'^')),'PENDING REFERRALS') then
      Result := Result + 'I ((+DVBC)&($P(DVBC,"^",2)]"")&($P(DVBC,"^",3)'']"")&($P(DVBX,"^",4)''["X"))'
    else if SameText(UpperCase(Piece(strParams,'^')),'CANCELLED') then
      Result := Result + ' I ((+DVBC)&($P(DVBX,"^",4)["X"))'
    else if SameText(UpperCase(Piece(strParams,'^')),'COMPLETED') then
      Result := Result + 'I ((+DVBC)&($P(DVBC,"^",3)]""))';
  end;  { End If File is 2507 Exam }
end;

procedure T2507Info.Get2507Requests(fmCmbBxRqsts: TFMComboBox; numRec: String = '*');
begin
  _fmLstrRqsts.PartList.Add(_PtntInfo.PatientName);
  _fmLstrRqsts.DisplayFields.Add('1');
  _fmLstrRqsts.FieldNumbers.Add('1');  { 2507 Request Date }
  _fmLstrRqsts.FieldNumbers.Add('2');  { Regional Office Number }
  _fmLstrRqsts.FieldNumbers.Add('5');  { Date Scheduling Completed }
  _fmLstrRqsts.FieldNumbers.Add('9I');  { Priority of Exam - Identifies Insuff. Exams}
  _fmLstrRqsts.FieldNumbers.Add('17I');  { Request Status }
  _fmLstrRqsts.FieldNumbers.Add('21');  { Claim Folder Required }
  _fmLstrRqsts.Number := numRec;
  if fmCmbBxRqsts <> nil then
  begin
    fmCmbBxRqsts.FMLister := _fmLstrRqsts;
    fmCmbBxRqsts.GetList;
  end
  else
    _fmLstrRqsts.GetList(nil)
end;

function T2507Info.GetVistACurrentDate(): String;
begin
  Result := '';
  { AMIE subscriber (Controlled Subscription) DBIA: 3363 }     // Ugh! So many places, calling the same RPC. Ugh!
  _CCOWBrkr.RemoteProcedure := 'ORWU DT';
  _CCOWBrkr.Param[1].Value := 'NOW';
  _CCOWBrkr.Param[1].PType := literal;
  try
    _CCOWBrkr.Call;
    Result := _CCOWBrkr.Results[0];
  except
    Result := DelphiDateToFMInternal(Now) + '.' +
         Piece(StringReplace(TimeToStr(Now), ':', '',[rfReplaceAll, rfIgnoreCase]), ' ');
  end;  { End Try/Except Block }
end;

end.
