Unit comments1;

Interface

Uses
  Classes,
  clipbrd,
  Controls,
  Dialogs,
  DialogsCAPRI,
  ExtCtrls,
  Forms,
  Graphics,
  Menus,
  Messages,
  StdCtrls,
  SysUtils,
  Windows, ActnList, XPStyleActnCtrls, ActnMan, ToolWin, ActnCtrls, ActnMenus;

Type
  TfrmComments = Class(TForm)
    btnDone: TButton;
    memoCancelComments: TMemo;
    ActionManComments: TActionManager;
    actEditUndo: TAction;
    actEditCut: TAction;
    actEditCopy: TAction;
    actEditPaste: TAction;
    actMenuBarComments: TActionMainMenuBar;
    Procedure btnDoneClick(Sender: TObject);
    procedure actEditUndoUpdate(Sender: TObject);
    procedure actEditUndoExecute(Sender: TObject);
    procedure actEditCutExecute(Sender: TObject);
    procedure actEditCopyExecute(Sender: TObject);
    procedure actEditPasteExecute(Sender: TObject);
  Private
    { Private declarations }
    procedure WMMenuChar(var Message: TWMMenuChar); message WM_MENUCHAR;
  Public
    { Public declarations }
  End;

Var
  frmComments: TfrmComments;
  FEditCtrl: TCustomEdit;

Implementation

Uses
  CapriSupport;

{$R *.DFM}

procedure TfrmComments.actEditCopyExecute(Sender: TObject);
begin
  FEditCtrl.CopyToClipboard;
end;

procedure TfrmComments.actEditCutExecute(Sender: TObject);
begin
  FEditCtrl.CutToClipboard;
end;

procedure TfrmComments.actEditPasteExecute(Sender: TObject);
begin
  FEditCtrl.SelText := Clipboard.AsText;
end;

procedure TfrmComments.actEditUndoExecute(Sender: TObject);
begin
  FEditCtrl.Perform(EM_UNDO, 0, 0);
end;

procedure TfrmComments.actEditUndoUpdate(Sender: TObject);
Var
  tempTMemoBox: TMemo;
  tempTEdit: TEdit;
Begin
  FEditCtrl := Nil;
  If Screen.ActiveControl Is TCustomEdit Then
    FEditCtrl := TCustomEdit(Screen.ActiveControl);
  If FEditCtrl <> Nil Then
  Begin
    actEditUndo.Enabled := FEditCtrl.Perform(EM_CANUNDO, 0, 0) <> 0;
    actEditCut.Enabled := FEditCtrl.SelLength > 0;
    actEditCopy.Enabled := actEditCut.Enabled;
    actEditPaste.Enabled := Clipboard.HasFormat(CF_TEXT);
  End
  Else
  Begin
    actEditUndo.Enabled := False;
    actEditCut.Enabled := False;
    actEditCopy.Enabled := False;
    actEditPaste.Enabled := False;
  End;
  // Don't let read only memos accept paste function
  If FEditCtrl = Nil Then
    exit;
  If (Uppercase(FEditCtrl.ClassName) = 'TMEMO') Then
  Begin
    tempTMemoBox := FEditCtrl As TMemo;
    If (tempTMemoBox.Readonly = True) Then
    Begin
      actEditUndo.Enabled := False;
      actEditCut.Enabled := False;
      actEditPaste.Enabled := False;
    End;
  End;
  If (Uppercase(FEditCtrl.ClassName) = 'TEDIT') Then
  Begin
    tempTEdit := FEditCtrl As TEdit;
    If (tempTEdit.Readonly = True) Then
    Begin
      actEditUndo.Enabled := False;
      actEditCut.Enabled := False;
      actEditPaste.Enabled := False;
    End;
  End;
end;

Procedure TfrmComments.btnDoneClick(Sender: TObject);
Begin
  ModalResult := mrOK;
End;

//CCAPRI_CodeCR96 - jcs - 03/16/10
procedure TfrmComments.WMMenuChar(var Message: TWMMenuChar);
begin
  If Not ActivateMenu(self, Message) then
    Inherited;
end;

End.
