unit dlgAbout;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, VA508AccessibilityManager, untMiscMthds;

type
  TfrmAboutDlg = class(TForm)
    imgTrain: TImage;
    btnOk: TButton;
    tmrAboutClose: TTimer;
    stlblPrdctName: TStaticText;
    stlblVersion: TStaticText;
    stlblCompany: TStaticText;
    stlblComments: TStaticText;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure tmrAboutCloseTimer(Sender: TObject);
  private
    { Private declarations }
    _VersionInfo: TStringList;
    procedure GetVersionInfo;
    procedure CreateVersionDisplay;
  public
    { Public declarations }
    class procedure ShowAbout;
  end;

var
  frmAboutDlg: TfrmAboutDlg;

implementation

{$R *.dfm}

procedure TfrmAboutDlg.FormCreate(Sender: TObject);
begin
//  GetVersionInfo;  { Retrieved from values in Project - Options - Version Info }

  CreateVersionDisplay;  { Populate Labels with selected Version Info }
end;

procedure TfrmAboutDlg.FormShow(Sender: TObject);
begin
  tmrAboutClose.Enabled := True;
  btnOk.SetFocus;
end;

procedure TfrmAboutDlg.GetVersionInfo;
begin

end;

procedure TfrmAboutDlg.CreateVersionDisplay;
begin
  { Product Name }
  stlblPrdctName.Caption := VersionInfo(vpProductName);
  { Version Info }
  stlblVersion.Caption := 'Version: ' + VersionInfo(vpFileVersion);
  { Company Info }
  stlblCompany.Caption := VersionInfo(vpCompanyName);
  { Comment Info }
  stlblComments.Caption := VersionInfo(vpComments);
  stlblComments.Width := 437;
  stlblComments.Height := 49;
end;

class procedure TfrmAboutDlg.ShowAbout;
begin
  frmAboutDlg := TfrmAboutDlg.Create(nil);
  try
    frmAboutDlg.ShowModal;
  finally
    frmAboutDlg.Release;
  end;  { End Try/Finally Block }
end;

procedure TfrmAboutDlg.tmrAboutCloseTimer(Sender: TObject);
begin
  self.ModalResult := mrOk;
end;

end.
