unit dlgCntrctdExmRpts;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Diaccess, StdCtrls, DateUtils, Fmcmpnts, Fmcntrls,
  CCOWRPCBrokerCAPRI,     // DONE: CodeCR457 - LMS Changed from CCOWRPCBroker
  untBrkrMthds, ComCtrls, untAddtnlMMthds, MFunStr,
  untMiscMthds, dialogsCAPRI, Buttons;

type
  TcntrctdExmRptDlg = class(TForm)
    tmrWndwClose: TTimer;
    fmLstrCntrctrs: TFMLister;
    tmrEnsrBrkrCnnctd: TTimer;
    btnOk: TButton;
    btnCancel: TButton;
    GroupBox1: TGroupBox;
    chkbxByCntrctrFltr: TCheckBox;
    fmCmbBxContractor: TFMComboBox;
    chkbxDateFltr: TCheckBox;
    pnlPendingFltr: TPanel;
    chkbxPndgExmsOnlyFltr: TCheckBox;
    chkbxNumDaysPstFltr: TCheckBox;
    txtbxDaysRfrlExcd: TEdit;
    pnlDateFltr: TPanel;
    cmbxDteFltrSlctn: TComboBox;
    pnlDteRnge: TPanel;
    chkbxCntrctrSort: TCheckBox;
    pnlMnths: TPanel;
    cmbxMonths: TComboBox;
    pnlYear: TPanel;
    txtbxYear: TEdit;
    pnlWeekOf: TPanel;
    cmbBxContractor: TComboBox;
    pnlCntrctrSlctn: TPanel;
    Label1: TLabel;
    Panel2: TPanel;
    Label2: TLabel;
    Panel3: TPanel;
    Label3: TLabel;
    Panel4: TPanel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    pnlDaysRfrrlExcds: TPanel;
    Label8: TLabel;
    btnDtPckrFrom: TSpeedButton;
    btnDtPckrTo: TSpeedButton;
    edtDtPckrFrom: TEdit;
    edtDtPckrTo: TEdit;
    edtDtWeekOf: TEdit;
    btnDtWeekOfCalendar: TSpeedButton;
    procedure tmrWndwCloseTimer(Sender: TObject);
    procedure tmrEnsrBrkrCnnctdTimer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure chkbxByCntrctrFltrClick(Sender: TObject);
    procedure chkbxDateFltrClick(Sender: TObject);
    procedure chkbxPndgExmsOnlyFltrClick(Sender: TObject);
    procedure chkbxNumDaysPstFltrClick(Sender: TObject);
    procedure cmbxDteFltrSlctnChange(Sender: TObject);
//    procedure dtPckrFromChange(Sender: TObject);
//    procedure dtPckrToChange(Sender: TObject);
//    procedure dtPckrWeekOfChange(Sender: TObject);
    procedure fmCmbBxContractorKeyPress(Sender: TObject; var Key: Char);
    procedure fmCmbBxContractorChange(Sender: TObject);
    procedure txtbxDaysRfrlExcdChange(Sender: TObject);
    procedure txtbxYearChange(Sender: TObject);
    procedure cmbxMonthsChange(Sender: TObject);
    procedure txtbxYearExit(Sender: TObject);
    procedure txtbxDaysRfrlExcdExit(Sender: TObject);
    procedure cmbBxContractorChange(Sender: TObject);
//    procedure dtPckrFromExit(Sender: TObject);
//    procedure dtPckrToExit(Sender: TObject);
//    procedure dtPckrWeekOfExit(Sender: TObject);
    procedure btnDtPckrFromClick(Sender: TObject);
    procedure btnDtPckrToClick(Sender: TObject);
    procedure edtDtPckrFromExit(Sender: TObject);
    procedure edtDtPckrToExit(Sender: TObject);
    procedure edtDtWeekOfExit(Sender: TObject);
    procedure btnDtWeekOfCalendarClick(Sender: TObject);
  private
    { Private declarations }
    _strRptType: String;
    _CCOWBrkr: TCCOWRPCBrokerCAPRI;
    function ContractorsExist(): Boolean;
    procedure ResetWndwTmr;
    procedure SetupForm;
    function  IsNumeric(sBuffer : String) : Boolean;  // 2/27/13 JRL - added to replace NumbersOnly property
    function GetDateOfText(aDateStr : string; defaultDate : string) : TDateTime;
    // function IsDateValid(aDateStr : string) : Boolean;  // DONE: LMS refactored out
    procedure DateComplete(var StrLikeDate : string; MinDate : TDate; const NowIfError : Boolean = TRUE);
  public
    { Public declarations }
    constructor Create(AOwner: TComponent; RptType: String; CCOWBrkr: TCCOWRPCBrokerCAPRI;
         TmrVal: Cardinal); reintroduce;
    destructor Destroy; override;
    function GetParams(): TStringList;
  end;

var
  cntrctdExmRptDlg: TcntrctdExmRptDlg;

implementation
uses
  VocRehabSelectDate  // DONE: CodeCR457 - LMS For replacing date selection components
  ;

{$R *.dfm}

{ RptType : Detailed / Summary or Timeliness }
constructor TcntrctdExmRptDlg.Create(AOwner: TComponent; RptType: String;
     CCOWBrkr: TCCOWRPCBrokerCAPRI; TmrVal: Cardinal);
begin
  inherited Create(AOwner);
  _CCOWBrkr := CCOWBrkr;
  _strRptType := RptType;
  fmLstrCntrctrs.RPCBroker := _CCOWBrkr;
  tmrWndwClose.Interval := TmrVal;
  { Throw Exception if no Contractors Exist }
  if Not ContractorsExist then
    raise Exception.Create('There are no contractors defined to create a  ' +
         LowerCase(_strRptType) + ' contracted report.' +
         #13#10 + 'Consult your local demTRAN Administrator or IRM about adding 2507 Exam Contractors.');
end;


destructor TcntrctdExmRptDlg.Destroy;
begin
  inherited;
end;

procedure TcntrctdExmRptDlg.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  tmrWndwClose.Enabled := False;
  tmrEnsrBrkrCnnctd.Enabled := False;
end;

procedure TcntrctdExmRptDlg.FormShow(Sender: TObject);
begin
  SetupForm;
end;

procedure TcntrctdExmRptDlg.tmrEnsrBrkrCnnctdTimer(Sender: TObject);
begin
  { Close Window if Broker cannot be reconnected }
  if Not EnsureBrokerConnected(_CCOWBrkr) then
    Close;
end;

procedure TcntrctdExmRptDlg.tmrWndwCloseTimer(Sender: TObject);
begin
  { Shutdown Report Filter window to allow app to close - tmr is set just
    short of Main Application's Shutdown Timer value }
  Close;
end;

procedure TcntrctdExmRptDlg.txtbxDaysRfrlExcdChange(Sender: TObject);
begin
  if not IsNumeric((Sender as TEdit).Text) then
     (Sender as TEdit).Undo;
  ResetWndwTmr;
end;

procedure TcntrctdExmRptDlg.txtbxDaysRfrlExcdExit(Sender: TObject);
begin
  if SameText(txtbxDaysRfrlExcd.Text, '') then
    txtbxDaysRfrlExcd.Text := '0';
end;

procedure TcntrctdExmRptDlg.txtbxYearChange(Sender: TObject);
begin
  if not IsNumeric((Sender as TEdit).Text) then
    (Sender as TEdit).Undo;
  ResetWndwTmr;
end;

procedure TcntrctdExmRptDlg.txtbxYearExit(Sender: TObject);
begin
  if Length(txtbxYear.Text) <> 4 then
  begin
    Application.MessageBox('Year must be 4 digits.' + #13#10 +
         'Please correct to continue.', 'Invalid Year', MB_OK);
    txtbxYear.SetFocus;
  end;  { End If Year Text is NOT 4 characters }
end;

procedure TcntrctdExmRptDlg.btnDtPckrFromClick(Sender: TObject);
var
  ADate : TDateTime;
  frmVRSelectDate: TfrmVRSelectDate;
begin
  frmVRSelectDate := TfrmVRSelectDate.Create(Application);
  try
    frmVRSelectDate.MinimumDate := StrToDate('01/01/1900');  // editing - allow reasonable dates
    if TryStrToDate(edtDtPckrFrom.Text,ADate) then
      frmVRSelectDate.calSelectDate.Date := ADate
    else
      frmVRSelectDate.calSelectDate.Date := Today;
    frmVRSelectDate.ShowModal;
    edtDtPckrFrom.Text := frmVRSelectDate.SelectedDate;
  finally
    FreeAndNil(frmVRSelectDate);
  end;
  if (ActiveControl = edtDtPckrFrom) then
    SelectNext(ActiveControl as TWinControl, TRUE, TRUE);

end;

procedure TcntrctdExmRptDlg.btnDtPckrToClick(Sender: TObject);
var
  ADate : TDateTime;
  frmVRSelectDate: TfrmVRSelectDate;
begin
  frmVRSelectDate := TfrmVRSelectDate.Create(Application);
  try
    frmVRSelectDate.MinimumDate := StrToDate('01/01/2000');  // editing - allow reasonable dates
    if TryStrToDate(edtDtPckrTo.Text,ADate) then
      frmVRSelectDate.calSelectDate.Date := ADate
    else
      frmVRSelectDate.calSelectDate.Date := Tomorrow;
    frmVRSelectDate.ShowModal;
    edtDtPckrTo.Text := frmVRSelectDate.SelectedDate;
  finally
    FreeAndNil(frmVRSelectDate);
  end;
  if (ActiveControl = edtDtPckrTo) then
    SelectNext(ActiveControl as TWinControl, TRUE, TRUE);
end;

procedure TcntrctdExmRptDlg.btnDtWeekOfCalendarClick(Sender: TObject);
var
  ADate : TDateTime;
  frmVRSelectDate: TfrmVRSelectDate;
begin
  frmVRSelectDate := TfrmVRSelectDate.Create(Application);
  try
    frmVRSelectDate.MinimumDate := StrToDate('01/01/1900');  // editing - allow reasonable dates
    if TryStrToDate(edtDtWeekOf.Text,ADate) then
      frmVRSelectDate.calSelectDate.Date := ADate
    else
      frmVRSelectDate.calSelectDate.Date := Today;
    frmVRSelectDate.ShowModal;
    edtDtWeekOf.Text := frmVRSelectDate.SelectedDate;
  finally
    FreeAndNil(frmVRSelectDate);
  end;
  if (ActiveControl = edtDtWeekOf) then
    SelectNext(ActiveControl as TWinControl, TRUE, TRUE);
end;

procedure TcntrctdExmRptDlg.chkbxByCntrctrFltrClick(Sender: TObject);
begin
  ResetWndwTmr;
  pnlCntrctrSlctn.Visible := chkbxByCntrctrFltr.Checked;
  { Sort By Contractor Option only enabled for Detailed Type Report }
  if SameText(UpperCase(_strRptType), 'DETAILED') then
    chkbxCntrctrSort.Visible := Not chkbxByCntrctrFltr.Checked;
end;

procedure TcntrctdExmRptDlg.chkbxDateFltrClick(Sender: TObject);
begin
  ResetWndwTmr;
  pnlDateFltr.Visible := chkbxDateFltr.Checked;
end;

procedure TcntrctdExmRptDlg.chkbxNumDaysPstFltrClick(Sender: TObject);
begin
  ResetWndwTmr;
  pnlDaysRfrrlExcds.Visible := chkbxNumDaysPstFltr.Checked;
end;

procedure TcntrctdExmRptDlg.chkbxPndgExmsOnlyFltrClick(Sender: TObject);
begin
  ResetWndwTmr;
  if Not chkbxPndgExmsOnlyFltr.Checked then
    chkbxNumDaysPstFltr.Checked := False;  { So TxtBx is hidden }
  chkbxNumDaysPstFltr.Visible := chkbxPndgExmsOnlyFltr.Checked;
end;

procedure TcntrctdExmRptDlg.cmbBxContractorChange(Sender: TObject);
begin
  ResetWndwTmr;
  { Keep FMCmbBx in sync }
  fmCmbBxContractor.ItemIndex := cmbBxContractor.ItemIndex;
end;

procedure TcntrctdExmRptDlg.cmbxDteFltrSlctnChange(Sender: TObject);
begin
  ResetWndwTmr;
  { Hide selection then show requested selection }
  pnlDteRnge.Visible := False;
  pnlMnths.Visible := False;
  pnlYear.Visible := False;
  pnlWeekOf.Visible := False;
  case cmbxDteFltrSlctn.ItemIndex of
    0 : pnlDteRnge.Visible := True;  { Date Range Selection }
    1 : pnlMnths.Visible := True;  { Month Selection }
    2 : pnlYear.Visible := True;  { Year Selection }
    3 : pnlWeekOf.Visible := True; { Week of Selection }
  end;  { End Case Selection }
end;

procedure TcntrctdExmRptDlg.cmbxMonthsChange(Sender: TObject);
begin
  ResetWndwTmr;
end;

//procedure TcntrctdExmRptDlg.dtPckrFromChange(Sender: TObject);
//begin
//  ResetWndwTmr;
//  edtDtPckrFrom.Text := DatetoStr(DtPckrFrom.Date);
//end;

//procedure TcntrctdExmRptDlg.dtPckrFromExit(Sender: TObject);
//var
//  msg: String;
//begin
//  msg := '';
//  ResetWndwTmr;
//  { Check for Valid Date }
//  if (dtPckrFrom.IsDateValid) then
//  begin
//    if (dtPckrFrom.Date > dtPckrTo.Date) then
//      msg := 'From date cannot exceed the To date.' + #13#10 +
//           'Please enter a date on or before ' + DateTimeToStr(dtPckrTo.Date) + '.';
//  end
//  else
//    msg := 'The date entered is invalid, please enter a valid date to continue.' + #13#10 +
//         'Valid date format is: 1-2 digit Month / 1-2 digit Day / 2-4 digit year';
//  if (Not SameText(msg, '')) then
//  begin
//    ShowMessageCAPRI(msg);
//    dtPckrFrom.SetFocus;
//    dtPckrFrom.SelectAll;
//  end;  { End Error Occured, display message and reset focus }
//end;

//procedure TcntrctdExmRptDlg.dtPckrToChange(Sender: TObject);
//begin
//  ResetWndwTmr;
//  edtDtPckrTo.Text := DatetoStr(DtPckrTo.Date);
//end;

//procedure TcntrctdExmRptDlg.dtPckrToExit(Sender: TObject);
//var
//  msg: String;
//begin
//  msg := '';
//  ResetWndwTmr;
//  { Check for Valid Date }
//  if (dtPckrTo.IsDateValid) then
//  begin
//    if (dtPckrTo.Date < dtPckrFrom.Date) then
//      msg := 'To date cannot precede the From date.' + #13#10 +
//           'Please enter a date on or after ' + DateTimeToStr(dtPckrFrom.Date) + '.';
//  end
//  else
//    msg := 'The date entered is invalid, please enter a valid date to continue.' + #13#10 +
//         'Valid date format is: 1-2 digit Month / 1-2 digit Day / 2-4 digit year';
//  if (Not SameText(msg, '')) then
//  begin
//    ShowMessageCAPRI(msg);
//    dtPckrTo.SetFocus;
//    dtPckrTo.SelectAll;
//  end;  { End Error Occured, display message and reset focus }
//end;

//procedure TcntrctdExmRptDlg.dtPckrWeekOfChange(Sender: TObject);
//begin
//  ResetWndwTmr;
//end;

//procedure TcntrctdExmRptDlg.dtPckrWeekOfExit(Sender: TObject);
//var
//  msg: String;
//begin
//  msg := '';
//  ResetWndwTmr;
//  { Check for Valid Date }
//  if (dtPckrWeekOf.IsDateValid) then
//    { Set date to beginning of week if NOT Monday }
//    dtPckrWeekOf.Date := IncDay(dtPckrWeekOf.Date, (2 - DayofWeek(dtPckrWeekOf.Date)))
//  else
//    msg := 'The date entered is invalid, please enter a valid date to continue.' + #13#10 +
//         'Valid date format is: 1-2 digit Month / 1-2 digit Day / 2-4 digit year';
//  if (Not SameText(msg, '')) then
//  begin
//    ShowMessageCAPRI(msg);
//    dtPckrWeekOf.SetFocus;
//    dtPckrWeekOf.SelectAll;
//  end;  { End Error Occured, display message and reset focus }
//end;

procedure TcntrctdExmRptDlg.edtDtPckrFromExit(Sender: TObject);
var
  msg: String;
  s : string;
  MinDate : TDate;
begin
  msg := '';
  // validate text input in date field
  s := edtDtPckrFrom.Text;
  MinDate := StrToDate('01/01/1900'); 
  DateComplete(s, MinDate, FALSE);
  edtDtPckrFrom.Text := s;
  if copy(edtDtPckrFrom.Text,1,4) = 'Min ' then
  begin
    edtDtPckrFrom.Text := '';
    ShowMessageCAPRI('Please select a more current date');
    edtDtPckrFrom.SetFocus;
  end;               
  { Check for Valid Date Range}
  if IsDateValid(edtDtPckrFrom.Text) then
  begin
    if ((GetDateOfText(edtDtPckrFrom.Text, '1/1/1900'))
        > (GetDateOfText(edtDtPckrTo.Text, '1/1/2000'))) then
      msg := 'From date cannot exceed the To date.' + #13#10 +
           'Please enter a date on or before ' + edtDtPckrTo.Text + '.';
  end
  else
    msg := 'The date entered is invalid, please enter a valid date to continue.' + #13#10 +
         'Valid date format is: 1-2 digit Month / 1-2 digit Day / 2-4 digit year';
  if (Not SameText(msg, '')) then
  begin
    ShowMessageCAPRI(msg);
    edtDtPckrFrom.SetFocus;
    edtDtPckrFrom.SelectAll;
  end;  { End Error Occured, display message and reset focus }

end;

procedure TcntrctdExmRptDlg.edtDtPckrToExit(Sender: TObject);
var
  msg: String;
  s : string;
  MinDate : TDate;
begin  
  msg := '';
  // validate text input in date field
  s := edtDtPckrFrom.Text;
  MinDate := StrToDate('01/01/2000');
  DateComplete(s, MinDate, FALSE);
  edtDtPckrFrom.Text := s;
  if copy(edtDtPckrFrom.Text,1,4) = 'Min ' then
  begin
    edtDtPckrFrom.Text := '';
    ShowMessageCAPRI('Please select a more current date');
    edtDtPckrFrom.SetFocus;
  end;               
  { Check for Valid Date Range}
  if IsDateValid(edtDtPckrFrom.Text) then
  begin
    if ((GetDateOfText(edtDtPckrFrom.Text, '1/1/1900'))
        > (GetDateOfText(edtDtPckrTo.Text, '1/1/2000'))) then
      msg := 'From date cannot exceed the To date.' + #13#10 +
           'Please enter a date on or before ' + edtDtPckrTo.Text + '.';
  end
  else
    msg := 'The date entered is invalid, please enter a valid date to continue.' + #13#10 +
         'Valid date format is: 1-2 digit Month / 1-2 digit Day / 2-4 digit year';
  if (Not SameText(msg, '')) then
  begin
    ShowMessageCAPRI(msg);
    edtDtPckrFrom.SetFocus;
    edtDtPckrFrom.SelectAll;
  end;  { End Error Occured, display message and reset focus }
          
end;

procedure TcntrctdExmRptDlg.edtDtWeekOfExit(Sender: TObject);
var
  msg: String;
  s : string;
  MinDate, ADate : TDate;
begin
  msg := '';
  ResetWndwTmr;
  // validate text input in date field
  s := edtDtWeekOf.Text;
  MinDate := StrToDate('01/01/1900'); 
  DateComplete(s, MinDate, FALSE);
  edtDtWeekOf.Text := s;
  if copy(edtDtWeekOf.Text,1,4) = 'Min ' then
  begin
    edtDtWeekOf.Text := '';
    ShowMessageCAPRI('Please select a more current date');
    edtDtWeekOf.SetFocus;
  end
  else
  begin
    ADate := StrToDate(edtDtWeekOf.Text); // valid date
    { Set date to beginning of week if NOT Monday }
    ADate := IncDay(ADate, (2 - DayofWeek(ADate)))  
  end;
end;

procedure TcntrctdExmRptDlg.fmCmbBxContractorChange(Sender: TObject);
begin
  ResetWndwTmr;
end;

procedure TcntrctdExmRptDlg.fmCmbBxContractorKeyPress(Sender: TObject;
  var Key: Char);
begin
  ResetWndwTmr;
  Key := #0; { Prevent Key Events, as style cannot be changed to dropdownlist }
end;

{ Functions / Procedures }

function TcntrctdExmRptDlg.ContractorsExist(): Boolean;
begin
  fmCmbBxContractor.Text := '';
  fmCmbBxContractor.Items.Clear;
  fmCmbBxContractor.GetList;
  cmbBxContractor.Items.Clear;
  cmbBxContractor.Items.AddStrings(fmCmbBxContractor.Items);  { For 508 }
  Result := (fmCmbBxContractor.Items.Count <> 0);
end;

procedure TcntrctdExmRptDlg.ResetWndwTmr;
begin
  tmrWndwClose.Enabled := False;
  tmrEnsrBrkrCnnctd.Enabled := False;
  tmrWndwClose.Enabled := True;
  tmrEnsrBrkrCnnctd.Enabled := True;
end;

procedure TcntrctdExmRptDlg.SetupForm;
var
  y, m, d: Word;
begin
  self.Caption := _strRptType + ' Report Filters';
  fmCmbBxContractor.ItemIndex := 0;  { There will be at least 1 entry in list }
  cmbBxContractor.ItemIndex := 0;
  DecodeDate(Now, y, m, d);  { Break current date down into components }
  cmbxMonths.ItemIndex := (m - 1);  { Set to current month }
  txtbxYear.Text := IntToStr(y);  { Set to current year }
//  dtPckrWeekOf.Date := Date;  { Set to current week }
  edtDtWeekOf.Text := DateToStr(Date);  { Set to current week }
//  dtPckrWeekOfChange(self);
  { Set Initial date range selection to approximately the last 30 days }
  
//  dtPckrFrom.Date := IncMonth(Date, -1);
  edtDtPckrFrom.Text := DateToStr(IncMonth(Date, -1));
//  dtPckrTo.Date := Date;
  edtDtPckrTo.Text := DateToStr(Date);
  { Configure Date Filter Selections based on report type }
  if Not SameText(UpperCase(_strRptType), 'DETAILED') then
  begin
    fmCmbBxContractor.Width := 362;
    chkbxCntrctrSort.Visible := False;
    cmbxDteFltrSlctn.Items.Add('Month');
    cmbxDteFltrSlctn.Items.Add('Year');
    if SameText(UpperCase(_strRptType), 'SUMMARY') then
      cmbxDteFltrSlctn.Items.Add('Week Of');
  end;  { End If type of report is not detailed }
  if Not SameText(UpperCase(_strRptType), 'TIMELINESS') then
    pnlPendingFltr.Visible := True
  else
    self.Height := 256;  { Shrink form as pending panel is hidden }
  cmbxDteFltrSlctnChange(self);  { Index set in object inspector to 0 }
  ResetWndwTmr;
end;

function TcntrctdExmRptDlg.GetParams(): TStringList;
var
  tmpVal: String;
  tmpDte, tmpDteNew: TDateTime;
begin
  Result := TStringList.Create;
  if chkbxByCntrctrFltr.Checked then
  begin
    Result.Add('"CONTRACTOR"=' + fmCmbBxContractor.GetSelectedRecord.IEN);
    Result.Add('HDRCONTRACTOR=' + fmCmbBxContractor.Text);
  end;  { End If Contractor Filter Checked }
  { Sort chkbx set invisible if filtering by specific contractor - irrelevant }
  if (chkbxCntrctrSort.Checked) then
    Result.Add('HDRSORT=1');
  if (chkbxByCntrctrFltr.Checked or chkbxCntrctrSort.Checked) then
    Result.Add('"SORT"=1');
    //Result.ValueFromIndex[Result.Add('"SORT"')] := '1';  { Because of how results retrieved }
  if chkbxDateFltr.Checked then
  begin
    case cmbxDteFltrSlctn.ItemIndex of
      { Date Range }
      0 : begin
//            tmpVal := DelphiDateToFMInternal(dtPckrFrom.Date) +
//                 '^' + DelphiDateToFMInternal(dtPckrTo.Date);
            tmpVal := DelphiDateToFMInternal(StrToDate(edtDtPckrFrom.Text)) +
                 '^' + DelphiDateToFMInternal(StrToDate(edtDtPckrTo.Text));
//            Result.Add('HDRDATE=From: ' +
//                 FormatDateTime('mmmm d,yyyy', dtPckrFrom.Date) +
//                 '   To: ' + FormatDateTime('mmmm d,yyyy', dtPckrTo.Date));
            Result.Add('HDRDATE=From: ' +
                 FormatDateTime('mmmm d,yyyy', StrToDate(edtDtPckrFrom.Text)) +
                 '   To: ' + 
                 FormatDateTime('mmmm d,yyyy', StrToDate(edtDtPckrTo.Text)));
          end;   
      { Current Month }
      1 : begin
            tmpDte := EncodeDate(CurrentYear, (cmbxMonths.ItemIndex + 1), 1);
            tmpDteNew := tmpDte;
            tmpDteNew := IncMonth(tmpDteNew, 1);
            tmpDteNew := IncDay(tmpDteNew, -1);  { Get Last Day of Month }
            tmpVal := DelphiDateToFMInternal(tmpDte) +
                 '^' + DelphiDateToFMInternal(tmpDteNew);
            Result.Add('HDRDATE=Month of ' + cmbxMonths.Text);
          end;
      { Year }
      2 : begin
            tmpVal := DelphiDateToFMInternal(EncodeDate(StrToInt(txtbxYear.Text), 1, 1)) + '^' +
                 DelphiDateToFMInternal(EncodeDate(StrToInt(txtbxYear.Text), 12, 31));
            Result.Add('HDRDATE=Year ' + txtbxYear.Text);
          end;
      { Week of }
      3 : begin
//            tmpDte := dtPckrWeekOf.Date;
//            tmpDte := IncDay(tmpDte, 6);
//            tmpVal := DelphiDateToFMInternal(dtPckrWeekOf.Date) + '^' +
//                 DelphiDateToFMInternal(tmpDte);
//            Result.Add('HDRDATE=Week of ' +
//                 FormatDateTime('mmmm d,yyyy', dtPckrWeekOf.Date));
          end;  { End Week Of Selection }
    end;  { End Case Selection }
    Result.Add('"DATE"=' + tmpVal);
  end;  { End If Date Filter Checked }
  if chkbxPndgExmsOnlyFltr.Checked then
  begin
    tmpVal := '';
    if chkbxNumDaysPstFltr.Checked then
    begin
      tmpVal := IntToStr(StrToIntDef(txtbxDaysRfrlExcd.Text, 0));
      Result.Add('HDRPNDGDAYS=' + tmpVal);
    end;  { End If Pending Days Past Defined }
    Result.Add('"PENDING"=1^' + tmpVal);
  end;  { End If Pending Filter Checked }
end;

// JRL 2/27/13 - Added to replace NumbersOnly property
function TcntrctdExmRptDlg.IsNumeric(sBuffer : string): Boolean;
var
  i : Integer;
begin
  Result := True;
  if sBuffer = '' then
  begin
     Result := False;
     exit;
  end;
  for i:=1 to Length(sBuffer) do 
  begin
    if (NOT (sBuffer[i] in ['0'..'9'])) and (sBuffer[i] <> '.') then 
    begin
      Result := False;
      exit;
    end; // if
  end; // for
end; // IsNumeric

// DONE: LMS move into untMiscMthds as likely the most appropriate unit
(*
function TcntrctdExmRptDlg.IsDateValid(aDateStr: string): Boolean;
var
  aDate : TDateTime;
begin
  Result := TryStrToDate(aDateStr, aDate);
  (* DONE: LMS more efficient implementation
  try
    aDate := StrToDate(aDateStr);
    Result := true;
  except on e:exception do
    Result := false;
  end;
  *)(*
end;*)

procedure TcntrctdExmRptDlg.DateComplete(var StrLikeDate: string;
  MinDate: TDate; const NowIfError: Boolean);
var
   DateStr : string;
   Year, Month, Day : Word;
   cnt, SepCount : Integer;
begin
   DateStr := StrLikeDate;
   if DateStr = '' then
      Exit;
   SepCount := 0;
   for cnt := 1 to Length(DateStr) do
   begin
     if not (DateStr[cnt] in ['0'..'9']) then
     begin
       DateStr[cnt] := DateSeparator;
       inc(SepCount);
     end;
   end;
   while (DateStr <> '') and (DateStr[Length(DateStr)]=DateSeparator) do
   begin
     Delete(DateStr, Length(DateStr),1);
     Dec(SepCount);
   end;
   DecodeDate(Now,Year,Month,Day);
   if SepCount = 0 then
   begin
     case Length(DateStr) of
       0   : DateStr := DateToStr(Now);
       1, 2: DateStr := DateStr+DateSeparator+IntToStr(Day);
//     1, 2: DateStr := DateStr+DateSeparator+IntToStr(Month);  // use this if short date format is dd/mm/yyyy
       4   : Insert(DateSeparator, DateStr, 3);
       6, 8: begin
             Insert(DateSeparator, DateStr, 5);
             Insert(DateSeparator, DateStr, 3);
             end; 
     end; // case
   end; // if SepCount
   try
     StrLikeDate := FormatDateTime('mm/dd/yyyy',StrToDate(DateStr));
   Except
     if NowIfError = TRUE then
     begin
      StrLikeDate := DateToStr(Date)
     end
     else
        StrLikeDate := '';
   end;
   // Date is valid, check for greater than minimum date
   if StrToDate(DateStr) < MinDate then
      StrLikeDate := 'Min ' + StrLikeDate;
end;
                       
function TcntrctdExmRptDlg.GetDateOfText(aDateStr, defaultDate: string): TDateTime;
begin
  try
    Result := StrToDate(aDateStr)
  except on e:exception do
    try
      Result := StrToDate(defaultDate);
    except on e2:exception do
      Result := StrToDate('1/1/1800');
    end;
  end;
end;

end.
