unit dlgVAMCInfoEdtr;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, untMiscMthds, untConstVals, MFunStr, dialogsCAPRI;

type
  TfrmVAMCEdtrDlg = class(TForm)
    Panel1: TPanel;
    tmrWndwClose: TTimer;
    btnSave: TButton;
    btnDelete: TButton;
    btnCncl: TButton;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    txtbxAreaCode: TEdit;
    Label3: TLabel;
    txtbxPrefix: TEdit;
    txtbxSuffix: TEdit;
    txtbxExtension: TEdit;
    Panel2: TPanel;
    Label1: TLabel;
    Panel3: TPanel;
    Label4: TLabel;
    Panel4: TPanel;
    Label5: TLabel;
    Panel5: TPanel;
    Label6: TLabel;
    procedure txtbxAreaCodeChange(Sender: TObject);
    procedure txtbxPrefixChange(Sender: TObject);
    procedure txtbxSuffixChange(Sender: TObject);
    procedure txtbxExtensionChange(Sender: TObject);
    procedure txtbxAreaCodeKeyPress(Sender: TObject; var Key: Char);
    procedure txtbxPrefixKeyPress(Sender: TObject; var Key: Char);
    procedure txtbxSuffixKeyPress(Sender: TObject; var Key: Char);
    procedure txtbxExtensionKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
  private
    { Private declarations }
    function EnbleSaveBtn(): Boolean;
    function GetPhoneNumber(): String;
    function IsValidChar(Key: Char): Boolean;
    procedure SetupForm;
    procedure ChckPastedText(TxtBx: TEdit);
    procedure ResetTmr;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent; TmrVal: Cardinal); reintroduce;
    destructor Destroy; override;
  end;

var
  frmVAMCEdtrDlg: TfrmVAMCEdtrDlg;

implementation

{$R *.dfm}

{ PUBLIC }

constructor TfrmVAMCEdtrDlg.Create(AOwner: TComponent; TmrVal: Cardinal);
begin
  inherited Create(AOwner);
  tmrWndwClose.Interval := TmrVal;
end;

destructor TfrmVAMCEdtrDlg.Destroy;
begin
  inherited;
end;

{ EVENTS }

procedure TfrmVAMCEdtrDlg.FormShow(Sender: TObject);
begin
  SetupForm;
end;

procedure TfrmVAMCEdtrDlg.txtbxAreaCodeChange(Sender: TObject);
begin
  ChckPastedText(txtbxAreaCode);
  if ((Length(txtbxAreaCode.Text) = 3) and (txtbxAreaCode.SelStart = 3)) then
  begin
    txtbxPrefix.SelectAll;
    txtbxPrefix.SetFocus;
  end;  { End If AreaCode Entered }
end;

procedure TfrmVAMCEdtrDlg.txtbxAreaCodeKeyPress(Sender: TObject; var Key: Char);
begin
  if Not IsValidChar(Key) then
    Key := #0;
end;

procedure TfrmVAMCEdtrDlg.txtbxPrefixChange(Sender: TObject);
begin
  ChckPastedText(txtbxPrefix);
  if ((Length(txtbxPrefix.Text) = 3) and (txtbxPrefix.SelStart = 3)) then
  begin
    txtbxSuffix.SelectAll;
    txtbxSuffix.SetFocus;
  end;  { End If Prefix Entered }
end;

procedure TfrmVAMCEdtrDlg.txtbxPrefixKeyPress(Sender: TObject; var Key: Char);
begin
  if Not IsValidChar(Key) then
    Key := #0;
end;

procedure TfrmVAMCEdtrDlg.txtbxSuffixChange(Sender: TObject);
begin
  ChckPastedText(txtbxSuffix);
  if ((Length(txtbxSuffix.Text) = 4) and (txtbxSuffix.SelStart = 4) and
       txtbxExtension.Enabled) then
  begin
    txtbxExtension.SelectAll;
    txtbxExtension.SetFocus;
  end;  { End If Suffix Entered }
end;

procedure TfrmVAMCEdtrDlg.txtbxSuffixKeyPress(Sender: TObject; var Key: Char);
begin
  if Not IsValidChar(Key) then
    Key := #0;
end;

procedure TfrmVAMCEdtrDlg.txtbxExtensionChange(Sender: TObject);
begin
  ChckPastedText(txtbxExtension);
  if True then

end;

procedure TfrmVAMCEdtrDlg.txtbxExtensionKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Not IsValidChar(Key) then
    Key := #0;
end;

procedure TfrmVAMCEdtrDlg.btnSaveClick(Sender: TObject);
begin
  { Button is ModalOK so form will close after event }
  if SetRgstryVal(VAMCREGKEY, VAMCREGKEYPHNEVAL, GetPhoneNumber) then
    ShowMessageCAPRI('Medical Center Contact Information has been successfully saved.')
  else
    MessageDlgCAPRI('Unable to save Medical Center Contact Information to system registry.',
         mtError, [mbOK], 0);
end;

procedure TfrmVAMCEdtrDlg.btnDeleteClick(Sender: TObject);
begin
  { Button is ModalOK so form will close after event }
  if DeleteRstryVal(VAMCREGKEY) then
    ShowMessageCAPRI('Medical Center Contact Information has been deleted.')
  else
    MessageDlgCAPRI('Error occurred deleting Medical Center Contact Information.', mtError, [mbOK], 0);
end;

{ PRIVATE }

procedure TfrmVAMCEdtrDlg.SetupForm;
var
  phnNum: String;
begin
  phnNum := GetRgstryVal(VAMCREGKEY, VAMCREGKEYPHNEVAL);
  if Not SameText(phnNum, '') then
  begin
    { Delete Entry from Registry if corrupted instead of displaying }
    if (Not Length(Trim(Piece(phnNum, 'x'))) = 13) then
      DeleteRstryVal(VAMCREGKEY)
    else
    begin
      { Display Phone Number Appropriately }
      txtbxExtension.Enabled := True;
      btnDelete.Enabled := True;
      txtbxAreaCode.Text := Piece(Piece(phnNum, '(', 2), ')');
      txtbxPrefix.Text := Trim(Piece(Piece(phnNum, ')', 2), '-'));
      txtbxSuffix.Text := Trim(Piece(Piece(phnNum, '-', 2), 'x'));
      txtbxExtension.Text := Piece(phnNum, 'x', 2);
    end;  { End If Valid Phone Number in Registry Exists }
  end;  { End If Phone Number Exists In Registry }
end;

procedure TfrmVAMCEdtrDlg.ChckPastedText(TxtBx: TEdit);
var
  modTxtVal: String;
begin
  { Ensure's valid pasted text content }
  modTxtVal := Trim(TxtBx.Text);  { Remove Leading and Trailing spaces }
  if (Not SameText(TxtBx.Text, modTxtVal)) then
    TxtBx.Text := modTxtVal;  { Update only if value changed }
  btnSave.Enabled := EnbleSaveBtn;
  txtbxExtension.Enabled := btnSave.Enabled;
end;

function TfrmVAMCEdtrDlg.GetPhoneNumber(): String;
begin
  Result := '(' + txtbxAreaCode.Text + ') ' + txtbxPrefix.Text + '-' +
       txtbxSuffix.Text;
  if (txtbxExtension.Enabled and Not SameText(txtbxExtension.Text, '')) then
    Result := Result + ' x' + txtbxExtension.Text;
end;

function TfrmVAMCEdtrDlg.IsValidChar(Key: Char) : Boolean;
const
  ValidChars : set of char = ['0'..'9', #8];
begin
  Result := (Key in ValidChars);  // DONE: LMS rewritten
end;

function TfrmVAMCEdtrDlg.EnbleSaveBtn(): Boolean;
var
  phneNum: String;
begin
  ResetTmr;
  Result := True;
  phneNum := txtbxAreaCode.Text + txtbxPrefix.Text + txtbxSuffix.Text;
  { Ensure Valid Phone Number if text entered }
  if (Length(phneNum) <> 10) then
    Result := False;
end;

procedure TfrmVAMCEdtrDlg.ResetTmr;
begin
  tmrWndwClose.Enabled := False;  // DONE: LMS there is no timer event handler. It's not being used.
  // tmrWndwClose.Enabled := True;
end;

end.
