unit enterptsimple;

interface

uses
  Windows,
  Messages,
  Classes,
  Controls,
  Diaccess,
  Dialogs,
  DialogsCAPRI,
  DiTypLib,
  ExtCtrls,
  Fmcmpnts,
  Fmcntrls,
  Forms,
  Graphics,
  Main,
  Mask,
  ORCtrls,
  StdCtrls,
  SysUtils,
  Trpcb,
  CCOWRPCBrokerCAPRI;

type
  TCity = class
    FName: String;
    FCntyName: String;
    FCntyIEN: String;
    FState: String;
    FStateIEN: String;
  public
    constructor Create; overload;
    constructor Create(aCountyState: String); overload;
  end;

  TfrmEnterPtSimple = class(TForm)
    Label1: TLabel;
    MaskEdit1: TMaskEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    FMListBox1: TFMListBox;
    FMLister1: TFMLister;
    FMListerPOS: TFMLister;
    FMListerEligibility: TFMLister;
    FMListerStates: TFMLister;
    FMListerCounties: TFMLister;
    FMTemp: TFMEdit;
    Panel1: TPanel;
    Label2: TLabel;
    EditHidden: TEdit;
    FMEditWhoEnteredPatient: TFMEdit;
    ComboBoxAuthorizedPatient: TORComboBox;
    FMGetsPtFile: TFMGets;
    PanelHelpAddPatient: TPanel;
    ScrollBox1: TScrollBox;
    Label20: TLabel;
    Label21: TLabel;
    StaticText1: TStaticText;
    Button7: TButton;
    Label22: TLabel;
    FMFiler1: TFMFiler;
    FMEditName: TFMEdit;
    grpRequired: TScrollBox;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label19: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Shape1: TShape;
    FirstName: TEdit;
    MiddleName: TEdit;
    LastName: TEdit;
    NameSuffix: TEdit;
    Gender: TComboBox;
    DOB: TMaskEdit;
    FMListerBranchOfService: TFMLister;
    FMListerDischargeType: TFMLister;
    Button8: TButton;
    Panel2: TPanel;
    Label9: TLabel;
    PatientType: TComboBox;
    FMPatientType: TFMEdit;
    Label10: TLabel;
    IsVeteran: TComboBox;
    Label11: TLabel;
    IsServiceConnected: TComboBox;
    Shape2: TShape;
    lblAddress: TLabel;
    FMEditStreet1: TFMEdit;
    FMEditStreet2: TFMEdit;
    FMEditStreet3: TFMEdit;
    lblCity: TLabel;
    lblZip: TLabel;
    FMEditZip: TFMEdit;
    lblPhone: TLabel;
    FMEditPhone: TFMEdit;
    lblOffice: TLabel;
    FMEditOffice: TFMEdit;
    lblAddress2: TLabel;
    lblAddress3: TLabel;
    lblCountry: TLabel;
    cboCountry: TComboBox;
    lblProvince: TLabel;
    FMEditProvince: TFMEdit;
    lblPostalCode: TLabel;
    FMEditPostalCode: TFMEdit;
    lblCounty: TLabel;
    cboCounty: TComboBox;
    lblState: TLabel;
    cboState: TComboBox;
    cboCity: TComboBox;
    FMListerCountry: TFMLister;
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FirstNameExit(Sender: TObject);
    procedure PatientTypeExit(Sender: TObject);
    procedure MaskEdit1KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBoxAuthorizedPatientExit(Sender: TObject);
    procedure IsVeteranExit(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure MaskEdit1Exit(Sender: TObject);
    procedure FMEditPhoneKeyPress(Sender: TObject; var Key: Char);
    procedure FMEditOfficeKeyPress(Sender: TObject; var Key: Char);
    procedure Button8Click(Sender: TObject);
    procedure cboCountryChange(Sender: TObject);
    procedure FMEditZipExit(Sender: TObject);
    procedure FMEditZipChange(Sender: TObject);
    procedure cboCitySelect(Sender: TObject);
    procedure cboStateSelect(Sender: TObject);
  private
    { Private declarations }
    function IsForeignCountry(aCountry: String): Boolean;
    procedure EnableForeign(isForeign: Boolean);
    procedure ClearProvincePostal;
    procedure ClearCtyCntySt;
    function PopulateCtyCntySt(aZipCode: String): Boolean;
    procedure PopulateCntySt(aCityItemIndex: Integer);
    function StripTrailingAsterisk(aString: String): String;
    function GetCountryList: Boolean;
    function GetStateList: Boolean;
    function GetCountyList(aStateIEN: String): Boolean;
    function HasSecurityKey(aKey: String): Boolean;
  public
    { Public declarations }
  end;

var
  frmEnterPtSimple: TfrmEnterPtSimple;
  tempssn: string;
  ANUTryTwice: boolean;

implementation

uses
  CAPRISupport,
  patientfilematchesform,
  patientlist,
  pseudossn,
  rofinder;

{$R *.DFM}
var
  aCity: TCity;

procedure TfrmEnterPtSimple.Button2Click(Sender: TObject);
begin
  if (PatientIEN = '+1,') or (PatientIEN = '') then
  begin
    PatientIEN := '';
    ModalResult := MrCancel;
    exit;
  end;
  if Application.MessageBox('If you exit now, you will leave a partially completed record that MAS will need to update.  You will not be able to go back and edit it.  Are you sure you want to close this window?', 'Close New Patient Entry Dialog?', 4) = 6 then
  begin
    PatientIEN := '';
    ModalResult := MrCancel;
    exit;
  end;
end;

procedure TfrmEnterPtSimple.Button3Click(Sender: TObject);
var
  FilemanDateNow   : string;
  i                : integer;
  IENS             : string;
  TempDOB          : string;
  TempServEntryDate: string;
  TempServSepDate  : string;
  TempText         : string;
begin
  if PatientIEN <> '' then
    if Pos(',', PatientIEN) = 0 then
      PatientIEN := PatientIEN + ',';

  // Validate Patient is not already in system.  If patient is in system, it means
  // an error occurred and user is editing info.  So, use the found patient.
  // This should prevent duplicate patient entry.
  if (PatientIEN = '+1,') or (PatientIEN = '') then begin
    tempSSN := EditHidden.Text;
    FMLister1.PartList.Clear;
    FMLister1.PartList.Add(tempSSN);
    FMLister1.GetList(FMListBox1.Items);
    try
    FMListBox1.GetList except
    end;
    {check for errors after the server call}
    if FMLister1.ErrorList.Count > 0 then
      FMLister1.DisplayErrors;
    if FMListBox1.Items.Count = 1 then begin
      FMListBox1.ItemIndex := 0;
      PatientIEN := FMListBox1.GetSelectedRecord.IEN;
      if Pos(',', PatientIEN) = 0 then
        PatientIEN := PatientIEN + ',';
    end
    else
      if FMlistBox1.Items.Count > 1 then begin
        ShowMessageCAPRI('Fatal Error:  There is more than one patient loaded with the selected SSN.  CAPRI cannot continue.');
        application.terminate;
      end;
  end;
  // End of validation process

  TempText := '';

  if PatientType.Text = '' then begin
    TempText := TempText + 'Please select a patient type for this record.' + char(13);
  end;
  if Length(FirstName.Text + ' ' + MiddleName.Text + ' ' + LastName.Text + ' ' + NameSuffix.Text) > 35 then begin
    TempText := TempText + 'The entire name cannot be more than 35 characters.' + char(13);
  end;
  if (FirstName.Text = '') or (LastName.Text = '') then begin
    TempText := TempText + 'You must enter a first and last name.' + char(13);
  end;
  if Gender.Text = '' then begin
    TempText := TempText + 'You must enter a gender.' + char(13);
  end;
  if DOB.Text = '  /  /    ' then begin
    TempText := TempText + 'You must enter a DOB.' + char(13);
  end;
  if IsVeteran.Text = '' then begin
    TempText := TempText + 'You must answer whether patient is a veteran.' + char(13);
  end;
  if IsServiceConnected.Text = '' then begin
    TempText := TempText + 'You must answer whether patient is service connected.' + char(13);
  end;
  if TempText <> '' then begin
    TempText := Copy(TempText, 1, Length(TempText) - 1); // Remove last carriage return
    ShowMessageCAPRI(TempText);
    exit;
  end;
  (*
  If ((MaskEdit2.Text<>'') or (MaskEdit3.Text<>'')) and (PatientType.Text='ACTIVE DUTY') then begin;
    Button5Click(Application);
    Button6Click(Application);
  end;
  *)

  TimeSinceLastBrokerCall := 0; // Prevent event

  frmMain.RPCBroker1.RemoteProcedure := 'ORWU DT';
  frmMain.RPCBroker1.Param[1].Value := 'NOW';
  frmMain.RPCBroker1.Param[1].PType := literal;
  frmMain.RPCBrokerCall;
  try
    frmMain.RPCBroker1.Call;
  except
    on EBrokerError do
      ShowMessageCAPRI('ORWU DT could not be accessed!');
  end;
  FilemanDateNow := frmMain.RPCBroker1.Results[0];
  FilemanDateNow := Piece(FileManDateNow, '.', 1);

  TempDOB := '';
  TempServEntryDate := '';
  TempServSepDate := '';
  if DOB.Text <> '  /  /    ' then
  begin
    //DOB
    FMTemp.Text := DOB.Text;
    FMTemp.FMFile := '2';
    FMTemp.FMField := '.03';
    FMTemp.IENS := PatientIEN;
    if FMTemp.Validate then
    begin
      FMFiler1.AddChgdControl(FMTemp);
      FMTemp.Text := FMTemp.FMCtrlExternal;
    end
    else
    begin
      frmMain.FMValidator1.DisplayErrors;
      FMTemp.Text := FMTemp.FMTag;
    end;
    TempDOB := frmMain.FMValidator1.Results[0];
  end;

  if (PatientIEN = '+1,') or (PatientIEN = '') then
  begin
    FMEditWhoEnteredPatient.Text := '`' + AuthorIEN; // Who entered Pt
    FMEditWhoEnteredPatient.IENS := PatientIEN;
    FMEditName.IENS := PatientIEN;
    if FMEditWhoEnteredPatient.FMModified then
      if FMEditWhoEnteredPatient.Validate then
      begin
        FMFiler1.AddChgdControl(FMEditWhoEnteredPatient);
        FMEditWhoEnteredPatient.Text := FMEditWhoEnteredPatient.FMCtrlExternal;
      end
      else
      begin
        frmMain.FMValidator1.DisplayErrors;
        FMEditWhoEnteredPatient.Text := FMEditWhoEnteredPatient.FMTag;
        exit;
      end;
  end;

  // Make sure IEN is being used.  If not, entry has already been validated
  FMPatientType.IENS := PatientIEN;
  if FMPatientType.FMModified then
    if FMPatientType.Validate then
    begin
      FMFiler1.AddChgdControl(FMPatientType);
      FMPatientType.Text := FMPatientType.FMCtrlExternal;
    end
    else
    begin
      frmMain.FMValidator1.DisplayErrors;
      FMPatientType.Text := FMPatientType.FMTag;
      exit;
    end;
  FMEditZip.IENS := PatientIEN;
  if FMEditZip.FMModified then
    if FMEditZip.Validate then
    begin
      FMFiler1.AddChgdControl(FMEditZip);
      FMEditZip.Text := FMEditZip.FMCtrlExternal;
    end
    else
    begin
      frmMain.FMValidator1.DisplayErrors;
      FMEditZip.Text := FMEditZip.FMTag;
      exit;
    end;

  FMEditName.Text := frmMain.RemoveSpaces(Uppercase(LastName.Text + ',' + FirstName.Text + ' ' + MiddleName.Text + ' ' + NameSuffix.Text));
  FMEditName.IENS := PatientIEN;
  if FMEditName.FMModified then
    if FMEditName.Validate then
    begin
      FMFiler1.AddChgdControl(FMEditName);
      FMEditName.Text := FMEditName.FMCtrlExternal;
    end
    else
    begin
      frmMain.FMValidator1.DisplayErrors;
      FMEditName.Text := FMEditName.FMTag;
      exit;
    end;

  // Insurance info
  frmMain.FMValidator1.Setup('2', PatientIEN, '.3192', 'U');
  //
  if TempDOB <> '' then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.03', TempDOB);
  //If Edit3.Text<>'' then frmMain.FMValidator1.Setup('2',PatientIEN,'.01',frmMain.RemoveSpaces(Uppercase(Edit3.Text+','+Edit1.Text+' '+Edit2.Text+' '+Edit5.Text)));
  if Gender.Text <> '' then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.02', Gender.Text[1]);
  if TempSSN <> '' then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.09', TempSSN);
  if IsVeteran.Text <> '' then
    frmMain.FMValidator1.Setup('2', PatientIEN, '1901', IsVeteran.Text[1]);
  if IsServiceConnected.Text <> '' then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.301', IsServiceConnected.Text[1]);
  if TempServEntryDate <> '' then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.326', TempServEntryDate);
  if TempServSepDate <> '' then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.327', TempServSepDate);
  if cboCountry.Text <> '' then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.1173', cboCountry.text);
  if FMEditStreet1.Text <> '' then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.111', Uppercase(FMEditStreet1.Text));
  if FMEditStreet2.Text <> '' then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.112', Uppercase(FMEditStreet2.Text));
  if FMEditStreet3.Text <> '' then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.113', Uppercase(FMEditStreet3.Text));
  if cboCity.Text <> '' then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.114', Uppercase(cboCity.Text));
  if cboCounty.Text <> '' then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.117', Uppercase(cboCounty.Text));
  if FMEditProvince.Text <> '' then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.1171', Uppercase(FMEditProvince.Text));
  if FMEditPostalCode.Text <> '' then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.1172', Uppercase(FMEditPostalCode.Text));
  if FMEditPhone.Text <> '' then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.131', FMEditPhone.Text);
  if FMEditOffice.Text <> '' then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.132', FMEditOffice.Text);
  if (PatientIEN = '+1,') or (PatientIEN = '') then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.097', FilemanDateNow);

  //If PrimaryEligibility.Text<>'' then frmMain.FMValidator1.Setup('2',PatientIEN,'.361','`'PrimaryEligibility.GetSelectedRecord.IEN);
  //If PeriodOfService.Text<>'' then frmMain.FMValidator1.Setup('2',PatientIEN,'.323',Copy(PeriodOfService.Text,1,Pos('  ',PeriodOfService.Text)-1));
  //If PeriodOfService.Text<>'' then frmMain.FMValidator1.Setup('2',PatientIEN,'.323','`'+PeriodOfService.GetSelectedRecord.IEN);
  if not frmMain.FMValidator1.Validate then
  begin
    frmMain.FMValidator1.DisplayErrors;
    Exit;
  end
  else
  begin {file}

    FMFiler1.AddFDA('2', PatientIEN, '.097', FilemanDateNow);

    //Insurance Info
    FMFiler1.AddFDA('2', PatientIEN, '.3192', 'U');
    //
    if TempDOB <> '' then
      FMFiler1.AddFDA('2', PatientIEN, '.03', TempDOB);
    if Gender.Text <> '' then
      FMFiler1.AddFDA('2', PatientIEN, '.02', Gender.Text[1]);
    if TempSSN <> '' then
      FMFiler1.AddFDA('2', PatientIEN, '.09', TempSSN);
    if IsVeteran.Text <> '' then
      FMFiler1.AddFDA('2', PatientIEN, '1901', IsVeteran.Text[1]);
    if IsServiceConnected.Text <> '' then
      FMFiler1.AddFDA('2', PatientIEN, '.301', IsServiceConnected.Text[1]);
    if TempServEntryDate <> '' then
      FMFiler1.AddFDA('2', PatientIEN, '.326', TempServEntryDate);
    if TempServSepDate <> '' then
      FMFiler1.AddFDA('2', PatientIEN, '.327', TempServSepDate);
    if cboCountry.Text <> '' then
      FMFiler1.AddFDA('2', PatientIEN, '.1173', IntToStr(Integer(cboCountry.Items.Objects[cboCountry.ItemIndex])));
    if FMEditStreet1.Text <> '' then
      FMFiler1.AddFDA('2', PatientIEN, '.111', Uppercase(FMEditStreet1.Text));
    if FMEditStreet2.Text <> '' then
      FMFiler1.AddFDA('2', PatientIEN, '.112', Uppercase(FMEditStreet2.Text));
    if FMEditStreet3.Text <> '' then
      FMFiler1.AddFDA('2', PatientIEN, '.113', Uppercase(FMEditStreet3.Text));
    if cboCity.Text <> '' then
      FMFiler1.AddFDA('2', PatientIEN, '.114', StripTrailingAsterisk(Uppercase(cboCity.Text)));

    if cboState.Text <> '' then
    begin
      frmMain.FMValidator1.Setup('2', PatientIEN, '.115', Uppercase(cboState.Text));
      if frmMain.FMValidator1.Validate then
      begin
        FMFiler1.AddFDA('2', PatientIEN, '.115', IntToStr(Integer(cboState.Items.Objects[cboState.ItemIndex])));
        if cboCounty.Text <> '' then
          FMFiler1.AddFDA('2', PatientIEN, '.117', IntToStr(Integer(cboCounty.Items.Objects[cboCounty.ItemIndex])));
      end;
    end;

    if FMEditProvince.Text <> '' then
      FMFiler1.AddFDA('2', PatientIEN, '.1171', Uppercase(FMEditProvince.Text));
    if FMEditPostalCode.Text <> '' then
      FMFiler1.AddFDA('2', PatientIEN, '.1172', Uppercase(FMEditPostalCode.Text));
    if FMEditPhone.Text <> '' then
      FMFiler1.AddFDA('2', PatientIEN, '.131', FMEditPhone.Text);
    if FMEditOffice.Text <> '' then
      FMFiler1.AddFDA('2', PatientIEN, '.132', FMEditOffice.Text);
    // Patient IEN= '+1,' at this point

    if not FMFiler1.Update then
    begin
      FMFiler1.DisplayErrors;
      exit;
    end;
    if PatientIEN = '+1,' then
    begin
      IENS := FMFiler1.FindIEN('+1,') + ',';
      PatientIEN := IENS;
    end;

    // Call MPI
    frmMain.RPCBroker1.RemoteProcedure := 'DVBAB MPI ASSIGN ICN';
    frmMain.RPCBroker1.Param[0].Value := Piece(PatientIEN, ',', 1);
    frmMain.RPCBroker1.Param[0].PType := literal;
    frmMain.RPCBrokerCall;
    try
      frmMain.RPCBroker1.Call;
    except
      on EBrokerError do
      begin
        ANURemoteProcedureCallInProgress := False;
        frmMain.AnimateLogo(False);
        frmMain.StatusBarLoadPt.Caption := 'DVBAB MPI ASSIGN ICN  could not be accessed!';
        frmMain.StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('DVBAB MPI ASSIGN ICN  could not be accessed!');
      end;
    end;

    if not FMFiler1.Update then begin
      FMFiler1.DisplayErrors;
      ShowMessageCAPRI('Primary eligibility doesn''t match other entries in this record.');
      exit;
    end;
    if TempServEntryDate <> '' then
      frmMain.FMValidator1.Setup('2', PatientIEN, '.326', TempServEntryDate);
    if TempServSepDate <> '' then
      frmMain.FMValidator1.Setup('2', PatientIEN, '.327', TempServSepDate);
    if not frmMain.FMValidator1.Validate then begin
      frmMain.FMValidator1.DisplayErrors;
      Exit;
    end
    else begin {file}
      if TempServEntryDate <> '' then
        FMFiler1.AddFDA('2', PatientIEN, '.326', TempServEntryDate);
      if TempServSepDate <> '' then
        FMFiler1.AddFDA('2', PatientIEN, '.327', TempServSepDate);
    end;
    if FMFiler1.AnythingToFile then
      FMFiler1.Update;
    if not FMFiler1.Update then begin
      FMFiler1.DisplayErrors;
      ShowMessageCAPRI('There is a problem with birthdate or service entry/exit dates as related to the period of service you have selected.  Please correct the problem and save the record again.');
      exit;
    end;

    // Send e-mail indicating new pt. has been added
    frmMain.MailManBuffer.Lines.Clear;
    frmMain.MailManBuffer.Lines.Add('The following veteran has been added to the Patient file');
    frmMain.MailManBuffer.Lines.Add('for Compensation and Pension exam purposes.');
    frmMain.MailManBuffer.Lines.Add('');
    frmMain.MailManBuffer.Lines.Add(' Name: ' + Uppercase(LastName.Text + ',' + FirstName.Text + ' ' + MiddleName.Text));
    frmMain.MailManBuffer.Lines.Add('  SSN: ' + TempSSN);
    frmMain.MailManBuffer.Lines.Add('');
    frmMain.MailManBuffer.Lines.Add('Added by: ' + frmMain.FMUserName.Caption + ' on ' + DateToStr(NOW));
    frmMain.RPCBroker1.Results.Clear;
    frmMain.RPCBroker1.RemoteProcedure := 'DVBAB SEND MSG';
    frmMain.RPCBroker1.Param[0].Value := AuthorIEN; //DUZ Of Author of Note
    frmMain.RPCBroker1.Param[0].PType := literal;
    frmMain.RPCBroker1.Param[1].Value := 'CAPRI: New C&P Veteran Added to Patient File'; //Max 45 Chars
    frmMain.RPCBroker1.Param[1].PType := literal;
    frmMain.RPCBroker1.Param[2].PType := list;
    for i := 0 to frmMain.MailManBuffer.lines.count - 1 do
      frmMain.RPCBroker1.Param[2].Mult[IntToStr(i + 1)] := frmMain.MailManBuffer.Lines[i];
    frmMain.RPCBroker1.Param[3].Value := 'DVBA C NEW C&P VETERAN'; //Mail Group Name
    frmMain.RPCBroker1.Param[3].PType := literal;
    frmMain.RPCBrokerCall;
    try
      frmMain.RPCBroker1.Call;
    except
      on EBrokerError do
        ShowMessageCAPRI('RPC DVBAB SEND MSG could not be accessed!');
    end;
    //Next line shows Mailman error message
    //If frmMain.RPCBroker1.Results[0]<>'MESSAGE SENT' then ShowMessageCAPRI(frmMain.RPCBroker1.Results[0]);
   // End of cancel e-mail;
    if MiddleName.Text <> '' then
      frmPatientList.Patient_ID.Text := Uppercase(LastName.Text + ',' + FirstName.Text + ' ' + MiddleName.Text)
    else
      frmPatientList.Patient_ID.Text := Uppercase(LastName.Text + ',' + FirstName.Text);

    ModalResult := mrOK;
  end;
end;

procedure TfrmEnterPtSimple.Button1Click(Sender: TObject);
var
  tempdob      : string;
  tempfirst    : string;
  templast     : string;
  tempmiddle   : string;
  tempname     : string;
  tempsex      : string;
  tempstrport  : string;
  tempstrserver: string;
  tempsuffix   : string;
  x            : integer;
begin
  ANUTryTwice := False;
  tempDOB := '';
  // If using restricted list
  if ListRestrictedPatients.Count > 0 then
  begin
    if tempSSN = '' then
    begin
      tempSSN := frmMain.Piece(ComboBoxAuthorizedPatient.Text, '(', 2);
      tempSSN := copy(tempssn, 1, length(tempssn) - 1);
      if length(tempssn) <> 9 then
      begin
        tempSSN := '';
        ShowMessageCAPRI('That SSN is in an invalid format');
        exit;
      end;
      if tempssn = '' then
      begin
        ShowMessageCAPRI('Please click a patient from the dropdown list.');
        exit;
      end;
      EditHidden.text := tempSSN;
      // Get DOB and Sex from home system
      if ESSOVersion = True then
      begin
        TempStrServer := frmMain.RPCBroker1.ANUStrServer;
        TempStrPort := frmMain.RPCBroker1.ANUStrPort;
        frmMain.RPCBroker1.Connected := False;
        frmMain.RPCBroker1.Server := frmMain.RPCBroker1.ANUStrServerHome;
        frmMain.RPCBroker1.ListenerPort := StrtoInt(frmMain.RPCBroker1.ANUStrPortHome);
        //frmMain.RPCBroker1.Connected := True;  BSE mod - rpm 1/8/09
        //if not frmMain.AuthorizedOption('DVBA CAPRI GUI') then begin  BSE mod - rpm 1/8/09
        if not frmMain.ConnectToServer('DVBA CAPRI GUI') then
        begin
          ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
          application.terminate;
        end;
        // Get DOB and Sex here
        for x := 0 to ListRestrictedPatients.Count - 1 do
          if TempSSN = frmMain.Piece(ListRestrictedPatients[x], '^', 3) then
            FMGetsPtFile.IENS := frmMain.Piece(ListRestrictedPatients[x], '^', 1);
        FMGetsPtFile.GetData;
        tempsex := FMGetsPtFile.GetField('.02').FMDBExternal;
        if uppercase(tempsex) = 'MALE' then
          Gender.itemindex := 0
        else
          Gender.itemindex := 1;
        Gender.enabled := False;
        DOB.EditMask := '';
        tempdob := FMGetsPtFile.GetField('.03').FMDBInternal;
        DOB.Text := FMDateTimeConvert2(tempdob);
        DOB.Enabled := False;
        //Connect back to remote system
        frmMain.RPCBroker1.Connected := False;
        frmMain.RPCBroker1.Server := TempStrServer;
        frmMain.RPCBroker1.ListenerPort := StrtoInt(TempStrPort);
        //frmMain.RPCBroker1.Connected := True;  BSE mod - rpm 1/8/09
        //if not frmMain.AuthorizedOption('DVBA CAPRI GUI') then begin  BSE mod - rpm 1/8/09
        if not frmMain.ConnectToServer('DVBA CAPRI GUI') then
        begin
          ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
          application.terminate;
        end;
      end;
      //
    end;
  end
  else
  begin
    //If not using restricted list
    if tempSSN = '' then
    begin
      if EditHidden.Text = '' then
      begin
        ShowMessageCAPRI('Please enter a valid SSN first.');
        EditHidden.SendToBack;
        exit;
      end;
      tempSSN := EditHidden.Text;
    end;
  end;
  FMLister1.PartList.Clear;
  FMLister1.PartList.Add(tempSSN);
  FMLister1.GetList(FMListBox1.Items);
  try
    FMListBox1.GetList
  except
  end;
  {check for errors after the server call}
  if FMLister1.ErrorList.Count > 0 then
    FMLister1.DisplayErrors;
  if FMListBox1.Items.Count > 0 then
  begin
    ShowMessageCAPRI('That SSN is already in use.');
    tempSSN := '';
    exit;
  end;
  Panel1.Visible := True;
  EditHidden.Visible := True;
  EditHidden.BringToFront;
  MaskEdit1.Visible := False;

  frmEnterPtSimple.Repaint;
  FirstName.Text := '';
  MiddleName.Text := '';
  LastName.Text := '';
  if TempDOB = '' then
    DOB.Text := '__/__/____';
  Gender.Text := '';
  IsVeteran.Text := '';
  IsServiceConnected.Text := '';
  //ClaimFolderLocation.Text:='';
  PatientType.Text := '';

  {process country}
  cboCountry.Text := '';
  if GetCountryList then
    cboCountry.ItemIndex := cboCountry.Items.IndexOf('UNITED STATES');
  EnableForeign(False);
  FMEditStreet1.Text := '';
  FMEditStreet2.Text := '';
  FMEditStreet3.Text := '';
  cboCity.Text := '';
  cboCounty.Text := '';
  cboState.Text := '';
  FMEditZip.Text := '';
  FMEditPhone.Text := '';
  FMEditOffice.Text := '';
  grpRequired.Visible := True;
  Panel2.Visible := False;
  try
    FirstName.SetFocus
  except
  end;
  if maskedit1.Text <> '         ' then
  try
    FirstName.Setfocus
  except
  end
  else
    EditHidden.Visible := True;
  EditHidden.BringToFront;
  MaskEdit1.Enabled := False;
  MaskEdit1.Visible := False;
  ComboBoxAuthorizedPatient.Enabled := False;
  Button1.Enabled := False;
  Button3.Enabled := True;
  button3.visible := false;
  Panel1.Visible := False;

  if ListRestrictedPatients.Count > 0 then
  begin
    FirstName.enabled := false;
    MiddleName.enabled := false;
    LastName.enabled := false;
    NameSuffix.enabled := false;
    button3.visible := true;
    tempname := ComboBoxAuthorizedPatient.Text;
    templast := frmMain.Piece(tempname, ',', 1);
    LastName.text := templast;
    tempname := frmMain.Piece(tempname, ',', 2);
    tempfirst := frmMain.Piece(tempname, ' ', 1);
    FirstName.text := tempfirst;
    tempmiddle := frmMain.Piece(tempname, ' ', 2);
    if tempmiddle[1] = '(' then
      tempmiddle := '';
    if (tempmiddle = 'JR') or (tempmiddle = 'SR') then
      NameSuffix.text := tempmiddle
    else
      MiddleName.text := tempmiddle;
    tempsuffix := frmMain.Piece(tempname, ' ', 3);
    if tempsuffix <> '' then
      if tempsuffix[1] <> '(' then
        NameSuffix.text := tempsuffix;
  end;
end;

procedure TfrmEnterPtSimple.FormCreate(Sender: TObject);
var
  xx: integer;
begin
  if ListRestrictedPatients.Count > 0 then
  begin
    ComboBoxAuthorizedPatient.Visible := True;
    Button1.Left := 360;
    Maskedit1.Visible := False;
    ComboBoxAuthorizedPatient.Visible := True;
    ComboBoxAuthorizedPatient.Items.Clear;
    for xx := 0 to ListRestrictedPatients.Count - 1 do
      ComboBoxAuthorizedPatient.Items.Add(frmMain.Piece(ListRestrictedPatients[xx], '^', 2) + ' (' + frmMain.Piece(ListRestrictedPatients[xx], '^', 3) + ')');
  end
  else
  begin
    ComboBoxAuthorizedPatient.Visible := False;
    MaskEdit1.Visible := true;
    Button1.Left := 152;
  end;
  PatientIEN := '+1,';
  Button3.Enabled := False;
  MaskEdit1.Enabled := True;
  Button1.Enabled := True;
  TempSSN := '';
end;

{==========================================================================
 GetCountryList
   rpm 9/14/09
   This function retrieves a list of countries from the COUNTRY (#779.004)
   file and populates cboCountry with Country string and IEN object.
 ==========================================================================}
function TfrmEnterPtSimple.GetCountryList: Boolean;
var
  I: Integer;
  aRecord: TFMRecordObj;
  aField: TFMFieldObj;
  aFieldVal: String;
begin
  Result := False;
  try
    FMListerCountry.GetList(nil);
    if FMListerCountry.Results.Count > 0 then
    begin
      for I := 0 to FMListerCountry.Results.Count - 1 do
      begin
        aRecord := FMListerCountry.GetRecord(FMListerCountry.Results[I]);
        //return Postal Name when not <NULL>; otherwise return uppercase description
        aField := aRecord.GetField('1.3');
        aFieldVal := aField.FMDBExternal;
        if aFieldVal = '<NULL>' then
        begin
          aField := aRecord.GetField('2');
          aFieldVal := aField.FMDBExternal;
        end;
        cboCountry.Items.AddObject(UpperCase(aFieldVal), TObject(StrToInt(FMListerCountry.Results[I])));
      end;
    end;
    Result := True;
  except on E: Exception do
    ShowMessageCapri('CAPRI failed to get Country list: ' + E.Message);
  end;
end;

{==========================================================================
 GetStateList
   rpm 9/14/09
   This function retrieves a list of states from the STATE (#5)
   file and populates cboState with State name and IEN object.
 ==========================================================================}
function TfrmEnterPtSimple.GetStateList: Boolean;
var
  I: Integer;
  aRecord: TFMRecordObj;
  aField: TFMFieldObj;
  aFieldVal: String;
begin
  cboState.Items.Clear;
  Result := False;
  try
    FMListerStates.GetList(nil);
    if FMListerStates.Results.Count > 0 then
    begin
      for I := 0 to FMListerStates.Results.Count - 1 do
      begin
        aRecord := FMListerStates.GetRecord(FMListerStates.Results[I]);
        aField := aRecord.GetField('.01');
        aFieldVal := aField.FMDBExternal;
        cboState.Items.AddObject(UpperCase(aFieldVal), TObject(StrToInt(FMListerStates.Results[I])));
      end;
    end;
    cboState.ItemIndex := 0;
    Result := True;
  except on E: Exception do
    ShowMessageCapri('CAPRI failed to get State list: ' + E.Message);
  end;
end;

{======================================================================
 HasSecurityKey
 rpm 9/14/09
 This function returns true when the user possesses the passed security
 key; otherwise returns false.
 ======================================================================}
function TfrmEnterPtSimple.HasSecurityKey(aKey: String): Boolean;
var
  I: Integer;
begin
  Result := False;
  for I := 0 to Main.UserKeys.Count - 1 do
    if Main.UserKeys[I] = aKey then
    begin
      Result := True;
      Break;  //Short-circuit if we find it
    end;
end;

{==========================================================================
 GetCountyList
   rpm 9/14/09
   This function retrieves a list of counties from the COUNTY (#5.01)
   sub-file of the STATE (#5) file and populates cboCounty with county
   name and IEN object.
 ==========================================================================}
function TfrmEnterPtSimple.GetCountyList(aStateIEN: String): Boolean;
var
  I: Integer;
  aRecord: TFMRecordObj;
  aField: TFMFieldObj;
  aFieldVal: String;
begin
  cboCounty.Items.Clear;
  Result := False;
  try
    FMListerCounties.IENS := ',' + aStateIEN + ',';
    FMListerCounties.GetList(nil);
    if FMListerCounties.Results.Count > 0 then
    begin
      for I := 0 to FMListerCounties.Results.Count - 1 do
      begin
        aRecord := FMListerCounties.GetRecord(FMListerCounties.Results[I]);
        aField := aRecord.GetField('.01');
        aFieldVal := aField.FMDBExternal;
        cboCounty.Items.AddObject(UpperCase(aFieldVal), TObject(StrToInt(FMListerCounties.Results[I])));
      end;
    end;
    cboCounty.ItemIndex := 0;
    Result := True;
  except on E: Exception do
    ShowMessageCapri('CAPRI failed to get County list: ' + E.Message);
  end;
end;

procedure TfrmEnterPtSimple.FirstNameExit(Sender: TObject);
var
  tempEdit: TEdit;
begin
  tempEdit := Sender as TEdit;
  // Remove trailing spaces
  if Uppercase(TempEdit.Text) = 'NMN' then
    TempEdit.text := '';
  Trim(TempEdit.Text);
  TempEdit.Text := Uppercase(TempEdit.Text);
end;

procedure TfrmEnterPtSimple.PatientTypeExit(Sender: TObject);
begin
  FMPatientType.Text := PatientType.Text;
  if (PatientType.Text = 'SC VETERAN') or
     (PatientType.Text = 'NSC VETERAN') or
     (PatientType.Text = 'MILITARY RETIREE') or
     (PatientType.Text = 'ALLIED VETERAN') then
  begin
    if IsVeteran.ItemIndex = 1 then
      ShowMessageCAPRI('Veteran field will be set to "YES."');
    IsVeteran.ItemIndex := 0;
  end;
  
  if (frmMain.Piece(PatientType.Text, ' ', 1) = 'NSC') and
     (IsServiceConnected.Text = 'YES') then
  begin
    ShowMessageCAPRI('A patient cannot be NSC and be service connected.');
    IsServiceConnected.ItemIndex := 1;
  end;
end;

{=======================================================================
 PopulateCntySt
   rpm 9/14/09
   Input:  ItemIndex from list of Cities
   Output: None
   This procedure populates the County and State fields for a given
   City.
 =======================================================================}
procedure TfrmEnterPtSimple.PopulateCntySt(aCityItemIndex: Integer);
var
  CountyState: TCity;
  StateIndex, CountyIndex: Integer;
begin
  CountyState := TCity(cboCity.Items.Objects[aCityItemIndex]);
  if GetStateList then
  begin
    StateIndex := cboState.Items.IndexOf(CountyState.FState);
    cboState.ItemIndex := StateIndex;
    if GetCountyList(CountyState.FStateIEN) then
    begin
      CountyIndex := cboCounty.Items.IndexOf(CountyState.FCntyName);
      cboCounty.ItemIndex := CountyIndex;
    end;
  end;
end;

{==========================================================================
 PopulateCtyCntySt
   rpm 9/14/09
   This function retrieves and populates the City, County and State fields
   for a given ZIP code.  The default City is selected when more than one
   city is returned.  The function returns True when a valid ZIP code
   returns at least one City, County, and State; otherwise returns False.
 ==========================================================================}
function TfrmEnterPtSimple.PopulateCtyCntySt(aZipCode: String): Boolean;
var
  I: Integer;
  DefaultCity: Integer;
  CityName: String;
begin
  Result := False;
  DefaultCity := -1;
  CityName := '';
  ClearCtyCntySt;
  frmMain.RPCBroker1.RemoteProcedure := 'DVBAB ZIP2CITY';
  frmMain.RPCBroker1.Param[0].PType := literal;
  frmMain.RPCBroker1.Param[0].Value := aZipCode;
  try
    frmMain.RPCBroker1.Call;
    if frmMain.RPCBroker1.Results.Count > 0 then
    begin
      if StrToInt(Piece(frmMain.RPCBroker1.Results[0],'^',1)) > 0 then
      begin
        for I := 1 to frmMain.RPCBroker1.Results.Count - 1 do
        begin
          aCity := TCity.Create(frmMain.RPCBroker1.Results[I]);
          cboCity.Items.AddObject(Piece(frmMain.RPCBroker1.Results[I],'^',1), TObject(aCity));
        end;
        for I := 0 to cboCity.Items.Count - 1 do
          if Pos('*', cboCity.Items[I]) > 0 then
            DefaultCity := I;

        if DefaultCity = -1 then
          cboCity.ItemIndex := 0
        else
          cboCity.ItemIndex := DefaultCity;
        PopulateCntySt(cboCity.ItemIndex);
        Result := True;
      end
      else
      begin
        ShowMessageCAPRI(Piece(frmMain.RPCBroker1.Results[0],'^',2));
        FMEditZip.SetFocus;
      end;
    end;
  except
    ShowMessageCAPRI('RPCBroker Error: ' + frmMain.RPCBroker1.RPCBError);
  end;
end;

{=========================================================================
 StripTrailingAsterisk
   rpm 9/14/09
   This function removes the trailing asterisk from the default city.
 =========================================================================}
function TfrmEnterPtSimple.StripTrailingAsterisk(aString: String): String;
begin
  if Pos('*', aString) = Length(aString) then
    Result := Copy(aString, 1 ,Length(aString) - 1)
  else
    Result := aString;
end;

procedure TfrmEnterPtSimple.MaskEdit1KeyPress(Sender: TObject; var Key: Char);
begin
  if (MaskEdit1.Text = '         ') and ((Key = 'p') or (Key = 'P')) then begin
    key := char(0);
    // Show PseudoSSN Creator here
    frmPseudoSSN := TfrmPseudoSSN.Create(frmEnterPtSimple);
    frmPseudoSSN.Top := frmEnterPtSimple.Top + ((frmEnterPtSimple.Height - frmPseudoSSN.Height) div 2);
    frmPseudoSSN.Left := frmEnterPtSimple.Left + ((frmEnterPtSimple.Width - frmPseudoSSN.Width) div 2);
    if frmPseudoSSN.ShowModal = mrOK then begin
      tempSSN := frmPseudoSSN.labelSSN.Caption;
      button1Click(Application);
      FirstName.Text := frmPseudoSSN.Edit1.Text;
      MiddleName.Text := frmPseudoSSN.Edit2.Text;
      LastName.Text := frmPseudoSSN.Edit3.Text;
      DOB.Text := frmPseudoSSN.MaskEditDOB.Text;
      FirstName.Color := clInactiveBorder;
      MiddleName.Color := clInactiveBorder;
      LastName.Color := clInactiveBorder;
      DOB.Color := clInactiveBorder;
      FirstName.Enabled := False;
      MiddleName.Enabled := False;
      LastName.Enabled := False;
      DOB.Enabled := False;
      EditHidden.Text := tempSSN;
      MaskEdit1.Text := '         ';
      MaskEdit1.Visible := False;
    end;
    frmPseudoSSN.Release;
    frmPseudoSSN := nil;
  end;
end;

{==================================================================
 ClearCtyCntySt
 rpm 9/14/09
 This procedure clears the City, County, and State fields.
 ==================================================================}
procedure TfrmEnterPtSimple.ClearCtyCntySt;
var
  I: Integer;
  City: TCity;
begin
  //free any City objects
  if cboCity.Items.Count > 0 then
    for I := 0 to cboCity.Items.Count - 1 do
      if cboCity.Items.Objects[I] <> nil then
      begin
        City := TCity(cboCity.Items.Objects[I]);
        FreeAndNil(City);
      end;

  cboCity.Text := '';
  cboCity.Items.Clear;
  cboCountry.Text := '';
  cboCounty.Items.Clear;
  cboState.Text := '';
  cboState.Items.Clear;
end;

{==================================================================
 ClearProvincePostal
 rpm 9/14/09
 This procedure clears the Province and Postal Code fields.
 ==================================================================}
procedure TfrmEnterPtSimple.ClearProvincePostal;
begin
  FMEditProvince.Text := '';
  FMEditPostalCode.Text := '';
end;

procedure TfrmEnterPtSimple.ComboBoxAuthorizedPatientExit(Sender: TObject);
var
  x: integer;
begin
  if ComboBoxAuthorizedPatient.Text = '' then
    exit;
  for x := 0 to ComboBoxAuthorizedPatient.Items.Count - 1 do
    if uppercase(ComboBoxAuthorizedPatient.Text) = uppercase(ComboBoxAuthorizedPatient.Items[x]) then begin
      ComboBoxAuthorizedPatient.ItemIndex := x;
    end;
  if ComboBoxAuthorizedPatient.ItemIndex = -1 then begin
    ShowMessageCAPRI('Please click a patient from the dropdown list.');
    ComboBoxAuthorizedPatient.Text := '';
    try
    ComboBoxAuthorizedPatient.Setfocus except
    end;
    ComboBoxAuthorizedPatient.Enabled := True;
    exit;
  end;
end;

{==================================================================
 EnableForeign
   rpm 9/14/09
   This procedure configures the address fields for foreign vs.
   non-foreign address and controls editing of non-foreign address
   fields based on 'EAS GMT COUNTY EDIT' security key.
 ==================================================================}
procedure TfrmEnterPtSimple.EnableForeign(isForeign: Boolean);
begin
    if isForeign then
      cboCity.Style := csSimple
    else
    begin
      if HasSecurityKey('EAS GMT COUNTY EDIT') then
      begin
        cboCity.Style := csDropDown;
        cboState.Enabled := True;
        cboCounty.Enabled := True;
      end
      else
      begin
        cboCity.Style := csDropDownList;
        cboState.Enabled := False;
        cboCounty.Enabled := False;
      end;
    end;

    lblProvince.Visible := isForeign;
    FMEditProvince.Enabled := isForeign;
    FMEditProvince.Visible := isForeign;

    lblPostalCode.Visible := isForeign;
    FMEditPostalCode.Enabled := isForeign;
    FMEditPostalCode.Visible := isForeign;

    ClearProvincePostal;

    lblZip.Visible := not isForeign;
    FMEditZip.Enabled := not isForeign;
    FMEditZip.Visible := not isForeign;

    lblState.Visible := not isForeign;
    cboState.Visible := not isForeign;

    lblCounty.Visible := not isForeign;
    cboCounty.Visible := not isForeign;

    FMEditZip.Text := '';
    ClearCtyCntySt;
end;

{=======================================================================
 IsForeignCountry
   rpm 9/14/09
   This function returns True when a foreign country is selected;
   otherwise returns False.
 =======================================================================}
function TfrmEnterPtSimple.IsForeignCountry(aCountry: String): Boolean;
begin
  if (UpperCase(aCountry) = 'UNITED STATES') then
    Result := False
  else
    Result := True;
end;

procedure TfrmEnterPtSimple.IsVeteranExit(Sender: TObject);
begin
  if (PatientType.Text = 'SC VETERAN') or (PatientType.Text = 'NSC VETERAN') or
    (PatientType.Text = 'MILITARY RETIREE') or (PatientType.Text = 'ALLIED VETERAN') then begin
    IsVeteran.ItemIndex := 0;
  end;
  if (PatientType.Text = 'ACTIVE DUTY') then
    IsVeteran.ItemIndex := 1;
end;

procedure TfrmEnterPtSimple.Button7Click(Sender: TObject);
begin
  PanelHelpAddPatient.Visible := False;
end;

procedure TfrmEnterPtSimple.MaskEdit1Exit(Sender: TObject);
begin
  //ShowMessageCAPRI(Maskedit1.Text);
  if MaskEdit1.Text <> '         ' then
    EditHidden.Text := MaskEdit1.Text;
  if EditHidden.Text <> '' then
    Maskedit1.text := '_________';
end;

procedure TfrmEnterPtSimple.FMEditPhoneKeyPress(Sender: TObject; var Key: Char);
begin
  if (Key <> '-') and
    (Key <> '1') and
    (Key <> '2') and
    (Key <> '3') and
    (Key <> '4') and
    (Key <> '5') and
    (Key <> '6') and
    (Key <> '7') and
    (Key <> '8') and
    (Key <> '9') and
    (Key <> '0') and
    (Key <> char(8)) then
    Key := char(0);
end;

procedure TfrmEnterPtSimple.FMEditZipChange(Sender: TObject);
begin
  //use Tag to indicate that value has changed; used and
  //reset by FMEditZipExit
  FMEditZip.Tag := Ord(True);
end;

procedure TfrmEnterPtSimple.FMEditZipExit(Sender: TObject);
begin
  //only run if value changed
  if (FMEditZip.Tag = Ord(True)) then
  begin
    ClearCtyCntySt;

    //validate ZIP - populate City, County, State when valid
    FMEditZip.IENS := '+1,';
    if FMEditZip.Validate then
    begin
      FMEditZip.Text := FMEditZip.FMCtrlExternal;
      if (FMEditZip.Text <> '') then
        PopulateCtyCntySt(FMEditZip.Text);
    end
    else
    begin
      ShowMessageCAPRI('Answer with either 5 digit or 9 digit zip code.');
      FMEditZip.SetFocus;
    end;

    //reset 'value changed' flag
    FMEditZip.Tag := Ord(False);
  end;
end;

procedure TfrmEnterPtSimple.cboCountryChange(Sender: TObject);
begin
  if IsForeignCountry(cboCountry.Text) then
    EnableForeign(True)
  else
    EnableForeign(False);

  FMEditStreet1.Text := '';
  FMEditStreet2.Text := '';
  FMEditStreet3.Text := '';
end;

procedure TfrmEnterPtSimple.cboStateSelect(Sender: TObject);
begin
  GetCountyList(IntToStr(Integer(cboState.Items.Objects[cboState.ItemIndex])));
end;

procedure TfrmEnterPtSimple.cboCitySelect(Sender: TObject);
begin
  if (not IsForeignCountry(cboCountry.Text)) then
    PopulateCntySt(cboCity.ItemIndex);
end;

procedure TfrmEnterPtSimple.FMEditOfficeKeyPress(Sender: TObject; var Key: Char);
begin
  if (Key <> '-') and
    (Key <> '1') and
    (Key <> '2') and
    (Key <> '3') and
    (Key <> '4') and
    (Key <> '5') and
    (Key <> '6') and
    (Key <> '7') and
    (Key <> '8') and
    (Key <> '9') and
    (Key <> '0') and
    (Key <> char(8)) then
    Key := char(0);
end;

procedure TfrmEnterPtSimple.Button8Click(Sender: TObject);
var
  nam: string;
  temptext, s: string;
  x, I, J: integer;
begin
  temptext := '';
  if (FirstName.text = '') or (LastName.text = '') then begin
    temptext := temptext + 'You must enter at least a first and last name.' + char(13);
  end;
  if DOB.Text = '  /  /    ' then begin
    temptext := temptext + 'You must enter a birthdate.' + char(13);
  end
  else  //validate DOB entry
  begin
    frmMain.FMValidator1.SetUp('2', '+1,', '.09', '000000000');
    frmMain.FMValidator1.SetUp('2', '+1,', '.03', DOB.Text);
    if NOT frmMain.FMValidator1.Validate then
    begin
      if frmMain.FMValidator1.ErrorList.Count > 0 then
      begin
        for I := 0 to frmMain.FMValidator1.ErrorList.Count - 1 do
          for J := 0 to TFMErrorObj(frmMain.FMValidator1.ErrorList[I]).ErrorText.Count -1 do
            temptext := temptext + TFMErrorObj(frmMain.FMValidator1.ErrorList[I]).ErrorText[J];
      end;
    end;
  end;

  if Gender.text = '' then begin
    temptext := temptext + 'You must enter a gender.' + char(13);
  end;

  if temptext <> '' then begin
    ShowmessageCAPRI(temptext);
    exit;
  end;

  nam := LastName.text + ',' + FirstName.text;

  frmMain.RPCBroker1.RemoteProcedure := 'DVBAB FIND DUPS';
  frmMain.RPCBroker1.Param[1].Value := nam;
  frmMain.RPCBroker1.Param[1].PType := literal;
  if DOB.Text <> '  /  /    ' then begin
    frmMain.RPCBroker1.Param[2].Value := FMToDateConvert(DOB.Text); // Convert to Fileman
    frmMain.RPCBroker1.Param[2].PType := literal;
  end;
  frmMain.RPCBroker1.Param[3].Value := tempSSN;
  frmMain.RPCBroker1.Param[3].PType := literal;

  frmMain.RPCBrokerCall;
  try
    frmMain.RPCBroker1.Call;
  except
    on EBrokerError do begin
      ShowMessageCAPRI('DVBAB FIND DUPS could not be accessed!');
      application.terminate;
      application.terminate;
    end;
  end;
  // got results
  if frmMain.RPCBroker1.Results.Count > 0 then begin
    if frmMain.piece(frmMain.RPCBroker1.Results[0], '^', 1) = '-1' then begin
      ShowmessageCAPRI(frmmain.piece(frmMain.RPCBroker1.Results[0], '^', 2));
      exit;
    end
    else begin
      // found matches
      formPatientFileMatches := tformPatientFileMatches.create(frmEnterPtSimple);
      formPatientFileMatches.ORListBoxPatientInfo.Clear;
      tempText := '';
      if strtoint(frmMain.RPCBroker1.Results[0]) > 0 then begin
        for x := 1 to strtoint(frmMain.RPCBroker1.Results[0]) do begin
          s := Copy(frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 2) + '                              ', 1, 30);
          tempText := s + '  '; // Name
          s := frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 3);
          if s = 'M' then
            s := 'MALE'
          else
            if s = 'F' then
              s := 'FEMALE'
            else
              s := 'UNKNOWN';
          s := Copy(s + '       ', 1, 7);
          temptext := temptext + s + '  '; // Gender
          // *SENSITIVE* means record is sensitive
          s := FMDateTimeConvert2(frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 4));
          temptext := temptext + s + '  ' + // DOB
          frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 10); // SSN
          formPatientFileMatches.ORListBoxPatientInfo.Items.Add(temptext);
        end;
        if formPatientFileMatches.ShowModal = mrCancel then begin
          formPatientFileMatches.Release;
          formPatientFileMatches := nil;
          button2Click(Application);
          exit;
        end;
      end;
      formPatientFileMatches.Release;
      formPatientFileMatches := nil;
    end;
  end
  else begin
    ShowmessageCAPRI('No data was returned.');
    exit;
  end;
  // Put continue entry stuff here
  panel2.Visible := True;
  FirstName.enabled := false;
  MiddleName.enabled := false;
  LastName.enabled := false;
  NameSuffix.enabled := false;
  Gender.enabled := false;
  DOB.enabled := false;
  button8.enabled := false;
  button3.visible := true;
  PatientType.Setfocus;
end;

{ TCity }

constructor TCity.Create(aCountyState: String);
begin
  Create;
  FName:= frmMain.Piece(aCountyState,'^',1);
  FCntyName:= frmMain.Piece(aCountyState,'^',2);
  FCntyIEN:= frmMain.Piece(aCountyState,'^',3);
  FState:= frmMain.Piece(aCountyState,'^',4);
  FStateIEN:= frmMain.Piece(aCountyState,'^',5);
end;

constructor TCity.Create;
begin
  Inherited;
end;

end.
