unit examrequest;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  DialogsCAPRI,
  Dialogs,
  StdCtrls,
  ORCtrls,
  ExtCtrls,
  Buttons,
  ComCtrls,
  Tabnotbk;

type
  TfrmExamRequestTemplate = class(TForm)
    Label1: TLabel;
    BitBtn3: TBitBtn;
    TabbedNotebook1: TTabbedNotebook;
    Label13: TLabel;
    CheckBox2: TCheckBox;
    MemoClaim: TMemo;
    CheckBox1: TCheckBox;
    ORListBox1: TORListBox;
    ButtonDeleteEval: TButton;
    ButtonAddEval: TButton;
    PanelAddEval: TPanel;
    OROffsetLabel1: TOROffsetLabel;
    OROffsetLabel3: TOROffsetLabel;
    Edit1: TEdit;
    Edit3: TEdit;
    Button3: TButton;
    Button4: TButton;
    CheckBox4: TCheckBox;
    Memo2: TMemo;
    ButtonSendCFile: TButton;
    BitBtn1: TBitBtn;
    Panel1: TPanel;
    CheckBox6: TCheckBox;
    Label25: TLabel;
    EditPOA: TEdit;
    MemoMedicalOpinion: TMemo;
    GroupBox1: TGroupBox;
    Label7: TLabel;
    Edit2: TEdit;
    Label9: TLabel;
    Edit4: TEdit;
    Memo1: TMemo;
    Memo3: TMemo;
    Memo4: TMemo;
    Memo5: TMemo;
    Memo6: TMemo;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Memo7: TMemo;
    GroupBox2: TGroupBox;
    MemoAddress: TMemo;
    procedure BitBtn3Click(Sender: TObject);
    procedure ButtonAddEvalClick(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ORListBox1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ButtonDeleteEvalClick(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure EditOpinion1KeyPress(Sender: TObject; var Key: Char);
    procedure FormActivate(Sender: TObject);
    procedure ButtonSendCFileClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure MemoEnter(Sender: TObject); // -MER 508 compliance.  No CodeCR.  Issue #12 in "CAPRI GUI 508 Issues.docx"
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmExamRequestTemplate: TfrmExamRequestTemplate;

implementation

uses newexam,
  main;

{$R *.DFM}

procedure TfrmExamRequestTemplate.BitBtn3Click(Sender: TObject);
var
  x: integer;
begin
  if (Checkbox6.Checked = True) and (EditPOA.Text = '') then begin
    ShowMessageCAPRI('Please enter a Power of Attorney or uncheck the POA checkbox.');
    exit;
  end;
  if MemoClaim.Visible = True then
    if MemoClaim.Lines.Count = 0 then begin
      ShowMessageCAPRI('Please finish entering the reason vet claims service connection on the SC/INCREASED EVAL tab.');
      exit;
    end;
  if ORListBox1.Visible = true then
    if ORListBox1.Items.Count = 0 then begin
      ShowMessageCAPRI('Please enter at least one reason for claim of increased disability evaluation on the SC/INCREASED EVAL tab.');
      exit;
    end;
  if PanelAddEval.Visible = true then begin
    ShowMessageCAPRI('You cannot exit until you finish adding the eval on the SC/INCREASED EVAL tab.');
    exit;
  end;
  if memo2.Visible = true then
    if Memo2.Lines.Count = 0 then begin
      ShowMessageCAPRI('Please Finish entering the reason the vet claims entitlement to pension benefits on the PENSION tab.');
      exit;
    end;

  // Screen 2
  if Checkbox6.Checked = True then begin
    frmNewExam.FMCommentsMemo.Lines.Add(Checkbox6.Caption);
    if EditPOA.Text <> '' then
      frmNewExam.FMCommentsMemo.Lines.Add('Please send a courtesy copy of the exam notice letter to ' + EditPOA.Text + '.');
    frmNewExam.FMCommentsMemo.Lines.Add('');
  end;

  if (Checkbox2.Checked = True) or (CheckBox1.Checked = True) then begin
    if checkbox2.checked then begin
      frmNewExam.FMCommentsMemo.Lines.Add(Checkbox2.Caption);
      if memoclaim.lines.count > 0 then
        for x := 0 to memoclaim.lines.count - 1 do
          frmNewExam.FMCommentsMemo.Lines.Add(' ' + memoclaim.lines[x]);
      frmNewExam.FMCommentsMemo.Lines.Add('');
    end;
    if checkbox1.checked then begin
      frmNewExam.FMCommentsMemo.Lines.Add(Checkbox1.Caption);
      if ORListBox1.Items.count > 0 then
        for x := 0 to ORListBox1.Items.count - 1 do
          frmNewExam.FMCommentsMemo.Lines.Add(' ' + ORListBox1.Items[x]);
      frmNewExam.FMCommentsMemo.Lines.Add('');
    end;
  end;

  // Screen 3
  if checkbox4.checked then begin
    frmNewExam.FMCommentsMemo.Lines.Add(Checkbox4.Caption);
    if Memo2.Lines.count > 0 then
      for x := 0 to Memo2.Lines.count - 1 do
        frmNewExam.FMCommentsMemo.Lines.Add(' ' + Memo2.Lines[x]);
    frmNewExam.FMCommentsMemo.Lines.Add('');
  end;

  //Screen 4  Medical Opinion
  if MemoMedicalOpinion.Lines.Count > 0 then begin
    frmNewExam.FMCommentsMemo.Lines.Add('MEDICAL OPINION:');
    for x := 0 to MemoMedicalOpinion.Lines.Count - 1 do
      frmNewExam.FMCommentsMemo.Lines.Add(MemoMedicalOpinion.Lines[x]);
    frmNewExam.FMCommentsMemo.Lines.Add('');
  end;

  //Screen 5
  if (edit2.Text <> '') or (memoAddress.Lines.Count > 0) or (edit4.text <> '') then begin
    frmNewExam.FMCommentsMemo.Lines.Add(Groupbox1.Caption);
    if Edit2.Text <> '' then
      frmNewExam.FMCommentsMemo.Lines.Add('NAME: ' + Edit2.Text);
    if MemoAddress.Lines.count > 0 then begin
      frmNewExam.FMCommentsMemo.Lines.Add('ADDRESS:');
      for x := 0 to MemoAddress.Lines.count - 1 do
        frmNewExam.FMCommentsMemo.Lines.Add(' ' + MemoAddress.Lines[x]);
    end;
    if Edit4.Text <> '' then
      frmNewExam.FMCommentsMemo.Lines.Add('PHONE: ' + Edit4.Text);
  end;

  frmMain.MemoNameAddressHolder.Lines.Clear;
  frmMain.MemoNameAddressHolder.Lines.Add(edit2.text);
  frmMain.MemoNameAddressHolder.Lines.Add(edit4.text);
  if MemoAddress.Lines.Count > 0 then
    for x := 0 to memoAddress.lines.count - 1 do
      frmMain.MemoNameAddressHolder.Lines.Add(memoAddress.Lines[x]);

  modalresult := mrOK;
end;

procedure TfrmExamRequestTemplate.ButtonAddEvalClick(Sender: TObject);
begin
  BitBtn3.enabled := False;
  ButtonAddEval.Enabled := False;
  PanelAddEval.Visible := True;
  Edit1.SetFocus; // -MER CodeCR115 Item #7
end;

{==============================================================================
  MemoEnter
    MemoEnter is a method that will cause the cursor to be set to the start
      of any TMemo that calls it.  At the time of creation, it was applied to
      the OnEnter handler of all TMemos on the "info" tab

  Modification History:
    CodeCR115 Item #6 - 8/2010 Method created  -MER
 ==============================================================================}
procedure TfrmExamRequestTemplate.MemoEnter(Sender: TObject);
begin
  if Sender is TMemo then begin
    with Sender as TMemo do begin
      selStart := 0;
    end;
  end;
end;

procedure TfrmExamRequestTemplate.Button4Click(Sender: TObject);
begin
  BitBtn3.Enabled := True;
  Edit1.Text := '';
  Edit3.Text := '';
  PanelAddEval.Visible := False;
  ButtonAddEval.Visible := True;
  ButtonAddEval.Enabled := True;
end;

procedure TfrmExamRequestTemplate.ORListBox1Click(Sender: TObject);
begin
  if ORListBox1.ItemIndex > -1 then
    buttonDeleteEval.Enabled := True;
end;

procedure TfrmExamRequestTemplate.Button3Click(Sender: TObject);
begin
  BitBtn3.Enabled := True;
  ORListBox1.Items.Add(edit1.text + ':  Currently evaluated as ' + edit3.text + '% disabling.');
  Edit1.Text := '';
  Edit3.Text := '';
  PanelAddEval.Visible := False;
  ButtonAddEval.Enabled := True;
  ButtonAddEval.Setfocus;
end;

procedure TfrmExamRequestTemplate.ButtonDeleteEvalClick(Sender: TObject);
begin
  ORListBox1.Items.Delete(ORListBox1.ItemIndex);
  ButtonDeleteEval.Enabled := False;
end;

procedure TfrmExamRequestTemplate.CheckBox2Click(Sender: TObject);
begin
  if Checkbox2.Checked = true then begin
    MemoClaim.Visible := True;
    Edit5.Visible := True;
    //    MemoClaim.SetFocus;
  end
  else begin
    MemoClaim.Lines.Clear;
    MemoClaim.Visible := False;
    Edit5.Visible := False;
  end;
end;

procedure TfrmExamRequestTemplate.CheckBox1Click(Sender: TObject);
begin
  if Checkbox1.Checked = true then begin
    ORListBox1.Visible := True;
    ButtonDeleteEval.Visible := True;
    ButtonAddEval.Visible := True;
    //    ButtonAddEval.Setfocus;
  end
  else begin
    ORListBox1.Visible := False;
    ButtonDeleteEval.Visible := False;
    ButtonAddEval.Visible := False;
    ButtonDeleteEval.Enabled := True;
    ButtonAddEval.Enabled := True;
    ButtonDeleteEval.Enabled := True;
    ButtonAddEval.Enabled := True;
    PanelAddEval.Visible := False;
    Edit1.Text := '';
    edit3.Text := '';
    ORListBox1.Items.Clear;
  end;
end;

procedure TfrmExamRequestTemplate.CheckBox4Click(Sender: TObject);
begin
  if Checkbox4.Checked = true then begin
    Memo2.Visible := True;
    Edit6.Visible := True;
    // Memo2.SetFocus;
  end
  else begin
    Memo2.Visible := False;
    Edit6.Visible := False;
    Memo2.Lines.Clear;
  end;
end;

procedure TfrmExamRequestTemplate.EditOpinion1KeyPress(Sender: TObject;
  var Key: Char);
begin
  if Key = '^' then
    key := '~';
end;

procedure TfrmExamRequestTemplate.FormActivate(Sender: TObject);
var
  x: integer;
  //allowchange: boolean;
begin
  if frmMain.MemoNameAddressHolder.Lines.Count > 0 then begin
    edit2.Text := frmMain.MemoNameAddressHolder.Lines[0];
  end;
  if frmMain.MemoNameAddressHolder.Lines.Count > 1 then begin
    edit4.Text := frmMain.MemoNameAddressHolder.Lines[1];
  end;
  memoAddress.lines.clear;
  if frmMain.MemoNameAddressHolder.Lines.Count > 2 then
    for x := 2 to frmMain.MemoNameAddressHolder.Lines.Count - 1 do
      memoAddress.Lines.add(frmMain.MemoNameAddressHolder.Lines[x]);
  //allowchange := true;
  //TabbedNotebook1Change(self,0,allowchange);
end;

procedure TfrmExamRequestTemplate.ButtonSendCFileClick(Sender: TObject);
begin
  frmNewExam.FMClaimFolderRequired.Text := 'YES';
  frmNewExam.FMClaimFolderRequiredExit(Application);
  ButtonSendCFile.Visible := False;
end;

procedure TfrmExamRequestTemplate.FormCreate(Sender: TObject);
begin
  if frmNewExam.FMClaimFolderRequired.Text <> 'YES' then
    ButtonSendCFile.Visible := True
  else
    ButtonSendCFile.Visible := False;
end;

procedure TfrmExamRequestTemplate.BitBtn1Click(Sender: TObject);
begin
  modalresult := mrCancel;
end;

procedure TfrmExamRequestTemplate.CheckBox6Click(Sender: TObject);
begin
  if Checkbox6.Checked = true then begin
    Label25.Visible := True;
    EditPOA.Visible := True;
    //    EditPOA.SetFocus;
  end
  else begin
    Label25.Visible := False;
    EditPOA.Visible := False;
    EditPOA.Text := '';
  end;
end;

end.
