unit examtaborder;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  Buttons,
  ORCtrls,
  CAPRISupport,
  DialogsCAPRI;

type
  TFormExamTabOrder = class(TForm)
    ORListBoxItems: TORListBox;
    btnMoveUp: TBitBtn;
    btnmovedown: TBitBtn;
    Button1: TButton;
    Button2: TButton;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure btnMoveUpClick(Sender: TObject);
    procedure btnmovedownClick(Sender: TObject);
    procedure ORListBoxItemsClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormExamTabOrder: TFormExamTabOrder;

implementation

{$R *.DFM}

procedure TFormExamTabOrder.Button2Click(Sender: TObject);
begin
  ModalResult := mrOK;
end;

procedure TFormExamTabOrder.Button1Click(Sender: TObject);
begin
  modalresult := mrCancel;
end;

procedure TFormExamTabOrder.btnMoveUpClick(Sender: TObject);
var
  oldspot, newspot: integer;
  tempstring: string;
begin
  oldspot := ORListBoxItems.ItemIndex;
  NewSpot := OldSpot - 1;
  TempString := ORListBoxItems.Items[OldSpot];
  // Don't allow user to choose/move medical opinion
  if (Piece(TempString, '^', 2) = 'MEDICAL OPINION') then begin
    ShowmessageCAPRI('Medical Opinion can''t be moved.');
    exit;
  end;
  ORListBoxItems.Items.Delete(OldSpot);
  ORListBoxItems.Items.Insert(NewSpot, TempString);
  ORListBoxItems.ItemIndex := NewSpot;
  ORListBoxItemsClick(Application);
end;

procedure TFormExamTabOrder.btnmovedownClick(Sender: TObject);
var
  oldspot, newspot: integer;
  tempstring: string;
begin
  oldspot := ORListBoxItems.ItemIndex;
  NewSpot := OldSpot + 1;
  TempString := ORListBoxItems.Items[OldSpot];
  // Don't let user do something that would force medical opinion to move
  if (Piece(ORListBoxItems.Items[NewSpot], '^', 2) = 'MEDICAL OPINION') then begin
    ShowmessageCAPRI('Medical Opinion can''t be moved.');
    exit;
  end;
  ORListBoxItems.Items.Delete(OldSpot);
  if NewSpot < ORListBoxItems.Items.Count then
    ORListBoxItems.Items.Insert(NewSpot, TempString)
  else
    ORListBoxItems.Items.Add(TempString);
  ORListBoxItems.ItemIndex := NewSpot;
  ORListBoxItemsClick(Application);
end;

procedure TFormExamTabOrder.ORListBoxItemsClick(Sender: TObject);
begin
  if ORListBoxItems.ItemIndex > 0 then
    btnMoveUp.Enabled := True
  else
    btnMoveUp.Enabled := False;
  if ORListBoxItems.ItemIndex < ORListBoxItems.Items.Count - 1 then
    btnMoveDown.Enabled := True
  else
    btnMoveDown.Enabled := False;
end;

end.
