unit fEpisodeOfCare;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Diaccess, Fmcmpnts, StdCtrls, Fmcntrls, Reports;

type
  TfrmEpisodeOfCare = class(TForm)
    FMlstAdmitDateTimes: TFMListBox;
    lblSelectAdmissionDateTime: TLabel;
    btnOK: TButton;
    btnCancel: TButton;
    FMListAdmitDtTm: TFMLister;
    procedure btnCancelClick(Sender: TObject);
    procedure FMlstAdmitDateTimesDblClick(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    FEpisodeOfCareIFN: String;
    procedure GetEpisodeOfCareIFN;
  public
    { Public declarations }
    property EpisodeOfCareIFN: String read FEpisodeOfCareIFN;  //read only
  end;

var
  frmEpisodeOfCare: TfrmEpisodeOfCare;

implementation

{$R *.dfm}
uses
  DialogsCAPRI,
  Main;


procedure TfrmEpisodeOfCare.btnCancelClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TfrmEpisodeOfCare.btnOKClick(Sender: TObject);
begin
  if (FMlstAdmitDateTimes.ItemIndex > -1) then
    GetEpisodeOfCareIFN
  else
    ShowMessageCAPRI('Please select an Admission Date/Time');
end;

procedure TfrmEpisodeOfCare.FMlstAdmitDateTimesDblClick(Sender: TObject);
begin
  GetEpisodeOfCareIFN;
end;

procedure TfrmEpisodeOfCare.FormShow(Sender: TObject);
begin
  FEpisodeOfCareIFN := '';
  FMListAdmitDtTm.GetList(FMlstAdmitDateTimes.Items);
  if (FMlstAdmitDateTimes.Items.Count = 0) then
    FMlstAdmitDateTimes.Items.Add('No Admissions Found');
end;

procedure TfrmEpisodeOfCare.GetEpisodeOfCareIFN;
begin
  if (FMlstAdmitDateTimes.Items[FMlstAdmitDateTimes.ItemIndex] <> 'No Admissions Found') then
  begin
    FEpisodeOfCareIFN := FMlstAdmitDateTimes.GetSelectedRecord.IEN;
    ModalResult := mrOK;
  end
  else
  begin
    FEpisodeOfCareIFN := '';
    ModalResult := mrCancel;
  end;
end;

end.
