unit fReportsAdhocComponent1;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  DialogsCAPRI,
  Dialogs,
  ExtCtrls,
  StdCtrls,
  Grids,
  ORCtrls,
  ORfn,
  Buttons,
  fAutoSz, VA508AccessibilityManager, AccessibilityUtils, VAUtils;

type
  TfrmReportsAdhocComponent1 = class(TfrmAutoSz)
    Splitter1: TSplitter;
    Panel2: TPanel;
    Panel3: TPanel;
    btnCancelMain: TButton;
    btnOKMain: TButton;
    Panel1: TPanel;
    ORListBox2: TORListBox;
    Panel6: TPanel;
    btnRemoveComponent: TButton;
    btnRemoveAllComponents: TButton;
    Splitter4: TSplitter;
    Panel7: TPanel;
    lblHeaderName: TLabel;
    edtHeaderName: TEdit;
    lblOccuranceLimit: TLabel;
    edtOccuranceLimit: TEdit;
    lblTimeLimit: TLabel;
    cboTimeLimit: TComboBox;
    gpbDisplay: TGroupBox;
    ckbHospitalLocation: TCheckBox;
    ckbProviderNarrative: TCheckBox;
    cboICD: TComboBox;
    lblICD: TLabel;
    btnAddComponent: TButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    Timer1: TTimer;
    ORListBox1: TORListBox;
    lblItems: TLabel;
    btnEditSubitems: TButton;
    GroupBox1: TGroupBox;
    rbtnHeader: TRadioButton;
    rbtnAbbrev: TRadioButton;
    rbtnName: TRadioButton;
    CCOWTimer: TTimer;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    pComponents: TPanel;
    ORComboBox1: TORComboBox;
    Label1: TLabel;
    st508HeaderName: TVA508StaticText;
    st508TimeLimit: TVA508StaticText;
    st508SubItems: TVA508StaticText;
    st508DisplayLocation: TVA508StaticText;
    st508DisplayProvider: TVA508StaticText;
    st508ICDText: TVA508StaticText;
    st508OccuranceLimit: TVA508StaticText;
    procedure FormCreate(Sender: TObject);
    procedure btnCancelMainClick(Sender: TObject);
    procedure btnOKMainClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HideEdits;
    procedure ORListBox2Click(Sender: TObject);
    procedure btnRemoveComponentClick(Sender: TObject);
    procedure btnRemoveAllComponentsClick(Sender: TObject);
    procedure Splitter4CanResize(Sender: TObject; var NewSize: Integer;
      var Accept: Boolean);
    procedure Splitter1CanResize(Sender: TObject; var NewSize: Integer;
      var Accept: Boolean);
    procedure btnAddComponentClick(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure ORListBox2DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure ORListBox2DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ORListBox2EndDrag(Sender, Target: TObject; X, Y: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure btnEditSubitemsClick(Sender: TObject);
    procedure edtHeaderNameExit(Sender: TObject);
    procedure edtOccuranceLimitExit(Sender: TObject);
    procedure cboTimeLimitExit(Sender: TObject);
    procedure ckbHospitalLocationExit(Sender: TObject);
    procedure ckbProviderNarrativeExit(Sender: TObject);
    procedure cboICDExit(Sender: TObject);
    procedure ORComboBox1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure LoadComponents(Dest: TStrings);
    procedure FormShow(Sender: TObject);
    procedure rbtnAbbrevClick(Sender: TObject);
    procedure rbtnNameClick(Sender: TObject);
    procedure rbtnHeaderClick(Sender: TObject);
    procedure CCOWTimerTimer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Init508Components;
    procedure Update508Components;
  private
    { Private declarations }
    GoingUp: Boolean;
    OKPressed: Boolean;
    ScreenReaderItemsActive: Boolean;
  public
    { Public declarations }
  end;

var
  frmReportsAdhocComponent1: TfrmReportsAdhocComponent1;
  uComponents: TStringList; {This is what is built as SubItems are
  selected.  It is identified by segment
  and is ordered in the order that the items
  have been selected or moved by the user.
  Segment^file #^ifn of file^zero node of file}
  uCurrentComponent: Integer; //Pointer to current Component ID
  HSCompCtr: integer; //Component ID
  uFile: string; //Mumps file Number of Subitems
  uLimit: Integer; //HS Component Subitem Selection limit
  uLimitCount: Integer; //Count of current Subitem Selections

function ExecuteAdhoc1: Boolean;

implementation

uses fReportsAdhocSubItem1,
  main;

{$R *.DFM}
type
  PHSCompRec = ^THSCompRec;
  THSCompRec = object
    ID: integer;
    Segment: string;
      Name: string;
    OccuranceLimit: string;
    TimeLimit: string;
    Header: string;
    HospitalLocation: string;
    ICDText: string;
    ProviderNarrative: string;

  end;

function ExecuteAdhoc1: Boolean;
begin
  Result := False;
  frmReportsAdhocComponent1 := TfrmReportsAdhocComponent1.Create(Application);
  try
    ResizeFormToFont(TForm(frmReportsAdhocComponent1));
    frmReportsAdhocComponent1.ShowModal;
    if frmReportsAdhocComponent1.OKPressed then
      Result := True;
  finally
    frmReportsAdhocComponent1.Release;
    frmReportsAdhocComponent1 := nil;
  end;
end;

procedure TfrmReportsAdhocComponent1.FormCreate(Sender: TObject);

begin
  Init508Components; // -MER CodeCR121 8/2010
  HideEdits;
  HSCompCtr := 0;
  uFile := '';
  uLimit := 0;
  uLimitCount := 1;
  uComponents := TStringList.Create;
end;

procedure TfrmReportsAdhocComponent1.FormShow(Sender: TObject);
begin
  inherited;
  if uListState = 1 then
    rbtnAbbrev.Checked := true;
  if uListState = 0 then
    rbtnName.Checked := true;
  if uListState = 2 then
    rbtnHeader.Checked := true;
  LoadComponents(ORComboBox1.Items);
end;

procedure TfrmReportsAdhocComponent1.btnCancelMainClick(Sender: TObject);
begin
  modalresult := mrcancel;
end;

procedure TfrmReportsAdhocComponent1.btnOKMainClick(Sender: TObject);
var
  i, j: integer;
begin
  OKPressed := True;
  with ORListBox2 do begin
    if Items.Count > 0 then begin
      for i := 0 to Items.Count - 1 do begin
        uHSComponents.Add(PHSCompRec(Items.Objects[i])^.Segment + '^' +
          PHSCompRec(Items.Objects[i])^.OccuranceLimit + '^' +
          PHSCompRec(Items.Objects[i])^.TimeLimit + '^' +
          PHSCompRec(Items.Objects[i])^.Header + '^' +
          PHSCompRec(Items.Objects[i])^.HospitalLocation + '^' +
          PHSCompRec(Items.Objects[i])^.ICDText + '^' +
          PHSCompRec(Items.Objects[i])^.ProviderNarrative);
        for j := 0 to uComponents.Count - 1 do
          if StrToInt(piece(uComponents[j], '^', 1)) =
            PHSCompRec(Items.Objects[i])^.ID then
            uHSComponents.Add(PHSCompRec(Items.Objects[i])^.Segment + '^' +
              PHSCompRec(Items.Objects[i])^.OccuranceLimit + '^' +
              PHSCompRec(Items.Objects[i])^.TimeLimit + '^' +
              PHSCompRec(Items.Objects[i])^.Header + '^' +
              PHSCompRec(Items.Objects[i])^.HospitalLocation + '^' +
              PHSCompRec(Items.Objects[i])^.ICDText + '^' +
              PHSCompRec(Items.Objects[i])^.ProviderNarrative + '^' +
              uComponents[j]);
      end;
    end;
  end;
  if uHSComponents.Count > 0 then begin
    frmMain.HSReportText(uLocalReportData, uHSComponents);
    modalresult := mrOK;
  end
  else
    Application.MessageBox(
      'Sorry, no Components have been selected',
      'Selection Error', MB_OK + MB_DEFBUTTON1);
end;

procedure TfrmReportsAdhocComponent1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  aParam: integer;
begin
  aParam := 1;
  if rbtnName.Checked = true then
    aParam := 0
  else
    if rbtnAbbrev.Checked = true then
      aParam := 1
    else
      if rbtnHeader.Checked = true then
        aParam := 2;
  frmMain.SetAdhocLookup(aParam);
  uComponents.Free;
end;

procedure TfrmReportsAdhocComponent1.HideEdits;
begin
  lblTimeLimit.Enabled := False;
  lblOccuranceLimit.Enabled := False;
  cboTimeLimit.Enabled := False;
  edtOccuranceLimit.Enabled := False;
  gpbDisplay.Enabled := False;
  ckbHospitalLocation.Enabled := False;
  ckbProviderNarrative.Enabled := False;
  lblICD.Enabled := False;
  cboICD.Enabled := False;
  lblItems.Enabled := False;
  ORListBox1.Enabled := False;
  btnEditSubitems.Enabled := False;
  cboTimeLimit.Text := '';
  edtOccuranceLimit.Text := '';
  ckbHospitalLocation.Checked := False;
  ckbProviderNarrative.Checked := False;
  cboICD.Text := '';
  if (ScreenReaderItemsActive) then begin // -MER CodeCR121 8/2010
    st508HeaderName.Visible := TRUE; // -MER CodeCR121 8/2010
    st508OccuranceLimit.Visible := TRUE; // -MER CodeCR121 8/2010
    st508TimeLimit.Visible := TRUE; // -MER CodeCR121 8/2010
    st508DisplayLocation.Visible := TRUE; // -MER CodeCR121 8/2010
    st508DisplayProvider.Visible := TRUE; // -MER CodeCR121 8/2010
    st508ICDText.Visible := TRUE; // -MER CodeCR121 8/2010
    st508SubItems.Visible := TRUE; // -MER CodeCR121 8/2010
  end;
end;

procedure TfrmReportsAdhocComponent1.ORListBox2Click(Sender: TObject);
var
  i: integer;
  a: string;
  uHSCompFiles: TStringList;
begin
  HideEdits;
  with ORListBox2 do
    a := PHSCompRec(Items.Objects[ItemIndex])^.Segment;
  uHSCompFiles := TStringList.Create;
  frmMain.HSComponentFiles(uHSCompFiles, Piece(a, ';', 2));
  if uHSCompFiles.Count > 0 then begin
    uFile := Piece(uHSCompFiles.Strings[0], '^', 3);
    if Length(uFile) > 0 then begin
      lblItems.Enabled := True;
      ORListBox1.Enabled := True;
      btnEditSubItems.Enabled := True;
    end;
  end;
  uHSCompFiles.Free;
  with ORListBox2 do begin
    if length(Piece(Items[ItemIndex], '^', 5)) > 0 then begin
      edtHeaderName.Text := PHSCompRec(Items.Objects[ItemIndex])^.Header;
      edtHeaderName.Enabled := True;
      lblHeaderName.Enabled := True;
    end;
    if length(Piece(Items[ItemIndex], '^', 3)) > 0 then begin
      edtOccuranceLimit.Text :=
        PHSCompRec(Items.Objects[ItemIndex])^.OccuranceLimit;
      edtOccuranceLimit.Enabled := True;
      lblOccuranceLimit.Enabled := True;
    end;
    if length(Piece(Items[ItemIndex], '^', 4)) > 0 then begin
      cboTimeLimit.Text :=
        PHSCompRec(Items.Objects[ItemIndex])^.TimeLimit;
      cboTimeLimit.Enabled := True;
      lblTimeLimit.Enabled := True;
    end;
    if length(Piece(Items[ItemIndex], '^', 6)) > 0 then begin
      gpbDisplay.Enabled := True;
      ckbHospitalLocation.Enabled := True;
      if PHSCompRec(Items.Objects[ItemIndex])^.HospitalLocation = 'Y'
        then
        ckbHospitalLocation.Checked := True
      else
        ckbHospitalLocation.Checked := False;
    end;
    if length(Piece(Items[ItemIndex], '^', 7)) > 0 then begin
      gpbDisplay.Enabled := True;
      lblICD.Enabled := True;
      cboICD.Enabled := True;
      cboICD.Text := PHSCompRec(Items.Objects[ItemIndex])^.ICDText;
    end;
    if length(Piece(Items[ItemIndex], '^', 8)) > 0 then begin
      gpbDisplay.Enabled := True;
      ckbProviderNarrative.Enabled := True;
      if PHSCompRec(Items.Objects[ItemIndex])^.ProviderNarrative = 'Y'
        then
        ckbProviderNarrative.Checked := True
      else
        ckbProviderNarrative.Checked := False;
    end;
    uCurrentComponent := PHSCompRec(Items.Objects[ItemIndex])^.ID;
  end;
  ORListBox1.Clear;
  for i := 0 to uComponents.Count - 1 do
    if piece(uComponents[i], '^', 1) = IntToStr(uCurrentComponent) then
      ORListBox1.Items.Add(Pieces(uComponents[i], '^', 3, 10));
  if ORListBox1.Items.Count > 0 then begin
    lblItems.Enabled := True;
    ORListBox1.Enabled := True;
    btnEditSubItems.Enabled := True;
  end;
  Update508Components; // -MER CodeCR121 9/2010
end;

procedure TfrmReportsAdhocComponent1.btnRemoveComponentClick(Sender: TObject);
var
  i: integer;
  chk: integer;
begin
  HideEdits;
  edtHeaderName.Text := '';
  edtHeaderName.Enabled := False;
  lblHeaderName.Enabled := False;
  chk := 0;
  ORListBox1.Clear;
  if ORListBox2.Items.Count < 1 then begin
    MessageDlgCAPRI('There are no items to remove.', mtInformation,
      [mbOk], 0);
    Exit;
  end
  else
    for i := 0 to ORListBox2.Items.Count - 1 do
      if ORListBox2.Selected[i] then
        chk := 1;
  if chk = 0 then begin
    MessageDlgCAPRI('Please select the item you wish to remove',
      mtInformation, [mbOK], 0);
    Exit;
  end;
  with ORListBox2 do begin
    for i := uComponents.Count - 1 downto 0 do
      if piece(uComponents[i], '^', 1) = IntToStr(uCurrentComponent) then
        uComponents.Delete(i);
    Items.Delete(ItemIndex);
    if Items.Count < 1 then begin
      SpeedButton5.Enabled := false;
      SpeedButton6.Enabled := false;
    end;
  end;
  Update508Components; // -MER CodeCR121 9/2010
end;

procedure TfrmReportsAdhocComponent1.btnRemoveAllComponentsClick(Sender: TObject);

var
  i: integer;
begin
  HideEdits;
  edtHeaderName.Text := '';
  edtHeaderName.Enabled := False;
  lblHeaderName.Enabled := False;
  ORListBox1.Clear;
  if ORListBox2.Items.Count < 1 then begin
    MessageDlgCAPRI('There are no items to remove.', mtInformation,
      [mbOk], 0);
    Exit;
  end;
  if MessageDlgCAPRI('This button will remove all selected components. OK?',
    mtInformation, [mbYes, mbNo], 0) = mrYes then begin
    with ORListBox2 do begin
      for i := uComponents.Count - 1 downto 0 do
        uComponents.Delete(i);
      for i := Items.Count - 1 downto 0 do
        Items.Delete(i);
    end;
    SpeedButton5.Enabled := false;
    SpeedButton6.Enabled := false;
  end;
  Update508Components; // -MER CodeCR121 9/2010
end;

procedure TfrmReportsAdhocComponent1.Splitter4CanResize(Sender: TObject; var NewSize: Integer;
  var Accept: Boolean);
begin
  if NewSize < 50 then
    NewSize := 50;
end;

procedure TfrmReportsAdhocComponent1.Splitter1CanResize(Sender: TObject; var NewSize: Integer;
  var Accept: Boolean);
begin
  if NewSize < 50 then
    NewSize := 50;
end;

procedure TfrmReportsAdhocComponent1.btnAddComponentClick(Sender: TObject);
var
  HSCompPtr: PHSCompRec;
  i: Integer;
  uHSCompFiles: TStringList;
  uCompSubs: TStringList;
begin
  if ORComboBox1.ItemIndex < 0 then begin
    MessageDlgCAPRI('Please select a component to Add.', mtInformation,
      [mbOk], 0);
    Exit;
  end;
  ORListBox1.Clear;
  HideEdits;
  New(HSCompPtr);
  HSCompCtr := HSCompCtr + 1;
  HSCompPtr^.ID := HSCompCtr;
  uLimit := 0;
  with ORComboBox1 do begin
    HSCompPtr^.Segment := Piece(Items[ItemIndex], '^', 1);
    HSCompPtr^.Name := Piece(Items[ItemIndex], '^', 2);
    HSCompPtr^.OccuranceLimit := Piece(Items[ItemIndex], '^', 3);
    HSCompPtr^.TimeLimit := UpperCase(Piece(Items[ItemIndex], '^', 4));
    HSCompPtr^.Header := Piece(Items[ItemIndex], '^', 5);
    HSCompPtr^.HospitalLocation := Piece(Items[ItemIndex], '^', 6);
    HSCompPtr^.ICDText := Piece(Items[ItemIndex], '^', 7);
    HSCompPtr^.ProviderNarrative := Piece(Items[ItemIndex], '^', 8);
    uCurrentComponent := HSCompCtr;
  end;
  with ORListBox2 do begin
    Items.AddObject(
      ORComboBox1.Items[ORComboBox1.ItemIndex], TObject(HSCompPtr));
    ItemIndex := Items.Count - 1;
    SpeedButton5.Enabled := true;
    SpeedButton6.Enabled := true;
  end;
  uHSCompFiles := TStringList.Create;
  uCompSubs := TStringList.Create;
  frmMain.HSComponentFiles(uHSCompFiles, Piece(HSCompPtr^.Segment, ';', 2));
  if uHSCompFiles.Count > 0 then begin
    uFile := Piece(uHSCompFiles.Strings[0], '^', 3);
    if Length(Piece(uHSCompFiles.Strings[0], '^', 4)) > 0 then
      uLimit := StrToInt(Piece(uHSCompFiles.Strings[0], '^', 4));
    if Length(uFile) > 0 then begin
      lblItems.Enabled := True;
      ORListBox1.Enabled := True;
      btnEditSubItems.Enabled := True;
      frmMain.HSComponentSubs(uCompSubs, Piece(HSCompPtr^.Segment, ';', 1));
      if uCompSubs.Count > 0 then begin
        ORListBox1.Clear;
        ORListBox1.Items.Assign(uCompSubs);
        for i := 0 to uCompSubs.Count - 1 do
          uComponents.Add(IntToStr(uCurrentComponent) + '^' + uFile +
            '^' + uCompSubs[i]);
      end
      else
        if ExecuteForm2 = True then begin
          ORListBox1.Clear;
          for i := 0 to uComponents.Count - 1 do
            if piece(uComponents[i], '^', 1) = IntToStr(uCurrentComponent) then
              ORListBox1.Items.Add(Pieces(uComponents[i], '^', 3, 10));
          if ORListBox1.Items.Count < 1 then begin
            MessageDlgCAPRI('No sub-items were selected', mtInformation,
              [mbOk], 0);
          end;
        end
        else begin
          MessageDlgCAPRI('No sub-items were selected', mtInformation,
            [mbOk], 0);
        end;
    end;
  end;
  with ORComboBox1 do begin
    if length(Piece(Items[ItemIndex], '^', 5)) > 0 then begin
      edtHeaderName.Text := Piece(Items[ItemIndex], '^', 5);
      edtHeaderName.Enabled := True;
      lblHeaderName.Enabled := True;
    end;
    if length(Piece(Items[ItemIndex], '^', 3)) > 0 then begin
      edtOccuranceLimit.Text := Piece(Items[ItemIndex], '^', 3);
      edtOccuranceLimit.Enabled := True;
      lblOccuranceLimit.Enabled := True;
    end;
    if length(Piece(Items[ItemIndex], '^', 4)) > 0 then begin
      cboTimeLimit.Text := Piece(Items[ItemIndex], '^', 4);
      cboTimeLimit.Enabled := True;
      lblTimeLimit.Enabled := True;
    end;
    if length(Piece(Items[ItemIndex], '^', 6)) > 0 then begin
      gpbDisplay.Enabled := True;
      ckbHospitalLocation.Enabled := True;
      if Piece(Items[ItemIndex], '^', 6) = 'Y' then
        ckbHospitalLocation.Checked := True;
    end;
    if length(Piece(Items[ItemIndex], '^', 7)) > 0 then begin
      gpbDisplay.Enabled := True;
      lblICD.Enabled := True;
      cboICD.Enabled := True;
      if Piece(Items[ItemIndex], '^', 7) = 'L' then
        cboICD.Text := 'Long text';
      if Piece(Items[ItemIndex], '^', 7) = 'S' then
        cboICD.Text := 'Short text';
      if Piece(Items[ItemIndex], '^', 7) = 'C' then
        cboICD.Text := 'Code only';
      if Piece(Items[ItemIndex], '^', 7) = 'T' then
        cboICD.Text := 'Text only';
      if Piece(Items[ItemIndex], '^', 7) = 'N' then
        cboICD.Text := 'None';
    end;
    if length(Piece(Items[ItemIndex], '^', 8)) > 0 then begin
      gpbDisplay.Enabled := True;
      ckbProviderNarrative.Enabled := True;
      if Piece(Items[ItemIndex], '^', 8) = 'Y' then
        ckbProviderNarrative.Checked := True;
    end;
  end;
  uHSCompFiles.Free;
  uCompSubs.Free;
  Update508Components; // -MER CodeCR121 9/2010
end;

procedure TfrmReportsAdhocComponent1.SpeedButton5Click(Sender: TObject);
var
  i: integer;
begin
  with ORListBox2 do
    if ItemIndex > 0 then begin
      i := ItemIndex;
      Items.Move(i, i - 1);
      ItemIndex := i - 1;
    end;
end;

procedure TfrmReportsAdhocComponent1.SpeedButton6Click(Sender: TObject);
var
  i: Integer;
begin
  with ORListbox2 do
    if (ItemIndex < Items.Count - 1) and
      (ItemIndex <> -1) then begin
      i := ItemIndex;
      Items.Move(i, i + 1);
      ItemIndex := i + 1;
    end;
end;

procedure TfrmReportsAdhocComponent1.ORListBox2DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Accept := (Sender = Source) and
    (TORListBox(Sender).ItemAtPos(Point(x, y), False) >= 0);
  if Accept then
    with Sender as TORListbox do
      if Y > Height - ItemHeight then begin
        GoingUp := False;
        Timer1.Enabled := True;
      end
      else
        if Y < ItemHeight then begin
          GoingUp := True;
          Timer1.Enabled := True;
        end
        else
          Timer1.Enabled := False;
end;

procedure TfrmReportsAdhocComponent1.ORListBox2DragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
  NuPos: Integer;
begin
  with Sender as TORListbox do begin
    NuPos := ItemAtPos(Point(X, Y), False);
    if NuPos >= Items.Count then
      Dec(NuPos);
    Items.Move(ItemIndex, NuPos);
    ItemIndex := NuPos;
  end;
end;

procedure TfrmReportsAdhocComponent1.ORListBox2EndDrag(Sender, Target: TObject; X, Y: Integer);
begin
  if (Sender = ORListBox2) and (Target = ORComboBox1) then
    btnRemoveComponentClick(nil);
  Timer1.Enabled := False;
end;

procedure TfrmReportsAdhocComponent1.Timer1Timer(Sender: TObject);
begin
  with ORListBox2 do
    if GoingUp then
      if TopIndex > 0 then
        TopIndex := TopIndex - 1
      else
        Timer1.Enabled := False
    else
      if TopIndex < Items.Count - 1 then
        TopIndex := TopIndex + 1
      else
        Timer1.Enabled := False;
end;

procedure TfrmReportsAdhocComponent1.btnEditSubitemsClick(Sender: TObject);
var
  i: integer;
begin
  if ExecuteForm2 = True then begin
    lblItems.Enabled := False;
    ORListBox1.Enabled := False;
    ORListBox1.Clear;
    for i := 0 to uComponents.Count - 1 do
      if piece(uComponents[i], '^', 1) = IntToStr(uCurrentComponent) then
        ORListBox1.Items.Add(Pieces(uComponents[i], '^', 3, 10));
    if ORListBox1.Items.Count > 0 then begin
      lblItems.Enabled := True;
      ORListBox1.Enabled := True;
      btnEditSubItems.Enabled := True;
    end;
  end;
end;

procedure TfrmReportsAdhocComponent1.edtHeaderNameExit(Sender: TObject);
var
  i: integer;
begin
  for i := 0 to ORListBox2.Items.Count - 1 do
    if PHSCompRec(ORListBox2.Items.Objects[i])^.ID = uCurrentComponent then
      PHSCompRec(ORListBox2.Items.Objects[i])^.Header :=
        edtHeaderName.Text;
end;

procedure TfrmReportsAdhocComponent1.edtOccuranceLimitExit(
  Sender: TObject);
var
  i: integer;
begin
  for i := 0 to ORListBox2.Items.Count - 1 do
    if PHSCompRec(ORListBox2.Items.Objects[i])^.ID = uCurrentComponent then
      PHSCompRec(ORListBox2.Items.Objects[i])^.OccuranceLimit :=
        edtOccuranceLimit.Text;
end;

procedure TfrmReportsAdhocComponent1.cboTimeLimitExit(Sender: TObject);
var
  i: integer;
begin
  if cboTimeLimit.Text = 'No Limit' then
    cboTimeLimit.Text := '99Y';
  for i := 0 to ORListBox2.Items.Count - 1 do
    if PHSCompRec(ORListBox2.Items.Objects[i])^.ID = uCurrentComponent then
      PHSCompRec(ORListBox2.Items.Objects[i])^.TimeLimit :=
        cboTimeLimit.Text;
end;

procedure TfrmReportsAdhocComponent1.ckbHospitalLocationExit(
  Sender: TObject);
var
  i: integer;
begin
  for i := 0 to ORListBox2.Items.Count - 1 do
    if PHSCompRec(ORListBox2.Items.Objects[i])^.ID = uCurrentComponent then
      if ckbHospitalLocation.Checked = True then
        PHSCompRec(ORListBox2.Items.Objects[i])^.HospitalLocation := 'Y'
      else
        PHSCompRec(ORListBox2.Items.Objects[i])^.HospitalLocation := 'N';
end;

procedure TfrmReportsAdhocComponent1.ckbProviderNarrativeExit(
  Sender: TObject);
var
  i: integer;
begin
  for i := 0 to ORListBox2.Items.Count - 1 do
    if PHSCompRec(ORListBox2.Items.Objects[i])^.ID = uCurrentComponent then
      if ckbProviderNarrative.Checked = True then
        PHSCompRec(ORListBox2.Items.Objects[i])^.ProviderNarrative := 'Y'
      else
        PHSCompRec(ORListBox2.Items.Objects[i])^.ProviderNarrative := 'N';
end;

procedure TfrmReportsAdhocComponent1.cboICDExit(Sender: TObject);
var
  i: integer;
begin
  for i := 0 to ORListBox2.Items.Count - 1 do
    if PHSCompRec(ORListBox2.Items.Objects[i])^.ID = uCurrentComponent then
      PHSCompRec(ORListBox2.Items.Objects[i])^.ICDText := cboICD.Text;
end;

procedure TfrmReportsAdhocComponent1.ORComboBox1KeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if Key = 13 then
    with ORComboBox1 do
      if (Text <> '') and (Items.IndexOf(Text) >= 0) then begin
        ItemIndex := Items.IndexOf(Text);
        btnAddComponentClick(nil);
      end;
end;

procedure TfrmReportsAdhocComponent1.LoadComponents(Dest: TStrings);
var
  sComponents: TStringList;
  i: integer;
  s: string;
begin
  sComponents := TStringList.Create;
  if uListState = 0 then begin
    frmMain.HSComponents(sComponents);
    for i := 0 to sComponents.Count - 1 do begin
      s := sComponents.Strings[i];
      s := MixedCase(piece(s, '[', 1)) + '[' + piece(s, '[', 2);
      sComponents.Strings[i] := s;
    end;
  end
  else
    if uListState = 1 then begin
      frmMain.HSABVComponents(sComponents);
      for i := 0 to sComponents.Count - 1 do begin
        s := sComponents.Strings[i];
        s := piece(s, '-', 1) + '-' + MixedCase(piece(s, '-', 2));
        sComponents.Strings[i] := s;
      end;
    end
    else
      if uListState = 2 then begin
        frmMain.HSDispComponents(sComponents);
        for i := 0 to sComponents.Count - 1 do begin
          s := sComponents.Strings[i];
          s := MixedCase(piece(s, '[', 1)) + '[' + piece(s, '[', 2);
          sComponents.Strings[i] := s;
        end;
      end;
  QuickCopy(sComponents, Dest);
  sComponents.Free;
end;

procedure TfrmReportsAdhocComponent1.rbtnAbbrevClick(Sender: TObject);
begin
  inherited;
  uListState := 1;
  ORComboBox1.Clear;
  LoadComponents(ORComboBox1.Items);
  ORComboBox1.SetFocus;
end;

procedure TfrmReportsAdhocComponent1.rbtnNameClick(Sender: TObject);
begin
  inherited;
  uListState := 0;
  ORComboBox1.Clear;
  LoadComponents(ORComboBox1.Items);
  ORComboBox1.SetFocus;
end;

procedure TfrmReportsAdhocComponent1.rbtnHeaderClick(Sender: TObject);
begin
  inherited;
  uListState := 2;
  ORComboBox1.Clear;
  LoadComponents(ORComboBox1.Items);
  ORComboBox1.SetFocus;
end;

procedure TfrmReportsAdhocComponent1.CCOWTimerTimer(Sender: TObject);
begin
  inherited;
  if ShutdownCAPRIModalDialogs = true then begin
    CCOWTimer.Enabled := False;
    frmReportsAdhocComponent1.visible := False;
    ContextorChangeMessage := '';
    ModalResult := mrCancel;
  end;
end;

procedure TfrmReportsAdhocComponent1.FormActivate(Sender: TObject);
begin
  inherited;
  CCOWTimer.Enabled := True;
end;

{==============================================================================
  Init508Components
    Init508Components is a method that will initialize the 508 compliance
      components on this form

  Modification History:
    CodeCR121 - 8/2010 Method created -MER
 ==============================================================================}
procedure TfrmReportsAdhocComponent1.Init508Components;
begin
  if VAUtils.ScreenReaderActive then begin
    // we use a string constant for the caption in case the desired text changes
    st508HeaderName.Caption := st508HeaderName.Caption + ST_DISABLED;
    st508OccuranceLimit.Caption := st508OccuranceLimit.Caption + ST_DISABLED;
    st508TimeLimit.Caption := st508TimeLimit.Caption + ST_DISABLED;
    st508DisplayLocation.Caption := st508DisplayLocation.Caption + ST_DISABLED;
    st508DisplayProvider.Caption := st508DisplayProvider.Caption + ST_DISABLED;
    st508ICDText.Caption := st508ICDText.Caption + ST_DISABLED;
    st508SubItems.Caption := st508SubItems.Caption + ST_DISABLED;
    ScreenReaderItemsActive := TRUE;
  end else begin
    st508HeaderName.Visible := FALSE;
    st508OccuranceLimit.Visible := FALSE;
    st508TimeLimit.Visible := FALSE;
    st508DisplayLocation.Visible := FALSE;
    st508DisplayProvider.Visible := FALSE;
    st508ICDText.Visible := FALSE;
    st508SubItems.Visible := FALSE;
    ScreenReaderItemsActive := FALSE;
  end;
end;

{==============================================================================
  Update508Components
    Update508Components is a method that will update the visibility of the 508
      compliance components on this form.  This visibility is based on the
      state of the companion UI components

  Modification History:
    CodeCR121 - 9/2010 Method created -MER
 ==============================================================================}
procedure TfrmReportsAdhocComponent1.Update508Components;
begin
  if ScreenReaderItemsActive then begin
    if (edtHeaderName.Enabled) then
      st508HeaderName.Visible := FALSE;
    if (edtOccuranceLimit.Enabled) then
      st508OccuranceLimit.Visible := FALSE;
    if (cboTimeLimit.Enabled) then
      st508TimeLimit.Visible := FALSE;
    if (ckbHospitalLocation.Enabled) then
      st508DisplayLocation.Visible := FALSE;
    if (ckbProviderNarrative.Enabled) then
      st508DisplayProvider.Visible := FALSE;
    if (cboICD.Enabled) then
      st508ICDText.Visible := FALSE;
    if (ORListBox1.Enabled) then
      st508SubItems.Visible := FALSE;
  end;
end;

end.
