unit fReportsAdhocSubItem1;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  DialogsCAPRI,
  Dialogs,
  StdCtrls,
  ExtCtrls,
  ORCtrls,
  Buttons,
  ORfn,
  fAutoSz,
  TRPCB,
  CCOWRPCBrokerCAPRI;

type
  TfrmReportsAdhocSubItem1 = class(TfrmAutoSz)
    GroupBox1: TGroupBox;
    Splitter3: TSplitter;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    ORComboBox2: TORComboBox;
    ORListBox1: TORListBox;
    Panel4: TPanel;
    Label4: TLabel;
    Label5: TLabel;
    Panel5: TPanel;
    btnCancel: TButton;
    Panel8: TPanel;
    btnAddSel: TButton;
    btnRemoveSel: TButton;
    btnRemoveAllSel: TButton;
    btnOK: TButton;
    Timer2: TTimer;
    Label6: TLabel;
    lblLimit: TLabel;
    CCOWTimer: TTimer;
    procedure btnCancelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ORListBox1EndDrag(Sender, Target: TObject; X, Y: Integer);
    procedure ORListBox1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ORListBox1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure Timer2Timer(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure btnRemoveAllSelClick(Sender: TObject);
    procedure btnRemoveSelClick(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure btnAddSelClick(Sender: TObject);
    procedure ORComboBox2KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ORComboBox2NeedData(Sender: TObject; const StartFrom: string;
      Direction, InsertAt: Integer);
    procedure CCOWTimerTimer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
    GoingUp: Boolean;
    OKPressed: Boolean;
  public
    { Public declarations }
  end;

var
  frmReportsAdhocSubItem1: TfrmReportsAdhocSubItem1;

function ExecuteForm2: Boolean;

implementation

uses fReportsAdhocComponent1,
  main;

{$R *.DFM}

function ExecuteForm2: Boolean;
begin
  Result := False;
  frmReportsAdhocSubItem1 := TfrmReportsAdhocSubItem1.Create(Application);
  try
    ResizeFormToFont(TForm(frmReportsAdhocSubItem1));
    frmReportsAdhocSubItem1.ShowModal;
    if frmReportsAdhocSubItem1.OKPressed then
      Result := True;
  finally
    frmReportsAdhocSubItem1.Release;
    frmReportsAdhocSubItem1 := nil;
  end;
end;

procedure TfrmReportsAdhocSubItem1.btnCancelClick(Sender: TObject);
begin
  ORComboBox2.Clear;
  ORListBox1.Clear;
  close;
end;

procedure TfrmReportsAdhocSubItem1.FormCreate(Sender: TObject);
var
  i: integer;
begin
  uLimitCount := 1;
  OKPressed := False;
  Panel8.Left := Splitter3.Left + Splitter3.Width;
  Panel8.Align := Splitter3.Align;
  ORListBox1.Left := Panel8.Left + Panel8.Width;
  ORListBox1.Align := Panel8.Align;
  RedrawSuspend(ORComboBox2.Handle);
  ORComboBox2.InitLongList('');
  RedrawActivate(ORComboBox2.Handle);
  if uLimit > 0 then
    lblLimit.Caption := IntToStr(uLimit)
  else
    lblLimit.Caption := 'No Limit';
  Caption := Piece(frmReportsAdhocComponent1.ORComboBox1.Items
    [frmReportsAdhocComponent1.ORComboBox1.ItemIndex], '^', 2);
  for i := 0 to uComponents.Count - 1 do
    if piece(uComponents[i], '^', 1) = IntToStr(uCurrentComponent) then
      ORListBox1.Items.Add(Pieces(uComponents[i], '^', 3, 10));
end;

procedure TfrmReportsAdhocSubItem1.ORListBox1EndDrag(Sender, Target: TObject; X, Y: Integer);
begin
  if (Sender = ORListBox1) and (Target = ORComboBox2) then
    btnRemoveSelClick(nil);
  Timer2.Enabled := False;
end;

procedure TfrmReportsAdhocSubItem1.ORListBox1DragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
  NuPos: Integer;
begin
  with Sender as TORListbox do begin
    NuPos := ItemAtPos(Point(X, Y), False);
    if NuPos >= Items.Count then
      Dec(NuPos);
    Items.Move(ItemIndex, NuPos);
    ItemIndex := NuPos;
  end;
end;

procedure TfrmReportsAdhocSubItem1.ORListBox1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Accept := (Sender = Source) and (TORListBox(Sender).ItemAtPos(Point(x, y), False) >= 0);
  if Accept then
    with Sender as TORListbox do
      if Y > Height - ItemHeight then begin
        GoingUp := False;
        Timer2.Enabled := True;
      end
      else
        if Y < ItemHeight then begin
          GoingUp := True;
          Timer2.Enabled := True;
        end
        else
          Timer2.Enabled := False;
end;

procedure TfrmReportsAdhocSubItem1.Timer2Timer(Sender: TObject);
begin
  with ORListBox1 do
    if GoingUp then
      if TopIndex > 0 then
        TopIndex := TopIndex - 1
      else
        Timer2.Enabled := False
    else
      if TopIndex < Items.Count - 1 then
        TopIndex := TopIndex + 1
      else
        Timer2.Enabled := False;
end;

procedure TfrmReportsAdhocSubItem1.SpeedButton8Click(Sender: TObject);
var
  i: Integer;
begin
  with ORListbox1 do
    if (ItemIndex < Items.Count - 1) and
      (ItemIndex <> -1) then begin
      i := ItemIndex;
      Items.Move(i, i + 1);
      ItemIndex := i + 1;
    end;
end;

procedure TfrmReportsAdhocSubItem1.SpeedButton7Click(Sender: TObject);
var
  i: integer;
begin
  with ORListBox1 do
    if ItemIndex > 0 then begin
      i := ItemIndex;
      Items.Move(i, i - 1);
      ItemIndex := i - 1;
    end;
end;

procedure TfrmReportsAdhocSubItem1.btnRemoveAllSelClick(Sender: TObject);
var
  i: integer;
begin
  if ORListBox1.Items.Count < 1 then begin
    MessageDlgCAPRI('There are no items to remove.', mtInformation,
      [mbOk], 0);
    Exit;
  end;
  if MessageDlgCAPRI('This button will remove all selected items. OK?',
    mtInformation, [mbYes, mbNo], 0) = mrYes then begin
    with ORListBox1 do begin
      for i := uComponents.Count - 1 downto 0 do
        uComponents.Delete(i);
      for i := Items.Count - 1 downto 0 do
        Items.Delete(i);
    end;
    uLimitCount := 1;
    SpeedButton7.Enabled := false;
    SpeedButton8.Enabled := false;
  end;
end;

procedure TfrmReportsAdhocSubItem1.btnRemoveSelClick(Sender: TObject);
var
  i: integer;
  chk: integer;
begin
  chk := 0;
  if ORListBox1.Items.Count < 1 then begin
    MessageDlgCAPRI('There are no items to remove.', mtInformation,
      [mbOk], 0);
    Exit;
  end
  else
    for i := 0 to ORListBox1.Items.Count - 1 do
      if ORListBox1.Selected[i] then
        chk := 1;
  if chk = 0 then begin
    MessageDlgCAPRI('Please select the item you wish to remove',
      mtInformation, [mbOK], 0);
    Exit;
  end;
  with ORListBox1 do begin
    for i := uComponents.Count - 1 downto 0 do
      if piece(uComponents[i], '^', 2) = Piece(Items[ItemIndex], '^', 1) then
        uComponents.Delete(i);
    Items.Delete(ItemIndex);
    uLimitCount := uLimitCount - 1;
    if Items.Count < 1 then begin
      SpeedButton7.Enabled := false;
      SpeedButton8.Enabled := false;
    end;
  end;
end;

procedure TfrmReportsAdhocSubItem1.btnOKClick(Sender: TObject);
var
  i: integer;
  uTestList: TStringList;
begin
  uTestList := TStringList.Create;
  uTestList.Clear;
  for i := 0 to ORListBox1.Items.Count - 1 do
    uTestList.Add(ORListBox1.Items[i]);
  for i := uComponents.Count - 1 downto 0 do
    if piece(uComponents[i], '^', 1) = IntToStr(uCurrentComponent) then
      uComponents.Delete(i);
  for i := 0 to uTestList.Count - 1 do
    if (uLimit = 0) or (i < uLimit) then
      uComponents.Add(IntToStr(uCurrentComponent)
        + '^' + uFile + '^' + uTestList[i]);
  OKPressed := True;
  ORListBox1.Clear;
  uTestList.Free;
  Close;
end;

procedure TfrmReportsAdhocSubItem1.btnAddSelClick(Sender: TObject);
var
  i: integer;
  uHSSubItems: TStringList;
begin
  if (uLimit <> 0) and (uLimitCount > uLimit) then begin
    Application.MessageBox(
      'Sorry, you have reached the selection limit for this component',
      'Selection Error', MB_OK + MB_DEFBUTTON1);
    Exit;
  end;
  if ORComboBox2.ItemIndex < 0 then begin
    MessageDlgCAPRI('Please select an item to Add.', mtInformation,
      [mbOk], 0);
    Exit;
  end;
  if uFile = '60' then begin
    uHSSubItems := TStringList.Create;
    frmMain.HSSubItems(uHSSubItems,
      Piece(ORComboBox2.Items[ORComboBox2.ItemIndex], '^', 1));
    if uHSSubItems.Count > 0 then
      for i := 0 to uHSSubItems.Count - 1 do begin
        ORListBox1.Items.Add(uHSSubItems[i]);
        uLimitCount := uLimitCount + 1;
      end
    else begin
      ORListBox1.Items.Add(ORComboBox2.Items[ORComboBox2.ItemIndex]);
      uLimitCount := uLimitCount + 1;
    end;
    uHSSubItems.Free;
  end
  else begin
    ORListBox1.Items.Add(ORComboBox2.Items[ORComboBox2.ItemIndex]);
    uLimitCount := uLimitCount + 1;
  end;
  if (uLimit <> 0) and (uLimitCount > (uLimit + 1)) then
    ShowMessageCAPRI(
      'MAXIMUM SELECTION LIMIT EXCEEDED! Only the first '
      + IntToStr(uLimit) + ' items in the list will be used');
  if ORListBox1.Items.Count > 0 then begin
    SpeedButton7.Enabled := true;
    SpeedButton8.Enabled := true;
  end;
  btnOK.SetFocus;
end;

procedure TfrmReportsAdhocSubItem1.ORComboBox2KeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if Key = 13 then
    with ORComboBox2 do
      if (Text <> '') and (Items.IndexOf(Text) >= 0) then begin
        ItemIndex := Items.IndexOf(Text);
        btnAddSelClick(nil);
      end;
end;

procedure TfrmReportsAdhocSubItem1.ORComboBox2NeedData(Sender: TObject;
  const StartFrom: string; Direction, InsertAt: Integer);
begin
  if ANURemoteProcedureCallInProgress = True then
    exit;
  ORComboBox2.ForDataUse(frmMain.HSFileLookup(uFile, StartFrom, Direction));
end;

procedure TfrmReportsAdhocSubItem1.CCOWTimerTimer(Sender: TObject);
begin
  inherited;
  if ShutdownCAPRIModalDialogs = true then begin
    CCOWTimer.Enabled := False;
    frmReportsAdhocSubItem1.Visible := False;
    ContextorChangeMessage := '';
    ModalResult := mrCancel;
  end;
end;

procedure TfrmReportsAdhocSubItem1.FormActivate(Sender: TObject);
begin
  inherited;
  CCOWTimer.Enabled := True;
end;

end.
