unit fWindowsProcesses;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  CAPRISupport,
  ExtCtrls;

type
  TfrmWindowsProcesses = class(TForm)
    ProcessListBox: TListBox;
    Close: TButton;
    Label1: TLabel;
    Button1: TButton;
    Label2: TLabel;
    Timer1: TTimer;
    procedure CloseClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmWindowsProcesses: TfrmWindowsProcesses;
  globalProcessResult: TStrings;
  countseconds: integer;

implementation

uses main;

{$R *.DFM}

procedure TfrmWindowsProcesses.CloseClick(Sender: TObject);
begin
  ModalResult := mrOK;
end;

function EnumProcess(hHwnd: HWND; lParam: integer): boolean; stdcall;
var
  pPid: Pointer;
  title, ClassName: string;
begin
  pPid:=nil;
  //if the returned value in null the
  //callback has failed, so set to false and exit.

  //jcs - d2006
  //if (hHwnd = NULL) then begin
  if (hHwnd = 0) then begin
    result := false;
  end
  else begin
    //additional functions to get more
    //information about a process.
    //get the Process Identification number.
    GetWindowThreadProcessId(hHwnd, pPID);
    //set a memory area to receive
    //the process class name
    SetLength(ClassName, 255);
    //get the class name and reset the
    //memory area to the size of the name
    SetLength(ClassName,
      GetClassName(hHwnd,
      PChar(className),
      Length(className)));
    SetLength(title, 255);
    //get the process title; usually displayed
    //on the top bar in visible process
    SetLength(title, GetWindowText(hHwnd, PChar(title), Length(title)));
    //Display the process information
    //by adding it to a list box
    GlobalProcessResult.Add(className + '^' + title + '^' +
      IntToStr(hHwnd) + '^' + string(pPid));
    result := true;
  end;
end;

procedure TfrmWindowsProcesses.FormCreate(Sender: TObject);
var
  lp: integer;
  x: integer;
begin
  CountSeconds := 11;

  GlobalProcessResult := TStringList.Create;
  ProcessListBox.Items.Clear;
  //Clear any previous calls
  if ProcessListBox.Items.Count > 0 then
    ProcessListBox.Clear;
  //define the tag flag
  lp := 0; //globally declared integer
  //call the windows function with the address
  //of handling function and show an error message if it fails
  if EnumWindows(@EnumProcess, lp) = false then
    ShowMessage('Error: Could not obtain process window hook from system.');

  (*
  for x:=0 to GlobalProcessResult.Count-1 do
    if uppercase(Piece(GlobalProcessResult[x],'^',1))='TAPPLICATION' then
    if Copy((Uppercase(Piece(GlobalProcessResult[x],'^',2))),1,6)<>'' then begin;
      if pos('CAPRI',uppercase(GlobalProcessResult[x]))>0 then
        showmessage(GlobalProcessResult[x]);
    end;
  *)

  if GlobalProcessResult.Count > 0 then
  begin
    for x := 0 to GlobalProcessResult.Count - 1 do
    begin
      {
      if (Uppercase(Piece(GlobalProcessResult[x], '^', 2)) = 'CAPRI GUI') and
        (Uppercase(Piece(GlobalProcessResult[x], '^', 1)) = 'TAPPLICATION') and
        (StrToInt(Piece(GlobalProcessResult[x], '^', 3)) <> application.handle) then
        ProcessListBox.Items.Add(GlobalProcessResult[x]);
      }
      if (Uppercase(Piece(GlobalProcessResult[x], '^', 2)) = 'CAPRI GUI') then
      begin
        if (Uppercase(Piece(GlobalProcessResult[x], '^', 1)) = 'TAPPLICATION') then
        begin
          {$WARNINGS OFF}
          if (StrToInt(Piece(GlobalProcessResult[x], '^', 3)) <> application.handle) then
          begin
            ProcessListBox.Items.Add(GlobalProcessResult[x]);
          end;
          {$WARNINGS ON}
        end;
      end;
    end;
  end;
  GlobalProcessResult.free;
  if ProcessListBox.Items.Count = 1 then
    Label1.Caption := IntToStr(ProcessListBox.Items.Count) + ' CAPRI session has been found running in the background.  Would you like to terminate this session?'
  else
    Label1.Caption := IntToStr(ProcessListBox.Items.Count) + ' CAPRI sessions have been found running in the background.  Would you like to terminate these sessions?';
end;

procedure KillProcess(hWindowHandle: integer);
var
  hprocessID: INTEGER;
  processHandle: THandle;
  DWResult: DWORD;
begin
  SendMessageTimeout(hWindowHandle, WM_CLOSE, 0, 0,
    SMTO_ABORTIFHUNG or SMTO_NORMAL, 5000, DWResult);

  if isWindow(hWindowHandle) then begin
    // PostMessage(hWindowHandle, WM_QUIT, 0, 0);

    { Get the process identifier for the window}
    GetWindowThreadProcessID(hWindowHandle, @hprocessID);
    if hprocessID <> 0 then begin
      { Get the process handle }
      processHandle := OpenProcess(PROCESS_TERMINATE or PROCESS_QUERY_INFORMATION,
        False, hprocessID);
      if processHandle <> 0 then begin
        { Terminate the process }
        TerminateProcess(processHandle, 0);
        CloseHandle(ProcessHandle);
      end;
    end;
  end;
end;

procedure TfrmWindowsProcesses.Button1Click(Sender: TObject);
var
  x: integer;
begin
  screen.cursor := crHourglass;
  if ProcessListBox.Items.Count > 0 then
    for x := 0 to ProcessListBox.Items.Count - 1 do
      KillProcess(strtoint(Piece(ProcessListBox.Items[x], '^', 3)));
  modalresult := mrOK;
  screen.cursor := crDefault;
end;

procedure TfrmWindowsProcesses.Timer1Timer(Sender: TObject);
begin
  Dec(CountSeconds);
  Label2.caption := 'The application will automatically continue in ' + inttostr(countseconds) + ' seconds.';
  if CountSeconds = 0 then
    CloseClick(Application);
end;

end.
