unit frmContractedAdminCheckIn;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, frmContractedBase, Diaccess, Fmcmpnts, ExtCtrls, StdCtrls, CheckLst,
  Fmcntrls, clsPatientInfo,
  CCOWRPCBrokerCAPRI,     // DONE: CodeCR457 - LMS Changed from CCOWRPCBroker
  ComCtrls, untAddtnlMMthds,
  untMiscMthds,
  DateUtils, AppEvnts, dialogsCAPRI, 
  Buttons;

type
  TExntdCntrctdBaseFormAdminCheckIn = class(TCntrctdBaseForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Label5: TLabel;
    lblFilePath: TLabel;
    btnGetCntrctdExamFile: TButton;
    chkbxDelChkIn: TCheckBox;
    Panel3: TPanel;
    Label1: TLabel;
    Panel4: TPanel;
    Label2: TLabel;
    Panel5: TPanel;
    Label3: TLabel;
    edtDtPckrFrom: TEdit;
    edtDtPckrTo: TEdit;
    btnDtPckrExamFrom: TSpeedButton;
    btnDtPckrExamTo: TSpeedButton;
    edDtCheckIn: TEdit;
    btnDtCheckIn: TSpeedButton;
    procedure FormShow(Sender: TObject);
    procedure btnCntrctdFrmCancelClick(Sender: TObject);
//    procedure dtPckrFromChange(Sender: TObject);
//    procedure dtPckrToChange(Sender: TObject);
    procedure btnRfrshRqstsClick(Sender: TObject);
    procedure chkdLstBxExamsClickCheck(Sender: TObject);
    procedure chkbxDelChkInClick(Sender: TObject);
//    procedure dtPckrCheckInChange(Sender: TObject);
//    procedure dtPckrToExit(Sender: TObject);
//    procedure dtPckrFromExit(Sender: TObject);
//    procedure dtPckrCheckInExit(Sender: TObject);
    procedure fmCmbBx2507RqstsKeyPress(Sender: TObject; var Key: Char);
    procedure btnDtPckrExamFromClick(Sender: TObject);
    procedure btnDtPckrExamToClick(Sender: TObject);
    procedure edtDtPckrFromExit(Sender: TObject);
    procedure edDtCheckInExit(Sender: TObject);
    procedure btnDtCheckInClick(Sender: TObject);
    procedure edtDtPckrToExit(Sender: TObject);
  protected
    { Protected declarations }
    procedure ExecuteBtnAction; override;
    procedure PopExamList(rqstIEN: String); override;
  private
    { Private declarations }
    _enbldExmLst: TStringList;
    _examIEN: String;
    _MinDate: TDateTime;
    procedure EditCheckIn;
    procedure SetExamAvailability(sts: Boolean);
    function GetDateOfText(aDateStr : string; defaultDate : string) : TDateTime;
    // function IsDateValid(aDateStr : string) : Boolean;  // DONE: LMS refactored out
    procedure DateComplete(var StrLikeDate : string; MinDate : TDate;
                    const NowIfError : Boolean = TRUE);
//    function AreInputDatesValid : Boolean;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent; PtntInfo: TPatientInfo;
         CCOWBrkr: TCCOWRPCBrokerCAPRI; TmrVal: Cardinal); reintroduce;
    destructor Destroy; override;
  end;

var
  ExntdCntrctdBaseFormAdminCheckIn: TExntdCntrctdBaseFormAdminCheckIn;

implementation
uses
  VocRehabSelectDate  // DONE: CodeCR457 - LMS For replacing date selection components
  ;

{$R *.dfm}

constructor TExntdCntrctdBaseFormAdminCheckIn.Create(AOwner: TComponent;
     PtntInfo: TPatientInfo; CCOWBrkr: TCCOWRPCBrokerCAPRI; TmrVal: Cardinal);
begin
  inherited Create(AOwner, PtntInfo, CCOWBrkr, TmrVal);
  _enbldExmLst := TStringList.Create;
  _examIEN := '';
end;

destructor TExntdCntrctdBaseFormAdminCheckIn.Destroy;
begin
  _enbldExmLst.Free;
  inherited;
end;

procedure TExntdCntrctdBaseFormAdminCheckIn.edDtCheckInExit(Sender: TObject);
var
  msg: String;
  s : string;
  MinDate : TDate;
begin
  msg := '';
  // validate text input in date field
  s := edDtCheckIn.Text;
  MinDate := StrToDate('01/01/2000'); 
  DateComplete(s, MinDate, FALSE);
  edtDtPckrFrom.Text := s;
  if copy(edDtCheckIn.Text,1,4) = 'Min ' then
  begin
    edDtCheckIn.Text := '';
    ShowMessageCAPRI('Please select a more current date');
    edtDtPckrFrom.SetFocus;
  end;               
end;

procedure TExntdCntrctdBaseFormAdminCheckIn.FormShow(Sender: TObject);
begin
  inherited;
  GetContractors; { Retrieve List of Contractors in File #396.45 }
  Caption := 'Edit Contracted Exam Check-In(s) for ' + _PtntInfo.PatientName +
    ' (' + Copy(_PtntInfo.PatientSSN, Length(_PtntInfo.PatientSSN) - 3, 4) + ')';
  { Initialize Date Parameters for 2507 Display
    FROM: 1 Month preceeding current date
    TO: Current date }
//  dtPckrFrom.Date := IncMonth(Date, -1);
  edtDtPckrFrom.Text := DateToStr(IncMonth(Date, -1));
//  dtPckrTo.Date := Date;
  edtDtPckrTo.Text := DateToStr(Date);
  { Default initial date to today - updated with Check-In Date when exam selected }
//  dtPckrCheckIn.Date := Date;
  { Inherited Contractor Lister NOT required for this form }
  btnRfrshRqstsClick(self); { Populate Requests }
end;

function TExntdCntrctdBaseFormAdminCheckIn.GetDateOfText(aDateStr,
  defaultDate: string): TDateTime;
begin
  try
    Result := StrToDate(aDateStr)
  except on e:exception do
    try
      Result := StrToDate(defaultDate);
    except on e2:exception do
      Result := StrToDate('1/1/1800');
    end;
  end;
end;

// DONE: LMS move into untMiscMthds as likely the most appropriate unit
(*
function TExntdCntrctdBaseFormAdminCheckIn.IsDateValid(aDateStr: string): Boolean;
var
  aDate : TDateTime;
begin
  Result := TryStrToDate(aDateStr, aDate);
  (* DONE: LMS more efficient implementation
  try
    aDate := StrToDate(aDateStr);
    Result := true;
  except on e:exception do
    Result := false;
  end;
  *)(*
end;*)

procedure TExntdCntrctdBaseFormAdminCheckIn.btnDtCheckInClick(Sender: TObject);
var
  ADate : TDateTime;
  frmVRSelectDate: TfrmVRSelectDate;
begin
  frmVRSelectDate := TfrmVRSelectDate.Create(Application);
  try
    frmVRSelectDate.MinimumDate := StrToDate('01/01/2000');  // editing - allow reasonable dates
    if TryStrToDate(edDtCheckIn.Text,ADate) then
      frmVRSelectDate.calSelectDate.Date := ADate
    else
      frmVRSelectDate.calSelectDate.Date := Today;
    frmVRSelectDate.ShowModal;
    edDtCheckIn.Text := frmVRSelectDate.SelectedDate;
  finally
    FreeAndNil(frmVRSelectDate);
  end;
  if (ActiveControl = edDtCheckIn) then
    SelectNext(ActiveControl as TWinControl, TRUE, TRUE);
end;

procedure TExntdCntrctdBaseFormAdminCheckIn.btnDtPckrExamFromClick(
  Sender: TObject);
var
  ADate : TDateTime;
  frmVRSelectDate: TfrmVRSelectDate;
begin
  frmVRSelectDate := TfrmVRSelectDate.Create(Application);
  try
    frmVRSelectDate.MinimumDate := StrToDate('01/01/2000');  // editing - allow reasonable dates
    if TryStrToDate(edtDtPckrFrom.Text,ADate) then
      frmVRSelectDate.calSelectDate.Date := ADate
    else
      frmVRSelectDate.calSelectDate.Date := Today;
    frmVRSelectDate.ShowModal;
    edtDtPckrFrom.Text := frmVRSelectDate.SelectedDate;
  finally
    FreeAndNil(frmVRSelectDate);
  end;
  if (ActiveControl = edtDtPckrFrom) then
    SelectNext(ActiveControl as TWinControl, TRUE, TRUE);
end;

procedure TExntdCntrctdBaseFormAdminCheckIn.btnDtPckrExamToClick(
  Sender: TObject);
var
  ADate : TDateTime;
  frmVRSelectDate: TfrmVRSelectDate;
begin
  frmVRSelectDate := TfrmVRSelectDate.Create(Application);
  try
    frmVRSelectDate.MinimumDate := StrToDate('01/01/2000');  // editing - allow reasonable dates
    if TryStrToDate(edtDtPckrTo.Text,ADate) then
      frmVRSelectDate.calSelectDate.Date := ADate
    else
      frmVRSelectDate.calSelectDate.Date := Tomorrow;
    frmVRSelectDate.ShowModal;
    edtDtPckrTo.Text := frmVRSelectDate.SelectedDate;
  finally
    FreeAndNil(frmVRSelectDate);
  end;
  if (ActiveControl = edtDtPckrTo) then
    SelectNext(ActiveControl as TWinControl, TRUE, TRUE);
end;

procedure TExntdCntrctdBaseFormAdminCheckIn.btnRfrshRqstsClick(Sender: TObject);
var
  itmsExist: Boolean;
  // FromDate, ToDate : TDate;
  dtModified: Boolean;
  tDtTimeT, tDtTimeF: TDateTime;
begin
//  if NOT AreInputDatesValid then  // If dates aren't valid, don't refresh anything
//     Exit;
  { Override Base Implementation - don't call inherited as date range and
    additional Request Statuses need to be added to lister screen. }
  ResetWndwTmr;
  fmCmbBx2507Rqsts.Text := '';
  fmCmbBx2507Rqsts.Items.Clear; { Clear / Reset Contents }
  chkdLstBxExams.Items.Clear;
//  dtPckrCheckIn.Enabled := False;
  chkbxDelChkIn.Checked := False;
  chkbxDelChkIn.Enabled := False;

  { Add Requests to Combo-Box - To Date increment by a day to be inclusive }

  (*FromDate := StrToDate(edtDtPckrFrom.Text);
  // ToDate := IncDay(StrToDate(edtDtPckrFrom.Text),1);
  // DONE: LMS The filters never took the "toDate" into account!
  ToDate := StrToDate(edtDtPckrTo.Text);
  if (FromDate > ToDate) then
  begin
    ToDate := IncDay(StrToDate(edtDtPckrFrom.Text),31);
  end;
  *)
  // DONE: LMS handling blanks and invalid dates

  dtModified := false;

  if not TryStrToDate(edtDtPckrTo.Text, tDtTimeT) then begin
    tDtTimeT := now;
    dtModified := true;
  end;
  if not TryStrToDate(edtDtPckrFrom.Text, tDtTimeF) then begin
    tDtTimeF := now;
    dtModified := true;
  end;

  if dtModified then
  begin
    if tDtTimeF > tDtTimeT then
      tDtTimeT := tDtTimeF + 31;
  end;

  _2507Info.GetPatient2507Rqsts(fmCmbBx2507Rqsts,
    DelphiDateToFMInternal(tDtTimeF),
    DelphiDateToFMInternal(tDtTimeT));
  { Add Delphi combobox over top FM combobox for 508 readability }
  cmbx2507Rqsts.Items.Clear();
  cmbx2507Rqsts.Items.AddStrings(fmCmbBx2507Rqsts.Items);
  itmsExist := (fmCmbBx2507Rqsts.Items.Count > 0);
  cmbx2507Rqsts.Enabled := itmsExist;
  chkdLstBxExams.Enabled := itmsExist;
  if itmsExist then
  begin
    cmbx2507Rqsts.ItemIndex := 0;
    cmbx2507RqstsChange(Sender);
  end; { End If Request Items Exist in List }
  AllowAction; { Ensures Button is Disabled on refresh - nothing checked }
end;

procedure TExntdCntrctdBaseFormAdminCheckIn.chkbxDelChkInClick(Sender: TObject);
begin
  inherited;
  ResetWndwTmr;
//  dtPckrCheckIn.Enabled := Not chkbxDelChkIn.Checked;

end;

procedure TExntdCntrctdBaseFormAdminCheckIn.chkdLstBxExamsClickCheck
  (Sender: TObject);
var
  curIndx: Integer;
  fmDtVal: String;
begin
  inherited;
  curIndx := chkdLstBxExams.ItemIndex;
  if Not chkdLstBxExams.Checked[curIndx] then
  begin
    _examIEN := '';
    SetExamAvailability(True); { Re-enable appropriate exams }
//    dtPckrCheckIn.Enabled := False;
    edDtCheckIn.Enabled := False;
    btnDtCheckIn.Enabled := False;
    chkbxDelChkIn.Checked := False;
    chkbxDelChkIn.Enabled := False;
  end { End If Exam Item Unchecked }
  else
  begin
    _examIEN := _fmTmpLstrExams.Results[curIndx];
//    dtPckrCheckIn.Enabled := True;
    edDtCheckIn.Enabled := True;
    btnDtCheckIn.Enabled := True;
    { Set Date Picker to Current Check-In if populated, else current date and
      Set the Minimum allowed value to the Contracted Out Date }
    _MinDate := StrToDate(FMInternalToDelphiDate(_fmTmpLstrExams.GetRecord
          (_fmTmpLstrExams.Results[curIndx]).GetField('101').FMDBExternal));
    fmDtVal := _fmTmpLstrExams.GetRecord(_fmTmpLstrExams.Results[curIndx])
      .GetField('102').FMDBExternal;
    if Not SameText(fmDtVal, '') then
      try
        { Only enable Delete Check Box if Check-In Date (Received) from Contractor
          exists. Situation only occurs if exam was checked-in in CAPRI. }
        chkbxDelChkIn.Enabled := True;
//        dtPckrCheckIn.Date := StrToDate(FMInternalToDelphiDate(fmDtVal));
        edDtCheckIn.Text := FMInternalToDelphiDate(fmDtVal);
      except
//      dtPckrCheckIn.Date := Date; { Set to today on conversion errors }
        edDtCheckIn.Text := DateToStr(Date); { Set to today on conversion errors }
      end { End Try/Except }
    else
//      dtPckrCheckIn.Date := Date; { No Check-In Date - Default to today }
      edDtCheckIn.Text := DateToStr(Date); { No Check-In Date - Default to today }
    { Force Administrator to edit each exam seperately }
    SetExamAvailability(False); { Disable non-checked exams }
  end; { End If Initial Exam Item Checked }
  AllowAction;
end;

//procedure TExntdCntrctdBaseFormAdminCheckIn.dtPckrCheckInChange
//  (Sender: TObject);
//begin
//  inherited;
//  ResetWndwTmr;
//end;

//procedure TExntdCntrctdBaseFormAdminCheckIn.dtPckrCheckInExit(Sender: TObject);
//var
//  msg: String;
//begin
//  msg := '';
//  ResetWndwTmr;
//  { Check for Valid Date }
//  if (dtPckrCheckIn.IsDateValid) then
//  begin
//    if (dtPckrCheckIn.Date > Date) then
//      msg := 'Future dates cannot be entered.' + #13#10 +
//        'Please enter a date on or before ' + DateTimeToStr(Date) + '.'
//    else if (dtPckrCheckIn.Date < _MinDate) then
//      msg :=
//        'Check In date cannot be prior to the date transferred to the contractor (Check Out).' +
//        #13#10 + 'Please enter a date on or after ' + DateTimeToStr(_MinDate)
//        + '.';
//  end
//  else
//    msg :=
//      'The date entered is invalid, please enter a valid date to continue.'
//      +
//      #13#10 + 'Valid date format is: 1-2 digit Month / 1-2 digit Day / 2-4 digit year';
//  if (Not SameText(msg, '')) then
//  begin
//    ShowMessageCAPRI(msg);
//    dtPckrCheckIn.SetFocus;
//    dtPckrCheckIn.SelectAll;
//  end; { End Error Occured, display message and reset focus }
//end;

//procedure TExntdCntrctdBaseFormAdminCheckIn.dtPckrFromChange(Sender: TObject);
//begin
//  ResetWndwTmr;
////  edtDtPckrFrom.Text := DatetoStr(DtPckrFrom.Date);
//end;

//procedure TExntdCntrctdBaseFormAdminCheckIn.dtPckrFromExit(Sender: TObject);
//var
//  s : string;
//  MinDate : TDate;
//  FromDate, ToDate : TDate;
//  msg: String;
//begin
//  msg := '';
//  ResetWndwTmr;
//end;

//procedure TExntdCntrctdBaseFormAdminCheckIn.dtPckrToChange(Sender: TObject);
//begin
//  ResetWndwTmr;
//  edtDtPckrTo.Text := DatetoStr(DtPckrTo.Date);
//end;

//procedure TExntdCntrctdBaseFormAdminCheckIn.dtPckrToExit(Sender: TObject);
//var
//  msg: String;
//begin
//  msg := '';
//  ResetWndwTmr;
//  { Check for Valid Date }
//  if (dtPckrTo.IsDateValid) then
//  begin
//    if (dtPckrTo.Date < dtPckrFrom.Date) then
//      msg := 'To date cannot precede the From date.' + #13#10 +
//        'Please enter a date on or after ' + DateTimeToStr(dtPckrFrom.Date)
//        + '.';
//  end
//  else
//    msg :=
//      'The date entered is invalid, please enter a valid date to continue.'
//      +
//      #13#10 + 'Valid date format is: 1-2 digit Month / 1-2 digit Day / 2-4 digit year';
//  if (Not SameText(msg, '')) then
//  begin
//    ShowMessageCAPRI(msg);
//    dtPckrTo.SetFocus;
//    dtPckrTo.SelectAll;
//  end; { End Error Occured, display message and reset focus }
//end;


procedure TExntdCntrctdBaseFormAdminCheckIn.btnCntrctdFrmCancelClick
  (Sender: TObject);
begin
  inherited;
  { Dynamically setting button modal result is ignored when passed back
    to calling application, so set the Form's Modal Result so correct
    value is seen and lists can be refreshed. }
  if btnCntrctdFrmCancel.ModalResult = mrOk then
    ModalResult := mrOk;
end;

procedure TExntdCntrctdBaseFormAdminCheckIn.ExecuteBtnAction;
begin
  { Edit Check-In for the selected exam. Reset Modal Result for Cancel
    button so that the Tree View is Refreshed on the MAIN form upon exiting }
  EditCheckIn;
  { Reset Check-In Components - as exam list will be repopulated }
  _examIEN := '';
//  dtPckrCheckIn.Enabled := False;
  chkbxDelChkIn.Checked := False;
  chkbxDelChkIn.Enabled := False;
  cmbx2507RqstsChange(self); { Refresh Exam List for Request }
  btnCntrctdFrmCancel.ModalResult := mrOk;
end;

procedure TExntdCntrctdBaseFormAdminCheckIn.fmCmbBx2507RqstsKeyPress
  (Sender: TObject; var Key: Char);
begin
  inherited;
end;

{ PRIVATE }

procedure TExntdCntrctdBaseFormAdminCheckIn.PopExamList(rqstIEN: string);
var
  i: Integer;
  IEN, exmSts, cntrctrIEN, cntrctrNme: String;
begin
  _enbldExmLst.Clear;
  chkdLstBxExams.Items.BeginUpdate;
  { Add Exams for Request to list, enable only those entries that have been
    Checked-Out and have a status of Completed }
  for i := 0 to _fmTmpLstrExams.Results.Count - 1 do
  begin
    IEN := _fmTmpLstrExams.Results[i];
    exmSts := _fmTmpLstrExams.GetRecord(IEN).GetField('.04').FMDBExternal;
    { Internal value requested in lister call, but value still returned in External }
    cntrctrIEN := _fmTmpLstrExams.GetRecord(IEN).GetField('100').FMDBExternal;
    cntrctrNme := '';
    if Not SameText(cntrctrIEN, '') then
      cntrctrNme := ' - ' + fmLstrCntrctrs.GetRecord(cntrctrIEN).GetField('.01').FMDBExternal;
    { Add Exam Info for Request to List }
    chkdLstBxExams.Items.AddObject(_fmTmpLstrExams.GetRecord(IEN).GetField
        ('.03').FMDBExternal + ' [' + exmSts + cntrctrNme + ']', TObject(StrToInt(IEN)));
    { Show all Exams for request, but Disable Exam entries in list if the exam
      has NOT been Checked-Out and does NOT have a status of Completed }
    if ((Not SameText(UpperCase(exmSts), 'COMPLETED')) or
        (SameText(_fmTmpLstrExams.GetRecord(IEN).GetField('101').FMDBExternal, ''))) then
      chkdLstBxExams.ItemEnabled[(chkdLstBxExams.Items.Count - 1)] := False
    else
    begin
      chkBxCntrctAllExams.Enabled := True; { If at least one exam is available }
      _enbldExmLst.Add(IntToStr(i)); { List of enabled Exams }
    end;
  end; { End For Loop }
  chkdLstBxExams.Items.EndUpdate;
  chkdLstBxExams.Repaint;
  AllowAction;
end;

procedure TExntdCntrctdBaseFormAdminCheckIn.EditCheckIn;
var
  dlgType: TMsgDlgType;
  chkInDte, msg: String;
begin
  { Success Message }
  msg := 'Date received from contractor (Check-In) has been successfully updated in the Exam.';
  dlgType := mtConfirmation;
  { Determine new check-in value for contracted exam }
//  chkInDte := DelphiDateToFMInternal(dtPckrCheckIn.Date);
  chkInDte := DelphiDateToFMInternal(StrToDate(edDtCheckIn.Text));
  { Currently hidden as all users can now delete the check-in through the
    CAPRI Manage Reports option under the tools menu. Remove in future. }
  if chkbxDelChkIn.Checked then
    chkInDte := '@';
  { Update Date Received From Contractor (Check-In) for selected Exam.
    Display message if error updating the value in VistA. }
  if Not _2507Info.EditExamCheckIn(_examIEN, chkInDte) then
  begin
    msg := 'An error occurred while updating the exam record in VistA.' +
           #13#10 + 'Please try updating the exam record again.' + #13#10 +
           'Consult your IRM/Help Desk if the problem persists.';
    dlgType := mtError;
  end; { End If Error Updating Check-In value in VistA }
  MessageDlgCAPRI(msg, dlgType, [mbOK], 0); { Display Appropriate Message to Screen }
end;

procedure TExntdCntrctdBaseFormAdminCheckIn.edtDtPckrFromExit(Sender: TObject);
var
  msg: String;
  s : string;
  MinDate : TDate;
begin
  msg := '';
  // validate text input in date field
  s := edtDtPckrFrom.Text;
  MinDate := StrToDate('01/01/2000'); 
  DateComplete(s, MinDate, FALSE);
  edtDtPckrFrom.Text := s;
  if copy(edtDtPckrFrom.Text,1,4) = 'Min ' then
  begin
    edtDtPckrFrom.Text := '';
    ShowMessageCAPRI('Please select a more current date');
    edtDtPckrFrom.SetFocus;
  end;               
end;

procedure TExntdCntrctdBaseFormAdminCheckIn.edtDtPckrToExit(Sender: TObject);
var
  msg: String;
  s : string;
  MinDate : TDate;
begin
  msg := '';
  // validate text input in date field
  s := edtDtPckrTo.Text;
  MinDate := StrToDate('01/01/2000'); 
  DateComplete(s, MinDate, FALSE);
  edtDtPckrTo.Text := s;
  if copy(edtDtPckrFrom.Text,1,4) = 'Min ' then
  begin
    edtDtPckrTo.Text := '';
    ShowMessageCAPRI('Please select a more current date');
    edtDtPckrFrom.SetFocus;
  end;               
end;

{ Enables/Disables applicable exams for request }
procedure TExntdCntrctdBaseFormAdminCheckIn.SetExamAvailability(sts: Boolean);
var
  i: Integer;
begin
  for i := 0 to _enbldExmLst.Count - 1 do
    if Not chkdLstBxExams.Checked[StrToInt(_enbldExmLst[i])] then
      chkdLstBxExams.ItemEnabled[StrToInt(_enbldExmLst[i])] := sts;
  chkdLstBxExams.Repaint;
end;

procedure TExntdCntrctdBaseFormAdminCheckIn.DateComplete(
  var StrLikeDate: string; MinDate: TDate; const NowIfError: Boolean);
var
   DateStr : string;
   Year, Month, Day : Word;
   cnt, SepCount : Integer;
begin
   DateStr := StrLikeDate;
   if DateStr = '' then
      Exit;
   SepCount := 0;
   for cnt := 1 to Length(DateStr) do
   begin
     if not (DateStr[cnt] in ['0'..'9']) then
     begin
       DateStr[cnt] := DateSeparator;
       inc(SepCount);
     end;
   end;
   while (DateStr <> '') and (DateStr[Length(DateStr)]=DateSeparator) do
   begin
     Delete(DateStr, Length(DateStr),1);
     Dec(SepCount);
   end;
   DecodeDate(Now,Year,Month,Day);
   if SepCount = 0 then
   begin
     case Length(DateStr) of
       0   : DateStr := DateToStr(Now);
       1, 2: DateStr := DateStr+DateSeparator+IntToStr(Day);
//     1, 2: DateStr := DateStr+DateSeparator+IntToStr(Month);  // use this if short date format is dd/mm/yyyy
       4   : Insert(DateSeparator, DateStr, 3);
       6, 8: begin
             Insert(DateSeparator, DateStr, 5);
             Insert(DateSeparator, DateStr, 3);
             end; 
     end; // case
   end; // if SepCount
   try
     StrLikeDate := FormatDateTime('mm/dd/yyyy',StrToDate(DateStr));
   Except
     if NowIfError = TRUE then
     begin
      StrLikeDate := DateToStr(Date)
     end
     else
        StrLikeDate := '';
   end;
   // Date is valid, check for greater than minimum date
   if StrToDate(DateStr) < MinDate then
      StrLikeDate := 'Min ' + StrLikeDate;
end;


//function TExntdCntrctdBaseFormAdminCheckIn.AreInputDatesValid: Boolean;
//begin
//  // Validate a valid from/to Date 
//  if (dtPckrFrom.IsDateValid) then
//  begin
//    if (dtPckrFrom.Date > dtPckrTo.Date) then
//      msg := 'From date cannot exceed the To date.' + #13#10 +
//        'Please enter a date on or before ' + DateTimeToStr(dtPckrTo.Date)
//        + '.';
//  end
//  else
//    msg :=
//      'The date entered is invalid, please enter a valid date to continue.'
//      +
//      #13#10 + 'Valid date format is: 1-2 digit Month / 1-2 digit Day / 2-4 digit year';
//  if (Not SameText(msg, '')) then
//  begin
//    ShowMessageCAPRI(msg);
//    dtPckrFrom.SetFocus;
//    dtPckrFrom.SelectAll;
//  end; { End Error Occured, display message and reset focus }
//end;

end.
