unit frmVVAGetDocs;

interface

uses
  // LMS could have use this to address the memory allocation issues ..SimpleShareMem.. However see VVA DLL for more details
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, MFunStr, ShellAPI, contnrs, Grids, VAUtils, ExtCtrls,
  fVVAStatus, virtualVAWebServiceClient, VA508AccessibilityManager
  , UnitDocumentMethods
  ;

type

  TCallBackFuncToGetDocBuffer = function(NewLength: Integer) : Pointer of object; cdecl;

  TfrmVVARetrieval = class(TForm)
    lbDocuments: TListBox;
    btnClose: TButton;
    lblDocumentList: TLabel;
    btnViewSelectedDocument: TButton;
    sgDocList: TStringGrid;
    gbSortBy: TGroupBox;
    cbSortColumn: TComboBox;
    cbSortDirection: TComboBox;
    lblColumn: TLabel;
    lblDirection: TLabel;
    gbPatient: TGroupBox;
    lblPatientName: TLabel;
    edbPatientName: TEdit;
    lblClaimNum: TLabel;
    edbClaimNum: TEdit;
    lblDOB: TLabel;
    edbDOB: TEdit;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    procedure btnCloseClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnViewSelectedDocumentClick(Sender: TObject);
    procedure lbDocumentsClick(Sender: TObject);
    procedure cbSortColumnChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure sgDocListClick(Sender: TObject);
    procedure sgDocListDblClick(Sender: TObject);
    procedure cbSortDirectionChange(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
    FVVASecToken: WideString;
    FVVAURL: WideString;
    FVVAUserID: WideString;
    FVVADocDir: String;
    FVAHospitalRole: Boolean;
    FCharOffset: Integer;
    SortedList: TStringList;
    FVVAOpInProcess: Boolean;
    aReturnTextP: Pointer;
    aRetBufSize : Integer;
    memHnd : HGLOBAL;
    OpenDocs: TOpenDocList; // TObjectList;
    // anOpenDoc: TOpenDoc;  //  Moved inside OpenDocs
    procedure SortList(Col: Integer; SortedList: TStringList; Descending : Boolean = False);
    function FormatLBRow(aRow: String): String;
    procedure FormatLBResults;
    procedure FormatSGResults;
    procedure PopulateSGRow(RowNum: Integer; RowData: String);
    procedure FormatSGDocList;
    procedure GetAndViewDocument;
    procedure ShowDialog(aMsg: String; aDialog: TfrmVVAStatus; isModal: Boolean = False);
    function IsSorted: Boolean;
    function IsRestrictedDoc(aDelimitedRecord: String): Integer;
  public
    { Public declarations }
    slDocList: TStringList;
    property VVAOpInProcess: Boolean read FVVAOpInProcess; // write FVVAOpInProcess;
    property VVASecToken : WideString read FVVASecToken write FVVASecToken;
    property VVAURL : WideString read FVVAURL write FVVAURL;
    property VVAUserID: WideString read FVVAUserID write FVVAUserID;
    property VVADocDir : String read FVVADocDir write FVVADocDir;
    property IsVAHospitalRole : Boolean read FVAHospitalRole write FVAHospitalRole;
    function GetAndFormatDocumentList: Boolean;
    function GetNewDocumentBuffer(NewLength: Integer): Pointer; cdecl;
  end;

var
  frmVVARetrieval: TfrmVVARetrieval;

  function GetDocumentList( const _ClmNmbr: WideString;
                            const _URL: WideString;
                            const _SECUSR: WideString;
                            const _SECPWD: WideString;
                            const _SECTOKEN: WideString;
                            const _SetDocListLength: TCallBackFuncToGetDocBuffer
                            ; const AApp: TObject
                            ; const AppProcessMessagesPointer : Pointer
                            ): PAnsiChar; cdecl;  // LMS Everything has to be cdecl, since caller is responsible for cleanup and will need the call stack for unloading return values.
                            external 'VACAPRIVVA.dll';

  function GetDocument( const _DocID: WideString;
                        const _DocSource: WideString;
                        const _DocFormat: WideString;
                        const _DocJRO: WideString;
                        const _Pth: WideString;
                        const _UserID: WideString;
                        const _URL: WideString;
                        const _SECUSR: WideString;
                        const _SECPWD: WideString;
                        const _SECTOKEN: WideString
                        ; const AApp: TObject
                        ; const AppProcessMessagesPointer : Pointer
                        ) : PAnsiChar; cdecl;
                        external 'VACAPRIVVA.dll';

implementation

uses Main, CCOWRPCBrokerCAPRI
   ;

{$R *.dfm}

const
  // Column sizes are used primarily for screen reader formatting
  DocIDColSize = 20;
  dateColSize = 18;
  DocTypeColSize = 30;
  SubjColSize = 30;
  SrcCommentColSize = 24;
  DocFrmtColSize = 10;
  // Column headers
  dtHdr = 'Date of Receipt';
  docTypeHdr = 'Document Type Desc';
  subHdr = 'Subject';
  srcCommentHdr = 'Source Comment';
  docIdHdr = 'Document Id';
  docFrmtHdr = 'Format';
  // Restricted display strings
  restrictedSubject =  '{Restricted Document}';
  blankSubject = '{Blank Subject}';
  // Restricted Message Types
  NOT_RESTRICTED = 1;
  RESTRICTED_TYPE2TO9 = 29;
  RESTRICTED_TYPE10 = 10;
  RESTRICTED_TYPE11 = 11;                                                       // JRL 3/21/13 Added type 11

procedure TfrmVVARetrieval.FormCreate(Sender: TObject);
begin
  FVVAOpInProcess := false;
  memHnd := 0;

  SortedList := TStringList.Create;       //used to contain sorted doc list
  slDocList := TStringList.Create;        //used to contain unsorted doc list
  //OpenDocs := TObjectList.Create(True);   //used to track open doc processes
  OpenDocs := TOpenDocList.Create(True);   //used to track open doc processes

  //configure startup component state
  btnViewSelectedDocument.Enabled := False;
  lbDocuments.Enabled := False;
  sgDocList.Enabled := False;
  cbSortColumn.Enabled := False;
  cbSortDirection.Enabled := False;

  FormatSGDocList;                        //configure string grid display

  if VAUtils.ScreenReaderActive then      //508 compliance
  begin
    edbPatientName.TabStop := True;
    edbClaimNum.TabStop := True;
    edbDOB.TabStop := True;
  end
  else
  begin
    edbPatientName.TabStop := False;
    edbClaimNum.TabStop := False;
    edbDOB.TabStop := False;
  end;
end;

procedure TfrmVVARetrieval.FormDestroy(Sender: TObject);
begin
  FreeAndNil(slDocList);
  FreeAndNil(SortedList);
  FreeAndNil(OpenDocs);
end;

procedure TfrmVVARetrieval.FormResize(Sender: TObject);
var
  I, rowTotal, oneCharPixelSize: Integer;
const
  ColumnCount = 3;  //share extra space with type description, subject and source comment lines only
begin
  rowTotal := 0;
  if VAUTils.ScreenReaderActive then
  begin
    oneCharPixelSize := lbDocuments.Canvas.TextWidth('A');
    rowTotal := dateColSize + DocTypeColSize + SubjColSize + DocIDColSize + DocFrmtColSize + SrcCommentColSize;

    if (Round(lbDocuments.Width / oneCharPixelSize) > rowTotal) then
      FCharOffset := ((Round(lbDocuments.Width / oneCharPixelSize)) - rowTotal) div ColumnCount
    else
      FCharOffset := 0;

    FormatLBResults;
  end
  else
  begin
    for I := 0 to sgDocList.ColCount - 1 do
      rowTotal := rowTotal + sgDocList.ColWidths[I];

    for I := 0 to sgDocList.ColCount - 1 do
      sgDocList.ColWidths[I] := Round((sgDocList.ColWidths[I] / rowTotal) * sgDocList.Width);
  end;
end;

function TfrmVVARetrieval.GetNewDocumentBuffer(NewLength: Integer): Pointer; cdecl;
begin
  Result := nil;
  if NewLength > 0  then
  begin
    aRetBufSize := NewLength;
    memHnd := GlobalAlloc(GHND , NewLength);  // LMS dont need it GMEM_FIXED and can be movable and must be zero inited.
    if (memHnd <> 0) then
    begin
      aReturnTextP := GlobalLock(memHnd);
      result := aReturnTextP;
    end;
  end;
end;

{============================================================================
 GetAndFormatDocumentList
 This function uses the Virtual VA GetDocumentList web service method to
 retrieve the full collection of available documents for a given Claim # or
 SSN.  The list is displayed in a string grid by default or a listbox when
 a screen reader is active or not.

 The funtion returns FALSE when a web service error is encountered or when
 no records are found; otherwise, TRUE is returned.
 ============================================================================}
function TfrmVVARetrieval.GetAndFormatDocumentList: Boolean;
const
  RETRIEVE_DOC_LIST_MSG = 'Retrieving document list ... please be patient.';
  NO_RECORDS_FOUND = 'No Records Found in Virtual VA.';
var
  frmVVAStatus: TFrmVVAStatus;
  wsSecUser, wsSecPwd, wsSecToken: WideString;
  aReturnText: WideString;
  aReturnTextAnsi: AnsiString;
  FApplicationProxy : TApplicationProxy;
  TempReturnTextP: Pointer;
begin
  Result := false;
  aReturnText := '';

  If VVAOpInProcess then exit;
  //disable UI controls
  cbSortColumn.Enabled := False;
  cbSortDirection.Enabled := False;
  btnViewSelectedDocument.Enabled := False;

  FormatSGDocList;
  slDocList.Clear;

  //retrieve document list
  if (Length(edbClaimNum.Text) = 9) and   //validate input SSN
     (StrToIntDef(edbClaimNum.Text, 0) > 0) then
  begin
    frmVVAStatus := TfrmVVAStatus.Create(Self);
    {center the form on main because the Retrieve Documents from VVA form
     is not visible yet}
    frmVVAStatus.Position := poMainFormCenter;

    try
      wsSecUser := Piece(FVVASecToken, '^' ,1);
      wsSecPwd := Piece(FVVASecToken, '^' ,2);
      wsSecToken := Piece(FVVASecToken, '^', 3);

      //display informational wait dialog
      ShowDialog(RETRIEVE_DOC_LIST_MSG, frmVVAStatus, False);

      FApplicationProxy := TApplicationProxy.create();
      FVVAOpInProcess := True;
      try
        TempReturnTextP := GetDocumentList(edbClaimNum.Text
                           , FVVAURL
                           , wsSecUser, wsSecPWD, wsSecToken
                           , GetNewDocumentBuffer
                           , FApplicationProxy, FApplicationProxy.ProxyProcessMessagesPointer);
                           // LMS sometimes this will result in something like..
                           //   First chance exception at $00D8B164. Exception class $C0000005 with
                           //    message 'access violation at 0x00d8b164: write of address 0x00000000'. Process ...
                           //  http://qc.embarcadero.com/wc/qcmain.aspx?d=100418
                           //  Apparently something like this happens in some scenarios in debugger only!
                           //  Also happens if caller uses stdcall and callee ues cdecl or vice-versa
                           //   or if the method signature mismatches in any way.
      finally
        FVVAOpInProcess := False;
        FreeAndNil(FApplicationProxy);
      end;

      frmMain.IsRPCBrokerConnected(); // LMS make it reconnect since too much time can elapsed
      Application.ProcessMessages;    // LMS In case of GetDocument call, it seemed file handle wasn't closed out by the time control returned.some file renames failed.. may be the recent write by the DLL is not finished or the handle is not closed. So doing same precaution here as well.

      Result := ((aRetBufSize>0) and (TempReturnTextP = aReturnTextP));  // TempReturnTextP comparison is for validation
      if Result then begin
        aReturnTextAnsi :='';
        SetString(aReturnTextAnsi,PWideChar(aReturnTextP),aRetBufSize div 2); // widechar gets div 2
        slDocList.Text := aReturnTextAnsi;
      end;
    finally
      FreeAndNil(frmVVAStatus);
      if (memHnd <> 0) then begin
        GlobalUnlock(memHnd);      // LMS: Clean up. These were set in the above callback in GetDocumentList.
        aReturnTextP := nil;
        GlobalFree(memHnd);
        memHnd := 0;
      end;
    end;
  end;

  //Display dialog when encountering an error or when no records are found
  if (not Result) or
     (Copy(slDocList.Text, 1, 6) = 'ERROR:') or
     (slDocList.Count = 0) then
  begin
    frmVVAStatus := TfrmVVAStatus.Create(Self);
    {center the form on main because the Retrieve Documents from VVA form
     is not visible yet}
    frmVVAStatus.Position := poMainFormCenter;
    try
      if (Copy(slDocList.Text, 1, 6) = 'ERROR:') then  //display error dialog
        ShowDialog(Copy(slDocList.Text, 1, Length(slDocList.Text) - 2), frmVVAStatus, True)
      else if (TempReturnTextP = aReturnTextP) then  //display no records dialog
        ShowDialog(NO_RECORDS_FOUND, frmVVAStatus, True)
        else
          ShowDialog('ERROR: Unhandled condition in reaching Web Service.', frmVVAStatus, True);
    finally
      FreeAndNil(frmVVAStatus);
      Result := False;
    end;
  end
  else   //success - records found and no errors
  begin
    Result := True;
    //display results
    if VAUtils.ScreenReaderActive then   //508 compliance
      FormatLBResults  //show listbox results
    else
      FormatSGResults;  //show string grid results

    //update UI
    lblDocumentList.Caption := 'Document List: '
                              + IntToStr(slDocList.Count)
                              + ' Documents';
    cbSortColumn.Enabled := True;
  end;
end;

{============================================================================
 GetAndViewDocument
 This procedure retrieves a selected document from the Virtual VA using the
 GetDocument web service method and displays the document in the application
 associated with the returned file's extent on the user's workstation.
 ============================================================================}
procedure TfrmVVARetrieval.GetAndViewDocument;
var
  docListIndex : Integer;
  docID, docFormat, docSrc, docJRO, docPath, docPathBase, docPathFinal: WideString;
  wsSecUser, wsSecPwd, wsSecToken: WideString;
  frmVVAStatus, frmVVAErrorStatus: TfrmVVAStatus;
  aSelectedRecord : String;
  GetDocResult, GetDocMimeType: AnsiString;
  DocumentTypeCode : Integer;
  RetrieveDocument : Boolean;

  //PreviousRPCCallinProgressState : Boolean; // LMS all this timer stuff needs done specifically for "GetDocument" operation because it takes too long. If needed in the future, it could be replicated for GetDocumentList and SendVVADoc call in virtualVAWebServiceClient.pas
  PreviousTimeoutTimerState : Boolean;
  PreviousRPCTimeLimit: integer;

  FApplicationProxy : TApplicationProxy;    // LMS The AppProxy is sent in all calls to avoid app from getting blocked
const
  VVA_FILEPREFIX = 'CAPRI_VVA_TEMP_';
  RESTRICTED_DOC_MSG = 'To view this document, please contact your IT staff for the proper security key.';
  RESTRICTED_MSG_TYPE10 = 'Fiduciary Document - Access not Permitted';
  RESTRICTED_MSG_TYPE11 = 'Federal Tax Information  Access not Permitted';
  RETRIEVE_DOC_MSG = 'Retrieving selected document ... please be patient.';
begin
  If VVAOpInProcess then exit;
  //disable UI controls
  btnViewSelectedDocument.Enabled := False;  //prevent multiple button clicks
  sgDocList.Enabled := False;
  cbSortColumn.Enabled := False;  //disable sort by when retrieving
  cbSortDirection.Enabled := False;

  docListIndex := -1;
  frmVVAStatus := TfrmVVAStatus.Create(Self);
  frmVVAStatus.Position := poOwnerFormCenter;

  //get the itemindex from the appropriate source list
  if VAUtils.ScreenReaderActive then
  begin  //selected doc in listbox when reader is active
    if (lbDocuments.ItemIndex > 0) and
       (slDocList.Count = (lbDocuments.Count - 1)) then
      docListIndex := lbDocuments.ItemIndex - 1;
  end
  else
  begin //default uses selected doc from string grid
    if (sgDocList.Row > 0) and
       (slDocList.Count = (sgDocList.RowCount - 1)) then
      docListIndex := sgDocList.Row - 1;
  end;

  if (docListIndex > -1) then
  try
    //get correct record based on sorted or not
    if IsSorted then
      aSelectedRecord := String(SortedList.Objects[docListIndex])
    else
      aSelectedRecord := slDocList[docListIndex];

    //check for restricted record - may not view a restricted document
    DocumentTypeCode := IsRestrictedDoc(aSelectedRecord);
    RetrieveDocument := TRUE;  // Default to Type 1 document where it can be viewed
    if DocumentTypeCode = RESTRICTED_TYPE11 then                                // modified 3/21/13 JRL
    begin                                                                       // add restricted document
      ShowDialog(RESTRICTED_MSG_TYPE11, frmVVAStatus, True);                    // IVM type 11
      RetrieveDocument := FALSE; // No one can view type 11 from CAPRI          //
    end;
    if DocumentTypeCode = RESTRICTED_TYPE10 then                                // modified 3/12/13 JRL
    begin                                                                       // allow user with the hospital
      ShowDialog(RESTRICTED_MSG_TYPE10, frmVVAStatus, True);                    // role to view restricted document
      RetrieveDocument := FALSE; // No one can view type 10 from CAPRI          // types 2-9.
    end;
    if DocumentTypeCode = RESTRICTED_TYPE2TO9 then
    begin
       if FVAHospitalRole then  //VA Hospital role
          RetrieveDocument := TRUE   // VA Hospital role users can view restricted document types 2-9
       else
       begin
          ShowDialog(RESTRICTED_DOC_MSG, frmVVAStatus, True);
          RetrieveDocument := FALSE; // Non hospital role users see a restricted document message and cannot view the document
       end;
    end;
    if RetrieveDocument then
    begin
      //define required web service input parameters to retrieve document
      docID := Piece(aSelectedRecord, '^', 4);
      docFormat := Piece(aSelectedRecord, '^', 5);
      docJRO := Piece(aSelectedRecord, '^', 6);
      docSrc := Piece(aSelectedRecord, '^', 7);
      if (docSrc = 'IS') then   //source is 'IS' in list, but wsdl uses 'IS_'
        docSrc := 'IS_';
      docPathBase := FVVADocDir + VVA_FILEPREFIX
                 + FormatDateTime('yyyymmddhhnnss', NOW)
                 + '.';
      docPath := docPathBase + docFormat;  // LMS 2013-04-26 New information from VVA group tells us that the actual docFormat is inaccurate and should not be used. It is only temporary and needed during the getDocument call in querying the webservice for the file. We need to use MimeType for the actual format of data in the returned buffer.
      wsSecUser := Piece(FVVASecToken, '^' ,1);
      wsSecPwd := Piece(FVVASecToken, '^' ,2);
      wsSecToken := Piece(FVVASecToken, '^', 3);

      //display informational wait dialog
      ShowDialog(RETRIEVE_DOC_MSG, frmVVAStatus, False);

      // LMS
      //  While the "get document" takes its sweet time on large documents (as much as 4-5 minutes on a good connection)
      //   we get timeouts and RPC Broker session gets closed.
      //  So we are launching the GetDocument in a separate thread.
      //  All other VVA DLL calls are also now wrapped in separate threads.
      //  This allows the Mainform Timer(s) to still going. Also RPC Broker timer(s) can be going as well.
      PreviousTimeoutTimerState := True;
      //PreviousRPCCallinProgressState := false;
      try
        PreviousTimeoutTimerState := frmMain.TimeoutTimer.Enabled;
        //PreviousRPCCallinProgressState := ANURemoteProcedureCallinProgress;
        frmMain.TimeoutTimer.Enabled := True;
        //ANURemoteProcedureCallinProgress] := False; // LMS - False so heartbeat keeps ticking. We leave it alone, if previously it happens to
                                                      //        be true, it will eventually turn false by the code that changed it to true

        PreviousRPCTimeLimit := frmMain.RPCBroker1.RPCTimeLimit;
        frmMain.RPCBroker1.RPCTimeLimit := (PreviousRPCTimeLimit*2000); // LMS arbiterarily high

        FApplicationProxy := TApplicationProxy.create();
        FVVAOpInProcess := True;
        try
          GetDocResult := GetDocument(docID, docSrc, docFormat, docJRO, docPath, FVVAUserID
                                     , FVVAURL, wsSecUser, wsSecPwd, wsSecToken
                                     , FApplicationProxy, FApplicationProxy.ProxyProcessMessagesPointer);
        finally
          FVVAOpInProcess := False;
          FreeAndNil(FApplicationProxy);
          frmMain.RPCBroker1.RPCTimeLimit := PreviousRPCTimeLimit;
        end;

        frmMain.IsRPCBrokerConnected(); // LMS make it reconnect since too much time may have elapsed

        Application.ProcessMessages; // LMS At least in one test a file rename failed.. may be the recent write by the DLL is not finished or the handle is not closed.

        // LMS Additional MimeType is returned as part of result
        GetDocMimeType := Piece(GetDocResult, '^', 2);
        if (GetDocMimeType = 'application/pdf') then begin
          GetDocMimeType := 'PDF';
        end else if (GetDocMimeType = 'image/tiff') then begin
          GetDocMimeType := 'TIFF';
        end;

        docPathFinal := docPathBase + GetDocMimeType;
        GetDocResult := Piece(GetDocResult, '^', 1);
        if (docPath <> docPathFinal) then
          try
            Application.ProcessMessages; // LMS One more time just in case
            RenameFile(docPath, docPathFinal);
          except
            GetDocResult := format('ERROR: Could not rename %s to %s', [docPath, docPathFinal]);
          end;
      finally
        //ANURemoteProcedureCallinProgress := PreviousRPCCallinProgressState;
        frmMain.TimeoutTimer.Enabled := PreviousTimeoutTimerState;
      end;

      if (GetDocResult = 'OK') then
      begin
        //open and display the file in viewer
        if FileExists(docPathFinal) then
           OpenDocs.OpenDocument(docPathFinal);
      end
      else  //error condition
      begin
        frmVVAStatus.Hide;
        frmVVAErrorStatus := TfrmVVAStatus.Create(Self);
        {center the form on main because the Retrieve Documents from VVA form
         is not visible yet}
        frmVVAErrorStatus.Position := poMainFormCenter;
        try
          //display informational wait dialog
          ShowDialog(GetDocResult, frmVVAErrorStatus, True);
        finally
          FreeAndNil(frmVVAErrorStatus);
        end;
      end;
    end;  {authorized for doc retrieval}
  finally
    //re-enable disabled UI controls
    FreeAndNil(frmVVAStatus);
    sgDocList.Enabled := True;
    btnViewSelectedDocument.Enabled := True;
    cbSortColumn.Enabled := True;
    if IsSorted then
      cbSortDirection.Enabled := True
    else
      cbSortDirection.Enabled := False;
  end;
end;

procedure TfrmVVARetrieval.btnCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmVVARetrieval.FormClose(Sender: TObject; var Action: TCloseAction);
////// All this is to be moved into CloseMyDocuments
//var
  //I: Integer;
begin
  (*
  if (OpenDocs.Count > 0) then
  begin
    //Terminate viewer processes to free any file locks
    for I := 0 to OpenDocs.Count - 1 do
    begin
      if (TOpenDoc(OpenDocs[I]).FShellExecInfo.hProcess <> 0) then
      begin
        TerminateProcess(TOpenDoc(OpenDocs[I]).FShellExecInfo.hProcess, 0);
      end else begin
        TOpenDoc(OpenDocs[I]).FindwindowAndClose;
      end;
    end;

    //wait 1 second to allow viewer processes to stop before trying to delete files
    Sleep(1000);

    //Delete temporary files
    for I := 0 to OpenDocs.Count - 1 do
    begin
      if FileExists(TOpenDoc(OpenDocs[I]).FFilePath) then
        DeleteFile(TOpenDoc(OpenDocs[I]).FFilePath);
    end;
  end;  *)
  openDocs.CloseMyDocuments();  // CALL this in FormClose
end;

procedure TfrmVVARetrieval.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := not VVAOpInProcess;
end;

procedure TfrmVVARetrieval.btnViewSelectedDocumentClick(Sender: TObject);
begin
  GetAndViewDocument;
end;

procedure TfrmVVARetrieval.cbSortColumnChange(Sender: TObject);
begin
  if VAUtils.ScreenReaderActive then
    FormatLBResults
  else
    FormatSGResults;

  if IsSorted then
    cbSortDirection.Enabled := True
  else
    cbSortDirection.Enabled := False;
end;

procedure TfrmVVARetrieval.cbSortDirectionChange(Sender: TObject);
begin
  if VAUtils.ScreenReaderActive then
    FormatLBResults
  else
    FormatSGResults;
end;

{===========================================================================
 FormatSGResults
 This procedure populates the string grid with the document list results
 ===========================================================================}
procedure TfrmVVARetrieval.FormatSGResults;
var
  I, aRowNum: Integer;
  aRow: String;
begin
  if (slDocList.Count > 0) then
  begin
    sgDocList.RowCount := (slDocList.Count + 1);
    if IsSorted then  //use sorted list
    begin
      SortList(cbSortColumn.ItemIndex, SortedList, cbSortDirection.Items[cbSortDirection.ItemIndex] = 'Descending');
      for I := 0 to (SortedList.Count - 1) do
      begin
        aRow := String(SortedList.Objects[I]);
        aRowNum := I + 1;  //offset due to header
        PopulateSGRow(aRowNum, aRow);
      end
    end
    else
    begin   //use unsorted list
      for I := 0 to (slDocList.Count - 1) do
      begin
        aRow := slDocList[I];
        aRowNum := I + 1;  //offset due to header
        PopulateSGRow(aRowNum, aRow);
      end;
    end;
    lbDocuments.Visible := False;
    lbDocuments.Enabled := False;
    sgDocList.Visible := True;
    sgDocList.Enabled := True;
    sgDocList.Row := 1;
  end;
end;

{==========================================================================
 PopulateSGRow
 This procedure populates a single string grid row.
 ==========================================================================}
procedure TfrmVVARetrieval.PopulateSGRow(RowNum: Integer; RowData: String);
var
  RestrictedDocType : Integer;
begin
  sgDocList.Cells[0, RowNum] := Piece(RowData, '^', 11); //Doc ID               //JRL 3/1/13
  sgDocList.Cells[1, RowNum] := Piece(RowData, '^', 1);  //Date
  sgDocList.Cells[2, RowNum] := Piece(RowData, '^', 2);  //Type description
  RestrictedDocType := IsRestrictedDoc(RowData);
  if (RestrictedDocType = RESTRICTED_TYPE2TO9) OR 
     (RestrictedDocType = RESTRICTED_TYPE10) OR
     (RestrictedDocType = RESTRICTED_TYPE11) then  //is it restricted?          //JRL 03/21/13 Added type 11
    sgDocList.Cells[3, RowNum] := restrictedSubject
  else
    sgDocList.Cells[3, RowNum] := Piece(RowData, '^', 3); //Subject
  sgDocList.Cells[4, RowNum] := Piece(RowData, '^', 10);  //Document Source
  sgDocList.Cells[5, RowNum] := Piece(RowData, '^', 5);   //DocFormat
end;

{==============================================================================
 FormatLBResults - Section 508 use only
 This procedure formats the header and populates the list box used when
 a screen reader is active.

 The FCharOffset form field provides additional space for the Document Type
 and Subject columns only when the form is enlarged beyond the 125 character
 row capacity.  This field is populated in FormResize.
 ==============================================================================}
procedure TfrmVVARetrieval.FormatLBResults;
var
  headerLine, aRow: String;
  I: Integer;
  lbWidth, oneCharPixelSize : Integer;
begin
  lbDocuments.Clear;
  oneCharPixelSize := lbDocuments.Canvas.TextWidth('A');
  lbWidth := (DocIDColSize + dateColSize + DocTypeColSize + SubjColSize + SrcCommentColSize + DocFrmtColSize) * oneCharPixelSize;
  if lbWidth > lbDocuments.Width then
     lbDocuments.ScrollWidth := lbWidth;
  if (slDocList.Count > 0) then
  begin
    headerLine := dtHdr;
    headerLine := headerLine + StringOfChar(' ', dateColSize - Length(dtHdr)) + docTypeHdr;
    headerLine := headerLine + StringOfChar(' ', DocTypeColSize + FCharOffset - Length(docTypeHdr)) + subHdr;
    headerLine := headerLine + StringOfChar(' ', SubjColSize + FCharOffset - Length(subHdr)) + docIdHdr;
    headerLine := headerLine + StringOfChar(' ', DocIDColSize - Length(docIdHdr)) + srcCommentHdr;
    headerLine := headerLine + StringOfChar(' ', SrcCommentColSize + FCharOffset - Length(srcCommentHdr)) + docFrmtHdr;
    lbDocuments.Items.Add(headerLine);              
                 
    if IsSorted then
    begin
      SortList(cbSortColumn.ItemIndex, SortedList, cbSortDirection.Items[cbSortDirection.ItemIndex] = 'Descending');
      for I := 0 to (SortedList.Count - 1) do
      begin
        aRow := String(SortedList.Objects[I]);
        lbDocuments.Items.Add(FormatLBRow(aRow));
      end;
    end
    else
    begin
      for I := 0 to (slDocList.Count - 1) do
      begin
        aRow := slDocList[I];
        lbDocuments.Items.Add(FormatLBRow(aRow));
      end;
    end;
  end
  else
    lbDocuments.Items.Add('No results received from web service');

  lbDocuments.Visible := True;
  lbDocuments.Enabled := True;
  lbDocuments.ItemIndex := -1;
  sgDocList.Visible := False;
  sgDocList.Enabled := False;
end;

{==========================================================================
 FormatLBRow - Section 508 use only
 This function formats the data of a single row for display in the list box
 used when a screen reader is active.

 The FCharOffset form field provides additional space for the Document Type
 and Subject columns only when the form is enlarged beyond the 125 character
 row capacity.  This field is populated in FormResize.
 ==========================================================================}
function TfrmVVARetrieval.FormatLBRow(aRow: String): String;
var
  aFormattedLine, date, docType, subj, docId, docFrmt, srcComment: String;
  RestrictedDocType : Integer;
begin
  date := Piece(aRow, '^', 1);
  docType := Copy(Piece(aRow, '^', 2), 1, docTypeColSize + FCharOffset - 2);

  RestrictedDocType := IsRestrictedDoc(aRow);
  if (RestrictedDocType = RESTRICTED_TYPE2TO9) OR 
     (RestrictedDocType = RESTRICTED_TYPE10) OR
     (RestrictedDocType = RESTRICTED_TYPE11) then  //is it restricted?          // JRL 03/21/13 Added Type 11
    subj := restrictedSubject
  else
    subj := Copy(Piece(aRow, '^', 3), 1, SubjColSize + FCharOffset - 2);

  if subj = '' then  //populate the field when empty for screen reader
    subj := blankSubject;

  docId := Copy(Piece(aRow, '^', 11), 1, docIdColSize - 2);                     // JRL 3/1/13
  docFrmt := Copy(Piece(aRow, '^', 5), 1, docFrmtColSize - 2);
  srcComment := Copy(Piece(aRow, '^',10), 1, srcCommentColSize - 2);  // source comment
  aFormattedLine := date;
  aFormattedLine := aFormattedLine + StringOfChar(' ', dateColSize - Length(date)) + docType;
  aFormattedLine := aFormattedLine + StringOfChar(' ', DocTypeColSize + FCharOffset - Length(docType)) + Subj;
  aFormattedLine := aFormattedLine + StringOfChar(' ', SubjColSize + FCharOffset - Length(Subj)) + docId;
  aFormattedLine := aFormattedLine + StringOfChar(' ', DocIDColSize - Length(docId)) + srcComment;
  aFormattedLine := aFormattedLine + StringOfChar(' ', srcCommentColSize + FCharOffset - Length(srcComment)) + docFrmt;
  Result := aFormattedLine;           
end;

{============================================================================
 FormatSGDocList
 This procedure sets the cell widths and populates the fixed header rows
 of the results string grid.
   Column 1:  DocID
   Column 2:  Date of Receipt
   Column 3:  Document Type
   Column 4:  Subject
   Column 5:  Source Comment
   Column 6:  Document Format
 ============================================================================}
procedure TfrmVVARetrieval.FormatSGDocList;
var
  I: Integer;
begin
  for I := 0 to sgDocList.ColCount - 1 do
    sgDocList.Cols[I].Clear;
  sgDocList.RowCount := 2;
  sgDocList.FixedRows := 1;
  sgDocList.DefaultColWidth := (sgDocList.Width-25) div 6;
  sgDocList.ScrollBars := ssBoth;
  sgDocList.ColWidths[0] := 85;
  sgDocList.Cells[0, 0] := docIdHdr;
  sgDocList.ColWidths[1] := 77;
  sgDocList.Cells[1, 0] := dtHdr;
  sgDocList.ColWidths[2] := 250;
  sgDocList.Cells[2, 0] := docTypeHdr;
  sgDocList.ColWidths[3] := 250;
  sgDocList.Cells[3, 0] := subHdr;
  sgDocList.ColWidths[4] := 175;
  sgDocList.Cells[4, 0] := srcCommentHdr;
  sgDocList.ColWidths[5] := 75;
  sgDocList.Cells[5, 0] := docFrmtHdr;
end;

{==============================================================================
 lbDocumentsClick
 This event procedure only functions for screen reader users for 508 compliance
 ==============================================================================}
procedure TfrmVVARetrieval.lbDocumentsClick(Sender: TObject);
begin
  if (lbDocuments.ItemIndex > 0) then
    btnViewSelectedDocument.Enabled := True
  else
    btnViewSelectedDocument.Enabled := False;
end;

procedure TfrmVVARetrieval.sgDocListClick(Sender: TObject);
begin
  if (sgDocList.Row > 0) then
    btnViewSelectedDocument.Enabled := True
  else
    btnViewSelectedDocument.Enabled := False;
end;

procedure TfrmVVARetrieval.sgDocListDblClick(Sender: TObject);
begin
  if btnViewSelectedDocument.Enabled then  //force double click to follow button
    btnViewSelectedDocumentClick(Sender);
end;

{============================================================================
 ShowDialog
 This procedure configures the wait/informational dialog and conditionally
 performs a Show or ShowModal.
 ============================================================================}
procedure TfrmVVARetrieval.ShowDialog(aMsg: String; aDialog: TfrmVVAStatus; isModal: Boolean);
begin
  aDialog.edbStatusMessage.Text := aMsg;

  //size the dialog based on text length
  aDialog.Width := aDialog.Canvas.TextWidth(aMsg) + 30;
  aDialog.edbStatusMessage.Width := aDialog.Canvas.TextWidth(aMsg) + 8;
  aDialog.edbStatusMessage.Left := aDialog.Left + 15;
  aDialog.btnOK.Left := (aDialog.Width div 2) - (aDialog.btnOk.Width div 2);

  if isModal then
  begin
    aDialog.btnOK.Visible := True;
    aDialog.ShowModal
  end
  else
  begin
    aDialog.btnOK.Visible := False;
    aDialog.Show;
    aDialog.Repaint;
  end;
end;

{===========================================================================
 SortList
 This procedure sorts the displayed document list based on the selected
 column and sort direction.

 Input Parameter Col remapping:

      Col                                  Piece
      cbSortColumn.ItemIndex               SortCol
      ----------------------------------------------------
         0: None
         1: Document ID                    Piece 11                             // JRL 3/1/13
         2: Date of Receipt                Piece 1
         3: Document Type                  Piece 2
         4: Subject                        Piece 3
         5: Source Comment                 Piece 10
         6: Format                         Piece 5

 ===========================================================================}
procedure TfrmVVARetrieval.SortList(Col: Integer; SortedList: TStringList; Descending: Boolean = False);
var
  I, J: Integer;
  Date: TDateTime;
  YYYYDate: String;
  WorkingSortList: TStringList;
  SortCol : Integer;
const
  DATE_OF_RECEIPT = 'Date of Receipt';
  SUBJECT = 'Subject';
  COL_DATE = 1;         // piece 1
  COL_DOC_TYPE = 2;     // piece 2
  COL_SUBJ = 3;         // piece 3
  COL_DOCID = 11;       // piece 11                                             // JRL 3/1/13
  COL_DOC_FMT = 5;      // piece 5
  COL_SRC_COMMENT = 10; // piece 10
begin
  WorkingSortList := TStringList.Create;
  WorkingSortList.Clear;
  SortedList.Clear;

  // Remap ItemIndex to Piece number
  SortCol := 0;
  case Col of
     // 0 : SortCol := 0; // None
     1 : SortCol := COL_DOCID;
     2 : SortCol := COL_DATE;
     3 : SortCol := COL_DOC_TYPE;
     4 : SortCol := COL_SUBJ;
     5 : SortCol := COL_SRC_COMMENT;
     6 : SortCol := COL_DOC_FMT;
  end;

  try
    for I := 0 to slDocList.Count - 1 do
    begin
      if (cbSortColumn.Items[Col] = DATE_OF_RECEIPT) and
         (Piece(slDocList[I], '^', SortCol) <> '') then
      begin  //convert date to YYYYMMDD before sort on date
        Date := StrToDate(Piece(slDocList[I], '^', SortCol));
        YYYYDate := FormatDateTime('yyyymmdd', Date);
        WorkingSortList.AddObject(YYYYDate, TObject(slDocList[I]));
      end
      else if (cbSortColumn.Items[Col] = SUBJECT) and
              ( 
                (IsRestrictedDoc(slDocList[I]) = RESTRICTED_TYPE2TO9) OR 
                (IsRestrictedDoc(slDocList[I]) = RESTRICTED_TYPE10) OR
                (IsRestrictedDoc(slDocList[I]) = RESTRICTED_TYPE11)             // JRL 03/21/13 Added type 11
              ) then     
      begin  //change restricted doc subject to "Restricted" before subject sort
        WorkingSortList.AddObject(restrictedSubject, TObject(slDocList[I]));
      end
      else   //all other columns sort using value as given
      begin
        WorkingSortList.AddObject(Piece(slDocList[I], '^', SortCol), TObject(slDocList[I]));
      end;
    end;

    //sort it
    WorkingSortList.Sort;

    if Descending then
    begin    //reverse list order when sort direction is descending
      for J := (WorkingSortList.Count - 1) downto 0 do
      begin
        SortedList.AddObject(WorkingSortList[J], WorkingSortList.Objects[J]);
      end;
    end
    else
    begin   //default loads sortedlist in ascending order
      for J := 0 to (WorkingSortList.Count - 1) do
        SortedList.AddObject(WorkingSortList[J], WorkingSortList.Objects[J]);
    end;
  finally
    FreeAndNil(WorkingSortList);
  end;
end;

{============================================================================
 IsRestrictedDoc
 This function evaluates the restricted document flag (rstrcdDcmntInd value)
 and the restricted reason flag (rstrctdReasonLupID) returned from the
 GetDocumentList web service and returns the restriction code category - either
 1 for Not Restricted, 2 for Restricted Reasons 2-9 or 10 for PGF data.
 
 User's with an assigned role of "VA Hospital" are able to view restricted
 documents within the Virtual VA application, except "PGF File".  Users without
 this role will see a message directing them to their IT office for the 
 security key to view restricted documents.   

 JRL 5/20/13 Modify to allow message display for type 10 and type 11 restricted 
 document regardless of the VA Hospital assigned role (as mentioned above)
 =============================================================================}
function TfrmVVARetrieval.IsRestrictedDoc(aDelimitedRecord: String): Integer;
begin
  Result := NOT_RESTRICTED;  
  if (Piece(aDelimitedRecord, '^', 8) = 'Y') then    //restricted document?
  begin
    if (Piece(aDelimitedRecord, '^', 9) = '11') then       //IVM File reason  // JRL 03/21/13 Added type 11
      Result := RESTRICTED_TYPE11
    else if (Piece(aDelimitedRecord, '^', 9) = '10') then  //PGF File reason
      Result := RESTRICTED_TYPE10
    else
      Result := RESTRICTED_TYPE2TO9;
  end;
end;

{=========================================================================
 IsSorted
 This function returns TRUE when a column sort is in effect; Otherwise,
 it returns FALSE
 =========================================================================}
function TfrmVVARetrieval.IsSorted: Boolean;
begin
  if (cbSortColumn.Items[cbSortColumn.ItemIndex] = 'None') or
     (cbSortColumn.Items[cbSortColumn.ItemIndex] = '') then
    Result := False
  else
    Result := True;
end;

end.

