unit frmVlerGetExamDocs;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, VA508AccessibilityManager, VA508AccessibilityRouter,
  Grids, ShellAPI, eCrud, XMLDoc, IdHTTP,
  xmldom, XMLIntf, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  msxmldom;

type

  TfrmVlerRetrievalExamDocs = class(TForm)
    gbPatient: TGroupBox;
    lblPatientName: TLabel;
    lblClaimNum: TLabel;
    lblDOB: TLabel;
    edbPatientName: TEdit;
    edbClaimNum: TEdit;
    edbDOB: TEdit;
    gbSortBy: TGroupBox;
    lblColumn: TLabel;
    lblDirection: TLabel;
    cbSortColumn: TComboBox;
    cbSortDirection: TComboBox;
    strgrdCollectResults: TStringGrid;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    btnClose: TButton;
    btnViewSelectedDocument: TButton;
    XMLDocVLERExamREST: TXMLDocument;
    aIDHTTPVLERExamREST: TIdHTTP;
    lblDocCntMsg: TStaticText;
    VA508CompAccessSgCollResults: TVA508ComponentAccessibility;
    procedure FormShow(Sender: TObject);
    procedure strgrdCollectResultsClick(Sender: TObject);
    procedure strgrdCollectResultsDblClick(Sender: TObject);
    procedure btnViewSelectedDocumentClick(Sender: TObject);
    procedure strgrdCollectResultsSelectCell(Sender: TObject; ACol,
      ARow: Integer; var CanSelect: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cbSortColumnCloseUp(Sender: TObject);
    procedure cbSortDirectionCloseUp(Sender: TObject);
    procedure VA508CompAccessSgCollResultsItemQuery(Sender: TObject;
      var Item: TObject);
    procedure VA508CompAccessSgCollResultsValueQuery(Sender: TObject;
      var Text: string);

  private
    { Private declarations }
//    ExamAttachmentsList: TeCrud;
    GridRowSelected: integer;
    procedure PatientHeader();
    procedure AssignSortColumns();
    procedure SortStringgridAndOrder(Grid: TStringGrid; byColumn: LongInt; ascending: Boolean);
    procedure ExchangeGridRows(Grid: TStringGrid; i, j: Integer);
    procedure QuickSort(Grid: TStringGrid; SortCol: integer; L, R: Integer);
    procedure InvertGrid(Grid: TStringGrid);
  public
    class procedure InitializeExamDocsGridHeader(infrmVlerRtrvExamDocs: TfrmVlerRetrievalExamDocs);
    class procedure FillExamDocsFromResultList(infrmVlerRtrvExamDocs: TfrmVlerRetrievalExamDocs; queryResult: TStringList);
    { Public declaratio ns }
  end;

var
  frmVlerRetrievalExamDocs: TfrmVlerRetrievalExamDocs;
  SelectedX: integer;
  SelectedY: integer;

implementation
uses main, FrmVlerGetExam, UnitDocumentMethods;

{$R *.dfm}

var
//  aAttachNodeList: TList;
//  recExamAttachments: PVLERAttachNodeVal;
  svrHttpECRUD: TeCRUD;
  aOpenDocList: TOpenDocList;

procedure TfrmVlerRetrievalExamDocs.AssignSortColumns;
var
  i: integer;

begin
//  with frmVlerRetrievalExamDocs do
//  begin
  for i := 0 to strgrdCollectResults.ColCount - 1 do
  begin
      //Set  cbSortColumn values
    cbSortColumn.Items.Add(strgrdCollectResults.Cells[i, 0]);
  end;
//  end;

end;

class procedure TfrmVlerRetrievalExamDocs.InitializeExamDocsGridHeader(infrmVlerRtrvExamDocs: TfrmVlerRetrievalExamDocs);
//var
//  frmVlerRtrvExamDocs: TfrmVlerRetrievalExamDocs; // rpk 8/26/2014
begin
  if infrmVlerRtrvExamDocs <> nil then begin
    infrmVlerRtrvExamDocs.strgrdCollectResults.ColCount := 16;
      //Add column names
    infrmVlerRtrvExamDocs.strgrdCollectResults.Cells[0, 0] := 'Pt. First Name';
    infrmVlerRtrvExamDocs.strgrdCollectResults.Cells[1, 0] := 'Pt. Middle Name';
    infrmVlerRtrvExamDocs.strgrdCollectResults.Cells[2, 0] := 'Pt. Last Name';
    infrmVlerRtrvExamDocs.strgrdCollectResults.Cells[3, 0] := 'Pt. DOB';
    infrmVlerRtrvExamDocs.strgrdCollectResults.Cells[4, 0] := 'Pt. SSN';
    infrmVlerRtrvExamDocs.strgrdCollectResults.Cells[5, 0] := 'Document ID (UUID)';
    infrmVlerRtrvExamDocs.strgrdCollectResults.Cells[6, 0] := 'Exam ID';
    infrmVlerRtrvExamDocs.strgrdCollectResults.Cells[7, 0] := 'DBQ Document Type';
    infrmVlerRtrvExamDocs.strgrdCollectResults.Cells[8, 0] := 'Creation Date';
    infrmVlerRtrvExamDocs.strgrdCollectResults.Cells[9, 0] := 'Status Date';
    infrmVlerRtrvExamDocs.strgrdCollectResults.Cells[10, 0] := 'VA Facility Information';
    infrmVlerRtrvExamDocs.strgrdCollectResults.Cells[11, 0] := 'Phys. First Name';
    infrmVlerRtrvExamDocs.strgrdCollectResults.Cells[12, 0] := 'Phys. Middle Name';
    infrmVlerRtrvExamDocs.strgrdCollectResults.Cells[13, 0] := 'Phys. Last Name';
    infrmVlerRtrvExamDocs.strgrdCollectResults.Cells[14, 0] := 'Status of Exam';
    infrmVlerRtrvExamDocs.strgrdCollectResults.Cells[15, 0] := 'Attachment ID';
      // setup custom column widths
    infrmVlerRtrvExamDocs.strgrdCollectResults.ColWidths[0] := 140; // Pt. First Name
    infrmVlerRtrvExamDocs.strgrdCollectResults.ColWidths[1] := 140; // Pt. Middle Name
    infrmVlerRtrvExamDocs.strgrdCollectResults.ColWidths[2] := 150; // Pt. Last Name
    infrmVlerRtrvExamDocs.strgrdCollectResults.ColWidths[3] := 77; // Pt. DOB
    infrmVlerRtrvExamDocs.strgrdCollectResults.ColWidths[4] := 100; // Pt. SSN
    infrmVlerRtrvExamDocs.strgrdCollectResults.ColWidths[5] := 300; // Document ID
    infrmVlerRtrvExamDocs.strgrdCollectResults.ColWidths[6] := 120; // Exam ID
    infrmVlerRtrvExamDocs.strgrdCollectResults.ColWidths[7] := 300; // DBQ Document Type
    infrmVlerRtrvExamDocs.strgrdCollectResults.ColWidths[8] := 145; // Creation Date
    infrmVlerRtrvExamDocs.strgrdCollectResults.ColWidths[9] := 145; // Status Date
    infrmVlerRtrvExamDocs.strgrdCollectResults.ColWidths[10] := 180; // VA Facility Information
    infrmVlerRtrvExamDocs.strgrdCollectResults.ColWidths[11] := 140; // Phys. First Name
    infrmVlerRtrvExamDocs.strgrdCollectResults.ColWidths[12] := 140; // Phys. Middle Name
    infrmVlerRtrvExamDocs.strgrdCollectResults.ColWidths[13] := 150; // Phys. Last Name
    infrmVlerRtrvExamDocs.strgrdCollectResults.ColWidths[14] := 120; // Status of Exam
  end;

     (*  Defined for future use
      frmVlerRtrvExamDocs.strgrdCollectResults.Cells[12,0]:='Claim ID';
      frmVlerRtrvExamDocs.strgrdCollectResults.Cells[14,0]:='File Control ID';
      frmVlerRtrvExamDocs.strgrdCollectResults.Cells[15,0]:='DBQ Document Type';
       *)
end; // InitializeExamDocsGridHeader

class procedure TfrmVlerRetrievalExamDocs.FillExamDocsFromResultList(infrmVlerRtrvExamDocs: TfrmVlerRetrievalExamDocs; queryResult: TStringList);
var
  i: Integer;
begin
  if infrmVlerRtrvExamDocs <> nil then begin
    infrmVlerRtrvExamDocs.strgrdCollectResults.RowCount := infrmVlerRtrvExamDocs.strgrdCollectResults.RowCount + queryResult.Count;
    for i := 0 to queryResult.Count - 1 do
    begin
      infrmVlerRtrvExamDocs.strgrdCollectResults.Rows[i + 1].Delimiter := ',';
      infrmVlerRtrvExamDocs.strgrdCollectResults.Rows[i + 1].CommaText := queryResult.Strings[i];
    end;
    infrmVlerRtrvExamDocs.strgrdCollectResults.ColCount := (infrmVlerRtrvExamDocs.strgrdCollectResults.ColCount - 1);
    infrmVlerRtrvExamDocs.lblDocCntMsg.Caption := infrmVlerRtrvExamDocs.lblDocCntMsg.Caption + IntToStr((queryResult.Count)) + ' Documents';
    infrmVlerRtrvExamDocs.strgrdCollectResults.RowCount := infrmVlerRtrvExamDocs.strgrdCollectResults.RowCount - 1;
  end;
end;

procedure TfrmVlerRetrievalExamDocs.btnViewSelectedDocumentClick(Sender: TObject);
var
  I: Integer;
//  svrHttpECRUD: TeCRUD;
  recExamAttachments: PVLERAttachNodeVal;
  //OpenBinaryAttachments: TOpenDocList;
  ncBinaryDescTxt,
    ncBinaryFormatStndrdName,
    ncBinaryLocURI,
    ncBinarySzValue,
    ncBinaryCtgryTxt,
    FileNM: string;
  strSQLAttachment: string;
begin
// this will open all attachments associated with selected record

   //Search TList to find DocumentFileControlID from strgrdCollectResults
 // VLERAttachNodeList.First;

 //Show column containing File Attachment id
//  frmVlerRetrievalExamDocs.strgrdCollectResults.ColCount :=
//    (frmVlerRetrievalExamDocs.strgrdCollectResults.ColCount + 1);
  strgrdCollectResults.ColCount := strgrdCollectResults.ColCount + 1;

//  svrHttpECRUD := TeCRUD.Create(self, frmMain.RPCBroker1); // IdHTTPVLERExamRESTful,XMLDocumentVLERExamRESTful);  // TODO
//  try
//  svrHttpECRUD.setOpenDocumentList(aOpenDocList);
//    for I := 0 to (frmVlerGetExams.aAttachNodeList.Count - 1) do
  if Assigned(aAttachNodeList) then begin
    for I := 0 to (aAttachNodeList.Count - 1) do
    begin
//      recExamAttachments := frmVlerGetExams.aAttachNodeList.Items[I];
      recExamAttachments := aAttachNodeList.Items[I];
      if Trim(recExamAttachments.strncDocumentFileControlID) =
        Trim(strgrdCollectResults.Cells[15, GridRowSelected]) then
      begin
        //Prepare to get attachments from "fs" collection
        ncBinaryDescTxt := recExamAttachments.strncBinaryDescriptionText;
        ncBinaryFormatStndrdName := recExamAttachments.strncBinaryFormatStandardName;
        ncBinaryLocURI := recExamAttachments.strncBinaryLocationURI;
        ncBinarySzValue := recExamAttachments.strncBinarySizeValue;
        ncBinaryCtgryTxt := recExamAttachments.strncBinaryCategoryText;

        //set file name
        //FileNM:= ncBinaryDescTxt + ncBinaryCtgryTxt + ncBinaryLocURI;
         //FileNM:=  Trim(ncBinaryDescTxt)+FormatDateTime('mmddyyyyhhmmss',now);


        //***Prepare HTTP Server Seetings***//
        //*** RESTful call to VLER eCRUD***//
        //Create TeCrud object. This object sets URL, Query and issues RESTful GET

  //svrHttpECRUD:=TeCRUD.Create(self, frmMain.RPCBroker1 ); // IdHTTPVLERExamRESTful,XMLDocumentVLERExamRESTful);  // TODO
  //svrHttpECRUD.XMLDocument := XMLDocumentVLERExamRESTful;


        svrHttpECRUD.XMLDocument := XMLDocVLERExamREST; // XMLDocumentVLERExamRESTful;


        //svrHttpECRUD:=TeCRUD.Create(aIDHTTPVLERExamREST,XMLDocVLERExamREST);
        //svrHttpECRUD.VlerDasToken:='XUSBSE958-470149_6^500^9560';
        {
  svrHttpECRUD.HTTPAcceptHeaderXML:=ncBinaryFormatStndrdName;
        svrHttpECRUD.HTTPContentType:= ncBinaryFormatStndrdName;
        svrHttpECRUD.HTTPContentEncoding:= 'utf-8';
        svrHttpECRUD.Host:='bhietestsapp4.vaco.domain';
        svrHttpECRUD.Port:='';  //must prefix port with ':' if Port is assigned
        }

        svrHttpECRUD.eCRUDVersion := 'v1';
        svrHttpECRUD.dbName := 'core';
        svrHttpECRUD.collectionName := 'fs';
        svrHttpECRUD.maxRecords := '';
        svrHttpECRUD.SpecifyResponseFields := '';
        svrHttpECRUD.Sort := '';


        svrHttpECRUD.getExamAttachments(ncBinaryLocURI, strSQLAttachment);


       //Call OpenDocumentFromXMLNode()
       //Paramters: ancBinaryLocationURI:String; aFilename: String; aFileType: String
       //Procedure will execute RESTFUL qry to obtain binary attachment, Save to a file and open and clear up
       //memory of open files
        svrHttpECRUD.OpenDocumentFromXMLNode(ncBinaryLocURI, FileNM, ncBinaryFormatStndrdName,
          strSQLAttachment, StrToInt(ncBinarySzValue));
      end;

    end;
     //hide column containing File Attachment id
//    frmVlerRetrievalExamDocs.strgrdCollectResults.ColCount :=
//      (frmVlerRetrievalExamDocs.strgrdCollectResults.ColCount - 1);
  end;

  strgrdCollectResults.ColCount := strgrdCollectResults.ColCount - 1;
//  finally
//    svrHttpECRUD.Free;
//  end;

end;

procedure TfrmVlerRetrievalExamDocs.cbSortColumnCloseUp(Sender: TObject);
var
  SortColIndx: integer;
  SortAscending: Boolean;
begin
  if (cbSortColumn.ItemIndex - 1) < 0 then
    SortColIndx := 0
  else
    SortColIndx := (cbSortColumn.ItemIndex - 1);

  if cbSortDirection.ItemIndex = 0 then
    SortAscending := True
  else
    SortAscending := False;

 //Enable for sort column containing File Attachment id
//  frmVlerRetrievalExamDocs.strgrdCollectResults.ColCount :=
//    (frmVlerRetrievalExamDocs.strgrdCollectResults.ColCount + 1);
  strgrdCollectResults.ColCount := strgrdCollectResults.ColCount + 1;

 //Sort the Grid
//  SortStringgridAndOrder(frmVlerRetrievalExamDocs.strgrdCollectResults, SortColIndx, SortAscending);
  SortStringgridAndOrder(strgrdCollectResults, SortColIndx, SortAscending);

 //hide metadata column containing File Attachment id
//  frmVlerRetrievalExamDocs.strgrdCollectResults.ColCount :=
//    (frmVlerRetrievalExamDocs.strgrdCollectResults.ColCount - 1);
  strgrdCollectResults.ColCount := strgrdCollectResults.ColCount - 1;

end;

procedure TfrmVlerRetrievalExamDocs.cbSortDirectionCloseUp(Sender: TObject);
begin
  cbSortColumnCloseUp(Sender);
end;

procedure TfrmVlerRetrievalExamDocs.FormClose(Sender: TObject;
  var Action: TCloseAction);
var
  I: Integer;
begin
//  ExamAttachmentsList.CloseOpenAttachments;
  try
    if Assigned(svrHttpECRUD) then
      svrHttpECRUD.CloseOpenAttachments;
    for I := 0 to aOpenDocList.Count - 1 do
      TOpenDoc(aOpenDocList[i]).Free;
  finally
    FreeAndNil(aOpenDocList);
  end;
end;

procedure TfrmVlerRetrievalExamDocs.FormShow(Sender: TObject);
begin
  //Refresh Patient Header Info
  PatientHeader();
  //Set sort columns
  AssignSortColumns();

  //Get reference to Exam Attachment List
//  aAttachNodeList := TList.create; //Destroy at close of form. Must be persistant
//  ExamAttachmentsList.getExamAttachmentList(aAttachNodeList, recExamAttachments);
//    aAttachNodeList := ExamAttachmentsList.getExamAttachmentList;
  aOpenDocList := TOpenDocList.Create;
  svrHttpECRUD := TeCRUD.Create(self, frmMain.RPCBroker1); // IdHTTPVLERExamRESTful,XMLDocumentVLERExamRESTful);  // TODO
//  try
  if Assigned(svrHttpECRUD) then
    svrHttpECRUD.setOpenDocumentList(aOpenDocList);
end;


procedure TfrmVlerRetrievalExamDocs.PatientHeader;
var
  PatientFnm, PatientMnm, PatientLnm: string;
//  concatName: string;
begin
//  with frmVlerRetrievalExamDocs do
//  begin
  if strgrdCollectResults.Row <> 0 then
  begin
      //Set  edbPatientName
    PatientFnm := strgrdCollectResults.Cells[0, strgrdCollectResults.Row];
    PatientMnm := strgrdCollectResults.Cells[1, strgrdCollectResults.Row];
    PatientLnm := strgrdCollectResults.Cells[2, strgrdCollectResults.Row];
    edbPatientName.Text := PatientFnm + ' ' + PatientMnm + ' ' + PatientLnm;

      //Patient ClaimID
    edbClaimNum.Text := strgrdCollectResults.Cells[4, strgrdCollectResults.Row];

      //Patient DOB
    edbDOB.Text := strgrdCollectResults.Cells[3, strgrdCollectResults.Row];
  end;
//  end;
end;

procedure TfrmVlerRetrievalExamDocs.strgrdCollectResultsClick(Sender: TObject);
begin
//Refresh Patient Header Info
  PatientHeader();
end;

procedure TfrmVlerRetrievalExamDocs.strgrdCollectResultsDblClick(
  Sender: TObject);
begin
//Open Attachment(S)
  btnViewSelectedDocumentClick(Sender);
//Refresh Patient Header Info
  PatientHeader();
end;

procedure TfrmVlerRetrievalExamDocs.strgrdCollectResultsSelectCell(
  Sender: TObject; ACol, ARow: Integer; var CanSelect: Boolean);
begin
  GridRowSelected := ARow;
  SelectedX := ACol;
  SelectedY := ARow;
end;

procedure TfrmVlerRetrievalExamDocs.VA508CompAccessSgCollResultsItemQuery(
  Sender: TObject; var Item: TObject);
var
  i, j: Integer;
begin
  j := Integer(Item);
  i := (100 * SelectedY) + SelectedX;
  if i <> j then begin
    j := i;
    Item := TObject(j);
  end;
end;

procedure TfrmVlerRetrievalExamDocs.VA508CompAccessSgCollResultsValueQuery(
  Sender: TObject; var Text: string);
var
//  Index: Integer;
  sg: TStringGrid;
  ca: TVA508ComponentAccessibility;
  PatientFnm, PatientMnm, PatientLnm: string;
begin
//  Text := '';
//  Index := SelectedY - 1;

  ca := TVA508ComponentAccessibility(Sender); // rpk 9/21/2011
  sg := TStringGrid(ca.component); // rpk 9/21/2011

  if strgrdCollectResults.Row <> 0 then
  begin
    //Set  edbPatientName
    PatientFnm := strgrdCollectResults.Cells[0, SelectedY];
    PatientMnm := strgrdCollectResults.Cells[1, SelectedY];
    PatientLnm := strgrdCollectResults.Cells[2, SelectedY];
    edbPatientName.Text := PatientFnm + ' ' + PatientMnm + ' ' + PatientLnm;
//  Text := Text + ' Patient ' + sg.Cells[0, SelectedY] + ' ' + // rpk 9/16/2011
//    'Column ' + sg.Cells[SelectedX, 0] + ', ' + // rpk 9/16/2011
//    sg.Cells[SelectedX, SelectedY]; // rpk 9/16/2011
    Text := ' Patient ' + edbPatientName.Text + ' ' + // rpk 9/16/2011
      'Column ' + sg.Cells[SelectedX, 0] + ', ' + // rpk 9/16/2011
    sg.Cells[SelectedX, SelectedY]; // rpk 9/16/2011
  end;

end;

{************** SortGrid *************}

procedure TfrmVlerRetrievalExamDocs.SortStringgridAndOrder(Grid: TStringGrid; byColumn: Integer; ascending: Boolean);
begin
  Screen.Cursor := crHourglass;
  Grid.Perform(WM_SETREDRAW, 0, 0);
  try
    QuickSort(Grid, byColumn, Grid.FixedRows, Grid.Rowcount - 1);
    if not ascending then
      InvertGrid(Grid);
  finally
    Grid.Perform(WM_SETREDRAW, 1, 0);
    Grid.Refresh;
    Screen.Cursor := crDefault;
  end;
end;

procedure TfrmVlerRetrievalExamDocs.ExchangeGridRows(Grid: TStringGrid; i, j: Integer);
var
  k: Integer;
begin
  with Grid do
    for k := 0 to ColCount - 1 do
      Cols[k].Exchange(i, j);
end;

procedure TfrmVlerRetrievalExamDocs.QuickSort(Grid: TStringGrid; SortCol: integer; L, R: Integer);
var
  I, J: Integer;
  P: string;
begin
  repeat
    I := L;
    J := R;
    P := Grid.Cells[SortCol, (L + R) shr 1];
    repeat
      while CompareStr(Grid.Cells[SortCol, I], P) < 0 do Inc(I);
      while CompareStr(Grid.Cells[SortCol, J], P) > 0 do Dec(J);
      if I <= J then
      begin
        if I <> J then
          ExchangeGridRows(Grid, I, J);
        Inc(I);
        Dec(J);
      end;
    until I > J;
    if L < J then QuickSort(Grid, SortCol, L, J);
    L := I;
  until I >= R;
end;

procedure TfrmVlerRetrievalExamDocs.InvertGrid(Grid: TStringGrid);
var
  i, j: Integer;
begin
  i := Grid.Fixedrows;
  j := Grid.Rowcount - 1;
  while i < j do
  begin
    ExchangeGridRows(Grid, I, J);
    Inc(i);
    Dec(j);
  end; { While }
end;

initialization
SpecifyFormIsNotADialog(TfrmVlerRetrievalExamDocs);

end.

