unit graphvs;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  DialogsCAPRI,
  Dialogs,
  TeEngine,
  Series,
  TeeProcs,
  Chart,
  StdCtrls,
  ExtCtrls,
  ComCtrls,
  ORCtrls,
  VitalsData;

type
  TformGraphVS = class(TForm)
    Panel1: TPanel;
    checkboxValues: TCheckBox;
    checkboxZoom: TCheckBox;
    Button1: TButton;
    chartVS: TChart;
    Series1: TLineSeries;
    Series2: TLineSeries;
    Panel2: TPanel;
    listboxVS: TORListBox;
    Splitter1: TSplitter;
    CCOWTimer: TTimer;
    procedure listboxVSChange(Sender: TObject);
    procedure checkboxValuesClick(Sender: TObject);
    procedure checkboxZoomClick(Sender: TObject);
    procedure Series1GetMarkText(Sender: TChartSeries; ValueIndex: Longint; var MarkText: string);
    procedure Series2GetMarkText(Sender: TChartSeries; ValueIndex: Longint; var MarkText: string);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure CCOWTimerTimer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formGraphVS: TformGraphVS;
  VitalsData: TVitalsData; // -MER CodeCR128 3/2011

implementation

uses main;

{$R *.DFM}

procedure TformGraphVS.listboxVSChange(Sender: TObject);
var
  x: integer;
  line, line2, lastdt, lastTime: string;

  function getvalue(line2: string): string;
  var
    tempstring: string;
    x: integer;
    addflag: boolean;
  begin
    // This function removes the type of vitals indicator
    // It also removes the other stuff at the end of the line like
    // "F" for Farenheit, "*," etc.
    // The only items in the returned strings will be a number, a period
    // or a slash used in blood pressure

    //First remove the header
    TempString := '';
    Addflag := true;

    if pos(':', line2) > 0 then
      line2 := Copy(line2, pos(':', line2) + 2, 999);
    line2 := frmMain.removespaces(line2);
    if Line2 <> '' then
      for x := 1 to length(line2) do
        if (line2[x] = '0') or
          (line2[x] = '1') or
          (line2[x] = '2') or
          (line2[x] = '3') or
          (line2[x] = '4') or
          (line2[x] = '5') or
          (line2[x] = '6') or
          (line2[x] = '7') or
          (line2[x] = '8') or
          (line2[x] = '9') or
          (line2[x] = '.') or
          (line2[x] = '/') then begin
          if addflag = true then
            tempstring := tempstring + line2[x]
        end
        else
          addflag := false;
    result := TempString;
  end;

begin
  if listboxVS.itemindex = -1 then
    exit;
  ChartVS.Title.Text.Clear;
  ChartVS.Title.Text.Add('Vitals/Measurements Report');
  ChartVS.Title.Text.Add(frmMain.Piece(listboxVS.Items[listboxVS.itemindex], '^', 1));

  CheckBoxValues.Checked := false;
  CheckBoxZoom.Checked := false;
  CheckBoxValuesClick(Application);
  CheckBoxZoomClick(Application);

  ChartVS.Series[0].Clear;
  ChartVS.Series[1].Clear;
  ChartVS.Series[2].Clear; // -MER series[2] doesn't seem to be used elsewhere
  VitalsData.Clear;  // -MER CodeCR128 3/2011
  VitalsData.IsDualSeries := FALSE; // -MER CodeCR128 3/2011
  ChartVS.Series[0].Title := frmMain.Piece(listboxVS.Items[listboxVS.itemindex], '^', 1);
  ChartVS.Series[1].Title := '';
  ChartVS.Series[1].ShowInLegend := False;
  if ChartVS.Series[0].Title = 'BLOOD PRESSURE' then begin
    ChartVS.Series[0].Title := 'SYSTOLIC';
    ChartVS.Series[1].Title := 'DIASTOLIC';
    ChartVS.Series[1].ShowInLegend := True;
  end;

  lastdt := '';
  lastTime := ''; // -MER CodeCR128 3/2011
  for x := 0 to frmMain.MemoDocs.lines.count - 1 do begin
    line := frmMain.MemoDocs.lines[x];
    if (pos(':', line) > 3) and (length(line) > 4) then begin
      // Found a vital type?
      // Check to be sure 4 spaces and then a character.  If so, it's a line with a vital
      if (line[1] = ' ') and (line[2] = ' ') and (line[3] = ' ') and (line[4] = ' ') and (line[5] <> ' ') then begin
        line := frmMain.removespaces(line);
        line2 := line;
        line := Copy(line, 1, pos(':', line) - 1);
        if uppercase(Line) = uppercase(frmMain.Piece(listboxVS.Items[listboxVS.ItemIndex], '^', 2)) then begin
          line2 := GetValue(line2);
          if pos('/', line2) > 0 then begin
            // -MER CodeCR128 3/2011
            VitalsData.IsDualSeries := TRUE;
            VitalsData.AddPoint(lastdt, lastTime, frmMain.piece(line2, '/', 1), frmMain.piece(line2, '/', 2));
          end
          else begin
            if line2 <> '' then begin
              VitalsData.AddPoint(lastdt, lastTime, line2, '-1'); // -MER CodeCR128 3/2011
            end;
          end;
        end;
      end;
    end;
    line := frmMain.MemoDocs.lines[x];
    if (length(line) > 6) then begin
      if (line[3] = '/') and (line[6] = '/') and (length(line) < 11) then begin
        lastdt := line;
      end;
    end else if (length(line) = 5) and (line[3] = ':') then begin
      lastTime := line;
    end;
  end;
  VitalsData.LoadPointsToChart(chartvs); // -MER CodeCR128 3/2011
end;

procedure TformGraphVS.checkboxValuesClick(Sender: TObject);
begin
  if CheckBoxValues.Checked = True then begin
    chartVS.SeriesList[0].Marks.Visible := True;
    chartVS.SeriesList[1].Marks.Visible := True;
  end
  else begin
    chartVS.SeriesList[0].Marks.Visible := False;
    chartVS.SeriesList[1].Marks.Visible := False;
  end;
  Series1.OnGetMarkText := Series1GetMarkText;
  Series2.OnGetMarkText := Series2GetMarkText;
end;

procedure TformGraphVS.checkboxZoomClick(Sender: TObject);
begin
  if checkboxZoom.Checked = True then begin
    chartVS.AllowZoom := True;
  end
  else begin
    chartVS.BottomAxis.Automatic := True;
    chartVS.LeftAxis.Automatic := True;
    chartVS.AllowZoom := False;
  end;
end;

procedure TformGraphVS.Series1GetMarkText(Sender: TChartSeries; ValueIndex: Longint; var MarkText: string);
begin
  MarkText := VitalsData.GetMarkText(ValueIndex, 1); // -MER CodeCR128 3/2011
end;

procedure TformGraphVS.Series2GetMarkText(Sender: TChartSeries; ValueIndex: Longint; var MarkText: string);
begin
  MarkText := VitalsData.GetMarkText(ValueIndex, 2); // -MER CodeCR128 3/2011
end;

procedure TformGraphVS.FormCreate(Sender: TObject);
begin
  VitalsData := TVitalsData.Create; // -MER CodeCR128 3/2011
end;

procedure TformGraphVS.FormDestroy(Sender: TObject);
begin
  VitalsData.Free; // -MER CodeCR128 3/2011
end;

procedure TformGraphVS.Button1Click(Sender: TObject);
begin
  ChartVS.CopyToClipBoardBitmap;
end;

procedure TformGraphVS.CCOWTimerTimer(Sender: TObject);
begin
  if ShutdownCAPRIModalDialogs = true then begin
    CCOWTimer.Enabled := False;
    formGraphVS.Visible := False;
    ContextorChangeMessage := '';
    ModalResult := mrCancel;
  end;
end;

procedure TformGraphVS.FormActivate(Sender: TObject);
begin
  CCOWTimer.Enabled := True;
end;

end.
