unit managereports;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ExtCtrls,
  StdCtrls,
  Fmcntrls,
  Diaccess,
  Fmcmpnts,
  Main,
  CAPRISupport,
  Trpcb,
  DialogsCAPRI,
  ORCtrls,
  ORDtTm,
  Buttons,
  ToolWin,
  ComCtrls,
  RichButton,
  ColorGrd,
  Menus,
  CCOWRPCBrokerCAPRI, ActnPopup;

type
  TfrmManageReports = class(TForm)
    GroupBox1: TGroupBox;
    FMExamRequestListbox: TFMListBox;
    ExamRequestRefresh: TButton;
    GroupBoxExams: TGroupBox;
    buttonReopen: TButton;
    buttonRelease: TButton;
    Shape1: TShape;
    Shape2: TShape;
    GroupBoxReportText: TGroupBox;
    ButtonSaveChanges: TButton;
    PanelRequestDate: TPanel;
    FMExamRequestLister1: TFMLister;
    FMListerExamsRequested: TFMLister;
    lstExamsRequested: TORListBox;
    FMGetsExamDetails: TFMGets;
    FMCommentsMemoRTF: TFMMemo;
    PanelSelectedExam: TPanel;
    ButtonEditSelectedExam: TButton;
    ORDateCombo1: TORDateCombo;
    Label12: TLabel;
    Label5: TLabel;
    FMExProvider: TFMEdit;
    ComboBoxExamLocation: TComboBox;
    Label7: TLabel;
    FMEditRequestStatus: TFMEdit;
    FMCommentsMemo: TFMMemo;
    ToolBar1: TToolBar;
    SpeedButtonFontSmaller: TSpeedButton;
    SpeedButtonUnderline: TSpeedButton;
    SpeedButtonItalic: TSpeedButton;
    SpeedButtonBold: TSpeedButton;
    SpeedButtonFontBigger: TSpeedButton;
    SpeedButtonColor: TSpeedButton;
    RichEditExamReport: TRichEdit;
    PanelColor: TPanel;
    ColorGrid1: TColorGrid;
    Label1: TLabel;
    ComboBoxExamStatus: TComboBox;
    LabelOpenExams: TLabel;
    mnuPopEdit: TPopupActionBar;
    mnuPopEditUndo: TMenuItem;
    mnuPopEditN1: TMenuItem;
    mnuPopEditCut: TMenuItem;
    mnuPopEditCopy: TMenuItem;
    mnuPopEditPaste: TMenuItem;
    mnuPopEditDelete: TMenuItem;
    mnuPopEditSelectAll: TMenuItem;
    mnuPopEditN2: TMenuItem;
    mnuPopEditCheckSpelling: TMenuItem;
    procedure ExamRequestRefreshClick(Sender: TObject);
    procedure FMExamRequestListboxClick(Sender: TObject);
    procedure lstExamsRequestedChange(Sender: TObject);
    procedure ButtonEditSelectedExamClick(Sender: TObject);
    procedure buttonReleaseClick(Sender: TObject);
    procedure buttonReopenClick(Sender: TObject);
    procedure ButtonSaveChangesClick(Sender: TObject);
    procedure SpeedButtonColorClick(Sender: TObject);
    procedure RichEditExamReportKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SpeedButtonBoldClick(Sender: TObject);
    procedure SpeedButtonItalicClick(Sender: TObject);
    procedure SpeedButtonUnderlineClick(Sender: TObject);
    procedure RichEditExamReportSelectionChange(Sender: TObject);
    procedure SpeedButtonFontBiggerClick(Sender: TObject);
    procedure SpeedButtonFontSmallerClick(Sender: TObject);
    procedure ColorGrid1Change(Sender: TObject);
    procedure ColorGrid1Click(Sender: TObject);
    procedure ComboBoxExamStatusChange(Sender: TObject);
    procedure Undo1Click(Sender: TObject);
    procedure mnuPopEditUndoClick(Sender: TObject);
    procedure mnuPopEditCutClick(Sender: TObject);
    procedure mnuPopEditCopyClick(Sender: TObject);
    procedure mnuPopEditPasteClick(Sender: TObject);
    procedure mnuPopEditDeleteClick(Sender: TObject);
    procedure mnuPopEditSelectAllClick(Sender: TObject);
    procedure mnuPopEditCheckSpellingClick(Sender: TObject);
  private
    { Private declarations }
    procedure FormatCancelNotice(ExamName: String; OpenCount: Integer);  //CodeCR266 - rpm 4/4/12
  public
    { Public declarations }
  end;

var
  frmManageReports: TfrmManageReports;
  donebold, doneitalic, doneunderline: boolean;
implementation

{$R *.DFM}

  // CodeCR319 - jrl, 3/23/12.  Changed RichEditExamReport.MaxLength to
  // the maximum of $7FFFFFFD to allow for the large sizes of templates now
  // being combined.

procedure TfrmManageReports.ExamRequestRefreshClick(Sender: TObject);
var
  x: integer;
  date1, date2, date3: string;
  tempString: string;
begin
  inherited;
  //ButtonClearAll.Enabled:=False;
  ComboBoxExamStatus.Enabled := False;
  ComboBoxExamLocation.Enabled := False;
  ORDateCombo1.Enabled := False;
  FMExProvider.Enabled := False;
  FMCommentsMemo.ReadOnly := True;
  FMCommentsMemo.Lines.Clear;
  ComboBoxExamLocation.ItemIndex := -1;
  ComboBoxExamStatus.ItemIndex := -1;
  ORDateCombo1.FMDate := 0;
  FMExProvider.Text := '';

  buttonEditSelectedExam.Enabled := False;
  shape2.brush.color := clSilver;
  ButtonSaveChanges.Enabled := False;
  ButtonReopen.Enabled := False;
  ButtonRelease.Enabled := False;
  FMCommentsMemo.Lines.Clear;
  lstExamsRequested.Items.Clear;
  PanelRequestDate.Caption := '';
  PanelSelectedExam.Caption := '';
  FMCommentsMemo.ReadOnly := True;

  FMExamRequestListBox.Items.Clear;
  FMExamRequestLister1.PartList.Clear;
  FMExamRequestLister1.PartList.Add(PatientIEN);
  //CodeCR193 - rpm 11/2/11 - only sreturn records with no CANCELLATION DATE
  FMExamRequestLister1.Screen := 'I $P(^(0),U,19)=""';
  FMExamRequestListbox.GetList;
  // Make sure data is correct for PatientIEN
  if FMExamRequestListbox.Items.Count > 0 then
    for x := FMExamRequestListbox.Items.Count - 1 downto 0 do begin
      if Pos(PatientIEN + '  ', FMExamRequestListbox.Items[x]) <> 1 then
        FMExamRequestListbox.Items.Delete(x);
    end;
  // Reformat data
  if FMExamRequestListbox.Items.Count > 0 then
    for x := 0 to FMExamRequestListbox.Items.Count - 1 do begin
      FMExamRequestListbox.Items[x] := Copy(FMExamRequestListbox.Items[x], Pos('  ', FMExamRequestListbox.Items[x]) + 4, 255); // Strip patient IEN;
      Date1 := Copy(FMExamRequestListbox.Items[x], 1, Pos('  ', FMExamRequestListbox.Items[x]) - 1);
      FMExamRequestListbox.Items[x] := Copy(FMExamRequestListbox.Items[x], Pos('  ', FMExamRequestListbox.Items[x]) + 4, 500);
      Date2 := Copy(FMExamRequestListbox.Items[x], 1, Pos('  ', FMExamRequestListbox.Items[x]) - 1);
      FMExamRequestListbox.Items[x] := Copy(FMExamRequestListbox.Items[x], Pos('  ', FMExamRequestListbox.Items[x]) + 4, 500);
      Date3 := Copy(FMExamRequestListbox.Items[x], 1, 254);

      tempstring := FMDateTimeConvert(Date1);
      tempstring := Copy(tempstring + '                   ', 1, 19);

      if Date3 <> '' then
        tempstring := tempstring + ' [CANCELED]'
      else
        if Date2 <> '' then
          tempstring := tempstring + ' [RELEASED]'
        else
          if Date2 = '' then
            tempstring := tempstring + ' [OPEN]';

      FMExamRequestListbox.Items[x] := tempstring;
    end;
  exit;
  (*
    If ANURemoteProcedureCallInProgress=True then exit;

    ListBoxIPR1.Items.Clear;
    ButtonIPRCopy.Enabled:=False;
    ButtonIPRDelete.Enabled:=False;
    ButtonIPRCopy.Enabled:=False;
    ButtonIPRDisplay.Enabled:=False;
    FMListerIPR1.PartList.Clear;
    FMListerIPR2.PartList.Clear;
    FMListerIPR1.PartList.Add(PatientIEN);
    FMListerIPR2.PartList.Add(PatientName);
    ListPoint:=ListBoxIPR1.ItemIndex;
    //try FMListerIPR1.GetList(nil) except end;
    try FMListBoxIPR1.GetList except end;
    If ANURemoteProcedureCallInProgress=True then exit;
    try FMListBoxIPR2.GetList except end;
    FMListerIPR2.ListerFlags:=[];
    try FMListBoxIPR2.GetList except end;
      // Make sure only the patient we want is in the list
      // Seach of IEN '123' could return '123' and '1234' and '12345'
      For x:=FMListBoxIPR1.Items.Count-1 downto 0 do
        If Pos(PatientIEN+'  ',FMListBoxIPR1.Items[x])<>1 then
          FMListBoxIPR1.Items.Delete(x);
      // The second list has external values.  Compare to the first to
      // find matches and use those by overwriting FMListBox1 Items
      for x:=FMListBoxIPR1.Items.Count-1 downto 0 do begin;
        FMListBoxIPR1.ItemIndex:=x;
        //ShowMessageCAPRI(IntToStr(FMListBoxIPR2.Items.Count));
        y:= FMListBoxIPR2.Items.Count-1;
        repeat begin;
          FMListBoxIPR2.ItemIndex:=y;
          //ShowMessageCAPRI(FMListBoxIPR2.GetSelectedRecord.IEN+' : '+FMListBoxIPR1.GetSelectedRecord.IEN);
          If FMListBoxIPR2.GetSelectedRecord.IEN=FMListBoxIPR1.GetSelectedRecord.IEN then begin;
            FMListBoxIPR1.Items[x]:=FMListBoxIPR2.Items[y];
            //ShowMessageCAPRI(FMListBoxIPR2.Items[y]);
            y:=0;
          end;
          dec(y);
        end until y=-1;
      end;
      // Now get rid of name at beginning of list since we already know
      // the patient we're accessing
      For x:=FMListBoxIPR1.Items.Count-1 downto 0 do
          FMListBoxIPR1.Items[x]:=Copy(FMListBoxIPR1.Items[x],Pos('  ',FMListBoxIPR1.Items[x])+4,255);

      //figure out merged forms and expand
      if FMListBoxIPR1.Items.Count>0 then begin;
        For x:=FMListBoxIPR1.Items.Count-1 downto 0 do begin;
          If (Copy(FMListBoxIPR1.Items[x],1,Length('*MERGED FORM  '))='*MERGED FORM  ') or
             (Copy(FMListBoxIPR1.Items[x],1,Length('MERGED FORM  '))='MERGED FORM  ') then begin;
               // Replace the text but keep the rest of the line
               If Copy(FMListBoxIPR1.Items[x],1,1)='*' then
                 FMListBoxIPR1.Items[x]:='*MERGED FORMS - LISTED BELOW:  '+Copy(FMListBoxIPR1.Items[x],pos('  ',FMListBoxIPR1.Items[x])+2,length(FMListBoxIPR1.Items[x])) else
                 FMListBoxIPR1.Items[x]:='MERGED FORMS - LISTED BELOW:  '+Copy(FMListBoxIPR1.Items[x],pos('  ',FMListBoxIPR1.Items[x])+2,length(FMListBoxIPR1.Items[x]));
               // Insert individual merge form names here
               FMListBoxIPR1.ItemIndex:=x;
               FMGetsIPRFile3.IENS:=FMListBoxIPR1.GetSelectedRecord.IEN;
               FMGetsIPRFile3.GetAndFill;
               For xx:=0 to xFMTemplatesUtilized.Lines.Count-1 do begin;
                 Try FMListBoxIPR1.Items.Insert(x,'!'+Piece(xFMTemplatesUtilized.Lines[xx],'^',2));
                   Except;
                   FMListBoxIPR1.Items.Add('!'+Piece(xFMTemplatesUtilized.Lines[xx],'^',2));
                   end;
                 Try FMListBoxIPR2.Items.Insert(x,'!'+Piece(xFMTemplatesUtilized.Lines[xx],'^',2));
                   Except;
                   FMListBoxIPR2.Items.Add('!'+Piece(xFMTemplatesUtilized.Lines[xx],'^',2));
                   end;
                 //FMListBoxIPR2.Items.Insert(x+1,'');
               end;
             end;
          //ShowmessageCAPRI('*'+FMListBoxIPR1.Items[x]);
        end;
      end;
    *)
  (*

    FormatIPRList1;
    ListBoxIPR1.Items.Clear;
    For x:=FMListBoxIPR1.Items.Count-1 downto 0 do begin;
      ListBoxIPR1.Items.Add(FMListBoxIPR1.Items[x]);
    end;
    ListBoxIPR1.ItemIndex:=ListPoint;
    ListBoxIPR1Click(Application);
    ListBoxIPR1.Repaint;
  *)
end;

procedure TfrmManageReports.FMExamRequestListboxClick(Sender: TObject);
var
  tempstring: string;
begin
  LabelOpenExams.Visible := False;
  RichEditExamReport.Lines.Clear;
  RichEditExamReport.ReadOnly := True;
  //ButtonClearAll.Enabled:=False;
  ComboBoxExamStatus.Enabled := False;
  ComboBoxExamLocation.Enabled := False;
  ORDateCombo1.Enabled := False;
  FMExProvider.Enabled := False;
  FMCommentsMemo.ReadOnly := True;
  FMCommentsMemo.Lines.Clear;
  ComboBoxExamLocation.ItemIndex := -1;
  ComboBoxexamStatus.ItemIndex := -1;
  ORDateCombo1.FMDate := 0;
  FMExProvider.Text := '';
  ButtonSaveChanges.Enabled := False;

  shape2.brush.color := clSilver;
  buttonReopen.enabled := true;
  buttonRelease.enabled := true;
  PanelRequestDate.Caption := FMExamRequestListBox.Items[FMExamRequestListBox.ItemIndex];
  lstExamsRequested.Items.Clear;
  FMCommentsMemo.Lines.Clear;
  FMCommentsMemo.ReadOnly := True;

  buttonReopen.Enabled := False;
  buttonRelease.Enabled := False;
  tempstring := FMExamRequestListBox.Items[FMExamRequestListBox.ItemIndex];
  if Pos('[CANCELED]', tempstring) > 0 then begin
    buttonReopen.Enabled := True;
    buttonRelease.Enabled := False;
  end;
  if Pos('[OPEN]', tempstring) > 0 then begin
    buttonReopen.Enabled := False;
    buttonRelease.Enabled := True;
  end;
  if Pos('[RELEASED]', tempstring) > 0 then begin
    buttonReopen.Enabled := True;
    buttonRelease.Enabled := False;
  end;

  // Find Exams
  frmMain.RPCBroker1.Results.Clear;
  frmMain.RPCBroker1.RemoteProcedure := 'DVBAB FIND EXAMS';
  frmMain.RPCBroker1.Param[0].Value := FMExamRequestListbox.GetSelectedRecord.IEN;
  frmMain.RPCBroker1.Param[0].PType := literal;
  frmMain.RPCBrokerCall;
  try
    frmMain.RPCBroker1.Call;
  except
    on EBrokerError do begin
      ANURemoteProcedureCallInProgress := False;
      frmMain.AnimateLogo(False);
      frmMain.StatusBarLoadPt.Caption := 'RPC DVBAB FIND EXAMS could not be accessed!';
      frmMain.StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('RPC DVBAB FIND EXAMS could not be accessed!');
    end;
  end;
  lstExamsRequested.Items := frmMain.RPCBroker1.Results;
end;

procedure TfrmManageReports.lstExamsRequestedChange(Sender: TObject);
var
  x: integer;
  tempMemoryStream: TMemoryStream;
begin

  RichEditExamReport.ReadOnly := True;
  RichEditExamReport.Lines.Clear;

  ButtonSaveChanges.Enabled := False;
  FMCommentsMemo.ReadOnly := True;
  //ButtonClearAll.Enabled:=False;
  ComboBoxExamStatus.Enabled := False;
  ComboBoxExamLocation.Enabled := False;
  ORDateCombo1.Enabled := False;
  FMExProvider.Enabled := False;
  shape2.brush.color := clSilver;

  if lstExamsRequested.ItemIndex = -1 then
    exit;
  //if Pos('[CANCELED', lstExamsRequested.Items[lstExamsRequested.itemIndex])>0 then exit;

  buttonEditSelectedExam.enabled := True;
  shape2.brush.color := clSilver;
  FMGetsExamDetails.IENS := Piece(lstExamsRequested.Items[lstExamsRequested.ItemIndex], '^', 1);
  if FMGetsExamDetails.IENS = '' then
    exit;
  PanelSelectedExam.Caption := Piece(lstExamsRequested.Items[lstExamsRequested.ItemIndex], '^', 2);
  FMGetsExamDetails.GetAndFill;

  (*
  // Populate RTF Memo Here
  If FMCommentsMemoRTF.Lines.Count=0 then begin
    FMCommentsMemoRTF.Lines:=FMCommentsMemo.Lines;
  end;
  tempMemoryStream:=tMemoryStream.Create;
  FMCommentsMemoRTF.Lines.SaveToStream(tempMemoryStream);
  tempMemoryStream.Position:=0;
  RichEditExamReport.PlainText:=False;
  RichEditExamReport.Lines.LoadFromStream(tempMemoryStream);
  tempMemoryStream.Free;
*)

  // Non-RTF Method to replace the above commented out chunk
  tempMemoryStream := tMemoryStream.Create;
  FMCommentsMemo.Lines.SaveToStream(tempMemoryStream);
  tempMemoryStream.Position := 0;
  RichEditExamReport.PlainText := False;
  RichEditExamReport.Lines.LoadFromStream(tempMemoryStream);
  tempMemoryStream.Free;

  FMCommentsMemo.ReadOnly := True;
  ComboBoxExamLocation.ItemIndex := -1;
  ComboBoxExamStatus.ItemIndex := -1;
  for x := 0 to 2 do // Tried reading ComboBoxExamLocation.Items.Count, but it was incorrectly reporting the # of items
    if Uppercase(FMGetsExamDetails.getfield('.09').fmdbExternal) = Uppercase(ComboBoxExamLocation.Items[x]) then
      ComboBoxExamLocation.ItemIndex := x;
  for x := 0 to 2 do // Find the item but don't look at the abbreviation part in the dropdown
    if Pos(Uppercase(FMGetsExamDetails.getfield('.04').fmdbExternal), Uppercase(ComboBoxExamStatus.Items[x])) > 0 then
      ComboBoxExamStatus.ItemIndex := x;
  try
  ORDateCombo1.FMDate := strtoint(FMGetsExamDetails.getfield('.06').fmdbInternal)except ORDateCombo1.FMDate := 0;
  end;
  try
    FMExProvider.Text := FMGetsExamDetails.getfield('.07').fmdbExternal;
  except FMExProvider.Text := '';
  end;
  ComboBoxExamStatusChange(application);
end;

procedure TfrmManageReports.ButtonEditSelectedExamClick(Sender: TObject);
begin
  if buttonRelease.enabled = False then begin
    showmessageCAPRI('Please re-open this exam request first.');
    exit;
  end;
  shape2.brush.color := $0080FFFF;
  FMCommentsMemo.Enabled := True;

  FMCommentsMemo.ReadOnly := False;
  //ButtonClearAll.Enabled:=True;
  ComboBoxExamStatus.Enabled := True;
  ComboBoxExamLocation.Enabled := True;
  ORDateCombo1.Enabled := True;
  FMExProvider.Enabled := True;
  ButtonSaveChanges.Enabled := True;
  RichEditExamReport.ReadOnly := False;
  ToolBar1.Enabled := True;
end;

procedure TfrmManageReports.buttonReleaseClick(Sender: TObject);
var
  nowdt: string;
  whichIEN: string;
  x: integer;
  foundflag: boolean;
begin
  foundflag := false;
  if lstExamsRequested.Items.Count > 0 then
    for x := 0 to lstExamsRequested.Items.Count - 1 do
      if pos('[OPEN]', lstExamsRequested.Items[x]) > 0 then
        foundflag := true;
  if foundflag = true then begin
    showmessageCAPRI('This exam request has open items and cannot be released yet.');
    exit;
  end;
  if MessageDlgCAPRI('Are you ready to release this exam request so it can be printed by the requestor?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin

    whichIEN := FMExamRequestListbox.GetSelectedRecord.IEN;
    if ANURemoteProcedureCallInProgress = True then
      exit;
    frmMain.RPCBroker1.RemoteProcedure := 'ORWU DT';
    frmMain.RPCBroker1.Param[1].Value := 'NOW';
    frmMain.RPCBroker1.Param[1].PType := literal;
    try
      frmMain.RPCBroker1.Call;
    except
      on EBrokerError do begin
        ANURemoteProcedureCallInProgress := False;
        frmMain.AnimateLogo(False);
        frmMain.StatusBarLoadPt.Caption := 'RPC ORWU DT could not be accessed!';
        frmMain.StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('ORWU DT could not be accessed!');
        exit;
      end;
    end;
    nowdt := frmMain.RPCBroker1.Results[0];

    frmMain.FMValidator1.SetUp('396.3', whichIEN, '12', NowDt); // Date Approved
    frmMain.FMValidator1.SetUp('396.3', whichIEN, '13', NowDt); // Date Released
    frmMain.FMValidator1.SetUp('396.3', whichIEN, '6', NowDt); // Date Completed
    //frmMain.FMValidator1.SetUp('396.3',whichIEN,'14',AuthorIEN); // Released By
    frmMain.FMValidator1.Setup('396.3', whichIEN, '17', 'R'); // Request Status

    (*
        fmEditRequestStatus.Text:='R';  // Request Status
        fmEditRequestStatus.IENS:=whichIEN;
        if FMEditRequestStatus.FMModified then  if FMEditRequestStatus.Validate then begin
           frmMain.FMFiler1.AddChgdControl(FMEditRequestStatus);FMEditRequestStatus.Text:=FMEditRequestStatus.FMCtrlExternal;
           end else begin
            frmMain.FMValidator1.DisplayErrors; FMEditRequestStatus.Text:=FMEditRequestStatus.FMTag;
           end;
    *)
    if not frmMain.FMValidator1.Validate then begin
      frmMain.FMValidator1.DisplayErrors;
      exit;
    end; {file}

    frmMain.fmfiler1.AddFDA('396.3', whichIEN, '12', NowDt); // Date Approved
    frmMain.fmfiler1.AddFDA('396.3', whichIEN, '13', NowDt); // Date Released
    frmMain.fmfiler1.AddFDA('396.3', whichIEN, '6', NowDt); // Date Completed
    frmMain.fmfiler1.AddFDA('396.3', whichIEN, '14', AuthorIEN); // Released By
    frmMain.fmfiler1.AddFDA('396.3', whichIEN, '17', 'R'); // Request Status

    if frmMain.FMFiler1.AnythingToFile then
    begin
      frmMain.FMFiler1.Update;
      //CodeCR266 - rpm 1/18/12 - Send email notification
      frmMain.MailManBuffer.Lines.Clear;
      frmMain.MailManBuffer.Lines.Add('');
      SendNotification(frmMain.MailManBuffer.Lines,
                       AuthorIEN,
                       'CAPRI: Release of 2507 Request',
                       'DVBA C 2507 EXAM READY',
                       whichIEN);
    end;

    ExamRequestRefreshClick(Application);
  end;
end;

procedure TfrmManageReports.buttonReopenClick(Sender: TObject);
var
  whichIEN: string;
begin
  if MessageDlgCAPRI('Re-opening will clear previous status information and may affect site statistics.  Are you sure you want to re-open this exam?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin

    whichIEN := FMExamRequestListbox.GetSelectedRecord.IEN;
    if ANURemoteProcedureCallInProgress = True then
      exit;

    frmMain.FMValidator1.SetUp('396.3', whichIEN, '6', ''); // Date Completed
    frmMain.FMValidator1.SetUp('396.3', whichIEN, '12', ''); // Date Approved
    frmMain.FMValidator1.SetUp('396.3', whichIEN, '13', ''); // Date Released
    frmMain.FMValidator1.SetUp('396.3', whichIEN, '14', ''); // Released By
    frmMain.FMValidator1.SetUp('396.3', whichIEN, '15', ''); // Date printed by the RO
    frmMain.FMValidator1.SetUp('396.3', whichIEN, '16', ''); // Printed By
    frmMain.FMValidator1.Setup('396.3', whichIEN, '17', 'O'); // Request Status
    frmMain.FMValidator1.Setup('396.3', whichIEN, '19', ''); // Cancellation Date
    frmMain.FMValidator1.SetUp('396.3', whichIEN, '20', ''); // Cancelled By
    frmMain.FMValidator1.SetUp('396.3', whichIEN, '25', ''); // Approved By
    frmMain.FMValidator1.SetUp('396.3', whichIEN, '26', ''); // Approval Date/Time

    (*
    fmEditRequestStatus.Text:='O';  // Request Status
    fmEditRequestStatus.IENS:=whichIEN;
    if FMEditRequestStatus.FMModified then  if FMEditRequestStatus.Validate then begin
       frmMain.fmFiler1.AddChgdControl(FMEditRequestStatus);FMEditRequestStatus.Text:=FMEditRequestStatus.FMCtrlExternal;
       end else begin
        frmMain.FMValidator1.DisplayErrors; FMEditRequestStatus.Text:=FMEditRequestStatus.FMTag;
       end;
    *)

    if not frmMain.FMValidator1.Validate then begin
      frmMain.FMValidator1.DisplayErrors;
      exit;
    end; {file}

    frmMain.fmfiler1.AddFDA('396.3', whichIEN, '6', ''); // Date Completed
    frmMain.fmfiler1.AddFDA('396.3', whichIEN, '12', ''); // Date Approved
    frmMain.fmfiler1.AddFDA('396.3', whichIEN, '13', ''); // Date Released
    frmMain.fmfiler1.AddFDA('396.3', whichIEN, '14', ''); // Released By
    frmMain.fmfiler1.AddFDA('396.3', whichIEN, '15', ''); // Date printed by the RO
    frmMain.fmfiler1.AddFDA('396.3', whichIEN, '16', ''); // Printed By
    frmMain.fmfiler1.AddFDA('396.3', whichIEN, '17', 'O'); // Request Status
    frmMain.FMValidator1.Setup('396.3', whichIEN, '19', ''); // Cancellation Date
    frmMain.FMValidator1.SetUp('396.3', whichIEN, '20', ''); // Cancelled By
    frmMain.fmfiler1.AddFDA('396.3', whichIEN, '25', ''); // Approved By
    frmMain.fmfiler1.AddFDA('396.3', whichIEN, '26', ''); // Approval Date/Time

    if frmMain.FMFiler1.AnythingToFile then
      frmMain.FMFiler1.Update;

    ExamRequestRefreshClick(Application);
  end;
end;

procedure TfrmManageReports.ButtonSaveChangesClick(Sender: TObject);
var
  tempstring: string;
  whichIEN, selectedExam, examName: string;
  x, OpenExamCount: integer;
  tempMemoryStream: TMemoryStream;
begin
  tempstring := '';
  if ComboBoxExamStatus.ItemIndex = -1 then begin
    tempstring := tempstring + 'You must pick an exam status.' + char(13);
  end;
  if ComboBoxExamLocation.ItemIndex = -1 then begin
    tempstring := tempstring + 'You must pick an exam location.' + char(13);
  end;
  if ORDateCombo1.FMDate = 0 then begin
    tempstring := tempstring + 'You must enter an exam date.' + char(13);
  end;
  if FMExProvider.Text = '' then begin
    tempstring := tempstring + 'You must enter an examining provider.' + char(13);
  end;

  ToolBar1.Enabled := False;

  whichIEN := Piece(lstExamsRequested.Items[lstExamsRequested.ItemIndex], '^', 1);

  // Save Data
  if MessageDlgCAPRI('Are you ready to save changes?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin

    FMCommentsMemo.Lines.Clear;
    FMCommentsMemoRTF.Lines.Clear;

    // Copy RTF here into non-RTF field
    if RichEditExamReport.Lines.Count > 0 then
      for x := 0 to RichEditExamReport.Lines.Count - 1 do
        FMCommentsMemo.Lines.Add(RichEditExamReport.Lines[x]);

    // Now store RTF version
    tempMemoryStream := tMemoryStream.Create;
    RichEditExamReport.Lines.SaveToStream(tempMemoryStream);
    TempMemoryStream.Position := 0;
    FMCommentsMemoRTF.Lines.LoadFromStream(tempMemoryStream);
    tempMemoryStream.Free;

    //if FMCommentsMemo.FMModified then
    frmMain.FMFiler1.AddChgdControl(FMCommentsMemo);
    frmMain.FMFiler1.AddChgdControl(FMCommentsMemoRTF);
    frmMain.fmfiler1.AddFDA('396.4', whichIEN, '.04', Trim(Copy(ComboBoxExamStatus.Text, 1, 2)));
    frmMain.fmfiler1.AddFDA('396.4', whichIEN, '.09', Copy(ComboBoxExamLocation.Text, 1, 1));
    frmMain.fmfiler1.AddFDA('396.4', whichIEN, '.06', FloatToStr(ORDateCombo1.FMDate));
    frmMain.fmfiler1.AddFDA('396.4', whichIEN, '.07', FMExProvider.Text);

    if frmMain.FMFiler1.AnythingToFile then
    begin
      frmMain.FMFiler1.Update;
      //CodeCR266 - rpm 4/3/12 - Send email notification for cancellations
      if (Trim(Copy(ComboBoxExamStatus.Text, 1, 2))='X') or   //Cancel by MAS
         (Trim(Copy(ComboBoxExamStatus.Text, 1, 2))='RX') then  //Cancel by RO
      begin
        //Extract exam name
        selectedExam := Uppercase(lstExamsRequested.Items[lstExamsRequested.ItemIndex]);
        examName := Copy(selectedExam, Pos('^', selectedExam) + 1, Pos('[OPEN', selectedExam) - Pos('^', selectedExam)- 1)
                    + '..................................................';

        //Calculate open exam count
        OpenExamCount := 0;
        if lstExamsRequested.Items.Count > 0 then
          for x := 0 to lstExamsRequested.Items.Count - 1 do
            if Pos('[OPEN', lstExamsRequested.Items[x]) > 0 then
              inc(OpenExamCount);
        {The resulting [OPEN] exam count must be decremented, because
         the current exam being canceled is still in the [OPEN] status
         when the count is performed}
        dec(OpenExamCount);

        FormatCancelNotice(examName, OpenExamCount);
        SendNotification(frmMain.MailManBuffer.Lines,
                         AuthorIEN,
                         'CAPRI: Cancellation of 2507 Exams',
                         'DVBA C 2507 CANCELLATION',
                         FMExamRequestListbox.GetSelectedRecord.IEN);
      end;
    end;

    buttonEditSelectedExam.Enabled := False;
    shape2.brush.color := clSilver;
    ButtonSaveChanges.Enabled := False;
    FMCommentsMemo.ReadOnly := True;
    ComboBoxExamLocation.Enabled := False;
    //ButtonClearAll.Enabled:=False;
    ComboBoxExamStatus.Enabled := False;
    ORDateCombo1.Enabled := False;
    FMExProvider.Enabled := False;
    RichEditExamReport.ReadOnly := True;
    ExamRequestRefreshClick(Application);
  end;
end;

procedure TfrmManageReports.SpeedButtonColorClick(Sender: TObject);
begin
  ColorGrid1.ForeGroundIndex := ColorGrid1.ColorToIndex(RichEditExamReport.SelAttributes.Color);
  if PanelColor.Visible = False then begin
    PanelColor.Visible := True;
  end
  else begin
    PanelColor.Visible := False;
  end;
end;

procedure TfrmManageReports.RichEditExamReportKeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  exit;
end;

procedure TfrmManageReports.SpeedButtonBoldClick(Sender: TObject);
begin
  if SpeedButtonBold.Down = True then
    RichEditExamReport.SelAttributes.Style := RichEditExamReport.SelAttributes.Style + [fsBold]
  else
    RichEditExamReport.SelAttributes.Style := RichEditExamReport.SelAttributes.Style - [fsBold];
end;

procedure TfrmManageReports.SpeedButtonItalicClick(Sender: TObject);
begin
  if SpeedButtonItalic.Down = True then
    RichEditExamReport.SelAttributes.Style := RichEditExamReport.SelAttributes.Style + [fsItalic]
  else
    RichEditExamReport.SelAttributes.Style := RichEditExamReport.SelAttributes.Style - [fsItalic];
end;

procedure TfrmManageReports.SpeedButtonUnderlineClick(Sender: TObject);
begin
  if SpeedButtonUnderline.Down = True then
    RichEditExamReport.SelAttributes.Style := RichEditExamReport.SelAttributes.Style + [fsUnderline]
  else
    RichEditExamReport.SelAttributes.Style := RichEditExamReport.SelAttributes.Style - [fsUnderline];
end;

procedure TfrmManageReports.RichEditExamReportSelectionChange(
  Sender: TObject);
begin
  if PanelColor.Visible = True then
    PanelColor.Visible := False;

  SpeedButtonBold.Down := False;
  SpeedButtonItalic.Down := False;
  SpeedButtonUnderline.Down := False;

  if RichEditExamReport.SelAttributes.Style = [fsbold] then
    SpeedButtonBold.Down := True;
  if RichEditExamReport.SelAttributes.Style = [fsitalic] then
    SpeedButtonitalic.Down := True;
  if RichEditExamReport.SelAttributes.Style = [fsunderline] then
    SpeedButtonunderline.Down := True;

  if RichEditExamReport.SelAttributes.Style = [fsbold, fsitalic] then begin
    SpeedButtonBold.Down := True;
    SpeedButtonItalic.Down := True;
  end;

  if RichEditExamReport.SelAttributes.Style = [fsbold, fsunderline] then begin
    SpeedButtonBold.Down := True;
    SpeedButtonUnderline.Down := True;
  end;

  if RichEditExamReport.SelAttributes.Style = [fsbold, fsitalic, fsunderline] then begin
    SpeedButtonBold.Down := True;
    SpeedButtonItalic.Down := True;
    SpeedButtonUnderline.Down := True;
  end;

  if RichEditExamReport.SelAttributes.Style = [fsitalic, fsunderline] then begin
    SpeedButtonItalic.Down := True;
    SpeedButtonUnderline.Down := True;
  end;

end;

procedure TfrmManageReports.SpeedButtonFontBiggerClick(Sender: TObject);
begin
  RichEditExamReport.SelAttributes.Size := RichEditExamReport.SelAttributes.Size + 1;
end;

procedure TfrmManageReports.SpeedButtonFontSmallerClick(Sender: TObject);
begin
  RichEditExamReport.SelAttributes.Size := RichEditExamReport.SelAttributes.Size - 1;
end;

procedure TfrmManageReports.ColorGrid1Change(Sender: TObject);
begin
  PanelColor.Visible := False;
end;

procedure TfrmManageReports.ColorGrid1Click(Sender: TObject);
begin
  PanelColor.Visible := False;
  RichEditExamReport.SelAttributes.Color := ColorGrid1.ForegroundColor;
end;

procedure TfrmManageReports.ComboBoxExamStatusChange(Sender: TObject);
begin
  LabelOpenExams.Visible := False;
  if Pos('  OPEN', ComboBoxExamStatus.Text) > 0 then begin
    LabelOpenExams.Visible := True;
  end;
end;

procedure TfrmManageReports.Undo1Click(Sender: TObject);
begin
  Sender := screen.ActiveControl;

  if Sender.ClassType = TMemo then begin
    (Sender as TMemo).Undo;
  end
  else
    if Sender.ClassType = TEdit then begin
      (Sender as TEdit).Undo;
    end
    else
      if Sender.ClassType = TRichEdit then begin
        (Sender as TRichEdit).Undo;
      end
      else
        Sleep(1); //Showmessage('Unknown class type: '+Sender.ClassName);
end;

procedure TfrmManageReports.mnuPopEditCheckSpellingClick(Sender: TObject);
var
  msg: TMsg;
  handled: Boolean;
begin
  handled := false;
  msg.message := WM_KEYUP;
  msg.wParam := VK_F7;
  frmmain.AppMessage(msg, handled);
end;

procedure TfrmManageReports.mnuPopEditCopyClick(Sender: TObject);
begin
  Sender := screen.ActiveControl;

  if Sender.ClassType = TMemo then begin
    (Sender as TMemo).CopyToClipboard;
  end
  else
    if Sender.ClassType = TEdit then begin
      (Sender as TEdit).CopyToClipboard;
    end
    else
      if Sender.ClassType = TRichEdit then begin
        (Sender as TRichEdit).CopyToClipboard;
      end
      else
        Sleep(1); //Showmessage('Unknown class type: '+Sender.ClassName);
end;

procedure TfrmManageReports.mnuPopEditCutClick(Sender: TObject);
begin
  Sender := screen.ActiveControl;

  if Sender.ClassType = TMemo then begin
    (Sender as TMemo).CutToClipboard;
  end
  else
    if Sender.ClassType = TEdit then begin
      (Sender as TEdit).CutToClipboard;
    end
    else
      if Sender.ClassType = TRichEdit then begin
        (Sender as TRichEdit).CutToClipboard;
      end
      else
        Sleep(1); //Showmessage('Unknown class type: '+Sender.ClassName);

end;

procedure TfrmManageReports.mnuPopEditDeleteClick(Sender: TObject);
begin
  Sender := screen.ActiveControl;

  if Sender.ClassType = TMemo then begin
    (Sender as TMemo).SelText := '';
  end
  else
    if Sender.ClassType = TEdit then begin
      (Sender as TEdit).SelText := '';
    end
    else
      if Sender.ClassType = TRichEdit then begin
        (Sender as TRichEdit).SelText := '';
      end
      else
        Sleep(1); //Showmessage('Unknown class type: '+Sender.ClassName);
end;

procedure TfrmManageReports.mnuPopEditPasteClick(Sender: TObject);
begin
  Sender := screen.ActiveControl;

  if Sender.ClassType = TMemo then begin
    (Sender as TMemo).PasteFromClipboard;
  end
  else
    if Sender.ClassType = TEdit then begin
      (Sender as TEdit).PasteFromClipboard;
    end
    else
      if Sender.ClassType = TRichEdit then begin
        (Sender as TRichEdit).PasteFromClipboard;
      end
      else
        Sleep(1); //Showmessage('Unknown class type: '+Sender.ClassName);
end;

procedure TfrmManageReports.mnuPopEditSelectAllClick(Sender: TObject);
begin
  Sender := screen.ActiveControl;

  if Sender.ClassType = TMemo then begin
    (Sender as TMemo).SelectAll;
  end
  else
    if Sender.ClassType = TEdit then begin
      (Sender as TEdit).SelectAll;
    end
    else
      if Sender.ClassType = TRichEdit then begin
        (Sender as TRichEdit).SelectAll;
      end
      else
        Sleep(1); //Showmessage('Unknown class type: '+Sender.ClassName);
end;

procedure TfrmManageReports.mnuPopEditUndoClick(Sender: TObject);
begin
  Sender := screen.ActiveControl;

  if Sender.ClassType = TMemo then begin
    (Sender as TMemo).Undo;
  end
  else
    if Sender.ClassType = TEdit then begin
      (Sender as TEdit).Undo;
    end
    else
      if Sender.ClassType = TRichEdit then begin
        (Sender as TRichEdit).Undo;
      end
      else
        Sleep(1); //Showmessage('Unknown class type: '+Sender.ClassName);
end;
{============================================================================
 FormatCancelNotice
 This procedure formats the initial text used in the email cancellation
 notification.  The server formats the remainder of the text when the
 DVBAB SEND MSG remote procedure is executed.

 Input:  ExamName - name of exam being cancelled
         OpenCount - number of exams still open on 2507 request

 Output:  none

 CodeCR266 - rpm 4/4/12
 ============================================================================}
procedure TfrmManageReports.FormatCancelNotice(ExamName: String;
  OpenCount: Integer);
begin
  frmMain.MailManBuffer.Lines.Clear;
  frmMain.MailManBuffer.Lines.Add('The following veteran had one or more 2507 exams cancelled:');
  frmMain.MailManBuffer.Lines.Add('');
  frmMain.MailManBuffer.Lines.Add('  Name: ' + Uppercase(Copy(frmMain.Panel1.caption, 1, Pos('  SSN#', frmMain.Panel1.Caption))) + '   SSN: ' + PatientSSN + '   C-Number: ' + frmMain.CNumber.Caption);
  frmMain.MailManBuffer.Lines.Add('');
  frmMain.MailManBuffer.Lines.Add('Exams cancelled');
  frmMain.MailManBuffer.Lines.Add('     ' + Copy(ExamName, 1, 40));
  frmMain.MailManBuffer.Lines.Add('');
  //Display open exam count
  if OpenCount < 1 then
    frmMain.MailManBuffer.Lines.Add('*** All exams on this request are now CANCELLED. ***')
  else if OpenCount = 1 then
    frmMain.MailManBuffer.Lines.Add('*** There is still 1 exam open on this request. ***')
  else
    frmMain.MailManBuffer.Lines.Add('*** There are still ' + IntToStr(OpenCount) + ' exams open on this request. ***');
  //The 'Additional Comments' line is replaced by the remote procedure
  frmMain.MailManBuffer.Lines.Add('');
  frmMain.MailManBuffer.Lines.Add('========================<  Additional Comments  >========================');
end;


end.
