unit new7131;

interface

uses
  Diaccess,
  Menus,
  StdCtrls,
  Fmcntrls,
  ORCtrls,
  Controls,
  Forms,
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  DialogsCAPRI,
  Dialogs,
  CheckLst,
  ORDtTm,
  Trpcb,
  ExtCtrls,
  clipbrd,
  OleCtrls,
  Fmcmpnts, ToolWin, ActnMan, ActnCtrls, ActnMenus, ActnList, XPStyleActnCtrls,
  AccessibilityUtils, VA508AccessibilityManager;

type
  TfrmNew7131 = class(TForm)
    Panel1: TPanel;
    btnCancel: TButton;
    btnSendRequest: TButton;
    ScrollBox1: TScrollBox;
    Panel2: TPanel;
    FMPatientName: TFMEdit;
    Label6: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox10: TCheckBox;
    CheckBox9: TCheckBox;
    CheckBox8: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox3: TCheckBox;
    FMTxReport: TFMEdit;
    Label14: TLabel;
    Label5: TLabel;
    FMRoutingLocationFake: TFMEdit;
    ListBox5: TListBox;
    ListBox2: TListBox;
    FMPatientNameIEN: TFMEdit;
    FMChk1: TFMEdit;
    FMChk2: TFMEdit;
    FMChk3: TFMEdit;
    FMChk4: TFMEdit;
    FMChk5: TFMEdit;
    FMChk6: TFMEdit;
    FMChk7: TFMEdit;
    FMChk8: TFMEdit;
    FMChk9: TFMEdit;
    FMChk10: TFMEdit;
    Label19: TLabel;
    FMAdmissionDate: TFMEdit;
    FMRequestedBy: TFMEdit;
    Label9: TLabel;
    Label1: TLabel;
    FMDocumentType: TFMEdit;
    FMRequestDate: TFMEdit;
    Label7: TLabel;
    FMDateStatusChange: TFMEdit;
    Label2: TLabel;
    Label8: TLabel;
    FMRegionalOfficeNumber: TFMComboBox;
    FMRegionalOfficeNumberFake: TFMEdit;
    FMFiler1: TFMFiler;
    FMRoutingLocation: TORComboBox;
    FMListerCustomExamListDivisions: TFMLister;
    FMListerCustomExamListDivisionsListBox: TFMListBox;
    CustomExamListDivisions: TFMGets;
    FMEditInactivateDivision: TFMEdit;
    CCOWTimer: TTimer;
    RadioGroup1: TRadioGroup;
    GroupBox1: TGroupBox;
    ListBox4: TListBox;
    GroupBox2: TGroupBox;
    FMCommentsMemo: TFMMemo;
    ActionManNew7131Request: TActionManager;
    actEditUndo: TAction;
    actEditCut: TAction;
    actEditCopy: TAction;
    actEditPaste: TAction;
    actMenuBarNew7131Request: TActionMainMenuBar;
    VA508AccessibilityManager1: TVA508AccessibilityManager; // -MER CodeCR118 8/2010
    st508RegionalOfficeNumber: TVA508StaticText; // -MER CodeCR118 8/2010
    procedure btnCancelClick(Sender: TObject);
    procedure ListBox4Click(Sender: TObject);
    procedure btnSendRequestClick(Sender: TObject);
    procedure FMRoutingLocationExit(Sender: TObject);
    procedure FMRegionalOfficeNumberExit(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FMRegionalOfficeNumberEnter(Sender: TObject);
    procedure FMCommentsMemoEnter(Sender: TObject);
    procedure CCOWTimerTimer(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure actEditUndoExecute(Sender: TObject);
    procedure actEditCutExecute(Sender: TObject);
    procedure actEditCopyExecute(Sender: TObject);
    procedure actEditPasteExecute(Sender: TObject);
    procedure actEditUndoUpdate(Sender: TObject);
  private
    { Private declarations }
    procedure WMMenuChar(var Message: TWMMenuChar); message WM_MENUCHAR;
    procedure Set508ControlOptions; // -MER CodeCR118 8/2010
  public
    { Public declarations }
  end;

var
  frmNew7131: TfrmNew7131;

implementation

uses
  CapriSupport,
  main,
  rofinder;

{$R *.DFM}

procedure TfrmNew7131.actEditCopyExecute(Sender: TObject);
begin
  FEditCtrl.CopyToClipboard;
end;

procedure TfrmNew7131.actEditCutExecute(Sender: TObject);
begin
  FEditCtrl.CutToClipboard;
end;

procedure TfrmNew7131.actEditPasteExecute(Sender: TObject);
begin
  FEditCtrl.SelText := Clipboard.AsText;
end;

procedure TfrmNew7131.actEditUndoExecute(Sender: TObject);
begin
  FEditCtrl.Perform(EM_UNDO, 0, 0);
end;

procedure TfrmNew7131.actEditUndoUpdate(Sender: TObject);
var
  tempTMemoBox: TMemo;
  tempTFmMemoBox: TFmMemo;
  tempTEdit: TEdit;
  tempTFMEdit: TFMEdit;
begin
  FEditCtrl := nil;
  if Screen.ActiveControl is TCustomEdit then
    FEditCtrl := TCustomEdit(Screen.ActiveControl);
  if FEditCtrl <> nil then begin
    actEditUndo.Enabled := FEditCtrl.Perform(EM_CANUNDO, 0, 0) <> 0;
    actEditCut.Enabled := FEditCtrl.SelLength > 0;
    actEditCopy.Enabled := actEditCut.Enabled;
    actEditPaste.Enabled := Clipboard.HasFormat(CF_TEXT);
  end
  else begin
    actEditUndo.Enabled := False;
    actEditCut.Enabled := False;
    actEditCopy.Enabled := False;
    actEditPaste.Enabled := False;
  end;
  // Don't let read only memos accept paste function
  if FEditCtrl = nil then
    exit;
  if (Uppercase(FEditCtrl.ClassName) = 'TMEMO') then begin
    tempTMemoBox := FEditCtrl as TMemo;
    if (tempTMemoBox.Readonly = True) then begin
      actEditUndo.Enabled := False;
      actEditCut.Enabled := False;
      actEditPaste.Enabled := False;
    end;
  end;
  if (Uppercase(FEditCtrl.ClassName) = 'TFMMEMO') then begin
    tempTFmMemoBox := FEditCtrl as TFmMemo;
    if (tempTFmMemoBox.Readonly = True) then begin
      actEditUndo.Enabled := False;
      actEditCut.Enabled := False;
      actEditPaste.Enabled := False;
    end;
  end;
  if (Uppercase(FEditCtrl.ClassName) = 'TEDIT') then begin
    tempTEdit := FEditCtrl as TEdit;
    if (tempTEdit.Readonly = True) then begin
      actEditUndo.Enabled := False;
      actEditCut.Enabled := False;
      actEditPaste.Enabled := False;
    end;
  end;
  if (Uppercase(FEditCtrl.ClassName) = 'TFMEDIT') then begin
    tempTFMEdit := FEditCtrl as TFMEdit;
    if (tempTFMEdit.Readonly = True) then begin
      actEditUndo.Enabled := False;
      actEditCut.Enabled := False;
      actEditPaste.Enabled := False;
    end;
  end;
end;

procedure TfrmNew7131.btnCancelClick(Sender: TObject);
begin
  if Application.MessageBox('Are you sure you want to CANCEL this new request?', 'Cancel Request', 4) = 6 then begin
    ModalResult := mrCancel;
  end;
end;

procedure TfrmNew7131.ListBox4Click(Sender: TObject);
begin
  Checkbox1.Enabled := True;
  Checkbox2.Enabled := True;
  Checkbox3.Enabled := True;
  Checkbox9.Enabled := True;
  FMAdmissionDate.Text := Copy(ListBox4.Items[ListBox4.ItemIndex], 1, Pos('  ', ListBox4.Items[ListBox4.ItemIndex]) - 1);
  FMDocumentType.Text := 'A'; //  L=Activity;

end;

procedure TfrmNew7131.btnSendRequestClick(Sender: TObject);
var
  x: integer;
  RoutingLocationInternal: string;
begin

  RoutingLocationInternal := Copy(FMRoutingLocationFake.Text, 2, Length(FMRoutingLocationFake.Text) - 1);

  if RadioGroup1.ItemIndex = -1 then begin
    ShowMessageCAPRI('Please select a type of request.');
    exit;
  end;
  if (RadioGroup1.ItemIndex = 1) and (ListBox4.ItemIndex = -1) then begin
    ShowMessageCAPRI('Please select an admission date or change the type of request.');
    exit;
  end;

  if FMRegionalOfficeNumber.Text = '' then begin
    ShowMessageCAPRI('Please select a regional office.');
    FMRegionalOfficeNumber.Enabled := True;
    Exit;
  end;
  if FMRoutingLocation.Text = '' then begin
    ShowMessageCAPRI('Please select a routing location.');
    exit;
  end;
  if (Checkbox4.Checked) and (FMCommentsMemo.Lines.Count = 0) then begin
    ShowMessageCAPRI('You must enter a comment if you select "Other/Exam (Review/Remarks)."');
    exit;
  end;
  if (Checkbox1.Checked = False) and (Checkbox2.Checked = False) and
    (Checkbox3.Checked = False) and (Checkbox4.Checked = False) and
    (Checkbox5.Checked = False) and (Checkbox6.Checked = False) and
    (Checkbox7.Checked = False) and (Checkbox8.Checked = False) and
    (Checkbox9.Checked = False) and (Checkbox10.Checked = False) and
    (FMTxReport.Text = '') and (FMCommentsMemo.Lines.Count = 0) then begin
    ShowMessageCAPRI('Cannot submit a blank request.');
    exit;
  end;
  if Checkbox1.Checked = True then
    FMChk1.Text := 'Y'
  else
    FMChk1.Text := 'N';
  if Checkbox2.Checked = True then
    FMChk2.Text := 'Y'
  else
    FMChk2.Text := 'N';
  if Checkbox3.Checked = True then
    FMChk3.Text := 'Y'
  else
    FMChk3.Text := 'N';
  if Checkbox4.Checked = True then
    FMChk4.Text := 'Y'
  else
    FMChk4.Text := 'N';
  if Checkbox5.Checked = True then
    FMChk5.Text := 'Y'
  else
    FMChk5.Text := 'N';
  if Checkbox6.Checked = True then
    FMChk6.Text := 'Y'
  else
    FMChk6.Text := 'N';
  if Checkbox7.Checked = True then
    FMChk7.Text := 'Y'
  else
    FMChk7.Text := 'N';
  if Checkbox8.Checked = True then
    FMChk8.Text := 'Y'
  else
    FMChk8.Text := 'N';
  if Checkbox9.Checked = True then
    FMChk9.Text := 'Y'
  else
    FMChk9.Text := 'N';
  if Checkbox10.Checked = True then
    FMChk10.Text := 'Y'
  else
    FMChk10.Text := 'N';

  TimeSinceLastBrokerCall := 0; // Prevent event

  if Application.MessageBox('Are you sure you want to send this new 7131 request?', 'Send 7131 Request', 4) = 6 then begin
    if FMDocumentType.FMModified then
      if FMDocumentType.Validate then begin
        FMFiler1.AddChgdControl(FMDocumentType);
        FMDocumentType.Text := FMDocumentType.FMCtrlExternal;
      end
      else begin
        frmMain.FMValidator1.DisplayErrors;
        FMDocumentType.Text := FMDocumentType.FMTag;
      end;
    if FMRoutingLocationFake.FMModified then
      if FMRoutingLocationFake.Validate then begin
        FMFiler1.AddChgdControl(FMRoutingLocationFake);
        FMRoutingLocationFake.Text := FMRoutingLocationFake.FMCtrlExternal;
      end
      else begin
        FMRoutingLocationFake.Text := '';
        ShowMessageCAPRI('This type of request cannot be sent to the division you''ve selected.  Please select a valid division.');
        exit;
        frmMain.FMValidator1.DisplayErrors;
        FMRoutingLocationFake.Text := FMRoutingLocationFake.FMTag;
      end;
    if FMRegionalOfficeNumberFake.FMModified then
      if FMRegionalOfficeNumberFake.Validate then begin
        FMFiler1.AddChgdControl(FMRegionalOfficeNumberFake);
        FMRegionalOfficeNumberFake.Text := FMRegionalOfficeNumberFake.FMCtrlExternal;
      end
      else begin
        frmMain.FMValidator1.DisplayErrors;
        FMRegionalOfficeNumberFake.Text := FMRegionalOfficeNumberFake.FMTag;
      end;
    if FMPatientNameIEN.FMModified then
      if FMPatientNameIEN.Validate then begin
        FMFiler1.AddChgdControl(FMPatientNameIEN);
        FMPatientNameIEN.Text := FMPatientNameIEN.FMCtrlExternal;
      end
      else begin
        frmMain.FMValidator1.DisplayErrors;
        FMPatientNameIEN.Text := FMPatientNameIEN.FMTag;
      end;
    if FMRequestDate.FMModified then
      if FMRequestDate.Validate then begin
        FMFiler1.AddChgdControl(FMRequestDate);
        FMRequestDate.Text := FMRequestDate.FMCtrlExternal;
      end
      else begin
        frmMain.FMValidator1.DisplayErrors;
        FMRequestDate.Text := FMRequestDate.FMTag;
      end;
    if FMDateStatusChange.FMModified then
      if FMDateStatusChange.Validate then begin
        FMFiler1.AddChgdControl(FMDateStatusChange);
        FMDateStatusChange.Text := FMDateStatusChange.FMCtrlExternal;
      end
      else begin
        frmMain.FMValidator1.DisplayErrors;
        FMDateStatusChange.Text := FMDateStatusChange.FMTag;
      end;
    if FMRequestedBy.FMModified then
      if FMRequestedBy.Validate then begin
        FMFiler1.AddChgdControl(FMRequestedBy);
        FMRequestedBy.Text := FMRequestedBy.FMCtrlExternal;
      end
      else begin
        frmMain.FMValidator1.DisplayErrors;
        FMRequestedBy.Text := FMRequestedBy.FMTag;
      end;
    if FMChk1.FMModified then
      if FMChk1.Validate then begin
        FMFiler1.AddChgdControl(FMChk1);
        FMChk1.Text := FMChk1.FMCtrlExternal;
        frmMain.FMValidator1.Setup('396', '+1', '4.5', 'P'); // Set Status to Pending
        if FMChk1.Text[1] = 'Y' then begin
          FMFiler1.AddFDA('396', '+1', '4.5', 'P');
          frmMain.FMValidator1.Setup('396', '+1', '4.6', RoutingLocationInternal);
          FMFiler1.AddFDA('396', '+1', '4.6', RoutingLocationInternal);
          frmMain.FMValidator1.Setup('396', '+1', '4.7', FMRequestDate.FMCtrlInternal); // Tran Date
          FMFiler1.AddFDA('396', '+1', '4.7', FMRequestDate.FMCtrlInternal);
        end;
      end
      else begin
        frmMain.FMValidator1.DisplayErrors;
        FMChk1.Text := FMChk1.FMTag;
      end;
    if FMChk2.FMModified then
      if FMChk2.Validate then begin
        FMFiler1.AddChgdControl(FMChk2);
        FMChk2.Text := FMChk2.FMCtrlExternal;
        if FMChk2.Text[1] = 'Y' then begin
          frmMain.FMValidator1.Setup('396', '+1', '5.5', 'P'); // Set Status to Pending
          FMFiler1.AddFDA('396', '+1', '5.5', 'P');
          frmMain.FMValidator1.Setup('396', '+1', '5.6', RoutingLocationInternal);
          FMFiler1.AddFDA('396', '+1', '5.6', RoutingLocationInternal);
          frmMain.FMValidator1.Setup('396', '+1', '5.7', FMRequestDate.FMCtrlInternal); // Tran Date
          FMFiler1.AddFDA('396', '+1', '5.7', FMRequestDate.FMCtrlInternal);
        end;
      end
      else begin
        frmMain.FMValidator1.DisplayErrors;
        FMChk2.Text := FMChk2.FMTag;
      end;
    if FMChk3.FMModified then
      if FMChk3.Validate then begin
        FMFiler1.AddChgdControl(FMChk3);
        FMChk3.Text := FMChk3.FMCtrlExternal;
        if FMChk3.Text[1] = 'Y' then begin
          frmMain.FMValidator1.Setup('396', '+1', '6.5', 'P'); // Set Status to Pending
          FMFiler1.AddFDA('396', '+1', '6.5', 'P');
          frmMain.FMValidator1.Setup('396', '+1', '6.6', RoutingLocationInternal);
          FMFiler1.AddFDA('396', '+1', '6.6', RoutingLocationInternal);
          frmMain.FMValidator1.Setup('396', '+1', '6.7', FMRequestDate.FMCtrlInternal); // Tran Date
          FMFiler1.AddFDA('396', '+1', '6.7', FMRequestDate.FMCtrlInternal);
        end;
      end
      else begin
        frmMain.FMValidator1.DisplayErrors;
        FMChk3.Text := FMChk3.FMTag;
      end;
    if FMChk4.FMModified then
      if FMChk4.Validate then begin
        FMFiler1.AddChgdControl(FMChk4);
        FMChk4.Text := FMChk4.FMCtrlExternal;
        if FMChk4.Text[1] = 'Y' then begin
          frmMain.FMValidator1.Setup('396', '+1', '8', 'P'); // Set Status to Pending
          FMFiler1.AddFDA('396', '+1', '8', 'P');
          frmMain.FMValidator1.Setup('396', '+1', '7.6', RoutingLocationInternal);
          FMFiler1.AddFDA('396', '+1', '7.6', RoutingLocationInternal);
          frmMain.FMValidator1.Setup('396', '+1', '7.7', FMRequestDate.FMCtrlInternal); // Tran Date
          FMFiler1.AddFDA('396', '+1', '7.7', FMRequestDate.FMCtrlInternal);
        end;
      end
      else begin
        frmMain.FMValidator1.DisplayErrors;
        FMChk4.Text := FMChk4.FMTag;
      end;
    if FMChk5.FMModified then
      if FMChk5.Validate then begin
        FMFiler1.AddChgdControl(FMChk5);
        FMChk5.Text := FMChk5.FMCtrlExternal;
        if FMChk5.Text[1] = 'Y' then begin
          frmMain.FMValidator1.Setup('396', '+1', '10', 'P'); // Set Status to Pending
          FMFiler1.AddFDA('396', '+1', '10', 'P');
          frmMain.FMValidator1.Setup('396', '+1', '9.6', RoutingLocationInternal);
          FMFiler1.AddFDA('396', '+1', '9.6', RoutingLocationInternal);
          frmMain.FMValidator1.Setup('396', '+1', '9.7', FMRequestDate.FMCtrlInternal); // Tran Date
          FMFiler1.AddFDA('396', '+1', '9.7', FMRequestDate.FMCtrlInternal);
        end;
      end
      else begin
        frmMain.FMValidator1.DisplayErrors;
        FMChk5.Text := FMChk5.FMTag;
      end;
    if FMChk6.FMModified then
      if FMChk6.Validate then begin
        FMFiler1.AddChgdControl(FMChk6);
        FMChk6.Text := FMChk6.FMCtrlExternal;
        if FMChk6.Text[1] = 'Y' then begin
          frmMain.FMValidator1.Setup('396', '+1', '12', 'P'); // Set Status to Pending
          FMFiler1.AddFDA('396', '+1', '12', 'P');
          frmMain.FMValidator1.Setup('396', '+1', '11.6', RoutingLocationInternal);
          FMFiler1.AddFDA('396', '+1', '11.6', RoutingLocationInternal);
          frmMain.FMValidator1.Setup('396', '+1', '11.7', FMRequestDate.FMCtrlInternal); // Tran Date
          FMFiler1.AddFDA('396', '+1', '11.7', FMRequestDate.FMCtrlInternal);
        end;
      end
      else begin
        frmMain.FMValidator1.DisplayErrors;
        FMChk6.Text := FMChk6.FMTag;
      end;
    if FMChk7.FMModified then
      if FMChk7.Validate then begin
        FMFiler1.AddChgdControl(FMChk7);
        FMChk7.Text := FMChk7.FMCtrlExternal;
        if FMChk7.Text[1] = 'Y' then begin
          frmMain.FMValidator1.Setup('396', '+1', '14', 'P'); // Set Status to Pending
          FMFiler1.AddFDA('396', '+1', '14', 'P');
          frmMain.FMValidator1.Setup('396', '+1', '13.6', RoutingLocationInternal);
          FMFiler1.AddFDA('396', '+1', '13.6', RoutingLocationInternal);
          frmMain.FMValidator1.Setup('396', '+1', '13.7', FMRequestDate.FMCtrlInternal); // Tran Date
          FMFiler1.AddFDA('396', '+1', '13.7', FMRequestDate.FMCtrlInternal);
        end;
      end
      else begin
        frmMain.FMValidator1.DisplayErrors;
        FMChk7.Text := FMChk7.FMTag;
      end;
    if FMChk8.FMModified then
      if FMChk8.Validate then begin
        FMFiler1.AddChgdControl(FMChk8);
        FMChk8.Text := FMChk8.FMCtrlExternal;
        if FMChk8.Text[1] = 'Y' then begin
          frmMain.FMValidator1.Setup('396', '+1', '16', 'P'); // Set Status to Pending
          FMFiler1.AddFDA('396', '+1', '16', 'P');
          frmMain.FMValidator1.Setup('396', '+1', '15.6', RoutingLocationInternal);
          FMFiler1.AddFDA('396', '+1', '15.6', RoutingLocationInternal);
          frmMain.FMValidator1.Setup('396', '+1', '15.7', FMRequestDate.FMCtrlInternal); // Tran Date
          FMFiler1.AddFDA('396', '+1', '15.7', FMRequestDate.FMCtrlInternal);
        end;
      end
      else begin
        frmMain.FMValidator1.DisplayErrors;
        FMChk8.Text := FMChk8.FMTag;
      end;
    if FMChk9.FMModified then
      if FMChk9.Validate then begin
        FMFiler1.AddChgdControl(FMChk9);
        FMChk9.Text := FMChk9.FMCtrlExternal;
        if FMChk9.Text[1] = 'Y' then begin
          frmMain.FMValidator1.Setup('396', '+1', '17.4', 'P'); // Set Status to Pending
          FMFiler1.AddFDA('396', '+1', '17.4', 'P');
          frmMain.FMValidator1.Setup('396', '+1', '17.6', RoutingLocationInternal);
          FMFiler1.AddFDA('396', '+1', '17.6', RoutingLocationInternal);
          frmMain.FMValidator1.Setup('396', '+1', '17.7', FMRequestDate.FMCtrlInternal); // Tran Date
          FMFiler1.AddFDA('396', '+1', '17.7', FMRequestDate.FMCtrlInternal);
        end;
      end
      else begin
        frmMain.FMValidator1.DisplayErrors;
        FMChk9.Text := FMChk9.FMTag;
      end;
    if FMChk10.FMModified then
      if FMChk10.Validate then begin
        FMFiler1.AddChgdControl(FMChk10);
        FMChk10.Text := FMChk10.FMCtrlExternal;
        if FMChk10.Text[1] = 'Y' then begin
          frmMain.FMValidator1.Setup('396', '+1', '21', 'P'); // Set Status to Pending
          FMFiler1.AddFDA('396', '+1', '21', 'P');
          frmMain.FMValidator1.Setup('396', '+1', '20.6', RoutingLocationInternal);
          FMFiler1.AddFDA('396', '+1', '20.6', RoutingLocationInternal);
          frmMain.FMValidator1.Setup('396', '+1', '20.7', FMRequestDate.FMCtrlInternal); // Tran Date
          FMFiler1.AddFDA('396', '+1', '20.7', FMRequestDate.FMCtrlInternal);
        end;
      end
      else begin
        frmMain.FMValidator1.DisplayErrors;
        FMChk10.Text := FMChk10.FMTag;
      end;
    if FMTxReport.FMModified then
      if FMTxReport.Validate then begin
        FMFiler1.AddChgdControl(FMTxReport);
        FMTxReport.Text := FMTxReport.FMCtrlExternal;
        if FMTxReport.Text <> '' then begin
          frmMain.FMValidator1.Setup('396', '+1', '19', 'P'); // Set Status to Pending
          FMFiler1.AddFDA('396', '+1', '19', 'P');
          frmMain.FMValidator1.Setup('396', '+1', '18.6', RoutingLocationInternal);
          FMFiler1.AddFDA('396', '+1', '18.6', RoutingLocationInternal);
          frmMain.FMValidator1.Setup('396', '+1', '18.7', FMRequestDate.FMCtrlInternal); // Tran Date
          FMFiler1.AddFDA('396', '+1', '18.7', FMRequestDate.FMCtrlInternal);
        end;
      end
      else begin
        frmMain.FMValidator1.DisplayErrors;
        FMTxReport.Text := FMTxReport.FMTag;
      end;
    if FMAdmissionDate.FMModified then
      if FMAdmissionDate.Validate then begin
        FMFiler1.AddChgdControl(FMAdmissionDate);
        FMAdmissionDate.Text := FMAdmissionDate.FMCtrlExternal;
      end
      else begin
        frmMain.FMValidator1.DisplayErrors;
        FMAdmissionDate.Text := FMAdmissionDate.FMTag;
      end;
    if FMCommentsMemo.Lines.Count > 0 then
      FMFiler1.AddChgdControl(FMCommentsMemo);
    // Add to the 7131 File 396

    for x := 0 to 10 do begin
    end; // For some reason, Delphi doesn't compile correctly unless some code is here...
    for x := 0 to 10 do begin
    end; // For some reason, Delphi doesn't compile correctly unless some code is here...
    for x := 0 to 10 do begin
    end; // For some reason, Delphi doesn't compile correctly unless some code is here...
    for x := 0 to 10 do begin
    end; // For some reason, Delphi doesn't compile correctly unless some code is here...
    for x := 0 to 10 do begin
    end; // For some reason, Delphi doesn't compile correctly unless some code is here...
    for x := 0 to 10 do begin
    end; // For some reason, Delphi doesn't compile correctly unless some code is here...
    for x := 0 to 10 do begin
    end; // For some reason, Delphi doesn't compile correctly unless some code is here...
    for x := 0 to 10 do begin
    end; // For some reason, Delphi doesn't compile correctly unless some code is here...
    for x := 0 to 10 do begin
    end; // For some reason, Delphi doesn't compile correctly unless some code is here...
    for x := 0 to 10 do begin
    end; // For some reason, Delphi doesn't compile correctly unless some code is here...
    if FMFiler1.AnythingToFile then begin
      if FMFiler1.DataProblemCheck then begin
        for x := 0 to 10 do begin
        end; // For some reason, Delphi doesn't compile correctly unless some code is here...
        FMFiler1.ProcessDataProblemList
      end
      else
        if FMFiler1.Update then begin
          for x := 0 to 10 do begin
          end; // For some reason, Delphi doesn't compile correctly unless some code is here...
          //AddRequestIEN:=FMFiler1.FindIen('+1,')+',';
          //
          ModalResult := mrOK;
          exit;
        end;
    end
    else
    ShowMessageCAPRI('No changes to file!');
  end;
end;

procedure TfrmNew7131.FMRoutingLocationExit(Sender: TObject);
var
  x: integer;
begin
  if FMRoutingLocation.Text = '' then
    exit;
  for x := 0 to FMRoutingLocation.Items.Count - 1 do
    if Pos(uppercase(FMRoutingLocation.Text), uppercase(FMRoutingLocation.Items[x])) = 1 then begin
      FMRoutingLocation.ItemIndex := x;
    end;
  if FMRoutingLocation.ItemIndex = -1 then begin
    ShowMessageCAPRI('The Routing Location response is not valid.');
    FMRoutingLocation.Text := '';
    try
    FMRoutingLocation.SetFocus except
    end;
    exit;
  end;
  FMRoutingLocationFake.Text := '`' + Piece(FMRoutingLocation.Items[FMRoutingLocation.ItemIndex], '^', 2);
end;

procedure TfrmNew7131.FMRegionalOfficeNumberExit(Sender: TObject);
begin
  FMRegionalOfficeNumberFake.Text := Copy(FMRegionalOfficeNumber.Text, 1, 30);
end;

procedure TfrmNew7131.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked = True then begin
    ShowMessageCAPRI('NOTE: If patient is already d/c''ed, you will not receive notification.');
  end;
end;

procedure TfrmNew7131.FormActivate(Sender: TObject);
begin
  if FMRegionalOfficeNumber.Text = '' then
    FMRegionalOfficeNumber.enabled := True
  else
    FMRegionalOfficeNumber.enabled := False;
  RadioGroup1Click(application);
  Set508ControlOptions; // -MER CodeCR118 8/2010
  try
  Radiogroup1.SetFocus except
  end;
end;

procedure TfrmNew7131.FMRegionalOfficeNumberEnter(Sender: TObject);
var
  tempstring: string;
begin
  FMRegionalOfficeNumber.Text := '';
  FMRegionalOfficeNumberFake.Text := '';
  if frmROFinder.ShowModal = mrOK then
  begin
    tempString := frmROFinder.GetCurrentROName;  //CodeCR170 - rpm 3/10/11
    FMRegionalOfficeNumber.Text := tempstring;
    FMRegionalOfficeNumberFake.Text := tempstring;
  end;
  // -MER CodeCR118 11/2010
  // note: since this combo box is being used in a non-conventional way, it is
  // necessary for focus to pass to the next control to behave as the users are
  // accustomed
  if (ActiveControl = FMRegionalOfficeNumber) then
    SelectNext(ActiveControl as TWinControl, TRUE, TRUE);
  exit;
end;

procedure TfrmNew7131.FMCommentsMemoEnter(Sender: TObject);
begin
  FEditCtrl := FMCommentsMemo;
end;

procedure TfrmNew7131.CCOWTimerTimer(Sender: TObject);
begin
  if ShutdownCAPRIModalDialogs = true then begin
    CCOWTimer.Enabled := False;
    modalresult := mrCancel;
    frmNew7131.visible := false;
  end;
end;

procedure TfrmNew7131.RadioGroup1Click(Sender: TObject);
begin
  if RadioGroup1.ItemIndex = 0 then begin
    FMDocumentType.Text := 'L'; //  A=Admission
    Checkbox1.Checked := False;
    Checkbox2.Checked := False;
    Checkbox3.Checked := False;
    Checkbox9.Checked := False;
    Checkbox1.Enabled := False;
    Checkbox2.Enabled := False;
    Checkbox3.Enabled := False;
    Checkbox9.Enabled := False;
    GroupBox1.Visible := False;
    ListBox4.ItemIndex := -1;
  end;
  if RadioGroup1.ItemIndex = 1 then begin
    FMDocumentType.Text := 'A'; //  A=Admission
    Checkbox1.Enabled := True;
    Checkbox2.Enabled := True;
    Checkbox3.Enabled := True;
    Checkbox9.Enabled := True;
    GroupBox1.Visible := True;
  end;
  Panel2.Visible := True;
end;

//CCAPRI_CodeCR96 - jcs - 03/16/10
procedure TfrmNew7131.WMMenuChar(var Message: TWMMenuChar);
begin
  If Not ActivateMenu(self, Message) then
    Inherited;
end;

{==============================================================================
  Set508ControlOptions
    Set508ControlOptions is a method that will set UI controls to be compatible
      with screen readers if a screen reader is active.  If a screen reader is
      not active, the 508 text components are hidden

  Modification History:
    CodeCR118 - 8/2010 Method created -MER
 ==============================================================================}
procedure TfrmNew7131.Set508ControlOptions;
begin
  if (UpdateEditBoxesForScreenReader(self)) then begin
    // A screen reader is active
    // Set up the static text accessibility controls for disabled combo box
    if not(FMRegionalOfficeNumber.Enabled) then begin
      st508RegionalOfficeNumber.Caption := 'Regional Office: Read Only.  Value is ' + FMRegionalOfficeNumber.Text;
      st508RegionalOfficeNumber.Visible := TRUE;
    end else begin
      st508RegionalOfficeNumber.Visible := FALSE;
    end;
  end else begin
    // a screen reader is not active
    st508RegionalOfficeNumber.Visible := FALSE;
  end;
end; // Set508ControlOptions

end.
