Unit news;

Interface

Uses
  Windows,
  Messages,
  Classes,
  ComCtrls,
  Controls,
  Dialogs,
  ExtCtrls,
  Forms,
  Graphics,
  Grids,
  HyperlinkLabel,
  StdCtrls,
  SysUtils, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, IdHTTP,
  VA508AccessibilityManager, VAUtils;

Type
  TformNews = Class(TForm)
    Button1: TButton;
    Button2: TButton;
    DrawGridNews: TDrawGrid;
    Edit1: TEdit;
    ImageHighPriority: TImage;
    ImageLowPriority: TImage;
    RichEditNews: TRichEdit;
    RichEditNewsViewed: TRichEdit;
    xHyperlinkLabel1: THyperlinkLabel;
    IdHTTP1: TIdHTTP;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    Procedure Button1Click(Sender: TObject);
    Procedure Button2Click(Sender: TObject);
    Procedure DrawGridNewsDblClick(Sender: TObject);
    Procedure DrawGridNewsDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
    Procedure DrawGridNewsKeyPress(Sender: TObject; Var Key: Char);
    Procedure FormActivate(Sender: TObject);
    Procedure FormCloseQuery(Sender: TObject; Var CanClose: Boolean);
    Procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
  Private
    { Private declarations }
  Public
    { Public declarations }
    Procedure GetURL(URLIn: String; var aStream: TMemoryStream);
  End;

Var
  formNews: TformNews;

Implementation

Uses main;

{$R *.DFM}

Procedure TformNews.FormCloseQuery(Sender: TObject; Var CanClose: Boolean);
Begin
  Button1Click(Application);
End;

Procedure TformNews.Button1Click(Sender: TObject);
Begin
  // Save View Info
  formNews.RichEditNewsViewed.Lines.SaveToFile(tempDir + 'CAPRINewsReadInfo.txt');
  modalResult := mrOK;
End;

Procedure TformNews.DrawGridNewsDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
Var
  S: String;
  TextCol: Integer;
  Viewed: Boolean;
  inVal: Integer;
Begin
  TextCol := 1;
  If ACol = 0 Then
    TextCol := 1; // Status
  If ACol = 1 Then
    TextCol := 3; // Date/Time
  If ACol = 2 Then
    TextCol := 4; // Title
  S := frmMain.Piece(RichEditNews.Lines[ARow], '^', TextCol);
  // Check if viewed yet
  Viewed := False;
  Try
    inVal := strtoint(frmMain.Piece(richEditNews.Lines[ARow], '^', 2));
    If inVal < richEditNewsViewed.Lines.Count + 1 Then
    Begin
      If RichEditNewsViewed.Lines[strtoint(frmMain.Piece(richEditNews.Lines[ARow], '^', 2))] = 'Y' Then
        Viewed := True;
    End;
  Except
  End;
  With (Sender As TDrawGrid) Do
  Begin
    With Canvas Do
    Begin
      (*
           if (gdSelected in State) then begin
              Font.Color := clWhite;
              Brush.Color := clNAvy;
              FillRect(Rect); // fill rectangle with navy
            end else
            *)
      If (Viewed = False) and not (VAUtils.ScreenReaderActive) Then  // -MER CodeCR113 10/2010
      Begin
        Font.Color := clBlack;
        Brush.Color := clYellow;
        FillRect(Rect); // fill rectangle with yellow
      End;
      // Next, draw the text in the rectangle
      If ACol > 0 Then
        TextOut(Rect.Left + 2, Rect.Top + 2, S)
      Else
      Begin
        If (S = '') Or (S = '2') Then
        Begin
          DrawGridNews.Canvas.Draw(Rect.Left + 2, Rect.Top + 2, ImageHighPriority.Picture.Graphic);
        End
        Else
        Begin
          If S = '0' Then
            DrawGridNews.Canvas.Draw(Rect.Left + 2, Rect.Top + 2, ImageLowPriority.Picture.Graphic);
        End;
      End;
    End;
  End;
End;

Procedure TformNews.FormResize(Sender: TObject);
Begin
  //DrawGridNews.ColWidths[2]:=DrawGridNews.Width-4-DrawGridNews.ColWidths[0]-DrawGridNews.ColWidths[1];
End;

procedure TformNews.FormShow(Sender: TObject); // -MER CodeCR166 3/2011
var
  lRow: integer;
begin
  //  -MER CodeCR166 3/2011 The following code used to be included in method
  //  DrawGridNewsDrawCell.  When there were no items to display, setting
  //  rowCount was resulting in an infinite event loop.  The sizing statements
  //  were moved as well so they wouldn't be executed repeatedly
  for lRow := 0 to DrawGridNews.RowCount - 1 do
    DrawGridNews.RowHeights[lRow] := 18;
  DrawGridNews.ColWidths[0] := 20;
  DrawGridNews.ColWidths[1] := 140;
  DrawGridNews.ColWidths[2] := DrawGridNews.Width - 23 - DrawGridNews.ColWidths[0] - DrawGridNews.ColWidths[1];
  DrawGridNews.RowCount := RichEditNews.Lines.Count - 1;
end;

Procedure TformNews.DrawGridNewsDblClick(Sender: TObject);
Var
  messageid: integer;
Begin
  messageid := strtoint(frmMain.Piece(richEditNews.Lines[DrawGridNews.Row], '^', 2));
  // Save read info
  If messageID < richEditNewsViewed.Lines.Count Then
  Begin
    richEditNewsViewed.Lines[messageID] := 'Y';
  End
  Else
  Begin
    Repeat
      richEditNewsViewed.Lines.Add('')
    Until richEditNewsViewed.Lines.Count = messageID + 1;
    richEditNewsViewed.Lines[messageID] := 'Y';
  End;
  xHyperLinkLabel1.TargetURL := frmMain.Piece(richEditNews.lines[DrawGridNews.Row], '^', 5);
  xHyperLinkLabel1.Navigate;

  // Check if clear button should be disabled
  FormActivate(application);

  // Execute command from news file
End;

Procedure TformNews.FormActivate(Sender: TObject);
Var
  x: integer;
  tempflag: boolean;
Begin
  tempflag := false;
  If richEditNews.Lines.Count > 0 Then
  Begin
    For x := 0 To richEditNews.Lines.Count - 1 Do
    Begin
      If copy(trim(uppercase(richEditNews.Lines[x])), 1, 4) <> ';END' Then
      Begin
        Try
          If strtoint(frmMain.Piece(richEditNews.Lines[x], '^', 2)) > richEditNewsViewed.Lines.Count + 1 Then
          Begin
            If RichEditNewsViewed.Lines[strtoint(frmMain.Piece(richEditNews.Lines[x], '^', 2))] <> 'Y' Then
            Begin
              TempFlag := True;
            End;
          End;
        Except
        End;
      End;
    End;
  End;
  If TempFlag = false Then
    button2.enabled := true
  Else
    button2.enabled := true;
End;

Procedure TformNews.Button2Click(Sender: TObject);
Var
  y, messageid: integer;
Begin
  For y := 0 To DrawGridNews.RowCount - 1 Do    
  Begin
    messageid := strtoint(frmMain.Piece(richEditNews.Lines[y], '^', 2));
    // Save read info
    If messageID < richEditNewsViewed.Lines.Count Then
    Begin
      richEditNewsViewed.Lines[messageID] := 'Y';
    End
    Else
    Begin
      Repeat
        richEditNewsViewed.Lines.Add('')
      Until richEditNewsViewed.Lines.Count = messageID + 1;
      richEditNewsViewed.Lines[messageID] := 'Y';
    End;
  End;
  Button1Click(Application);
  // Execute command from news file
End;

Procedure TformNews.DrawGridNewsKeyPress(Sender: TObject; Var Key: Char);
Begin
  If key = char(32) Then
    DrawGridNewsDblClick(application);
End;

Procedure TformNews.GetURL(URLIn: String; var aStream: TMemoryStream);
begin
  try
    idHTTP1.Get(URLIn, aStream);
    idHTTP1.Disconnect;
    aStream.Position := 0;
  except
    //Don't do anything. There is no need to bother the user if we fail to
    //retrieve the news, as network timeouts occasionally occur and this is
    //triggered by a timer.
  end;
end;

End.
