Unit patientlist;

Interface

Uses
  Windows,
  Buttons,
  Classes,
  Controls,
  Diaccess,
  Dialogs,
  DialogsCAPRI,
  ExtCtrls,
  Fmcmpnts,
  Fmcntrls,
  Forms,
  Gauges,
  Graphics,
  Messages,
  ORCtrls,
  StdCtrls,
  SysUtils,
  TRPCB,
  VERGENCECONTEXTORLib_TLB,
  CCOWRPCBrokerCAPRI;

Type
  TPatientFilterType = (pfNormal, pfFeeBasis, pfDOD);  //CodeCR124 -MER 07/2010
  TfrmPatientList = Class(TForm)
    btnCvrCancelPt             : TButton;
    btnCvrDemographicsPt       : TButton;
    btnCvrEnterNewPt           : TButton;
    btnCvrMorePt               : TButton;
    btnCvrSelectPt             : TButton;
    btnCvrTimerPt              : TTimer;
    btnSearch                  : TButton;
    Button1                    : TButton;
    buttonEdit                 : TButton;
    ButtonOtherSites           : TButton;
    CCOWClose                  : TTimer;
    CCOWTimer                  : TTimer;
    FMCvrAgePt                 : TFMLabel;
    FMCvrBirthdatePt           : TFMLabel;
    FMCvrCNumberPt             : TFMLabel;
    FMCvrGets1Pt               : TFMGets;
    FMCvrICNPt                 : TFMLabel;
    FMCvrListBox1Pt            : TFMListBox;
    FMCvrListBox2Pt            : TFMListBox;
    FMCvrListBox3Pt            : TFMListBox;
    FMCvrLister1Pt             : TFMLister;
    FMCvrLister2Pt             : TFMLister;
    FMCvrLister3Pt             : TFMLister;
    FMCvrNamePt                : TFMLabel;
    FMCvrRoomBedPt             : TFMLabel;
    FMCvrSexPt                 : TFMLabel;
    FMCvrSSNPt                 : TFMLabel;
    FMCvrWardPt                : TFMLabel;
    GroupBoxCvr1Pt             : TGroupBox;
    LabelCvrCNumberPt          : TLabel;
    LabelCvrICNPt              : TLabel;
    LabelCvrSSN                : TLabel;
    LabelCvrWard               : TLabel;
    LabelID                    : TLabel;
    LabelStatus                : TLabel;
    ORListBoxRestrictedPatients: TORComboBox;
    PanelAuthorizedPatients    : TGroupBox;
    PanelCvr1Pt                : TPanel;
    Patient_ID                 : TEdit;
    ScrollBox1                 : TScrollBox;
    TimerCloseIt               : TTimer;
    TimerCloseIt2              : TTimer;
    TimerWait                  : TTimer;
    TimerWait2                 : TTimer;
    Procedure btnCvrCancelPtClick(Sender: TObject);
    Procedure btnCvrDemographicsPtClick(Sender: TObject);
    Procedure btnCvrEnterNewPtClick(Sender: TObject);
    Procedure btnCvrMorePtClick(Sender: TObject);
    Procedure btnCvrSelectPtClick(Sender: TObject);
    Procedure btnCvrTimerPtTimer(Sender: TObject);
    Procedure btnSearchClick(Sender: TObject);
    Procedure Button1Click(Sender: TObject);
    Procedure buttonEditClick(Sender: TObject);
    Procedure ButtonOtherSitesClick(Sender: TObject);
    Procedure CCOWCloseTimer(Sender: TObject);
    Procedure CCOWTimerTimer(Sender: TObject);
    Procedure CheckRestrictedFMCvrListBox1Pt;
    Procedure CheckRestrictedFMCvrListBox2Pt;
    Procedure CheckRestrictedFMCvrListBox3Pt;
    Procedure FMCvrListBox1PtClick(Sender: TObject);
    Procedure FMCvrListBox1PtDblClick(Sender: TObject);
    Procedure FormActivate(Sender: TObject);
    Procedure FormCreate(Sender: TObject);
    Procedure ORListBoxRestrictedPatientsClick(Sender: TObject);
    Procedure ORListBoxRestrictedPatientsDblClick(Sender: TObject);
    Procedure ORListBoxRestrictedPatientsKeyPress(Sender: TObject;Var Key: Char);
    Procedure Patient_IDChange(Sender: TObject);
    Procedure Patient_IDKeyPress(Sender: TObject; Var Key: Char);
    Procedure TimerCloseIt2Timer(Sender: TObject);
    Procedure TimerCloseItTimer(Sender: TObject);
    Procedure TimerWait2Timer(Sender: TObject);
    Procedure TimerWaitTimer(Sender: TObject);
    procedure FormShow(Sender: TObject);
  Private
    { Private declarations }
    FBHIEInstitutionIEN: String;  //CodeCR131 rpm 12/8/2010
    procedure ConfigurePatientFiltering; //CodeCR124 -MER 07/2010
  Public
    { Public declarations }
    PatientFilterType: TPatientFilterType;  //CodeCR124 -MER 07/2010
    property BHIEInstitutionIEN : String
      read FBHIEInstitutionIEN write FBHIEInstitutionIEN;  //CodeCR131 rpm 12/8/2010
  End;

Var
  CCOWPatientIEN     : String;
  CCOWPatientName    : String;
  clickedyet         : boolean;
  frmPatientList     : TfrmPatientList;
  lastpatientsearched: String;
  processingtimer    : boolean;
  ShutDownSwitchSites: Boolean;
  SiteNum            : String;
  TimerCount         : Integer;
  timercount2        : Integer;

Implementation

Uses
  caprisupport,
  editpt,
  enterpt,
  enterpt140,
  enterptsimple,
  enterptsimple140,
  essoselect,
  fmrptrecordflags,
  main,
  remotesitepick,
  REPORTS,
  rofinder;

{$R *.DFM}

Function DevPCode(P: TEdit): Boolean;
Var
  PCode: String;
  lst: TStringList;
  TempFile: String;
Begin
  Result := False;
  Try
    If Trim(TempDir) = '' Then
      Exit;
    TempFile := TempDir + 'capriqrzdev.txt';
    If Not FileExists(TempFile) Then
      Exit;
    lst := TStringList.Create();
    Try
      lst.LoadFromFile(TempFile);
      PCode := lst.Values['PCode'];
      If P <> Nil Then
      Begin
        If PCode <> '' Then
        Begin
          P.Text := PCode;
        End;
      End;
      Result := True;
    Finally
      FreeAndNil(lst);
    End;
  Except
  End;
End;

Procedure TfrmPatientList.CheckRestrictedFMCvrListBox1Pt;
Var
  x, xx: integer;
  matchflag: boolean;
  tempSSN: String;
Begin
  If FMCvrListBox1Pt.Items.Count = 0 Then
    exit;
  btnCvrTimerPt.enabled := false;
  FMCvrListBox1Pt.Visible := False;
  If FMCvrListBox1Pt.Items.Count > 0 Then
    For x := FMCvrListBox1Pt.Items.Count - 1 Downto 0 Do
      If ListRestrictedPatients.Count > 0 Then
      Begin
        matchflag := false;
        FMCvrListBox1Pt.ItemIndex := x;
        FMCvrGets1Pt.IENS := FMCvrListBox1Pt.GetselectedRecord.IEN;
        FMCvrGets1Pt.GetData;
        TempSSN := FMCvrGets1Pt.GetField('.09').FMDBExternal;
        For xx := 0 To ListRestrictedPatients.Count - 1 Do
        Begin
          //Get ssn and compare to 3rd piece
          If frmMain.Piece(ListRestrictedPatients[xx], '^', 3) = TempSSN Then
            matchflag := true;
        End;
        If MatchFlag <> true Then
          FMCvrListBox1Pt.Items.Delete(x);
      End;
  FMCvrListBox1Pt.ItemIndex := -1;
  FMCvrListBox1Pt.Visible := True;
  btnCvrTimerPt.enabled := true;
End;

Procedure TfrmPatientList.CheckRestrictedFMCvrListBox2Pt;
Var
  x, xx: integer;
  matchflag: boolean;
  tempSSN: String;
Begin
  If FMCvrListBox2Pt.Items.Count = 0 Then
    exit;
  btnCvrTimerPt.enabled := false;
  FMCvrListBox2Pt.Visible := False;
  If FMCvrListBox2Pt.Items.Count > 0 Then
    For x := FMCvrListBox2Pt.Items.Count - 1 Downto 0 Do
      If ListRestrictedPatients.Count > 0 Then
      Begin
        matchflag := false;
        FMCvrListBox2Pt.ItemIndex := x;
        FMCvrGets1Pt.IENS := FMCvrListBox2Pt.GetselectedRecord.IEN;
        FMCvrGets1Pt.GetData;
        TempSSN := FMCvrGets1Pt.GetField('.09').FMDBExternal;
        For xx := 0 To ListRestrictedPatients.Count - 1 Do
        Begin
          //Get ssn and compare to 3rd piece
          If frmMain.Piece(ListRestrictedPatients[xx], '^', 3) = TempSSN Then
            matchflag := true;
        End;
        If MatchFlag <> true Then
          FMCvrListBox2Pt.Items.Delete(x);
      End;
  FMCvrListBox2Pt.ItemIndex := -1;
  FMCvrListBox2Pt.Visible := True;
  btnCvrTimerPt.enabled := true;
End;

Procedure TfrmPatientList.CheckRestrictedFMCvrListBox3Pt;
Var
  x, xx: integer;
  matchflag: boolean;
  tempSSN: String;
Begin
  If FMCvrListBox3Pt.Items.Count = 0 Then
    exit;
  btnCvrTimerPt.enabled := false;
  FMCvrListBox3Pt.Visible := False;
  If FMCvrListBox3Pt.Items.Count > 0 Then
    For x := FMCvrListBox3Pt.Items.Count - 1 Downto 0 Do
      If ListRestrictedPatients.Count > 0 Then
      Begin
        matchflag := false;
        FMCvrListBox3Pt.ItemIndex := x;
        FMCvrGets1Pt.IENS := FMCvrListBox3Pt.GetselectedRecord.IEN;
        FMCvrGets1Pt.GetData;
        TempSSN := FMCvrGets1Pt.GetField('.09').FMDBExternal;
        For xx := 0 To ListRestrictedPatients.Count - 1 Do
        Begin
          //Get ssn and compare to 3rd piece
          If frmMain.Piece(ListRestrictedPatients[xx], '^', 3) = TempSSN Then
            matchflag := true;
        End;
        If MatchFlag <> true Then
          FMCvrListBox3Pt.Items.Delete(x);
      End;
  FMCvrListBox3Pt.ItemIndex := -1;
  FMCvrListBox3Pt.Visible := True;
  btnCvrTimerPt.enabled := true;
End;

Procedure TfrmPatientList.FormActivate(Sender: TObject);
Var
  anItem, anItem2: IContextItem;
  data: IContextItemCollection;
  FoundRestrictedPt: Boolean;
  temptext: String;
  x: integer;
Begin
  DevPCode(Patient_ID);
  If (essoversion = true) Then
  Begin
    btnSearch.enabled := true;
  End
  Else
  Begin
    btnSearch.visible := false;
    btnCvrCancelPt.Width := 113;
    btnCvrSelectPt.Left := 400;
    btnCvrSelectPt.Width := 121;
  End;

  If switchtosite <> '' Then
  Begin
    // This is called from main.pas
    // frmPatientList.Visible:=False;      <----------------------------------------------------------------
    ShutDownSwitchSites := True;
    TimerWait.Enabled := True;
    exit;
  End;

  height := 0;  //CodeCR124 - rpm 7/27/10
  width := 0;  //CodeCR124 - rpm 7/27/10

  ClickedYet := False;
  SwitchToSite := '';
  FMCvrListBox1Pt.Visible := True;
  FMCvrListBox2Pt.Visible := False;
  FMCvrListBox3Pt.Visible := False;
  LabelStatus.Caption := '';
  If PanelAuthorizedPatients.Enabled = True Then
    btnSearch.Enabled := False;
  If PanelAuthorizedPatients.Enabled = True Then
    PanelAuthorizedPatients.Setfocus;
  If PanelAuthorizedPatients.Enabled = False Then
  Begin
    If SwitchToPatientSSN <> '' Then
    Begin
      Patient_ID.Text := SwitchToPatientSSN;
      timercount := 4;
      btnCvrTimerPtTimer(application);
    End;
  End;
  If PanelAuthorizedPatients.Visible = False Then
  Begin
    buttonEdit.Visible := False;
    btnCvrEnterNewPt.left := btnCvrCancelPt.Left;
    btnCvrEnterNewPt.Width := (btnCvrSelectPt.Width + btnCvrSelectPt.Left) - btnCvrCancelPt.Left;
  End;
  CCOWPatientName := '';
  CCOWPatientIEN := '';
  If frmMain.bitbtnCCOWLinkBroken.Visible = False Then
    If EssoVersion = False Then
      If CCOWMode = True Then
        If CCOWInitialized = False Then
        Begin
          // Check context and try to set to that patient
          // Check limited pt. list, if applicable
          data := ContextorControl.CurrentContext;
          anItem := data.Present('Patient.ID.MRN.DFN_' + LocalStationNumber); // returns null if item not in context
          anItem2 := data.Present('Patient.co.PatientName'); // returns null if item not in context

          If (Nil = anItem) Then
          Begin
            //ShowMessageCAPRI('Item not present: ' +  APP_KEY_NAME);
          End
          Else
          Begin
            CCOWPatientIEN := anItem.value;
            // Check for CCOW patient on restricted list, if needed
            If PanelAuthorizedPatients.Enabled = True Then
            Begin
              // Do lookup of SSN on this IEN
              // Hide info used for lookup
              GroupBoxCvr1Pt.Visible := False;
              PanelCvr1Pt.Visible := True;
              FMCvrGets1Pt.IENS := CCOWPatientIEN;
              FMCvrGets1Pt.GetAndFill;
              FoundRestrictedPt := False;
              If ORListBoxRestrictedPatients.Items.Count > 0 Then
                For x := 0 To ORListBoxRestrictedPatients.Items.Count - 1 Do
                Begin
                  temptext := frmMain.Piece(ORListBoxRestrictedPatients.Items[x], '(', 2);
                  If temptext <> '' Then
                    temptext := copy(temptext, 1, length(temptext) - 1); // strip off ")" at end
                  If temptext = FMCvrSSNPt.Caption Then
                    FoundRestrictedPt := True;
                End;
              If FoundRestrictedPt = False Then
              Begin
                CCOWPatientIEN := '';
                anItem2 := Nil;
                // Couldn't find CCOW patient on restricted list
                // So go to blank pt.
                CCOWClose.enabled := true;
              End
              Else
              Begin
                CCOWPatientIEN := anItem.Value;
              End;
            End;
          End;
          If (Nil = anItem2) Then
          Begin
            //ShowMessageCAPRI('Item not present: ' +  APP_KEY_NAME);
          End
          Else
          Begin
            CCOWPatientName := anItem.value
          End;
        End;
  If CCOWPatientIEN <> '' Then
    btnCvrSelectPtClick(application);
  If CCOWPatientIEN <> '' Then
    Visible := False;  //CodeCR124 - rpm 7/27/10
  If CCOWMode <> True Then
  Begin
    height := 360;  //CodeCR124 - rpm 7/27/10
    width := 535;   //CodeCR124 - rpm 7/27/10
  End;
  If ((CCOWMode = True) And (ESSOVersion = False)) Then
  Begin
    If CCOWInitialized = True Then
    Begin
      height := 360;  //CodeCR124 - rpm 7/27/10
      width := 535;  //CodeCR124 - rpm 7/27/10
    End;
    If CCOWInitialized = False Then
      If CCOWPatientIEN = '' Then
      Begin
        // This code will essentially hide the patient selector by making it
        // small.  This avoids annoying flicker during CCOW context change
        height := 360;  //CodeCR124 - rpm 7/27/10
        width := 535;  //CodeCR124 - rpm 7/27/10
      End;
  End;
  Try
    Left := (frmMain.Width Div 2) + frmMain.Left - (Width Div 2);  //CodeCR124 - rpm 7/27/10
    Top := (frmMain.Height Div 2) + frmMain.Top - (Height Div 2);  //CodeCR124 - rpm 7/27/10
  Except
  End;

End;

Procedure TfrmPatientList.Patient_IDChange(Sender: TObject);
Begin
  If Patient_ID.Text = '<MORE>' Then
  Begin
    Patient_ID.Text := '';
    exit;
  End;

  btnCvrTimerPt.Enabled := True;
  If Patient_ID.Text = '' Then
  Begin
    FMCvrListBox1Pt.Items.Clear;
    btnCvrTimerPt.Enabled := False;
    btnCvrMorePt.Enabled := False;
    btnCvrDemographicsPt.Enabled := False;
  End;
  {Reset timer and clear patient info controls}
  TimerCount := 0;
  FMCvrNamePt.Caption := '';
  FMCvrSSNPt.Caption := '';
  FMCvrSexPt.Caption := '';
  FMCvrBirthdatePt.Caption := '';
  FMCvrAgePt.Caption := '';
  FMCvrWardPt.Caption := '';
  FMCvrRoomBedPt.Caption := '';
  FMCvrCNumberPt.Caption := '';
  FMCvrICNPt.Caption := '';
  LabelCvrCNumberPt.Visible := False;
  LabelCvrSSN.Visible := False;
  LabelCvrICNPt.Visible := False;
  LabelCvrWard.Visible := False;
End;

Procedure TfrmPatientList.FormCreate(Sender: TObject);
Var
  xx: integer;
Begin
  ProcessingTimer := False;
  PatientFilterType := pfNormal; //CodeCR124 -MER 07/2010
  FBHIEInstitutionIEN := '0';  //CodeCR131 - rpm 12/9/10
  If ReadOnlyMode = True Then
    btnCvrEnterNewPt.Enabled := False;

  ORListBoxRestrictedPatients.Items.Clear;
  If ListRestrictedPatients.Count > 0 Then
  Begin
    Patient_ID.Enabled := False;
    FMCvrListBox1Pt.Enabled := False;
    FMCvrListBox2Pt.Enabled := False;
    FMCvrListBox3Pt.Enabled := False;
    Try
    ORListBoxRestrictedPatients.Setfocus Except
    End;
    PanelAuthorizedPatients.Visible := True;
    PanelAuthorizedPatients.Enabled := True;
    PanelAuthorizedPatients.BringToFront;

    //Gauge1.MaxValue:=ListRestrictedPatients.Count-1;

    For xx := 0 To ListRestrictedPatients.Count - 1 Do
    Begin
      ORListBoxRestrictedPatients.Items.Add(frmMain.Piece(ListRestrictedPatients[xx], '^', 2) + ' (' + frmMain.Piece(ListRestrictedPatients[xx], '^', 3) + ')');
    End;
  End
  Else
  Begin
    PanelAuthorizedPatients.Visible := False;
    PanelAuthorizedPatients.Enabled := False;
  End;

  FMCvrLister2Pt.Number := '16'; //Set back to what it should be

  TimerCount := 0;
  FMCvrNamePt.Caption := '';
  FMCvrSSNPt.Caption := '';
  FMCvrSexPt.Caption := '';
  FMCvrBirthdatePt.Caption := '';
  FMCvrAgePt.Caption := '';
  FMCvrWardPt.Caption := '';
  FMCvrRoomBedPt.Caption := '';
  FMCvrCNumberPt.Caption := '';
  FMCvrICNPt.Caption := '';
  LabelCvrCNumberPt.Visible := False;
  LabelCvrSSN.Visible := False;
  LabelCvrICNPt.Visible := False;
  LabelCvrWard.Visible := False;
End;

procedure TfrmPatientList.FormShow(Sender: TObject);
begin
  ConfigurePatientFiltering; //CodeCR124 -MER 07/2010
end;

Procedure TfrmPatientList.btnCvrMorePtClick(Sender: TObject);
Begin
  btnCvrMorePt.enabled := false;
  btnCvrDemographicsPt.Enabled := False;
  FMCvrListBox1Pt.Enabled := False;
  FMCvrListBox2Pt.Enabled := False;
  FMCvrListBox3Pt.Enabled := False;
  btnCvrSelectPt.Enabled := False;
  buttonOtherSites.Enabled := False;
  FMCvrNamePt.Caption := '';
  FMCvrSSNPt.Caption := '';
  FMCvrSexPt.Caption := '';
  FMCvrBirthdatePt.Caption := '';
  FMCvrAgePt.Caption := '';
  FMCvrWardPt.Caption := '';
  FMCvrRoomBedPt.Caption := '';
  FMCvrCNumberPt.Caption := '';
  FMCvrICNPt.Caption := '';
  LabelCvrCNumberPt.Visible := False;
  LabelCvrSSN.Visible := False;
  LabelCvrICNPt.Visible := False;
  LabelCvrWard.Visible := False;
  Try
  FMCvrListBox1Pt.GetMore Except
  End;
  Try
  FMCvrListBox2Pt.GetMore Except
  End;
  Try
  FMCvrListBox3Pt.GetMore Except
  End;
  {Delete off last line of fileman result info}
  {Scroll List Down}
  If FMCvrListBox1Pt.Items.Count > 0 Then
  Begin
    FMCvrListBox1Pt.ItemIndex := FMCvrListBox1Pt.Items.Count - 1;
    FMCvrListBox1Pt.ItemIndex := -1;
    CheckRestrictedFMCvrListBox1Pt;
    FMCvrListBox1Pt.Enabled := True;
  End;
  If FMCvrListBox2Pt.Items.Count > 0 Then
  Begin
    FMCvrListBox2Pt.ItemIndex := FMCvrListBox2Pt.Items.Count - 1;
    FMCvrListBox2Pt.ItemIndex := -1;
    CheckRestrictedFMCvrListBox2Pt;
    FMCvrListBox2Pt.Enabled := True;
  End;
  If FMCvrListBox3Pt.Items.Count > 0 Then
  Begin
    FMCvrListBox3Pt.ItemIndex := FMCvrListBox3Pt.Items.Count - 1;
    FMCvrListBox3Pt.ItemIndex := -1;
    CheckRestrictedFMCvrListBox3Pt;
    FMCvrListBox3Pt.Enabled := True;
  End;

  Try
  Patient_ID.Setfocus Except
  End;

  TimerWait.Enabled := False;
  btnCvrTimerPt.Enabled := False;
  TimerCount := 0;

  btnCvrMorePt.enabled := true;
  btnCvrDemographicsPt.Enabled := true;
End;

Procedure TfrmPatientList.btnCvrTimerPtTimer(Sender: TObject);
Var
  x: integer;
Begin

  If (ANURemoteProcedureCallInProgress = True) Or (ProcessingTimer = True) Then
    exit;

  If (ProcessingTimer = True) And (TimerCount < 99) Then
    exit;
  ProcessingTimer := True;
  btnCvrSelectPt.Enabled := False;

  Inc(TimerCount);

  If PanelAuthorizedPatients.Visible = True Then
    If TimerCount = 4 Then
    Begin
      TimerCount := 0;
      // If patient changes, do a load of the pt id stuff
      If ORListBoxRestrictedPatients.ItemIndex > -1 Then
        If ORListBoxRestrictedPatients.Items[ORListBoxRestrictedPatients.ItemIndex] <> lastpatientsearched Then
        Begin
          ORListBoxRestrictedPatientsClick(Application)
        End;
      // In case they type a name not on the list...
      If ORListBoxRestrictedPatients.ItemIndex = -1 Then
        btnCvrSelectPt.Enabled := False;
      ProcessingTimer := False;

      Patient_ID.enabled := true;
      Try
      Patient_ID.SetFocus Except
      End;
      // Do a right arrow to get the cursor to the end
      keybd_event(VK_RIGHT, 0, 0, 0);
      exit;
    End;

  If TimerCount >= 4 Then
  Begin
    Patient_ID.enabled := false;
    If Copy(Patient_ID.Text, 1, 1) = '`' Then
      If
        Length(Patient_ID.Text) > 1 Then
      Begin
        // Do a FM-style tick lookup by IEN
        GroupBoxCvr1Pt.Visible := True;
        PanelCvr1Pt.Visible := False;
        FMCvrGets1Pt.IENS := Copy(Patient_ID.Text, 2, length(Patient_ID.Text) - 1);
        FMCvrSSNPt.Caption := '';
        FMCvrSSNPt.IENS := FMCvrGets1Pt.IENS;
        FMCvrGets1Pt.GetAndFill;
        If FMCvrSSNPt.Caption = '' Then
        Begin
          BtnCvrTimerPt.Enabled := True;
          LabelStatus.Visible := True;
          LabelStatus.Caption := 'No record found with that IEN.';
          Patient_ID.Text := '';
          //Patient_ID.OnChange(Application);
          ProcessingTimer := False;
          TimerCount := 0;
          ANURemoteProcedureCallInProgress := False;
          BtnCvrTimerPt.Enabled := True;
          Patient_ID.enabled := true;
          Try
          Patient_ID.SetFocus Except
          End;
          // Do a right arrow to get the cursor to the end
          keybd_event(VK_RIGHT, 0, 0, 0);
          exit;
        End;
        Patient_ID.Text := FMCvrSSNPt.Caption;
        ProcessingTimer := False;
        Patient_ID.OnChange(Application);
        TimerCount := 4;
        ANURemoteProcedureCallInProgress := False;
        BtnCvrTimerPt.Enabled := True;
        Patient_ID.enabled := true;
        Try
        Patient_ID.SetFocus Except
        End;
        // Do a right arrow to get the cursor to the end
        keybd_event(VK_RIGHT, 0, 0, 0);
        exit;
      End;

    TimerCount := 0;
    // FMLister1 is the patient name
    FMCvrListBox1Pt.Visible := False;
    FMCvrListBox2Pt.Visible := False;
    FMCvrListBox3Pt.Visible := False;
    FMCvrLister1Pt.PartList.Clear;
    FMCvrLister1Pt.PartList.Add(Patient_ID.Text);
    Try
    FMCvrListBox1Pt.GetList Except
    End;
    CheckRestrictedFMCvrListBox1Pt;
    FMCvrListBox1Pt.Enabled := False;
    FMCvrListBox2Pt.Enabled := False;
    FMCvrListBox3Pt.Enabled := False;
    {check for errors after the server call}
    If FMCvrLister1Pt.ErrorList.Count > 0 Then
      FMCvrLister1Pt.DisplayErrors;
    If FMCvrLister1Pt.More = True Then
    Begin
      btnCvrMorePt.enabled := true;
    End
    Else
    Begin
      btnCvrMorePt.enabled := false;
    End;
    If FMCvrListBox1Pt.Items.Count > 0 Then
      For x := 0 To FMCvrListBox1Pt.Items.Count - 1 Do
      Begin
        If Pos(Patient_ID.Text, Uppercase(FMCvrListBox1Pt.Items[x])) > 0 Then
        Begin
          FMCvrListBox1Pt.ItemIndex := x;
          FMCvrListBox1PtClick(Application);  //CodeCR124 - rpm 7/27/10
          ProcessingTimer := False;
          If GroupboxCvr1Pt.Visible = false Then
            Repeat application.processmessages Until ((GroupboxCvr1Pt.Visible = true) Or (btnCvrSelectPt.Enabled = True));
          FMCvrListBox1Pt.Enabled := True;
          break;
        End;
      End;

    // FMLister2 is the SSN
    // FMLister1 is the patient name
    FMCvrLister2Pt.PartList.Clear;
    FMCvrLister2Pt.PartList.Add(Patient_ID.Text);
    Try
    FMCvrListBox2Pt.GetList Except
    End;
    CheckRestrictedFMCvrListBox2Pt;
    {check for errors after the server call}
    If FMCvrLister2Pt.ErrorList.Count > 0 Then
      FMCvrLister2Pt.DisplayErrors;
    If FMCvrListBox2Pt.Items.Count > 0 Then
    Begin
      FMCvrListBox1Pt.Visible := False;
      FMCvrListBox2Pt.Visible := True;
      FMCvrListBox2Pt.ItemIndex := 0;
      FMCvrListBox2Pt.Enabled := True;
      FMCvrListBox3Pt.Visible := False;
      FMCvrListBox2Pt.Repaint;
      FMCvrListBox1PtClick(Application);
      If FMCvrLister2Pt.More = True Then
      Begin
        btnCvrMorePt.enabled := true;
      End
      Else
      Begin
        btnCvrMorePt.enabled := false;
      End;
    End;

    If FMCvrListBox2Pt.Items.Count > 0 Then
    Begin
      If SwitchToPatientSSN <> '' Then
      Begin
        If FMCvrListBox2Pt.Items.Count = 1 Then
          FMCvrListBox2Pt.ItemIndex := 0
        Else
        Begin
          Showmessage('There was a problem.  More than 1 patient was found with a matching identifier from the previous site.');
          application.terminate;
        End;
        FMCvrListBox2Pt.BringToFront;
        FMCvrListBox2Pt.Enabled := True;
        FMCvrListBox1PtClick(Application);
        SwitchToPatientSSN := '';
        Patient_ID.Enabled := True;
        btnCvrSelectPt.enabled := True;
        btnCvrDemographicsPt.Enabled := true;
        btnCvrSelectPtClick(application);
        exit;
      End;
    End;

    // FMLister3 is the first letter of last name and last4
    // FMLister1 is the patient name
    FMCvrLister3Pt.PartList.Clear;
    FMCvrLister3Pt.PartList.Add(Patient_ID.Text);
    Try
    FMCvrListBox3Pt.GetList Except
    End;
    CheckRestrictedFMCvrListBox3Pt;
    {check for errors after the server call}
    If FMCvrLister3Pt.ErrorList.Count > 0 Then
      FMCvrLister3Pt.DisplayErrors;
    If FMCvrListBox3Pt.Items.Count > 0 Then
    Begin
      FMCvrListBox1Pt.Visible := False;
      FMCvrListBox2Pt.Visible := False;
      FMCvrListBox3Pt.Visible := True;
      If FMCvrLister3Pt.More = True Then
      Begin
        btnCvrMorePt.enabled := true;
      End
      Else
      Begin
        btnCvrMorePt.enabled := false;
      End;
    End;
    If FMCvrListBox3Pt.Items.Count > 0 Then
    Begin
      FMCvrListBox3Pt.Enabled := True;
      FMCvrListBox3Pt.ItemIndex := 0;
      FMCvrListBox1PtClick(Application);
    End;

    If FMCvrListBox1Pt.ItemIndex > -1 Then
      btnCvrSelectPt.Enabled := True;
    If FMCvrListBox2Pt.ItemIndex > -1 Then
      btnCvrSelectPt.Enabled := True;
    If FMCvrListBox3Pt.ItemIndex > -1 Then
      btnCvrSelectPt.Enabled := True;
    If btnCvrSelectPt.Enabled = True Then
      btnCvrDemographicsPt.Enabled := true;

    {Delete off last line of fileman result info}
    btnCvrTimerPt.Enabled := False;
    ProcessingTimer := False;
    If (FMCvrListBox1Pt.Visible = False) And (FMCvrListBox2Pt.Visible = False) And
      (FMCvrListBox3Pt.Visible = False) Then
    Begin
      LabelStatus.Caption := 'Match not found.';
    End
    Else
    Begin
      //LabelStatus.Caption:='';
    End;
    Patient_ID.enabled := true;
    Try
    Patient_ID.SetFocus Except
    End;
    // Do a right arrow to get the cursor to the end
    keybd_event(VK_RIGHT, 0, 0, 0);
    exit;
  End;
  ProcessingTimer := False;
  If GroupboxCvr1Pt.Visible = false Then
    Repeat application.processmessages Until ((GroupboxCvr1Pt.Visible = true) Or (btnCvrSelectPt.Enabled = True));

  If ReadOnlyMode = False Then
  Begin
    If Pos('@', userfilemancode) > 0 Then
      buttonEdit.enabled := true;
    If Pos('u', userfilemancode) > 0 Then
      buttonEdit.enabled := true;
    If Pos('U', userfilemancode) > 0 Then
      buttonEdit.enabled := true;
  End;
End;

Procedure TfrmPatientList.FMCvrListBox1PtClick(Sender: TObject);

  Procedure RemoveHDRFromList;
  Var
    x: integer;
  Begin
    // Remove HDR entry, if found
    If frmMain.Piece(frmMain.RPCBroker1.Results[0], '^', 1) <> '-1' Then
      For x := frmMain.RPCBroker1.Results.Count - 1 Downto 0 Do
        If frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 1) = '200HD' Then
          frmMain.RPCBroker1.Results.Delete(x);
    // If the list is empty, make sure this is reflected.
    If frmMain.RPCBroker1.Results.Count = 0 Then
      frmMain.RPCBroker1.Results.Add('-1^No Sites Found');
  End;

  Procedure checkforflagsformessage;
  Begin
    exit;
    frmMain.RPCBroker1.RemoteProcedure := 'ORPRF TRIGGER POPUP';
    frmMain.RPCBroker1.Param[1].Value := frmMain.Piece(FMCvrGets1Pt.IENS, ',', 1);
    frmMain.RPCBroker1.Param[1].PType := literal;
    Try
      frmMain.RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        ShowMessageCAPRI('ORPRF TRIGGER POPUP could not be accessed!');
      End;
    End;
    If frmMain.RPCBroker1.Results[0] = '1' Then
    Begin
      LabelStatus.Caption := LabelStatus.Caption + 'Record flags found.' + char(13);
    End;
  End;

  Procedure checkfordoddata;
  Var
    x: integer;
  Begin
    frmMain.RPCBroker1.RemoteProcedure := 'ORWCIRN FACLIST';
    frmMain.RPCBroker1.Param[0].Value := frmMain.Piece(FMCvrGets1Pt.IENS, ',', 1);
    frmMain.RPCBroker1.Param[0].PType := literal;
    frmMain.RPCBrokerCall;
    Try
      frmMain.RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        frmMain.AnimateLogo(False);
        frmMain.StatusBarLoadPt.Caption := 'RPC ORWCIRN FACLIST could not be accessed!';
        frmMain.StatusBarLoadPt.Repaint;
        Application.Processmessages;
        exit;
      End
    End;
    If frmMain.Piece(frmMain.RPCBroker1.Results[0], '^', 1) = '-1' Then
    Begin
      // Only local data or other problem
      // Do nothing
    End
    Else
    Begin
      For x := 0 To frmMain.RPCBroker1.Results.Count - 1 Do
      Begin
        Copy(frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 1) + '        ', 1, 8);
        Copy(frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 2) + '                         ', 1, 25);
        sitenum := frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 1);
        If sitenum = '200' Then
        Begin
          // DOD data is available so do something here....
          LabelStatus.Caption := LabelStatus.Caption + 'DoD data is available.' + char(13);
        End;
      End;
    End;
  End;
Begin
  If Uppercase(sender.classname) = 'TFMLISTBOX' Then
    clickedyet := true;
  sleep(250);
  If ANURemoteProcedureCallInProgress = True Then
    exit;
  If (GroupBoxCvr1Pt.Visible = False) And (PanelCvr1Pt.Visible = False) Then
  Begin
    // Exit because the call is actually already in progress and the user
    // kicked off another one
    exit;
  End;
  GroupboxCvr1Pt.Visible := false;
  btnCvrTimerPt.enabled := False;
  btnCvrSelectPt.Enabled := false;
  buttonOtherSites.Enabled := False;
  LabelStatus.Caption := '';
  PanelCvr1Pt.Visible := false;
  ReFresh;  //CodeCR124 - rpm 7/27/10

  frmMain.RPCBroker1.RemoteProcedure := 'DG SENSITIVE RECORD ACCESS';
  If FMCvrListBox1Pt.Visible = True Then
    If FMCvrListBox1Pt.ItemIndex > -1 Then
      frmMain.RPCBroker1.Param[0].Value := FMCvrListBox1Pt.GetselectedRecord.IEN;
  If FMCvrListBox2Pt.Visible = True Then
    If FMCvrListBox2Pt.ItemIndex > -1 Then
      frmMain.RPCBroker1.Param[0].Value := FMCvrListBox2Pt.GetselectedRecord.IEN;
  If FMCvrListBox3Pt.Visible = True Then
    If FMCvrListBox3Pt.ItemIndex > -1 Then
      frmMain.RPCBroker1.Param[0].Value := FMCvrListBox3Pt.GetselectedRecord.IEN;
  frmMain.RPCBroker1.Param[0].PType := literal;
  frmMain.RPCBrokerCall;
  Try
    frmMain.RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      enabled := True;  //CodeCR124 - rpm 7/27/10
      ShowMessageCAPRI('DG SENSITIVE RECORD ACCESS could not be accessed!');
    End;
  End;
  If FMCvrListBox1Pt.Visible = True Then
    If FMCvrListBox1Pt.ItemIndex > -1 Then
      FMCvrGets1Pt.IENS := FMCvrListBox1Pt.GetselectedRecord.IEN;
  If FMCvrListBox2Pt.Visible = True Then
    If FMCvrListBox2Pt.ItemIndex > -1 Then
      FMCvrGets1Pt.IENS := FMCvrListBox2Pt.GetselectedRecord.IEN;
  If FMCvrListBox3Pt.Visible = True Then
    If FMCvrListBox3Pt.ItemIndex > -1 Then
      FMCvrGets1Pt.IENS := FMCvrListBox3Pt.GetselectedRecord.IEN;
  If frmMain.RPCBroker1.Results[0] = '0' Then
  Begin
    PanelCvr1Pt.Visible := False;
    FMCvrNamePt.IENS := FMCvrGets1Pt.IENS;
    FMCvrGets1Pt.GetAndFill;

    frmMain.RPCBroker1.RemoteProcedure := 'ORWCIRN FACLIST';
    frmMain.RPCBroker1.Param[0].Value := frmMain.Piece(FMCvrGets1Pt.IENS, ',', 1);
    frmMain.RPCBroker1.Param[0].PType := literal;
    frmMain.RPCBrokerCall;
    Try
      frmMain.RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        frmMain.AnimateLogo(False);
        frmMain.StatusBarLoadPt.Caption := 'RPC ORWCIRN FACLIST could not be accessed!';
        frmMain.StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('ORWCIRN FACLIST could not be accessed!');
      End
    End;
    RemoveHDRFromList;
    If frmMain.Piece(frmMain.RPCBroker1.Results[0], '^', 1) = '-1' Then
    Begin
      // Only local data or other problem
      ButtonOtherSites.Enabled := False;
    End
    Else
    Begin
      ButtonOtherSites.Enabled := True;
    End;

    CheckForDODData;
    checkforflagsformessage;

    GroupBoxCvr1Pt.Visible := True; // Hide info on sensitive pt.'s
    If FMCvrGets1Pt.GetField('.351').FMDBExternal <> '' Then
    Begin
      LabelStatus.Caption := LabelStatus.Caption + 'Patient is deceased.' + char(13);
      LabelStatus.Visible := True;
    End;
  End
  Else
  Begin
    GroupBoxCvr1Pt.Visible := False; // Hide info on sensitive pt.'s
    FMCvrNamePt.IENS := FMCvrGets1Pt.IENS;
    FMCvrGets1Pt.GetAndFill;
    ButtonOtherSites.Enabled := True;
    CheckForDODData;
    checkforflagsformessage;
    PanelCvr1Pt.Visible := True;
  End;

  LabelCvrCNumberPt.Visible := True;
  LabelCvrSSN.Visible := True;
  LabelCvrICNPt.Visible := True;
  LabelCvrWard.Visible := True;
  FMCvrAgePt.Caption := FMCvrAgePt.Caption + ' y/o';
  // Check for errors after the server call.
  If FMCvrGets1Pt.ErrorList.Count > 0 Then
    FMCvrGets1Pt.DisplayErrors;

  If FMCvrListBox1Pt.ItemIndex > -1 Then
    btnCvrSelectPt.Enabled := True;
  If FMCvrListBox2Pt.ItemIndex > -1 Then
    btnCvrSelectPt.Enabled := True;
  If FMCvrListBox3Pt.ItemIndex > -1 Then
    btnCvrSelectPt.Enabled := True;
  If btnCvrSelectPt.enabled = true Then
    btnCvrDemographicsPt.Enabled := true;
  enabled := True;  //CodeCR124 - rpm 7/27/10

  If ReadOnlyMode = False Then
  Begin
    If Pos('@', userfilemancode) > 0 Then
      buttonEdit.enabled := true;
    If Pos('u', userfilemancode) > 0 Then
      buttonEdit.enabled := true;
    If Pos('U', userfilemancode) > 0 Then
      buttonEdit.enabled := true;
  End;
End;

Procedure TfrmPatientList.btnCvrCancelPtClick(Sender: TObject);
Begin
  btnCvrTimerPt.Enabled := False;
  modalresult := mrcancel;
End;

Procedure TfrmPatientList.btnCvrSelectPtClick(Sender: TObject);
Var
  boIsDODData: Boolean;
  buf: Array[0..7000] Of char;
  foundflag: boolean;
  msg: String;
  PatientDFN: String;
  x: integer;
  xx: integer;

  Function ptdeceasedcheck: boolean;
  Var
    diedtext: String;
  Begin
    diedtext := FMCvrGets1Pt.GetField('.351').FMDBExternal;
    If diedtext <> '' Then
    Begin
      msg := 'This patient died ' + diedtext + char(13) + 'Do you wish to continue?';
      StrPCopy(buf, msg);
      If Application.MessageBox(buf, 'Deceased Patient', 4) = IDNo Then
      Begin
        patientien := '-1';
        result := false;
        exit;
      End;
    End;
    result := true;
  End;

  Procedure ptcheckflags;
  Var
    x: integer;
  Begin
    exit;
    frmMain.RPCBroker1.RemoteProcedure := 'ORPRF TRIGGER POPUP';
    frmMain.RPCBroker1.Param[1].Value := PatientDFN;
    frmMain.RPCBroker1.Param[1].PType := literal;
    Try
      frmMain.RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        ShowMessageCAPRI('ORPRF TRIGGER POPUP could not be accessed!');
      End;
    End;
    If frmMain.RPCBroker1.Results[0] = '1' Then
    Begin
      // Popup indicated

      FormPtRecordFlags := TFormPtRecordFlags.create(frmPatientList);
      FormPtRecordFlags.LabelPatientDFN.Caption := PatientDFN;

      frmMain.RPCBroker1.RemoteProcedure := 'ORPRF HASFLG';
      frmMain.RPCBroker1.Param[1].Value := PatientDFN;
      frmMain.RPCBroker1.Param[1].PType := literal;
      Try
        frmMain.RPCBroker1.Call;
      Except
        On EBrokerError Do
        Begin
          ANURemoteProcedureCallInProgress := False;
          ShowMessageCAPRI('ORPRF HASFLG could not be accessed!');
          frmMain.RPCBroker1.Results.Add('0'); // Let the user continue
        End;
      End;
      If frmMain.RPCBroker1.Results.Count > 0 Then
      Begin
        For x := 0 To frmMain.RPCBroker1.Results.Count - 1 Do
        Begin
          FormPtRecordFlags.ORListBoxFlags.Items.Add(frmMain.RPCBroker1.Results[x]);
        End;
        FormPtRecordFlags.ORListBoxFlags.ItemIndex := 0;
        FormPtRecordFlags.ORListBoxFlagsClick(Application);
      End;
      FormPtRecordFlags.ShowModal;
      FormPtRecordFlags.Release;
    End;
  End;

  Function checkCCOWfordoddata: boolean;
  Var
    x: integer;
  Begin
    result := false;
    frmMain.RPCBroker1.RemoteProcedure := 'ORWCIRN FACLIST';
    frmMain.RPCBroker1.Param[0].Value := CCOWPatientIEN;
    frmMain.RPCBroker1.Param[0].PType := literal;
    frmMain.RPCBrokerCall;
    Try
      frmMain.RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        frmMain.AnimateLogo(False);
        frmMain.StatusBarLoadPt.Caption := 'RPC ORWCIRN FACLIST could not be accessed!';
        frmMain.StatusBarLoadPt.Repaint;
        Application.Processmessages;
        exit;
      End
    End;
    result := false;
    If frmMain.Piece(frmMain.RPCBroker1.Results[0], '^', 1) = '-1' Then
    Begin
      // Only local data or other problem
      // Do nothing
    End
    Else
    Begin
      For x := 0 To frmMain.RPCBroker1.Results.Count - 1 Do
      Begin
        Copy(frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 1) + '        ', 1, 8);
        Copy(frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 2) + '                         ', 1, 25);
        sitenum := frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 1);
        If sitenum = '200' Then
        Begin
          result := true
        End;
      End;
    End;
  End;

Begin
  If Patient_ID.Text = '' Then
    exit;

  // Next line is sometimes needed when adding a new patient dialog has been executed
  frmROFinder.visible := false;

  frmMain.TabDoD.Enabled := True;
  // Do the next section only for a double-click
  // Wait for demographic data to load

  btnCvrTimerPt.enabled := False;
  PatientSensitive := 'N';
  //First check if new patient selected in restricted list
  //Requery just to be sure the one clicked is the one returned
  If ORListBoxRestrictedPatients.ItemIndex <> -1 Then
    ORListBoxRestrictedPatientsClick(Application);
  If CCOWPatientIEN = '' Then
  Begin
    frmMain.RPCBroker1.RemoteProcedure := 'DG SENSITIVE RECORD ACCESS';
    If FMCvrListBox1Pt.Visible = True Then
      If FMCvrListBox1Pt.ItemIndex > -1 Then
        frmMain.RPCBroker1.Param[0].Value := FMCvrListBox1Pt.GetselectedRecord.IEN;
    If FMCvrListBox2Pt.Visible = True Then
      If FMCvrListBox2Pt.ItemIndex > -1 Then
        frmMain.RPCBroker1.Param[0].Value := FMCvrListBox2Pt.GetselectedRecord.IEN;
    If FMCvrListBox3Pt.Visible = True Then
      If FMCvrListBox3Pt.ItemIndex > -1 Then
        frmMain.RPCBroker1.Param[0].Value := FMCvrListBox3Pt.GetselectedRecord.IEN;
    frmMain.RPCBroker1.Param[0].PType := literal;
    PatientDFN := frmMain.RPCBroker1.Param[0].Value;
    frmMain.RPCBrokerCall;
    Try
      frmMain.RPCBroker1.Call
    Except
      On EBrokerError Do
      Begin
        enabled := True;  //CodeCR124 - rpm 7/27/10
        ShowMessageCAPRI('DG SENSITIVE RECORD ACCESS could not be accessed!');
      End;
    End;
    If frmMain.RPCBroker1.Results[0] <> '0' Then
    Begin
      If frmMain.RPCBroker1.Results[0] <> '3' Then
      Begin
        //2=regular patient
        msg := '';
        If frmMain.RPCBroker1.Results.Count > 0 Then
          For xx := 1 To frmMain.RPCBroker1.Results.Count - 1 Do
            msg := msg + frmMain.RPCBroker1.Results[xx] + char(13);
        //xx:=0;
        StrPCopy(buf, msg);
        If ANURemoteProcedureCallInProgress = True Then
          Repeat application.processmessages Until ANURemoteProcedureCallInProgress = False;
        If Application.MessageBox(buf, 'Sensitive Record', 4) = IDNo Then
        Begin
          ProcessingTimer := False;
          // Check that user should have access to this site in case they switched
          // sites, don't normally have access and then cancelled a sensitive patient switch
          If essoversion = true Then
          Begin
            foundflag := false;
            If formESSOSelect.slUserSites.Count > 0 Then   //CodeCR77
              For x := 0 To formESSOSelect.slUserSites.Count - 1 Do
                If uppercase(frmMain.piece(formESSOSelect.slUserSites[x], '^', 2)) = uppercase(frmMain.RPCBroker1.Server) Then
                  foundflag := true;
            If foundflag <> true Then
            Begin
              ShowmessageCAPRI('You do not have direct access to this site.  Please use FILE | SWITCH SITES and pick a different site prior to selecting a patient.');
              btnCvrCancelPtClick(Application);
              exit;
            End;
          End;
          exit;
        End;
        // Send warning message to ISO
        PatientSensitive := 'Y';
        frmMain.RPCBroker1.RemoteProcedure := 'DG SENSITIVE RECORD BULLETIN';
        frmMain.RPCBroker1.Param[1].Value := PatientDFN;
        frmMain.RPCBroker1.Param[1].PType := literal;
        frmMain.RPCBroker1.Param[2].Value := 'DVBA CAPRI GUI^Capri GUI (Broker)';
        frmMain.RPCBroker1.Param[2].PType := literal;
        frmMain.RPCBroker1.Param[3].Value := ''; // Use the default for this parameter by leaving it blank
        frmMain.RPCBroker1.Param[3].PType := literal;
        frmMain.RPCBrokerCall;
        frmMain.RPCBroker1.Call;
        If frmMain.RPCBroker1.Results.Count > 0 Then
          If frmMain.RPCBroker1.Results[0] <> '1' Then
          Begin
            ShowMessageCAPRI('There was a problem generating the DG SENSITIVE RECORD e-mail.  Please notify IRM.');
          End;
      End;

      If ptDeceasedCheck = false Then
      Begin
        processingtimer := false;
        exit;
      End;

      ptcheckflags;

      If frmMain.RPCBroker1.Results[0] = '3' Then
      Begin
        msg := '';
        If frmMain.RPCBroker1.Results.Count > 0 Then
          For xx := 1 To frmMain.RPCBroker1.Results.Count - 1 Do
            msg := msg + frmMain.RPCBroker1.Results[xx] + char(13);
        ShowMessageCAPRI(msg);
        processingtimer := false;
        exit;
        // Don't send warning message to ISO
      End;
    End;
  End;

  If CCOWPatientIEN <> '' Then
  Begin
    FMCvrListBox1Pt.ItemIndex := -1;
    FMCvrListBox2Pt.ItemIndex := -1;
    FMCvrListBox3Pt.ItemIndex := -1;
    PatientIEN := CCOWPatientIEN;
    PatientIENDoD := '';
    boIsDODData:= CheckCCOWForDODData;
    If boIsDODData Then
    Begin
      frmMain.TabDOD.Visible := True;
      frmMain.TabDOD.TabVisible := True;
      frmMain.Page95Control1.ActivePage := frmMain.TabDOD;
      frmMain.Page95Control1.ActivePage := frmMain.TabCPExams;
    End
    Else
    Begin
      frmMain.TabDOD.Visible := False;
      frmMain.TabDOD.TabVisible := False;
    End;
    ccowclose.enabled := true;
    exit;
  End;

  If FMCvrListBox1Pt.Visible = True Then
    If FMCvrListBox1Pt.ItemIndex > -1 Then
    Begin
      If FMCvrListBox1Pt.Items[FMCvrListBox1Pt.ItemIndex] <> '' Then
      Begin
        If ptDeceasedCheck = false Then
        Begin
          processingtimer := false;
          exit;
        End;

        ptcheckflags;

        PatientIEN := FMCvrListBox1Pt.GetselectedRecord.IEN;
        PatientIENDoD := '';
        If Pos('DOD DATA IS AVAILABLE.', Uppercase(LabelStatus.Caption)) > 0 Then
        Begin
          frmMain.TabDOD.Visible := True;
          frmMain.TabDOD.TabVisible := True;
          frmMain.Page95Control1.ActivePage := frmMain.TabDOD;
          frmMain.Page95Control1.ActivePage := frmMain.TabCPExams;
        End
        Else
        Begin
          frmMain.TabDOD.Visible := False;
          frmMain.TabDOD.TabVisible := False;
        End;
        If CCOWMode = True Then
          If frmMain.bitbtnCCOWLinkBroken.Visible = False Then
          Begin
            frmMain.BitBtnCCOWLinkBroken.Visible := False;
            frmMain.BitBtnCCOWLink.Visible := False;
            frmMain.BitBtnCCOWLinkChanging.Visible := True;
          End;
        ModalResult := mrOK;
        Close;  //CodeCR124 - rpm 7/27/10
        exit;
      End;
    End;
  If FMCvrListBox2Pt.Visible = True Then
    If FMCvrListBox2Pt.ItemIndex > -1 Then
    Begin
      If FMCvrListBox2Pt.Items[FMCvrListBox2Pt.ItemIndex] <> '' Then
      Begin
        If ptDeceasedCheck = false Then
        Begin
          processingtimer := false;
          exit;
        End;

        ptcheckflags;

        PatientIEN := FMCvrListBox2Pt.GetselectedRecord.IEN;
        PatientIENDoD := '';
        If Pos('DOD DATA IS AVAILABLE.', Uppercase(LabelStatus.Caption)) > 0 Then
        Begin
          frmMain.TabDOD.Visible := True;
          frmMain.TabDOD.TabVisible := True;
          frmMain.Page95Control1.ActivePage := frmMain.TabDOD;
          frmMain.Page95Control1.ActivePage := frmMain.TabCPExams;
        End
        Else
        Begin
          frmMain.TabDOD.Visible := False;
          frmMain.TabDOD.TabVisible := False;
        End;
        If CCOWMode = True Then
          If frmMain.bitbtnCCOWLinkBroken.Visible = False Then
          Begin
            frmMain.BitBtnCCOWLinkBroken.Visible := False;
            frmMain.BitBtnCCOWLink.Visible := False;
            frmMain.BitBtnCCOWLinkChanging.Visible := True;
          End;
        TimerCloseit.enabled := true;
        exit;
      End;
    End;
  If FMCvrListBox3Pt.Visible = True Then
    If FMCvrListBox3Pt.ItemIndex > -1 Then
    Begin
      If FMCvrListBox3Pt.Items[FMCvrListBox3Pt.ItemIndex] <> '' Then
      Begin
        If ptDeceasedCheck = false Then
        Begin
          processingtimer := false;
          exit;
        End;

        ptcheckflags;

        PatientIEN := FMCvrListBox3Pt.GetselectedRecord.IEN;
        PatientIENDoD := '';
        If Pos('DOD DATA IS AVAILABLE.', Uppercase(LabelStatus.Caption)) > 0 Then
        Begin
          frmMain.TabDOD.Visible := True;
          frmMain.TabDOD.TabVisible := True;
          frmMain.Page95Control1.ActivePage := frmMain.TabDOD;
          frmMain.Page95Control1.ActivePage := frmMain.TabCPExams;
        End
        Else
        Begin
          frmMain.TabDOD.Visible := False;
          frmMain.TabDOD.TabVisible := False;
        End;
        If CCOWMode = True Then
          If frmMain.bitbtnCCOWLinkBroken.Visible = False Then
          Begin
            frmMain.BitBtnCCOWLinkBroken.Visible := False;
            frmMain.BitBtnCCOWLink.Visible := False;
            frmMain.BitBtnCCOWLinkChanging.Visible := True;
          End;
        ModalResult := mrOK;
        Close;  //CodeCR124 - rpm 7/27/10
        exit;
      End;
    End;
End;

Procedure TfrmPatientList.btnCvrEnterNewPtClick(Sender: TObject);
Var
  x: integer;
  TempRecord: integer;
  WhichDialog: Integer;
  xx: integer;
  isForeignAddrSupport: Boolean;
Begin
  ContextorChangeMessage := 'You are adding a patient.  If you continue, CAPRI will drop out of the clinical context.';
  CCOWBreakLink := True;

  If frmROFinder.ORListBoxSites.Items.Count = 0 Then
    frmMain.LoadInstitutions;

  PatientIEN := '';
  PatientIENDoD := '';

  WhichDialog := 1; // Normal pt entry dialog;

  For xx := 0 To UserKeys.Count - 1 Do
    If (UserKeys[xx] = 'DVBA CAPRI SIMPLE PT ENTRY') Or
      (UserKeys[xx] = 'DVBA CAPRI SIMPLE PT ENTRY') Then
    Begin
      WhichDialog := 2; // Simple pt entry dialog
    End;

  {rpm 9/16/09 - patch DVBA*2.7*143 provides updated Enter New Patient dialogs
                 that support Foreign Address and require the server to contain
                 the DVBAB ZIP2CITY RPC.  A work-around is required during
                 testing, since not all sites will have the patch installed.
                 CAPRI will continue to run the pre-143 Enter New Patient
                 dialogs when Foreign Address server support is missing.
                 The Foreign Address check and alternate dialog use should be
                 removed in a future patch, since it will no longer be needed.}
  if IsPatchInstalled('DVBA*2.7*143') then
    isForeignAddrSupport := True
  else
    isForeignAddrSupport := False;

  if isForeignAddrSupport then
  begin  {foreign address supported}
    if (WhichDialog = 2) then
    begin  {Simple patient entry}
      frmEnterPtSimple := TfrmEnterPtSimple.Create(nil);
      frmEnterPtSimple.Top := frmMain.Top + ((frmMain.Height - frmEnterPtSimple.Height) Div 2);
      frmEnterPtSimple.Left := frmMain.Left + ((frmMain.Width - frmEnterPtSimple.Width) Div 2);

      //set up division
      searchforstring := UserDivision;
      searchforstring := '';

      frmEnterPtSimple.grpRequired.VertScrollBar.Position := 0;
      frmEnterPtSimple.ShowModal;
      frmEnterPtSimple.Release;
    end   {Simple patient entry}
    else
    begin {full patient entry}
      frmEnterPt := TfrmEnterPt.Create(nil);
      frmEnterPt.Top := frmMain.Top + ((frmMain.Height - frmEnterPt.Height) Div 2);
      frmEnterPt.Left := frmMain.Left + ((frmMain.Width - frmEnterPt.Width) Div 2);

      //set up division
      searchforstring := UserDivision;
      frmEnterPt.ClaimFolderLocationEnter(Application);
      searchforstring := '';

      frmEnterPt.grpRequired.VertScrollBar.Position := 0;
      frmEnterPt.ShowModal;
      frmEnterPt.Release;
    end; {full patient entry}
  end   {foreign address supported}
  else
  begin {no foreign address support}
    if (WhichDialog = 2) then
    begin {Simple patient entry}
      frmEnterPtSimple140 := TfrmEnterPtSimple140.Create(nil);
      frmEnterPtSimple140.Top := frmMain.Top + ((frmMain.Height - frmEnterPtSimple140.Height) Div 2);
      frmEnterPtSimple140.Left := frmMain.Left + ((frmMain.Width - frmEnterPtSimple140.Width) Div 2);

      //set up division
      searchforstring := UserDivision;
      searchforstring := '';

      frmEnterPtSimple140.grpRequired.VertScrollBar.Position := 0;
      frmEnterPTSimple140.ShowModal;
      frmEnterPtSimple140.Release;
    end  {Simple patient entry}
    else
    begin  {full patient entry}
      frmEnterPt140 := TfrmEnterPt140.Create(nil);
      frmEnterPt140.Top := frmMain.Top + ((frmMain.Height - frmEnterPt140.Height) Div 2);
      frmEnterPt140.Left := frmMain.Left + ((frmMain.Width - frmEnterPt140.Width) Div 2);

      //set up division
      searchforstring := UserDivision;
      frmEnterPt140.ClaimFolderLocationEnter(Application);
      searchforstring := '';

      frmEnterPt140.grpRequired.VertScrollBar.Position := 0;
      frmEnterPT140.ShowModal;
      frmEnterPt140.Release;
    end; {full patient entry}
  end; {no foreign address support}

  // Next line is sometimes needed
  frmROFinder.visible := false;
  ContextorChangeMessage := '';
  CCOWBreakLink := False;
  TimerCount := 5;

  if PatientIEN <> '' then
  begin
    btnCvrTimerPtTimer(Application);
    TempRecord := -1;
    If PatientIEN <> '' Then
      PatientIEN := Copy(PatientIEN, 1, Length(PatientIEN) - 1); // Strip off comma at end;
    If FMCvrListBox1Pt.Items.Count > 0 Then
      If PatientIEN <> '' Then
      Begin
        For x := 0 To FMCvrListBox1Pt.Items.Count - 1 Do
        Begin
          FMCvrListBox1Pt.ItemIndex := x;
          If FMCvrListBox1Pt.Visible = True Then
            If FMCvrListBox1Pt.GetSelectedRecord.IEN = PatientIEN Then
              TempRecord := x;
          If FMCvrListBox2Pt.Visible = True Then
            If FMCvrListBox2Pt.GetSelectedRecord.IEN = PatientIEN Then
              TempRecord := x;
          If FMCvrListBox3Pt.Visible = True Then
            If FMCvrListBox3Pt.GetSelectedRecord.IEN = PatientIEN Then
              TempRecord := x;
        End;
        If TempRecord > -1 Then
        Begin
          FMCvrListBox1Pt.ItemIndex := TempRecord;
          frmMain.TabDOD.TabVisible := False;
          FMCvrListBox1PtClick(Application);
          ModalResult := mrOK;
          exit;
        End;
      End;
  end;
End;

Procedure TfrmPatientList.Patient_IDKeyPress(Sender: TObject; Var Key: Char);
Begin
  // Don't allow a space after a comma to help in picking a patient
  If Patient_ID.Text <> '' Then
  Begin
    If ((Copy(Patient_ID.Text, Length(Patient_ID.Text), 1) = ',') And (key = ' ')) Then
      key := char(0);
    If key = char(13) Then
    Begin
      timercount := 4;
      btnCvrTimerPtTimer(application);
      key := char(0);
    End;
  End;
End;

Procedure TfrmPatientList.ORListBoxRestrictedPatientsDblClick(
  Sender: TObject);
Var
  temptext: String;
Begin
  temptext := frmMain.Piece(ORListBoxRestrictedPatients.Items[ORListBoxRestrictedPatients.ItemIndex], '(', 2);
  If temptext <> '' Then
    temptext := copy(temptext, 1, length(temptext) - 1); // strip off ")" at end
  Patient_ID.Text := temptext;
  timerCount := 5;
  btnCvrTimerPtTimer(application);
  Repeat application.processmessages Until timercount = 0;
  If (FMCvrListBox3Pt.Visible = True) And (FMCvrListBox3Pt.Items.Count = 1) Then
    btnCvrSelectPtClick(Application);
  If (FMCvrListBox2Pt.Visible = True) And (FMCvrListBox2Pt.Items.Count = 1) Then
    btnCvrSelectPtClick(Application);
  If (FMCvrListBox1Pt.Visible = True) And (FMCvrListBox1Pt.Items.Count = 1) Then
    btnCvrSelectPtClick(Application);
  // Should exit before hitting this.  Otherwise...
  If (FMCvrListBox1Pt.Items.Count = 0) And (FMCvrListBox2Pt.Items.Count = 0) And (FMCvrListBox3Pt.Items.Count = 0) Then
  Begin
    Patient_ID.Text := '';
    ShowMessageCAPRI('The patient is not found in this VistA system.');
  End;
End;

Procedure TfrmPatientList.ORListBoxRestrictedPatientsClick(
  Sender: TObject);
Var
  tempid: String;
Begin
  ORListBoxRestrictedPatients.Enabled := False;
  TimerCount := 0;
  btnCvrTimerPt.Enabled := False;
  labelstatus.Caption := '';
  tempid := ORListBoxRestrictedPatients.Items[ORListBoxRestrictedPatients.ItemIndex];
  //Get what's between the parentheses
  tempID := frmMain.Piece(tempid, '(', 2);
  tempID := frmMain.Piece(tempid, ')', 1);
  Patient_ID.Text := tempid;
  TimerCount := 4;
  btnCvrTimerPt.enabled := true;
  Repeat application.processmessages Until timercount = 0;

  If btnCvrSelectPt.Enabled = False Then
  Begin
    LabelStatus.Caption := 'That patient is not in this VistA database!';
  End
  Else
  Begin
    lastpatientsearched := ORListBoxRestrictedPatients.Items[ORListBoxRestrictedPatients.ItemIndex];
  End;
  ORListBoxRestrictedPatients.Enabled := True;
  If ReadOnlyMode = False Then
  Begin
    If Pos('@', userfilemancode) > 0 Then
      buttonEdit.enabled := true;
    If Pos('u', userfilemancode) > 0 Then
      buttonEdit.enabled := true;
    If Pos('U', userfilemancode) > 0 Then
      buttonEdit.enabled := true;
  End;
End;

Procedure TfrmPatientList.ORListBoxRestrictedPatientsKeyPress(
  Sender: TObject; Var Key: Char);
Begin
  LabelStatus.Caption := '';
  timerCount2 := 0;
  TimerWait2.Enabled := True;
End;

Procedure TfrmPatientList.FMCvrListBox1PtDblClick(Sender: TObject);
Begin
  If clickedyet = false Then
    exit;
  If TListBox(Sender).Enabled = False Then
    exit;
  enabled := False;  //CodeCR124 - rpm 7/27/10
  TimerWait.Enabled := True;
End;

Procedure TfrmPatientList.TimerWaitTimer(Sender: TObject);
Begin
  enabled := True;  //CodeCR124 - rpm 7/27/10
  btnCvrTimerPt.enabled := False;
  TimerWait.Enabled := False;

  If ShutDownSwitchSites = True Then
    btnCvrCancelPtClick(Application);

  If ProcessingTimer = True Then
    Repeat
      application.processmessages;
    Until processingtimer = false;
  If btnCvrSelectPt.enabled = True Then
    btnCvrSelectPtClick(Application);
End;

Procedure TfrmPatientList.ButtonOtherSitesClick(Sender: TObject);
Var
  a, b: String;
  x: integer;

  Procedure RemoveHDRFromList;
  Var
    x: integer;
  Begin
    // Remove HDR entry, if found
    If frmMain.Piece(frmMain.RPCBroker1.Results[0], '^', 1) <> '-1' Then
      For x := frmMain.RPCBroker1.Results.Count - 1 Downto 0 Do
        If frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 1) = '200HD' Then
          frmMain.RPCBroker1.Results.Delete(x);
    // If the list is empty, make sure this is reflected.
    If frmMain.RPCBroker1.Results.Count = 0 Then
      frmMain.RPCBroker1.Results.Add('-1^No Sites Found');
  End;
Begin
  frmRemoteSitePick := TfrmRemoteSitePick.Create(frmPatientList);
  frmMain.AnimateLogo(True);
  frmMain.StatusBarLoadPt.Caption := 'Generating report.';
  frmMain.StatusBarLoadPt.Repaint;
  Application.Processmessages;
  frmMain.RPCBroker1.RemoteProcedure := 'ORWCIRN FACLIST';
  frmMain.RPCBroker1.Param[0].Value := frmMain.Piece(FMCvrGets1Pt.IENS, ',', 1);
  frmMain.RPCBroker1.Param[0].PType := literal;
  frmMain.RPCBrokerCall;
  Try
    frmMain.RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      frmMain.AnimateLogo(False);
      frmMain.StatusBarLoadPt.Caption := 'RPC ORWCIRN FACLIST could not be accessed!';
      frmMain.StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('ORWCIRN FACLIST could not be accessed!');
    End
  End;
  RemoveHDRFromList;
  If frmMain.Piece(frmMain.RPCBroker1.Results[0], '^', 1) = '-1' Then
  Begin
    // Only local data or other problem
    frmRemoteSitePick.ORListBoxSites.Items.Add('Sites could not be loaded.');
  End
  Else
  Begin
    For x := 0 To frmMain.RPCBroker1.Results.Count - 1 Do
    Begin
      a := Copy(frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 1) + '        ', 1, 8);
      b := Copy(frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 2) + '                         ', 1, 25);
      sitenum := frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 1);
      If a <> '200HD' Then
        frmRemoteSitePick.ORListBoxSites.Items.Add(a + b + '  ' + FMDateTimeConvert(frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 3)) + '^' + sitenum)
      Else
        showmessage('Found HDR');
    End;
  End;
  frmMain.AnimateLogo(False);
  frmMain.StatusBarLoadPt.Caption := 'Ready.';
  frmMain.StatusBarLoadPt.Repaint;
  Application.Processmessages;
  If frmRemoteSitePick.ShowModal = mrok Then
  Begin
    If SiteNum = '200' Then
    Begin
      frmRemoteSitePick.Release;
      switchtosite := '';
      ShowMessageCAPRI('Switching to DoD is not allowed.  Instead, select the patient and use the DOD RECORDS tab to view DOD data.');
      exit;
    End;

    If switchtosite <> '' Then
    Begin
      For x := 0 To formEssoSelect.slUserSites.Count - 1 Do   //CodeCR77
        If (Pos(SwitchToSite, frmMain.Piece(formESSOSelect.slUserSites[x], '^', 8)) > 0) Or // CodeCR191 -MER 05/2011
          (Pos(SwitchToSite, frmMain.Piece(formESSOSelect.slUserSites[x], '^', 4)) > 0) Then
        Begin
          switchtosite := inttostr(x);
          SwitchToPatientSSN := FMCvrSSNPt.Caption;
          frmRemoteSitePick.Release;
          Visible := False;  //CodeCR124 - rpm 7/27/10
          btnCvrCancelPtClick(Application);
          frmRemoteSitePick.Release;
          exit;
        End;
      // User doesn't have authorized access, so look for site an alternate way
      For x := 0 To formEssoSelect.ORListBox2.Items.Count - 1 Do
        If (Pos(SwitchToSite, frmMain.Piece(formESSOSelect.ORListBox2.Items[x], '^', 1)) > 0) Or
          (Pos(SwitchToSite, frmMain.Piece(formESSOSelect.ORListBox2.Items[x], '^', 4)) > 0) Then
        Begin
          switchtosite := '*' + inttostr(x);
          SwitchToPatientSSN := FMCvrSSNPt.Caption;
          frmRemoteSitePick.Release;
          Visible := False;  //CodeCR124 - rpm 7/27/10
          btnCvrCancelPtClick(Application);
          frmRemoteSitePick.Release;
          exit;
        End;
      switchtosite := '';
      ShowMessageCAPRI('+You either do not have access to the remote site or some other problem prevented connection.  Try connecting manually instead using FILE | SWITCH SITES.');
    End
    Else
    Begin
      SwitchToSite := '';
      ShowMessageCAPRI('*You either do not have access to the remote site or some other problem prevented connection.  Try connecting manually instead using FILE | SWITCH SITES.');
    End;
  End;
  frmRemoteSitePick.Release;
End;

Procedure TfrmPatientList.buttonEditClick(Sender: TObject);
Var
  tempstrserver, tempstrport: String;
  tempUserIEN: String;
  tempSSNText: String;
Begin
  If PanelAuthorizedPatients.Visible = False Then
  Begin
    ShowMessageCAPRI('This option only works when the user has been assigned a restricted patient list.');
    exit;
  End;
  If ANURemoteProcedureCallInProgress = True Then
    exit;
  If (LabelStatus.Caption = '') And (FMCvrSSNPt.Caption = '') Then
    exit;

  If (ESSOVersion = true) Then
  Begin
    TempStrServer := Uppercase(frmMain.RPCBroker1.ANUStrServer);
    TempStrPort := frmMain.RPCBroker1.ANUStrPort;
    TempUserIEN := AuthorIEN;
    AuthorIEN := UserDUZHomeServer;
    frmMain.rpcbroker1.Connected := False;
    frmMain.rpcbroker1.Server := frmMain.RPCBroker1.ANUStrServerHome;
    frmMain.rpcbroker1.ListenerPort := StrtoInt(frmMain.RPCBroker1.ANUStrPortHome);
    //frmMain.rpcbroker1.Connected := True;  BSE mod - rpm 1/8/09
    //If Not frmMain.AuthorizedOption('DVBA CAPRI GUI') Then  BSE mod - rpm 1/8/09
    if not frmMain.ConnectToServer('DVBA CAPRI GUI') then
    Begin
      ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
      application.terminate;
    End;

    frmEditPt := tfrmEditPt.Create(frmMain);
    frmEditPt.FMCvrLister2Pt.PartList.Clear;
    tempSSNtext := frmMain.Piece(ORListBoxRestrictedPatients.Text, '(', 2);
    tempSSNtext := frmMain.Piece(tempSSNtext, ')', 1);
    frmEditPt.FMCvrLister2Pt.PartList.Add(tempSSNtext);
    frmEditPt.FMCvrLister2Pt.GetList(frmEditPt.FMCvrListBox1Pt.Items);

    If frmEditPt.FMCvrListBox1Pt.Items.Count > 1 Then
    Begin
      ShowMessageCAPRI('There is more than one patient with the SSN ' + patientSSN + '.  The change must be made within VistA.');
    End;
    If frmEditPt.FMCvrListBox1Pt.Items.Count = 0 Then
    Begin
      ShowMessageCAPRI('There current patient was not found on the home server.');
    End;
    If frmEditPt.FMCvrListBox1Pt.Items.Count = 1 Then
    Begin
      frmEditPt.FMCvrListBox1Pt.ItemIndex := 0;
      frmEditPt.FMGets1.IENS := frmEditPt.FMCvrListBox1Pt.GetSelectedRecord.IEN;
      frmEditPt.FMGets1.GetAndFill;
      ContextorChangeMessage := 'You are editing a patient.  If you continue, CAPRI will drop out of the clinical context.';
      CCOWBreakLink := True;
      frmEditPt.ShowModal;
      ContextorChangeMessage := '';
      CCOWBreakLink := False;
    End;
    frmEditPt.Release;

    //Connect back to remote here
    AuthorIEN := TempUserIEN;
    frmMain.rpcbroker1.Connected := False;
    frmMain.rpcbroker1.Server := TempStrServer;
    frmMain.rpcbroker1.ListenerPort := StrtoInt(TempStrPort);
    //frmMain.rpcbroker1.Connected := True;  BSE mod - rpm 1/8/09
    //If Not frmMain.AuthorizedOption('DVBA CAPRI GUI') Then  BSE mod - rpm 1/8/09
    if not frmMain.ConnectToServer('DVBA CAPRI GUI') then
    Begin
      ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
      application.terminate;
    End;
  End;
End;

Procedure TfrmPatientList.TimerWait2Timer(Sender: TObject);
Begin
  Inc(timercount2);
  If timerCount2 > 3 Then
  Begin
    TimerWait2.Enabled := False;
    TimerCount2 := 0;
    If ORListBoxRestrictedPatients.ItemIndex > -1 Then
      ORListBoxRestrictedPatientsClick(Application);
  End;
End;

Procedure TfrmPatientList.Button1Click(Sender: TObject);
Begin
  If Patient_ID.Text = '' Then
  Begin
    ShowmessageCAPRI('Please enter a search string in the yellow edit box and try again.');
    exit;
  End;
End;

Procedure TfrmPatientList.CCOWCloseTimer(Sender: TObject);
Begin
  CCOWClose.Enabled := False;
  If CCOWPatientIEN <> '' Then
  Begin
    FMCvrGets1Pt.IENS := CCOWPatientIEN;
    FMCvrGets1Pt.GetAndFill;
  End
  Else
  Begin
    PatientIEN := '';
  End;
  ModalResult := mrOK;
  Close;  //CodeCR124 - rpm 7/27/10
End;

Procedure TfrmPatientList.CCOWTimerTimer(Sender: TObject);
Begin
  If ShutdownCAPRIModalDialogs = true Then
  Begin
    CCOWTimer.Enabled := False;
    btnCvrCancelPtClick(Application);
    visible := false;  //CodeCR124 - rpm 7/27/10
  End;
End;

Procedure TfrmPatientList.btnSearchClick(Sender: TObject);
Begin
  frmMain.actToolsSearch.Execute;
End;

Procedure TfrmPatientList.btnCvrDemographicsPtClick(Sender: TObject);
Var
  temptext: String;
Begin
  If PanelCvr1Pt.Visible = True Then
  Begin
    Temptext := 'This is a sensitive record.';
  End
  Else
  Begin
    Temptext := 'Name: ' + FMCvrNamePt.caption + char(13);
    Temptext := temptext + 'SSN: ' + FMCvrSSNPt.caption + char(13);
    If FMCvrSexPt.caption <> '' Then
      Temptext := temptext + 'Sex: ' + FMCvrSexPt.caption + char(13);
    If FMCvrAgePt.caption <> '' Then
      Temptext := temptext + 'Age: ' + FMCvrAgePt.caption + char(13);
    If (FMCvrWardPt.caption <> '') Or (FMCvrRoomBedPt.caption <> '') Then
      Temptext := temptext + 'Ward, Room/Bed: ' + FMCvrWardPt.caption + ', ' + FMCvrRoomBedPt.caption + char(13);
    If FMCvrCNumberPt.caption <> '' Then
      Temptext := temptext + 'Claim Number: ' + FMCvrCNumberPt.caption + char(13);
    If FMCvrICNPt.caption <> '' Then
      Temptext := temptext + 'ICN: ' + FMCvrICNPt.caption + char(13);
  End;
  ShowmessageCAPRI(temptext);
End;

Procedure TfrmPatientList.TimerCloseItTimer(Sender: TObject);
Begin
  ModalResult := mrOK;
  Close;  //CodeCR124 - rpm 7/27/10
End;

Procedure TfrmPatientList.TimerCloseIt2Timer(Sender: TObject);
Begin
  ModalResult := mrCancel;
  Close;  //CodeCR124 - rpm 7/27/10
End;

{==============================================================================
  ConfigurePatientFiltering
    ConfigurePatientFiltering is a method that will set filtering for
    the patient lookup form based on PatientFilterType.
    It will also disable or enable several form components.

  Modification History:
    CodeCR124 - 7/2010 Method created -MER
    CodeCR131 - 12/8/2010 Modified for DOD Filtering.
 ==============================================================================}
procedure TfrmPatientList.ConfigurePatientFiltering;
var
  DOD_Screen: String;
begin
  case PatientFilterType of
    pfFeeBasis : begin
      //return record only when patient exists in FEE BASIS PATIENT (#161) file "B" index
      FMCvrLister1Pt.Screen := 'I $D(^FBAAA("B",Y))';
      FMCvrLister2Pt.Screen := 'I $D(^FBAAA("B",Y))';
      FMCvrLister3Pt.Screen := 'I $D(^FBAAA("B",Y))';
      buttonEdit.Enabled := FALSE;
      btnCvrEnterNewPt.Enabled := FALSE;
      btnSearch.Enabled := FALSE;
    end;
    pfDoD : begin
      //return record only when patient exists in TREATING FACILITY LIST (#391.91)
      // file "APAT" index with station# 200 IEN.
      DOD_Screen := 'I $D(^DGCN(391.91,"APAT",Y,' + FBHIEInstitutionIEN + '))';
      FMCvrLister1Pt.Screen := DOD_Screen;
      FMCvrLister2Pt.Screen := DOD_Screen;
      FMCvrLister3Pt.Screen := DOD_Screen;
      buttonEdit.Enabled := True;
      btnCvrEnterNewPt.Enabled := True;
      btnSearch.Enabled := True;
    end;
    else begin
      // no filtering
      FMCvrLister1Pt.Screen := '';
      FMCvrLister2Pt.Screen := '';
      FMCvrLister3Pt.Screen := '';
      buttonEdit.Enabled := TRUE;
      btnCvrEnterNewPt.Enabled := TRUE;
      btnSearch.Enabled := TRUE;
    end;
  end; // case PatientFilterType
end; // ConfigurePatientFiltering

End.
