unit pncsOptions;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TformPncsOptions = class(TForm)
    pnlBase: TPanel;
    pnlBot: TPanel;
    pnlTitle: TPanel;
    pnlBotRight: TPanel;
    pnlBotLeft: TPanel;
    pnlBotMid: TPanel;
    pnlClose: TPanel;
    pnlBotMidRow07: TPanel;
    btnSpellCheck: TButton;
    pnlBotMidRow06: TPanel;
    btnReviewEventsComments: TButton;
    pnlBotMidRow05: TPanel;
    pnlBotMidRow04: TPanel;
    btnRestorePreviousVersion: TButton;
    pnlBotMidRow03: TPanel;
    btnChangeExamTabOrder: TButton;
    pnlBotMidRow02: TPanel;
    btnManageTemplates: TButton;
    pnlBotMidRow01: TPanel;
    pnlBotMidRow10: TPanel;
    btnGenBlankTemplate: TButton;
    pnlBotMidRow09: TPanel;
    pnlBotMidRow08: TPanel;
    btnInfo: TButton;
    procedure pnlCloseClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btnManageTemplatesClick(Sender: TObject);
  protected
    FButtonPressed: String;
    FSuccess      : Boolean;
    function GetBottomLeft: TPoint;
    function GetButtonPressed: String;
    function GetSuccess: Boolean;
    procedure SetBottomLeft(const Value: TPoint);
    procedure SetButtonPressed(const Value: String);
    procedure SetSuccess(const Value: Boolean);
  public
    { Public declarations }
    property BottomLeft   : TPoint  read GetBottomLeft    write SetBottomLeft;
    property ButtonPressed: String  read GetButtonPressed write SetButtonPressed;
    property Success      : Boolean read GetSuccess       write SetSuccess;
  end;

var
  formPncsOptions: TformPncsOptions;

implementation

{$R *.DFM}

function TformPncsOptions.GetBottomLeft: TPoint;
begin
  Result.x:=Left;
  Result.y:=Top+Height;
end;

function TformPncsOptions.GetSuccess: Boolean;
begin
  Result:=FSuccess;
end;

procedure TformPncsOptions.pnlCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TformPncsOptions.SetBottomLeft(const Value: TPoint);
begin
  Left:=Value.x;
  Top :=Value.y-Height;
end;

procedure TformPncsOptions.SetSuccess(const Value: Boolean);
begin
  FSuccess:=Value;
end;

procedure TformPncsOptions.FormCreate(Sender: TObject);
begin
  FSuccess:=False;
end;

procedure TformPncsOptions.FormActivate(Sender: TObject);
begin
  FSuccess:=False;
  btnManageTemplates.SetFocus;
end;

function TformPncsOptions.GetButtonPressed: String;
begin
  Result:=FButtonPressed;
end;

procedure TformPncsOptions.SetButtonPressed(const Value: String);
begin
  FButtonPressed:=Value;
end;

procedure TformPncsOptions.btnManageTemplatesClick(Sender: TObject);
Var
  Button: TButton;
begin
  If Not (Sender is TButton) Then Exit;
  Button:=TButton(Sender);
  FButtonPressed:=Button.Caption;
  FButtonPressed:=StringReplace(FButtonPressed,'&','',[rfReplaceAll]);
  Success:=True;
  Close;
end;

end.
