unit pncsreportcheck;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  DialogsCAPRI,
  Dialogs,
  StdCtrls,
  ExtCtrls;

procedure PNCSReportInterpret(MemoCode: TMemo; XBaseForm: TForm; MemoErrors: TMemo);
function CheckIfValidObjectorCommand(NewWord: string; xBaseForm: TForm; MemoErrors: TMemo): Boolean;

var
  CodeString: string;
  ErrorCount: Integer;
  WhichLine: Integer;
  NewWord: string;

implementation

function CheckIfValidObjectorCommand(NewWord: string; XBaseForm: TForm; MemoErrors: TMemo): Boolean;
var
  xx: integer;
begin
  result := False;
  NewWord := Copy(NewWord, 3, Length(NewWord) - 4);
  if xBaseForm.ComponentCount - 1 > 0 then
    for xx := 0 to xBaseForm.ComponentCount - 1 do begin
      if UpperCase(xBaseform.Components[xx].Name) = Uppercase(NewWord) then
        result := true;
    end;
  if Uppercase(NewWord) = 'INDENT2' then
    result := true;
  if Uppercase(NewWord) = 'INDENT4' then
    result := true;
  if Uppercase(NewWord) = 'INDENT6' then
    result := true;
  if Uppercase(NewWord) = 'INDENT8' then
    result := true;
  if Uppercase(NewWord) = 'INDENT10' then
    result := true;
  if Uppercase(NewWord) = 'INDENTOFF' then
    result := true;
  if Uppercase(NewWord) = 'CAPSON' then
    result := true;
  if Uppercase(NewWord) = 'CAPSOFF' then
    result := true;
  if Uppercase(NewWord) = 'OUTPUTOFF' then
    result := true;
  if Uppercase(NewWord) = 'OUTPUTON' then
    result := true;
end;

procedure PNCSReportInterpret(MemoCode: TMemo; XBaseForm: TForm; MemoErrors: TMemo);
begin
  WhichLine := 0;
  ErrorCount := 0;
  MemoErrors.Lines.Clear;
  if memoCode.Lines.Count = 0 then begin
    MemoErrors.Lines.Add('<No report text has been entered>');
    exit;
  end;
  repeat
    CodeString := MemoCode.Lines[WhichLine];
    if CodeString <> '' then begin
      // Don't do if blank
      //Interpret current line here
      if CodeString <> '' then
        repeat begin
            if Pos(' ', CodeString) > 0 then
              NewWord := Copy(Codestring, 1, Pos(' ', codestring) - 1)
            else
              NewWord := CodeString;
            if Pos(' ', CodeString) > 0 then
              CodeString := Copy(CodeString, Pos(' ', CodeString) + 1, Length(CodeString))
            else
              CodeString := ''; // Delete word that was just found
            // Find 1st word
            // Interpret 1st word
            //If Pos('MESSAGE',UpperCase(NewWord))=1 then begin;
            //  InterpretCommandMessage(CodeString, MemoErrors);
            //  CodeString:='';
            if Length(NewWord) > 4 then
              if (Uppercase(Copy(NewWord, 1, 2)) = '<<') and (Uppercase(Copy(NewWord, Length(NewWord) - 1, 2)) = '>>') then begin
                if CheckIfValidObjectorCommand(NewWord, xBaseForm, MemoErrors) = False then begin
                  inc(ErrorCount);
                  MemoErrors.Lines.Add('Command or object ' + NewWord + ' not recognized on line <' + IntToStr(WhichLine + 1) + '>');
                end;
              end;
            if Length(NewWord) > 4 then
              if (Uppercase(Copy(NewWord, 1, 2)) = '##') and (Uppercase(Copy(NewWord, Length(NewWord) - 1, 2)) = '##') then begin
                if CheckIfValidObjectorCommand(NewWord, xBaseForm, MemoErrors) = False then begin
                  inc(ErrorCount);
                  MemoErrors.Lines.Add('Command or object ' + NewWord + ' not recognized on line <' + IntToStr(WhichLine + 1) + '>');
                end;
              end;
            //end else
        end until CodeString = '';
      //Interpret end
    end;
    Inc(WhichLine);
  until WhichLine = MemoCode.Lines.Count;
  if ErrorCount = 0 then
    MemoErrors.Lines.Add('<No errors found>');
  MemoErrors.Lines.Add('<Lines evalutated = ' + IntToStr(MemoCode.Lines.Count) + '>');
end;

initialization

finalization

end.
