unit pncsreviewer;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  DialogsCAPRI,
  Dialogs,
  StdCtrls,
  Fmcntrls,
  ExtCtrls,
  Main,
  Diaccess,
  Fmcmpnts;

type
  TFormReviewerUtility = class(TForm)
    FMComboBoxReviewEvents: TFMComboBox;
    lblDTComboBox: TLabel;
    btnAddSendBackEvent: TButton;
    Panel1: TPanel;
    Label4: TLabel;
    Label2: TLabel;
    FMMemoComments: TFMMemo;
    FMEditReviewerName: TFMEdit;
    Button2: TButton;
    FMEditReviewDateTime: TFMEdit;
    Label5: TLabel;
    FMListerReviewInfo: TFMLister;
    FMGetsReviewData: TFMGets;
    Button3: TButton;
    procedure btnAddSendBackEventClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FMComboBoxReviewEventsChange(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FMComboBoxReviewEventsKeyPress(Sender: TObject;      var Key: Char);
    procedure FormCreate(Sender: TObject);
  protected
    FSentBack   : Integer;
    FSentSuccess: Boolean;
    function GetSentSuccess: Boolean;
    function GetSentBack: Integer;
    procedure SetSentBack(const Value: Integer);
    { Private declarations }
  published
    { Published declarations }
    property SentSuccess: Boolean read GetSentSuccess write FSentSuccess;
    property SentBack        : Integer read GetSentBack write SetSentBack;
  end;

var
  FormReviewerUtility: TFormReviewerUtility;

implementation

uses PNCSMain;

{$R *.DFM}

// CodeCR304 jrl - 3/23/12.  Changed the ScrollBars property on FMMemoComments
// from ssBoth to ssVertical.  Using ssVertical allows the memo field to
// wrap pasted data instead of putting all comments on one line. This
// avoids errors when large amounts of text were input on one line.
// Changed the FMMemoStyle property from msByLines to msWrapped to force
// retrieved data to wrap correctly.

procedure TFormReviewerUtility.btnAddSendBackEventClick(Sender: TObject);
begin
  FSentSuccess := False;
  btnAddSendBackEvent.Enabled := False;
  FMEditReviewerName.IENS := '+1,' + pncsform.xFMEdit10.IENS;
  FMEditReviewDateTime.IENS := '+1,' + pncsform.xFMEdit10.IENS;
  FMMemoComments.IENS := '+1,' + pncsform.xFMEdit10.IENS;
  FMEditReviewerName.text := '`' + AuthorIEN;
  if FMEditReviewerName.FMModified then
    if FMEditReviewerName.Validate then begin
      //frmMain.FMFiler1.AddChgdControl(FMEditReviewerName);
      FMEditReviewerName.Text := FMEditReviewerName.FMCtrlExternal;
    end
    else begin
      frmMain.FMValidator1.DisplayErrors;
      FMEditReviewerName.Text := FMEditReviewerName.FMTag;
    end;
  FMEditReviewDateTime.text := 'NOW';
  if FMEditReviewDateTime.FMModified then
    if FMEditReviewDateTime.Validate then begin
      //frmMain.FMFiler1.AddChgdControl(FMEditReviewDateTime);
      FMEditReviewDateTime.Text := FMEditReviewDateTime.FMCtrlExternal;
    end
    else begin
      frmMain.FMValidator1.DisplayErrors;
      FMEditReviewDateTime.Text := FMEditReviewDateTime.FMTag;
    end;
  FMMemoComments.Lines.Clear;
  FMMemoComments.Enabled := True;
  FMMemoComments.ReadOnly := False;
  FMMemoComments.Color := clYellow;
//  FMMemoComments.SetFocus;  // CodeCR304 - jrl, 3/23/12, added for user convenience -- causes problems so remove again JRL 12/18/12
  Button2.Enabled := True;
  FMComboBoxReviewEvents.Enabled := False;
end;

procedure TFormReviewerUtility.Button2Click(Sender: TObject);
begin
  frmMain.FMFiler1.AddChgdControl(FMEditReviewerName);
  frmMain.FMFiler1.AddChgdControl(FMEditReviewDateTime);
  frmMain.FMFiler1.AddChgdControl(FMMemoComments);
  pncsForm.xFMEditFlagNew.text := 'Y';

  if frmMain.FMFiler1.AnythingToFile then
    if frmMain.FMFiler1.Update then begin
      FSentSuccess := True;
      //ModalResult := mrOK;
    end
    else begin
      FSentSuccess := False;
      ShowMessageCAPRI('Not able to save data to VistA!');
    end;
  if FSentSuccess then begin
  formReviewerUtility.caption := '~CLOSE~';
  formReviewerUtility.Visible := False;
  end;
  //modalresult := mrOk;
  Close;
end;

procedure TFormReviewerUtility.FMComboBoxReviewEventsChange(
  Sender: TObject);
begin
  if FMComboBoxReviewEvents.ItemIndex > -1 then begin
    FMGetsReviewData.IENS := FMComboBoxReviewEvents.GetSelectedRecord.IEN + ',' + pncsform.xFMEdit10.IENS;
    FMGetsReviewData.GetAndFill;
    FMMemoComments.ReadOnly := True;
    FMMemoComments.Color := clWindow;
  end;
end;

procedure TFormReviewerUtility.Button3Click(Sender: TObject);
begin
  FSentSuccess := False;
  modalresult := mrCancel;
end;

procedure TFormReviewerUtility.FMComboBoxReviewEventsKeyPress(
  Sender: TObject; var Key: Char);
begin
  Key := char(0);
end;

function TFormReviewerUtility.GetSentSuccess: Boolean;
begin
  Result := FSentSuccess;
end;

function TFormReviewerUtility.GetSentBack: Integer;
begin
  Result:=FSentBack;
end;

procedure TFormReviewerUtility.SetSentBack(const Value: Integer);
begin
  FSentBack:=Value;
end;

procedure TFormReviewerUtility.FormCreate(Sender: TObject);
begin
  FSentBack    := 0;
  FSentSuccess := False;
end;

end.
