unit properties;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  DialogsCAPRI,
  Dialogs,
  StdCtrls,
  ExtCtrls,
  Buttons,
  ComCtrls,
  OleServer,
  SpeechLib_TLB;

type
  TfrmProperties = class(TForm)
    Button1: TButton;
    GroupBox1: TGroupBox;
    ScrollBarKeyboardSensitivity: TScrollBar;
    GroupBox2: TGroupBox;
    LableSample: TLabel;
    Button3: TButton;
    Button4: TButton;
    Label2: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label1: TLabel;
    CCOWTimer: TTimer;
    GroupBoxSpeech: TGroupBox;
    Label3: TLabel;
    ComboBoxVoice: TComboBox;
    Label4: TLabel;
    TrackBarSpeechRate: TTrackBar;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    TrackBarSpeechVolume: TTrackBar;
    Label8: TLabel;
    Label9: TLabel;
    SpVoice1: TSpVoice;
    GroupBox3: TGroupBox;
    lstEngineInfo: TListBox;
    Button2: TButton;
    Label11: TLabel;
    Label12: TLabel;
    CheckBoxActivateSpeechPrompts: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ScrollBarKeyboardSensitivityChange(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure CCOWTimerTimer(Sender: TObject);
    procedure ComboBoxVoiceChange(Sender: TObject);
    procedure TrackBarSpeechRateChange(Sender: TObject);
    procedure TrackBarSpeechVolumeChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmProperties: TfrmProperties;

implementation

uses main;

{$R *.DFM}

procedure TfrmProperties.Button1Click(Sender: TObject);
begin
  ModalResult := mrOk
end;

procedure TfrmProperties.Button2Click(Sender: TObject);
var
  x: integer;
  temptext: string;
begin
  Randomize;
  x := random(28) + 1;
  case X of
    1: temptext := 'A banker is a fellow who lends you his umbrella when the sun is shining, but wants it back the minute it begins to rain.';
    2: temptext := 'A man cannot be comfortable without his own approval.';
    3: temptext := 'Always acknowledge a fault. This will throw those in authority off their guard and give you an opportunity to commit more.';
    4: temptext := 'Always do right. This will gratify some people and astonish the rest.';
    5: temptext := 'An Englishman is a person who does things because they have been done before. An American is a person who does things because they haven''t been done before.';
    6: temptext := 'Barring that natural expression of villainy which we all have, the man looked honest enough.';
    7: temptext := 'Be careful about reading health books. You may die of a misprint.';
    8: temptext := 'By trying we can easily learn to endure adversity -- another man''s I mean.';
    9: temptext := 'Clothes make the man. Naked people have little or no influence on society.';
    10: temptext := 'Courage is resistance to fear, mastery of fear - not absence of fear.';
    11: temptext := 'Do something every day that you don''t want to do; this is the golden rule for acquiring the habit of doing your duty without pain.';
    12: temptext := 'Don''t go around saying the world owes you a living. The world owes you nothing. It was here first.';
    13: temptext := 'Don''t part with your illusions. When they are gone you may still exist, but you have ceased to live.';
    14: temptext := 'Education: that which reveals to the wise, and conceals from the stupid, the vast limits of their knowledge.';
    15: temptext := 'Facts are stubborn things, but statistics are more pliable.';
    16: temptext := 'Fiction is obliged to stick to possibilities. Truth isn''t.';
    17: temptext := 'Get your facts first, and then you can distort them as much as you please.';
    18: temptext := 'Grief can take care of itself, but to get the full value of a joy you must have somebody to divide it with.';
    19: temptext := 'Habit is habit and not to be flung out of the window by any man, but coaxed downstairs a step at a time.';
    20: temptext := 'Honesty is the best policy - when there is money in it.';
    21: temptext := 'Humor is the great thing, the saving thing. The minute it crops up, all our irritations and resentments slip away and a sunny spirit takes their place.';
    22: temptext := 'I am opposed to millionaires, but it would be dangerous to offer me the position.';
    23: temptext := 'I didn''t attend the funeral, but I sent a nice letter saying that I approved of it.';
    24: temptext := 'I don''t give a damn for a man that can only spell a word one way.';
    25: temptext := 'I have a higher and grander standard of principle than George Washington. He could not lie; I can, but I won''t.';
    26: temptext := 'I have never let my schooling interfere with my education.';
    27: temptext := 'I have never taken any exercise except sleeping and resting.';
    28: temptext := 'I thoroughly disapprove of duels. If a man should challenge me, I would take him kindly and forgivingly by the hand and lead him to a quiet place and kill him.';
    29: temptext := 'I was gratified to be able to answer promptly. I said I don''t know.';
    else
      temptext := 'I''m confused.  Try again.'
  end;
  SPVoice1.Speak('<speak><voice name="' + frmproperties.comboboxvoice.text + '"><volume level="' + inttostr(frmproperties.trackBarSpeechVolume.Position) + '"><rate absspeed="' + inttostr(frmproperties.trackBarSpeechRate.Position) + '">' + temptext + '</rate></speed></voice></speak>', SVSFlagsAsync + SVSFPurgeBeforeSpeak);

  // frmMain.SpVoice1.Speak(temptext,SVSFlagsAsync+SVSFPurgeBeforeSpeak);
end;

procedure TfrmProperties.BitBtn2Click(Sender: TObject);
begin
  WinExec('CONTROL.EXE DESK.CPL', sw_ShowNormal);
end;

procedure TfrmProperties.BitBtn1Click(Sender: TObject);
begin
  WinExec('CONTROL.EXE ACCESS.CPL', sw_ShowNormal);
end;

procedure TfrmProperties.Button3Click(Sender: TObject);
begin
  frmMain.FontDialog1.Execute;
  LableSample.Font := frmMain.FontDialog1.Font;
  frmMain.SetFont;
  frmMain.FormResize(Application);
end;

procedure TfrmProperties.FormCreate(Sender: TObject);
begin
  LableSample.Font := frmMain.FontDialog1.Font;
end;

procedure TfrmProperties.ScrollBarKeyboardSensitivityChange(
  Sender: TObject);
begin
  Label1.Caption := IntToStr(ScrollBarKeyboardSensitivity.Position) + ' ms';
end;

procedure TfrmProperties.Button4Click(Sender: TObject);
begin
  frmMain.FontDialog1.Font.name := 'MS Sans Serif';
  frmMain.FontDialog1.font.charset := DEFAULT_CHARSET;
  frmMain.FontDialog1.Font.size := 8;
  frmMain.FontDialog1.Font.style := [];
  frmMain.FontDialog1.Font.pitch := fpDefault;
  frmMain.FontDialog1.Font.height := -11;
  LableSample.Font := frmMain.FontDialog1.Font;
  frmMain.SetFont;
  frmMain.FormResize(Application);
  ScrollBarKeyboardSensitivity.Position := 500;
  ScrollBarKeyboardSensitivityChange(Application);
end;

procedure TfrmProperties.CCOWTimerTimer(Sender: TObject);
begin
  if ShutdownCAPRIModalDialogs = true then begin
    CCOWTimer.Enabled := False;
    modalresult := mrOk;
    frmProperties.Visible := False;
  end;
end;

procedure TfrmProperties.ComboBoxVoiceChange(Sender: TObject);
var
  SOToken: ISpeechObjectToken;
begin
  with lstEngineInfo.Items do begin
    Clear;
    SOToken := ISpeechObjectToken(Pointer(
      comboBoxVoice.Items.Objects[comboBoxVoice.ItemIndex]));
    frmMain.SpVoice1.Voice := SOToken;
    try
      Add(Format('Name: %s', [SOToken.GetAttribute('Name')]));
    except
    end;
    try
      Add(Format('Vendor: %s', [SOToken.GetAttribute('Vendor')]));
    except
    end;
    try
      Add(Format('Age: %s', [SOToken.GetAttribute('Age')]));
    except
    end;
    try
      Add(Format('Gender: %s', [SOToken.GetAttribute('Gender')]));
    except
    end;
    try
      Add(Format('Language: %s', [SOToken.GetAttribute('Language')]));
    except
    end;
    try
      Add(Format('Reg key: %s', [SOToken.Id]));
    except
    end;
  end;
end;

procedure TfrmProperties.TrackBarSpeechRateChange(Sender: TObject);
begin
  frmMain.SPVoice1.Rate := TrackBarSpeechRate.Position;
end;

procedure TfrmProperties.TrackBarSpeechVolumeChange(Sender: TObject);
begin
  frmMain.SPVoice1.Volume := TrackBarSpeechVolume.Position;
end;

end.
