unit pseudossn;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  DialogsCAPRI,
  Dialogs,
  StdCtrls,
  Mask;

type
  TfrmPseudoSSN = class(TForm)
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Label8: TLabel;
    MaskEditDOB: TMaskEdit;
    GroupBox1: TGroupBox;
    labelSSN: TLabel;
    Label5: TLabel;
    Edit1: TEdit;
    Label6: TLabel;
    Edit2: TEdit;
    Label7: TLabel;
    Edit3: TEdit;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Edit1Exit(Sender: TObject);
    procedure Edit1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmPseudoSSN: TfrmPseudoSSN;

implementation

{$R *.DFM}

procedure TfrmPseudoSSN.Button2Click(Sender: TObject);
var
  m, d: integer;
begin
  if (Edit1.Text = '') or
    (Edit3.Text = '') then begin
    ShowMessageCAPRI('You must enter at least the first and last name.');
    exit;
  end;
  if MaskeditDOB.Text = '  /  /    ' then begin
    ShowMessageCAPRI('You must enter a DOB.');
    exit;
  end;
  //Make sure date is valid
  m := 0;
  d := 0;
  try
  m := StrToInt(copy(Maskeditdob.text, 1, 2))except
  end;
  try
  d := StrToInt(copy(Maskeditdob.text, 4, 2))except
  end;
  if (m < 1) or (m > 12) then begin
    ShowMessageCAPRI('Month is invalid.');
    exit;
  end;
  if ((d < 1) or (d > 31)) or
    ((m = 1) and (d > 31)) or
    ((m = 2) and (d > 29)) or
    ((m = 3) and (d > 31)) or
    ((m = 4) and (d > 30)) or
    ((m = 5) and (d > 31)) or
    ((m = 6) and (d > 30)) or
    ((m = 7) and (d > 31)) or
    ((m = 8) and (d > 31)) or
    ((m = 9) and (d > 30)) or
    ((m = 10) and (d > 31)) or
    ((m = 11) and (d > 30)) or
    ((m = 12) and (d > 31)) then begin
    ShowMessageCAPRI('Day is invalid for month selected.');
    exit;
  end;
  modalresult := mrOK;
end;

procedure TfrmPseudoSSN.Button1Click(Sender: TObject);
begin
  modalresult := mrCancel;
end;

procedure TfrmPseudoSSN.Edit1Exit(Sender: TObject);
var
  x: integer;
  tempEdit: TEdit;
begin
  tempEdit := Sender as TEdit;
  // Remove trailing spaces
  if Length(TempEdit.Text) > 0 then begin
    x := length(TempEdit.text);
    repeat begin
        if Copy(TempEdit.Text, x, 1) = ' ' then
          TempEdit.Text := copy(TempEdit.text, 1, x - 1)
        else
          x := 1;
        dec(x);
    end until x = 0;
  end;
  // Remove leading spaces
  if Length(TempEdit.Text) > 0 then begin
    x := 0;
    repeat begin
        if Copy(TempEdit.Text, 1, 1) = ' ' then begin
          TempEdit.Text := copy(TempEdit.text, 2, length(TempEdit.text) - 1);
          dec(x);
        end
        else
          x := length(TempEdit.text);
        inc(x);
    end until x > length(TempEdit.text);
  end;
end;

procedure TfrmPseudoSSN.Edit1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  char1, char2, char3: string;
  m, d, y: string;
  function convertpseudo(a: string): string;
  begin
    result := '';
    if a = '' then
      result := '9';
    if (a = 'A') or (a = 'B') or (a = 'C') then
      result := '1';
    if (a = 'D') or (a = 'E') or (a = 'F') then
      result := '2';
    if (a = 'G') or (a = 'H') or (a = 'I') then
      result := '3';
    if (a = 'J') or (a = 'K') or (a = 'L') then
      result := '4';
    if (a = 'M') or (a = 'N') or (a = 'O') then
      result := '5';
    if (a = 'P') or (a = 'Q') or (a = 'R') then
      result := '6';
    if (a = 'S') or (a = 'T') or (a = 'U') then
      result := '7';
    if (a = 'V') or (a = 'W') or (a = 'X') then
      result := '8';
    if (a = 'Y') or (a = 'Z') then
      result := '0';
  end;

begin
  Edit1Exit(Edit1);
  Char1 := '';
  Char2 := '';
  Char3 := '';
  m := '';
  d := '';
  y := '';
  //First middle last
  if Edit1.text <> '' then
    char1 := Uppercase(Copy(edit1.Text, 1, 1));
  if Edit2.text <> '' then
    char2 := Uppercase(Copy(edit2.Text, 1, 1));
  if Edit3.text <> '' then
    char3 := Uppercase(Copy(edit3.Text, 1, 1));
  char1 := ConvertPseudo(char1);
  char2 := ConvertPseudo(char2);
  char3 := ConvertPseudo(char3);
  // Month Day Year
  m := copy(Maskeditdob.text, 1, 2);
  if m = '  ' then
    m := '00';
  if (m[1] = ' ') or (m[2] = ' ') then
    m := '00';
  d := copy(Maskeditdob.text, 4, 2);
  if d = '  ' then
    d := '00';
  if (d[1] = ' ') or (d[2] = ' ') then
    d := '00';
  y := copy(Maskeditdob.text, 9, 2);
  if y = '  ' then
    y := '00';
  if (y[1] = ' ') or (y[2] = ' ') then
    y := '00';
  m := IntToStr(StrToInt(m));
  if length(m) = 1 then
    m := '0' + m;
  if length(m) = 0 then
    m := '00';
  d := IntToStr(StrToInt(d));
  if length(d) = 1 then
    d := '0' + d;
  if length(d) = 0 then
    d := '00';
  y := IntToStr(StrToInt(y));
  if length(y) = 1 then
    y := '0' + y;
  if length(y) = 0 then
    y := '00';
  // Build SSN
  labelssn.caption := char1 + char2 + char3 + m + d + y + 'P';
end;

end.
