unit remotereports;

interface

uses
  Windows,
  Messages,
  ActnList,
  Buttons,
  Classes,
  ComCtrls,
  Controls,
  Diaccess,
  Dialogs,
  DialogsCAPRI,
  ExtCtrls,
  Fmcmpnts,
  Fmcntrls,
  Forms,
  Gauges,
  Graphics,
  Menus,
  ORCtrls,
  Printers,
  ShlObj,
  StdCtrls,
  SysUtils,
  TRPCB,
  CCOWRPCBrokerCAPRI;

type
  TfrmRemoteReports = class(TForm)
    ActionClear                           : TAction;
    ActionClose                           : TAction;
    ActionList1                           : TActionList;
    ActionPrint                           : TAction;
    ActionPrintSetup                      : TAction;
    ActionSaveAs                          : TAction;
    BitBtnClear                           : TBitBtn;
    BitBtnPrint                           : TBitBtn;
    BitBtnPrintSetup                      : TBitBtn;
    BitBtnSaveAs                          : TBitBtn;
    ButtonClose                           : TButton;
    ButtonLookupRO                        : TButton;
    ButtonRunSelected                     : TButton;
    btnSelectAll: TButton;
    CustomExamListDivisions               : TFMGets;
    DateTimePickerStart                   : TDateTimePicker;
    DateTimePickerStop                    : TDateTimePicker;
    EditRONumber                          : TEdit;
    File1                                 : TMenuItem;
    FMEditInactivateDivision              : TFMEdit;
    FMListerCustomExamListDivisions       : TFMLister;
    FMListerCustomExamListDivisionsListBox: TFMListBox;
    FMRegionalOfficeNumberFake            : TFMEdit;
    Gauge1                                : TGauge;
    GroupBox1                             : TGroupBox;
    Label1                                : TLabel;
    Label13                               : TLabel;
    Label14                               : TLabel;
    Label16                               : TLabel;
    Label2                                : TLabel;
    Label3                                : TLabel;
    Label4                                : TLabel;
    Label5                                : TLabel;
    LabelSite                             : TLabel;
    ListBoxDivisions                      : TListBox;
    MainMenu1                             : TMainMenu;
    N1                                    : TMenuItem;
    N2                                    : TMenuItem;
    OpenDialogCRR                         : TOpenDialog;
    ORListBoxAvailableConnections         : TORListBox;
    PanelBuildingReport                   : TPanel;
    PanelReportControl                    : TPanel;
    PanelReportView                       : TPanel;
    PanelSelectReport                     : TPanel;
    Print1                                : TMenuItem;
    PrintDialogCRR                        : TPrintDialog;
    PrinterSetupDialogCRR                 : TPrinterSetupDialog;
    PrintSetup1                           : TMenuItem;
    Quit1                                 : TMenuItem;
    RadioButtonAMIS290                    : TRadioButton;
    RadioButtonCPFinalPrint               : TRadioButton;
    RadioButtonPendingCnP                 : TRadioButton;
    ReportMemo                            : TRichEdit;
    RichEditWorkSpace                     : TRichEdit;
    SaveAs1                               : TMenuItem;
    SaveDialogCRR                         : TSaveDialog;
    Splitter1                             : TSplitter;
    aniBusy: TAnimate;
    lbFailedReports: TORListBox;
    lbSuccessfulReports: TORListBox;
    rgPriorityOfExamFilter: TRadioGroup;  //CodeCR162 - rpm 4/21/11
    cbAllRO: TCheckBox;         //CodeCR162 - rpm 4/21/11
    pnlAMIS290: TPanel;                   // CodeCR440 JRL 11/16/12
    memoAMIS290Message: TMemo;
    rgReportFormat: TRadioGroup;
    SaveDialog: TSaveDialog;            // CodeCR440 JRL 11/16/12
    procedure ActionClearExecute(Sender: TObject);
    procedure ActionCloseExecute(Sender: TObject);
    procedure ActionPrintExecute(Sender: TObject);
    procedure ActionPrintSetupExecute(Sender: TObject);
    procedure ActionSaveAsExecute(Sender: TObject);
    procedure BitBtnClearClick(Sender: TObject);
    procedure BitBtnPrintClick(Sender: TObject);
    procedure BitBtnPrintSetupClick(Sender: TObject);
    procedure BitBtnSaveAsClick(Sender: TObject);
    procedure ButtonCloseClick(Sender: TObject);
    procedure ButtonLookupROClick(Sender: TObject);
    procedure ButtonRunSelectedClick(Sender: TObject);
    procedure btnSelectAllClick(Sender: TObject);
    procedure EditRONumberKeyPress(Sender: TObject; var Key: Char);
    procedure FMRegionalOfficeNumberEnter(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure Quit1Click(Sender: TObject);
    procedure RadioButtonAMIS290Click(Sender: TObject);
    procedure RadioButtonCPFinalPrintClick(Sender: TObject);
    procedure RadioButtonPendingCnPClick(Sender: TObject);
    procedure cbAllROClick(Sender: TObject);  //CodeCR162 - rpm 4/21/11
  private
    { Private declarations }
    function AMIS290(aConnectionName: string; aRegionalOffice: string; DivisionList: TStrings; aBroker: TRPCBroker): boolean;
    function CnPReprint(aConnectionName, aRegionalOffice: string;aBroker: TRPCBroker): boolean;
    function FMToDateConvert(DateTimeST: string): string;
    function GetDivisionsConsolidated: tstrings;
    function PendingCnP(aConnectionName: string; aRegionalOffice: string; aBroker: TRPCBroker): boolean;
    function PendingCnPDelimited(aConnectionName: string; aRegionalOffice: string; aBroker: TRPCBroker): boolean;
    function SaveDelimitedReportCSV(DelimitedLines: TStringList; ReportName: String): String;  //CodeCR470 JRL 4/24/13
    procedure SaveCnPReportCSV;                                                                //CodeCR470 JRL 4/24/13
  protected
    { Protected declarations }
    function FormatPages(ReportName: string; aBroker: TRPCBroker): integer;
    procedure PagedPrint(lines: TStrings);
  public
    { Public declarations }
    Procedure DisplayBusyAnimation(Display: Boolean; aCaption: String);  //CodeCR162 - rpm 4/21/11
  end;

var
  frmRemoteReports: TfrmRemoteReports;
  stopcheck: boolean;
  ListMedicalCenterDivisionConsolidated: tStringlist;

implementation

uses
  caprisupport,
  essoselect,
  main,
  rofinder;

{$R *.DFM}

function TfrmRemoteReports.GetDivisionsConsolidated: tstrings;
var
  x, y: integer;
begin
  // Get divisions and force them in the order they are in the file
  frmMain.GetAllDivisions(ListMedicalCenterDivisionConsolidated);  //CodeCR186 - rpm 4/25/11

  FMListerCustomExamListDivisions.getlist(FMListerCustomExamListDivisionsListBox.Items);
  if FMListerCustomExamListDivisionsListBox.Items.Count > 0 then
    for x := 0 to FMListerCustomExamListDivisionsListBox.Items.Count - 1 do begin
      FMListerCustomExamListDivisionsListBox.ItemIndex := x;
      CustomExamListDivisions.IENS := FMListerCustomExamListDivisionsListBox.GetSelectedRecord.IEN;
      CustomExamListDivisions.GetAndFill;
      //Inactivate if "YES"
      if FMEditInactivateDivision.Text = 'YES' then begin
        if ListMedicalCenterDivisionConsolidated.Count > 0 then
          for y := ListMedicalCenterDivisionConsolidated.Count - 1 downto 0 do begin
            //ListMedicalCenterDivisionConsolidated.ItemIndex:=y;
            if Piece(ListMedicalCenterDivisionConsolidated[y], '^', 2) = FMListerCustomExamListDivisionsListBox.Items[x] then begin
              ListMedicalCenterDivisionConsolidated.Delete(y);
            end;
          end;
      end;
    end;

  Result := ListMedicalCenterDivisionConsolidated;
end;

function TfrmRemoteReports.PendingCnP(aConnectionName: string; aRegionalOffice: string; aBroker: TRPCBroker): boolean;
var
  dataLine: string;
  findLocation: integer;
  ro: string;
  examCount: integer;

  function RTrimChar(aChar: char; aString: string): string;
  begin
    Result := Trim(aString);
    while AnsiLastChar(Result) = aChar do
      Result := Copy(Result, 0, Length(Result) - 1);
    Result := Trim(Result); // cleanup any control characters
  end;

begin
  examCount := 0;
  try
    DisplayBusyAnimation(True, 'Working...');  //CodeCR162 - rpm 4/21/11

    aBroker.Results.Clear;
    aBroker.RemoteProcedure := 'DVBAB PENDING C&P REPORT';

    aBroker.Param[0].Value := 'V'; // Always sort by Veteran Name
    aBroker.Param[0].PType := literal;
    aBroker.Param[1].Value := '';
    aBroker.Param[1].PType := literal;
    aBroker.Param[2].Value := '';
    aBroker.Param[2].PType := literal;
    aBroker.Param[3].Value := '';
    aBroker.Param[3].PType := literal;
    aBroker.Param[4].Value := '';
    aBroker.Param[4].PType := literal;
    aBroker.Param[5].Value := 'C'; // Always by (C)alendar Days
    aBroker.Param[5].PType := literal;
    aBroker.Param[6].Value := '0'; // Plain Text                                //CodeCR470 JRL 4/25/13
    aBroker.Param[6].PType := literal;                                          //CodeCR470 JRL 4/25/13
    aBroker.Param[7].Value := '0'; // Plain Text not RO                         //CodeCR470 JRL 5/13/13
    aBroker.Param[7].PType := literal;                                          //CodeCR470 JRL 5/13/13
    
                  
    //ShowMessageCAPRI(aBroker.Param[0].Value);
    //ShowMessageCAPRI(aBroker.Param[1].Value);
    //ShowMessageCAPRI(aBroker.Param[2].Value);
    //ShowMessageCAPRI(aBroker.Param[3].Value);
    //ShowMessageCAPRI(aBroker.Param[4].Value);
    //ShowMessageCAPRI(aBroker.Param[5].Value);

    frmMain.RPCBrokerCall;
    try
      aBroker.Call;
      if aBroker.Results.Count > 0 then 
      begin
//        try
//          CapriQuickCopy(frmMain.RPCBroker1.Results, ReportMemo);
//   
        try
          Screen.Cursor := crHourglass;
          ReportMemo.Enabled := False;
          ReportMemo.Lines.Add('========================================');
          ReportMemo.Lines.Add('   ' + aConnectionName + ' report follows:');
          ReportMemo.Lines.Add('========================================');
          RichEditWorkSpace.Clear;
          repeat
            begin

              if Pos('^', aBroker.Results[0]) > 0 then begin
                dataLine := Copy(aBroker.Results[0], 1, Pos('^', aBroker.Results[0]) - 1);
                aBroker.Results[0] := Copy(aBroker.Results[0], Pos('^', aBroker.Results[0]) + 1, Length(aBroker.Results[0]));
              end
              else begin
                dataLine := aBroker.Results[0];
                aBroker.Results[0] := '';
              end;

              if ((Pos('Division:', dataLine) > 0) or (Pos('Total pending:', dataLine) > 0)) then begin
                findLocation := RichEditWorkSpace.FindText('Requested by:', 0, Length(RichEditWorkSpace.Text), [stMatchCase]);
                if findLocation > -1 then begin
                  findLocation := RichEditWorkSpace.FindText('at ', findLocation + 12, Length(RichEditWorkSpace.Text), [stMatchCase]);
                  ro := RTrimChar('-', Copy(RichEditWorkSpace.Text, findLocation + 3, Length(RichEditWorkSpace.Text)));
                end;
                if ro = Trim(aRegionalOffice) then begin
                  ReportMemo.Lines.AddStrings(RichEditWorkSpace.Lines);
                  Inc(examCount);
                end;
                RichEditWorkSpace.Clear;
                RichEditWorkSpace.Lines.Add(dataLine); // Should be division: label of next block
              end
              else
                RichEditWorkSpace.Lines.Add(dataLine);

            end
          until aBroker.Results[0] = '';

          ReportMemo.Lines.Add('Total pending for ' + aRegionalOffice + ': ' + IntToStr(examCount));
          {
                    // get any residual (such as the 'Total Pending:'
                   if RichEditWorkSpace.Lines.Count > 0 then
                    begin
                      ReportMemo.Lines.AddStrings(RichEditWorkSpace.Lines);
                      ReportMemo.Lines.Add('Note: Total is for ALL pending exams on this system, regardless of the requestor.');
                    end;
          }
          RichEditWorkSpace.Clear;

        finally
          Screen.Cursor := crDefault;
          ReportMemo.Enabled := True;
        end;
      end
      else
        ReportMemo.Lines.Add('No data found for requested report criteria.');
      Result := true;
    except
      on E: EBrokerError do begin
        ReportMemo.Lines.Add('!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!');
        ReportMemo.Lines.Add(aConnectionName + ' report could NOT be run!');
        ReportMemo.Lines.Add('!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!');
        ReportMemo.Lines.Add(E.Message);
        ANURemoteProcedureCallInProgress := False;
        Result := false;
      end;
    end;

    ReportMemo.Lines.Add(' ');
    ReportMemo.Lines.Add('========================================'); // Inter Report seperator
    ReportMemo.Lines.Add('     End of ' + aConnectionName); // Inter Report seperator
    ReportMemo.Lines.Add('========================================'); // Inter Report seperator
    ReportMemo.Lines.Add(' ');
  finally
    DisplayBusyAnimation(false, '');  //CodeCR162 - rpm 4/21/11
  end;
end;

//------------------------------------------------------------------------------
// CodeCR470 JRL 4/25/13
// Added Delimited Consolidated Pending C&P Exam Report
// Create separate report for readability as the format for the delimited 
// report will likely change.
//------------------------------------------------------------------------------
function TfrmRemoteReports.PendingCnPDelimited(aConnectionName: string; aRegionalOffice: string; aBroker: TRPCBroker): boolean;
var
  dataLine: string;
  findLocation: integer;
  ro: string;
  examCount: integer;
  i : Integer;
  
  function RTrimChar(aChar: char; aString: string): string;
  begin
    Result := Trim(aString);
    while AnsiLastChar(Result) = aChar do
      Result := Copy(Result, 0, Length(Result) - 1);
    Result := Trim(Result); // cleanup any control characters
  end;

begin
  examCount := 0;
  try
    DisplayBusyAnimation(True, 'Working...');  //CodeCR162 - rpm 4/21/11

    aBroker.Results.Clear;
    aBroker.RemoteProcedure := 'DVBAB PENDING C&P REPORT';

    aBroker.Param[0].Value := 'V'; // Always sort by Veteran Name
    aBroker.Param[0].PType := literal;
    aBroker.Param[1].Value := '';
    aBroker.Param[1].PType := literal;
    aBroker.Param[2].Value := '';
    aBroker.Param[2].PType := literal;
    aBroker.Param[3].Value := '';
    aBroker.Param[3].PType := literal;
    aBroker.Param[4].Value := '';
    aBroker.Param[4].PType := literal;
    aBroker.Param[5].Value := 'C'; // Always by (C)alendar Days
    aBroker.Param[5].PType := literal;
    aBroker.Param[6].Value := '1'; // Delimited
    aBroker.Param[6].PType := literal;
    aBroker.Param[7].Value := FMRegionalOfficeNumberFake.Text; // RO            // CodeCR470 JRL 5/2/13
    aBroker.Param[7].PType := literal;                                          // This is an optional parameter only
                                                                                // sent via the Remote Consolidated
                                                                                // Reports to allow the RPC to know 
                                                                                // this is a consolated report so
                                                                                // add an additional column to include
                                                                                // the Regional Office within the data.
    frmMain.RPCBrokerCall;                                                      
    try
      aBroker.Call;
      
      if aBroker.Results.Count > 0 then begin
        try
          Screen.Cursor := crHourglass;
          ReportMemo.Enabled := False;
          ReportMemo.Lines.Add('========================================');
          ReportMemo.Lines.Add('   ' + aConnectionName + ' report follows:');
          ReportMemo.Lines.Add('========================================');

          for i := 0 to frmMain.RPCBroker1.Results.Count - 1 do                 //CodeCR470 JRL 7/26/13
              Reportmemo.Lines.Add(frmMain.RPCBroker1.Results[i]);              //CodeCR470 JRL 7/26/13
          
//          RichEditWorkSpace.Clear;
//          repeat
//            begin
//
//              if Pos('^', aBroker.Results[0]) > 0 then begin
//                dataLine := Copy(aBroker.Results[0], 1, Pos('^', aBroker.Results[0]) - 1);
//                aBroker.Results[0] := Copy(aBroker.Results[0], Pos('^', aBroker.Results[0]) + 1, Length(aBroker.Results[0]));
//              end
//              else begin
//                dataLine := aBroker.Results[0];
//                aBroker.Results[0] := '';
//              end;
//
//              if ((Pos('Division:', dataLine) > 0) or (Pos('Total pending:', dataLine) > 0)) then begin
//                findLocation := RichEditWorkSpace.FindText('Requested by:', 0, Length(RichEditWorkSpace.Text), [stMatchCase]);
//                if findLocation > -1 then begin
//                  findLocation := RichEditWorkSpace.FindText('at ', findLocation + 12, Length(RichEditWorkSpace.Text), [stMatchCase]);
//                  ro := RTrimChar('-', Copy(RichEditWorkSpace.Text, findLocation + 3, Length(RichEditWorkSpace.Text)));
//                end;
//                if ro = Trim(aRegionalOffice) then begin
//                  ReportMemo.Lines.AddStrings(RichEditWorkSpace.Lines);
//                  Inc(examCount);
//                end;
//                RichEditWorkSpace.Clear;
//                RichEditWorkSpace.Lines.Add(dataLine); // Should be division: label of next block
//              end
//              else
//                RichEditWorkSpace.Lines.Add(dataLine);
//
//            end
//          until aBroker.Results[0] = '';
//
//          ReportMemo.Lines.Add('Total pending for ' + aRegionalOffice + ': ' + IntToStr(examCount));
//          {
//                    // get any residual (such as the 'Total Pending:'
//                   if RichEditWorkSpace.Lines.Count > 0 then
//                    begin
//                      ReportMemo.Lines.AddStrings(RichEditWorkSpace.Lines);
//                      ReportMemo.Lines.Add('Note: Total is for ALL pending exams on this system, regardless of the requestor.');
//                    end;
//          }
//          RichEditWorkSpace.Clear;

        finally
          Screen.Cursor := crDefault;
          ReportMemo.Enabled := True;
        end;
      end
      else
        ReportMemo.Lines.Add('No data found for requested report criteria.');
      Result := true;
    except
      on E: EBrokerError do begin
        ReportMemo.Lines.Add('!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!');
        ReportMemo.Lines.Add(aConnectionName + ' report could NOT be run!');
        ReportMemo.Lines.Add('!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!');
        ReportMemo.Lines.Add(E.Message);
        ANURemoteProcedureCallInProgress := False;
        Result := false;
      end;
    end;

    ReportMemo.Lines.Add(' ');
    ReportMemo.Lines.Add('========================================'); // Inter Report seperator
    ReportMemo.Lines.Add('     End of ' + aConnectionName); // Inter Report seperator
    ReportMemo.Lines.Add('========================================'); // Inter Report seperator
    ReportMemo.Lines.Add(' ');
  finally
    DisplayBusyAnimation(false, '');  //CodeCR162 - rpm 4/21/11
  end;
end;



function TfrmRemoteReports.CnPReprint(aConnectionName: string; aRegionalOffice: string; aBroker: TRPCBroker): boolean;
var
  dataLine: string;
  i       : integer;
begin
  try

    DisplayBusyAnimation(True, 'Working...');  //CodeCR162 - rpm 4/21/11

    aBroker.Results.Clear;

    aBroker.RemoteProcedure := 'DVBAB REPORTS';

    //   aBroker.Param[0].Value := 'V'; // Always sort by Veteran Name
    //   aBroker.Param[0].PType := literal;
    aBroker.Param[1].Value := '3';
    aBroker.Param[1].PType := literal;
    aBroker.Param[2].Value := '';
    aBroker.Param[2].PType := literal;
    //    aBroker.Param[3].Value := '';
    //    aBroker.Param[3].PType := literal;
    //    aBroker.Param[4].Value := '';
    //    aBroker.Param[4].PType := literal;
    //    aBroker.Param[5].Value := 'C'; // Always by (C)alendar Days
    //    aBroker.Param[5].PType := literal;

        //ShowMessageCAPRI(aBroker.Param[0].Value);
        //ShowMessageCAPRI(aBroker.Param[1].Value);
        //ShowMessageCAPRI(aBroker.Param[2].Value);
        //ShowMessageCAPRI(aBroker.Param[3].Value);
        //ShowMessageCAPRI(aBroker.Param[4].Value);
        //ShowMessageCAPRI(aBroker.Param[5].Value);

    frmMain.RPCBrokerCall;
    try
      aBroker.Call;

      if aBroker.Results.Count > 0 then begin
        try
          Screen.Cursor := crHourglass;
          ReportMemo.Enabled := False;
          //          ReportMemo.Lines.Add('========================================');
          //          ReportMemo.Lines.Add('   '+aConnectionName +' report follows:');
          //          ReportMemo.Lines.Add('========================================');
          RichEditWorkSpace.Clear;
          //repeat
          for i := 0 to aBroker.Results.Count - 1 do begin

            //              if Pos('^',aBroker.Results[0])>0 then
            //              begin
            //                dataLine := Copy(aBroker.Results[0],1,Pos('^',aBroker.Results[0])-1);
            //                aBroker.Results[0] := Copy(aBroker.Results[0],Pos('^',aBroker.Results[0])+1,Length(aBroker.Results[0]));
            //              end
            //              else
            //              begin
            //                dataLine := aBroker.Results[0];
            //                aBroker.Results[0] := '';
            //              end;

            dataLine := aBroker.Results[i];

            {
                     if ((Pos('Division:',dataLine) > 0) or (Pos('Total pending:',dataLine) > 0)) then
                     begin
                       findLocation := RichEditWorkSpace.FindText('Requested by:', 0, Length(RichEditWorkSpace.Text), [stMatchCase]);
                       if findLocation > -1 then
                       begin
                         findLocation := RichEditWorkSpace.FindText('at ', findLocation+12, Length(RichEditWorkSpace.Text), [stMatchCase]);
                         ro := RTrimChar('-',Copy(RichEditWorkSpace.Text,findLocation+3,Length(RichEditWorkSpace.Text)));
                       end;
                       if ro = Trim(aRegionalOffice) then
                       begin
                         ReportMemo.Lines.AddStrings(RichEditWorkSpace.Lines);
                         Inc(examCount);
                       end;
                       RichEditWorkSpace.Clear;
                       RichEditWorkSpace.Lines.Add(dataLine); // Should be division: label of next block
                     end
                     else
             }
            RichEditWorkSpace.Lines.Add(dataLine);

          end;
          // until aBroker.Results[0] = '';

          if RichEditWorkSpace.Lines.Count > 0 then begin
            ReportMemo.Lines.AddStrings(RichEditWorkSpace.Lines);
            //ReportMemo.Lines.Add('Note: Total is for ALL pending exams on this system, regardless of the requestor.');
          end;

          RichEditWorkSpace.Clear;

        finally
          Screen.Cursor := crDefault;
          ReportMemo.Enabled := True;
        end;
      end
      else
        ReportMemo.Lines.Add('No data found for requested report criteria.');
      Result := true;
    except
      on E: EBrokerError do begin
        ReportMemo.Lines.Add('!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!');
        ReportMemo.Lines.Add(aConnectionName + ' report could NOT be run!');
        ReportMemo.Lines.Add('!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!');
        ReportMemo.Lines.Add(E.Message);
        ANURemoteProcedureCallInProgress := False;
        Result := false;
      end;
    end;

    //    ReportMemo.Lines.Add(' ');
    //    ReportMemo.Lines.Add('========================================'); // Inter Report seperator
    //    ReportMemo.Lines.Add('     End of '+aConnectionName);             // Inter Report seperator
    //    ReportMemo.Lines.Add('========================================'); // Inter Report seperator
    //    ReportMemo.Lines.Add(' ');
  finally
    DisplayBusyAnimation(false, '');  //CodeCR162 - rpm 4/21/11
  end;
end;

function TfrmRemoteReports.AMIS290(aConnectionName: string; aRegionalOffice: string; DivisionList: TStrings; aBroker: TRPCBroker): boolean;
var
  i: integer;
  tempString: string;
  PriorityFilter: String;        //CodeCR162 - rpm 4/21/11
begin
  Result := false;

  try
    DisplayBusyAnimation(true, 'Working...');  //CodeCR162 - rpm 4/21/11

    if frmROFinder.ORListBoxSites.Items.Count = 0 then
      frmMain.LoadInstitutions;

    case rgPriorityOfExamFilter.ItemIndex of  //CodeCR162 - rpm 4/21/11
      0: PriorityFilter := 'AO';
      1: PriorityFilter := 'BDD';
      2: PriorityFilter := 'IDES';  //CodeCR331 - LMS 12/18/2012
      else
        PriorityFilter := 'ALL';
    end;

    ReportMemo.Lines.Add('========================================');
    ReportMemo.Lines.Add('   ' + aConnectionName + ' report follows:');
    ReportMemo.Lines.Add('========================================');
    ReportMemo.Lines.Add(' ');
    for i := 0 to DivisionList.Count - 1 do begin
      aBroker.Results.Clear;
      aBroker.RemoteProcedure := 'DVBAB AMIS REPORT';
      aBroker.Param[0].Value := FMToDateConvert(FormatDateTime('mm/dd/yyyy', DateTimePickerStart.Date));
      aBroker.Param[0].PType := literal;
      aBroker.Param[1].Value := FMToDateConvert(FormatDateTime('mm/dd/yyyy', DateTimePickerStop.Date));
      aBroker.Param[1].PType := literal;
      aBroker.Param[2].Value := aRegionalOffice + '^' + Piece(DivisionList.Strings[i], '^', 2);

      //ShowMessageCAPRI(aBroker.Param[2].Value);
      tempString := aBroker.Param[2].Value;
      aBroker.Param[2].PType := literal;
      aBroker.Param[3].Value := 'N'; // Just say NO to mailman
      aBroker.Param[3].PType := literal;
      aBroker.Param[4].Value := AuthorIEN;
      aBroker.Param[4].PType := literal;
      aBroker.Param[5].Value := PriorityFilter;  //CodeCR296 - rpm 2/2/12 - removed IsPatch149Installed check
      aBroker.Param[5].PType := literal;

      frmMain.RPCBrokerCall;
      try
        aBroker.Call;

        if ReportMemo.Lines.count > 0 then begin
          ReportMemo.Lines.Add(' ');
          ReportMemo.Lines.Add('----------------------------------------');
          ReportMemo.Lines.Add('Division: ' + Piece(DivisionList.Strings[i], '^', 1));
          ReportMemo.Lines.AddStrings(aBroker.Results);
        end
        else
          ReportMemo.Lines.Add('No data found for requested report criteria.');
        Result := true;
      except
        on E: EBrokerError do begin
          ReportMemo.Lines.Add('!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!');
          ReportMemo.Lines.Add(aConnectionName + ' report could NOT be run!');
          ReportMemo.Lines.Add('!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!');
          ReportMemo.Lines.Add(tempString + ':' + E.Message);
          ANURemoteProcedureCallInProgress := False;
          Result := false;
          exit;
        end;
      end;
    end; // for Sites

    ReportMemo.Lines.Add(' ');
    ReportMemo.Lines.Add('========================================'); // Inter Report seperator
    ReportMemo.Lines.Add('     End of ' + aConnectionName); // Inter Report seperator
    ReportMemo.Lines.Add('========================================'); // Inter Report seperator
    ReportMemo.Lines.Add(' ');

  finally
    DisplayBusyAnimation(false, '');  //CodeCR162 - rpm 4/21/11
  end;
end;

procedure TfrmRemoteReports.ButtonRunSelectedClick(Sender: TObject);
var
  x, count: integer;
  currentConnection: string;
  reportSuccess: boolean;
  procedure stoprunning;
  begin
    // Stop run here...
    Gauge1.Visible := False;
    btnSelectAll.Enabled := True;
    ButtonClose.Enabled := True;
    ButtonRunSelected.Enabled := True;
    ButtonRunSelected.Enabled := True;
    StopCheck := True;
  end;
begin
  if ButtonRunSelected.Enabled = True then begin
    Count := 0;
    for x := 0 to ORListBoxAvailableConnections.Items.Count - 1 do
      if ORListBoxAvailableConnections.Selected[x] = True then
        inc(Count);
    if Count = 0 then begin
      // Stop run here...
      StopRunning;
      exit;
    end;

    if Gauge1.Visible = True then begin
      ShowMessageCAPRI('Previous connection in progress.  Please try again.');
      exit;
    end;

    if RadioButtonCPFinalPrint.Checked then
      // Confirm they know and accept the reprint protocol
      if MessageDlgCAPRI('WARNING:  This report will extract all unprinted exams, record your name as the person who printed, and will change the status to "PRINTED BY RO" so that they cannot again be printed automatically.  Are you sure you want to continue?',
        mtConfirmation, [mbYes, mbNo], 0) <> mrYes then begin
        exit;
      end;

    //CodeCR162 - rpm 4/21/11 - add AMIS290 All RO check
    if (not RadioButtonCPFinalPrint.Checked) and
       (not cbAllRO.Checked) and
       (Length(Trim(EditRONumber.Text)) = 0) then begin
      ShowMessageCAPRI('Please select a Regional Office.  Please try again.');
      exit;
    end;

    ReportMemo.Clear; // remove last report output
    btnSelectAll.Enabled := False;
    ButtonClose.Enabled := False;
    ButtonRunSelected.Enabled := False;
    //    ButtonRunSelected.Enabled:=False;
    lbFailedReports.Items.Clear; //CodeCR110 -MER 06/2010
    lbSuccessfulReports.Items.Clear; //CodeCR110 -MER 06/2010
    if ORListBoxAvailableConnections.Items.Count = 0 then
      exit;
    Gauge1.Visible := True;
    //First count them up and set the gauge
    Gauge1.Progress := 0;
    Gauge1.MaxValue := Count;
    StopCheck := False;

    LabelSite.Visible := True;
    try
      DateTimePickerStart.Enabled := false;
      DateTimePickerStop.Enabled := false;
      EditRONumber.Enabled := false;
      ButtonLookupRO.Enabled := false;
      cbAllRO.Enabled := False;  //CodeCR162 - rpm 4/21/11
      rgPriorityOfExamFilter.Enabled := False;  //CodeCR162 - rpm 4/21/11
      // Now run the list
      for x := 0 to ORListBoxAvailableConnections.Items.Count - 1 do begin
        if ORListBoxAvailableConnections.Selected[x] = True then begin
          frmMain.RPCBroker1.Connected := false; // close the current connection
          frmMain.RPCBroker1.Server := frmMain.Piece(ORListBoxAvailableConnections.Items[x], '^', 2);
          frmMain.RPCBroker1.ListenerPort := StrToInt(frmMain.Piece(ORListBoxAvailableConnections.Items[x], '^', 3));

          currentConnection := frmMain.Piece(ORListBoxAvailableConnections.Items[x], '^', 1);

          LabelSite.Caption := Piece(ORListboxAvailableConnections.Items[x], '^', 1);
          LabelSite.Repaint;
          DisplayBusyAnimation(True, 'Connecting...');  //CodeCR162 - rpm 4/21/11
          if not frmMain.ConnectToServer('DVBA CAPRI GUI') then begin
            // Couldn't connect...
            reportSuccess := false;
            DisplayBusyAnimation(False, '');  //CodeCR162 - rpm 4/21/11
          end
          else begin // could connect; now let's try a report
            if RadioButtonAMIS290.Checked then 
            begin
              if frmMain.AMIS290URL = '' then                             // CodeCR440 JRL 11/16/12
              begin  // only do a report if AMIS290URL is not defined     // CodeCR440 JRL 11/16/12
                ListBoxDivisions.Items.Clear;
                ListBoxDivisions.Items := GetDivisionsConsolidated;
                reportSuccess := AMIS290(currentConnection, FMRegionalOfficeNumberFake.Text, ListBoxDivisions.Items, frmMain.RPCBroker1)
              end;                                                        // CodeCR440 JRL 11/16/12
            end
            else
              if RadioButtonCPFinalPrint.Checked then begin
                reportSuccess := CnPReprint(currentConnection, FMRegionalOfficeNumberFake.Text, frmMain.RPCBroker1);
              end
              else // Pending C&P
              begin
                if rgReportFormat.ItemIndex = 0 then // plain text
                  reportSuccess := PendingCnP(currentConnection, FMRegionalOfficeNumberFake.Text, frmMain.RPCBroker1)
                else                 
                  reportSuccess := PendingCnPDelimited(currentConnection, FMRegionalOfficeNumberFake.Text, frmMain.RPCBroker1);
              end;  
          end;

          if reportSuccess then begin
            lbSuccessfulReports.Items.Add(currentConnection); //CodeCR110 -MER 06/2010
            if RadioButtonCPFinalPrint.Checked then begin
              PrintDialogCRR.Copies := 1;
              ReportMemo.Lines.Clear;
            end;
          end
          else
            lbFailedReports.Items.Add(currentConnection); //CodeCR110 -MER 06/2010
          frmMain.RPCBroker1.Connected := False; // close the current connection

          if StopCheck = True then
            exit;
          Gauge1.Progress := Gauge1.Progress + 1; // update progress
        end;
      end;

    finally
      if (RadioButtonPendingCnP.Checked) and (rgReportFormat.ItemIndex = 1) then
      begin
        SaveCnPReportCSV;
      end;
      
      DateTimePickerStart.Enabled := true;
      DateTimePickerStop.Enabled := true;
      if NOT cbAllRO.Checked then  //CodeCR162 - rpm 4/25/11
      begin
        EditRONumber.Enabled := true;
        ButtonLookupRO.Enabled := true;
      end;
      cbAllRO.Enabled := True;  //CodeCR162 - rpm 4/21/11
      rgPriorityOfExamFilter.Enabled := True;  //CodeCR162 - rpm 4/21/11
    end;
    StopRunning;
  end
  else begin
    // Stop run here...
    StopRunning;
  end;
  LabelSite.Caption := 'Not connected...';
  LabelSite.Visible := False;
end;


{===========================================================================
 SaveCnPReportCSV
 This procedure copies the lines in the Report Memo from the completed report
 and attempts to save the file.  Displays the number of lines saved.

 //CodeCR470 - JRL - 4/24/13
 ===========================================================================}
procedure TfrmRemoteReports.SaveCnPReportCSV;
var
  Filename : String;               // CodeCR470 JRL 4/24/13
  AbbrevReportName : String;       // CodeCR470 JRL 4/24/13
  DelimitedLines : TStringList;    // CodeCR470 JRL 4/24/13
begin                                                                 
  AbbrevReportName := 'ConsolPendingCnPExam';                                   //CodeCR470 JRL 4/25/13
  DelimitedLines := TStringList.Create;                                         //CodeCR470 JRL 4/25/13
  try                                                                           //CodeCR470 JRL 4/25/13
    CAPRIQuickCopy(ReportMemo, DelimitedLines);                                 //CodeCR470 JRL 4/25/13
    FileName := SaveDelimitedReportCSV(DelimitedLines, AbbrevReportName         //CodeCR470 JRL 4/25/13
                                             + '_'
                                             + FormatDateTime('YYYYMMDD', Now));
    ReportMemo.Lines.Clear;
    ReportMemo.Lines.Insert(0, '');                                             //CodeCR470 JRL 4/25/13
    if (FileName <> '') then                                                    //CodeCR470 JRL 4/25/13
        ReportMemo.Lines.Insert(0, IntToStr(DelimitedLines.Count)               //CodeCR470 JRL 4/25/13
                                + ' Extract lines saved to: ' + #13#10
                                + FileName)
    else                                                                        //CodeCR470 JRL 4/25/13
       ReportMemo.Lines.Insert(0, 'No delimited text lines were saved!');       //CodeCR470 JRL 4/25/13
  finally                                                                       //CodeCR470 JRL 4/25/13
    FreeAndNil(DelimitedLines);                                                 //CodeCR470 JRL 4/25/13
  end;                                                                          //CodeCR470 JRL 4/25/13
end;


{===========================================================================
 SaveDelimitedReportCSV
 This procedure displays the save dialog and saves the passed delimited data
 to the selected filename.  Returns filepath on success; otherwise returns ''
 This routine saves the data to a CSV extension instead of a TXT extension
 for easier integration into Excel.

 //CodeCR470 - JRL - 4/24/13
 ===========================================================================}
function TfrmRemoteReports.SaveDelimitedReportCSV(DelimitedLines: TStringList;
  ReportName: String): String;
var
  IsExistingFile: Boolean;
  ExistsDlgMsg: String;
begin    
  Result := '';
  if (DelimitedLines.Count > 0) then
  begin
    SaveDialog.FileName := ReportName;
    if (SaveDialog.InitialDir = '') then
      SaveDialog.InitialDir := GetSystemPath(CSIDL_DESKTOP);
    SaveDialog.DefaultExt :=  'csv';
    SaveDialog.Filter := 'CSV file (*.csv)|*.csv';
    if SaveDialog.Execute then
    begin
      IsExistingFile := FileExists(SaveDialog.FileName);
      if IsExistingFile then
        ExistsDlgMsg := SaveDialog.FileName + ' already exists.' + #13#10 +
                            'Do you want to replace it?';

      if NOT IsExistingFile or
         (IsExistingFile and
         (MessageBox(0, PAnsiChar(ExistsDlgMsg), 'Save As', +mb_YesNo +mb_ICONWARNING +mb_DEFBUTTON2) = IDYES)) then
      begin
        DelimitedLines.SaveToFile(SaveDialog.FileName);
        SaveDialog.InitialDir := ExtractFileDir(SaveDialog.FileName);
        Result := SaveDialog.FileName;
      end;
    end;
  end;
end;




//CodeCR162 - rpm 4/21/11 - added All RO checkbox clears the RO selection
procedure TfrmRemoteReports.cbAllROClick(Sender: TObject);
begin
  if cbAllRO.Checked then
  begin
    FMRegionalOfficeNumberFake.Text := '';
    EditRONumber.Text := '';
    EditRONumber.Enabled := False;
    ButtonLookupRO.Enabled := False;
  end
  else
  begin
    EditRONumber.Enabled := True;
    ButtonLookupRO.Enabled := True;
  end;
end;

procedure TfrmRemoteReports.ButtonCloseClick(Sender: TObject);
begin
  ListMedicalCenterDivisionConsolidated.Free;
  modalresult := mrOK;
end;

procedure TfrmRemoteReports.FormCreate(Sender: TObject);
var
  x: integer;
begin
  Label5.Caption := 'for ' + Userdivision;
  ListMedicalCenterDivisionConsolidated := tstringlist.create;
  DateTimePickerStart.Date := Now;
  DateTimePickerStop.Date := Now;
  if (ESSOVersion = true) then begin
    if formESSOSelect.slUserSites.Count > 0 then  //CodeCR77
      for x := 0 to formESSOSelect.slUserSites.Count - 1 do
        ORListBoxAvailableConnections.Items.Add(formESSOSelect.slUserSites[x]);
  end;
end;

procedure TfrmRemoteReports.btnSelectAllClick(Sender: TObject);
begin
  OrListBoxSelectAll(ORListBoxAvailableConnections);
end;

procedure TfrmRemoteReports.FormActivate(Sender: TObject);
begin
  Gauge1.Visible := False;
  // AMIS 290 Enhancement
  // If the new version of the AMIS 290 is turned on, the variable AMIS290URL
  // will not be null.  If the value is null, continue using the old method
  // for the report.
  // CodeCR440  JRL 09/07/12
  if frmMain.AMIS290URL <> '' then
  begin
    RadioButtonPendingCnP.Checked := TRUE;
    DateTimePickerStart.Visible := False;
    DateTimePickerStop.Visible := False;
    Label13.Visible := False;
    Label14.Visible := False;
    Label16.Visible := True;
    EditRONumber.Visible := True;
    rgPriorityOfExamFilter.Visible := False;  //CodeCR162 - rpm 4/21/11
    cbAllRO.Checked := False;  //CodeCR162 - rpm 4/21/11
    cbAllRO.Visible := False;  //CodeCR162 - rpm 4/21/11
    memoAMIS290Message.Clear; 
    memoAMIS290Message.Lines.Add('The AMIS 290 Report is no longer available from this location.  Please go to:  ' + frmMain.AMIS290URL);
  end                                  
  else
  begin
    RadioButtonAMIS290.Checked := TRUE;
    DateTimePickerStart.Visible := True;
    DateTimePickerStop.Visible := True;
    Label13.Visible := True;
    Label14.Visible := True;
    Label16.Visible := True;
    EditRONumber.Visible := True;
    cbAllRO.Visible := True;  //CodeCR162 - rpm 4/21/11
    rgPriorityOfExamFilter.ItemIndex := 3;  //default to 'All except...' CodeCR162 - rpm 4/21/11
    rgPriorityOfExamFilter.Visible := True;  //CodeCR162 - rpm 4/21/11
  end;
end;

function TfrmRemoteReports.FMToDateConvert(DateTimeST: string): string;
begin
  Result:=caprisupport.FMToDateConvert(DateTimeST);
end;

procedure TfrmRemoteReports.FMRegionalOfficeNumberEnter(Sender: TObject);
var
  tempString: string;
begin
  if frmROFinder.ORListBoxSites.Items.Count = 0 then
    frmMain.LoadInstitutions;
  if frmROFinder.ShowModal = mrOK then begin
    tempString := frmROFinder.GetCurrentROName;  //CodeCR170 - rpm 3/10/11
    //    FMRegionalOfficeNumber.Text:=tempstring;
    FMRegionalOfficeNumberFake.Text := tempstring;
  end;
end;

procedure TfrmRemoteReports.ButtonLookupROClick(Sender: TObject);
var
  tempString: string;
begin
  if frmROFinder.ORListBoxSites.Items.Count = 0 then
    frmMain.LoadInstitutions;
  if frmROFinder.ShowModal = mrOK then begin
    tempString := frmROFinder.GetCurrentROName;  //CodeCR170 - rpm 3/10/11
    EditRONumber.Text := tempstring;
    FMRegionalOfficeNumberFake.Text := tempstring;
  end;
end;

procedure TfrmRemoteReports.BitBtnClearClick(Sender: TObject);
begin
  if MessageDlgCAPRI('Are you sure you want to clear this report output?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    ReportMemo.Clear;
end;

procedure TfrmRemoteReports.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  modalresult := mrOK;
  CanClose := true;
end;

procedure TfrmRemoteReports.BitBtnSaveAsClick(Sender: TObject);
begin
  //  if RadioButtonPendingCnP.Checked then
  //    SaveDialogCRR.FileName := 'Pending C&&P Exams Reported as of '+FormatDateTime('mm/dd/yy hh:nn:ss',Now)+'.txt';
  if SaveDialogCRR.Execute then
    ReportMemo.Lines.SaveToFile(SaveDialogCRR.FileName);

end;

procedure TfrmRemoteReports.BitBtnPrintClick(Sender: TObject);
begin
  if PrintDialogCRR.Execute then
    ReportMemo.Print('Pending C&&P Exams');
end;

procedure TfrmRemoteReports.BitBtnPrintSetupClick(Sender: TObject);
begin
  PrinterSetupDialogCRR.Execute;
end;

procedure TfrmRemoteReports.EditRONumberKeyPress(Sender: TObject;
  var Key: Char);
begin
  Key := #0;
end;

procedure TfrmRemoteReports.ActionSaveAsExecute(Sender: TObject);
begin
  if SaveDialogCRR.Execute then
    ReportMemo.Lines.SaveToFile(SaveDialogCRR.FileName);
end;

procedure TfrmRemoteReports.ActionPrintSetupExecute(Sender: TObject);
begin
  PrinterSetupDialogCRR.Execute;
end;

procedure TfrmRemoteReports.PagedPrint(lines: TStrings);
var
  i, line, y, pageCount: integer;
begin
  pageCount := 0;
  line := 1;
  with Printer do begin
    PrinterIndex := PrinterIndex;
    Printer.Canvas.Font := frmMain.MemoPrint.Font;
    BeginDoc;
    for i := 0 to lines.Count - 1 do begin
      y := line * Abs(Printer.Canvas.Font.Height);
      canvas.TextOut(10, y, lines[i]);
      inc(line);
      if Pos('!PAGEBREAK!', lines[i]) > 0 then begin
        NewPage;
        Inc(pageCount);
        line := 1;
        if pageCount >= 3 then
          break; // TEST CODE
      end;

      //      if Pos('!PAGEBREAK!', lines[i]) > 0 then
      //      begin
      //
      //        NewPage;
      //        Inc(pageCount);
      //        line := 1;
      //        if pageCount >= 3  then break; // TEST CODE
      //      end
      //      else
      //      begin
      //        y := line*Abs(Printer.Canvas.Font.Height);
      //        canvas.TextOut(10,y, lines[i]);
      //        inc(line);
      //      end;
    end;
    EndDoc;
  end;
end;

procedure TfrmRemoteReports.ActionPrintExecute(Sender: TObject);
begin

  if PrintDialogCRR.Execute then begin
    if RadioButtonCPFinalPrint.Checked then {// Reformat pages if a C&P Final Reprint report} begin
    end
    else
      ReportMemo.Print('CAPRI Remote Reports'); // Now print it
  end;
end;

procedure TfrmRemoteReports.ActionClearExecute(Sender: TObject);
begin
  if MessageDlgCAPRI('Are you sure you want to clear this report output?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    ReportMemo.Clear;
end;

procedure TfrmRemoteReports.ActionCloseExecute(Sender: TObject);
begin
  modalresult := mrOK;
  frmRemoteReports.Close;
end;

procedure TfrmRemoteReports.Quit1Click(Sender: TObject);
begin
  self.Close;
end;

function TfrmRemoteReports.FormatPages(ReportName: string; aBroker: TRPCBroker): integer;
type
  TMargins = record
    Left,
      Top,
      Right,
      Bottom: Double;
  end;
var
  x, y, w: LongInt;
  line, linesperpage, charactersperline: Integer;
  pagenum: Integer;
  PixelsPerInch: TPoint;
  PhysPageSize: TPoint;
  OffsetStart: TPoint;
  PageRes: TPoint;
  Margins: TMargins;

  procedure exitprint;
  begin
    frmMain.AnimateLogo(False);
    frmMain.StatusBarLoadPt.Caption := 'Ready.';
    frmMain.StatusBarLoadPt.Repaint;
    Application.Processmessages;
    ANURemoteProcedureCallInProgress := False;
    frmMain.MemoPrint.Lines.Clear;
  end;

  procedure GetPrinterMargins(var Margins: TMargins);
  begin
    PixelsPerInch.y := GetDeviceCaps(Printer.Handle, LOGPIXELSY);
    PixelsPerInch.x := GetDeviceCaps(Printer.Handle, LOGPIXELSX);
    Escape(Printer.Handle, GETPHYSPAGESIZE, 0, nil, @PhysPageSize);
    Escape(Printer.Handle, GETPRINTINGOFFSET, 0, nil, @OffsetStart);
    PageRes.y := GetDeviceCaps(Printer.Handle, VERTRES);
    PageRes.x := GetDeviceCaps(Printer.Handle, HORZRES);
    // Top Margin
    Margins.Top := OffsetStart.y / PixelsPerInch.y;
    // Left Margin
    Margins.Left := OffsetStart.x / PixelsPerInch.x;
    // Bottom Margin
    Margins.Bottom := ((PhysPageSize.y - PageRes.y) / PixelsPerInch.y) -
      (OffsetStart.y / PixelsPerInch.y);
    // Right Margin
    Margins.Right := ((PhysPageSize.x - PageRes.x) / PixelsPerInch.x) -
      (OffsetStart.x / PixelsPerInch.x);
  end;

begin
  Result := 0;

  frmMain.MemoPrint.Font.Size := 11;

  if ANURemoteProcedureCallInProgress = True then
    exit;

  frmMain.MemoPrint.Lines.Clear;
  GetPrinterMargins(Margins);

  //
//  {Get Date}
//  frmMain.RPCBroker1.RemoteProcedure := 'DVBAB DATETIME';
//  try
//    DtTm := '';
//    aBroker.Results.Clear;
//    aBroker.Call;
//    DtTm := aBroker.Results[0];
//  except
//    On EBrokerError do
//    begin
//      ANURemoteProcedureCallInProgress:=False;
//      frmMain.GIFImageVistaYellow.Animate:=False;
//      frmMain.StatusBarLoadPt.Caption:='RPC DVBAB DATETIME could not be accessed!';
//      frmMain.StatusBarLoadPt.Repaint;
//      Application.Processmessages;
//      ShowMessageCAPRI('DVBAB DATETIME could not be accessed!');
//    end;
//  end;
//
//  {Get Division}
//  aBroker.RemoteProcedure := 'XWB GET VARIABLE VALUE';
//  aBroker.Param[0].Value :='DUZ("2")';
//  aBroker.Param[0].PType := reference;
//  try
//    Division := '';
//    aBroker.Results.Clear;
//    aBroker.Call;
//    Division:=aBroker.Results[0];
//  except
//    On EBrokerError do
//    begin;  ANURemoteProcedureCallInProgress:=False;
//      frmMain.GIFImageVistaYellow.Animate:=False;
//      frmMain.StatusBarLoadPt.Caption:='RPC XWB GET VARIABLE VALUE could not be accessed!'; frmMain.StatusBarLoadPt.Repaint; Application.Processmessages;
//      ShowMessageCAPRI('XWB GET VARIABLE VALUE could not be accessed!');
//    end;
//  end;

//  If PrintDialogCRR.Execute=False then
//    exit;
  if PrintDialogCRR.Copies = 0 then
    exit;
  frmmain.AnimateLogo(True);
  frmMain.StatusBarLoadPt.Caption := 'Printing...';
  frmMain.StatusBarLoadPt.Repaint;
  Application.Processmessages;

  Printer.Canvas.Font := frmMain.MemoPrint.Font;
  CharactersPerLine := PageRes.X div Printer.Canvas.TextWidth('Z');
  LinesPerPage := PageRes.Y div Printer.Canvas.TextHeight('Z') - 1;
  Screen.Cursor := crHourglass;
  PageNum := 1;

  begin
    for x := 1 to PrintDialogCRR.Copies do begin
      Line := 1;
      for y := 0 to ReportMemo.Lines.Count - 1 do begin
        //If Line<5 then begin; AddHeader; Line:=6; end;
        if Line < 3 then begin
          frmMain.MemoPrint.Lines.Add(' ');
          frmMain.MemoPrint.Lines.Add(' ');
          Line := 3;
        end;
        if ReportMemo.Lines[y] = '' then
          ReportMemo.Lines[y] := ' ';
        if Pos(#12, ReportMemo.Lines[y]) = 0 then begin
          if Line - LinesPerPage - 2 < 0 then begin
            frmMain.MemoPrint.Lines.Add(Copy(ReportMemo.Lines[y], 1, CharactersPerLine));
          end;
        end;
        inc(Line);
        if Pos(#12, ReportMemo.Lines[y]) > 0 then begin

          { // PUT BACK AFTER TEST
                  If LinesPerPage-Line+2>0 then
                      for w:=0 to LinesPerPage-Line+2 do
                        MemoPrint.Lines.Add(' ');
          }
          if LinesPerPage - Line + 2 > 0 then // TEST CODE
            for w := 0 to LinesPerPage - Line + 2 do // TEST CODE
              frmMain.MemoPrint.Lines.Add(' '); // TEST CODE
          //          MemoPrint.Lines.Add('!PAGEBREAK!');     // TEST CODE

          line := 1;
          frmMain.StatusBarLoadPt.Caption := 'Buffering page ' + IntToStr(PageNum + 1);
          frmMain.StatusBarLoadPt.Repaint;
          Application.Processmessages;
          inc(PageNum);
          application.processmessages;
        end;
      end;

      // Fix up last page
      if LinesPerPage - Line + 2 > 0 then
        for w := 0 to LinesPerPage - Line + 2 do
          frmMain.MemoPrint.Lines.Add(' ');
      frmMain.StatusBarLoadPt.Caption := 'Buffering page ' + IntToStr(PageNum + 1);
      frmMain.StatusBarLoadPt.Repaint;
      Application.Processmessages;
      application.processmessages;
      frmMain.StatusBarLoadPt.Caption := 'Printing report.';
      frmMain.StatusBarLoadPt.Repaint;
      Application.Processmessages;

      // Now move back to the ReportMemo
//      ReportMemo.Clear;
//      ReportMemo.Lines.AddStrings(frmMain.MemoPrint.Lines);
      frmMain.MemoPrint.Print('CAPRI Document - ' + InttoStr(pagenum) + ' Pages');
    end;

    Screen.Cursor := crDefault;
    ExitPrint;
    ShowMessageCAPRI(IntToStr(PageNum * PrintDialogCRR.Copies) + ' page(s) have been printed.');
    Exit;
  end;
  //    else
  //    For x:=1 to frmMain.PrintDialog1.Copies do begin;
  //      Line:=1;
  //      For y:=0 to ReportMemo.Lines.Count-1 do begin;
  //(*
  //        If Line<2 then begin;  // Add space at top;
  //          QRMemo1.Lines.Add('');
  //          QRMemo1.Lines.Add('');
  //          Line:=2;
  //        end;
  //*)
  //        If Line<5 then begin; AddHeader; Line:=6; end;
  //        MemoPrint.Lines.Add(ReportMemo.Lines[y]);
  //        Inc(Line);
  //        If LinesPerPage-Line=4 then begin; // Put in footer
  //          Line:=1;
  //          MemoPrint.Lines.Add('--------------------------------------------------------------------------------');
  //          z:=Copy(footdescrip+'                                                                                ',1,69)+'Page: '+IntToStr(PageNum);
  //          MemoPrint.Lines.Add(z); // Report Name + Page
  //          z:=Copy('                                                                                ',1,65)+'Division: '+Division;
  //          MemoPrint.Lines.Add(z); // Patient Name + Division
  //          MemoPrint.Lines.Add('Printed on: '+DtTm+'  System: '+ANUStrServer);
  //          MemoPrint.Lines.Add(' ');
  //          //QuickRep1.NewPage;
  //          //MemoPrint.Lines.Clear;
  //          If PageNum/100 = trunc(PageNum/100) then begin;
  //            MemoPrint.Print('CAPRI Document - '+InttoStr(pagenum)+' Pages');
  //            MemoPrint.Lines.Clear;
  //          end;
  //          inc(PageNum);
  //          end;
  //      End;
  //      // Add footer to last page
  //      For y:=1 to LinesPerPage-Line-4 do MemoPrint.Lines.Add('');
  //      MemoPrint.Lines.Add('--------------------------------------------------------------------------------');
  //      z:=Copy(footdescrip+'                                                                                ',1,69)+'Page: '+IntToStr(PageNum);
  //      MemoPrint.Lines.Add(z); // Report Name + Page
  //      z:=Copy('                                                                                ',1,65)+'Division: '+Division;
  //      MemoPrint.Lines.Add(z); // Patient Name + Division
  //      MemoPrint.Lines.Add('Printed on: '+DtTm+'  System: '+ANUStrServer);
  //      MemoPrint.Lines.Add(' ');
  //      //QuickRep1.NewPage;
  //    end;
  //    MemoPrint.Print('CAPRI Document - '+InttoStr(pagenum)+' Pages');
  //    Screen.Cursor:=crDefault;
  //    ShowMessageCAPRI(IntToStr(PageNum)+' page(s) have been printed.');
  //    exitprint;
  //    exit;
end;

procedure TfrmRemoteReports.RadioButtonPendingCnPClick(Sender: TObject);
begin
  DateTimePickerStart.Visible := False;
  DateTimePickerStop.Visible := False;
  Label13.Visible := False;
  Label14.Visible := False;
  Label16.Visible := True;
  EditRONumber.Visible := True;
  rgPriorityOfExamFilter.Visible := False;  //CodeCR162 - rpm 4/21/11
  cbAllRO.Checked := False;  //CodeCR162 - rpm 4/21/11
  cbAllRO.Visible := False;  //CodeCR162 - rpm 4/21/11
  rgReportFormat.Visible := TRUE;   // CodeCR470 JRL 04/24/13
  if frmMain.AMIS290URL <> '' then    // CodeCR440 JRL 11/16/12
  begin
    pnlAMIS290.Visible := FALSE;         // CodeCR440 JRL 11/16/12
    ButtonLookupRO.Visible := TRUE;      // CodeCR440 JRL 11/16/12
    ButtonRunSelected.Enabled := TRUE;   // CodeCR440 JRL 11/16/12
  end
end;

procedure TfrmRemoteReports.RadioButtonAMIS290Click(Sender: TObject);
begin
  if frmMain.AMIS290URL <> '' then    // CodeCR440 JRL 11/16/12
  begin
    pnlAMIS290.Visible := TRUE;          // CodeCR440 JRL 11/16/12
    Label16.Visible := FALSE;            // CodeCR440 JRL 11/16/12
    EditRONumber.Visible := FALSE;       // CodeCR440 JRL 11/16/12
    ButtonLookupRO.Visible := FALSE;     // CodeCR440 JRL 11/16/12
    ButtonRunSelected.Enabled := FALSE;  // CodeCR440 JRL 11/16/12
    rgReportFormat.Visible := FALSE;     // CodeCR470 JRL 04/24/13
  end
  else
  begin
    DateTimePickerStart.Visible := True;
    DateTimePickerStop.Visible := True;
    Label13.Visible := True;
    Label14.Visible := True;
    Label16.Visible := True;
    EditRONumber.Visible := True;
    cbAllRO.Visible := True;  //CodeCR162 - rpm 4/21/11
    rgPriorityOfExamFilter.ItemIndex := 3;  //default to 'All except...' CodeCR162 - rpm 4/21/11
    rgPriorityOfExamFilter.Visible := True;  //CodeCR162 - rpm 4/21/11
    rgReportFormat.Visible := FALSE;     // CodeCR470 JRL 04/24/13
  end
end;

procedure TfrmRemoteReports.RadioButtonCPFinalPrintClick(Sender: TObject);
begin
  DateTimePickerStart.Visible := False;
  DateTimePickerStop.Visible := False;
  Label13.Visible := False;
  Label14.Visible := False;
  Label16.Visible := False;
  EditRONumber.Visible := False;
  rgPriorityOfExamFilter.Visible := False;  //CodeCR162 - rpm 4/21/11
  cbAllRO.Checked := False;  //CodeCR162 - rpm 4/21/11
  cbAllRO.Visible := False;  //CodeCR162 - rpm 4/21/11
  rgReportFormat.Visible := FALSE;     // CodeCR470 JRL 04/24/13
  if frmMain.AMIS290URL <> '' then    // CodeCR440 JRL 11/16/12
  begin
    pnlAMIS290.Visible := FALSE;        // CodeCR440 JRL 11/16/12
    ButtonLookupRO.Visible := TRUE;     // CodeCR440 JRL 11/16/12
    ButtonRunSelected.Enabled := TRUE;  // CodeCR440 JRL 11/16/12
  end;
end;

{===========================================================================
 DisplayBusyAnimation
 This procedure displays or hides the "file transfer" animation busy panel.
 Input:
   Display: Boolean - flags whether to display or hide the busy panel
   aCaption: String - text to display in the busy panel

 //CodeCR162 - rpm 4/21/11 - added aCaption parameter to increase flexibility
 ===========================================================================}
Procedure TfrmRemoteReports.DisplayBusyAnimation(Display: Boolean; aCaption: String);
begin
  if Display then
  begin
    Label4.Caption := aCaption;  //CodeCR162 - rpm 4/21/11
    aniBusy.Active := True;
    PanelBuildingReport.Visible := True;
    frmRemoteReports.Repaint;
  end
  else
  begin
    Label4.Caption := aCaption;  //CodeCR162 - rpm 4/21/11
    aniBusy.Active := False;
    PanelBuildingReport.Visible := False;
    frmRemoteReports.Repaint;
  end;
end;
end.







