unit remotesitepick;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  DialogsCAPRI,
  Dialogs,
  StdCtrls,
  ORCtrls,
  main,
  Fmcntrls,
  Diaccess,
  Fmcmpnts,
  Trpcb,
  PatientList,
  ExtCtrls,
  CCOWRPCBrokerCAPRI;

type
  TfrmRemoteSitePick = class(TForm)
    Button1: TButton;
    ButtonSwitchSites: TButton;
    Label1: TLabel;
    ORListBoxSites: TORListBox;
    FMFinderInstitutionFile: TFMFinder;
    FMListBoxInstitutions: TFMListBox;
    CCOWTimer: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure ButtonSwitchSitesClick(Sender: TObject);
    procedure ORListBoxSitesClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure CCOWTimerTimer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmRemoteSitePick: TfrmRemoteSitePick;

implementation

uses essoselect;

{$R *.DFM}

procedure TfrmRemoteSitePick.Button1Click(Sender: TObject);
begin
  modalresult := mrCancel;
end;

procedure TfrmRemoteSitePick.ButtonSwitchSitesClick(Sender: TObject);
var
  x, z: integer;
begin
  if essoversion = false then
    exit;
  if ORListBoxSites.ItemIndex = -1 then
    exit;
  // strip off division to get main site number;
  sitenum := frmMain.Piece(ORListBoxSites.Items[ORListBoxSites.ItemIndex], '^', 2);
  switchtosite := frmMain.Piece(ORListBoxSites.Items[ORListBoxSites.ItemIndex], '^', 1);
  switchtosite := trim(copy(switchtosite, pos('  ', switchtosite) + 5, 250));
  if pos('  ', switchtosite) > 0 then
    switchtosite := trim(copy(switchtosite, 1, pos('  ', switchtosite) - 1));
  //ShowmessageCAPRI('*'+switchtosite+'*');
  modalresult := mrok;
  exit;

  // First search institution file for a match.  Get the IEN
  // Next, search through the CAPRI SITE file to see if that IEN
  // has been set up.  If so, use use the DNS/IP in the config.
  // If it can't be found, check to see if it's a division of another
  // site.  If so, look for the main site and start over
  // If it still can't be found, then tell the user.

  // strip off division to get main site number;
  sitenum := frmMain.Piece(ORListBoxSites.Items[ORListBoxSites.ItemIndex], '^', 2);
  z := 0;
  if length(sitenum) > 0 then
    for x := length(sitenum) downto 1 do
      if (sitenum[x] <> '0') and (sitenum[x] <> '1') and (sitenum[x] <> '2') and
        (sitenum[x] <> '3') and (sitenum[x] <> '4') and (sitenum[x] <> '5') and
        (sitenum[x] <> '6') and (sitenum[x] <> '7') and (sitenum[x] <> '8') and
        (sitenum[x] <> '9') then
        z := x;
  if z > 0 then
    sitenum := copy(sitenum, 1, z - 1);

  // Look up the main division # in the institution file
  fmFinderInstitutionfile.Value := sitenum;
  fmFinderInstitutionFile.GetFinderList(FMListBoxInstitutions.Items);

  if FMListBoxInstitutions.Items.Count > 0 then
    for x := FMListBoxInstitutions.Items.Count - 1 downto 0 do
      if Pos('  INACTIVE', FMListBoxInstitutions.Items[x]) > 0 then
        FMListBoxInstitutions.Items.Delete(x);

  // Check to be sure there wasn't a problem.
  if FMListBoxInstitutions.Items.Count = 0 then begin
    ShowMessageCAPRI('That site can''t be found for an unknown reason.');
    exit;
  end;

  FMListBoxInstitutions.ItemIndex := 0;
  //sitenum:=FMListBoxInstitutions.GetSelectedRecord.IEN;
  // sitenum now contains IEN of the main site in file 4, not
  // the text name or site number.

  //ShowmessageCAPRI('*'+Copy(FMListBoxInstitutions.Items[0],1,Pos('  ',FMListBoxInstitutions.Items[0])-1)+'*');
  switchtosite := Copy(FMListBoxInstitutions.Items[0], 1, Pos('  ', FMListBoxInstitutions.Items[0]) - 1);
  (*
  for x:=0 to formEssoSelect.FMListBoxSiteInfo.Items.Count-1 do begin;
    //ShowmessageCAPRI(formEssoSelect.FMListBoxSiteInfo.Items[x]);
    If (Pos(Copy(FMListBoxInstitutions.Items[0],1,Pos('  ',FMListBoxInstitutions.Items[0])-1),formEssoSelect.FMListBoxSiteInfo.Items[x])>0) then begin;
      switchtosite:=Copy(FMListBoxInstitutions.Items[0],1,Pos('  ',FMListBoxInstitutions.Items[0])-1);
    end;
  end;
  *)
  modalResult := mrOK;
end;

procedure TfrmRemoteSitePick.ORListBoxSitesClick(Sender: TObject);
begin
  if essoversion = true then
    if ORListBoxSites.ItemIndex > -1 then
      buttonSwitchSites.enabled := True;
end;

procedure TfrmRemoteSitePick.FormActivate(Sender: TObject);
begin
  frmRemoteSitePick.Visible := False;
  frmRemoteSitePick.Top := frmMain.Top + ((frmMain.Height - frmRemoteSitePick.Height) div 2);
  frmRemoteSitePick.Left := frmMain.Left + ((frmMain.Width - frmRemoteSitePick.Width) div 2);
  frmRemoteSitePick.Visible := True;

  CCOWTimer.Enabled := True;
end;

procedure TfrmRemoteSitePick.CCOWTimerTimer(Sender: TObject);
begin
  if ShutdownCAPRIModalDialogs = true then begin
    CCOWTimer.Enabled := False;
    frmRemoteSitePick.visible := false;
    button1Click(Application);
  end;
end;

end.
