unit rpcbrokercallsbuffer;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  ComCtrls;

type
  TfrmBrokerHistoryBuffer = class(TForm)
    RichEditBrokerCalls: TRichEdit;
    UpDown1: TUpDown;
    Edit1: TEdit;
    RichEditBrokerDisplay: TRichEdit;
    Button1: TButton;
    Button2: TButton;
    SaveDialog1: TSaveDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure SaveNewCall;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmBrokerHistoryBuffer: TfrmBrokerHistoryBuffer;
  rpcbrokerbuffers: TStringList;
  rpcbrokerbufferscount: Integer;
implementation

{$R *.DFM}

procedure TfrmBrokerHistoryBuffer.FormCreate(Sender: TObject);
begin
  rpcbrokerbuffers := tStringList.Create;
  rpcbrokerbufferscount := 0;

end;

procedure TfrmBrokerHistoryBuffer.FormDestroy(Sender: TObject);
begin
  rpcbrokerbuffers.free;

end;

procedure TfrmBrokerHistoryBuffer.FormShow(Sender: TObject);
begin
  Edit1.Text := inttostr(rpcbrokerbufferscount);
  UpDown1Click(Application, btNext);
end;

procedure TfrmBrokerHistoryBuffer.UpDown1Click(Sender: TObject;
  Button: TUDBtnType);
var
  x: integer;
begin
  //
  x := StrToInt(edit1.text);
  if button = btNext then begin
    inc(x);
    if x > rpcbrokerbufferscount then
      x := rpcbrokerbufferscount;
  end;
  if button = btPrev then begin
    dec(x);
    if rpcbrokerbufferscount < 1 then
      x := 1;
  end;
  UpDown1.Position := x;
  Edit1.Text := inttostr(x);
  RichEditBrokerDisplay.Text := rpcbrokerbuffers[strtoint(edit1.text) - 1];
end;

procedure TfrmBrokerHistoryBuffer.SaveNewCall;
begin
  if rpcbrokerbufferscount = 250 then
    rpcbrokerbuffers.Delete(0);
  rpcbrokerbuffers.Add(richeditbrokercalls.text);
  if rpcbrokerbufferscount < 250 then
    inc(rpcbrokerbufferscount);
  UpDown1.Max := RPCBrokerBuffersCount;
  UpDown1.Position := UpDown1.Max;
  richeditbrokercalls.text := '';
  RichEditBrokerDisplay.text := '';
end;

procedure TfrmBrokerHistoryBuffer.Button2Click(Sender: TObject);
var
  FileSave: Boolean;
begin
  if SaveDialog1.Execute then begin
    FileSave := True;
    if FileExists(SaveDialog1.Filename) then begin
      FileSave := False;
      if MessageDlg('Overwrite existing file?',
        mtConfirmation, [mbYes, mbNo], 0) = mrYes then
        FileSave := True;
    end;
    if FileSave = True then begin
      try
        RichEditBrokerDisplay.Lines.SaveToFile(SaveDialog1.Filename);
      except
        on EInOutError do
          MessageDlg('File I/O error.', mtError, [mbOk], 0);
      end;
    end;
  end;
end;

procedure TfrmBrokerHistoryBuffer.Button1Click(Sender: TObject);
var
  FileSave: Boolean;
  x: integer;
begin
  RichEditBrokerCalls.Lines.Clear;
  if SaveDialog1.Execute then begin
    FileSave := True;
    if FileExists(SaveDialog1.Filename) then begin
      FileSave := False;
      if MessageDlg('Overwrite existing file?',
        mtConfirmation, [mbYes, mbNo], 0) = mrYes then
        FileSave := True;
    end;
    if FileSave = True then begin
      cursor := crHourglass;
      if rpcbrokerbuffers.Count > 0 then
        for x := 0 to rpcbrokerbufferscount - 1 do begin
          RichEditBrokerCalls.Lines.Add(RPCBrokerBuffers[x]);
          RichEditBrokerCalls.Lines.Add('');
          RichEditBrokerCalls.Lines.Add('======================================================================');
          RichEditBrokerCalls.Lines.Add('');
        end;
      cursor := crDefault;

      try
        RichEditBrokerCalls.Lines.SaveToFile(SaveDialog1.Filename);
      except
        on EInOutError do
          MessageDlg('File I/O error.', mtError, [mbOk], 0);
      end;
    end;
  end;
end;

end.
