unit tiucosignature;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  ORCtrls,
  TRPCB,
  DialogsCAPRI,
  CAPRISupport,
  ExtCtrls,
  Hash;

type
  TfrmTIUCosign = class(TForm)
    GroupBox1: TGroupBox;
    ORListBox1: TORListBox;
    GroupBox2: TGroupBox;
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Button3: TButton;
    Panel1: TPanel;
    AddendumText: TMemo;
    Label2: TLabel;
    Button4: TButton;
    Button5: TButton;
    procedure Button2Click(Sender: TObject);
    procedure ORListBox1Click(Sender: TObject);
    procedure GetCosignatureAlerts;
    procedure Button1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure SaveAddendum;
  private
    fTiuDocumentIEN: String;
  public
    property TiuDocumentIEN: String read fTiuDocumentIEN;
  end;

var
  frmTIUCosign: TfrmTIUCosign;

implementation

uses main,
  alerts,
  tiusign,
  CCOWRPCBrokerCAPRI;

{$R *.DFM}

procedure TfrmTIUCosign.Button2Click(Sender: TObject);
begin
  GetCosignatureAlerts;
  modalresult := mrCancel;
end;

procedure TfrmTIUCosign.ORListBox1Click(Sender: TObject);
begin
  addendumtext.lines.clear;
  button1.enabled := true;
  button3.enabled := true;
  frmMain.RPCBroker1.RemoteProcedure := 'TIU GET RECORD TEXT';
  fTiuDocumentIEN := frmMain.Piece(frmMain.Piece(frmMain.Piece(ORListBox1.Items[ORListBox1.ItemIndex], '^', 8), ';', 1), 'U', 2);
  frmMain.RPCBroker1.Param[1].Value := fTiuDocumentIEN;
  frmMain.RPCBroker1.Param[1].PType := literal;
  try
    frmMain.RPCBroker1.Call;
  except
    on EBrokerError do begin
      ANURemoteProcedureCallInProgress := False;
      frmMain.AnimateLogo(False);
      frmMain.StatusBarLoadPt.Caption := 'RPC TIU GET RECORD TEXT could not be accessed!';
      frmMain.StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('RPC TIU GET RECORD TEXT could not be accessed!');
    end
  end;
  Memo1.Lines := frmMain.RPCBroker1.Results;
end;

procedure TfrmTIUCosign.GetCosignatureAlerts;
var
  x, xx: integer;
  foundcptitle: boolean;
begin
  button1.enabled := false;
  button3.enabled := false;

  Memo1.Lines.Clear;
  ORListBox1.Items.Clear;
  xx := 0;
  frmMain.RPCBroker1.RemoteProcedure := 'ORWORB FASTUSER';

  frmMain.RPCBrokerCall;
  try
    frmMain.RPCBroker1.Call;
  except
    on EBrokerError do begin
      ANURemoteProcedureCallInProgress := False;
      frmMain.AnimateLogo(False);
      frmMain.StatusBarLoadPt.Caption := 'RPC ORWORB FASTUSER could not be accessed!';
      frmMain.StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('ORWORB FASTUSER could not be accessed!');
    end;
  end;
  //if assigned(frmAlerts) then

  // Remove anything not C&P related
  // This is just a simple text filter
  if frmMain.RPCBroker1.Results.Count > 0 then
    for x := frmMain.RPCBroker1.Results.Count - 1 downto 0 do begin
      foundcptitle := false;
      if Pos('C&P', frmMain.RPCBroker1.Results[x]) > 0 then
        FoundCPTitle := True;
      if Pos('PENSION', frmMain.RPCBroker1.Results[x]) > 0 then
        FoundCPTitle := True;
      if Pos('COMPENSATION', frmMain.RPCBroker1.Results[x]) > 0 then
        FoundCPTitle := True;
      if Pos('COMP AND PEN', frmMain.RPCBroker1.Results[x]) > 0 then
        FoundCPTitle := True;
      if Pos('COMP &', frmMain.RPCBroker1.Results[x]) > 0 then
        FoundCPTitle := True;
      if FoundCPTitle <> true then
        frmMain.RPCBroker1.Results.Delete(x);
    end;
  //

  if frmMain.RPCBroker1.Results.Count > 0 then begin
    for x := 0 to frmMain.RPCBroker1.Results.Count - 1 do
      if Copy(frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 6), 1, 10) = 'UNCOSIGNED' then
        inc(xx);
    if assigned(frmAlerts) then begin
      if xx = 0 then begin
        frmAlerts.EditUncosigned.enabled := false;
        frmAlerts.EditUncosigned.Text := 'You have no CPRS documents to co-sign.';
        frmAlerts.buttonUncosigned.enabled := False;
      end
      else begin
        if xx = 1 then begin
          frmAlerts.EditUncosigned.enabled := true;
          frmAlerts.EditUncosigned.Text := 'You have 1 CPRS document to co-sign.';
          frmAlerts.buttonUncosigned.enabled := true;
        end
        else begin
          frmAlerts.EditUncosigned.enabled := true;
          frmAlerts.EditUncosigned.Text := 'You have ' + inttostr(xx) + ' CPRS documents to co-sign.';
          frmAlerts.buttonUncosigned.enabled := true;
        end;
      end;
      for x := 0 to frmMain.RPCBroker1.Results.Count - 1 do
        if Copy(frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 6), 1, 10) = 'UNCOSIGNED' then
          ORListBox1.Items.Add(frmMain.RPCBroker1.Results[x]);
    end;
  end
  else begin
    if assigned(frmAlerts) then begin
      frmAlerts.EditUncosigned.enabled := false;
      frmAlerts.EditUncosigned.Text := 'You have no CPRS documents to co-sign.';
      frmAlerts.buttonUncosigned.enabled := False;
    end;
  end;
  if not assigned(frmAlerts) then begin
    for x := 0 to frmMain.RPCBroker1.Results.Count - 1 do
      if Copy(frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 6), 1, 10) = 'UNCOSIGNED' then
        ORListBox1.Items.Add(frmMain.RPCBroker1.Results[x]);
  end;
  if ORListBox1.Items.Count > 0 then begin
    ORListBox1.ItemIndex := 0;
    ORListBox1Click(Application);
  end;

  if ORListBox1.Items.Count = 0 then
    modalResult := mrOK;
end;

procedure TfrmTIUCosign.Button1Click(Sender: TObject);
var
  x, xx: integer;
  date1, date2, date3: string;
  tempPatientIEN: string;
begin
  button1.enabled := false;
  button3.enabled := false;
  TIUSignForm := TTIUSignForm.Create(frmTIUCosign);

  try
    TIUSignForm.CheckBoxOpinion.Visible := False;

    //TIUSignForm.ButtonTemplatesUtilized.Visible:=false;
    TIUSignForm.Button3.Visible := false;
    TIUSignForm.FMReportText.Lines.Clear;
    TIUSignForm.GroupBox2.Visible := False;
    if Memo1.Lines.Count > 0 then
      for xx := 0 to Memo1.Lines.Count - 1 do
        TIUSignForm.FMReportText.Lines.Add(Memo1.Lines[xx]);

    {------END OF REPORT--------------------}

    frmMain.RPCBroker1.RemoteProcedure := 'TIU GET ALERT INFO';
    frmMain.RPCBroker1.Param[1].Value := frmMain.Piece(ORListBox1.Items[ORListBox1.ItemIndex], '^', 8);
    frmMain.RPCBroker1.Param[1].PType := literal;
    try
      frmMain.RPCBroker1.Call;
    except
      on EBrokerError do begin
        ANURemoteProcedureCallInProgress := False;
        frmMain.AnimateLogo(False);
        frmMain.StatusBarLoadPt.Caption := 'RPC TIU GET ALERT INFO could not be accessed!';
        frmMain.StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('RPC TIU GET ALERT INFO could not be accessed!');
      end
    end;
    tempPatientIEN := frmMain.Piece(frmMain.RPCBroker1.Results[0], '^', 2);
    if tempPatientIEN = '' then begin
      ShowmessageCAPRI('Couldn''t identify patient.');
      application.terminate;
      application.terminate;
    end;

    // * is appended to tell the TIUSign unit that this one is already
    // signed and is being co-signed.  Transfer to AMIE and send signature, but don't update
    // report text or other fields already there.
    // Titles and such are unneeded since the document is already in TIU.

    CoSigTIUNoteIEN := frmMain.Piece(frmMain.Piece(frmMain.Piece(ORListBox1.Items[ORListBox1.ItemIndex], '^', 8), ';', 1), 'U', 2);

    TIUSignForm.ptIENHidden.Caption := tempPatientIEN;

    { Get AMIE Exam Requests}
    TIUSignForm.FMExamRequestLister1.PartList.Clear;
    TIUSignForm.FMExamRequestLister1.PartList.Add(tempPatientIEN);
    TIUSignForm.FMExamRequestListbox.GetList;
    // Make sure data is correct for PatientIEN
    if TIUSignForm.FMExamRequestListbox.Items.Count > 0 then
      for x := TIUSignForm.FMExamRequestListbox.Items.Count - 1 downto 0 do begin
        if Pos(tempPatientIEN + '  ', TIUSignForm.FMExamRequestListbox.Items[x]) <> 1 then
          TIUSignForm.FMExamRequestListbox.Items.Delete(x);
      end;
    // Reformat data
    // Don't show complete or cancelled exams
    if TIUSignForm.FMExamRequestListbox.Items.Count > 0 then
      for x := TIUSignForm.FMExamRequestListbox.Items.Count - 1 downto 0 do begin
        TIUSignForm.FMExamRequestListbox.Items[x] := Copy(TIUSignForm.FMExamRequestListbox.Items[x], Pos('  ', TIUSignForm.FMExamRequestListbox.Items[x]) + 4, 255); // Strip patient IEN;
        Date1 := Copy(TIUSignForm.FMExamRequestListbox.Items[x], 1, Pos('  ', TIUSignForm.FMExamRequestListbox.Items[x]) - 1);
        TIUSignForm.FMExamRequestListbox.Items[x] := Copy(TIUSignForm.FMExamRequestListbox.Items[x], Pos('  ', TIUSignForm.FMExamRequestListbox.Items[x]) + 4, 500);
        Date2 := Copy(TIUSignForm.FMExamRequestListbox.Items[x], 1, Pos('  ', TIUSignForm.FMExamRequestListbox.Items[x]) - 1);
        TIUSignForm.FMExamRequestListbox.Items[x] := Copy(TIUSignForm.FMExamRequestListbox.Items[x], Pos('  ', TIUSignForm.FMExamRequestListbox.Items[x]) + 4, 500);
        Date3 := Copy(TIUSignForm.FMExamRequestListbox.Items[x], 1, 254);
        if Date2 <> '' then
          TIUSignForm.FMExamRequestListbox.Items[x] := Copy(FMDateTimeConvert(Date1) + '                    ', 1, 20) + '  |  ' + FMDateTimeConvert(Date2)
        else
          if Date3 <> '' then
            TIUSignForm.FMExamRequestListbox.Items[x] := Copy(FMDateTimeConvert(Date1) + '                    ', 1, 20) + '  |  ' + FMDateTimeConvert(Date3) + ' [EXAM CANCELED]'
          else
            TIUSignForm.FMExamRequestListbox.Items[x] := Copy(FMDateTimeConvert(Date1) + '                    ', 1, 20) + '    ';
        //Fix single digit date and move over
        if Copy(TIUSignForm.FMExamRequestListbox.Items[x], 6, 1) = ',' then
          TIUSignForm.FMExamRequestListbox.Items[x] := Copy(TIUSignForm.FMExamRequestListbox.Items[x], 1, 4) + ' ' + Copy(TIUSignForm.FMExamRequestListbox.Items[x], 5, 15) + Copy(TIUSignForm.FMExamRequestListbox.Items[x], 21, 99);
        if (Date2 <> '') or (Date3 <> '') then
          TIUSignForm.FMExamRequestListbox.Items.Delete(x);
      end;

    TIUSignForm.ListBox1.Enabled := False;
    TIUSignForm.ListBox4.Enabled := False;
    TIUSignForm.sttxtCnPExamQuestion.Visible := FALSE;   // CodeCR459 JRL 7/22/13
    TIUSignForm.cmbxCPRqst.Visible := FALSE;             // CodeCR459 JRL 7/22/13
    TIUSignForm.GroupBox2.Visible := FALSE;              // CodeCR459 JRL 7/22/13    
    TIUSignForm.Panel1.Top := 11;
    TIUSignForm.GroupBox1.Top := 126;
    TIUSignForm.Button3.Top := 300;
    TIUSignForm.buttonOK2.Top := 300;
    TIUSignForm.ButtonTemplatesUtilized.Top := 300;
    TIUSignForm.height := 365;
    TIUSignForm.label3.enabled := false;
    TIUSignForm.PNTitles.enabled := false;
    TIUSignForm.PNTitles.text := 'N/A during co-signature';
    TIUSignForm.Panel1.Visible := True;
    TIUSignForm.GroupBox1.Visible := True;
    TIUSignForm.FMExProvider.Text := Copy(AuthorName, 1, 30);
    TIUSignForm.ButtonTemplatesUtilized.Top := TIUSignForm.GroupBox1.Top + TIUSignForm.GroupBox1.Height + 8;
    TIUSignForm.ButtonOK2.Top := TIUSignForm.ButtonTemplatesUtilized.Top;

    if TIUSignForm.ShowModal = mrOK then begin
      Panel1.Visible := False;
    (* CodeCR112 rpm 6/28/10 - Remoaeb call to SaveAddendum because it
                               duplicates call to SaveAddendum in tiusign.pas
    *)
    end;
    (* CodeCR108 rpm 11/22/10 - removed "else" block that exited without
                                clearing CoSigTIUNoteIEN when a user Canceled.
                                Added try...finally block to prevent memory
                                leaks.
     *)
  finally
    CoSigTIUNoteIEN := '';
    TIUSignForm.Release;
    TIUSignForm := nil;
    getCosignatureAlerts;
    button1.enabled := true;
    button3.enabled := true;
  end;
end;

procedure TfrmTIUCosign.SaveAddendum;
var
  x: integer;
  dttm, addendien: string;
begin
  // File addendum
  frmMain.RPCBroker1.RemoteProcedure := 'ORWU DT';
  frmMain.RPCBroker1.Param[1].Value := 'NOW';
  frmMain.RPCBroker1.Param[1].PType := literal;
  try
    frmMain.RPCBroker1.Call;
  except
    on EBrokerError do begin
      ANURemoteProcedureCallInProgress := False;
      frmMain.AnimateLogo(False);
      frmMain.StatusBarLoadPt.Caption := 'RPC ORWU DT could not be accessed!';
      frmMain.StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('RPC ORWU DT could not be accessed!');
    end
  end;
  dttm := frmMain.RPCBroker1.Results[0];

  ///////////////

  frmMain.RPCBroker1.RemoteProcedure := 'TIU CREATE ADDENDUM RECORD';
  frmMain.RPCBroker1.Param[1].Value := CoSigTIUNoteIEN;
  frmMain.RPCBroker1.Param[1].PType := literal;
  frmMain.RPCBroker1.Param[2].Mult['1202'] := authorIEN;
  frmMain.RPCBroker1.Param[2].Mult['1301'] := dttm;
  frmMain.RPCBroker1.Param[2].PType := list;
  frmMain.RPCBroker1.Param[3].Value := '1';
  frmMain.RPCBroker1.Param[3].PType := literal;
  frmMain.RPCBroker1.Call;
  (*
  try frmMain.RPCBroker1.Call;
    except
  On EBrokerError do begin;  ANURemoteProcedureCallInProgress:=False;
    frmMain.AnimateLogo(False);
    frmMain.StatusBarLoadPt.Caption:='RPC TIU CREATE ADDENDUM RECORD could not be accessed!';
    frmMain.StatusBarLoadPt.Repaint; Application.Processmessages;
    Showmessage(EBrokerError.);
    ShowMessageCAPRI('RPC TIU CREATE ADDENDUM RECORD could not be accessed!');
  end end;
  *)
  addendien := frmMain.RPCBroker1.Results[0];
  if addendien = '' then begin
    ShowmessageCAPRI('Couldn''t create addendum');
    exit;
  end;

  ///////////////

  frmMain.RPCBroker1.RemoteProcedure := 'TIU UPDATE RECORD';
  frmMain.RPCBroker1.Param[1].Value := addendIEN;
  frmMain.RPCBroker1.Param[1].PType := literal;
  frmMain.RPCBroker1.Param[2].Mult['1202'] := authorIEN;
  frmMain.RPCBroker1.Param[2].Mult['1301'] := dttm;
  frmMain.RPCBroker1.Param[2].Mult['1701'] := '';
  frmMain.RPCBroker1.Param[2].PType := list;
  frmMain.RPCBroker1.Param[3].Value := '1';
  frmMain.RPCBroker1.Param[3].PType := literal;
  try
    frmMain.RPCBroker1.Call;
  except
    on EBrokerError do begin
      ANURemoteProcedureCallInProgress := False;
      frmMain.AnimateLogo(False);
      frmMain.StatusBarLoadPt.Caption := 'RPC TIU UPDATE RECORD could not be accessed!';
      frmMain.StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('RPC TIU UPDATE RECORD could not be accessed!');
    end
  end;
  if frmMain.Piece(frmMain.RPCBroker1.Results[0], '^', 2) <> '' then begin
    ShowmessageCAPRI(frmMain.Piece(frmMain.RPCBroker1.Results[0], '^', 2));
    exit;
  end;

  ///////////////

  frmMain.RPCBroker1.RemoteProcedure := 'TIU SET DOCUMENT TEXT';
  frmMain.RPCBroker1.Param[1].Value := addendIEN;
  frmMain.RPCBroker1.Param[1].PType := literal;
  for x := 0 to addendumtext.lines.count - 1 do
    frmMain.RPCBroker1.Param[2].Mult['"TEXT",' + inttostr(x + 1) + ',0'] := addendumtext.lines[x];
  frmMain.RPCBroker1.Param[2].Mult['"HDR"'] := '1^1';
  frmMain.RPCBroker1.Param[2].PType := list;
  frmMain.RPCBroker1.Param[3].Value := '0';
  frmMain.RPCBroker1.Param[3].PType := literal;
  try
    frmMain.RPCBroker1.Call;
  except
    on EBrokerError do begin
      ANURemoteProcedureCallInProgress := False;
      frmMain.AnimateLogo(False);
      frmMain.StatusBarLoadPt.Caption := 'RPC TIU SET DOCUMENT TEXT could not be accessed!';
      frmMain.StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('RPC TIU SET DOCUMENT TEXT could not be accessed!');
    end;
  end;
  if frmMain.Piece(frmMain.RPCBroker1.Results[0], '^', 4) <> '' then begin
    // There was a problem creating the addendum
    ShowmessageCAPRI(frmMain.Piece(frmMain.RPCBroker1.Results[0], '^', 4));
  end
  else begin
    frmMain.RPCBroker1.RemoteProcedure := 'TIU SIGN RECORD';
    frmMain.RPCBroker1.Param[0].Value := addendIEN;
    frmMain.RPCBroker1.Param[0].PType := literal;
    frmMain.RPCBroker1.Param[1].Value := Encrypt(TIUSignForm.Edit3.Text);
    frmMain.RPCBroker1.Param[1].PType := literal;
    frmmain.RPCBrokerCall;
    try
      frmMain.RPCBroker1.Call;
    except
      on EBrokerError do
        ShowMessageCAPRI('Connection to server could not be established!');
    end;
    if Piece(frmMain.RPCBroker1.Results[0], '^', 1) <> '0' then begin
      ShowmessageCAPRI(Piece(frmMain.RPCBroker1.Results[0], '^', 2));
    end;
  end;
end;

procedure TfrmTIUCosign.Button5Click(Sender: TObject);
begin
  Panel1.Visible := False;
  AddendumText.Lines.Clear;
end;

procedure TfrmTIUCosign.Button3Click(Sender: TObject);
begin
  AddendumText.Lines.Clear;
  Panel1.Visible := True;
  Panel1.BringToFront;
  AddendumText.SetFocus;
end;

procedure TfrmTIUCosign.Button4Click(Sender: TObject);
begin
  Button1Click(Application);
end;

end.
