unit tiudisplayunit;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  ComCtrls,
  ExtCtrls,
  Menus,
  DialogsCAPRI,
  Trpcb,
  CCOWRPCBroker,
  CCOWRPCBrokerCAPRI,
  Buttons,
  ToolWin,
  ORFn,
  Fmcntrls,
  Diaccess,
  Fmcmpnts, ActnMan, ActnCtrls, ActnMenus, ActnPopup, XPStyleActnCtrls, ActnList;

type
  TFormTIUDisplay = class(TForm)
    memoDocs: TRichEdit;
    editTemplateIEN: TEdit;
    ToolBar1: TToolBar;
    SpeedButtonCAPRI: TSpeedButton;
    SpeedButtonCPRS: TSpeedButton;
    EditTIUDocumentNumber: TEdit;
    Panel1: TPanel;
    Label1: TLabel;
    FMListerAMIEExams: TFMLister;
    FMMemoAMIEExamResults: TFMMemo;
    FMGetsAMIEExam: TFMGets;
    FMListBoxAMIEExams: TFMListBox;
    ActionManTIUDisplay: TActionManager;
    mnuPopUpTIUDisplay: TPopupActionBar;
    actMenuBarTIUDisplay: TActionMainMenuBar;
    actFilePrint: TAction;
    actFilePageSetup: TAction;
    actFileOpenGUI: TAction;
    actEditCopy: TAction;
    actEditSelectAll: TAction;
    mnuPopUpCopy: TMenuItem;
    mnuPopUpSelectAll: TMenuItem;
    actFileTransmitVirtualVA: TAction;
    procedure File1Click(Sender: TObject);
    procedure SpeedButtonCPRSClick(Sender: TObject);
    procedure SpeedButtonCAPRIClick(Sender: TObject);
    procedure FMListBoxAMIEExamsClick(Sender: TObject);
    procedure actFilePrintExecute(Sender: TObject);
    procedure actFilePageSetupExecute(Sender: TObject);
    procedure actFileOpenGUIExecute(Sender: TObject);
    procedure actEditCopyExecute(Sender: TObject);
    procedure actEditSelectAllExecute(Sender: TObject);
    procedure actEditCopyUpdate(Sender: TObject);
    procedure actFileTransmitVirtualVAExecute(Sender: TObject);
    procedure actFileTransmitVirtualVAUpdate(Sender: TObject);
  private
    { Private declarations }
    procedure WMMenuChar(var Message: TWMMenuChar); message WM_MENUCHAR;
  public
    { Public declarations }
    procedure Print(Sender: TObject);
  end;

var
  FormTIUDisplay: TFormTIUDisplay;

implementation

uses
  main,
  printsupport,
  CapriSupport;

{$R *.DFM}

procedure TFormTIUDisplay.actEditCopyExecute(Sender: TObject);
begin
  FEditCtrl := TRichEdit(Screen.ActiveControl);
  FEditCtrl.CopyToClipboard;
end;

procedure TFormTIUDisplay.actEditCopyUpdate(Sender: TObject);
begin
  FEditCtrl := nil;
  (*
  if FEditCtrl <> nil then
  begin
    mnuEditCopy.Enabled := True;
    mnuEditSelectAll.Enabled := True;
  end else
  begin
  end;
*)
  actEditCopy.Enabled := False;
  actEditSelectAll.Enabled := False;

  if screen.activecontrol.name = 'memoDocs' then begin
    FEditCtrl := TRichEdit(Screen.ActiveControl);
    actEditCopy.Enabled := True;
    actEditSelectAll.Enabled := True;
  end;

end;

procedure TFormTIUDisplay.actEditSelectAllExecute(Sender: TObject);
begin
  FEditCtrl := TRichEdit(Screen.ActiveControl);
  FEditCtrl.SelectAll;
  //FEditCtrl.PasteFromClipboard;  // use AsText to prevent formatting from being pasted
end;

procedure TFormTIUDisplay.actFileOpenGUIExecute(Sender: TObject);
var
  x: integer;
  tempX: integer;
  found: boolean;
begin
  frmMain.Page95Control1.ActivePage := frmMain.TabCPWorksheets;
  found := false;
  tempX := -1;

  // First find a matching IEN in the FMListboxIPR1 component.
  if frmMain.FMListboxIPR1.Items.Count > 0 then
    for x := 0 to frmMain.FMListboxIPR1.Items.Count - 1 do begin
      frmMain.FMListboxIPR1.Itemindex := x;
      //showmessage('>'+inttostr(x)+':'+frmMain.FMListboxIPR1.GetSelectedRecord.IEN+':'+editTemplateIEN.text+'<');
      try
        if frmMain.FMListboxIPR1.GetSelectedRecord.IEN = editTemplateIEN.text then begin
          tempX := x;
          found := true;
      end except
      end;
    end;

  frmMain.ListBoxIPR1.ItemIndex := -1;

  // Now find which ListBoxIPR1.ItemIndex will make a connection back to
  // the right FMListboxIPR1 IEN, if selected.
  if Found = true then
    for x := 0 to frmMain.ListBoxIPR1.Items.Count - 1 do
      if tempX = frmMain.FMListBoxIPR1.Items.Count - 1 - x then begin
        frmMain.ListBoxIPR1.ItemIndex := x;
      end;

  if frmMain.ListBoxIPR1.ItemIndex > -1 then
    if
      found = true then
      frmMain.ButtonIPRDisplayClick(formTIUDisplay);

  if Found = False then begin
    ShowmessageCAPRI('Unable to find this template in GUI format.  It may have been deleted.');
  end;
end;

procedure TFormTIUDisplay.actFilePageSetupExecute(Sender: TObject);
begin
  Print(Sender);
end;

procedure TFormTIUDisplay.actFilePrintExecute(Sender: TObject);
begin
  Print(Sender);
end;

procedure TFormTIUDisplay.actFileTransmitVirtualVAExecute(Sender: TObject);
begin
  frmMain.actFileTransmitVirtualVAExecute(Self);
end;

procedure TFormTIUDisplay.actFileTransmitVirtualVAUpdate(Sender: TObject);
begin
  if (frmMain.VirtualVAURL = '') or
     (frmMain.VirtualVAToken = '') then
    actFileTransmitVirtualVA.Enabled := False
  else
    actFileTransmitVirtualVA.Enabled := True;
end;

procedure TFormTIUDisplay.File1Click(Sender: TObject);
var
  x: integer;
  showedit: boolean;
begin
  showedit := false;

  if noprinting = true then begin
    actFilePrint.enabled := false;
    actFilePageSetup.enabled := false;
  end;

  //EditCPExamReports1.Visible:=False;

(*
  If ANURemoteProcedureCallInProgress=True then
    OpenAsGUI1.Enabled:=False else
    OpenAsGUI1.Enabled:=True;
 *)

  if UserKeys.Count > 0 then begin
    for x := 0 to UserKeys.Count - 1 do
      if (UserKeys[x] = 'DVBA CAPRI EXAM LIST EDIT') or
        (UserKeys[x] = 'DVBA CAPRI EXAM LIST E') then
        showedit := true;
    for x := 0 to UserKeys.Count - 1 do
      if (UserKeys[x] = 'DVBAB CPWM REVIEWER') or
        (UserKeys[x] = 'DVBAB CPWM REVIE') then
        showedit := true;
    for x := 0 to UserKeys.Count - 1 do
      if (UserKeys[x] = 'DVBA C SUPERVISOR') then
        showedit := true;
  end;
  if Pos('@', userfilemancode) > 0 then begin
    ShowEdit := true;
  end;
  if PatientIEN <> '' then
    if ShowEdit = True then begin
      (*
            OpenAsGUI1.Visible:=True;
      *)
    end;
end;

procedure TFormTIUDisplay.SpeedButtonCPRSClick(Sender: TObject);
begin
  speedButtonCPRS.enabled := false;
  frmMain.RPCBroker1.Results.Clear;
  frmmain.RPCBroker1.RemoteProcedure := 'TIU GET RECORD TEXT';
  frmmain.RPCBroker1.Param[1].Value := editTIUDocumentNumber.text;
  frmmain.RPCBroker1.Param[1].PType := literal;
  frmMain.RPCBrokerCall;
  try
    frmMain.RPCBroker1.Call;
  except
    on EBrokerError do begin
      ANURemoteProcedureCallInProgress := False;
      frmmain.AnimateLogo(False);
      frmmain.StatusBarLoadPt.Caption := 'RPC TIU GET RECORD TEXT could not be accessed!';
      frmmain.StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('RPC TIU GET RECORD TEXT could not be accessed!');
      exit;
    end
  end;
  memoDocs.Lines.Clear;
  QuickCopy(frmmain.RPCBroker1.Results, MemoDocs);
  speedButtonCPRS.enabled := true;
end;

procedure TFormTIUDisplay.SpeedButtonCAPRIClick(Sender: TObject);
begin
  frmmain.RPCBrokerCall;
  FMListerAMIEExams.IENS := ',' + edittemplateIEN.Text;
  FMListerAMIEExams.GetList(FMListBoxAMIEExams.Items);
  if FMListBoxAMIEExams.Items.Count = 0 then begin
    // ShowmessageCAPRI('Only the CPRS version of this note exists.');
    SpeedButtonCPRS.Down := True;
    SpeedButtonCPRSClick(Application);
    exit;
  end;
  FMListBoxAMIEExams.ItemIndex := 0;
  FMListBoxAMIEExamsClick(Application);
end;

procedure TFormTIUDisplay.FMListBoxAMIEExamsClick(Sender: TObject);
begin
  frmmain.RPCBrokerCall;
  MemoDocs.Lines.Clear;
//  CodeCR319 - rpm 6/25/12 - increasing the max size of the report text
//  field in C&P Exam Request Report Management form caused <STORE> errors
//  when retrieving data from field #71 using the GetAndFill method to
//  populate a hidden TFMMemo component named FMMemoAMIEExamResults.
//  The Exam results are now retrieved by GetExamResults.
  GetExamResults(FMListBoxAMIEExams.Items[FMListBoxAMIEExams.ItemIndex], FMMemoAMIEExamResults, memoDocs);
end;

procedure TFormTIUDisplay.Print(Sender: TObject);
Var
  Division: String;
  DtTm    : String;
begin
  formPrint.QRMemoReport.Lines.Clear;
  formPrint.QRMemoReport.Lines.SetText(PAnsiChar(memoDocs.Lines.Text));
  formPrint.QRLabel1.Caption := 'CLIN DOC: Progress Note';
  formPrint.QRLabel3.Caption :=
    Copy(
      PatientName +
      '  SSN#' +
      PatientSSN +
      '                                                                                ',
      1,
      51);
  frmMain.RPCBroker1.RemoteProcedure := 'DVBAB DATETIME';
  Try
    frmMain.RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      frmMain.AnimateLogo(False);
      frmMain.StatusBarLoadPt.Caption := 'RPC DVBAB DATETIME could not be accessed!';
      frmMain.StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('DVBAB DATETIME could not be accessed!');
    End;
  End;
  DtTm := frmMain.RPCBroker1.Results[0];
  formPrint.QRLabel4.Caption := 'Printed on: ' + DtTm;
  formPrint.QRLabel5.Caption := 'System: ' + Uppercase(frmMain.RPCBroker1.ANUStrServer);
  {Get Division}
  frmMain.RPCBroker1.RemoteProcedure := 'XWB GET VARIABLE VALUE';
  frmMain.RPCBroker1.Param[0].Value := 'DUZ("2")';
  frmMain.RPCBroker1.Param[0].PType := reference;
  Division := '';
  Try
    frmMain.RPCBroker1.Call;
    Division := frmMain.RPCBroker1.Results[0];
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      frmMain.AnimateLogo(False);
      frmMain.StatusBarLoadPt.Caption := 'RPC XWB GET VARIABLE VALUE could not be accessed!';
      frmMain.StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('XWB GET VARIABLE VALUE could not be accessed!');
    End;
  End;
  Division := frmMain.RPCBroker1.Results[0];
  formPrint.QRLabel6.Caption := 'Division: ' + Division;
  If sender = actFilePageSetup Then
  Begin
    formPrint.buttonPreviewClick(Application);
  End
  Else
  Begin
    formPrint.buttonPrintClick(Application);
  End;
end;

//CCAPRI_CodeCR96 - jcs - 03/16/10
procedure TFormTIUDisplay.WMMenuChar(var Message: TWMMenuChar);
begin
  If Not ActivateMenu(self, Message) then
    Inherited;
end;
end.
