unit unitzip;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  DialogsCAPRI,
  Dialogs,
  StdCtrls,
  ComCtrls,
  Math,
  Main,
  TRPCB,
  Diaccess,
  Fmcmpnts,
  Fmcntrls;

type
  TfrmZipCodes = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Button1: TButton;
    Label3: TLabel;
    editDistance: TEdit;
    Button2: TButton;
    Label4: TLabel;
    editLat1: TEdit;
    editLong1: TEdit;
    editLat2: TEdit;
    editLong2: TEdit;
    RichEdit1: TRichEdit;
    ButtonPatientZip: TButton;
    ButtonCalculateDistance: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure ButtonPatientZipClick(Sender: TObject);
    procedure ButtonCalculateDistanceClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function GetDataForZipCode(zipcode: string): string;
  end;

var
  frmZipCodes: TfrmZipCodes;

implementation

{$R *.DFM}

procedure TfrmZipCodes.Button1Click(Sender: TObject);
var
  tempstring: string;
begin
  if edit2.text <> '' then begin
    tempstring := GetDataForZipCode(IntToStr(StrToInt(Edit2.Text)));
    if tempstring <> '' then begin
      editlat2.text := frmMain.Piece(tempstring, ',', 5);
      editlong2.text := frmMain.Piece(tempstring, ',', 6);
    end;
  end;

end;

procedure TfrmZipCodes.Button2Click(Sender: TObject);
begin
  ModalResult := mrOK;
end;

procedure TfrmZipCodes.Edit1Change(Sender: TObject);
begin
  if Pos('-', edit1.text) > 0 then
    Edit1.text := frmMain.Piece(Edit1.Text, '-', 1);
end;

procedure TfrmZipCodes.Edit2Change(Sender: TObject);
begin
  if Pos('-', edit2.text) > 0 then
    Edit2.text := frmMain.Piece(Edit2.Text, '-', 1);
end;

function TfrmZipCodes.GetDataForZipCode(zipcode: string): string;
var
  FoundAt1, FoundAt2: LongInt;
  startpos: LongInt;
begin
  // Need to try to optimize this.
  startpos := 0;
  if RichEdit1.Lines.Count = 0 then
    exit;
  FoundAt1 := RichEdit1.FindText(',' + zipcode + ',', startpos, Length(RichEdit1.text), []);
  FoundAt2 := RichEdit1.FindText(char(13), foundat1, Length(RichEdit1.text) - foundat1, []);
  //RichEdit1.SetFocus;
  //RichEdit1.SelStart:=FoundAt1;
  //RichEdit1.SelLength:=FoundAt2-FoundAt1;
  Result := Copy(RichEdit1.Text, FoundAt1 + 1, FoundAt2 - FoundAt1);
end;

procedure TfrmZipCodes.ButtonPatientZipClick(Sender: TObject);
var
  tempstring: string;
begin
  if edit1.text <> '' then begin
    tempstring := GetDataForZipCode(IntToStr(StrToInt(Edit1.Text)));
    if tempstring <> '' then begin
      editlat1.text := frmMain.Piece(tempstring, ',', 5);
      editlong1.text := frmMain.Piece(tempstring, ',', 6);
    end;
  end;
end;

procedure TfrmZipCodes.ButtonCalculateDistanceClick(Sender: TObject);
var
  a, c, r, distance: real;
  lat1, lat2, long1, long2: real;
  dlat, dlon: real;
begin
  try
  lat1 := strtofloat(editlat1.text)except begin
      editDistance.text := '???';
      exit;
    end;
  end;
  try
  long1 := strtofloat(editlong1.text)except begin
      editDistance.text := '???';
      exit;
    end;
  end;

  try
  lat2 := strtofloat(editlat2.text)except begin
      editDistance.text := '???';
      exit;
    end;
  end;
  try
  long2 := strtofloat(editlong2.text)except begin
      editDistance.text := '???';
      exit;
    end;
  end;

  if (editlat1.text = '') or (editlat2.text = '') then begin
    editDistance.text := '???';
    exit;
  end;

  r := 3956; //miles of Earth's diameter

  lat1 := degtorad(lat1);
  lat2 := degtorad(lat2);
  long1 := degtorad(long1);
  long2 := degtorad(long2);

  dlon := long2 - long1;
  dlat := lat2 - lat1;

  a := sqr(sin(dlat / 2)) + (cos(lat1) * cos(lat2) * sqr(sin(dlon / 2)));
  c := 2 * arcsin(min(1, sqrt(a)));
  distance := R * c;
  try
  editDistance.Text := floattostr(distance)except editDistance.Text := '???'
  end;
end;

end.
