unit vlerCCRExams;

// Portions of Manifests form, pulled in here for existing functionality.
//  The GUI is only used during debugging. Form is invisible at run time.

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Fmcntrls, xmldom, XMLIntf, msxmldom, XMLDoc,
  ComCtrls, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, IdHTTP,
  Fmcmpnts, Diaccess
  , VlerDasIdHTTP
  , VlerDasClient, ExtCtrls
  ;

type
  TfrmvlerCCRExams = class(TForm)
    btnCCR: TButton;
    btnPendExamResults: TButton;
    XMLManifests: TXMLDocument;
    lbxIPR: TListBox;
    btnGetPatient: TButton;
    ed_SSN: TEdit;
    XMLManifestDoc: TXMLDocument;
    lblPatientName: TLabel;
    txtPatientName: TStaticText;
    txtGridHeader: TStaticText;
    btnRemoveExam: TButton;
    Timer1: TTimer;
    procedure FormShow(Sender: TObject);
    //procedure btnPendExamResultsClick(Sender: TObject);
    procedure lbxIPRClick(Sender: TObject);
    procedure btnGetPatientClick(Sender: TObject);
    procedure btnCCRClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
    FHTTPServer: TIdHTTPvler;
    //procedure getManifestList;
    //procedure getManifestURL;
    procedure getPatientExamsFromManifestDocs(CurrentPatient: string);
    function curPatAtIx(ix: integer): string;
    procedure RemoveAllSubNodesAtIx(ix: integer);
    procedure RemoveRootRecordAtIx(ix: integer);
    procedure RemoveRecordAtIx(ix: integer);
    procedure CcrGetManifestList;
    procedure CcrGetManifestDoc(manifestURL: string);
    procedure CcrGetExamResultByDocId(docUUId, manifObjID: string);
    procedure getNodeAndCheckValidDate(var nextUploadDate: string; var nextNode: IXMLNode; aDocNode: IXMLNode);
    //procedure CcrGetExamResultByResultId(ResultObjId: string);
    //procedure Fill   ugData(CurrentPatientSSN: string);
  public
    { Public declarations }
    lbxIprItems: TStringList;
    XMLResultFromVendor: TXMLDocument;
    //function getManifestCnt: Integer;
    class procedure EnsurefrmvlerCCRExamsReady(var frmvlerCCRExams: TfrmvlerCCRExams);
    function CcrGetManifestCount: Integer;
    procedure CcrGetManifests(CurrentPatient: string);
    procedure CcrGetManifestURLsExams(CurrentPatient: string);
    //procedure RemoveDupeNotificForSameExams;
    procedure LimitToPatient(CurrentPatient: string);
    procedure FetchAllExamsTextToFiles(var ResList: TList);
    procedure FillExamResultList(var ResList: TList);
    procedure CcrFetchExamResultFile(docUUId: string; var ExamID: string; var ExamFileName: string; var ExamResultObjectId: string);
    procedure CcrFilterResultXMLForLatestUploadDate(strStationNo: string; filePrefix: string; docUUId: string; AXMLDom: TXMLDocument; SaveLoaded: Boolean = false);
    {Begin Generic Independantly Callable methods}
    procedure FetchAFileObjectFromFS(fsObjectID: string; fileFullNamePath: TFileName);
    procedure FetchAFileObjectFromFSToStream(fsObjectID: string; ResponseToStream: TStream);
    function FetchAFileObjectFromVLERToString(collection: string; fsObjectID: string): string;
    function getStatusDateText(AVLERDateNode: IXMLNode): string;
    procedure RemoveAllCldAttachments(XMLResultFromVendor: TXMLDocument);
    procedure RemoveFileControlInfo(XMLResultFromVendor: TXMLDocument);
    procedure SetResultStatusText(XMLResultFromVendor: TXMLDocument; newStatus: string);
    procedure SetResultStatusDate(XMLResultFromVendor: TXMLDocument; newStatusDate: string);
    procedure RemoveResultSetcontainerNodes(XMLResultFromVendor: TXMLDocument; var XMLResultFromVendorNoContainer: TXMLDocument);

    function SetManifestStatus(ManifestObjectId: string; newStatus: string; oldStatus: string = ''): string;
    procedure GetExamResultByID2DOM(exResultID: string; XMLResultFromVendor: TXMLDocument);

    procedure GetQuerySetOfAllNonTextAttachments(XMLResultFromVendor: TXMLDocument);

    //procedure SetManifestStatus(ManifestObjectId: string; newStatus: string);
    {End Generic Independantly Callable methods}
  end;

var
  frmvlerCCRExams: TfrmvlerCCRExams;

  // move to XmlEngine before finished.
// procedure DomToTree(anXmlNode: IXMLNode; aTreeNode: TTreeNode; aTreeView: TTreeView);

implementation
uses
  main, clsPatientInfo, Patient
  , IdURI
  , untBrkrMthds
  , untMiscMthds
  , MFunStr
  , clsVLERConn
  , IdDateTimeStamp
  , untAddtnlMMthds
  , CAPRISupport
  ;

{$R *.DFM}

(*
type TIntegerSSN = class
  private
    intV : integer;
  public
    property IntObj : integer read intV;
    constructor Create(intVal : integer);
end;

{ TIntegerSSN }

constructor TIntegerSSN.Create(intVal: integer);
begin
  intV := intVal;
end;
*)

var
  tmpPatientInfo: TPatientInfoBucket;

// move to XmlEngine

function getChildNodes(node: IDOMNode): string;
var
  J: Integer;
begin
  Result := '';
  for J := 0 to node.childNodes.length - 1 do
    if (node.childNodes.item[J].nodeType = TEXT_NODE) or
      (node.childNodes.item[J].nodeType = CDATA_SECTION_NODE) then
      Result := Result + node.childNodes.item[J].nodeValue;
end;

(*
procedure TfrmvlerCCRExams.getManifestList;
var
  strXml: string;
  strURL: string;
  //strURLEnc: string;
  strStationNo: String;
begin
  strStationNo :=  GetDivisionOfCBOC(frmMain.RPCBroker1.User.Division);
  strURL := TIdHTTPVler.GetVlerDasURL()
          + '/ecrud/v1/core/compensationAndPension.manifest.notification?query={"feed.entry.content.StationNumber":"'
          + strStationNo
          + '","feed.entry.content.Status":"Open"}';
  //strURLEnc := TIdHTTPVler.URLParamsEncode(strURL);
  try
    strXML := FHTTPServer.Get(TIdHTTPVler.URLParamsEncode(strURL){$IFDEF CAPRIDEVELOPER},[502]{$ENDIF});
    SaveStrXMLInFileAndXMLDoc(strXml, strStationNo, 'ManifestNotificationList', '', XMLManifests, PARAM_SAVE_XML);
  except
    on e: exception do
      raise;
  end;
end;
*)

class procedure TfrmvlerCCRExams.EnsurefrmvlerCCRExamsReady(var frmvlerCCRExams: TfrmvlerCCRExams);
begin
  if frmvlerCCRExams = nil then begin
    Application.CreateForm(TfrmvlerCCRExams, frmvlerCCRExams);
    frmvlerCCRExams.Visible := false;
    frmvlerCCRExams.Hide;
    frmvlerCCRExams.width := 1;                                                 // rpk 10/23/2014
    frmvlerCCRExams.height := 1;                                                // rpk 10/23/2014
    frmvlerCCRExams.top := 5000;                                                // rpk 10/23/2014
    frmvlerCCRExams.left := 5000;                                               // rpk 10/23/2014
  end;
end;

procedure TfrmvlerCCRExams.RemoveAllCldAttachments(XMLResultFromVendor: TXMLDocument);
var
  nc_BaseNodePath: string;
  nc_BaseNode: IXMLNode;
  indx: Integer;
  NamespaceURI: string;
  nc_BaseNodeToDel: IXMLNode;
begin
  //     Remove all cld:Attachments
  nc_BaseNodePath := 'cld:Claim^cld:Attachments';
  nc_BaseNode := FindNodeInPathByNodeName(XMLResultFromVendor.DocumentElement, nc_BaseNodePath);

  while True do begin
    nc_BaseNodeToDel := FindNodeInPathByNodeName(nc_BaseNode, 'nc:Attachment');
    if nc_BaseNodeToDel = nil then break;
    indx := nc_BaseNode.ChildNodes.IndexOf(nc_BaseNodeToDel);
    //showmessage(intToStr(indx));
    if nc_BaseNode.ChildNodes.Delete(indx) = -1 then break;
  end;
end;

procedure TfrmvlerCCRExams.RemoveFileControlInfo(XMLResultFromVendor: TXMLDocument);
var
  nc_BaseNodePath: string;
  nc_BaseNode: IXMLNode;
begin
  // remove  <nc:DocumentFileControlID>
  //         <nc:DocumentFormatText>  ?? double check posted record
  nc_BaseNodePath := 'cld:Claim^cld:CommonData^nc:Document';
  nc_BaseNode := FindNodeInPathByNodeName(XMLResultFromVendor.DocumentElement, nc_BaseNodePath);

  //nc_DocumentFileControlIDNode := frmvlerCCRExams.FindNodeByNodeName(nc_DocumentNode,'nc:DocumentFileControlID');
  nc_BaseNode.ChildNodes.Delete('nc:DocumentFileControlID');
  nc_BaseNode.ChildNodes.Delete('nc:DocumentFormatText');
end;

procedure TfrmvlerCCRExams.SetResultStatusText(XMLResultFromVendor: TXMLDocument; newStatus: string);
var
  nc_BaseNodePath: string;
  nc_StatusTextNode: IXMLNode;
begin
  //  set <nc:DocumentStatus> <nc:StatusText>  Rejected </nc:StatusText>
  nc_BaseNodePath := 'cld:Claim^cld:CommonData^nc:Document^nc:DocumentStatus^nc:StatusText';
  nc_StatusTextNode := FindNodeInPathByNodeName(XMLResultFromVendor.DocumentElement, nc_BaseNodePath);
  nc_StatusTextNode.Text := newStatus;
end;

procedure TfrmvlerCCRExams.SetResultStatusDate(XMLResultFromVendor: TXMLDocument; newStatusDate: string);
var
  nc_BaseNodePath: string;
  vler_StatusDate_nc_DateTimeNode: IXMLNode;
begin
  nc_BaseNodePath := 'cld:Claim^cld:CommonData^vler:ExamDetail^vler:StatusDate^nc:DateTime';
  vler_StatusDate_nc_DateTimeNode := FindNodeInPathByNodeName(XMLResultFromVendor.DocumentElement, nc_BaseNodePath);
  vler_StatusDate_nc_DateTimeNode.Text := newStatusDate;
end;

procedure TfrmvlerCCRExams.Timer1Timer(Sender: TObject);
begin
  timer1.Enabled := False;                                                      // rpk 10/23/2014
  Hide;                                                                         // rpk 10/23/2014
end;

procedure TfrmvlerCCRExams.RemoveResultSetcontainerNodes(XMLResultFromVendor: TXMLDocument; var XMLResultFromVendorNoContainer: TXMLDocument);
var
  cld_ClaimNodePath: string;
  cld_ClaimNode: IXMLNode;
  cld_ClaimNodeStream: TStringStream;

begin
  //  set <nc:DocumentStatus> <nc:StatusText>  Rejected </nc:StatusText>
  cld_ClaimNodePath := 'cld:Claim';
  cld_ClaimNode := FindNodeInPathByNodeName(XMLResultFromVendor.DocumentElement, cld_ClaimNodePath);
  cld_ClaimNodeStream := TStringStream.create(cld_ClaimNode.XML);
  try
    XMLResultFromVendorNoContainer.LoadFromStream(cld_ClaimNodeStream);
  finally
    cld_ClaimNodeStream.Free;
  end;
end;

procedure TfrmvlerCCRExams.GetQuerySetOfAllNonTextAttachments(XMLResultFromVendor: TXMLDocument);
var
  nc_BaseNodePath: string;
  nc_BaseNode: IXMLNode;
  indx: Integer;
  NamespaceURI: string;
  nc_BaseNodeToDel: IXMLNode;
begin
  //     Remove all cld:Attachments
  nc_BaseNodePath := 'cld:Claim^cld:Attachments';
  nc_BaseNode := FindNodeInPathByNodeName(XMLResultFromVendor.DocumentElement, nc_BaseNodePath);

  while True do begin
    nc_BaseNodeToDel := FindNodeInPathByNodeName(nc_BaseNode, 'nc:Attachment');
    if nc_BaseNodeToDel = nil then break;
    indx := nc_BaseNode.ChildNodes.IndexOf(nc_BaseNodeToDel);
    //showmessage(intToStr(indx));
    if nc_BaseNode.ChildNodes.Delete(indx) = -1 then break;
  end;
end;

procedure TfrmvlerCCRExams.CcrGetManifestList;
var
  strXml: string;
  strURL: string;
  //strURLEnc: string;
  strStationNo: String;
begin
  strStationNo := GetDivisionOfCBOC(frmMain.RPCBroker1.User.Division);
  strURL := TIdHTTPVler.GetVlerDasURL()
    + '/ecrud/v1/core/compensationAndPension.manifest.notification?query={"feed.entry.content.StationNumber":"'
    + strStationNo
    + '","feed.entry.content.Status":"Open"}';
  //strURLEnc := TIdHTTPVler.URLParamsEncode(strURL);
  try
    strXML := FHTTPServer.Get(TIdHTTPVler.URLParamsEncode(strURL){$IFDEF CAPRIDEVELOPER}, [502]{$ENDIF});
    SaveStrXMLInFileAndXMLDoc(strXml, strStationNo, 'ManifestNotificationList', '', XMLManifests, PARAM_SAVE_XML);
  except
    on e: exception do
      raise;
  end;
end;

procedure TfrmvlerCCRExams.CcrGetManifestDoc(manifestURL: string);
var
  strXml: string;
  ix: Integer;
  pieceObjID: string;
  pieceNext: string;
  strStationNo: String;
begin
  strStationNo := GetDivisionOfCBOC(frmMain.RPCBroker1.User.Division);
  ix := 6;                                                                      // This can be done better with TIdURI
  repeat
    pieceObjID := piece(manifestURL, '/', ix);
    inc(ix);
    pieceNext := piece(manifestURL, '/', ix);
  until (pieceNext = '');

  try
    strXML := FHTTPServer.Get(TIdHTTPVler.URLParamsEncode(manifestURL){$IFDEF CAPRIDEVELOPER}, [404, 502]{$ENDIF});
    SaveStrXMLInFileAndXMLDoc(strXml, strStationNo, 'ManifestDoc', pieceObjID, XMLManifestDoc, PARAM_SAVE_XML);
  except on
    e: EIdHTTPProtocolException do begin
      if e.ErrorCode = 404 then
        Raise Exception.CreateFmt('Bad URL in manifest ObjectID: %s.%s Can not continue.', [pieceObjID, #13#10])
      else
        Raise;
    end;
  end;
end;

procedure TfrmvlerCCRExams.getPatientExamsFromManifestDocs(CurrentPatient: string);
var
  docElemNode, rNode, cNode, examsNode, eNode: IXMLNode;
  pNode, xNode, xIdNode, xDocIDNode: IXMLNode;
  mnDateNode, mnFSIdNode: IXMLNode;

  patientstr, examstr, SSN, firstName, middleName, lastName, examName, examValue: string;
  I, Jcount, idx: Integer;
  inpstr: string;
  icnt: Integer;
  tmpobj: TObject;
  AExamInfo: TVLERExamInfo;
  mnDateTime: string;
  curReqID: string;
begin
  idx := -1;

  docElemNode := XMLManifestDoc.DocumentElement;

  if docElemNode.HasChildNodes then begin
    mnFSIdNode := docElemNode.ChildNodes['_id'];                                // causes a traversal of XML to bottom but unavoidable
    rNode := docElemNode.ChildNodes['ResultManifest'];                          // ResultManifest Node

    // Get ManifestDate
    mnDateNode := rNode.ChildNodes['ManifestDate'];
    //mnDateTime := mnDateNode.Text;  This doesn't work
    mnDateTime := mnDateNode.ChildNodes[0].NodeValue;                           // This does
    mnDateTime := StripMSAndZFromISO8601(mnDateTime);                           // loose milliseconds and Z. Everytimestamp coming in is Zulu

    pNode := rNode.ChildNodes['Patient'];
    patientstr := pNode.NodeName;
    if patientstr = 'Patient' then begin                                        // done: lms - NO. should these be compared case insensitive
      SSN := pNode.ChildNodes['SSN'].NodeValue;                                 // Text??

      SSN := StringReplace(SSN, '-', '', [rfReplaceAll]);                       // Handle previous erroneous data
      if (CurrentPatient <> SSN) then
        exit;                                                                   // New exclusion.. only current patient's exams are added to the listBox

      firstName := pNode.ChildNodes['FirstName'].Text;
      middleName := pNode.ChildNodes['MiddleName'].Text;
      lastName := pNode.ChildNodes['LastName'].Text;

      inpstr := lastName + ', ' + firstName + ' ' + middleName;                 // rpk 8/7/2014

      // check for duplicate patient; add if no duplicate
      idx := -1;
      for icnt := 0 to lbxIpr.Count - 1 do begin
        tmpobj := lbxIpr.Items.Objects[icnt];
        if tmpobj <> nil then begin
          if SSN = TVLERExamInfo(tmpobj).SSN then
            idx := icnt;
          break;
        end;
      end;
      if idx < 0 then begin
        AExamInfo := TVLERExamInfo.Create;
        AExamInfo.SSN := SSN;                                                   // Top level patient record - no exam info.
        AExamInfo.ManifestDateTime := mnDateTime;
        Jcount := lbxIPR.Items.AddObject(inpstr, AExamInfo);
      end else
        Inc(idx);
    end;

    // exams list
    examsNode := rNode.ChildNodes['Exams'];
    curReqID := '';
    for I := 0 to examsNode.ChildNodes.Count - 1 do begin
      // First get RequestId
      eNode := examsNode.ChildNodes[i];
      if eNode.NodeName = 'RequestId' then begin
        curReqID := GenericGetXMLNodeText(eNode);
        break;
      end;
    end;
    for I := 0 to examsNode.ChildNodes.Count - 1 do begin
      // each exam
      eNode := examsNode.ChildNodes[i];
      if eNode.NodeName = 'RequestId' then begin
        //curReqID := GenericGetXMLNodeText(eNode);
        continue;
      end;

      xNode := eNode.ChildNodes['ExamName'];
      xIdNode := eNode.ChildNodes['ExamID'];
      xDocIDNode := eNode.ChildNodes['DocumentID'];
      if (xNode <> nil) and (xIdNode <> nil) and (xDocIDNode <> nil) then begin
        if (xNode.NodeValue <> '') then begin
          // examValue := xNode.NodeValue; This broke on some values.... hence
          // examValue := GenericGetXMLNodeText(xNode);
          // The actual reason was that the parser found requestID element first and then looked for ExamID.. but not finding it, it marked that as an empty cell and didn't stop processing. So we were getting an empty cell
          examValue := xNode.NodeValue;

          // add exam name as indented column under patient
          inpstr := '   ' + examValue;
          // if patient already exists, add exams to patient; object is added for exams with extra info
          AExamInfo := TVLERExamInfo.Create;
          AExamInfo.ExamName := xNode.NodeValue;
          AExamInfo.ExamID := xIdNode.NodeValue;
          AExamInfo.DocumentUUID := xDocIDNode.NodeValue;
          AExamInfo.RequestUUID := curReqID;
          AExamInfo.SSN := SSN;
          AExamInfo.ManifestDateTime := mnDateTime;
          AExamInfo.ManifestObjectId := mnFSIdNode.NodeValue;
          if idx >= 0 then
            lbxIPR.Items.InsertObject(idx, inpstr, AExamInfo)
          else
            Jcount := lbxIPR.Items.AddObject(inpstr, AExamInfo);
        end;
      end else begin
        Raise Exception.Create('Incomplete Nodes in Manifest Exam Listing');
      end;
    end;
  end;
end;

function TfrmvlerCCRExams.CcrGetManifestCount: Integer;
var
  rNode: IXMLNode;
begin
  Result := -1;

  if not XMLManifests.Active then
    CcrGetManifestList;

  if XMLManifests.Active then begin
    rNode := XMLManifests.DocumentElement;
    Result := 0;
    if rNode.HasChildNodes then
      Result := rNode.ChildNodes.Count;
  end;
end;

procedure TfrmvlerCCRExams.btnCCRClick(Sender: TObject);
begin
  exit;
  // make sure the TmpPatientInfo is loaded
  //btnGetPatient.Click;

  // After patient info is loaded in main, run CCR
  //frmMain.actCCRLaunchExecute(Self);

end;

procedure TfrmvlerCCRExams.btnGetPatientClick(Sender: TObject);
begin
  exit;
  if ed_SSN.Text > '' then begin
    if tmpPatientInfo <> nil then
      FreeAndNil(tmpPatientInfo);
    if ed_SSN.Text = '50090876' then           // debugging line only..
      ed_SSN.Text := '50090876P';
//    tmpPatientInfo := TPatientInfoBucket.Create(ed_SSN.Text)
    TPatientInfoBucket.CreatePatientInfoBucket(ed_SSN.Text, tmpPatientInfo);  // CodeCR701 rpk 2/9/2015
  end;

  if (tmpPatientInfo <> nil) and (tmpPatientInfo.SSN > '') then begin
    frmMain.PatientInfo := tmpPatientInfo;
    txtPatientName.Caption := tmpPatientInfo.Name;
    btnCCR.Enabled := True;
  end
  else begin
//    ShowMessage('Patient Not Found.');
    btnCCR.Enabled := False;
  end;
end;                                                                            // btnGetPatientClick

procedure TfrmvlerCCRExams.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if tmpPatientInfo <> nil then
    FreeAndNil(tmpPatientInfo);
end;

procedure TfrmvlerCCRExams.FormCreate(Sender: TObject);
begin
  tmpPatientInfo := nil;
  FHTTPServer := TIdHTTPvler.Create(Self, frmMain.RPCBroker1);
  //FHTTPServer.ManagedIdHTTP := IdHTTPBase1;  // DONE: LMS if there is nothing useful coming from this, then it should be removed. one should rarely need to set their own managedIdHTTP
  lbxIprItems := TStringList.Create;                                            // wait TODO: LMS for efficiency, switch to using this instead of the ListBox Items.
  XMLResultFromVendor := TXMLDocument.Create(Self);
end;

procedure TfrmvlerCCRExams.FormDestroy(Sender: TObject);
begin
  EmptyTStringsAndFreeObjects(TStrings(lbxIprItems));
  EmptyTStringsAndFreeObjects(lbxIpr.Items);
end;

procedure TfrmvlerCCRExams.FormShow(Sender: TObject);
begin
  timer1.Enabled := true;                                                       // rpk 10/23/2014

  Hide;                                                                         // rpk 10/23/2014
end;

function ISSNToSSN(iSSN: Integer): string;
var
  ssnstr: string;
begin
  ssnstr := IntToStr(issn);
  // handle pseudo SSN with trailing P
  if issn > 1000000000 then begin
    issn := issn - 1000000000;
    ssnstr := ssnstr + 'P';
  end;
  Result := ssnstr;
end;


procedure TfrmvlerCCRExams.lbxIPRClick(Sender: TObject);
var
  x, issn: integer;
  ssnstr: string;
  tmpobj: TObject;
begin
  exit;
  // Deal with a sub-form component being clicked
  // a leading blank space indicates that this row has an exam name
  // move index up to parent patient row
  if Copy(lbxIPR.Items[lbxIPR.ItemIndex], 1, 1) = ' ' then
  begin
    x := lbxIPR.ItemIndex;
    repeat
      dec(x);
    until Copy(lbxIPR.Items[x], 1, 1) <> ' ';
    lbxIPR.ItemIndex := x;
  end;
  x := lbxIPR.ItemIndex;
//  ssnstr := Copy(lbxIPR.Items[x], 1, 10);
  tmpobj := lbxIpr.Items.Objects[x];
  if tmpobj <> nil then begin
    //issn := Integer(tmpobj);
    //ssnstr := ISSNToSSN(issn);
    ed_ssn.Text := TVLERExamInfo(tmpobj).SSN;                                   // ssnstr;
    btnGetPatient.Click;
  end;
end;

function TfrmvlerCCRExams.curPatAtIx(ix: integer): string;
var
  issn: integer;
  ssnstr: string;
  tmpobj: TObject;
begin
  result := '';
  if lbxIPR.Items.count <= ix then exit;

  try
    tmpobj := lbxIpr.Items.Objects[ix];
  except
  end;
  if tmpobj <> nil then begin
    result := TVLERExamInfo(tmpobj).SSN;
    exit;
  end;
end;

procedure TfrmvlerCCRExams.RemoveAllSubNodesAtIx(ix: integer);
begin
  while ((ix + 1) <= (lbxIpr.Items.Count - 1)) do
    if (Copy(lbxIPR.Items[ix + 1], 1, 1) = ' ') then begin
      RemoveRecordAtIx(ix + 1)
    end else
      break;
end;

procedure TfrmvlerCCRExams.RemoveRecordAtIx(ix: integer);
begin
  if ix <= (lbxIPR.Items.Count - 1) then begin
    lbxIpr.Items.Objects[ix].Free;
    lbxIpr.Items.delete(ix);
  end;
end;

procedure TfrmvlerCCRExams.RemoveRootRecordAtIx(ix: integer);
begin
  if ix <= (lbxIPR.Items.Count - 1) then begin
    if (Copy(lbxIPR.Items[ix], 1, 1) <> ' ') then begin
      RemoveRecordAtIx(ix);
    end;
  end;
end;

function TfrmvlerCCRExams.SetManifestStatus(ManifestObjectId: string; newStatus: string; oldStatus: string = ''): string;
var
  newStatusSetCmd: string;
  ResponseToFile: TFileStream;
  AURL: string;
  hadException: boolean;

  FHTTPServerPut: TIdHTTPvler;
  PutJSONCommand: TStringStream;
  outPutFileName: string;
  AXMLDom: TXMLDocument;
  aNode: IXMLNode;
begin
  Result := '';
  if ManifestObjectId = '' then
    Exception.CreateFmt('Error: Blank Manifest ID supplied for update status from %s to %s', [oldStatus, newStatus]);

  hadException := false;
  EnsureBrokerConnected(frmMain.RPCBroker1);                                    // SFTP operations are prone to time outs. VLER could too.. This is preventative.
  // Ideally This and other similar methods should be class methods, or instance methods of TIdHTTPVler class.
  //  Do query by manifest ID.. but if duplicate found, then raise error and quit.
  AURL := TIdHTTPVler.GetVlerDasURL()
          //+ '/ecrud/v1/core/compensationAndPension.manifest.notification' // ?query={"feed.entry.content.ManifestID":"6ba7b810-9dad-11d1-80b4-10c04fd3333"}&upsert=false&multi=false
  + '/ecrud/v1/core/compensationAndPension.manifest.notification'
    + '?query={"feed.entry.id":"'                                               //   // id":"53e2322f345fd6607PORTd8b","feed.entry.content.Status":"Open"}
    + ManifestObjectId
    + '"';
  if oldStatus <> '' then begin
    AURL := AURL
      + ','
      + '"feed.entry.content.Status":{"$regex":"^'
      + oldStatus                                                               // ,"feed.entry.content.Status":{"$regex":"^InProcess"}
      + '"}'
  end;
          //+ ',"feed.entry.content.Status":"Open"'     // this has to work for any existing status, open or inprocess
  AURL := AURL
    + '}'
    + '&upsert=false&multi=false';
  FHTTPServerPut := TIdHTTPvler.Create(Self, frmMain.RPCBroker1);
  //FHTTPServerPut.Request.CustomHeaders.Delete(FHTTPServerPut.Request.CustomHeaders.IndexOfName('Content-Type'));
  FHTTPServerPut.Request.ContentType := 'application/json';
  // Accept := HTTPHeaderAcceptXML;  // ** May have to tweak this.

  newStatusSetCmd := '{"$set":{"feed.entry.content.Status":"' + newStatus + '"}}';
  PutJSONCommand := TStringStream.Create(newStatusSetCmd);

  outPutFileName := GetTempExmDir(frmMain.RPCBroker1.User.DUZ);
  outPutFileName := outPutFileName + '\' + 'ManifestNewStatusResult' + Piece(newStatus, '+') + ManifestObjectId + '.html';

  if fileExists(outPutFileName) then
    sysutils.DeleteFile(outPutFileName);

  ResponseToFile := TFileStream.Create(outPutFileName, fmCreate);
  try
    try
      //FHTTPServerPut.Request.Source := PutJSONCommand;
      try
        FHTTPServerPut.Put(TIdHTTPVler.URLParamsEncode(AURL), PutJSONCommand, ResponseToFile, {$IFDEF CAPRIDEVELOPER} [502]{$ELSE} []{$ENDIF});
      except on excp: EIdHTTPProtocolException do                               // trap only http 404 on put. Meaning original record to update was not found
        begin
          hadException := not (excp.ErrorCode = 404);
          if hadException then
            raise
          else Result := 'false^0^0^0';
        end;
      end;
    finally
      if ResponseToFile <> nil then
        ResponseToFile.Free;                                                    // DONE: LMS Make sure the file is saved if SAVEXML parameter is set.
      if PutJSONCommand <> nil then
        PutJSONCommand.Free;
    end;
  finally
    if fileExists(outPutFileName) and not hadException then begin
      ResponseToFile := TFileStream.Create(outPutFileName, fmOpenRead);
      if ResponseToFile.Size > 0 then begin
        ResponseToFile.Free;
        AXMLDom := TXMLDocument.Create(self);
        AXMLDom.LoadFromFile(outPutFileName);
        // example: <?xml version="1.0" encoding="UTF-8" ?><document><success>true</success><nMatched>1</nMatched><nModified>1</nModified><nInserted>0</nInserted></document>
        AXMLDom.Active := true;
        aNode := FindNodeInPathByNodeName(AXMLDom.DocumentElement, 'success');
        if aNode <> nil then
          Result := Result + GenericGetXMLNodeText(aNode);

        Result := Result + '^';
        aNode := FindNodeInPathByNodeName(AXMLDom.DocumentElement, 'nMatched');
        if aNode <> nil then
          Result := Result + GenericGetXMLNodeText(aNode);

        Result := Result + '^';
        aNode := FindNodeInPathByNodeName(AXMLDom.DocumentElement, 'nModified');
        if aNode <> nil then
          Result := Result + GenericGetXMLNodeText(aNode);

        Result := Result + '^';
        aNode := FindNodeInPathByNodeName(AXMLDom.DocumentElement, 'nInserted');
        if aNode <> nil then
          Result := Result + GenericGetXMLNodeText(aNode);
      end;
    end;
    if (not (hadException or PARAM_SAVE_XML))
{$IFDEF CAPRIDEVELOPER}
    and false
{$ENDIF}
    then begin
      try
        sysutils.DeleteFile(outPutFileName);
      except
      end;
    end;
  end;
end;

procedure TfrmvlerCCRExams.CcrGetManifests(CurrentPatient: string);
begin
  // Here always get a fresh list // if not XMLManifests.Active then
  CcrGetManifestList;
  if CcrGetManifestCount > 0 then begin
    CcrGetManifestURLsExams(CurrentPatient);
  end;
end;

procedure TfrmvlerCCRExams.CcrGetManifestURLsExams(CurrentPatient: string);
var
  manifestURL: string;
  tmpstr: string;
  I: Integer;
  rNode, dNode, fNode, eNode, lNode, hNode: IXMLNode;
begin
  rNode := XMLManifests.DocumentElement;
  if rNode.HasChildNodes then begin
    for I := 0 to rNode.ChildNodes.Count - 1 do begin
      dNode := rNode.ChildNodes[i];
      fNode := dNode.ChildNodes['feed'];
      if fNode <> nil then begin
        eNode := fNode.ChildNodes['entry'];
        if eNode <> nil then begin
          lNode := eNode.ChildNodes['link'];
          if lNode <> nil then begin
            hNode := lNode.AttributeNodes['href'];
            if hNode <> nil then begin
              ManifestURL := hNode.Text;
              CcrGetManifestDoc(ManifestURL);
              Application.ProcessMessages;                                      // Allow broker keep-alives
              getPatientExamsFromManifestDocs(CurrentPatient);
            end;
          end;
        end;
      end;
    end;
  end;
end;

procedure TfrmvlerCCRExams.LimitToPatient(CurrentPatient: string);
var
  itIndex, itIndex2: integer;
  curPat: string;
begin
  itIndex := 0;
  curPat := '';

  lbxIpr.Items.BeginUpdate;
  try
    while (curPat <> CurrentPatient) do
    begin
      curPat := curPatAtIx(itIndex);
      if curPat = '' then break;
      if (curPat <> CurrentPatient) then begin
        RemoveAllSubNodesAtIx(itIndex);
        RemoveRootRecordAtIx(itIndex);
      end;
    end;

    if (curPat = CurrentPatient) then
      while (curPatAtIx(itIndex) = CurrentPatient) and (itIndex <= (lbxIpr.Items.Count - 1)) do inc(itIndex);

    for itIndex2 := lbxIpr.Items.Count - 1 downto itIndex do begin
      RemoveRecordAtIx(itIndex2);
    end;

  finally
    lbxIpr.Items.EndUpdate;
  end;
end;

(*
procedure TfrmvlerCCRExams.CcrGetExamResultByResultId(ResultObjId: string);
var
  strURL, strXml: string;
  strStationNo: String;
begin
  strStationNo :=  GetDivisionOfCBOC(frmMain.RPCBroker1.User.Division);
  strURL := TIdHTTPVler.GetVlerDasURL()
          + '/ecrud/v1/core/disabilityBenefitsQuestionnaires'
          + '?query='
          + '{'
          + '"cld:Claim.cld:CommonData.nc:Document.nc:DocumentIdentification.nc:IdentificationID":"'
          + ResultObjId
          //+ 'f1e0d785-ebb9-2988-26d0-ecb7583f294f'
          + '"';
          // TODO: LMS - Status of Pending-UnderReview
  strURL := strURL + ','
          + '"cld:Claim.cld:CommonData.nc:Document.nc:DocumentStatus.nc:StatusText":"Pending-UnderReview"'
          + '}';
          // DONE: LMS - Sort by Date Descending.
  strURL := strURL + '&sort={"cld:Claim.cld:CommonData.nc:Document.nc:DocumentCreationDate.nc:DateTime":-1}';
          // DONE: LMS - Limit Count to 1 - max records
  //strURL := strURL + '&limit=1';  Can't limit because a vendor might upload 2 results with same document creation date.
  //    We'll sort and remove it right here.
  try
    strXML := FHTTPServer.Get(TIdHTTPVler.URLParamsEncode(strURL){$IFDEF CAPRIDEVELOPER},[404,502]{$ENDIF});
    SaveStrXMLInFileAndXMLDoc(strXml, strStationNo, 'ExamResultFromVendor', docUUId, XMLResultFromVendor, PARAM_SAVE_XML);
    CcrFilterResultXMLForLatestUploadDate(strStationNo, 'ExamResultFromVendorFiltered', docUUId, XMLResultFromVendor, PARAM_SAVE_XML);
  except on
    e:EIdHTTPProtocolException do begin
      if e.ErrorCode = 404 then
        Raise Exception.CreateFmt('Bad Document UUID: %s.'#13#10'Encountered in Manifest ObjectID: %s.'#13#10'Can not continue.', [docUUId, manifObjID])
      else
        Raise;
    end;
  end;
end;
*)

procedure TfrmvlerCCRExams.CcrGetExamResultByDocId(docUUId: string; manifObjID: string);
var
  strURL, strXml: string;
  strStationNo: String;
begin
  strStationNo := GetDivisionOfCBOC(frmMain.RPCBroker1.User.Division);
  strURL := TIdHTTPVler.GetVlerDasURL()
    + '/ecrud/v1/core/disabilityBenefitsQuestionnaires'
    + '?query='
    + '{'
    + '"cld:Claim.cld:CommonData.nc:Document.nc:DocumentIdentification.nc:IdentificationID":"'
    + docUUId
          //+ 'f1e0d785-ebb9-2988-26d0-ecb7583f294f'
  + '"';
          // DONE: LMS - Status of Pending-UnderReview - VLER is down and can't test it.
  strURL := strURL + ','
    + '"cld:Claim.cld:CommonData.nc:Document.nc:DocumentStatus.nc:StatusText":"Pending-UnderReview"'
    + '}';
          // DONE: LMS - Sort by Date Descending.
  strURL := strURL + '&sort={"cld:Claim.cld:CommonData.nc:Document.nc:DocumentCreationDate.nc:DateTime":-1}';
          // DONE: LMS - Limit Count to 1 - max records
  //strURL := strURL + '&limit=1';  Can't limit because a vendor might upload 2 results with same document creation date.
  //    We'll sort and remove it right here.
  //             Also exam will have many versions and relying on DocumentCreationDate is a bad idea.
  //              uploadDate is expected to be much more suitable because, it doesn't depend on vendor provided value.
  try
    strXML := FHTTPServer.Get(TIdHTTPVler.URLParamsEncode(strURL){$IFDEF CAPRIDEVELOPER}, [404, 502]{$ENDIF});
    SaveStrXMLInFileAndXMLDoc(strXml, strStationNo, 'ExamResultFromVendor', docUUId, XMLResultFromVendor, PARAM_SAVE_XML);
    CcrFilterResultXMLForLatestUploadDate(strStationNo, 'ExamResultFromVendorFiltered', docUUId, XMLResultFromVendor, PARAM_SAVE_XML);
  except on
    e: EIdHTTPProtocolException do begin
      if e.ErrorCode = 404 then
        Raise Exception.CreateFmt('Bad Document UUID: %s.'#13#10'Encountered in Manifest ObjectID: %s.'#13#10'Can not continue.', [docUUId, manifObjID])
      else
        Raise;
    end;
  end;
end;

procedure TfrmvlerCCRExams.FetchAFileObjectFromFS(fsObjectID: string; fileFullNamePath: TFileName);
var
  ResponseToFile: TFileStream;
  AURL: string;
begin
  AURL := TIdHTTPVler.GetVlerDasURL()
    + '/ecrud/v1/core/fs/'
    + fsObjectID;
  try
    if FileExists(fileFullNamePath) then sysutils.DeleteFile(fileFullNamePath);
    ResponseToFile := TFileStream.Create(fileFullNamePath, fmCreate);
    try
      FHTTPServer.Get(TIdHTTPVler.URLParamsEncode(AURL), ResponseToFile{$IFDEF CAPRIDEVELOPER}, [502]{$ENDIF});
    finally
      ResponseToFile.Free;
    end;
  except
    on e: exception do
      raise;
  end;
end;

function TfrmvlerCCRExams.FetchAFileObjectFromVLERToString(collection: string; fsObjectID: string): string;
var
  AURL: string;
begin
  // Ideally This and other similar methods should be class methods, or instance methods of TIdHTTPVler class.
  AURL := TIdHTTPVler.GetVlerDasURL()
    + '/ecrud/v1/core/'
    + collection
    + '/'
    + fsObjectID
    ;
  Result := FHTTPServer.Get(TIdHTTPVler.URLParamsEncode(AURL){$IFDEF CAPRIDEVELOPER}, [502]{$ENDIF});
end;

procedure TfrmvlerCCRExams.FetchAFileObjectFromFSToStream(fsObjectID: string; ResponseToStream: TStream);
var
  AURL: string;
begin
  // Ideally This and other similar methods should be class methods, or instance methods of TIdHTTPVler class.
  AURL := TIdHTTPVler.GetVlerDasURL()
    + '/ecrud/v1/core/fs/'
    + fsObjectID;
  FHTTPServer.Get(TIdHTTPVler.URLParamsEncode(AURL), ResponseToStream{$IFDEF CAPRIDEVELOPER}, [502]{$ENDIF});
end;

function TfrmvlerCCRExams.getStatusDateText(AVLERDateNode: IXMLNode): string;
var
  aNode: IXMLNode;
  ChildNodeName: string;
  rootNodeName: string;
begin
  ChildNodeName := 'nc:DateTime';
  rootNodeName := 'vler:StatusDate';
  if AVLERDateNode.IsTextElement and (AVLERDateNode.NodeName = rootNodeName) then
    Result := AVLERDateNode.Text
  else begin
    aNode := FindNodeByNodeName(AVLERDateNode, ChildNodeName);
    if aNode <> nil then
      Result := GenericGetXMLNodeText(aNode);
  end;
end;

procedure TfrmvlerCCRExams.CcrFetchExamResultFile(docUUId: string; var ExamID: string; var ExamFileName: string; var ExamResultObjectId: string);
var
  fileToDownLoad: string;
  docElemNode, docNode, vler_StatusDateNode: IXMLNode;
  vler_ExamDetailNode: IXMLNode;
  vler_PhysicalSourceNode: IXMLNode;
  vler_ExamIdNode: IXMLNode;
  cld_AttachmentsNode: IXMLNode;
  atchIx: Integer;
  txtAttachNodeFound: boolean;
  AMemStream: TMemoryStream;
  vStatusDate: string;
  cld_ClaimNode: IXMLNode;
  cld_CommonData: IXMLNode;
  nc_AttachmentNode: IXMLNode;
  nc_BinaryFormatStandardNameNode: IXMLNode;
  docFSIdNode: IXMLNode;
begin
  //ExamFileName := ''; Initial counter value is now passed in.
  docElemNode := XMLResultFromVendor.DocumentElement;

  txtAttachNodeFound := false;
  if docElemNode.HasChildNodes then begin
    // temp debug **** Definitely remove comment from check in  *****
    {
    if docElemNode.ChildNodes.Count > 1 then
      Raise Exception.CreateFmt('Error: Multiple records found for Document UUID: %s.'#13#10'Can not continue.', [docUUId]);
      }

    docNode := docElemNode.ChildNodes[0];                                       // Taking the first document (assuming there is only one document returned).
    if docNode.NodeName = 'document' then begin
      docFSIdNode := docNode.ChildNodes['_id'];
      // nc:BinaryLocationURI, nc:BinaryFormatStandardName, nc:BinaryDescriptionText
      // vler_ExamDetailNode := docNode.ChildNodes['cld:Claim'].ChildNodes['cld:CommonData'].ChildNodes['vler:ExamDetail'];
      cld_ClaimNode := docNode.ChildNodes['cld:Claim'];
      // cld_ClaimNode := FindNodeByNodeName(docNode, 'cld:Claim'); if needed, can switch to this more generic way
      if cld_ClaimNode.ChildNodes.count > 0 then begin
        cld_CommonData := cld_ClaimNode.ChildNodes['cld:CommonData'];
      end;

      {if cld_CommonData.ChildNodes.count > 0 then begin
        vler_ExamDetailNode := cld_ClaimNode.ChildNodes['vler:ExamDetail'];
      end;}
      vler_ExamDetailNode := FindNodeByNodeName(cld_CommonData, 'vler:ExamDetail');

      if vler_ExamDetailNode = nil then
        Raise Exception.CreateFmt('Error getting Exam Detail for Document UUID: %s.'#13#10'Can not continue.', [docUUId]);

      //vStatusDate:= vler_ExamDetailNode.Text; // NodeValue;
      //vStatusDate:= vler_ExamDetailNode.NodeValue;
      //vStatusDate:= vler_ExamDetailNode.XML; // NodeValue;

      vler_PhysicalSourceNode := vler_ExamDetailNode.ChildNodes['vler:PhysicalSource'];
      vler_ExamIdNode := vler_ExamDetailNode.ChildNodes['vler:ExamId'];
      vler_StatusDateNode := vler_ExamDetailNode.ChildNodes['vler:StatusDate'];

      //cld_AttachmentsNode := docNode.ChildNodes['cld:Attachments'];   // doesn't work.
      cld_AttachmentsNode := FindNodeByNodeName(cld_ClaimNode, 'cld:Attachments');

      for atchIx := 0 to (cld_AttachmentsNode.ChildNodes.Count - 1) do begin
        nc_AttachmentNode := cld_AttachmentsNode.ChildNodes[atchIx];
        nc_BinaryFormatStandardNameNode := nc_AttachmentNode.ChildNodes['nc:BinaryFormatStandardName'];
        if (nc_BinaryFormatStandardNameNode.NodeValue = 'text/text')
          or (nc_BinaryFormatStandardNameNode.NodeValue = 'text/plain')
          then begin
          //txtAttachNode := nc_AttachmentNode;
          txtAttachNodeFound := true;
          break;
        end;
      end;
      if txtAttachNodeFound then begin
        vStatusDate := getStatusDateText(vler_StatusDateNode);
        if vStatusDate <> '' then begin
          vStatusDate := StripMSAndZFromISO8601(vStatusDate);

          ExamID := '';                                                         //  vler_ExamIdNode.Text; kept blank here, i.e. not duplicated. Only when a Genmed condition occurs, this property will be populated by the new ID created in VistA
          ExamFileName := vler_ExamIdNode.Text
            + '$' + vler_PhysicalSourceNode.Text
            + '$' + StringReplace(vStatusDate, ':', '#', [rfReplaceAll])        // fileDateTime ":" won't save on disk
            + '!' + ExamFileName                                                // for those scenarios where vendor sends 2 exam results for same original exam with same datetime. Here file name generated would clash with the other result. So we'll separate them on the file counter.
            + '.txt';
          fileToDownLoad := GetTempExmDir(frmMain.RPCBroker1.User.DUZ);
          fileToDownLoad := fileToDownLoad + '\' + ExamFileName;

          FetchAFileObjectFromFS(nc_AttachmentNode.ChildNodes['nc:BinaryLocationURI'].Text, fileToDownLoad);
        end;
      end;
      ExamResultObjectId := docFSIdNode.Text;
    end;
  end;
  // temp debug **** Definitely remove comment from check in
  {
  if result = '' then
    Raise Exception.CreateFmt('Error getting Text Attachment for Document UUID: %s.'#13#10'Can not continue.', [docUUId])
    }
end;

procedure TfrmvlerCCRExams.getNodeAndCheckValidDate(var nextUploadDate: string; var nextNode: IXMLNode; aDocNode: IXMLNode);
begin
  //if docNode.NodeName = 'document' then begin   // assume this structure and proper uploadDate element and also an _id element. If not, let it error out
  nextNode := aDocNode.ChildNodes['uploadDate'];
  nextUploadDate := nextNode.Text;
  if nextUploadDate = '' then
  begin
    nextNode := aDocNode.ChildNodes['_id'];
    if nextNode = nil then
      Exception.Create('Catastrophic Error: _ID node Missing.')
    else
      Exception.CreateFmt('Node with blank uploadDate Encountered with ID: %s', [nextNode.Text]);
  end;
end;

procedure TfrmvlerCCRExams.CcrFilterResultXMLForLatestUploadDate(strStationNo: string; filePrefix: string; docUUId: string; AXMLDom: TXMLDocument; SaveLoaded: Boolean = false);
var
  firstNode, nextNode: IXMLNode;
  docElemNode: IXMLNode;
  strXml: string;

  aDocNode: IXMLNode;

  firstUploadDate: string;
  nextUploadDate: string;
begin
  docElemNode := AXMLDom.DocumentElement;
  if docElemNode.ChildNodes.Count > 0 then                                      // breakpoint for docElemNode.ChildNodes.Count > 1
  begin
    aDocNode := docElemNode.ChildNodes[0];
    getNodeAndCheckValidDate(firstUploadDate, firstNode, aDocNode);

    while (docElemNode.ChildNodes.Count > 1) do
    begin
      aDocNode := docElemNode.ChildNodes[1 {ix}];
      getNodeAndCheckValidDate(nextUploadDate, nextNode, aDocNode);
      if (firstUploadDate < nextUploadDate) then begin
        docElemNode.ChildNodes.Delete(0 {ix-1});
        firstUploadDate := nextUploadDate;
        firstNode := nextNode;
      end else begin
        docElemNode.ChildNodes.Delete(1 {ix})
      end;
    end;

    strXml := AXMLDom.XML.Text;
    // Now AXMLDom has been filtered to one record with highest "uploadDate"
    SaveStrXMLInFileAndXMLDoc(strXml, strStationNo, filePrefix, docUUId, AXMLDom, SaveLoaded);
  end;
end;

procedure TfrmvlerCCRExams.GetExamResultByID2DOM(exResultID: string; XMLResultFromVendor: TXMLDocument);
var
  strStationNo: string;
  strXml: string;
begin
  strStationNo := GetDivisionOfCBOC(frmMain.RPCBroker1.User.Division);
  // TfrmvlerCCRExams.EnsurefrmvlerCCRExamsReady(frmvlerCCRExams);          // rpk 10/23/2014, unnecessary
  try
    // strXML := frmvlerCCRExams.FetchAFileObjectFromVLERToString('disabilityBenefitsQuestionnaires', exResultID);
    strXML := FetchAFileObjectFromVLERToString('disabilityBenefitsQuestionnaires', exResultID); // rpk 10/23/2014

    SaveStrXMLInFileAndXMLDoc(strXml, strStationNo, 'ResultByID', exResultID, XMLResultFromVendor, PARAM_SAVE_XML);
  except
    on e: exception do
      raise;
  end;
end;

procedure TfrmvlerCCRExams.FetchAllExamsTextToFiles(var ResList: TList);        // var is unnecessary. It's just informational, i.e. we're adding objects to the list.
var
  AExamInfo: TVLERExamInfo;
  // BExamInfo: TVLERExamInfo;
  ix: integer;
  AEObj: TObject;
  ManifInProcessList: TStringList;
  fileCount: integer;
begin
  fileCount := 0;
  ManifInProcessList := TStringList.Create;
  // ManifInProcessList.Sorted := true;
  //ManifInProcessList.Duplicates := dupIgnore;
  try
    ix := 1;                                                                    // skip top level
    while (ix <= (lbxIpr.Items.Count - 1)) do
    begin
      AEObj := lbxIpr.Items.Objects[ix];
      if AEObj <> nil then begin
        if AEObj is TVLERExamInfo then begin
          AExamInfo := TVLERExamInfo(AEObj);
          if AExamInfo.DocumentUUID <> '' then begin
            if ManifInProcessList.IndexOf(AExamInfo.ManifestObjectId) < 0 then begin
              SetManifestStatus(AExamInfo.ManifestObjectId, 'InProcess+' + GetVistATimestampUTC(frmMain.RPCBroker1), 'Open');
              // DONE -cNotToDo : lms - handle error conditions in setting status. NO let error come up the stack.
              ManifInProcessList.Add(AExamInfo.ManifestObjectId);
            end;
            CcrGetExamResultByDocId(AExamInfo.DocumentUUID, AExamInfo.ManifestObjectId);
            //AExamInfo.ExamFileName := CcrFetchExamResultFile(AExamInfo.DocumentUUID);
            AExamInfo.ExamFileName := intToStr(fileCount);                      // send in file counter
            CcrFetchExamResultFile(AExamInfo.DocumentUUID, AExamInfo.ExamID, AExamInfo.ExamFileName, AExamInfo.ExamResultObjectId);
            if AExamInfo.ExamFileName = intToStr(fileCount) then                // no text was found
              AExamInfo.ExamFileName := '';
            inc(fileCount);
          end;
        end;
      end;
      inc(ix);
    end;
  finally
    if ManifInProcessList <> nil then if ManifInProcessList.count > 0 then ResList.Insert(0, ManifInProcessList); // ManifInProcessList.Free;
  end;
  {
  if AExamInfo <> nil then begin   // add a duplicate for test / debug *****
    BExamInfo := TVLERExamInfo.Create;
    BExamInfo.CopyFrom(AExamInfo);
    lbxIpr.Items.AddObject(lbxIpr.Items[ix-1], BExamInfo);
  end;
  if AExamInfo <> nil then begin   // add a duplicate for test / debug *****
    BExamInfo := TVLERExamInfo.Create;
    BExamInfo.CopyFrom(AExamInfo);
    lbxIpr.Items.AddObject(lbxIpr.Items[ix-1], BExamInfo);
  end;
  if AExamInfo <> nil then begin   // add a duplicate for test / debug *****
    BExamInfo := TVLERExamInfo.Create;
    BExamInfo.CopyFrom(AExamInfo);
    lbxIpr.Items.AddObject(lbxIpr.Items[ix-1], BExamInfo);
  end;
  }
end;

{
procedure TfrmvlerCCRExams.RemoveDupeNotificForSameExams;
var
  AExamInfo : TVLERExamInfo;
  ix : integer;
  AEObj : TObject;
  aStrList : TStringList;
  curFile: string;
  prevFile: string;
begin
  exit;  // not needed most likely.  ***
  //  TODO : LMS  ******
  // Look for newest date if same exam exists twice.
  // put in a temp tstringlist, sort it but duplicates allowed. And then remove all old.
  ix := 1;  // skip top level
  aStrList := TStringList.Create;
  aStrList.Sorted := false;
  try
    while (ix <= (lbxIpr.Items.Count - 1)) do
    begin
      AEObj := lbxIpr.Items.Objects[ix];
      if AEObj <> nil then begin
        if AEObj is TVLERExamInfo then begin
          AExamInfo := TVLERExamInfo(AEObj);
          if AExamInfo.ExamFileName <> '' then begin
            aStrList.Add(AExamInfo.ExamFileName + '^' + intToStr(ix));
            // AExamInfo.ExamFileName := CcrFetchExamResultFile(AExamInfo.DocumentID);
          end;
        end;
      end;
      inc(ix);
    end;
    aStrList.Sort;
    ix := aStrList.Count - 1;
    while ix <= aStrList.Count - 1 do begin   // TODO: ***** Logic needs to be checked.
      curFile := aStrList[ix];
      if ix > 0 then begin
        prevFile := aStrList[ix-1];
        if piece(curFile,'$',1) = piece(prevFile,'$',1) then begin   // duplicate, older result. Remove.
          RemoveRecordAtIx(strToInt(piece(prevFile,'^',Occurrences('^',prevFile))));
          aStrList.Delete(ix-1);
        end
      end;
      dec(ix);
    end;
  finally
    aStrList.Free;
  end;
end;
}

procedure TfrmvlerCCRExams.FillExamResultList(var ResList: TList);              // var is unnecessary
var
  aResultListNode: TVlerResultFileInfo;
  AExamInfo: TVLERExamInfo;
  ix: integer;
  AEObj: TObject;
begin
  //ix := 1;  // skip top level
  ix := 0;
  while (ix <= (lbxIpr.Items.Count - 1)) do
  begin
    AEObj := lbxIpr.Items.Objects[ix];
    if AEObj <> nil then begin
      if AEObj is TVLERExamInfo then begin
        AExamInfo := TVLERExamInfo(AEObj);
        if AExamInfo.ExamFileName <> '' then begin
          aResultListNode := TVlerResultFileInfo.Create(nil);                   // The List Owner has to destroy these.
          aResultListNode.FileName := AExamInfo.ExamFileName;                   // DONE: Get the actual exam result XML downloaded and put its name here.      //aNode.FileDateTime  Not used
          aResultListNode.ExamName := AExamInfo.ExamName;
          aResultListNode.ExamResultObjectId := AExamInfo.ExamResultObjectId;
          aResultListNode.ManifestObjectId := AExamInfo.ManifestObjectId;
          ResList.Add(aResultListNode);
        end;
      end;
    end;
    inc(ix);
  end;
end;

end.

