Unit main;

// April 2007
// NOTE ----------------------------
// Changes to support CAPRI, remote logins exist in the RPC Broker units
// TRPCB and CCOWRPCBROKER
// All changes can be found by searching for DVB and ANU.

// JANUARY 30, 2005 *****

// Added "details" button to memo boxes on PNCS templates.  The button will
// display a larger pop up, allowing users more room to enter and view their
// responses

// Added/enabled CCOW patient context functionality.

// Added the ability to remove or add forms to a PNCS template, even after the
// user has already started using the template.

// FEBRUARY 6, 2005 *****

// Script processing mods to speed up some repetitive processes in the script
// engine

// Updated CPWMObjects with Ed's fix to properly execute script when switching
// to a tab only used by one form.  The script didn't kick off if a different
// form was in use, then then user switches to another tab but it automatically
// switches to a different form because the previous form didn't have that tab.

// Cancel feature added for templates

// Save has been updated to first save to a failsafe location, then the real
// location.  This prevents lost data if there is a network failure.
// There should always be something, even if it's the previous version of
// the saved form

// FEBRUARY 14, 2005
// Added news feature in lower right of main CAPRI window
// Icon should change when new news and when it's all been read

// FEBRUARY 15,2005
// Templates can no longer be overlayed on top of an exam in AMIE that's in an
// open state and is in the middle of being transcribed.  This glitch was
// reported by a site testing of DVBA*2.7*71.

// FEBRUARY 16, 2005
// Cancel feature added to templates

// FEBRUARY 17, 2005
// Redundant save added to form save process.
// On restart, the user will be prompted for a backup version to load
// if there is a problem saving and a form being saved doesn't get
// stored in VistA.
// Using the delete button on the keyboard to delete a template was
// causing an exception

// FEBRUARY 18, 2005
// Record locking implemented.
// A template can now only be opened by one user at a time.

// FEBRUARY 22, 2005
// News function now goes directly to the CPEP webserver.

// MARCH 1, 2005
// Added VHA report to view template list, including status

// MARCH 2, 2005
// Modified VHA template report to include sort criteria

// MARCH 3,2005
// Added option to select a font in the VistA terminal
// VistA terminal will remember last font, font size, window size, window
// position if CAPRI is exited normally.
// Added option to exclude "completed" exams from the VHA template report.

// MARCH 4, 2005
// 1U4N (1st letter last name + last 4 of SSN) has been added
// as an identifier in the unsigned forms dialog

// MARCH 9, 2005
// Ability to edit address on admin tab and when entering a new C&P has
// been removed.  Instead, address changes will be copied into the text of
// the C&P request.

// MARCH 10, 2005
// Copy template button added to C&P Worksheet tab.

// There is a new tool to restore from a previous form.  It's under "OPTIONS."  Autosave will create a restore point.
// The user can create their own restore point with the "save" button.  All restore points will be deleted once the form is signed.

// MARCH 15, 2005
// Save/load function in a template saves the color info with control data
// Load feature fixed.  Some controls weren't populating correctly
// Info button in a template will show in what version of CAPRI the form
// was last saved.

// MARCH 17, 2005
// Patient entry now runs a routine to check for potential matches
// User can cancel or continue after display.

// MARCH 2, 2005
// Added code to deal with TIU blank character string of "***".
// Some templates were displaying the message about the document having
// blanks (Joints, for example) when the site had set their string to
// "***" in TIU.

// MARCH 23
// Faster form startup.
// Resolved issue of flickering hourglass during firstrun and lastrun
// script processing.
// It was possible to click a button, then click another one but the first one hadn't
// been processed yet.  Changed it to ignore subsequent buttons until the first is processed.

// MARCH 28
// Modified co-signature transfer option to not allow transfer into an exam
// if there's already data there.  This probably means the note is in
// the middle of being transcribed.

// APRIL 1
// Seattle is concerned non C&P alerts are showing in the co-signature
// alert window.  Logic was added to filter for just C&P ones.  It's the same
// logic used on the signature screen to look for C&P titles.

// APRIL 7
// VBA wants a way to add a date of address info when entering a new C&P
// and telling it there's an address change

// APRIL 11
// Shawnta found an issue where address could still be edited on the admin tab
// Address edit has been disabled but not removed, in case VBA changes its mind
// Changed label "1U4N" to "ID" on the unsigned forms dialog.

///////////////////////////////////////////////////////////////////

// The things below will are in this version but will be disabled until
// the next version of CAPRI

// APRIL 11
// Under tools, edit C&P reports for the loaded pt. has been added.
// Allows re-opening of released exams so they can be edited and
// re-printed or release of open exams still needing release.

////////////////////////////////////////////////////////////////////
//
// APRIL 22
// Timeout was being read from the connected site when switching sites.
// This was overriding the Claims system timeout value.

// TEST SITE ISSUES:

// April 25:
// Remedy Ticked 106388 by VBA.  Duplex printing is difficult and non-functional.
// A new printers dialog box was added that will pop up anytime something is
// printed.

// June 2005 changes

// Spell check function has been added.  Access it with F7.  It'll spellcheck an
// active control, IF it's a type it's been allowed to check.  If it's a read-only
// control (like progress notes on the clinical document tab), it'll still check the\
// spelling but then warn the user it can't overwrite the text.  This is by design.

// Variables for running forms will be saved between sessions.  If you save a form
// and look at it in VistA, you'll see the variable info at the beginning of the
// saved form file

// When a new template is started, an autosave kicks off immediately so something
// will show if the user tries to revert to an old version.

// Medical Opinion form can be added with a checkbox.

// Details popus on CPWM forms modified to let the user change the height, move them, etc.
// Spellcheck added to details popup
// Details popup changed to not close until user chooses to close it

//  Rich click menu added to forms for memos and edit boxes to support spell check

// Added training website to help menu

// Report text of CPWM Form has been highlighted with colors to make user
// vs. prompt text stand out.

// July 2005 Changes

// Fixed date calculation on "special" report type used by VBA on reports dialog.

// CAPRI will autodetect conflicting CPWM keys at startup and display a warning to the user.

// Data was being lost during cloning of objects on merged forms, when objects matched.

// RTF Support added to CPWM Reports

// RTF Printing Support added to CPWM print preview screen

// Wilmington was not showing in the division list due to changes made in the national instution file
// It will be forced into the list.

// Errors with division setting function when first connecting to a site have been
// fixed.

// August 2005 Changes

// Sped up script processing.  Certain commands, like the goto command, were inefficient

// Cache latitude and longitude for zipcode distance lookup when entering a new C&P
// request.  Kansas was having a problem for slowness.  Once a lat/long is found, it'll be
// saved for later reference, which speeds up the distance calculation process
// considerably.

// 200HD, HDR is showing in the other facilities visited list.  It's not really a VistA
// system that CAPRI can switch to.  It's been removed from the list but will still
// show on the "additional treating facilities" report on the reports tab.

// Stephenie Wallace (Tuscaloosa) requested the alerts dialog be changed to split up
// unsigned templates into draft, awaiting signature, and sent back.

// Zach found a problem wherein a user needing co-signature would get a box popping up
// at signature telling them they haven't selected enough exams to close out.  But they
// can't because they need co-signer.  The box was removed if co-signer is selected.

// Oct 2005
// Created a way to manage/import templates under TOOLS.  Need to have a high level
// security key to access it.

// Added Hyperlink to AMIE Worksheets under TOOLS.  Address is retrieved with new Broker call
// DVBAB GET URL, param 1
// Routine is DVBABURL

// October 2005
// Saved forms will restore back with the screen exactly as it was when the user left.  Popup
// panels and tabs will be right where they were.   Autosave doesn't save the screen due to the
// overhead involved.  The save screen only happens at exit or if the user clicks the "save" button.

// Added a way to print a blank template under Options and under TOOLS on the main menu.

Interface

Uses
  Windows,
  Messages,
  Buttons,
  //CCOWRPCBroker,
  CheckLst,
  Classes,
  ColorCapriBtn,
  ComCtrls,
  ComCtrls95,
  Controls,
  Diaccess,
  Dialogs,
  DialogsCAPRI,
  DiTypLib,
  ExtCtrls,
  FileCtrl,
  Fmcmpnts,
  Fmcntrls,
  Forms,
  GIFImage,
  Graphics,
  Grids,
  hash,
  HyperlinkLabel,
  ImgList,
  IPTerm,
  JclDateTime,
  jpeg,
  KernelUtilities,
  LoginFrm,
  Menus,
  mergePScripts,
  OffBtn,
  OleCtrls,
  OleServer,
  ORCtrls,
  ORDtTm,
  pncsCodeRun,
  PNCSMain,
  SHDocVw,
  SpeechLib_TLB,
  StdCtrls,
  SysUtils,
  TabNotbk,
  Trpcb,
  uSpell,
  UUCode,
  Vawrgrid,
  VERGENCECONTEXTORLib_TLB,
  ZipMcpt, CCOWRPCBrokerCAPRI, CCOWRPCBroker, ActnList, XPStyleActnCtrls,
  ActnMan, ToolWin, ActnCtrls, ActnMenus, ActnPopup,
  ShellAPI,
  Jcl   ug,
  patientlist, ORCtrlsVA508Compatibility, AccessibilityUtils,
  VA508AccessibilityManager, VAUtils,                                           //CodeCR124 -MER 07/2010
  ReflectionWrapper,
  frmVVA,                                                                       {CodeCR353 - rpm 5/1/12}
  VocRehabClass,                                                                //CodeCR347 - jrl 5/21/12
  CAPRIHelpMgr,                                                                 // CodeCR381 - LMS 2012-11-15
  Patient,
  clsPatientInfo, AppEvnts                                                      // CodeCR457 - LMS
//  , FrmVlerGetExam  // moved to Implementation; rpk 9/12/2014
  ;

  // moved TPatientInfoBucket to fPatient // rpk 7/15/2014
{ type
  TPatientInfoBucket = class(TObject)
    public
    DFN, Name, SSN, DOB, AGE, SEX, DOD, ClaimNum: String;
    NameComponents, Last, First, Middle: String;
    Address1, Address2, Address3, City, StateProv, Zip, Country: String;
    HomePhone, CellPhone, BadAddressType, AddrssType: String;
    VTRN: Boolean;
  end; }

Type
  TSearchText = record                    // CodeCR696 JRL 4/8/15
     FoundAt : Integer;                   // CodeCR696 JRL 4/8/15
     LastSearchFoundAt : Integer;         // CodeCR696 JRL 4/8/15
     FindText : String;                   // CodeCR696 JRL 4/8/15
     Options : Set Of TSearchType;        // CodeCR696 JRL 4/8/15
   end;                                   // CodeCR696 JRL 4/8/15

  TfrmMain = Class(TForm)
    AdminDocuments: TTab95Sheet;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtnCCOWLink: TBitBtn;
    BitBtnCCOWLinkBroken: TBitBtn;
    BitBtnCCOWLinkChanging: TBitBtn;
    BitBtnLaunchVistaWeb: TBitBtn;
    BitBtnNewForm: TBitBtn;
    BitBtnUnsignedForms: TBitBtn;
    BitBtnVistA: TBitBtn;
    btnAdd7131: TButton;
    btnAddRequest: TButton;
    btnAdHoc: TButton;
    btnAdmissions: TButton;
    btnAll: TButton;
    btnDivisions: TButton;
    btnDocsRefresh: TButton;
    btnEditAddress: TButton;
    btnExamFinalReport: TButton;
    btnFuture: TButton;
    btnGenerate7131Report: TButton;
    btnGenerateReport: TButton;
    btnGraphVS: TButton;
    btnLoadHSNames: TButton;
    btnLoadHSNamesRemoteData: TButton;
    btnMulti: TBitBtn;
    btnMulti2: TBitBtn;
    btnPast: TButton;
    btnRefreshAddress: TButton;
    btnSaveAddress: TButton;
    btnView7131: TButton;
    btnViewExam: TButton;
    btnVistAWebHome: TBitBtn;
    Button1: TButton;
    Button13: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button9: TButton;
    buttonCancelReportAdmission: TButton;
    ButtonCancelSurgeryReports: TButton;
    buttonClinDocDateRange: TButton;
    ButtonCountyAccept: TButton;
    ButtonCPTCopyright: TButton;
    ButtonGCPRGo: TButton;
    ButtonGraph: TButton;
    ButtonIPRCopy: TButton;
    ButtonIPRDelete: TButton;
    ButtonIPRDisplay: TButton;
    ButtonIPRRefresh: TButton;
    buttonNews: TBitBtn;
    buttonNewsFlash: TBitBtn;
    buttonOKReportAdmission: TButton;
    ButtonOKSurgeryReports: TButton;
    ButtonOtherSites: TButton;
    ButtonRDV: TButton;
    ButtonSearch: TButton;
    ButtonStateAccept: TButton;
    CheckBoxMailman: TCheckBox;
    CheckListBoxRemoteData: TCheckListBox;
    CNumber: TLabel;
    ComboBoxHSSections: TComboBox;
    CountyFake: TEdit;
    DateTimePicker1: TDateTimePicker;
    DateTimePicker2: TDateTimePicker;
    EditDODMaxItems: TEdit;
    editSearchPN: TEdit;
    ExamRequestRefresh: TButton;
    FMCommentsMemo: TFMMemo;
    FMCountiesList: TFMListBox;
    FMEdit1: TFMEdit;
    FMEdit10: TFMEdit;
    FMEdit11: TFMEdit;
    FMEdit2: TFMEdit;
    FMEdit3: TFMEdit;
    FMEdit4: TFMEdit;
    FMEdit5: TFMEdit;
    FMEdit6: TFMEdit;
    FMEdit7: TFMEdit;
    FMEdit8: TFMEdit;
    FMEdit9: TFMEdit;
    FMEditCity: TFMEdit;
    FMEditCounty: TFMEdit;
    FMEditEpisodeBeginDateTime: TFMEdit;
    FMEditEpisodeEndDateTime: TFMEdit;
    FMEditFacilityMovementType: TFMEdit;
    FMEditIPR10: TFMEdit;
    FMEditIPR11: TFMEdit;
    FMEditIPR2: TFMEdit;
    FMEditIPR4: TFMEdit;
    FMEditIPR5: TFMEdit;
    FMEditIPR6: TFMEdit;
    FMEditIPR7: TFMEdit;
    FMEditIPR8: TFMEdit;
    FMEditIPRExe: TFMEdit;
    FMEditMovementAttending: TFMEdit;
    FMEditMovementDateTime: TFMEdit;
    FMEditMovementProvider: TFMEdit;
    FMEditMovementRoomBed: TFMEdit;
    FMEditMovementSpecialty: TFMEdit;
    FMEditMovementType: TFMEdit;
    FMEditMovementTypeofMovement: TFMEdit;
    FMEditMovementWardLocation: TFMEdit;
    FMEditOffice: TFMEdit;
    FMEditPhone: TFMEdit;
    FMEditReviewStatus: TFMEdit;
    FMEditState: TFMEdit;
    FMEditStreet1: TFMEdit;
    FMEditStreet2: TFMEdit;
    FMEditStreet3: TFMEdit;
    FMEditZip: TFMEdit;
    FMExamHistory: TFMLister;
    FMExamRequestListbox: TFMListBox;
    FMExamRequestLister1: TFMLister;
    FMFiler1: TFMFiler;
    FMFiler2: TFMFiler;
    FMFinder1: TFMFinder;
    FMFinder2: TFMFinder;
    FMGets1: TFMGets;
    FMGets2: TFMGets;
    FMGets3: TFMGets;
    FMGets4: TFMGets;
    FMGets5: TFMGets;
    FMGets6: TFMGets;
    FMGetsAddRequest: TFMGets;
    FMGetsCAPRIDivision: TFMGets;
    FMGetsDrugFile: TFMGets;
    FMGetsFacilityMovementType: TFMGets;
    FMGetsHospitalLocation: TFMGets;
    FMGetsInstitution: TFMGets;
    FMGetsIPRFile: TFMGets;
    FMGetsIPRFile3: TFMGets;
    FMGetsMedicalCenterDivision: TFMGets;
    FMGetsMovementType: TFMGets;
    FMGetsNewPerson: TFMGets;
    FMGetsPatientMovement: TFMGets;
    FMGetsPtAddress: TFMGets;
    FMGetsTemplateInfo: TFMGets;
    FMGetsTIU: TFMGets;
    FMListBoxAdmission: TFMListBox;
    FMListBoxCAPRITools: TFMListBox;
    FMListBoxIPR1: TFMListBox;
    FMListBoxMedicalCenterDivision: TFMListBox;
    FMListBoxOrderInfo: TFMListBox;
    FMListBoxVADrugClass: TFMListBox;
    FMLister1: TFMLister;
    FMListerAdmissions: TFMLister;
    FMListerCAPRITools: TFMLister;
    FMListerCounties: TFMLister;
    FMListerExams: TFMLister;
    FMListerIPR1: TFMLister;
    FMListerMedicalCenterDivision: TFMLister;
    FMListerOrderInfo: TFMLister;
    FMListerStates: TFMLister;
    FMListerUserKeys: TFMLister;
    FMListerVADrugClass: TFMLister;
    FMMemoFormDefinition: TRichEdit;
    FMMemoMovementDiagnosis: TFMMemo;
    FMMemoReportDefinition: TRichEdit;
    FMMemoScriptDefinition: TRichEdit;
    FMRegionalOfficeNumber: TFMComboBox;
    FMRegionalOfficeNumberFake: TFMEdit;
    FMSeventyOne31Lister1: TFMLister;
    FMSeventyOne31RequestListbox: TFMListBox;
    FMStatesList: TFMListBox;
    FMUserName: TFMLabel;
    FMValidator1: TFMValidator;
    FontDialog1: TFontDialog;
    FormData: TFMMemo;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    HeaderControlDoDAllergies: THeaderControl;
    HeaderControlDODConsults: THeaderControl;
    HeaderControlDODDCS: THeaderControl;
    HeaderControlDODLRC: THeaderControl;
    HeaderControlDODLRCY: THeaderControl;
    HeaderControlDODMI: THeaderControl;
    HeaderControlDoDPNs: THeaderControl;
    HeaderControlDODRR: THeaderControl;
    HSMemo: TRichEdit;
    HSMemoLocal: TRichEdit;
    Image1: TImage;
    ImageFlagExclamation: TImage;
    ImageFlagFlag: TImage;
    ImageFlagNew: TImage;
    ImageVistaRed: TImage;
    IPRLocation: TEdit;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label2: TLabel;
    Label20: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label29: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    LabelActiveControl: TLabel;
    LabelCurrentView: TLabel;
    LabelDivision: TLabel;
    LabelDOB: TLabel;
    LabelDocsFound: TLabel;
    LabelDoDInfo: TLabel;
    LabelGridHeader: TLabel;
    LabelICN: TLabel;
    labelReportChoice: TLabel;
    LabelReportChoice2: TLabel;
    lbHealthSummaryList: TListBox;
    lblAddress: TLabel;
    lblApptStatus: TLabel;
    lblCity: TLabel;
    lblCounty: TLabel;
    lblOffice: TLabel;
    lblPhone: TLabel;
    lblState: TLabel;
    lblZip: TLabel;
    ListBoxIPR1: TListBox;
    ListBoxRemoteData: TListBox;
    ListBoxRemoteDataPending: TListBox;
    ListBoxRestrictedPatients: TListBox;
    lstDocs: TORListBox;
    lstInstitutions: TListBox;
    MailManBuffer: TMemo;
    MemoAppointments: TRichEdit;
    memoClinDocument: TMemo;
    MemoCPTCopyright: TMemo;
    memoDocs: TRichEdit;
    MemoNameAddressHolder: TMemo;
    MemoPrint: TRichEdit;
    MiniZip1: TMiniZip;
    ORHealthSummaryUserList: TORListBox;
    ORListBoxDODReportTypes: TORListBox;
    ORListBoxSurgeryReports: TORListBox;
    ORReportsAvailable: TORListBox;
    Page95Control1: TPage95Control;
    Panel1: TPanel;
    Panel10: TPanel;
    Panel11: TPanel;
    Panel12: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    Panel9: TPanel;
    PanelAppointments: TPanel;
    panelCount: TPanel;
    PanelDivision: TPanel;
    panelDocs: TPanel;
    PanelDODGrids: TPanel;
    PanelFHIEOptions: TPanel;
    PanelGraphVS: TPanel;
    PanelHSReport: TPanel;
    PanelRemoteData: TPanel;
    panelReportChoice: TPanel;
    panelReportChoice2: TPanel;
    panelSearch: TPanel;
    PanelSurgeryReports: TPanel;
    PopupMenuImages: TImageList;
    PrintDialog1: TPrintDialog;
    PrinterSetupDialog1: TPrinterSetupDialog;
    ProgressBarLoadPt: TProgressBar;
    ReportMemo: TRichEdit;
    RichEditDODReport: TRichEdit;
    RichEditDODTempReport: TRichEdit;
    RichEditFormEvents: TRichEdit;
    RichEditReport: TRichEdit;
    RPCBroker1: TCCOWRPCBrokerCAPRI;
    RPCBrokerDoD: TCCOWRPCBrokerCAPRI;
    ScrollBoxAddress: TScrollBox;
    SeventyOne31RequestRefresh: TButton;
    Shape1: TShape;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    Splitter3: TSplitter;
    Splitter4: TSplitter;
    Splitter5: TSplitter;
    Splitter6: TSplitter;
    Splitter7: TSplitter;
    SpVoice1: TSpVoice;
    StateFake: TEdit;
    StatusBarLoadPt: TLabel;
    Tab7131Request: TTab95Sheet;
    Tab95Control1: TTab95Control;
    Tab95Control2: TTab95Control;
    Tab95Control3: TTab95Control;
    TabClinicalDocuments: TTab95Sheet;
    TabCPExams: TTab95Sheet;
    TabCPWorksheets: TTab95Sheet;
    TabDOD: TTab95Sheet;
    TabHealthSummaries: TTab95Sheet;
    TabReports: TTab95Sheet;
    TabVistAWeb: TTab95Sheet;
    TimeoutTimer: TTimer;
    TimerFHIERunning: TTimer;
    TimerHalt: TTimer;
    TimerInfoBox: TTimer;
    TimerInitialConnection: TTimer;
    TimerNews: TTimer;
    TimerRemoteData: TTimer;
    VAWrapGridDOD: TVAWrapGrid;
    WebBrowser1: TWebBrowser;
    xFMEditObjectCount: TFMEdit;
    xFMTemplatesUtilized: TFMMemo;
    xHyperlinkLabel1: THyperlinkLabel;
    GIFImageVistaYellow: TImage;
    ActionManMain: TActionManager;
    actFileConnect: TAction;
    actFileSwitchSites: TAction;
    actFileSelectPatient: TAction;
    actFileReports: TAction;
    actFilePrint: TAction;
    actFilePrintPreview: TAction;
    actFilePrinterSetup: TAction;
    actFileQuit: TAction;
    actEditUndo: TAction;
    actEditCut: TAction;
    actEditCopy: TAction;
    actEditPaste: TAction;
    actEditSelectAll: TAction;
    actToolsAMIE: TAction;
    actToolsPrintBlankExam: TAction;
    actToolsBringExamToFront: TAction;
    actToolsMacroEditor: TAction;
    actToolsUnsignedWorkSheets: TAction;
    actToolsUncosignedDocs: TAction;
    actToolsNews: TAction;
    actToolsVista: TAction;
    actToolsSearch: TAction;
    actToolsProperties: TAction;
    actToolsChangeAddress: TAction;
    actToolsEditEsig: TAction;
    actToolsEditCPReports: TAction;
    actToolsExamListParameters: TAction;
    actToolsCPRSCosigUtil: TAction;
    actToolsManageTemplateDef: TAction;
    ActionMainMenuBar1: TActionMainMenuBar;
    actDevEditUserKeys: TAction;
    actDevThrowExcept: TAction;
    actDevUserKeys: TAction;
    actHelpAbout: TAction;
    actHelpCAPRITraining: TAction;
    actHelpAuditUtil: TAction;
    actHelpCheckConnections: TAction;
    actHelpConsReports: TAction;
    actHelpEditRemoteUser: TAction;
    actHelpEditPatientLists: TAction;
    actHelpRPCBrokerHistory: TAction;
    actToolsExternalApps: TAction;
    actPopTempDelete: TAction;
    actPopTempTogNew: TAction;
    actPopTempTogGreen: TAction;
    actPopTempTogExclamation: TAction;
    actPopReadOnlyCopy: TAction;
    actPopReadOnlySelectAll: TAction;
    actPopEditUndo: TAction;
    actPopEditCut: TAction;
    actPopEditCopy: TAction;
    actPopEditPaste: TAction;
    actPopEditDelete: TAction;
    actPopEditSelectAll: TAction;
    actPopEditCheckSpelling: TAction;
    actPopEditLoadExam: TAction;
    mnuPopTemplate: TPopupActionBar;
    mnuPopTempDelete: TMenuItem;
    menuPopTempN1: TMenuItem;
    mnuPopTempTogNew: TMenuItem;
    mnuPopTempTogGreen: TMenuItem;
    mnuPopTempTogExclamation: TMenuItem;
    mnuPopReadOnly: TPopupActionBar;
    mnuPopReadOnlyCopy: TMenuItem;
    mnuPopReadOnlySelectAll: TMenuItem;
    mnuPopEdit: TPopupActionBar;
    mnuPopEditUndo: TMenuItem;
    mnuPopEditN1: TMenuItem;
    mnuPopEditCut: TMenuItem;
    mnuPopEditCopy: TMenuItem;
    mnuPopEditPaste: TMenuItem;
    mnuPopEditDelete: TMenuItem;
    mnuPopEditSelectAll: TMenuItem;
    mnuPopEditN2: TMenuItem;
    mnuPopEditCheckSpelling: TMenuItem;
    mnuPopEditN3: TMenuItem;
    mnuPopEditLoadExam: TMenuItem;
    lblCountry: TLabel;
    lblProvince: TLabel;
    lblPostalCode: TLabel;
    lblLastUpdate: TLabel;
    lblUpdateSite: TLabel;
    FMEditCountry: TFMEdit;
    FMEditProvince: TFMEdit;
    FMEditPostalCode: TFMEdit;
    FMEditLastUpdate: TFMEdit;
    FMEditUpdateSite: TFMEdit;
    FMEditTempCountry: TFMEdit;
    FMEditTempProvince: TFMEdit;
    FMEditTempPostalCode: TFMEdit;
    FMEditTempLastUpdate: TFMEdit;
    FMEditTempUpdateSite: TFMEdit;
    lblTempCountry: TLabel;
    lblTempProvince: TLabel;
    lblTempPostalCode: TLabel;
    lblTempLastUpdate: TLabel;
    lblTempUpdateSite: TLabel;
    FMGetsCountry: TFMGets;
    grpDODStartDate: TGroupBox;                                                 //CodeCR102 - rpm 4/12/10
    grpDODEndDate: TGroupBox;                                                   //CodeCR102 - rpm 4/12/10
    dtpDODStartDate: TDateTimePicker;                                           //CodeCR102 - rpm 4/12/10
    dtpDODEndDate: TDateTimePicker;                                             //CodeCR102 - rpm 4/12/10
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    ca508ListBoxIPR1: TVA508ComponentAccessibility;
    actHIASearch: TAction;
    actFileTransmitVirtualVA: TAction;                                          //CodeCR353 - rpm 5/1/12
    actCapriHelp: TAction;
    TabVocRehab: TTab95Sheet;
    pnlVocRehab: TPanel;
    btnVRAddNewRequest: TBitBtn;
    btnVREditRequest: TBitBtn;
    lbVocRehab: TListBox;
    FMGetsVocRehab: TFMGets;
    FMListerVocRehab: TFMLister;
    edtHeader: TEdit;
    edtColumnHeader: TEdit;
    actFileRetrieveVirtualVA: TAction;
    actCCRLaunch: TAction;
    actFileRetrieveDocsVLERDAS: TAction;
    actHelpEdtCancelReasons: TAction;
    actHelpEdtInsuffReasons: TAction;
    Find1: TMenuItem;       // CodeCR696 JRL 4/8/15
    FindNext1: TMenuItem;
    lbNUTASSESSSearchIndex: TListBox;   // CodeCR696 JRL 4/8/15
    Function AuthorizedOption(Const OptionName: String): Boolean;
    Function CCOWForceCloseOfAllDialogs: boolean;
    Function ConnectToServer(Const OptionName: String): Boolean;
    Function GetAdhocLookup: integer;
    Function GetDivisions: TStrings;
    Function HSFileLookup(aFile: String; Const StartFrom: String; Direction: Integer): TStrings;
    Function removespaces(tempstring: String): String;
    Procedure AnimateLogo(YesOrNo: Boolean);
    Procedure ApplicationExceptionHandler(Sender: TObject; E: Exception);
    Procedure BitBtn1Click(Sender: TObject);
    Procedure BitBtn2Click(Sender: TObject);
    Procedure BitBtn4Click(Sender: TObject);
    Procedure BitBtnCCOWLinkBrokenClick(Sender: TObject);
    Procedure BitBtnCCOWLinkClick(Sender: TObject);
    Procedure BitBtnLaunchVistaWebClick(Sender: TObject);
    Procedure BitBtnNewFormClick(Sender: TObject);
    Procedure BitBtnUnsignedFormsClick(Sender: TObject);
    Procedure BitBtnVistAClick(Sender: TObject);
    Procedure btnAdd7131Click(Sender: TObject);
    Procedure btnAddExamClick(Sender: TObject);
    Procedure btnAddRequestClick(Sender: TObject);
    Procedure btnAdHocClick(Sender: TObject);
    Procedure btnAdmissionsClick(Sender: TObject);
    Procedure btnAllClick(Sender: TObject);
    Procedure btnDivisionsClick(Sender: TObject);
    Procedure btnDocsRefreshClick(Sender: TObject);
    Procedure btnEditAddressClick(Sender: TObject);
    Procedure btnExamFinalReportClick(Sender: TObject);
    Procedure btnFutureClick(Sender: TObject);
    Procedure btnGenerate7131ReportClick(Sender: TObject);
    Procedure btnGenerateReportClick(Sender: TObject);
    Procedure btnGraphVSClick(Sender: TObject);
    Procedure btnLoadHSNamesClick(Sender: TObject);
    Procedure btnLoadHSNamesRemoteDataClick(Sender: TObject);
    Procedure btnMulti2Click(Sender: TObject);
    Procedure btnMultiClick(Sender: TObject);
    Procedure btnPastClick(Sender: TObject);
    Procedure btnRefreshAddressClick(Sender: TObject);
    Procedure btnRefreshPtDemographicsClick(Sender: TObject);
    Procedure btnSaveAddressClick(Sender: TObject);
    Procedure btnView7131Click(Sender: TObject);
    Procedure btnViewExamClick(Sender: TObject);
    Procedure btnVistAWebHomeClick(Sender: TObject);
    Procedure Button1Click(Sender: TObject);
    Procedure Button3Click(Sender: TObject);
    Procedure Button4Click(Sender: TObject);
    Procedure Button5Click(Sender: TObject);
    Procedure Button9Click(Sender: TObject);
    Procedure buttonCancelReportAdmissionClick(Sender: TObject);
    Procedure ButtonCancelSurgeryReportsClick(Sender: TObject);
    Procedure buttonClinDocDateRangeClick(Sender: TObject);
    Procedure ButtonCountyAcceptClick(Sender: TObject);
    Procedure ButtonCPTCopyrightClick(Sender: TObject);
    Procedure ButtonGCPRGoClick(Sender: TObject);
    Procedure ButtonIPRCopyClick(Sender: TObject);
    Procedure ButtonIPRDeleteClick(Sender: TObject);
    Procedure ButtonIPRDisplayClick(Sender: TObject);
    Procedure ButtonIPRRefreshClick(Sender: TObject);
    Procedure ButtonIPRRefreshEnter(Sender: TObject);
    Procedure buttonNewsClick(Sender: TObject);
    Procedure buttonOKReportAdmissionClick(Sender: TObject);
    Procedure ButtonOKSurgeryReportsClick(Sender: TObject);
    Procedure ButtonOtherSitesClick(Sender: TObject);
    Procedure ButtonRDVClick(Sender: TObject);
    Procedure ButtonSearchClick(Sender: TObject);
    Procedure ButtonStateAcceptClick(Sender: TObject);
    Procedure ComboBoxHSSectionsChange(Sender: TObject);
    Procedure ContextorControlCanceled(Sender: TObject);
    Procedure ContextorControlCommitted(Sender: TObject);
    Procedure ContextorControlPending(Sender: TObject; Const aContextItemCollection: IDispatch);
    Procedure CountyFakeEnter(Sender: TObject);
    Procedure DeleteTemplateClick(Sender: TObject);
    Procedure DeleteText(Sender: TObject);
    Procedure DimMenuOptions;
    Procedure EditDODMaxItemsExit(Sender: TObject);
    Procedure EnsureBroker;
    Procedure ExamRequestRefreshClick(Sender: TObject);
    Procedure FMCountiesListExit(Sender: TObject);
    Procedure FMEditCityExit(Sender: TObject);
    Procedure FMEditStreet1Exit(Sender: TObject);
    Procedure FMExamRequestListboxClick(Sender: TObject);
    Procedure FMExamRequestListboxDrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    Procedure FMListBoxAdmissionEnter(Sender: TObject);
    Procedure FMListBoxAdmissionExit(Sender: TObject);
    Procedure FMListBoxIPR1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    Procedure FMMemoFormDefinitionChange(Sender: TObject);
    Procedure FMRegionalOfficeNumberExit(Sender: TObject);
    Procedure FMSeventyOne31RequestListboxClick(Sender: TObject);
    Procedure FMSeventyOne31RequestListboxDrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    Procedure FMStatesListExit(Sender: TObject);
    Procedure FormActivate(Sender: TObject);
    Procedure FormatIPRList1;
    Procedure FormClose(Sender: TObject; Var Action: TCloseAction);
    Procedure FormCloseQuery(Sender: TObject; Var CanClose: Boolean);
    Procedure FormCreate(Sender: TObject);
    Procedure FormPaint(Sender: TObject);
    Procedure FormResize(Sender: TObject);
    Procedure HeaderControlDoDAllergiesSectionResize(HeaderControl: THeaderControl; Section: THeaderSection);
    Procedure HeaderControlDODConsultsSectionResize(HeaderControl: THeaderControl; Section: THeaderSection);
    Procedure HeaderControlDODDCSSectionResize(HeaderControl: THeaderControl; Section: THeaderSection);
    Procedure HeaderControlDODLRCSectionResize(HeaderControl: THeaderControl; Section: THeaderSection);
    Procedure HeaderControlDODLRCYSectionResize(HeaderControl: THeaderControl; Section: THeaderSection);
    Procedure HeaderControlDODMISectionResize(HeaderControl: THeaderControl; Section: THeaderSection);
    Procedure HeaderControlDoDPNsSectionResize(HeaderControl: THeaderControl; Section: THeaderSection);
    Procedure HeaderControlDODRRSectionResize(HeaderControl: THeaderControl; Section: THeaderSection);
    Procedure HorScrollBar(ListBox: TListBox; MaxWidth: integer);
    Procedure HSABVComponents(Dest: TStrings);
    Procedure HSComponentFiles(Dest: TStrings; aComponent: String);
    Procedure HSComponents(Dest: TStrings);
    Procedure HSComponentSubs(Dest: TStrings; aItem: String);
    Procedure HSDispComponents(Dest: TStrings);
    Procedure HSMemoChange(Sender: TObject);
    Procedure HSMemoEnter(Sender: TObject);
    Procedure HSMemoLocalChange(Sender: TObject);
    Procedure HSReportText(Dest: TStrings; aComponents: TStringlist);
    Procedure ListBoxIPR1Click(Sender: TObject);
    Procedure ListBoxIPR1DblClick(Sender: TObject);
    Procedure ListBoxIPR1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    Procedure ListBoxIPR1KeyUp(Sender: TObject; Var Key: Word; Shift: TShiftState);
    Procedure loadinstitutions;
    Procedure LoadReportsOptions;
    Procedure lstDocsChange(Sender: TObject);
    Procedure lstDocsClick(Sender: TObject);
    Procedure MemoAppointmentsChange(Sender: TObject);
    Procedure MemoAppointmentsEnter(Sender: TObject);
    Procedure memoDocsChange(Sender: TObject);
    Procedure memoDocsEnter(Sender: TObject);
    Procedure MyTempExceptionHandler(Sender: TObject; E: Exception);
    Procedure ORHealthSummaryUserListClick(Sender: TObject);
    Procedure ORListBoxSurgeryReportsChange(Sender: TObject);
    Procedure ORListBoxSurgeryReportsClick(Sender: TObject);
    Procedure ORReportsAvailableClick(Sender: TObject);
    Procedure Page95Control1Change(Sender: TObject);
    Procedure Page95Control1Changing(Sender: TObject; Var AllowChange: Boolean);
    Procedure PopupReadonlyRicheditPopup(Sender: TObject);
    Procedure ReportMemoChange(Sender: TObject);
    Procedure ReportMemoEnter(Sender: TObject);
    Procedure RestoreMenuOptions;
    Procedure RPCBroker1AfterCall(Sender: TObject);
    Procedure RPCBroker1BeforeCall(Sender: TObject);
    Procedure RPCBrokerCall;
    Procedure RPCBrokerDODCall;
    Procedure SaveCAPRISettings;
    Procedure SetAdhocLookup(aLookup: integer);
    Procedure SetBrokerServer(Const AName: String; APort: Integer; Want   ug: Boolean);
    Procedure SetFont;
    Procedure SeventyOne31RequestRefreshClick(Sender: TObject);
    Procedure ShowHIAUserDownloadWebsite;
    Procedure Splitter3Moved(Sender: TObject);
    Procedure Splitter7CanResize(Sender: TObject; Var NewSize: Integer; Var Accept: Boolean);
    Procedure StateFakeChange(Sender: TObject);
    Procedure StateFakeEnter(Sender: TObject);
    Procedure Tab95Control1Change(Sender: TObject);
    Procedure Tab95Control1Changing(Sender: TObject; Var AllowChange: Boolean);
    Procedure Tab95Control2Change(Sender: TObject);
    Procedure Tab95Control3Change(Sender: TObject);
    Procedure tempToolClick(Sender: TObject);
    Procedure TimeoutTimerTimer(Sender: TObject);
    Procedure TimerFHIERunningTimer(Sender: TObject);
    Procedure TimerHaltTimer(Sender: TObject);
    Procedure TimerInfoBoxTimer(Sender: TObject);
    Procedure TimerInitialConnectionTimer(Sender: TObject);
    Procedure TimerNewsTimer(Sender: TObject);
    Procedure TimerRemoteDataTimer(Sender: TObject);
    Procedure UserKeys1Click(Sender: TObject);
    Procedure VAWrapGridDODClick(Sender: TObject);
    Procedure WebBrowser1BeforeNavigate2(Sender: TObject; Const pDisp: IDispatch; Var URL, Flags, TargetFrameName, PostData, Headers: OleVariant; Var Cancel: WordBool);
    Procedure WebBrowser1DocumentComplete(Sender: TObject; Const pDisp: IDispatch; Var URL: OleVariant);
    Procedure WebBrowser1NavigateComplete2(Sender: TObject; Const pDisp: IDispatch; Var URL: OleVariant);
    Procedure WebBrowser1ProgressChange(Sender: TObject; Progress, ProgressMax: Integer);
    procedure actFileConnectExecute(Sender: TObject);
    procedure actFileConnectUpdate(Sender: TObject);
    procedure actFileSwitchSitesUpdate(Sender: TObject);
    procedure actFileSelectPatientUpdate(Sender: TObject);
    procedure actFileSelectPatientExecute(Sender: TObject);
    procedure actFileReportsExecute(Sender: TObject);
    procedure actFileReportsUpdate(Sender: TObject);
    procedure actFilePrintUpdate(Sender: TObject);
    procedure actFilePrintExecute(Sender: TObject);
    procedure actFilePrintPreviewUpdate(Sender: TObject);
    procedure actFilePrintPreviewExecute(Sender: TObject);
    procedure actFilePrinterSetupUpdate(Sender: TObject);
    procedure actFilePrinterSetupExecute(Sender: TObject);
    procedure actFileQuitExecute(Sender: TObject);
    procedure actEditUpdate(Sender: TObject);
    procedure actEditUndoExecute(Sender: TObject);
    procedure actEditCutExecute(Sender: TObject);
    procedure actEditCopyExecute(Sender: TObject);
    procedure actEditPasteExecute(Sender: TObject);
    procedure actEditSelectAllExecute(Sender: TObject);
    procedure actToolsAMIEExecute(Sender: TObject);
    procedure actToolsPrintBlankExamExecute(Sender: TObject);
    procedure actToolsBringExamToFrontExecute(Sender: TObject);
    procedure actToolsBringExamToFrontUpdate(Sender: TObject);
    procedure actToolsMacroEditorExecute(Sender: TObject);
    procedure actToolsUnsignedWorkSheetsUpdate(Sender: TObject);
    procedure actToolsUncosignedDocsUpdate(Sender: TObject);
    procedure actToolsUncosignedDocsExecute(Sender: TObject);
    procedure actToolsVistaUpdate(Sender: TObject);
    procedure actToolsSearchUpdate(Sender: TObject);
    procedure actToolsSearchExecute(Sender: TObject);
    procedure actToolsPropertiesUpdate(Sender: TObject);
    procedure actToolsPropertiesExecute(Sender: TObject);
    procedure actToolsChangeAddressUpdate(Sender: TObject);
    procedure actToolsChangeAddressExecute(Sender: TObject);
    procedure actToolsEditEsigExecute(Sender: TObject);
    procedure actToolsEditCPReportsUpdate(Sender: TObject);
    procedure actToolsEditCPReportsExecute(Sender: TObject);
    procedure actToolsExamListParametersUpdate(Sender: TObject);
    procedure actToolsExamListParametersExecute(Sender: TObject);
    procedure actToolsCPRSCosigUtilUpdate(Sender: TObject);
    procedure actToolsCPRSCosigUtilExecute(Sender: TObject);
    procedure actToolsManageTemplateDefExecute(Sender: TObject);
    procedure actDevEditUserKeysExecute(Sender: TObject);
    procedure actDevThrowExceptExecute(Sender: TObject);
    procedure actDevUserKeysExecute(Sender: TObject);
    procedure actHelpAboutUpdate(Sender: TObject);
    procedure actHelpAboutExecute(Sender: TObject);
    procedure actHelpCAPRITrainingExecute(Sender: TObject);
    procedure actHelpAuditUtilExecute(Sender: TObject);
    procedure actHelpAuditUtilUpdate(Sender: TObject);
    procedure actHelpRPCBrokerHistoryUpdate(Sender: TObject);
    procedure actHelpCheckConnectionsExecute(Sender: TObject);
    procedure actHelpConsReportsExecute(Sender: TObject);
    procedure actHelpEditRemoteUserExecute(Sender: TObject);
    procedure actHelpEditPatientListsExecute(Sender: TObject);
    procedure actHelpRPCBrokerHistoryExecute(Sender: TObject);
    procedure actPopTempDeleteUpdate(Sender: TObject);
    procedure actPopTempDeleteExecute(Sender: TObject);
    procedure actPopTempTogNewExecute(Sender: TObject);
    procedure actPopTempTogGreenExecute(Sender: TObject);
    procedure actPopTempTogExclamationExecute(Sender: TObject);
    procedure actPopEditUndoExecute(Sender: TObject);
    procedure actPopEditCutExecute(Sender: TObject);
    procedure actPopEditCopyExecute(Sender: TObject);
    procedure actPopEditPasteExecute(Sender: TObject);
    procedure actPopEditSelectAllExecute(Sender: TObject);
    procedure actPopEditCheckSpellingExecute(Sender: TObject);
    procedure actPopEditLoadExamExecute(Sender: TObject);
    procedure actPopEditUndoUpdate(Sender: TObject);
    procedure ActionMainMenuBar1EnterMenuLoop(Sender: TObject);
    procedure ShowPatientList(Sender: TObject; PatientFilterType: TPatientFilterType); //CodeCR124 -MER 07/2010
    procedure ListBoxIPR1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ca508ListBoxIPR1ValueQuery(Sender: TObject;
      var Text: string);                                                        // -MER CodeCR117 8/2010
    procedure WebBrowser1WindowClosing(ASender: TObject;
      IsChildWindow: WordBool; var Cancel: WordBool);
    procedure actHIASearchExecute(Sender: TObject);
    procedure actFileTransmitVirtualVAExecute(Sender: TObject);
    procedure actFileTransmitVirtualVAUpdate(Sender: TObject);
    procedure actCapriHelpExecute(Sender: TObject);
    procedure lbVocRehabClick(Sender: TObject);                                 // CodeCR347 - JRL 05/22/12
    procedure btnVRAddNewRequestClick(Sender: TObject);                         // CodeCR347 - JRL 05/22/12
    procedure btnVREditRequestClick(Sender: TObject);                           // CodeCR347 - JRL 05/22/12
    procedure actFileRetrieveVirtualVAExecute(Sender: TObject);                 //CodeCR424 - rpm 11/13/12
    procedure actFileRetrieveVirtualVAUpdate(Sender: TObject);                  //CodeCR424 - rpm 11/13/12
    procedure actCCRLaunchExecute(Sender: TObject);
    procedure actFileRetrieveDocsVLERDASExecute(Sender: TObject);
    procedure actFileRetrieveDocsVLERDASUpdate(Sender: TObject);
//    procedure ApplicationEvents1Message(var Msg: tagMSG; var Handled: Boolean);
//    procedure ApplicationEvents1Idle(Sender: TObject; var Done: Boolean);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure actHelpEdtCancelReasonsExecute(Sender: TObject);
//    procedure actHelpEdtCancelReasonsUpdate(Sender: TObject);
    procedure actHelpEdtInsuffReasonsExecute(Sender: TObject);
//    procedure actHelpEdtInsuffReasonsUpdate(Sender: TObject);
//    procedure ApplicationEvents1Idle(Sender: TObject; var Done: Boolean);
    procedure RunSearch(SearchString : String);                                 //CodeCR696 JRL 4/8/15
    procedure Find1Click(Sender: TObject);                                      //CodeCR696 JRL 4/8/15
    procedure FindNext1Click(Sender: TObject);                                  //CodeCR696 JRL 4/8/15
//  procedure FindTextDlgFind(Sender: TObject);                                 //CodeCR696 JRL 4/8/15
//  procedure FindTextDlgShow(Sender: TObject);                                 //CodeCR696 JRL 4/8/15

  Private
    { Private declarations }
    FMVISearch   ug: Boolean;                                                   //CodeCR267 - 8/28/12
    FNoDeleteVVA: Boolean;                                                      //CodeCR353 - 5/30/12
    FVirtualVAURL: String;                                                      //CodeCR353 - rpm 5/14/12
    FVirtualVAToken: String;                                                    //CodeCR353 - rpm 5/31/12
    FAMIS290URL: string;                                                        //CodeCR440 (AMIS290) - JRL 11/15/12
    // FVlerDasURL : String;  //CodeCR500 JRL 8/27/13
    // FVlerDasToken : String; //CodeCR540 JRL 12/11/13
    FPrimaryMenuAssignable: Boolean;                                            //CodeCR109 - rpm 8/4/10
    FIsDoDUser: Boolean;                                                        //CodeCR131 - rpm 10/26/10
    FPatientInfoBucket: TPatientInfoBucket;
    PatientSex: string;
    PatientAge: string;
    function IsPrimaryMenuAssignable(const UserPrimaryMenu: String): Boolean;   //CodeCR109 - rpm 8/1/10
    Function UserConfirmsAssigningEmptyString: boolean;
    procedure GetPatientProfileMAS(aDFN: String);                               //CodeCR85 - rpm 4/13/10
    procedure CCOWIconSetup;                                                    //CodeCR124 refactor -MER 07/2010
    procedure UpdateAuditOnHomeServer;                                          //CodeCR124 refactor -MER 07/2010
    function GetBHIEInstitutionIEN: String;                                     //CodeCR131 - rpm 12/8/10
    procedure ClearForm;                                                        //CodeCR248 - rpm 3/8/12
    function GetServerDateTime(): String;                                       //CodeCR353 - rpm 4/30/12
    function GetFooterDescription(Sender: TObject; var footDescrip: String; var ErrorText: String): Boolean; //CodeCR353 - rpm 4/30/12
    procedure FormatReportFooter(Sender: TObject; footDescrip: String; DtTm: String; Division: String); //CodeCR353 - rpm 4/30/12
    procedure FormatReportBody(Sender: TObject);                                //CodeCR353 - rpm 4/30/12
    function FormatReport(Sender: TObject): Boolean; overload;                  //CodeCR353 - rpm 5/8/12
    function FormatReport(Sender: TObject; var footdescrip: String;             //CodeCR353 - rpm 5/8/12
      var DtTm: String; var Division: String): Boolean; overload;               //CodeCR353 - rpm 5/8/12
    procedure CleanupAfterReport(Sender: TObject);                              //CodeCR353 - rpm 5/8/12
    procedure DoLegacyEnterpriseSearch(Sender: TObject);                        //CodeCR267 - rpm 8/28/12
    procedure DoMVISiteSwitch(Sender: TObject);                                 //CodeCR267 - rpm 8/30/12
    function IsButtonTagOne(Sender: TObject): Boolean;                          //CodeCR267 - rpm 8/30/12
    procedure LoadRestrictedSearchTraits;                                       //CodeCR267 - rpm 9/13/12
    function GetCurrentPatientInfo: TPatientInfoBucket;
    function RemoveSpecialCharacters(InputExamName: string): string;            //CodeCR522 JRL 11/15/13

  Public
    { Public declarations }
    VocRehab: TVocRehab;                                                        //CodeCR347 - JRL 5/22/12
    ReflectionWrapper: TReflectionWrapper;                                      //CodeCR185 -MER 4/2011
    ExamTextForPDFs: array of TMemoryStream;                                    // CodeCR565 JRL 7/9/14
    NumExamTextForPDFs: Integer;                                                // CodeCR565 JRL 7/10/14
    SearchText : TSearchText;                                                   //CodeCR696 JRL 4/8/15
    Property PatientInfo: TPatientInfoBucket read GetCurrentPatientInfo write FPatientInfoBucket; // CodeCR??? TODO: LMS Check to see if Patient Bucket was ever used.
    property MVISearch   ug: Boolean read FMVISearch   ug write FMVISearch   ug; //CodeCR267 - rpm 8/28/12
    property VirtualVAURL: String read FVirtualVAURL write FVirtualVAURL;       //CodeCR353 - rpm 5/14/12
    property VirtualVAToken: String read FVirtualVAToken write FVirtualVATOken; //CodeCR353 - rpm 5/31/12
    property AMIS290URL: String read FAMIS290URL write FAMIS290URL;             // CodeCR440 (AMIS290) JRL 11/15/12
    property IsDoDUser: Boolean read FIsDoDUser write FIsDoDUser;               //CodeCR131 - rpm 10/26/10
    // property VlerDasURL : String read FVlerDasURL write FVlerDasURL; // CodeCR500 JRL 8/27/13         // CodeCR??? LMS 2014-07-21  Moving from main form field. moving to VlerDasClient
    // property VlerDasToken : String read FVlerDasToken write FVlerDasToken; //CodeCR540 JRL 12/11/13
    function IsAllowed2OpenExam(anIENS: String): Boolean;
    function IsLockedDate(anIENS: String): Boolean;
    function GetDivision(aRemoteLogin: Boolean; aRPCBroker: TCCOWRPCBrokerCAPRI): String;
    //QC #2016 - Call no longer needed
    //Function CanAccessReview(): Boolean;
    Function FileDeleteOldSaveHistory(ExistingFile, ExistingDateCreated, CurrentFile: String): Boolean;
    Function IsPNCSOpen(): Boolean;
    Function IsPNCSRecordSelected(FMListBox: TFMListBox): Boolean;
    Function IsRPCBrokerConnected(): Boolean; overload;
    Function IsRPCBrokerConnected(RPCBroker: TCCOWRPCBrokerCAPRI; ShowMsg: Boolean; Status: TLabel): Boolean; overload;
    Function IsRPCBrokerConnected(ShowMsg: Boolean; Status: TLabel): Boolean; overload;
    Function IsUserKey(KeyName: String): Boolean;
    Function IsUserKeyInList(KeyList: String): Boolean;
    Function Piece(Const S: String; Delim: char; PieceNum: Integer): String;
    Procedure AppMessage(Var Msg: TMsg; Var Handled: Boolean);
    Procedure HSSubItems(Dest: TStrings; aItem: String);
    Procedure FileCreateNameForApplicationExceptionLog(var Filename: String; DayCounter: integer);
    Procedure FileCreateNameForSaveHistoryLog(var Filename: String; DayCounter: integer);
    Function TIUShowModal(SenderName: String; FMListBox: TFMListBox): Boolean;
    Procedure SaveToUsersTempDirectory(Sender: TObject; ErrorMsg: String; ParseErrorMsg: boolean);
    Procedure SetFileAttributesReadOnly(Sender: TObject; FileName: String; ReadOnly: boolean);
    Procedure UserKeysDialog();
    Procedure UserKeysEditDialog();
    function GetCountryName(aCountryIEN: String): String;
    function GetVersionUser: String;
    procedure GetActiveCapriDivisions(aDivisionList: TStrings; Target: TStrings); //CodeCR173 - rpm 4/18/11
    procedure GetAllDivisions(aDivisionList: TStrings);                         //CodeCR186 - rpm 4/18/11
    function GetDisplayGrpIEN(aDisplayGroup: String): String;                   //CodeCR178 - rpm 4/18/11
    function IsCCRUser: Boolean;
    function IsCCRSuperVisor: Boolean;
  End;

  
Var
 {Prior to v149, VersionUser was a string const fixed at 27 characters to
  be compatible with the version update tool (ex.'*#/VUSER/#*^DVBA*2.7*143.01').
  v149 implemented GetVersionUser to dynamically build the version from the
  project fileversion options}
  VersionUser: String;
  MergedFormMode: Boolean;
  TabReorderMode: Boolean;
  FHIESiteLocation: String;
  CallRPCErrorTest: Boolean = false;
Const
  // *** these are constants from RPCBErr.pas, will broker document them????
  XWB_M_REJECT = 20000 + 2;                                                     // M erfsror
  XWB_BadSignOn = 20000 + 4;                                                    // SignOn 'Error' (happens when cancel pressed)
  Version = 'DVBA2.7*177*1*A';                                                  // Change to *1*A to distinguish release version from test version
  CAPRIVersion = 1.0;                                                           // For PNCSCodeRun.pas

  //MessageFile = '\\isp-hardenbrook.vha.domain.ext\caprimessages\DVBA_2_7_91A.txt';
  //NewsFolder = '\\isp-hardenbrook.vha.domain.ext\caprimessages\';
  NewsURL = 'vaww.cpep.domain.ext/SHARE/CAPRI%20Announcements/';
  //NewsURL = 'isp-hardenbrook.vha.domain.ext/CAPRI%20Announcements/';
  (* rpm 5/26/09 - FHIE server locations determined in ConnectToServer *)
  //FHIESiteLocation ='10.4.237.70,9200';  //Test System
  //FHIESiteLocation = 'FHIE.DOMAIN.EXT,9200'; //Live system
  //FHIESiteLocation ='10.224.50.50,9200';
  app_name = 'CAPRI';
  PROXYSERVER_DEV_URL = 'https://10.232.159.218:8181/CapriProxyServlet/';
  PROXYSERVER_TEST_URL = 'https://10.232.159.218:8181/CapriProxyServlet/';

Var
  AddRequestIEN: String;
  addressinfo: String;
  AllowSurgeryReport: Boolean;
  // QC #2016 - jcs - found variable no longer needed.
  //ANUCanEditCPWM: Boolean;
  ANURefreshCPWMTitles: Boolean;
  ANUReportsClosing: Boolean;
  ANUTelnetLoginName: String;
  AppStarted: Boolean;
  AuditInProgress: Boolean;
  authorien: String;
  authorname: String;
  authorssn: String;
  BrokerfirstLogin: Boolean;
  CancelIt: Array[0..1000] Of boolean;
  CancellationReason: String;                                                   // Used to control Cancel All Exams
  CancelReason: Array[0..1000] Of String;
  CCOWBreakLink: Boolean;
  CCOWInitialized: Boolean;
  CCOWMode: Boolean;
  CCOWSuspended: Boolean;
  ClinDocDateRangeSelected: Boolean;
  ConfigMode508: Boolean;
  ContextorChangeMessage: String;
  ContextorControl: TContextorControl;
  CPRSVersion: String;
  CurrentControl, CurrentDialog: String;
  currentpncstabname: String;
     ugSQA: Boolean;
  DivisionRun: Boolean;
  DocType: String;
  dvbaTimerInfoBox: integer;
  dvbaz: integer;                                                               // Used for report builder
  EditWhich: Integer;
  ESSOConnecting: Boolean;
  ESSOInitialized: Boolean;
  ESSOLoginYet: boolean;
  FEditCtrl: TCustomEdit;
  FEditCtrlRichEdit: TRichEdit;
  foundMergeflag: integer;
  frmMain: TfrmMain;
  HaltFlag: Boolean;
  hOldWnd: hWnd;
  homeemailaddress: String;
  Homeserver, HomePort: String;
  InsufficientExam: Boolean;
  iprdirectory: String;
  LastAnimationFrame: Integer;
  LastSearch: String;
  LastSearchFoundAt: Integer;
  listDocs: tstrings;
  listExams: tstrings;
  listLabTestNames: tstrings;
  listMedicalCenterDivision: tstrings;
  listRestrictedPatients: tstrings;
  localemailaddress: String;
  LocalStationNumber: String;
  loggermodeforCPEP: boolean;
  NewMail: Boolean;
  noprinting: boolean;
  NumberClinDocsToRetrieve: Integer;
//  SelectedPatient: TPatient;
  patientclaimnumber: String;
  patienticn: String;
  patientien: String;
  patientienDOD: String;
  patientname: String;
  PatientSelectionList: String;
  patientsensitive: String;
  patientssn: String;
  PNCSTimeoutValue: Integer;
  ProgramNameCaption: String;
  ReadOnlyMode: Boolean;
  RemoteDataPtId: String;
  RemoteSiteName: String;
  RemoteSiteNamePointer: String;
  RemoteUserDivisionNumber: String;
  RestrictedPtSelection: String;
  SaveFlag: Boolean;
  ScreenReaderActive: Boolean;
  SearchForString: String;
  SearchRunning: Integer;
  SendPNCSCounter: Integer;
  SendPNCSEventHint: String;
  ShuttingDown: Boolean;
  SpeechAPIInstalled: boolean;
  starttime: tdatetime;
  surgeryreports: tstrings;
  SwitchToPatientSSN: String;
  SwitchToSite: String;
  telnetcapturefile: String;
  TelnetConfigX: Integer;
  tempCursor: TCursor;
  TempDir: TFileName;
  TempFileName: String;
  tempHSMemo: TStringList;
  tempIEN: String;
  TempLastMemo: TMemo;
  TempAction: Array[0..49] Of TAction;
  TestSystemLogin: String;
  timeoutval, timeoutcount: longint;
  TimeSinceLastBrokerCall: Integer;
  uHSComponents: TStringList;                                                   //components selected
  uListState: Integer;                                                          //Checked state of list of Adhoc components Checked: Abbreviation, UnChecked: Name
  uLocalReportData: TStringList;                                                //Storage for Local report data
  UserDivision: String;
  UserDivisionNumber: String;
  UserDUZHomeServer: String;
  UserFilemanCode: String;
  UserHasNewStyleRestrictedList: Integer;
  UserHomePrimaryMenu: String;
  UserKeys: TStrings;
  UserKeysStr: String;
  UserRemoteDISUSER, UserRemoteTerminationDate, UserRemotePrimaryMenu: String;
  UserRemoteHIAUser: Boolean;
  VistAHost: String;
  VistAWebLoaded: Boolean;
  whichmergeform: integer;
  PARAM_SAVE_XML: Boolean;
  PARAM_SAVE_VLER_WS: Boolean;

Implementation

Uses
  about,
  alerts,
  audit,
  auditold,
  browsetemplates,
  CAPRISupport,
  checkremoteconnections,
  checktasks,
  Clipbrd,
  comments1,
  //  Comobj,      LMS removed.. was only added for one call.. the call moved to untMiscMthds
  connected,
  CPWMObjects,
  DateRangeSelect,
  daterangeshort,
  deletetemplateverification,
  divisionlister,
  editpatientlists,
  editpt,
  electronicsignature,
  emailforward,
  essoselect,
  establishingnetworkconnection,
  examdet,
  EdtCancelReasons,                                                             // CodeCR698 rpk 3/24/2015
  EdtInsuffReasons,                                                             // CodeCR698 rpk 3/30/2015
  FHIEGraph,
  findpatientanywhere,
  FiveZeroEightMessages,
  fPatientProfileMAS {CodeCR85 rpm 4/13/10},
  fReportsAdhocComponent1,
  frmWebDisplay,
  fWindowsProcesses,
  graphvs,
  hintdisplay,
  infobox,
  labgraph,
  loadexamcomments,
  macroedit,
  mailman,
  mailmanmessage,
  managereports,
  managetemplatedefs,
  manifests,
  new7131,
  newexam,
  news,
  ORFn,
  patientlistrestricted,
  pncsreviewer,
  pncsShow,
  printconfirm,
  Printers,
  printsupport,
  printtemplate,
  properties,
  registry,
  remotereports,
  remotesitepick,
  remoteusersiteseditor,
  reportauto,
  reportbld,
  REPORTS,
  rofinder,
  rpcbrokercallsbuffer,
  RPCConf1,
  siteexamlist,
  spellcheck,
  splash,
  telnet,
  tiucosignature,
  tiudisplayunit,
  tiusign,                                                                      // CodeCR423 JRL 11/9/12
  uncosignedutility,
  unitsiblings,
  unitzip,
  unsigned,
  UserKeyEditor,
  view7131,
  viewaddress,
  viewexam,
  VocRehabMedicalRequest,                                                       //CodeCR347 - jrl 5/22/12
  wait,
  HIAVerifyPatient, frmMVISearch,
  frmVVAGetDocs,                                                                //CodeCR424 - rpm 11/13/12
  demTranMain                                                                   // CodeCR457 - LMS Minimalistics Embed demTRAN/CCR into CAPRI
  , untConstVals                                                                // CodeCR457 - LMS Another CCR unit
  , untMiscMthds                                                                // CodeCR??? - LMS - 2014-07-14 consolidate/refactor all GetTempDir into one location, so all can benefit from Win 7 specific handling.
  , untBrkrMthds                                                                // JRL 12/10/13
  , FrmVlerGetExam                                                              // rpk 9/12/2014
  , VlerDasClient                                                               //  CodeCR??? LMS 2014-07-21  Moving Vler specific references out of main form.
  , VlerDasIdHTTP                                                               //  CodeCR??? LMS 2014-07-21  Moving Vler specific references out of main form.
  , SearchText
  ;


Var
  UnitName: String = 'main';
  FormTIUDisplay: TFormTIUDisplay;                                              //CodeCR353 - rpm 5/7/12

{$R *.DFM}
{$R zipcodes.RES}
{$R capridictionary.RES}

(*   // LMS - consolidate/refactor all GetTempDir into one
type
  KNOWNFOLDERID = TGuid;
  TSHGetKnownFolderPath = function(const rfid: KNOWNFOLDERID; dwFlags: DWord; hToken: THandle; var ppSzPath: LPWSTR) : HResult; StdCall;
const
  FOLDERID_LocalAppData: KNOWNFOLDERID = '{F1B32785-6FBA-4FCF-9D55-7B8E7F157091}';

{The next two functions will setup the call and return the result.  After that the Memory will be freeand Nil}
function ShGetKnownFolderPath(const rfid: KNOWNFOLDERID; dwFlags: DWord; hToken: THandle; var ppszPath: LPWSTR): HResult;
var
  Shell: HModule;
  SHGetKnownFolderPath: TSHGetKnownFolderPath;
begin
  Shell := LoadLibrary('shell32.dll');
  Win32Check(Shell <> 0);
  try
    @SHGetKnownFolderPath := GetProcAddress(Shell, 'SHGetKnownFolderPath');
    Win32Check(Assigned(SHGetKnownFolderPath));
    Result := SHGetKnownFolderPath(rfid, dwFlags, hToken, ppszPath);
  finally
    FreeLibrary(Shell);
  end;
end;

function GetKnownFolderPath(const rfid: KNOWNFOLDERID; dwFlags: DWord; hToken: THandle): WideString;
var
  buffer: LPWSTR;
begin
  buffer := nil;
  OleCheck(ShGetKnownFolderPath(rfid, dwFlags, hToken, buffer));
  try
    Result := buffer;
  finally
    CoTaskMemFree(buffer);
  end;
end;

{-----------------------------------------------------------------------------
  Procedure: GetTempDir
  Author:    From http://www.latiumsoftware.com/en/delphi/00017.php
  Date:      24-Feb-2004
  Arguments: None
  Result:    TFileName
-----------------------------------------------------------------------------}

Function GetTempDir: TFileName;
Var
  TmpDir: Array[0..MAX_PATH - 1] Of char;
Begin
  Try
    Result := GetKnownFolderPath(FOLDERID_LocalAppData, 0, 0) + '\CAPRI\';     //rra 819092 Find path to Local App Data
    If not DirectoryExists(Result) then                                        //rra 819092 Check if CAPRI Dir exists
       If not CreateDir(Result) then                                            //rra 819092
       Begin                                                                    //rra 819092
         SetString(Result, TmpDir, GetTempPath(MAX_PATH, TmpDir));
         If Not DirectoryExists(Result) Then
           If Not CreateDirectory(PChar(Result), Nil) Then
           Begin
             Result := IncludeTrailingPathDelimiter(GetWindowsDir) + 'TEMP';
             If Not DirectoryExists(Result) Then
               If Not CreateDirectory(Pointer(Result), Nil) Then
               Begin
                 Result := ExtractFileDrive(Result) + '\TEMP';
                 If Not DirectoryExists(Result) Then
                   If Not CreateDirectory(Pointer(Result), Nil) Then
                   Begin
                     Result := ExtractFileDrive(Result) + '\TMP';
                     If Not DirectoryExists(Result) Then
                       If Not CreateDirectory(Pointer(Result), Nil) Then
                       Begin
                         Raise Exception.Create(SysErrorMessage(GetLastError));
                       End;
                   End;
               End;
           End;
       End;                                                                     //rra 819092
  Except
    Result := '';
    Raise;
  End;
End;
*)

Procedure TfrmMain.HSABVComponents(Dest: TStrings);
Begin
  frmMain.RPCBroker1.Results.Clear;
  RPCBroker1.RemoteProcedure := 'ORWRP2 COMPABV';
  //RPCBroker1.Param[0].Value := '';
  //RPCBroker1.Param[0].PType := literal;
  RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'ORWRP2 COMPABV could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('ORWRP2 COMPABV could not be accessed!');
    End;
  End;
  QuickCopy(RPCBroker1.Results, Dest);
End;

Procedure TfrmMain.HSDispComponents(Dest: TStrings);
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;
  frmMain.RPCBroker1.Results.Clear;
  RPCBroker1.RemoteProcedure := 'ORWRP2 COMPDISP';
  //RPCBroker1.Param[0].Value := '';
  //RPCBroker1.Param[0].PType := literal;
  RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'ORWRP2 COMPDISP could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('ORWRP2 COMPDISP could not be accessed!');
    End;
  End;
  QuickCopy(RPCBroker1.Results, Dest);
End;

Procedure TfrmMain.HSComponents(Dest: TStrings);
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;
  frmMain.RPCBroker1.Results.Clear;
  RPCBroker1.RemoteProcedure := 'ORWRP2 HS COMPONENTS';
  //RPCBroker1.Param[0].Value := '';

  //RPCBroker1.Param[0].PType := literal;
  RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'ORWRP2 HS COMPONENTS could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('ORWRP2 HS COMPONENTS could not be accessed!');
    End;
  End;
  QuickCopy(RPCBroker1.Results, Dest);
End;

Procedure TfrmMain.HSComponentSubs(Dest: TStrings; aItem: String);
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;
  frmMain.RPCBroker1.Results.Clear;
  RPCBroker1.RemoteProcedure := 'ORWRP2 HS COMPONENT SUBS';
  RPCBroker1.Param[0].Value := aItem;
  RPCBroker1.Param[0].PType := literal;
  RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'ORWRP2 HS COMPONENT SUBS could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('ORWRP2 HS COMPONENT SUBS could not be accessed!');
    End;
  End;
  MixedCaseList(RPCBroker1.Results);
  QuickCopy(RPCBroker1.Results, Dest);
End;

Procedure TfrmMain.HSComponentFiles(Dest: TStrings; aComponent: String);
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;
  frmMain.RPCBroker1.Results.Clear;
  RPCBroker1.RemoteProcedure := 'ORWRP2 HS COMP FILES';
  RPCBroker1.Param[0].Value := aComponent;
  RPCBroker1.Param[0].PType := literal;
  RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'ORWRP2 HS COMP FILES could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('ORWRP2 HS COMP FILES could not be accessed!');
    End;
  End;
  QuickCopy(RPCBroker1.Results, Dest);
End;

Procedure TfrmMain.SetAdhocLookup(aLookup: integer);
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;
  frmMain.RPCBroker1.Results.Clear;
  RPCBroker1.RemoteProcedure := 'ORWRP2 SAVLKUP';
  RPCBroker1.Param[0].Value := IntToStr(aLookup);
  RPCBroker1.Param[0].PType := literal;
  RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'ORWRP2 SAVLKUP could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('ORWRP2 SAVLKUP could not be accessed!');
    End;
  End;
End;

Procedure TfrmMain.HSReportText(Dest: TStrings; aComponents: TStringlist);
Var
  i: integer;
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;
  frmMain.RPCBroker1.Results.Clear;
  RPCBroker1.RemoteProcedure := 'ORWRP2 HS REPORT TEXT';
  RPCBroker1.Param[1].PType := list;
  For i := 0 To aComponents.count - 1 Do
    frmMain.RPCBroker1.Param[1].Mult[IntToStr(i + 1)] := aComponents[i];
  RPCBroker1.Param[2].Value := PatientIEN;
  RPCBroker1.Param[2].PType := literal;
  RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'ORWRP2 HS REPORT TEXT could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('ORWRP2 HS REPORT TEXT could not be accessed!');
    End;
  End;
  QuickCopy(RPCBroker1.Results, Dest);
End;

Function TfrmMain.GetDivisions: TStrings;
Var
  x: integer;
Begin
  // Get divisions and force them in the order they are in the file
  FMListBoxMedicalCenterDivision.Sorted := False;
  FMListBoxMedicalCenterDivision.GetList;
  If FMListBoxMedicalCenterDivision.Items.Count > 0 Then
    For x := 0 To FMListBoxMedicalCenterDivision.Items.Count - 1 Do
    Begin
      FMListBoxMedicalCenterDivision.ItemIndex := x;
      FMListBoxMedicalCenterDivision.Items[x] := FMListBoxMedicalCenterDivision.GetSelectedRecord.IEN + '^' + FMListBoxMedicalCenterDivision.Items[x];
    End;
  FMListBoxMedicalCenterDivision.Sorted := True;
  ListMedicalCenterDivision.Clear;
  If FMListBoxMedicalCenterDivision.Items.Count > 0 Then
    For x := 0 To FMListBoxMedicalCenterDivision.Items.Count - 1 Do
      ListMedicalCenterDivision.Add(Piece(FMListBoxMedicalCenterDivision.Items[x], '^', 2) + ' ^' + Piece(FMListBoxMedicalCenterDivision.Items[x], '^', 1));

  Result := ListMedicalCenterDivision;
End;

Function TfrmMain.GetAdhocLookup: integer;
Begin
  If ANURemoteProcedureCallInProgress = True Then
  Begin
    result := 0;
    exit;
  End;
  frmMain.RPCBroker1.Results.Clear;
  RPCBroker1.RemoteProcedure := 'ORWRP2 GETLKUP';
  //RPCBroker1.Param[0].Value := '';
  //RPCBroker1.Param[0].PType := literal;
  RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'ORWRP2 GETLKUP could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('ORWRP2 GETLKUP could not be accessed!');
    End;
  End;

  If RPCBroker1.Results.Count > 0 Then
    Result := StrToInt(RPCBroker1.Results[0])
  Else
    Result := 0;
End;

{=========================================================================
 GetBHIEInstitutionIEN
 This function determines the INSTITUTION (#4) file IEN for station 200
 that is used to denote BHIE/FHIE data in the TREATING FACILITIES LIST.
 This returned value is used to populate the BHIEInstitutionIEN property
 in the Patient Selector (frmPatientList).

 Returns the INSTITUTION (#4) file IEN on success; otherwise returns '0'.
 //CodeCR131 - rpm 12/8/10
 =========================================================================}

function TfrmMain.GetBHIEInstitutionIEN: String;
var
  FMFindBHIEIEN: TFMFindOne;
  BHIEIEN: String;
  ErrMsg: String;
  I, J: Integer;
begin
  Result := '0';
  ErrMsg := '';
  FMFindBHIEIEN := TFMFindOne.Create(nil);
  try
    FMFindBHIEIEN.RPCBroker := RPCBroker1;
    FMFIndBHIEIEN.FinderFlags := [fnfXactMatch];
    FMFindBHIEIEN.FileNumber := '4';                                            //INSTITUTION file
    FMFindBHIEIEN.Value := '200';                                               //AUSTIN (BHIE/FHIE) station #
    FMFindBHIEIEN.FMIndex := 'D';                                               //Station # index in the INSTITUTION file
    BHIEIEN := FMFindBHIEIEN.GetIEN;
    if (FMFIndBHIEIEN.ErrorList.Count > 0) then
    begin
      ErrMsg := 'Due to the following error, CAPRI is unable to filter DOD patients.' + #13#10
        + 'As a result, the patient selection dialog will not display any patients.' + #13#10
        + #13#10
        + 'FileMan Error details: ' + #13#10;
      for I := 0 to FMFIndBHIEIEN.ErrorList.Count - 1 do
        for J := 0 to TFMErrorObj(FMFIndBHIEIEN.ErrorList[I]).ErrorText.Count - 1 do
          ErrMsg := ErrMsg + TFMErrorObj(FMFIndBHIEIEN.ErrorList[I]).ErrorText[J] + #13#10;
      ShowMessageCAPRI(ErrMsg);
    end
    else
      Result := BHIEIEN;
  finally
    FreeAndNil(FMFindBHIEIEN);
  end;
end;

Function TfrmMain.HSFileLookup(aFile: String; Const StartFrom: String;
  Direction: Integer): TStrings;
Begin
  If ANURemoteProcedureCallInProgress = True Then
  Begin
    result := Nil;
    exit;
  End;
  frmMain.RPCBroker1.Results.Clear;
  RPCBroker1.RemoteProcedure := 'ORWRP2 HS FILE LOOKUP';
  RPCBroker1.Param[0].Value := aFile;
  RPCBroker1.Param[0].PType := literal;
  RPCBroker1.Param[1].Value := StartFrom;
  RPCBroker1.Param[1].PType := literal;
  RPCBroker1.Param[2].Value := IntToStr(Direction);
  RPCBroker1.Param[2].PType := literal;
  RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'ORWRP2 HS FILE LOOKUP could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('ORWRP2 HS FILE LOOKUP could not be accessed!');
    End;
  End;
  MixedCaseList(RPCBroker1.Results);
  Result := RPCBroker1.Results;
End;

Procedure TfrmMain.HSSubItems(Dest: TStrings; aItem: String);
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;
  frmMain.RPCBroker1.Results.Clear;
  RPCBroker1.RemoteProcedure := 'ORWRP2 HS SUBITEMS';
  RPCBroker1.Param[0].Value := aItem;
  RPCBroker1.Param[0].PType := literal;
  RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'ORWRP2 HS SUBITEMS could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('ORWRP2 HS SUBITEMS could not be accessed!');
    End;
  End;
  MixedCaseList(RPCBroker1.Results);
  QuickCopy(RPCBroker1.Results, Dest);
End;

Function TfrmMain.removespaces(tempstring: String): String;
Var
  x: integer;
Begin
  // Remove trailing spaces
  If Length(tempstring) > 0 Then
  Begin
    x := length(tempstring);
    Repeat
      Begin
        If Copy(tempstring, x, 1) = ' ' Then
          tempstring := copy(tempstring, 1, x - 1)
        Else
          x := 1;
        dec(x);
    End Until x = 0;
  End;
  // Remove leading spaces
  If Length(tempstring) > 0 Then
  Begin
    x := 0;
    Repeat
      Begin
        If Copy(tempstring, 1, 1) = ' ' Then
        Begin
          tempstring := copy(tempstring, 2, length(tempstring) - 1);
          dec(x);
        End
        Else
          x := length(tempstring);
        inc(x);
    End Until x > length(tempstring);
  End;
  result := tempstring;
End;

Procedure TfrmMain.SetFont;
Begin
  If FormEssoSelect <> Nil Then
  Begin
    formESSOSelect.font := panel1.font;
    formEssoSelect.height := frmMain.Height - 100;
    formEssoSelect.top := frmMain.Top + ((frmMain.Height - formEssoSelect.Height) Div 2);
    formEssoSelect.left := frmMain.left + ((frmMain.Width - formEssoSelect.Width) Div 2);
    formEssoSelect.LabelMessage.Left := (formEssoSelect.Width Div 2) - (formEssoSelect.LabelMessage.width Div 2);
    formEssoSelect.Width := formEssoSelect.Label1.Width + formEssoSelect.Label1.Left * 3;
    formEssoSelect.lstUserSites.Top := formEssoSelect.Label1.Top + formEssoSelect.Label1.Height + 8; //CodeCR77
    formEssoSelect.Button2.Height := panel1.Height;
    formEssoSelect.Button1.Height := panel1.Height;
    bitbtnCCOWLink.Height := panel1.Height;
    bitbtnCCOWLinkBroken.Height := panel1.Height;
    bitbtnCCOWLinkChanging.Height := panel1.Height;
    //formEssoSelect.ButtonHomeMail.Height:=panel1.Height;
    formEssoSelect.Button1.Width := (formEssoSelect.lstUserSites.width Div 2);  //CodeCR77
    formEssoSelect.Button2.Width := formEssoSelect.Button1.Width;
    formEssoSelect.Button1.Left := formEssoSelect.Button2.Left + formEssoSelect.Button2.Width;
    //formEssoSelect.ButtonHomeMail.width:=formEssoSelect.button1.width+formEssoSelect.button2.width;
    formessoselect.button1.top := formessoselect.height - (formessoselect.button1.height * 2) - 16;
    //formessoselect.buttonhomemail.top:=formessoselect.button1.top+formessoselect.button1.height+1;
    formEssoSelect.Button2.Top := FormEssoSelect.Button1.Top;
    formEssoSelect.StaticText1.Top := FormEssoSelect.Button1.Top - 8 - formEssoSelect.StaticText1.Height;
    formEssoSelect.lstUserSites.Height := FormEssoSelect.StaticText1.Top - 1 - formEssoSelect.lstUserSites.Top; //CodeCR77
  End;

  PanelSurgeryReports.Left := (frmMain.Width Div 2) - (PanelSurgeryReports.width Div 2);
  PanelSurgeryReports.Top := (frmMain.Height Div 2) - (PanelSurgeryReports.height Div 2) - 30;

  //FMExamRequestListbox.Font:=FontDialog1.Font;
  FMSeventyOne31RequestListbox.Font := FMExamRequestListbox.Font;
  ORReportsAvailable.Font := FontDialog1.Font;
  ORHealthSummaryUserList.Font := FontDialog1.Font;

  {rpm 9/22/09 -  The following 5 lines cause the non-proportional report
                  controls to display with the default proportional font.
                  This was not evident in Delphi 5, but causes problems
                  in Delphi 2006.
  MemoDocs.Font := Panel1.Font;
  ReportMemo.Font := Panel1.Font;
  HSMemo.Font := Panel1.Font;
  HSMemoLocal.Font := Panel1.Font;
  MemoAppointments.Font := Panel1.Font;
  }

  //ReportMemo.SelAttributes.Name:=FontDialog1.Font.name;
    //ReportMemo.SelAttributes.Size:=FontDialog1.Font.Size;
    //ReportMemo.SelAttributes.Style:=FontDialog1.Font.Style;
  //HSMemo.SelAttributes.name:=FontDialog1.Font.name;
    //HSMemo.SelAttributes.size:=FontDialog1.Font.size;
    //HSMemo.SelAttributes.style:=FontDialog1.Font.style;
  //HSMemoLocal.SelAttributes.name:=FontDialog1.Font.name;
    //HSMemoLocal.SelAttributes.size:=FontDialog1.Font.size;
    //HSMemoLocal.SelAttributes.style:=FontDialog1.Font.style;
  //MemoDocs.SelAttributes.name:=FontDialog1.Font.name;
    //MemoDocs.SelAttributes.size:=FontDialog1.Font.size;
    //MemoDocs.SelAttributes.style:=FontDialog1.Font.style;
  //MemoAppointments.SelAttributes.name:=FontDialog1.Font.name;
    //MemoAppointments.SelAttributes.size:=FontDialog1.Font.size;
    //MemoAppointments.SelAttributes.style:=FontDialog1.Font.style;
  lstDocs.Font := FontDialog1.Font;
  Tab95Control1.Font := FontDialog1.Font;
  Page95Control1.Font := FontDialog1.Font;
  frmMain.font := FontDialog1.Font;
  Groupbox2.Font := GroupBox1.Font;
  //HSMemoLocal.Plaintext:=True;
  //HSMemo.Plaintext:=true;
  //ReportMemo.PlainText:=true;
  //MemoAppointments.PlainText:=True;
  //frmReports.ReportMemo.Plaintext:=True;
  //memodocs.plaintext:=true;
  FormResize(application);
End;

Procedure TfrmMain.RPCBrokerCall;
Var
  x: integer;
Begin
  TimeSinceLastBrokerCall := 0;
  If ANURemoteProcedureCallInProgress = True Then
    Repeat
      Begin
        TimeSinceLastBrokerCall := 0;
        For x := 1 To 50 Do
          application.processmessages;
    End Until ANURemoteProcedureCallInProgress = False;
End;

Procedure TfrmMain.RPCBrokerDODCall;
Var
  x: integer;
Begin
  TimeSinceLastBrokerCall := 0;
  If ANURemoteProcedureCallInProgress = True Then
    Repeat
      Begin
        TimeSinceLastBrokerCall := 0;
        For x := 1 To 50 Do
          application.processmessages;
    End Until ANURemoteProcedureCallInProgress = False;
End;

Function removetrailingspaces(tempstring: String): String;
Var
  x: integer;
Begin
  // Remove trailing spaces
  If Length(tempstring) > 0 Then
  Begin
    x := length(tempstring);
    Repeat
      Begin
        If Copy(tempstring, x, 1) = ' ' Then
          tempstring := copy(tempstring, 1, x - 1)
        Else
          x := 1;
        dec(x);
    End Until x = 0;
  End;
  result := tempstring;
End;

Function FMToDateConvert(DateTimeST: String): String;
Begin
  Result := caprisupport.FMToDateConvert(DateTimeST);
End;

Procedure TfrmMain.btnVistAWebHomeClick(Sender: TObject);
Var
  tempstring, tempstring2: String;
  tempdivision: String;
  tempDUZ: String;
  tempUserDivision: String;
  x: integer;
  URLString: String;
Begin
  tempDivision := '';
  // Check for URL
  //CAPRI_CodeCR95  - jcs - 05/20/2010
  if not CallRPC(RPCBroker1, 'DVBAB GET URL', ['3'], nil) then
    exit;

  If RPCBroker1.Results.Count > 0 Then
  Begin
    If Piece(RPCBroker1.Results[0], '^', 1) = '-1' Then
    Begin
      TabVistAWeb.Visible := False;
      TabVistAWeb.TabVisible := False;
      exit;
    End;
  End
  Else
  Begin
    TabVistAWeb.Visible := False;
    TabVistAWeb.TabVisible := False;
    exit;
  End;

  URLString := RPCBroker1.Results[0];

  {CodeCR181 - rpm 3/31/11 - always return division at patient location for VistaWeb}
  tempDivision := Piece(GetDivision(False, RPCBroker1), '^', 3);
  if tempDivision = '' then
    tempDivision := '???';

  If ESSOVersion = True Then
  Begin
    tempUserDivision := '100';
    tempDUZ := UserDUZHomeServer;
  End
  Else
  Begin
    tempUserDivision := tempDivision;
    {Get User DUZ}

    //CAPRI_CodeCR95  - jcs - 05/20/2010
    if not CallRPC(RPCBroker1, 'XWB GET VARIABLE VALUE', ['DUZ'], nil, True) then
      exit;

    tempDUZ := RPCBroker1.Results[0];
  End;
  //URLString:='https://vistaweb.domain.ext/CapriPage.aspx';
  tempString := URLString + '?q9gtw0' +
    '=' +
    tempUserDivision
    + '&yiicf=' +
    tempDUZ                                                                     // User DUZ
    + '&hiaoe=' +
    AuthorSSN
    + '&qqlwel=' +
    AuthorName + '&xqi4z=' +
    PatientIEN +
    '&vmc3ed5f=' + tempDivision;
  //+
  //'&hs77sq=bMdlIJod56'; // App Passcode
  tempstring2 := '';
  If length(tempstring) > 0 Then
    For x := 1 To length(tempstring) Do
      If tempstring[x] <> ' ' Then
        tempstring2 := tempstring2 + tempstring[x]
      Else
        tempstring2 := tempstring2 + '%20';
  tempstring := tempstring2;

  If sender = bitbtnLaunchVistaWeb Then
  Begin
    xHyperlinkLabel1.targetURL := tempstring;
    xHyperlinkLabel1.Navigate;
  End
  Else
    WebBrowser1.Navigate(tempString);

End;


Function TfrmMain.AuthorizedOption(Const OptionName: String): Boolean;
{ checks to see if the user is authorized to use this application }
Begin
  EnsureBroker;
  RPCBrokerCall;
  Result := RPCBroker1.CreateContext(OptionName);
  //Set up Server/Port values to be used by Telnet window - rpm 3/16/09
  if RPCBroker1.ANUstrServer = '' then
  begin
    RPCBroker1.ANUstrServer := RPCBroker1.Server;
    RPCBroker1.ANUstrPort := IntToStr(RPCBroker1.ListenerPort);
  end;
End;

Procedure TfrmMain.EnsureBroker;
{ ensures that a broker object has been created - creates & initializes it if necessary }
Begin
  If RPCBroker1 = Nil Then
  Begin
    RPCBroker1 := TCCOWRPCBrokerCAPRI.Create(Application);
    With RPCBroker1 Do
    Begin
      ClearParameters := True;
      ClearResults := True;
         ugMode := False;
    End;
  End;
End;

Procedure TfrmMain.SetBrokerServer(Const AName: String; APort: Integer; Want   ug: Boolean);
{ makes the initial connection to a server }
Begin
  EnsureBroker;
  With RPCBroker1 Do
  Begin
    Server := AName;
    If APort > 0 Then
      ListenerPort := APort;
       ugMode := Want   ug;
    Connected := True;
  End;
End;

Function TfrmMain.ConnectToServer(Const OptionName: String): Boolean;
{ establish initial connection to server using optional command line parameters and check that
  this application (option) is allowed for this user }
Var
  APort: String;
  AServer: String;
  i: Integer;
  ModalResult: Integer;
  Want   ug: Boolean;
  x: String;
  IsConnected: Boolean;
Begin
  Result := False;
  Want   ug := False;
  AServer := '';
  APort := '';

  If BrokerFirstLogin Then                                                      // LMS
  Begin
    RPCBroker1.ANUTestMode := False;
    RPCBrokerDOD.ANUTestMode := False;
    FHIESiteLocation := 'FHIE.DOMAIN.EXT,9200';                                 //production server

    PARAM_SAVE_VLER_WS := False;
    PARAM_SAVE_XML := False;
    FMVISearch   ug := FALSE;
    FNoDeleteVVA := False;

    TIdHTTPVler.SetVlerDasURL('');                                              // VlerDasURL := '';     // CodeCR540 JRL 12/11/13
    // VlerDasToken := '';   // CodeCR540 JRL 12/11/13     // LMS removed.

    For i := 1 To ParamCount Do                                                 // params may be: S[ERVER]=hostname P[ORT]=port DEBUG
    Begin
      If UpperCase(ParamStr(i)) = 'DEBUG' Then
        Want   ug := True;
      x := UpperCase(Piece(ParamStr(i), '=', 1));
      If (x = 'S') Or (x = 'SERVER') Then
        AServer := Piece(ParamStr(i), '=', 2);
      If (x = 'P') Or (x = 'PORT') Then
        APort := Piece(ParamStr(i), '=', 2);
      If (x = 'R') Or (x = 'REMOTE') Then
      Begin
        If Piece(ParamStr(i), '=', 2) = '1' Then
          essoversion := true
        Else
          essoversion := false;
      End;
      (* rpm 5/26/09 - TESTMODE parameter must be '1' to use
         Test.claims.isc-wash.domain.ext server with BSE.
         ANUTestMode property used to select correct ApplicationCode
         Set FHIE server to 'Silver' test server *)
      if (x = 'T') or (x = 'TESTMODE') then
        if (Piece(ParamStr(i), '=', 2) = '1') then
        begin
          RPCBroker1.ANUTestMode := True;
          RPCBrokerDOD.ANUTestMode := True;
          //Updated server DNS - rpm 11/14/12
          FHIESiteLocation := 'silverFHIE.vaco.domain,9200'                     //test server
        end;

      If (x = 'VISTAHOST') Then
        VistAHost := Piece(ParamStr(i), '=', 2);
      If (x = 'DEBUGSQA') Then
        If Piece(ParamStr(i), '=', 2) = '1' Then
        Begin
             ugSQA := true;
        End
        Else
             ugSQA := false;
      If (x = 'PNCSTIMEOUT') Then
        PNCSTimeoutValue := strtoInt(Piece(ParamStr(i), '=', 2));
      If (x = 'CONFIG508') Then
        If Piece(ParamStr(i), '=', 2) = '1' Then
        Begin
          configMode508 := true;
          Try
            frm508Messages.RichEditRaw508Messages.Lines.LoadFromFile(extractfilepath(application.exename) + 'CAPRI508Messages.txt');
            Application.messagebox('A local copy of custom Section 508 messages has been loaded.' + char(13) + 'It may be different from what has been compiled into CAPRI.', '508 Customization',
              MB_OK);
          Except
          End;
        End
        Else
          configMode508 := false;
      //NODELETEVVA parameter allows the option of not deleting the temporary
      //Virtual VA PDF file...primarily for testing
      if (UpperCase(ParamStr(i)) = 'NODELETEVVA') then                          //CodeCR353 - rpm 5/30/12
        FNoDeleteVVA := True;
      //SHOWDEBUGSEARCH parameter brings up the test utility for running the
      // MVI search - used for testing
      if (UpperCase(ParamStr(i)) = 'SHOWDEBUGSEARCH') then                      //CodeCR267 - rpm 8/28/12
        FMVISearch   ug := TRUE;

      if (UpperCase(ParamStr(i))) = 'SAVEXML' then
        PARAM_SAVE_XML := True;

      if (UpperCase(ParamStr(i))) = 'SAVEVLERWS' then
        PARAM_SAVE_VLER_WS := True;

      if (x = 'VLER') then
      begin
        TIdHTTPVler.SetVlerDasURL(Piece(ParamStr(i), '=', 2));                  // LMS wrap variable in optimization
      end;
    End;
    BrokerFirstLogin := False;
  End;
  If AServer = '' Then
  Begin
    AServer := RPCBroker1.Server;
    APort := IntToStr(RPCBroker1.ListenerPort);
  End;

  //AServer:='cor.isc-albany.domain.ext';
  //APort:='9560';
  //AServer:='forum.domain';
  //APort:='9400';

  If (AServer = '') Or (APort = '') Then
  Begin
    ModalResult := GetServerInfo(AServer, APort);
    //if ModalResult = mrCancel then exit; //SPH
    If ModalResult = mrCancel Then
    Begin
      //exit;
      //application.OnException:=MyTempExceptionHandler;
      application.terminate;
    End;
  End;

  // Force to ESSOVersion for Forum
  //CodeCR333 rpm 3/20/12 - add 'CLAIMS.FORUM.DOMAIN'
  If (Uppercase(AServer) = 'FORUM.DOMAIN') or
    (Uppercase(AServer) = 'CLAIMS.DOMAIN.EXT') or                               // lms 2013-03-25 - Added due to dynamic updates to FQDN entries for FORUM.DOMAIN, CLAIMS.FORUM.DOMAIN and IFCAP-VACO.domain are not allowed.
    (Uppercase(AServer) = 'FORUM.DOMAIN.EXT') or                                // lms 2013-03-25 - Added as above
    (Uppercase(AServer) = 'CLAIMS.FORUM.DOMAIN') Then
    EssoVersion := True;

  // use try..except to work around errors in the Broker SignOn screen
  Try
    if (RPCBroker1.ANUstrServerHome = '') or
      (AServer = RPCBroker1.ANUstrServerHome) then
      IsConnected := RPCBroker1.Connect2HomeServer(RPCBroker1.ANUAccessCodeHome,
        RPCBroker1.ANUVerifyCodeHome,
        AServer,
        APort,
        Want   ug)
    else
    begin
      if RPCBroker1.ANUBSEToken = '' then                                       //must return "home" and retrieve token
        RPCBroker1.Connect2HomeServer(RPCBroker1.ANUAccessCodeHome,
          RPCBroker1.ANUVerifyCodeHome,
          RPCBroker1.ANUstrServerHome,
          RPCBroker1.ANUstrPortHome,
          Want   ug);
      IsConnected := RPCBroker1.Connect2RemoteServer(Aserver, APort, Want   ug);
    end;
    //  SetBrokerServer(AServer, StrToIntDef(APort, 9200), Want   ug);
    if IsConnected then
    begin
      if AuthorizedOption(OptionName) then
      begin
        RPCBroker1.RPCTimeLimit := 28800;
        Result := True;
      end;
    end;
  Except
    On E: EBrokerError Do
    Begin
      If E.Code <> XWB_BadSignOn Then
        MessageDlgCAPRI(E.Message, mtError, [mbOK], 0);
      Result := False;
    End;
  End;
End;

Procedure TfrmMain.AppMessage(Var Msg: TMsg; Var Handled: Boolean);
Var
  bReaderRunning: Boolean;
  bReaderStateOn: Boolean;
  CrPos: TPoint;
  hNewWnd: HWnd;
  hWnd: THandle;
  message508: String;
  tempControl: TControl;
  tempstring: String;
  tempstring2: String;
  tempstring3: String;
  tempTToolBar: TToolBar;
  tempTWinControl: TWinControl;
  Text: String;
  x: integer;
  xx: integer;
  yy: integer;

  Function Removewindowscontrolstrings(st: String): String;
  Var
    x: integer;
  Begin
    result := '';
    If length(st) > 0 Then
      For x := 1 To length(st) Do
        If st[x] <> '&' Then
          result := result + st[x];
  End;                                                                          { Removewindowscontrolstrings }

  Procedure ButtonBarCheck;
  Var
    x: integer;
  Begin
    If assigned(tempTWinControl) Then
      If (UpperCase(Copy(tempTWinControl.Name, 1, 1)) = 'X') And
        (UpperCase(tempTWinControl.ClassName) = 'TTOOLBAR') Then
      Begin
        tempTToolBar := tempTWinControl As TToolBar;
        If tempTToolBar.ButtonCount > 0 Then
          For x := 0 To tempTToolBar.ButtonCount - 1 Do
            If tempTToolBar.Buttons[x].Marked = True Then
            Begin
              If piece(tempTToolBar.Buttons[x].Hint, '^', 4) <> 'CLICKED' Then
                tempTToolBar.Buttons[x].Hint := tempTToolBar.Buttons[x].Hint + '^CLICKED';
              FormIDChanged(Piece(tempTToolBar.Buttons[x].Hint, '^', 3));
            End;                                                                { for }
      End;                                                                      { if }
  End;                                                                          { ButtonBarCheck }

Begin
  tempTWinControl := Nil;
  CurrentControl := '';
  CurrentDialog := '';
  If screen.ActiveControl <> Nil Then
  Begin
    CurrentControl := screen.activecontrol.Name;
    CurrentDialog := screen.ActiveForm.Name;
  End;

  If (Msg.message = WM_MOUSEMOVE) Or (Msg.message = WM_KEYUP) Then
  Begin
    // Check screenreader state
    bReaderRunning := SystemParametersInfo(SPI_GETSCREENREADER, 0, @bReaderStateOn, 0);
    ScreenReaderActive := (bReaderRunning And bReaderStateOn);

    TimeOutCount := 0;

    If msg.message = WM_MouseMove Then
    Begin
        {rpm/jcs 9/21/2009 - Replace Mouse.CursorPos with Windows.GetCursorPos to
         prevent errors caused by screensavers.  Short-circuit when GetCursorPos
         fails.
        CrPos.x := mouse.CursorPos.x;
        CrPos.y := mouse.CursorPos.y;}
      if Windows.GetCursorPos(CrPos) then
        tempControl := FindDragTarget(CrPos, True)
      else                                                                      //failed: short-circuit
        Exit;

      If tempControl = Nil Then
        Exit;

      If Uppercase(tempControl.Classname) = 'TMEMO' Then
        tempLastMemo := tempcontrol As tmemo;

      If ((Uppercase(tempControl.ClassName) <> 'TMEMO')
        And (Uppercase(tempControl.Name) <> 'XBUTTONDETAILS'))
        And (assigned(formCustomHint)) Then
        If formCustomHint.Visible = true Then
        Begin
          formCustomHint.TimerShowHint.Enabled := False;
          If Uppercase(tempControl.Name) = 'RICHEDITHINT' Then
            exit;
        End;
    End;

    // Show 508 messages
    If SpeechAPIInstalled = True Then
    Begin
      If CurrentDialog <> screen.ActiveForm.Name Then
      Begin
        // Dialog changed, check for auto message
        message508 := '';
        x := 0;
        Repeat
          If uppercase(frm508Messages.RichEditRaw508Messages.Lines[x]) = uppercase('AMD.' + screen.ActiveForm.Name) Then
          Begin
            Repeat
              inc(x);
              If frm508Messages.RichEditRaw508Messages.Lines[x] <> '!@#$END$#@!' Then
                Message508 := Message508 + frm508Messages.RichEditRaw508Messages.Lines[x];
            Until frm508Messages.RichEditRaw508Messages.Lines[x] = '!@#$END$#@!';
            x := frm508Messages.RichEditRaw508Messages.Lines.Count;
            If SpeechAPIInstalled = True Then
            Begin
              If frmProperties.CheckBoxActivateSpeechPrompts.Checked Then
                SPVoice1.Speak('<speak>' + Message508 + '</speak>', SVSFlagsAsync + SVSFPurgeBeforeSpeak);
            End;
            //Application.MessageBox(PChar(Message508),'508 Automessage for Control',mb_ok);
          End;
          inc(x);
        Until x >= frm508Messages.RichEditRaw508Messages.Lines.Count - 1;
      End;
    End;

    If SpeechAPIInstalled = True Then
    Begin
      If (CurrentControl <> screen.activecontrol.Name) And (frmProperties.CheckBoxActivateSpeechPrompts.Checked = true) Then
      Begin
        message508 := '';
        // Control changed, speak it

        If Uppercase((Screen.ActiveControl.ClassName)) = 'TBUTTON' Then
        Begin
          message508 := ((Screen.ActiveControl) As TButton).Caption + ' button';
          Message508 := Removewindowscontrolstrings(message508);
        End
        Else
          If Uppercase((Screen.ActiveControl.ClassName)) = 'TBITBTN' Then
          Begin
            message508 := ((Screen.ActiveControl) As TButton).Caption + ' button';
            Message508 := Removewindowscontrolstrings(message508);
          End
          Else
            If Uppercase((Screen.ActiveControl.ClassName)) = 'TCHECKBOX' Then
            Begin
              message508 := ((Screen.ActiveControl) As TCheckBox).Caption + ' checkbox';
              If ((Screen.ActiveControl) As TCheckBox).Checked = True Then
                message508 := message508 + ' - checked'
              Else
                message508 := message508 + ' - not checked';
              Message508 := Removewindowscontrolstrings(message508);
            End;

        If message508 <> '' Then
          SPVoice1.Speak('<speak>' + Message508 + '</speak>', SVSFlagsAsync + SVSFPurgeBeforeSpeak);

        // Control changed, check for auto message
        message508 := '';
        x := 0;
        Repeat
          If uppercase(frm508Messages.RichEditRaw508Messages.Lines[x]) = uppercase('AMC.' + screen.ActiveForm.Name + '.' + screen.activecontrol.Name) Then
          Begin
            Repeat
              inc(x);
              If frm508Messages.RichEditRaw508Messages.Lines[x] <> '!@#$END$#@!' Then
                Message508 := Message508 + frm508Messages.RichEditRaw508Messages.Lines[x];
            Until frm508Messages.RichEditRaw508Messages.Lines[x] = '!@#$END$#@!';
            x := frm508Messages.RichEditRaw508Messages.Lines.Count;
            If SpeechAPIInstalled = True Then
            Begin
              If frmProperties.CheckBoxActivateSpeechPrompts.Checked Then
                SPVoice1.Speak('<speak>' + Message508 + '</speak>', SVSFlagsAsync + SVSFPurgeBeforeSpeak);
            End;
          End;
          inc(x);
        Until x >= frm508Messages.RichEditRaw508Messages.Lines.Count - 1;
      End;
    End;

    If SpeechAPIInstalled = True Then
    Begin
      If (configMode508 = true) And (msg.message = WM_KEYUP) And (Msg.wParam = VK_F1) Then
      Begin
        // Dialog help message activated
        message508 := '';
        x := 0;
        Repeat
          If uppercase(frm508Messages.RichEditRaw508Messages.Lines[x]) = uppercase('HMD.' + screen.ActiveForm.Name) Then
          Begin
            Repeat
              inc(x);
              If frm508Messages.RichEditRaw508Messages.Lines[x] <> '!@#$END$#@!' Then
                Message508 := Message508 + frm508Messages.RichEditRaw508Messages.Lines[x];
            Until frm508Messages.RichEditRaw508Messages.Lines[x] = '!@#$END$#@!';
            x := frm508Messages.RichEditRaw508Messages.Lines.Count;
            If SpeechAPIInstalled = True Then
            Begin
              If frmProperties.CheckBoxActivateSpeechPrompts.Checked Then
                SPVoice1.Speak('<speak>' + Message508 + '</speak>', SVSFlagsAsync + SVSFPurgeBeforeSpeak);
            End;
          End;
          inc(x);
        Until x >= frm508Messages.RichEditRaw508Messages.Lines.Count - 1;
      End;
    End;

    If SpeechAPIInstalled = True Then
    Begin
      If (configMode508 = true) And (msg.message = WM_KEYUP) And (Msg.wParam = VK_F2) Then
      Begin
        // Control help message activated
        message508 := '';
        x := 0;
        Repeat
          If uppercase(frm508Messages.RichEditRaw508Messages.Lines[x]) = uppercase('HMC.' + screen.ActiveForm.Name + '.' + screen.activecontrol.Name) Then
          Begin
            Repeat
              inc(x);
              If frm508Messages.RichEditRaw508Messages.Lines[x] <> '!@#$END$#@!' Then
                Message508 := Message508 + frm508Messages.RichEditRaw508Messages.Lines[x];
            Until frm508Messages.RichEditRaw508Messages.Lines[x] = '!@#$END$#@!';
            x := frm508Messages.RichEditRaw508Messages.Lines.Count;
            If SpeechAPIInstalled = True Then
            Begin
              If frmProperties.CheckBoxActivateSpeechPrompts.Checked Then
                SPVoice1.Speak('<speak>' + Message508 + '</speak>', SVSFlagsAsync + SVSFPurgeBeforeSpeak);
            End;
          End;
          inc(x);
        Until x >= frm508Messages.RichEditRaw508Messages.Lines.Count - 1;
      End;
    End;

    If (configMode508 = true) And (msg.message = WM_KEYUP) And (Msg.wParam = VK_F5) And (screen.ActiveForm.Name <> 'frm508Messages') Then
    Begin
      frm508Messages.EditCurrentControl.text := screen.activecontrol.Name;
      frm508Messages.EditCurrentDialog.text := screen.ActiveForm.Name;
      frm508Messages.BringToFront;
      frm508Messages.ShowModal;
      frm508Messages.TabbedNotebook1.PageIndex := 0;
      Try
      frm508Messages.MemoHelpCurrentDialog.SetFocus Except
      End;
    End;

    If (msg.message = WM_KEYUP) And (Msg.wParam = VK_F7) Then
    Begin
      text := screen.activecontrol.className;
      If (text <> 'TEdit') And (text <> 'TMemo') And (text <> 'TRichEdit') And
        (text <> 'TFMMemo') Then
      Begin
        exit;
      End;

      If Not assigned(frmSpellcheck) Then
      Begin
        // Need hourglass b/c word list takes time to load
        screen.cursor := crHourglass;
        frmSpellCheck := TfrmSpellCheck.Create(frmMain);
        screen.cursor := crDefault;
        textposspellcheck := 0;
        whichspellcheckline := 0;
      End;
      hWnd := screen.activecontrol.Handle;
      frmSpellCheck.RichEditTextToCheck.Lines.Clear;

      tempcontrol := Nil;

      If text = 'TEdit' Then
        tempControl := screen.activecontrol As TEdit;
      If text = 'TMemo' Then
        tempControl := screen.activecontrol As TMemo;
      If text = 'TRichEdit' Then
        tempControl := screen.activecontrol As TRichEdit;
      If text = 'TFMMemo' Then
        tempControl := screen.activecontrol As TFMMemo;

      text := '';

      xx := SendMessage(hWnd, WM_GETTEXTLENGTH, 0, 0);
      For xx := 0 To xx Do
        text := text + ' ';
      // Use pointer to first character of string space
      SendMessage(hWnd, WM_GETTEXT, Length(Text), integer(addr(text[1])));
      frmSpellCheck.RichEditTextToCheck.Text := text;
      text := '';                                                               // free up memory
      If frmSpellCheck.Visible = false Then
        If frmSpellcheck.Showmodal <> mrCancel Then
        Begin
          If tempControl = Nil Then
            exit;
          If tempcontrol Is TEdit Then
          Begin
            If TEdit(tempcontrol).readonly = false Then
            Begin
              If frmSpellCheck.RichEditTextToCheck.Text = '' Then
              Begin
                If UserConfirmsAssigningEmptyString Then
                  TEdit(tempcontrol).text := frmSpellCheck.RichEditTextToCheck.Text;
              End
              Else
                TEdit(tempcontrol).text := frmSpellCheck.RichEditTextToCheck.Text
            End
            Else
              showmessage('This control is read only.  Changes were not made.')
          End
          Else
            If tempcontrol Is TMemo Then
            Begin
              If TMemo(tempcontrol).readonly = false Then
              Begin
                If frmSpellCheck.RichEditTextToCheck.Text = '' Then
                Begin
                  If UserConfirmsAssigningEmptyString Then
                    TMemo(tempcontrol).text := frmSpellCheck.RichEditTextToCheck.Text
                End
                Else
                  TMemo(tempcontrol).text := frmSpellCheck.RichEditTextToCheck.Text
              End
              Else
                showmessage('This control is read only.  Changes were not made.');
            End
            Else
              If tempcontrol Is TRichEdit Then
              Begin
                If TRichEdit(tempcontrol).readonly = false Then
                Begin
                  If frmSpellCheck.RichEditTextToCheck.Text = '' Then
                  Begin
                    If UserConfirmsAssigningEmptyString Then
                      TRichEdit(tempcontrol).text := frmSpellCheck.RichEditTextToCheck.Text
                  End
                  Else
                    TRichEdit(tempcontrol).text := frmSpellCheck.RichEditTextToCheck.Text
                End
                Else
                  showmessage('This control is read only.  Changes were not made.');
              End
              Else
                If tempcontrol Is TFMMemo Then
                Begin
                  If TFMMemo(tempcontrol).readonly = false Then
                  Begin
                    If frmSpellCheck.RichEditTextToCheck.Text = '' Then
                    Begin
                      If UserConfirmsAssigningEmptyString Then
                        TFMMemo(tempcontrol).text := frmSpellCheck.RichEditTextToCheck.Text
                    End
                    Else
                      TFMMemo(tempcontrol).text := frmSpellCheck.RichEditTextToCheck.Text
                  End
                  Else
                    showmessage('This control is read only.  Changes were not made.');
                End;
        End;
    End;

  End;

  If PNCSResetDoneButton = True Then
  Begin
    PNCSResetDoneButton := False;
    If PNCSForm <> Nil Then
      PNCSForm.xButton4.Enabled := True;
  End;

  If (Msg.message = WM_LBUTTONUP) Then
  Begin
    If FirstRun = 1 Then
      exit;
    PauseScript := False;
    If PNCSForm = Nil Then
      exit;
    If PNCSForm <> Nil Then
      If PNCSForm.Active = False Then
        exit;
    PNCSEvent := True;
    tempstring2 := '';
    Try
      tempTWinControl := FindControl(msg.Hwnd);
      If tempTWinControl = Nil Then
        Exit;

      If tempTWinControl.Classname = 'TGroupButton' Then
      Begin
        // Get parent radiogroup name that'll be referenced in the script
        PNCSEventControl := tempTWinControl.Parent.Name;
        tempstring2 := tempTWinControl.Parent.Name;
        tempTWinControl.Hint := tempTWinControl.Parent.Hint;
        PNCSButtonWasClicked := True;
      End
      Else
        If tempTWinControl.Name <> '' Then
        Begin
          If uppercase(copy(tempTWinControl.Name, 1, 1)) = 'X' Then
          Begin
            // one of the form's buttons or objects was clicked, so don't reset
            // the script
            PNCSEvent := False;
            exit;
          End;
          PNCSEventControl := tempTWinControl.Name;
          PNCSButtonWasClicked := True;
        End
        Else
        Begin
          // PNCSEventControl:='';
        End;
    Except
    End;
    buttonbarcheck;
    If currentPNCSTabName = '' Then
      currentPNCSTabName := '??UNKNOWN??';
    If tempTWinControl <> Nil Then
      If tempTWinControl.ClassName = 'TTabbedNotebook' Then
        If Uppercase(tempTWinControl.Name) = 'XMETANOTEBOOK' Then
          currentPNCSTabName := (tempTWinControl As TTabbedNotebook).ActivePage;
    If (loggermodeforCPEP = true) Then
    Begin
      tempString := FormatDateTime('hh:nn:ss:zzz', now - starttime);
      If tempTWinControl <> Nil Then
      Begin
        tempstring3 := tempTWinControl.Hint;
        If tempTWinControl.Name = 'RichEditHint' Then
        Begin
          tempstring2 := Piece(tempTWinControl.Hint, '^', 2);
          tempstring3 := Piece(tempTWinControl.Hint, '^', 1);
          val(Piece(tempTWinControl.Hint, '^', 1), xx, yy);
          If yy <> 0 Then
            Raise Exception.Create('Error:val(Piece(tempTWinControl.Hint, ''^'', 1), xx, yy);>yy=' + IntToStr(yy) + ';');
        End
        Else
        Try
        val(tempTWinControl.Hint, xx, yy)Except xx := 0
        End;
        If tempTWinControl.Hint <> '' Then
          If xx > 0 Then
          Begin
            If tempstring2 = '' Then
              tempstring2 := tempTWinControl.Name;
            If tempTWinControl.Name = 'RichEditHint' Then
              tempstring2 := tempLastMemo.Name;
            RichEditFormEvents.Lines.Add('"' + FormatDateTime('hh:nn:ss:zzz', now) + '","' + tempstring + '","' + tempstring2 + '","' + tempstring3 + '","' + currentpncstabname + '","' + patientssn +
              '","Click"');
          End;
      End;
    End;
  End;

  If (Msg.message = WM_KEYUP) Then
  Begin

    If firstrun = 1 Then
      exit;
    PauseScript := True;
    SendPNCSCounter := 0;                                                       // Wait 2 seconds after final keypress to send a message
    tempTWinControl := FindControl(msg.Hwnd);
    buttonbarcheck;
    If (tempTWinControl <> Nil) Then
    Begin
      SendPNCSEvent := tempTWinControl.Name;
      SendPNCSEventHint := tempTWinControl.Hint;
    End
    Else
    Begin
      SendPNCSEvent := '8974u893oirjhwegerwuyrty34289rdjery8t949okdgjkfg';
      SendPNCSEventHint := '';
    End;

  End;

  If ANURemoteProcedureCallInProgress = true Then
  Begin
    If Msg.message = WM_CHAR Then
    Begin
      handled := True;
    End;
    If Msg.message = WM_LBUTTONUP Then
    Begin
      handled := True;
    End;
    If Msg.message = WM_MBUTTONUP Then
    Begin
      handled := True;
    End;
    If Msg.message = WM_RBUTTONUP Then
    Begin
      handled := True;
    End;
    If Msg.message = WM_LBUTTONDOWN Then
    Begin
      handled := True;
    End;
    If Msg.message = WM_MBUTTONDOWN Then
    Begin
      handled := True;
    End;
    If Msg.message = WM_RBUTTONDOWN Then
    Begin
      handled := True;
    End;
  End;

  Try                                                                           // Need the try...except to prevent error when returning from active screen saver
    If assigned(PNCSForm) And (PNCSForm.Active) Then
      If PNCSForm.xbuttondetails.visible = true Then
      Begin
        hNewWnd := WindowFromPoint(Mouse.CursorPos);
        If (hNewWnd <> hOldWnd) And (hNewWnd <> 0) Then
          If (assigned(formCustomHint) And (formCustomHint.Visible = False)) Or
            (Not assigned(formCustomHint)) Then
            If (PNCSForm.xButtonDetails.Handle <> hNewWnd) Then
              PNCSForm.xButtonDetails.Visible := False;
          // Don't lose the last handle if pointing to the button itself
        If hNewWnd <> PNCSForm.xButtonDetails.Handle Then
          hOldWnd := hNewWnd;
      End;                                                                      { if }
  Except
  End;

  { for all other messages, Handled remains False }
  { so that other message handlers can respond }
End;

Function TfrmMain.UserConfirmsAssigningEmptyString: boolean;
Var
  Msg: String;
Begin
  result := False;
  Msg := 'There will be no text transferred back into' + CR + LF;
  Msg := Msg + 'the original Memo control.' + CR + LF + CR + LF;
  Msg := Msg + 'Do you want to proceed?';
  If Application.MessageBox(PChar(Msg), 'Transfer empty text?', MB_YESNO) = IDYES Then
    result := True;
End;                                                                            { UserConfirmsAssigningEmptyString }

Procedure TfrmMain.AnimateLogo(YesOrNo: Boolean);
Begin
  If YesOrNo = True Then
  Begin
    Try
    ImageVistaRed.Visible := False Except
    End;
    TGifImage(GifImageVistaYellow.picture.Graphic).AnimationSpeed := 1500;
    TGifImage(GifImageVistaYellow.picture.Graphic).PaintStart;

    Try
    GifImageVistaYellow.Visible := True Except
    End;
    BitBtnVistA.enabled := false;
    //ChangeVerifyCode1.enabled:=False;
  End
  Else
  Begin
    Try
    ImageVistaRed.Visible := True Except
    End;
    TGifImage(GifImageVistaYellow.picture.Graphic).PaintStop;
    Try
    GifImageVistaYellow.Visible := False Except
    End;
    if EssoVersion = False Then
    begin
      BitBtnVistA.Enabled := False;
    end
    else
    begin
      BitBtnVistA.Enabled := True;                                              //only remote connections - rpm 3/17/09
    end;

    //ChangeVerifyCode1.enabled:=True;
    ANURemoteProcedureCallInProgress := False;
  End;
End;

Procedure TfrmMain.SaveToUsersTempDirectory(Sender: TObject; ErrorMsg: String; ParseErrorMsg: boolean);
Var
  AddText: String;
  DatePart: String;
  Filename: String;
  SaveFile: TextFile;
  TextHolder: String;
  VersionPart: String;
Begin
  //DatePart := IntToStr(DateTimeToFileDate(Date));
  DateTimeToString(DatePart, 'dd_mm_yy', Date);
  VersionPart := VersionUser;
  VersionPart := StringReplace(VersionPart, '*', '_', [rfReplaceAll]);
  Filename := TempDir + VersionPart + '_' + DatePart + '.Txt';
  SetFileAttributesReadOnly(Sender, Filename, False);
  AssignFile(SaveFile, FileName);
  { append each days messages or create a new file for each day }
  Try
    Try
      If FileExists(FileName) Then
        Append(SaveFile)
      Else
        ReWrite(SaveFile);
      WriteLn(SaveFile, '');
      WriteLn(SaveFile, 'APPLICATION EXCEPTION AT ' + DateTimeToStr(Now));
      WriteLn(SaveFile, 'User: ' + AuthorName);
      WriteLn(SaveFile, 'User Division: ' + UserDivision + CR + LF);
      If (Sender <> Nil) Then
        If (Sender Is TComponent) And (TComponent(Sender).Name <> '') Then
        Begin
          WriteLn(SaveFile, '-   Sender Name: ' + TComponent(Sender).Name);
          If (TComponent(Sender).Owner <> Nil) And (TComponent(Sender).Owner.Name <> '') Then
            WriteLn(SaveFile, '-   Sender Owner: ' + TComponent(Sender).Owner.Name);
        End;
      TextHolder := 'Error Message:  ' + ErrorMsg;
      If ParseErrorMsg Then
        Repeat
          Begin
            AddText := Copy(TextHolder, 1, 128);
            WriteLn(SaveFile, AddText);
            If AddText = ErrorMsg Then
              TextHolder := ''
            Else
              TextHolder := Copy(TextHolder, 129, length(TextHolder) - 128);
        End Until TextHolder = ''
      Else
        WriteLn(SaveFile, TextHolder);
    Except
      On e: EInOutError Do
        Application.MessageBox(PChar(E.Message), PChar('Exception File Error'), MB_OK);
    End;                                                                        { try/except }

  Finally
    Try
      Flush(SaveFile);
      CloseFile(SaveFile);
      SetFileAttributesReadOnly(Sender, Filename, True);
    Except
      CloseFile(SaveFile);
    End;                                                                        { try/finally }
  End;                                                                          { try/finally }

End;                                                                            { SaveToUsersTempDirectory }

Procedure TfrmMain.SetFileAttributesReadOnly(Sender: TObject; FileName: String; ReadOnly: boolean);
Var
  Attributes: word;
  Msg: String;
  NewAttributes: word;
  ToFrom: String;
Begin
  If FileExists(Filename) Then
  Begin
    Attributes := FileGetAttr(Filename);
    If ReadOnly Then
      ToFrom := 'to'
    Else
      ToFrom := 'from';

    If ReadOnly Then
      NewAttributes := Attributes + SysUtils.faReadOnly
    Else
      NewAttributes := Attributes - SysUtils.faReadOnly;

    If FileSetAttr(Filename, NewAttributes) <> 0 Then
    Begin
      Msg := 'Could not change ' + ToFrom + ' ReadOnly: ' + FileName;
      SaveToUsersTempDirectory(Sender, Msg, False);
    End;
  End;                                                                          { File exists }
End;                                                                            { SetFileAttributesReadOnly }

{ procedure TfrmMain.ApplicationEvents1Message(var Msg: tagMSG;
  var Handled: Boolean);
var
  mousePos: TPoint;
  wc: TWinControl;
begin
  // mouse wheel scrolling for the control under the mouse
  if Msg.message = WM_MOUSEWHEEL then
  begin
    mousePos.X := Word(Msg.lParam);
    mousePos.Y := HiWord(Msg.lParam);
    wc := FindVCLWindow(mousePos);
    if wc = nil then
      Handled := True
    else
      if wc.Handle <> Msg.hwnd then
      begin
        SendMessage(wc.Handle, WM_MOUSEWHEEL, Msg.wParam, Msg.lParam);
        Handled := True;
      end;
  end;
end; }

(* procedure TfrmMain.ApplicationEvents1Idle(Sender: TObject; var Done: Boolean);
var
  ctrl: TWinControl;
begin
{$IFDEF CAPRIDEVELOPER}
  ctrl := FindVCLWindow(Mouse.CursorPos);
  if ctrl <> nil then
  begin
    Caption := ctrl.Name;
  end;
{$ENDIF}
end; *)

{===========================================================================
CAPRI_CodeCR95  - jcs - 05/20/2010
Made several changes in relation to the new RPC Broker call wrapper.
The intent here is to display additional information to the user, then
force a shut down of the application after an error occurs.

Modification history:
  02/2011  -MER v149 build 7 This procedure was modified to terminate the
    application only when critical errors occurred.
===========================================================================}
Procedure TfrmMain.ApplicationExceptionHandler(Sender: TObject; E: Exception);
Var
  Msg: String;
  MsgError: String;
  LogMessage: String;
  CallStack: TStringList;
  i: Integer;

  Procedure PrepareMessages(NeedTerminate: Boolean);                            // -MER 02/2011
  Begin
    MsgError := E.Message;
    Msg := 'An error has been captured at the application level by CAPRI. ' + CRLF;
    if NeedTerminate then begin                                                 // -MER 02/2011
      Msg := Msg + 'CAPRI must now shut down in order to recover from the error.' + CRLF + CRLF;
      Msg := Msg + 'Please re-launch CAPRI and verify the state of any work that was in progress.' + CRLF;
    end;
    Msg := Msg + CR + LF + 'The following information describes the error:' + CRLF + CRLF;
  End;                                                                          { PrepareMessages }

  Procedure ShowUserMessage;
  Var
    UserCaption: String;
    UserMsg: String;
  Begin
    UserMsg := Msg + MsgError;
    UserCaption := 'CAPRI: Application Exception';
    { filter only frmPNCS with Sender <> Nil }
    Application.MessageBox(PChar(UserMsg), PChar(UserCaption), MB_OK);
  End;                                                                          { ShowUserMessage }

Begin
  Screen.cursor := crDefault;

  //CAPRI_CodeCR94 - jcs - 03/02/10
  CallStack := TStringList.Create;
  try                                                                           // -MER 2/2011
    JclLastExceptStackListToStrings(CallStack, False, True, True, True);
    LogMessage := #13 + #10 + #13 + #10 + 'Call Stack:' + #13 + #10;

    for i := 0 to CallStack.count - 1 do
      LogMessage := LogMessage + CallStack[i] + #13 + #10;
    SaveToUsersTempDirectory(Sender, E.Message + LogMessage, False);
  finally
    CallStack.Free;
  end;

  // -MER 2/2011 Branch on the type of exception.  We will terminate for
  // critical exceptions.  For all other exceptions that are not class
  // EPascalScriptFailure, we will show a formatted message
  if (E is EBrokerError) or (E is EAccessViolation) or (E is EHeapException) or
    (E is EInvalidOp) or (E is EInvalidPointer) or (E is EOSError) or
    (E is EOutOfMemory)
    then begin
    // Need to terminate
    if shuttingdown <> true then begin
      PrepareMessages(TRUE);
      ShowUserMessage;
    end;
    Application.Terminate;
  end else if not (E Is EPascalScriptFailure) then begin
    // for EPascalScriptFailure, the user has already been notified.  In all
    // other cases, we show the user message, but do not terminate
    if shuttingdown <> true then begin
      PrepareMessages(FALSE);
      ShowUserMessage;
    end;
  end;
End;                                                                            { ApplicationExceptionHandler }

Procedure TfrmMain.FormCreate(Sender: TObject);
Var
  DirectoryName: String;
  fStream: TMemoryStream;
  rStream: TResourceStream;
  SOToken: ISpeechObjectToken;
  SOTokens: ISpeechObjectTokens;
  x: integer;
  y: integer;
  lslConfig: TStringList;                                                       // CodeCR168 -MER 04/2011
  OrigHelpFile: String;                                                         // CodeCR381 - LMS 2012-11-15
  NewHelpFile: String;                                                          // CodeCR381 - LMS 2012-11-15
  ChangeHelp: Boolean;                                                          // CodeCR381 - LMS 2012-11-15

  //sColor should be in XXXXXX format
  //(X being a hex digit)
  Function HexToTColor(sColor: String): TColor;
  Begin
    Result :=
      RGB(
      { get red value }
      StrToInt('$' + Copy(sColor, 1, 2)),
      { get green value }
      StrToInt('$' + Copy(sColor, 3, 2)),
      { get blue value }
      StrToInt('$' + Copy(sColor, 5, 2))
      );
  End;

Begin
  Application.HelpFile := ExtractFilePath(Application.ExeName) + 'CAPRI_Help.CHM'; // CodeCR381 -MER 6/2012

  OrigHelpFile := Application.HelpFile;
  CAPRIHelpMgr.ChangeApplicationHelpFileToLocal(OrigHelpFile, NewHelpFile, ChangeHelp); // CodeCR381 - LMS 2012-11-15
  If ChangeHelp then Application.HelpFile := NewHelpFile;

  ReflectionWrapper := TReflectionWrapper.Create;                               // CodeCR185 -MER 04/2011
  WaitForm := TWaitForm.Create(Application);

  dtpDODStartDate.Date := NOW;                                                  //CodeCR102 - rpm 4/12/10
  dtpDODEndDate.Date := NOW;                                                    //CodeCR102 - rpm 4/12/10
  dtpDODStartDate.MinDate := EncodeDate(1988, 01, 01) {01/01/1988};             //CodeCR102 - rpm 4/12/10, CodeCR165 - rpm 2/24/11
  dtpDODEndDate.MinDate := EncodeDate(1988, 01, 01) {01/01/1988};               //CodeCR102 - rpm 4/12/10, CodeCR165 - rpm 2/24/11

  VistAHost := '';                                                              // This will be used for telnet, if the user defines a command line argument.

  VersionUser := GetVersionUser;

  Application.OnException := ApplicationExceptionHandler;                       //zzz rlm
  Randomize;
  TempDir := GetTempDir;                                                        // Set/Find this machines temporary directory
  RecordAudit('Starting CAPRI', 'Audit');

  frmWindowsProcesses := TfrmWindowsProcesses.Create(frmMain);
  If frmWindowsProcesses.processListBox.Items.Count > 0 Then
    frmWindowsProcesses.ShowModal;
  frmWindowsProcesses.Release;

  PNCSTimeoutValue := 7200;

  UserHasNewStyleRestrictedList := -1;

  frmBrokerHistoryBuffer := TfrmBrokerHistoryBuffer.Create(frmMain);
  frm508Messages := Tfrm508Messages.Create(frmMain);
  frmMacroEditor := TfrmMacroEditor.Create(frmMain);

  loggermodeforCPEP := false;


  noprinting := false;
  Try
    formPrintConfirm := tformPrintConfirm.Create(frmMain);
    formPrint := TformPrint.Create(frmMain);
  Except
    noprinting := true;
  End;

  formNews := TformNews.Create(frmMain);
  formNews.RichEditNews.Lines.Clear;

  UserHomePrimaryMenu := '';
  TelnetCaptureFile := '';
  SwitchToSite := '';

  //application.OnException:=MyTempExceptionHandler;
  CCOWInitialized := False;

  // Next line forces CCOW off for now.  Remove it to activate CCOW.
  // CCOWMode:=true;
  // 1/20/2006, SPH

  essoversion := false;
  //essoversion:=true;
  //If ESSOVersion=True then begin
  //  RPCBroker1.Server:='forum.domain';
  //  RPCBroker1.ListenerPort:=9400;
  //end;

  //If EssoVersion=true then
    //BitBtnVistA.Visible:=True else BitBtnVistA.Visible:=False;

  //If ESSOVersion=True then CCOWMode:=False;

  AppStarted := False;
  //TempDir := GetTempDir; // Set/Find this machines temporary directory
  Application.OnMessage := AppMessage;
  PNCSEvent := False;

  //  tempFormObjectList := TList.Create;
  //  tempMergeScripts := TList.Create;

  LabelICN.Caption := '';
  LabelDOB.Caption := '';
  TabCPWorksheets.TabVisible := False;
  // rpm 12/10/09 - disabling C&P Worksheets tab while not visible causes a
  // visible DOD tab to appear ghosted (disabled) when it occupies the same space.
  // TabCPWorksheets.Enabled := False;
  actToolsUnsignedWorkSheets.Visible := False;
  CancellationReason := '';

  RPCBroker1.ANUUserSpecs := '';
  ReadOnlyMode := False;
  SurgeryReports := TStringList.Create;

  uLocalReportData := TStringList.Create;
  uHSComponents := TStringList.Create;

  TempHSMemo := TStringList.Create;

  frmProperties := TfrmProperties.Create(frmMain);
  frmROFinder := TfrmROFinder.Create(frmMain);

  //////////////////////////// Section 508 Speech Engine Check ///////////////////////////

  //Jaws uses the Microsoft Speech API.

  //Lots of info:
  //http://support.microsoft.com/default.aspx?scid=kb;en-us;306902

  //How to know if MS Speech is installed:
  //When you install on of the SAPI SDK distributions you will find spchapi.exe in the  "\Program Files\Microsoft Speech SDK\REDIST\API" directory.

  // Nice explanation:
  //http://bdn.borland.com/article/0,1410,29583,00.html

  Try
    SpeechAPIInstalled := True;
  Except
    SpeechAPIInstalled := False;
  End;

  // Turn off speech in V105
  SpeechAPIInstalled := False;

  If SpeechAPIInstalled = True Then
  Begin
    SPVoice1.Connect;
    For x := 1 To 100 Do
    Begin
      For y := 1 To 1000 Do
        application.processmessages;
      sleep(1);
    End;
    //SPVoice1.Speak('<speak>This is the default voice, which should also be the <voice gender="male">default voice</voice></speak>',0 );
    // Give speech the time to set up
    frmProperties.ComboBoxVoice.Items.Clear;
    frmProperties.ComboBoxVoice.ItemIndex := -1;

    frmProperties.groupBoxSpeech.enabled := true;
    // Enumerate voices
    //Ensure all events fire
    SPVoice1.EventInterests := SVEAllEvents;
    SOTokens := SPVoice1.GetVoices('', '');
    For x := 0 To SOTokens.Count - 1 Do
    Begin
      //For each voice, store the descriptor in the TStrings list
      SOToken := SOTokens.Item(x);
      frmProperties.ComboBoxVoice.Items.AddObject(SOToken.GetDescription(0), TObject(SOToken));
      //Increment descriptor reference count to ensure it's not destroyed
      SOToken._AddRef;
    End;

    frmProperties.ComboBoxVoice.ItemIndex := 0;
    frmProperties.ComboBoxVoiceChange(Application);

  End
  Else
  Begin
    frmProperties.groupBoxSpeech.enabled := false;
  End;

  ////////////////////// End of Section 508 Speech Engine Check ///////////////////////////

  frmZipCodes := TfrmZipCodes.Create(frmMain);
  rStream := TResourceStream.Create(hInstance, 'Zipcodes', RT_RCDATA);
  Try
    fStream := TMemoryStream.Create;
    Try
      fStream.CopyFrom(rStream, 0);
      fStream.Position := 0;
      frmZipCodes.RichEdit1.Lines.LoadFromStream(fStream);
      //frmZipCodes.richedit1.lines.savetofile('c:\temp\temp.txt');
    Finally fStream.Free;
    End;
  Finally rStream.Free;
  End;
  //  frmZipCodes.Show;

  If ESSOVersion = true Then
  Begin
    // Don't allow change verify code
    //ChangeVerifyCode1.Visible:=False;
    ButtonRDV.Enabled := False;
    //MailManHome1.Visible:=True;
  End;

  BrokerFirstLogin := True;

  NumberClinDocsToRetrieve := 100;
  buttonClinDocDateRange.Caption := '100 Documents';

  RPCBroker1.Server := '';

  TimeOutVal := 0;
  Application.OnMessage := AppMessage;

  DateTimePicker1.Date := Now;
  DateTimePicker2.Date := Now;

  frmLabGraph := TfrmLabGraph.Create(frmMain);
  //frmNHE:=TfrmNHE.Create(frmMain);
 //formVitalsGraph:=TformVitalsGraph.Create(frmMain);
  ProgramNameCaption := frmMain.Caption;
  ReportMemo.ReadOnly := True;
  HSMemo.ReadOnly := True;
  MemoDocs.ReadOnly := True;
  MemoAppointments.ReadOnly := True;

  InsufficientExam := False;                                                    // Set flag
  {Store directory of .exe for reference later}
  DirectoryName := Application.ExeName;
  IPRDirectory := '';
  If Pos('\', DirectoryName) > 0 Then
    Repeat
      Begin
        IPRDirectory := IPRDirectory + Copy(DirectoryName, 1, Pos('\', DirectoryName));
        Delete(DirectoryName, 1, Pos('\', DirectoryName));
    End Until Pos('\', DirectoryName) = 0;
  listMedicalCenterDivision := TStringList.Create;
  listlabTestNames := TStringList.Create;
  UserKeys := TStringList.Create;
  listDocs := TStringList.Create;
  listExams := TStringList.Create;
  ListRestrictedPatients := TStringList.Create;

  //Center on screen
  frmMain.Left := (Screen.Width Div 2) - (frmMain.Width Div 2);
  frmMain.Top := (Screen.Height Div 2) - (frmmain.Height Div 2);

  // Set some defaults, just in case they're needed
  ipc_TermBufForeColor := clBlack;
  ipc_TermBufBackColor := clWhite;

  //Load settings from previous session
  if FileExists('c:\capri.cfg') then begin
    // CodeCR168 -MER 04/2011  Previously, a memoBox was used to load the config
    // information.  This resulted in problems when the line width was greater
    // than what the control could contain.  The memoBox has been replaced with
    // a stringlist
    lslConfig := TStringList.Create;
    try
      try
        lslConfig.LoadFromFile('c:\capri.cfg')
      except
        // eat the exception
      end;
      If lslConfig.Count > 27 Then
      Begin
        If lslConfig.Count > 1 Then
        Begin
          //Put in code to delete config file if it's not the
          //right length.  This means it's old or been modified
          //Then exit.
          Try frmMain.Top := StrToInt(lslConfig[0])Except End;
          Try frmMain.Left := StrToInt(lslConfig[1])Except End;
          Try frmMain.Width := StrToInt(lslConfig[2])Except End;
          Try frmMain.Height := StrToInt(lslConfig[3])Except End;
          If lslConfig[4] = 'WSMAXIMIZED' Then
            frmMain.WindowState := wsMaximized
          Else
            frmMain.WindowState := wsNormal;
          Try
          lstDocs.Width := StrToInt(lslConfig[5])Except
          End;
          If lstDocs.Width > frmMain.Width - 100 Then
            lstDocs.Width := frmMain.Width - 100;
          Try
          ORHealthSummaryUserList.Width := StrToInt(lslConfig[6])Except
          End;
          If ORHealthSummaryUserList.Width > frmMain.Width - 100 Then
            ORHealthSummaryUserList.Width := frmMain.Width - 100;
          Try
          ORReportsAvailable.Width := StrToInt(lslConfig[7])Except
          End;
          If ORReportsAvailable.Width > frmMain.Width - 100 Then
            ORReportsAvailable.Width := frmMain.Width - 100;
          FontDialog1.Font.Name := lslConfig[8];
          FontDialog1.Font.Size := StrToInt(lslConfig[9]);
          If lslConfig[10] = 'TRUE' Then
            FontDialog1.font.style := FontDialog1.font.style + [fsbold];
          If lslConfig[11] = 'TRUE' Then
            FontDialog1.font.style := FontDialog1.font.style + [fsItalic];
          If lslConfig[12] = 'TRUE' Then
            FontDialog1.font.style := FontDialog1.font.style + [fsUnderline];
          If lslConfig[13] = 'TRUE' Then
            FontDialog1.font.style := FontDialog1.font.style + [fsStrikeout];
          Try
          frmProperties.ScrollBarKeyboardSensitivity.Position := strtoint(lslConfig[14])Except
          End;
          Try
          RemoteSiteName := lslConfig[15]Except
          End;
          x := 16;
          //Address Info
          MemoNameAddressHolder.Lines.Clear;
          Try
            If ((lslConfig[x] <> '^NONE^') And (lslConfig[x] <> '')) Then
            Begin
              Repeat
                Begin
                  MemoNameAddressHolder.Lines.Add(Copy(lslConfig[x], 2, length(lslConfig[x]) - 1));
                  inc(x);
              End Until (x > lslConfig.count - 1) Or (copy(lslConfig[x], 1, 1) <> '~');
            End
            Else
              inc(x);
          Except
          End;
          TelnetConfigX := x;
          If TelnetConfigX > 0 Then
          Begin
            Try
              ipc_TermBufForeColor := HexToTColor(lslConfig[x + 6]);
            Except
              ipc_TermBufForeColor := clBlack;
            End;
            Try
              ipc_TermBufBackColor := HexToTColor(lslConfig[x + 7]);
            Except
              ipc_TermBufBackColor := clWhite;
            End;
            frmTelnet := TfrmTelnet.Create(frmMain);
            Try
              frmTelnet.Width := strtoint(lslConfig[x]);
            Except
            End;
            inc(x);
            Try
              frmTelnet.Height := strtoint(lslConfig[x]);
            Except
            End;
            inc(x);
            Try
              frmTelnet.Left := strtoint(lslConfig[x]);
            Except
            End;
            inc(x);
            Try
              frmTelnet.Top := strtoint(lslConfig[x]);
            Except
            End;
            inc(x);
            Try
              frmTelnet.IPTerminal1.Font.Size := strtoint(lslConfig[x]);
            Except
            End;
            inc(x);
            Try
              frmTelnet.IPTerminal1.Font.Name := lslConfig[x];
            Except
            End;
            inc(x);
            inc(x);
            inc(x);

            //showmessage(inttostr(frmTelnet.IPTerminal1.Font.Size)+' : '+frmTelnet.IPTerminal1.Font.Name);
            telnetConfigX := -1;
          End
          Else
          Begin
            // Telnet data not there yet
            frmTelnet := TfrmTelnet.Create(frmMain);
            frmTelnet.Width := 589;
            frmTelnet.Height := 509;
            frmTelnet.IPTerminal1.Font.Size := 11;
            frmTelnet.IPTerminal1.Font.Name := 'Terminal';
          End;

          // Speech Settings
          If frmProperties.ComboboxVoice.Items.Count > 0 Then
            For y := 0 To frmProperties.ComboBoxVoice.Items.Count - 1 Do
              If frmProperties.ComboboxVoice.Items[y] = lslConfig[x] Then
                frmProperties.ComboboxVoice.ItemIndex := y;
          inc(x);
          Try
          frmProperties.TrackBarSpeechRate.Position := strtoint(lslConfig[x])Except
          End;
          inc(x);
          Try
          frmProperties.TrackBarSpeechVolume.Position := strtoint(lslConfig[x])Except
          End;
          inc(x);
          Try
            If lslConfig[x] = 'TRUE' Then
              frmProperties.CheckBoxActivateSpeechPrompts.Checked := True
            Else
              frmProperties.CheckBoxActivateSpeechPrompts.Checked := False;
          Except
          End;
          If SpeechAPIInstalled = True Then
            frmProperties.ComboBoxVoiceChange(Application);
          If SpeechAPIInstalled = False Then
            frmProperties.CheckBoxActivateSpeechPrompts.Checked := False;
          If frmProperties.CheckBoxActivateSpeechPrompts.Checked Then
          Begin
            //frmMain.SPVoice1.Rate:=0;
            //frmMain.SPVoice1.Volume:=100;
            SPVoice1.Speak('<speak>checking network connections</speak>', 0);
          End;
          //frmProperties.TrackBarSpeechRateChange(Application);
          //frmProperties.TrackBarSpeechVolumeChange(Application);

          SetFont;
        End;
      End
      Else
      Begin
        // No config file found
        frmTelnet := TfrmTelnet.Create(frmMain);
        frmTelnet.Width := 589;
        frmTelnet.Height := 509;
        frmTelnet.IPTerminal1.Font.Size := 11;
        frmTelnet.IPTerminal1.Font.Name := 'Terminal';
      End;
    finally
      lslConfig.Free;
    end;
  end else begin
    // No config file found
    frmTelnet := TfrmTelnet.Create(frmMain);
    frmTelnet.Width := 589;
    frmTelnet.Height := 509;
    frmTelnet.IPTerminal1.Font.Size := 11;
    frmTelnet.IPTerminal1.Font.Name := 'Terminal';
  end;                                                                          // if FileExists('c:\capri.cfg') then begin
  // Make sure not off the boundaries of the screen if resolution changed
  If frmmain.Left + frmMain.Width > screen.width Then
    frmMain.Left := Screen.Width - frmMain.Width;
  If frmMain.Left < 0 Then
    frmMain.Left := 0;
  If frmMain.Width > Screen.Width Then
    frmMain.Width := Screen.Width;
  If frmmain.Top + frmMain.Height > screen.height Then
    frmMain.Top := Screen.Height - frmMain.Height;
  If frmMain.Top < 0 Then
    frmmain.Top := 0;
  If frmMain.Height > Screen.Height Then
    frmMain.Height := Screen.Height;

  If ESSOVersion = False Then
  Begin
    // ContextorControl is used for CCOW.

    RPCBroker1.Contextor := Nil;
    // This needs to be re-activated in order for CCOW to function
    // It's beeing taken out from V71 for now.

    If CCOWMode = True Then
    Try
      Begin
        ContextorControl := TContextorControl.Create(frmMain);
        ContextorControl.OnPending := ContextorControlPending;
        ContextorControl.OnCanceled := ContextorControlCanceled;
        ContextorControl.OnCommitted := ContextorControlCommitted;
        RPCBroker1.Contextor := ContextorControl;
    End Except
      Begin
        CCOWMode := False;
          // Contextor component not installed
      End
    End;

    Try
      If ContextorControl <> Nil Then
      Begin
        ContextorControl.Run(APP_NAME + '#'                                     // The pound sign allows multiple instances to run in CCOW mode
          , ''
          , TRUE                                                                // VARIANT_TRUE == -1 in COM
          , '*');

        (*
            ContextorControl.Run( 'BrokerLoginModule' + '#'
                           , 'kqdQ8siyn1_XwshtOYUJU6orRQVV_PWhKWK9TVbRGG3AnVlKoSHPTRbS-KP3MLAYq5wcmkKIDZUaLWELN0uiAbseTlqwK0ARhZEPqoJzyn9r319qvp_kWP1_dGE'+
                             'IQmnoB4pKsVrVqCMEXMNZdQ0KCp5QeX7nHqg1oQwxHRlH1MpMwnUBFTqAZgs_wfDwDgitY3sDyAM3fKnQtXQBSUaH2a5ZfFajnJxCERavwh3aWOgsHoKwyTmDSssHupUjnPy7'
                           , TRUE  // VARIANT_TRUE == -1 in COM
                           , '*');
        *)

        If ContextorControl.State = 2 Then
          CCOWMode := True
        Else
        Begin
          CCOWMode := False;
          ShowmessageCAPRI('CCOW mode couldn''t be activated.  The application will run, but CCOW functionality will be unavailable.');
          RPCBroker1.Contextor := Nil;
        End;
      End;
    Except
      CCOWMode := False;
    End;                                                                        // Some problem with CCOW vault
  End;

  If CCOWMode = True Then
  Begin
    bitbtnCCOWLink.BringToFront;
    bitbtnCCOWLink.Visible := True;
    BitBtnCCOWLinkBroken.Visible := False;
    BitBtnCCOWLinkChanging.Visible := false;
  End
  Else
  Begin
    bitbtnCCOWLink.Visible := false;
    bitbtnCCOWLinkBroken.Visible := false;
    bitbtnCCOWLinkChanging.Visible := false;
  End;

  // Check news
  TimerNewsTimer(RPCBroker1);                                                   // Need some control here to force pop up at startup but not other times.

  actFileConnect.Execute;

  If EssoVersion = False Then
    ButtonOtherSites.Visible := False;
  frmMain.Show;
  frmMain.Repaint;

  actFileSelectPatient.Execute;

//  FPatientInfoBucket := nil;
  if Assigned(FPatientInfoBucket) then                                          // rpk 2/12/2015
    FreeAndNil(FPatientInfoBucket);                                             // rpk 2/12/2015
End;                                                                            // FormCreate

procedure TfrmMain.FormMouseWheel(Sender: TObject; Shift: TShiftState;          // CodeCR700 rpk 3/5/2015
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
var
  tbool: Boolean;
  wc: TWinControl;
begin
  if Page95Control1.ActivePage = TabCPWorksheets then begin
    wc := ListBoxIPR1;
    if wc <> nil then begin
      tbool := ScrollBox(wc, MousePos, WheelDelta);
      Handled := tbool;
    end;
  end;
end;                                                                            // FormMouseWheel

Procedure TfrmMain.btnPastClick(Sender: TObject);
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;

  AnimateLogo(True);
  StatusBarLoadPt.Caption := 'Downloading past appointments.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;

  lblApptStatus.Caption := 'Past Appointments';
  frmMain.RPCBroker1.Results.Clear;
  RPCBroker1.RemoteProcedure := 'DVBAB APPOINTMENT LIST';
  RPCBroker1.Param[0].Value := PatientIEN;
  RPCBroker1.Param[0].PType := literal;
  RPCBroker1.Param[1].Value := 'P';                                             //A=All appt. F=Future appt. P=Past appt.
  RPCBroker1.Param[1].PType := literal;
  RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'RPC DVBAB APPOINTMENT LIST could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('DVBAB APPOINTMENT LIST could not be accessed!');
    End;
  End;
  //Begin Build Report
  ANURemoteProcedureCallInProgress := true;
  MemoAppointments.Lines.Clear;
  screen.cursor := crHourglass;

  MemoAppointments.SetSelTextBuf(RPCBroker1.Results.GetText);

  screen.cursor := crDefault;
  MemoAppointments.Visible := True;
  MemoAppointments.SelStart := 0;
  MemoAppointments.SelLength := 0;
  Try
  MemoAppointments.SetFocus Except
  End;
  ANURemoteProcedureCallinProgress := False;
  AnimateLogo(False);
  StatusBarLoadPt.Caption := 'Ready.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
  //End Of Build Report

End;

Procedure TfrmMain.ExamRequestRefreshClick(Sender: TObject);
Var
  x: integer;
  date1, date2, date3: String;
Begin
  // Get C&P Exam Dates
  FMExamRequestLister1.PartList.Clear;
  FMExamRequestLister1.PartList.Add(PatientIEN);
  FMExamRequestListbox.GetList;
  // Make sure data is correct for PatientIEN
  If FMExamRequestListbox.Items.Count > 0 Then
    For x := FMExamRequestListbox.Items.Count - 1 Downto 0 Do
    Begin
      If Pos(PatientIEN + '  ', FMExamRequestListbox.Items[x]) <> 1 Then
        FMExamRequestListbox.Items.Delete(x);
    End;
  // Reformat data
  If FMExamRequestListbox.Items.Count > 0 Then
    For x := 0 To FMExamRequestListbox.Items.Count - 1 Do
    Begin
      FMExamRequestListbox.Items[x] := Copy(FMExamRequestListbox.Items[x], Pos('  ', FMExamRequestListbox.Items[x]) + 4, 255); // Strip patient IEN;
      Date1 := Copy(FMExamRequestListbox.Items[x], 1, Pos('  ', FMExamRequestListbox.Items[x]) - 1);
      FMExamRequestListbox.Items[x] := Copy(FMExamRequestListbox.Items[x], Pos('  ', FMExamRequestListbox.Items[x]) + 4, 500);
      Date2 := Copy(FMExamRequestListbox.Items[x], 1, Pos('  ', FMExamRequestListbox.Items[x]) - 1);
      FMExamRequestListbox.Items[x] := Copy(FMExamRequestListbox.Items[x], Pos('  ', FMExamRequestListbox.Items[x]) + 4, 500);
      Date3 := Copy(FMExamRequestListbox.Items[x], 1, 254);
      If Date2 <> '' Then
        FMExamRequestListbox.Items[x] := Copy(FMDateTimeConvert(Date1) + '                    ', 1, 20) + '  |  ' + FMDateTimeConvert(Date2)
      Else
        If Date3 <> '' Then
          FMExamRequestListbox.Items[x] := Copy(FMDateTimeConvert(Date1) + '                    ', 1, 20) + '  |  ' + FMDateTimeConvert(Date3) + ' [EXAM CANCELED]'
        Else
          FMExamRequestListbox.Items[x] := Copy(FMDateTimeConvert(Date1) + '                    ', 1, 20) + '  |  ';
      //Fix single digit date and move over
      If Copy(FMExamRequestListbox.Items[x], 6, 1) = ',' Then
        FMExamRequestListbox.Items[x] := Copy(FMExamRequestListbox.Items[x], 1, 4) + ' ' + Copy(FMExamRequestListbox.Items[x], 5, 15) + Copy(FMExamRequestListbox.Items[x], 21, 99);
    End;
End;

Procedure TfrmMain.btnRefreshAddressClick(Sender: TObject);
Var
  x: integer;
Begin
  AnimateLogo(True);
  StatusBarLoadPt.Caption := 'Refreshing Address.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;

  FMEditZip.Visible := True;

  FMStatesList.Visible := False;
  ButtonStateAccept.Visible := False;

  FMGetsPtAddress.IENS := PatientIEN;
  FMGetsPtAddress.GetAndFill;

  //rpm 9/28/09 - Corrected carryover from previous patient address
  if FMEditCounty.Text = '' then
    CountyFake.Text := '';
  if FMEditState.Text = '' then
    StateFake.Text := '';
  //rpm 9/17/09 - Foreign Address: Replace Country and TempCountry .01 value with Postal Name
  FMEditCountry.Text := GetCountryName(FMEditCountry.FMDBInternal);
  FMEditTempCountry.Text := GetCountryName(FMEditTempCountry.FMDBInternal);

  FMEditStreet1.Color := clSilver;
  FMEditStreet2.Color := clSilver;
  FMEditStreet3.Color := clSilver;
  FMEditCity.Color := clSilver;
  FMEditState.Color := clSilver;
  FMEditZip.Color := clSilver;
  CountyFake.Color := clSilver;
  FMEditPhone.Color := clSilver;
  FMEditOffice.Color := clSilver;
  FMEditCountry.Color := clSilver;                                              //Country
  FMEditProvince.Color := clSilver;                                             //Province
  FMEditPostalCode.Color := clSilver;                                           //Postal Code
  FMEditLastUpdate.Color := clSilver;                                           //Last Update
  FMEditUpdateSite.Color := clSilver;                                           //Update Site

  FMEditStreet1.enabled := True;
  FMEditStreet2.enabled := True;
  FMEditStreet3.enabled := True;
  FMEditCity.enabled := True;
  FMEditState.enabled := True;
  FMEditZip.enabled := True;
  CountyFake.enabled := True;
  StateFake.enabled := True;
  FMEditPhone.enabled := True;
  FMEditOffice.enabled := True;
  FMEditCountry.Enabled := True;                                                //Country
  FMEditProvince.Enabled := True;                                               //Province
  FMEditPostalCode.Enabled := True;                                             //Postal Code
  FMEditLastUpdate.Enabled := True;                                             //Last Update
  FMEditUpdateSite.Enabled := True;                                             //Update Site

  FMEditStreet1.ReadOnly := True;
  FMEditStreet2.ReadOnly := True;
  FMEditStreet3.ReadOnly := True;
  FMEditCity.ReadOnly := True;
  FMEditState.ReadOnly := True;
  FMEditZip.ReadOnly := True;
  CountyFake.ReadOnly := True;
  StateFake.ReadOnly := True;
  FMEditPhone.ReadOnly := True;
  FMEditOffice.ReadOnly := True;
  FMEditCountry.ReadOnly := True;                                               //Country
  FMEditProvince.ReadOnly := True;                                              //Province
  FMEditPostalCode.ReadOnly := True;                                            //Postal Code
  FMEditLastUpdate.ReadOnly := True;                                            //Last Update
  FMEditUpdateSite.ReadOnly := True;                                            //Update Site

  lblZip.Visible := True;
  lblCounty.Visible := True;
  FMEditZip.Visible := True;
  CountyFake.Visible := True;
  CountyFake.BringToFront;

  StateFake.SendToBack;

  btnSaveAddress.Enabled := False;
  // btnEditAddress.Enabled:=True;  // Disabled to turn off address editing
  If ReadOnlyMode = true Then
    btnEditAddress.Enabled := False;

  fmListerStates.GetList(FMStatesList.Items);
  If FMEditState.Text <> '' Then
  Begin
    For x := 0 To FMStatesList.Items.Count - 1 Do                               // Find Selected State
      If FMStatesList.Items[x] = FMEditState.Text Then
        FMStatesList.ItemIndex := x;
    //Now find selected county
    CountyFake.Text := '';
    If FMStatesList.ItemIndex > -1 Then
    Begin
      FMListerCounties.IENS := ',' + FMStatesList.GetSelectedRecord.IEN;
      fmListerCounties.GetList(FMCountiesList.Items);
      If FMEditCounty.Text <> '' Then
      Begin
        For x := 0 To FMCountiesList.Items.Count - 1 Do
        Begin
          If Copy(FMCountiesList.Items[x], Pos('  ', FMCountiesList.Items[x]) + 4, 128) = FMEditCounty.Text Then
          Begin
            FMCountiesList.ItemIndex := x;
            CountyFake.Text := FMCountiesList.Items[x];
            AnimateLogo(False);
            StatusBarLoadPt.Caption := 'Ready.';
            StatusBarLoadPt.Repaint;
            Application.Processmessages;
            Exit;
          End;
        End;
      End;
    End;
  End;
  StateFakeChange(Application);
  AnimateLogo(False);
  StatusBarLoadPt.Caption := 'Ready.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
End;

Procedure TfrmMain.btnRefreshPtDemographicsClick(Sender: TObject);
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;

  StatusBarLoadPt.Caption := 'Downloading Demographics.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
  AnimateLogo(True);

  frmMain.RPCBroker1.Results.Clear;
  RPCBroker1.RemoteProcedure := 'DVBAB PTINQ';
  RPCBroker1.Param[0].Value := PatientIEN;
  RPCBroker1.Param[0].PType := literal;
  RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'RPC DVBAB PTINQ could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('RPC DVBAB PTINQ could not be accessed!');
    End
  End;
  ReportMemo.Lines.Clear;
  screen.cursor := crHourglass;

  //Build Report
  ANURemoteProcedureCallInProgress := true;
  ReportMemo.SetSelTextBuf(RPCBroker1.Results.GetText);
  screen.cursor := crDefault;
  ReportMemo.Visible := True;
  ReportMemo.SelStart := 1;
  ReportMemo.SelLength := 1;

  If IsSetFocusValid(ReportMemo) then
    ReportMemo.SetFocus;

  ReportMemo.SelStart := 0;
  ReportMemo.SelLength := 0;

  If IsSetFocusValid(ReportMemo) then
    ReportMemo.SetFocus;

  ANURemoteProcedureCallinProgress := False;
  AnimateLogo(False);
  StatusBarLoadPt.Caption := 'Ready.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
  //End Of Build Report

End;

Procedure TfrmMain.btnSaveAddressClick(Sender: TObject);
Var
  Save_Cursor: TCursor;
  x: integer;
Begin
  If (StateFake.Text <> 'CANADA') And (StateFake.Text <> 'PHILIPPINES') And
    (StateFake.Text <> 'QUEBEC') And
    (Uppercase(Trim(StateFake.Text)) <> 'NEWFOUNDLAND') And (Uppercase(Trim(StateFake.text)) <> 'LABRADOR') And (Uppercase(Trim(StateFake.text)) <> 'NOVA SCOTIA') And
    (Uppercase(Trim(StateFake.Text)) <> 'PRINCE EDWARD ISLAND') And (Uppercase(Trim(StateFake.text)) <> 'NEW BRUNSWICK') And (Uppercase(Trim(StateFake.text)) <> 'ONTARIO') And
    (Uppercase(Trim(StateFake.Text)) <> 'MANITOBA') And (Uppercase(Trim(StateFake.text)) <> 'SASKATCHEWAN') And (Uppercase(Trim(StateFake.text)) <> 'ALBERTA') And
    (Uppercase(Trim(StateFake.text)) <> 'BRITISH COLUMBIA') And (Uppercase(Trim(StateFake.text)) <> 'YUKON TERRITORY') And (Uppercase(Trim(StateFake.text)) <> 'NORTHWEST TERRITORIES') And
    (Uppercase(Trim(StateFake.text)) <> 'NUNAVUT') Then
    If (Length(FMEditZip.Text) <> 4) And ((Length(FMEditZip.Text) < 5) And (Length(FMEditZip.Text) < 9)) Then
    Begin
      ShowmessageCAPRI('Zip code appears to be incorrectly entered.');
      exit;
    End;
  //

  If (StateFake.Text <> 'CANADA') And (StateFake.Text <> 'PHILIPPINES') And
    (StateFake.Text <> 'QUEBEC') And
    (Uppercase(Trim(StateFake.Text)) <> 'NEWFOUNDLAND') And (Uppercase(Trim(StateFake.text)) <> 'LABRADOR') And (Uppercase(Trim(StateFake.text)) <> 'NOVA SCOTIA') And
    (Uppercase(Trim(StateFake.Text)) <> 'PRINCE EDWARD ISLAND') And (Uppercase(Trim(StateFake.text)) <> 'NEW BRUNSWICK') And (Uppercase(Trim(StateFake.text)) <> 'ONTARIO') And
    (Uppercase(Trim(StateFake.Text)) <> 'MANITOBA') And (Uppercase(Trim(StateFake.text)) <> 'SASKATCHEWAN') And (Uppercase(Trim(StateFake.text)) <> 'ALBERTA') And
    (Uppercase(Trim(StateFake.text)) <> 'BRITISH COLUMBIA') And (Uppercase(Trim(StateFake.text)) <> 'YUKON TERRITORY') And (Uppercase(Trim(StateFake.text)) <> 'NORTHWEST TERRITORIES') And
    (Uppercase(Trim(StateFake.text)) <> 'NUNAVUT') Then
    If FMEditZip.Text = '' Then
    Begin
      ShowmessageCAPRI('You must enter a zipcode.');
      exit;
    End;
  If (StateFake.Text <> 'CANADA') And (StateFake.Text <> 'PHILIPPINES') And
    (StateFake.Text <> 'QUEBEC') And
    (Uppercase(Trim(StateFake.Text)) <> 'NEWFOUNDLAND') And (Uppercase(Trim(StateFake.text)) <> 'LABRADOR') And (Uppercase(Trim(StateFake.text)) <> 'NOVA SCOTIA') And
    (Uppercase(Trim(StateFake.Text)) <> 'PRINCE EDWARD ISLAND') And (Uppercase(Trim(StateFake.text)) <> 'NEW BRUNSWICK') And (Uppercase(Trim(StateFake.text)) <> 'ONTARIO') And
    (Uppercase(Trim(StateFake.Text)) <> 'MANITOBA') And (Uppercase(Trim(StateFake.text)) <> 'SASKATCHEWAN') And (Uppercase(Trim(StateFake.text)) <> 'ALBERTA') And
    (Uppercase(Trim(StateFake.text)) <> 'BRITISH COLUMBIA') And (Uppercase(Trim(StateFake.text)) <> 'YUKON TERRITORY') And (Uppercase(Trim(StateFake.text)) <> 'NORTHWEST TERRITORIES') And
    (Uppercase(Trim(StateFake.text)) <> 'NUNAVUT') Then
    If CountyFake.Text = '' Then
    Begin
      ShowMessageCAPRI('You must enter a county.');
      exit;
    End;
  //
  If (FMEditStreet1.Text <> '') And (Length(FMEditStreet1.Text) < 3) Then
  Begin
    ShowMessageCAPRI('Street Address Line 1 is too short.');
    exit;
  End;
  If (FMEditStreet2.Text <> '') And (Length(FMEditStreet2.Text) < 3) Then
  Begin
    ShowMessageCAPRI('Street Address Line 2 is too short.');
    exit;
  End;
  If (FMEditStreet3.Text <> '') And (Length(FMEditStreet3.Text) < 3) Then
  Begin
    ShowMessageCAPRI('Street Address Line 2 is too short.');
    exit;
  End;
  If (FMEditCity.Text <> '') And (Length(FMEditCity.Text) < 2) Then
  Begin
    ShowMessageCAPRI('City is too short.');
    exit;
  End;
  If Application.MessageBox('Are you sure you want to update the address in VistA?', 'Update Address', 4) = 6 Then
  Begin
    TimeSinceLastBrokerCall := 0;                                               // Prevent event
    If ANURemoteProcedureCallInProgress = True Then
      Repeat application.processmessages Until ANURemoteProcedureCallInProgress = False;
    Save_Cursor := Screen.Cursor;
    Screen.Cursor := crHourglass;                                               { Show hourglass cursor }
    If FMEditStreet1.FMModified Then
      If FMEditStreet1.Validate Then
      Begin
        fmfiler2.AddChgdControl(FMEditStreet1);
        FMEditStreet1.Text := FMEditStreet1.FMCtrlExternal;
      End
      Else
      Begin
        FMValidator1.DisplayErrors;
        FMEditStreet1.Text := FMEditStreet1.FMTag;
      End;
    If FMEditStreet2.FMModified Then
      If FMEditStreet2.Validate Then
      Begin
        fmfiler2.AddChgdControl(FMEditStreet2);
        FMEditStreet2.Text := FMEditStreet2.FMCtrlExternal;
      End
      Else
      Begin
        FMValidator1.DisplayErrors;
        FMEditStreet2.Text := FMEditStreet2.FMTag;
      End;
    If FMEditStreet3.FMModified Then
      If FMEditStreet3.Validate Then
      Begin
        fmfiler2.AddChgdControl(FMEditStreet3);
        FMEditStreet3.Text := FMEditStreet3.FMCtrlExternal;
      End
      Else
      Begin
        FMValidator1.DisplayErrors;
        FMEditStreet3.Text := FMEditStreet3.FMTag;
      End;
    If FMEditCity.FMModified Then
      If FMEditCity.Validate Then
      Begin
        fmfiler2.AddChgdControl(FMEditCity);
        FMEditCity.Text := FMEditCity.FMCtrlExternal;
      End
      Else
      Begin
        FMValidator1.DisplayErrors;
        FMEditCity.Text := FMEditCity.FMTag;
      End;
    If FMEditState.FMModified Then
      If FMEditState.Validate Then
      Begin
        fmfiler2.AddChgdControl(FMEditState);
        FMEditState.Text := FMEditState.FMCtrlExternal;
      End
      Else
      Begin
        FMValidator1.DisplayErrors;
        FMEditState.Text := FMEditState.FMTag;
      End;
    If FMEditZip.FMModified Then
      If FMEditZip.Validate Then
      Begin
        fmfiler2.AddChgdControl(FMEditZip);
        FMEditZip.Text := FMEditZip.FMCtrlExternal;
      End
      Else
      Begin
        FMValidator1.DisplayErrors;
        FMEditZip.Text := FMEditZip.FMTag;
      End;
    If FMEditPhone.FMModified Then
      If FMEditPhone.Validate Then
      Begin
        fmfiler2.AddChgdControl(FMEditPhone);
        FMEditPhone.Text := FMEditPhone.FMCtrlExternal;
      End
      Else
      Begin
        FMValidator1.DisplayErrors;
        FMEditPhone.Text := FMEditPhone.FMTag;
      End;
    If FMEditOffice.FMModified Then
      If FMEditOffice.Validate Then
      Begin
        fmfiler2.AddChgdControl(FMEditOffice);
        FMEditOffice.Text := FMEditOffice.FMCtrlExternal;
      End
      Else
      Begin
        FMValidator1.DisplayErrors;
        FMEditOffice.Text := FMEditOffice.FMTag;
      End;
    For x := 0 To 10 Do
    Begin
    End;                                                                        // Not sure why, but it bombs if I don't have a line of code here.
    //ShowMessageCAPRI('ok');
    If fmfiler2.AnythingToFile Then
      If fmfiler2.DataProblemCheck Then
        fmfiler2.ProcessDataProblemList
      Else
      Begin
        If fmfiler2.Update Then
        Begin
          // Only update county if there is a change and the IEN
          // is in the box.
          If FMEditCounty.Text <> '' Then
            If Copy(FMEditCounty.Text, 1, 1) = '`' Then
            Begin
              If FMEditCounty.FMModified Then
                If FMEditCounty.Validate Then
                Begin
                  fmfiler2.AddChgdControl(FMEditCounty);
                  FMEditCounty.Text := FMEditCounty.FMCtrlExternal;
                End
                Else
                Begin
                  FMValidator1.DisplayErrors;
                  FMEditCounty.Text := FMEditCounty.FMTag;
                End;
              If fmfiler2.AnythingToFile Then
                If fmfiler2.DataProblemCheck Then
                  fmfiler2.ProcessDataProblemList
                Else
                  //if
                  fmfiler2.Update
                  //then begin end;
            End;
          btnRefreshPtDemographicsClick(Application);
          btnRefreshAddressClick(Application);
          //FMGetsPtAddress.GetAndFill;
        End;
      End
    Else
      ShowMessageCAPRI('No changes to file!');
    Screen.Cursor := Save_Cursor;                                               { Always restore to normal }
  End;
End;

Procedure TfrmMain.btnEditAddressClick(Sender: TObject);
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;

  frmMain.RPCBroker1.Results.Clear;
  RPCBroker1.RemoteProcedure := 'DVBAB CHECK CREDENTIALS';
  RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'RPC DVBAB CHECK CREDENTIALS could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('RPC DVBAB CHECK CREDENTIALS could not be accessed!');
    End;
  End;
  If RPCBroker1.Results[0] <> '[OK]' Then
  Begin
    ShowMessageCAPRI(RPCBroker1.Results[0]);
    application.terminate;
    Exit;
  End;
  // If credentials are ok, then continue
  ContextorChangeMessage := 'You are editing an address. If you continue, your changes may be lost.';
  CCOWBreakLink := True;

  btnEditAddress.Enabled := False;
  btnSaveAddress.Enabled := True;

  StateFake.Text := FMEditState.Text;

  btnSaveAddress.Enabled := True;

  FMEditStreet1.Color := clYellow;
  FMEditStreet2.Color := clYellow;
  FMEditStreet3.Color := clYellow;
  FMEditCity.Color := clYellow;
  FMEditState.Color := clYellow;
  FMEditZip.Color := clYellow;
  CountyFake.Color := clYellow;
  FMEditPhone.Color := clYellow;
  FMEditOffice.Color := clYellow;

  FMEditStreet1.enabled := True;
  FMEditStreet2.enabled := True;
  FMEditStreet3.enabled := True;
  FMEditCity.enabled := True;
  FMEditState.enabled := True;
  FMEditZip.enabled := True;
  CountyFake.enabled := True;
  StateFake.Enabled := True;
  FMEditPhone.enabled := True;
  FMEditOffice.enabled := True;

  StateFake.BringToFront;
  btnEditAddress.Enabled := False;

  If (StateFake.Text = 'CANADA') Or (StateFake.Text = 'PHILIPPINES') Or
    (StateFake.Text = 'QUEBEC') Or
    (Uppercase(Trim(StateFake.Text)) = 'NEWFOUNDLAND') Or (Uppercase(Trim(StateFake.text)) = 'LABRADOR') Or (Uppercase(Trim(StateFake.text)) = 'NOVA SCOTIA') Or
    (Uppercase(Trim(StateFake.Text)) = 'PRINCE EDWARD ISLAND') Or (Uppercase(Trim(StateFake.text)) = 'NEW BRUNSWICK') Or (Uppercase(Trim(StateFake.text)) = 'ONTARIO') Or
    (Uppercase(Trim(StateFake.Text)) = 'MANITOBA') Or (Uppercase(Trim(StateFake.text)) = 'SASKATCHEWAN') Or (Uppercase(Trim(StateFake.text)) = 'ALBERTA') Or
    (Uppercase(Trim(StateFake.text)) = 'BRITISH COLUMBIA') Or (Uppercase(Trim(StateFake.text)) = 'YUKON TERRITORY') Or (Uppercase(Trim(StateFake.text)) = 'NORTHWEST TERRITORIES') Or
    (Uppercase(Trim(StateFake.text)) = 'NUNAVUT') Then
  Begin
    FMEditZip.Text := '@';
    FMEditZip.Visible := False;
  End
  Else
  Begin
    FMEditZip.Visible := True;
    If FMEditZip.Text = '@' Then
      FMEditZip.Text := '';
  End;
End;

Procedure TfrmMain.FMStatesListExit(Sender: TObject);
Begin
  //FMStatesList.Visible:=False;
  //ButtonStateAccept.Visible:=False;
End;

Procedure TfrmMain.StateFakeEnter(Sender: TObject);
Begin

  exit;

  FMStatesList.BringToFront;
  ButtonStateAccept.BringToFront;
  FMStatesList.Visible := True;
  ButtonStateAccept.Visible := True;
  Try
  FMStatesList.SetFocus Except
  End;
  If FMStatesList.ItemIndex > -1 Then
  Begin
    TempIEN := FMStatesList.GetSelectedRecord.IEN;
  End
  Else
    TempIEN := '';
End;

Procedure TfrmMain.FMCountiesListExit(Sender: TObject);
Begin
  //FMCountiesList.Visible:=False;
  //ButtonCountyAccept.Visible:=False;
End;

Procedure TfrmMain.CountyFakeEnter(Sender: TObject);
Begin

  exit;

  FMCountiesList.BringToFront;
  ButtonCountyAccept.BringToFront;
  FMCountiesList.Visible := True;
  ButtonCountyAccept.Visible := True;
  Try
  FMCountiesList.SetFocus Except
  End;
End;

Procedure TfrmMain.FMEditCityExit(Sender: TObject);
Begin
  FMEditCity.Text := Uppercase(FMEditCity.Text);
End;

Procedure TfrmMain.btnLoadHSNamesClick(Sender: TObject);
Var
  x: integer;
  deleteflag: integer;
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;

  HSMemo.Lines.Clear;
  frmMain.RPCBroker1.Results.Clear;

  {Get HEALTH SUMMARY TYPES using ORWRP REPORT LISTS CPRS Broker Call}
  RPCBroker1.RemoteProcedure := 'ORWRP REPORT LISTS';
  Try
  RPCBroker1.Call Except On EBrokerError Do
    Try
    RPCBroker1.Call Except On EBrokerError Do
      Try
      RPCBroker1.Call Except On EBrokerError Do
        Begin
          ANURemoteProcedureCallInProgress := False;
          frmMain.Show;
          Application.BringToFront;
          ShowMessageCAPRI('RPC Broker connection error!');
        End;
      End;
    End;
  End;

  Repeat
    RPCBroker1.Results.Delete(0);
  Until RPCBroker1.Results[0] = '[HEALTH SUMMARY TYPES]';
  RPCBroker1.Results.Delete(0);
  DeleteFlag := -1;
  If RPCBroker1.Results.Count > 0 Then
  Begin
    For x := 0 To RPCBroker1.Results.Count - 1 Do
    Begin
      If (RPCBroker1.Results[x] = '$$END') And (DeleteFlag = -1) Then
        DeleteFlag := x;
    End;
    For x := RPCBroker1.Results.Count - 1 Downto DeleteFlag Do
      RPCBroker1.Results.Delete(x);

    ORHealthSummaryUserList.Items.Clear;
    lbHealthSummaryList.Items.Clear;
    If RPCBroker1.Results.Count > 0 Then
      For x := 0 To RPCBroker1.Results.Count - 1 Do
      Begin
        If Pos('ADHOC REPORT', UpperCase(Piece(RPCBroker1.Results[x], '^', 2))) <> 1 Then
          If Pos('REMOTE', UpperCase(Piece(RPCBroker1.Results[x], '^', 2))) <> 1 Then
          Begin
            lbHealthSummaryList.Items.Add(Copy(Piece(RPCBroker1.Results[x], '^', 1), 2, 99)); // Strip off the first character of "h"
            ORHealthSummaryUserList.Items.Add(Piece(RPCBroker1.Results[x], '^', 2));
            //ShowMessageCAPRI(RPCBroker1.Results[x]+'  '+(Copy(Piece(RPCBroker1.Results[x],'^',1),2,99))+'  '+(Piece(RPCBroker1.Results[x],'^',2)));
          End;
      End;
  End;

End;

Procedure TfrmMain.ORHealthSummaryUserListClick(Sender: TObject);
Var
  Z: String;
  x, y: integer;

Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;
  ComboBoxHSSections.Text := '';
  ComboBoxHSSections.Repaint;
  AnimateLogo(True);
  StatusBarLoadPt.Caption := 'Generating Health Summary.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
  Tab95Control2.TabIndex := 0;
  TimerRemoteData.Enabled := False;
  ListBoxRemoteDataPending.Items.Clear;
  //Clear off previous transaction messages just in case
  //some have already been done.  Grab first 5 pieces
  //piece 6 is the transaction message
  //piece 7 is the done message
  If ListBoxRemoteData.Items.Count > 0 Then
    For y := 0 To listboxremotedata.items.count - 1 Do
    Begin
      ListBoxRemoteData.Items[y] := Piece(ListBoxRemoteData.Items[y], '^', 1) + '^' +
        Piece(ListBoxRemoteData.Items[y], '^', 2) + '^' +
        Piece(ListBoxRemoteData.Items[y], '^', 3) + '^' +
        Piece(ListBoxRemoteData.Items[y], '^', 4) + '^' +
        Piece(ListBoxRemoteData.Items[y], '^', 5);
    End;
  // Get MPI ID
 // RPCBroker1.RemoteProcedure := 'ORWPT SELECT';
 // RPCBroker1.Param[1].Value := PatientIEN;
 // RPCBroker1.Param[1].PType := literal;
 // RPCBrokerCall; try RPCBroker1.Call;
 //   except
 // On EBrokerError do
 //   ShowMessageCAPRI('RPC ORWPT SELECT PATIENT could not be accessed!');
 // end;
 // RemoteDataPtID:=Piece(RPCBroker1.Results[0],'^',14);
 //RemoteDataPtID:='';
  Z := lbHealthSummaryList.Items[ORHealthSummaryUserList.ItemIndex];

  // Remote Sites Selected
  If Tab95Control2.Tabs.Count > 1 Then
    For x := 1 To Tab95Control2.Tabs.Count - 1 Do
      For y := 0 To listboxremotedata.items.count - 1 Do
        If Tab95Control2.Tabs[x] = Piece(ListBoxRemoteData.Items[y], '^', 2) Then
          If Piece(ListBoxRemoteData.Items[y], '^', 6) = '' Then
          Begin
            // Found match not retrieved yet.  Query remote site
            Application.ProcessMessages;
            RPCBroker1.RemoteProcedure := 'XWB REMOTE RPC';
            RPCBroker1.Param[1].Value := Piece(ListBoxRemoteData.Items[y], '^', 1); // Site Location
            RPCBroker1.Param[1].PType := literal;
            RPCBroker1.Param[2].Value := 'ORWRP REPORT TEXT';                   // RPC to Call
            RPCBroker1.Param[2].PType := literal;
            RPCBroker1.Param[3].Value := '0';
            RPCBroker1.Param[3].PType := literal;
            RPCBroker1.Param[4].Value := PatientIEN + ';' + RemoteDataPtID;
            RPCBroker1.Param[4].PType := literal;
            RPCBroker1.Param[5].Value := '1;1';
            RPCBroker1.Param[5].PType := literal;
            RPCBroker1.Param[6].Value := Z + ';' + ORHealthSummaryUserList.Items[ORHealthSummaryUserList.ItemIndex]; // HS IEN
            RPCBroker1.Param[6].PType := literal;
            RPCBroker1.Param[7].Value := '';
            RPCBroker1.Param[7].PType := literal;
            RPCBroker1.Param[8].Value := '';
            RPCBroker1.Param[8].PType := literal;
            RPCBroker1.Param[9].Value := '0';                                   // Start Date
            RPCBroker1.Param[9].PType := literal;
            RPCBroker1.Param[10].Value := '0';                                  // End Date
            RPCBroker1.Param[10].PType := literal;
            //ShowMessageCAPRI(RPCBroker1.Param[1].Value+CR+RPCBroker1.Param[2].Value+CR+RPCBroker1.Param[3].Value+CR+RPCBroker1.Param[4].Value+CR+RPCBroker1.Param[5].Value+CR
            //+RPCBroker1.Param[6].Value+CR+RPCBroker1.Param[7].Value+CR+RPCBroker1.Param[8].Value+CR+RPCBroker1.Param[9].Value+CR+RPCBroker1.Param[10].Value+CR);
            RPCBrokerCall;
            Try
              RPCBroker1.Call;
            Except
              On EBrokerError Do
              Begin
                ANURemoteProcedureCallInProgress := False;
                AnimateLogo(False);
                StatusBarLoadPt.Caption := 'RPC XWB REMOTE RPC could not be accessed!';
                StatusBarLoadPt.Repaint;
                Application.Processmessages;
                ShowMessageCAPRI('RPC XWB REMOTE RPC could not be accessed!');
                ANURemoteProcedureCallInProgress := False;
                exit;
              End;
            End;
            If RPCBroker1.Results[0] <> '' Then
            Begin
              ListBoxRemoteDataPending.Items.Add(RPCBroker1.Results[0]);
            End
            Else
            Begin
              ListBoxRemoteData.Items[y] := ListBoxRemoteData.Items[y] + '^*';
              ListBoxRemoteDataPending.Items.Add('*');                          // * = Communication Problems
              //ShowmessageCAPRI('There was a communication problem requesting this report from '+Piece(ListBoxRemoteData.Items[y],'^',2)+'.  Data will not be returned for this site.');
            End;
            //ShowmessageCAPRI(RPCBroker1.Results[0]);
            // Keep track of message id
            ListBoxRemoteData.Items[y] := ListBoxRemoteData.Items[y] + '^' + RPCBroker1.Results[0];
          End;

  // Get HS from local site
  HSMemoLocal.Lines.Clear;
  frmMain.RPCBroker1.Results.Clear;
  RPCBroker1.RemoteProcedure := 'ORWRP REPORT TEXT';
  RPCBroker1.Param[1].Value := PatientIEN;
  RPCBroker1.Param[1].PType := literal;
  RPCBroker1.Param[2].Value := '1';                                             // HS Report Type
  RPCBroker1.Param[2].PType := literal;
  RPCBroker1.Param[3].Value := Z + ';' + ORHealthSummaryUserList.Items[ORHealthSummaryUserList.ItemIndex]; // HS IEN
  RPCBroker1.Param[3].PType := literal;
  RPCBroker1.Param[4].Value := '';
  RPCBroker1.Param[4].PType := literal;
  RPCBroker1.Param[5].Value := '';
  RPCBroker1.Param[5].PType := literal;
  RPCBroker1.Param[6].Value := '0';                                             // Begin Date
  RPCBroker1.Param[6].PType := literal;
  RPCBroker1.Param[7].Value := '0';                                             // End Date
  RPCBroker1.Param[7].PType := literal;

  RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'RPC ORWRP REPORT TEXT could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('RPC ORWRP REPORT TEXT could not be accessed!');
      ANURemoteProcedureCallInProgress := false;
      exit;
    End;
  End;

  ANURemoteProcedureCallInProgress := true;
  HSMemoLocal.Lines.Clear;
  ComboBoxHSSections.Items.Clear;
  screen.cursor := crHourglass;

  HSMemoLocal.SetSelTextBuf(RPCBroker1.Results.GetText);

  screen.cursor := crDefault;
  HSMemoLocal.BringToFront;
  HSMemoLocal.Visible := True;
  HSMemoLocal.SelStart := 0;
  HSMemoLocal.SelLength := 0;
  Try
  HSMemoLocal.SetFocus Except
  End;

  If ListBoxRemoteDataPending.Items.Count > 0 Then
    TimerRemoteData.Enabled := True;
  Tab95Control2Change(Application);
  ANURemoteProcedureCallinProgress := False;
  AnimateLogo(False);
  StatusBarLoadPt.Caption := 'Ready.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
End;

Procedure TfrmMain.btnAddExamClick(Sender: TObject);
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;

  frmMain.RPCBroker1.Results.Clear;
  RPCBroker1.RemoteProcedure := 'DVBAB CHECK CREDENTIALS';
  RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'RPC DVBAB CHECK CREDENTIALS could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('RPC DVBAB CHECK CREDENTIALS could not be accessed!');
    End;
  End;
  If RPCBroker1.Results[0] <> '[OK]' Then
  Begin
    ShowMessageCAPRI(RPCBroker1.Results[0]);
    application.terminate;
    Exit;
  End;
  // If credentials are ok, then continue

End;

Procedure TfrmMain.btnAddRequestClick(Sender: TObject);
Var
  x, y: integer;
  MyTreeNode: Array[0..50000] Of TTreeNode;
  NodeCount: LongInt;
  temptextz: String;
Begin
  If frmROFinder.ORListBoxSites.Items.Count = 0 Then
    LoadInstitutions;

  frmAddress := TfrmAddress.Create(frmMain);
  frmAddress.CountyFake.Text := '';
  frmAddress.Top := 7 + frmMain.Top + ((frmMain.Height - frmAddress.Height) Div 2);
  frmAddress.Left := frmMain.Left + ((frmMain.Width - frmAddress.Width) Div 2);
  frmAddress.FMGetsPtAddress.IENS := PatientIEN;
  frmAddress.FMGetsPtAddress.GetAndFill;
  frmAddress.PopulateCountry;
  If frmAddress.FMEditCounty.Text <> '' Then
  Begin
    For x := 0 To FMCountiesList.Items.Count - 1 Do
    Begin
      If Copy(FMCountiesList.Items[x], Pos('  ', FMCountiesList.Items[x]) + 4, 128) = frmAddress.FMEditCounty.Text Then
      Begin
        FMCountiesList.ItemIndex := x;
        frmAddress.CountyFake.Text := FMCountiesList.Items[x];
      End;
    End;
  End;

  fmListerStates.GetList(frmAddress.FMStatesList.Items);
  If FMEditState.Text <> '' Then
  Begin
    For x := 0 To frmAddress.FMStatesList.Items.Count - 1 Do                    // Find Selected State
      If frmAddress.FMStatesList.Items[x] = FMEditState.Text Then
        frmAddress.FMStatesList.ItemIndex := x;
    //Now find selected county
    FMListerCounties.IENS := ',' + frmAddress.FMStatesList.GetSelectedRecord.IEN;
    fmListerCounties.GetList(frmAddress.FMCountiesList.Items);
    If FMEditCounty.Text <> '' Then
    Begin
      For x := 0 To frmAddress.FMCountiesList.Items.Count - 1 Do
      Begin
        If Copy(frmAddress.FMCountiesList.Items[x], Pos('  ', frmAddress.FMCountiesList.Items[x]) + 4, 128) = FMEditCounty.Text Then
        Begin
          frmAddress.FMCountiesList.ItemIndex := x;
          CountyFake.Text := frmAddress.FMCountiesList.Items[x];
          AnimateLogo(False);
          StatusBarLoadPt.Caption := 'Ready.';
          StatusBarLoadPt.Repaint;
          Application.Processmessages;
        End;
      End;
    End;
  End;

  ContextorChangeMessage := 'You are editing an address. If you continue, CAPRI will drop out of the clinical context.';
  CCOWBreakLink := True;

  addressinfo := '';
  If frmAddress.ShowModal = mrOK Then
  Begin
    temptextz := 'Address:       ';
    If (frmAddress.FMEditStreet1.Text <> '') And (frmAddress.FMEditStreet1.Text <> '@') Then
      addressinfo := addressinfo + temptextz + frmAddress.FMEditStreet1.Text + CR + LF;
    If (frmAddress.FMEditStreet1.Text <> '') And (frmAddress.FMEditStreet1.Text <> '@') Then
      temptextz := '               ';
    If (frmAddress.FMEditStreet2.Text <> '') And (frmAddress.FMEditStreet2.Text <> '@') Then
      addressinfo := addressinfo + temptextz + frmAddress.FMEditStreet2.Text + CR + LF;
    If (frmAddress.FMEditStreet2.Text <> '') And (frmAddress.FMEditStreet2.Text <> '@') Then
      temptextz := '               ';
    If (frmAddress.FMEditStreet3.Text <> '') And (frmAddress.FMEditStreet3.Text <> '@') Then
      addressinfo := addressinfo + temptextz + frmAddress.FMEditStreet3.Text + CR + LF;
    If (frmAddress.FMEditCity.Text <> '') And (frmAddress.FMEditCity.Text <> '@') Then
      addressinfo := addressinfo + 'City:          ' + frmAddress.FMEditCity.Text + CR + LF;
    If (frmAddress.StateFake.Text <> '') and (frmAddress.StateFake.Text <> '@') then
      addressinfo := addressinfo + 'State:         ' + frmAddress.StateFake.Text + CR + LF;
    If (frmAddress.FMEditZip.Text <> '') And (frmAddress.FMEditZip.Text <> '@') Then
      addressinfo := addressinfo + 'Zip:           ' + frmAddress.FMEditZip.Text + CR + LF;
    If (frmAddress.CountyFake.Text <> '') and (frmAddress.CountyFake.Text <> '@') Then
      addressinfo := addressinfo + 'County:        ' + frmAddress.CountyFake.Text + CR + LF;
    if (frmAddress.FMEditProvince.Text <> '') and (frmAddress.FMEditProvince.Text <> '@') then
      addressinfo := addressinfo + 'Province:      ' + frmAddress.FMEditProvince.Text + CR + LF;
    if (frmAddress.FMEditPostalCode.Text <> '') and (frmAddress.FMEditPostalCode.Text <> '@') then
      addressinfo := addressinfo + 'Postal Code:   ' + frmAddress.FMEditPostalCode.Text + CR + LF;
    if (frmAddress.cboCountry.Text <> '') then
      addressinfo := addressinfo + 'Country:       ' + frmAddress.cboCountry.Text + CR + LF;
    If (frmAddress.FMEditPhone.Text <> '') And (frmAddress.FMEditPhone.Text <> '@') Then
      addressinfo := addressinfo + 'Phone:         ' + frmAddress.FMEditPhone.Text + CR + LF;
    If (frmAddress.FMEditOffice.Text <> '') And (frmAddress.FMEditOffice.Text <> '@') Then
      addressinfo := addressinfo + 'Office Phone:  ' + frmAddress.FMEditOffice.Text + CR + LF;
    If IsPatchInstalled('DVBA*2.7*190') then                                    // CodeCR694 JRL 3/27/15
    begin                                                                       // CodeCR694 JRL 3/27/15
      If (frmAddress.FMEditCell.Text <> '') And (frmAddress.FMEditCell.Text <> '@') Then // CodeCR694 JRL 3/13/15
        addressinfo := addressinfo + 'Cell Phone:  ' + frmAddress.FMEditCell.Text + CR + LF; // CodeCR694 JRL 3/13/15
      If (frmAddress.FMEditEmail.Text <> '') And (frmAddress.FMEditEmail.Text <> '@') Then // CodeCR694 JRL 3/13/15
        addressinfo := addressinfo + 'Email:  ' + frmAddress.FMEditEmail.Text + CR + LF; // CodeCR694 JRL 3/13/15
    end;                                                                        // CodeCR694 JRL 3/27/15

    If (frmAddress.AddressDate.Text <> '') Then
//      addressinfo := addressinfo + CR + LF + frmAddress.Label12.Caption + '  ' + frmAddress.AddressDate.Text + CR + LF;
      addressinfo := addressinfo + CR + LF + frmAddress.lblAddressDate.Caption + '  ' + frmAddress.AddressDate.Text + CR + LF;  // rpk 4/20/2015
  End;
  (*
     If frmAddress.Showmodal=mrCancel then begin
       Page95Control1.ActivePage:=AdminDocuments;
       Tab95Control3.Tabs[Tab95Control3.TabIndex]:='Address';
       ScrollBoxAddress.VertScrollBar.Position:=0;
       frmAddress.release; frmAddress := nil;
       ContextorChangeMessage:='';
       CCOWBreakLink:=False;
       exit;
     end;
     *)

  frmAddress.release;
  frmAddress := Nil;
  AddRequestIEN := '+1';
  frmMain.RPCBroker1.Results.Clear;
  RPCBroker1.RemoteProcedure := 'DVBAB CHECK CREDENTIALS';
  RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'RPC DVBAB CHECK CREDENTIALS could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('RPC DVBAB CHECK CREDENTIALS could not be accessed!');
    End
  End;
  If RPCBroker1.Results[0] <> '[OK]' Then
  Begin
    ShowMessageCAPRI(RPCBroker1.Results[0]);
    application.terminate;
    Exit;
  End;
  btnAddRequest.Enabled := False;
  btnViewExam.Enabled := False;
  btnExamFinalReport.Enabled := False;
  btnGenerateReport.Enabled := False;
  btnGenerate7131Report.enabled := False;
  frmNewExam := TfrmNewExam.Create(frmMain);
  // If credentials are ok, then continue
  // Populate lists and controls
  //FMListerExams.GetList(frmNewExam.FMExamsList.Items);
  //frmNewExam := TfrmNewExam.Create(frmMain);
  frmNewExam.FMExamsList.Items := ListExams;
  frmNewExam.CheckBoxExamsToComplete.Items.Clear;
  GetActiveCapriDivisions(listMedicalCenterDivision, frmNewExam.FMRoutingLocation.Items); //CodeCR173 - rpm 4/18/11
  frmNewExam.FMListBoxBodySystems.GetList;

  frmNewExam.TreeViewExams.Items.Clear;
  nodecount := 0;
  If frmNewExam.FMListBoxBodySystems.Items.Count > 0 Then
    For x := 0 To frmNewExam.FMListBoxBodySystems.Items.Count - 1 Do
    Begin
      MyTreeNode[x] := frmNewExam.TreeViewExams.Items.Add(Nil, frmNewExam.FMListBoxBodySystems.Items[x]);
      nodecount := nodecount + 1;
      frmNewExam.FMListBoxBodySystems.ItemIndex := x;
      For y := 0 To frmNewExam.FMExamsList.Items.Count - 1 Do
        If Pos('  I  ', frmNewExam.FMExamsList.Items[y]) = 0 Then
          If Pos('  ' + frmNewExam.FMListBoxBodySystems.GetSelectedRecord.IEN + '  ', frmNewExam.FMExamsList.Items[y] + '  ') > 0 Then
          Begin
            MyTreeNode[NodeCount] := frmNewExam.TreeViewExams.Items.AddChild(MyTreeNode[x], Copy(frmNewExam.FMExamsList.Items[y], 1, Pos('  A', frmNewExam.FMExamsList.Items[y]) - 3));
            inc(nodecount);
          End;
      If MyTreeNode[x].getFirstChild = Nil Then
        MyTreeNode[x].Delete;
    End;

  //FMListerInstitutionFile.GetList(frmNewExam.FMRegionalOfficeNumber.Items);
  frmNewExam.FMRegionalOfficeNumber.Items.Clear;

  (*
  If lstInstitutions.Items.Count>0 then
    For x:=0 to lstInstitutions.Items.Count-1 do
        frmNewExam.FMRegionalOfficeNumber.Items.Add(Copy(lstInstitutions.Items[x],1,Pos('^',lstInstitutions.Items[x])-1));
    *)
(*
  frmNewExam.FMRegionalOfficeNumber.Items:=lstInstitutions.Items;
  If frmNewExam.FMRegionalOfficeNumber.Items.Count>0 then
    For x:=frmNewExam.FMRegionalOfficeNumber.Items.Count-1 downto 0 do
      If Pos('-RO ',frmNewExam.FMRegionalOfficeNumber.Items[x])=0 then
        frmNewExam.FMRegionalOfficeNumber.Items.Delete(x) else
          frmNewExam.FMRegionalOfficeNumber.Items[x]:=Copy(frmNewExam.FMRegionalOfficeNumber.Items[x],1,Pos('  ',frmNewExam.FMRegionalOfficeNumber.Items[x])-1);
*)
  frmNewExam.FMPatientName.Text := Copy(Panel1.Caption, 1, Pos('  SSN#', Panel1.Caption));
  frmNewExam.FMPatientNameIEN.Text := '`' + PatientIEN;
  frmNewExam.FMRequestedBy.Text := FMUserName.Caption;
  frmNewExam.FMRequestedByIEN.Text := '`' + AuthorIEN;
  frmNewExam.FMRequestDate.Text := 'NOW';
  frmNewExam.FMRequestedByIEN.Text := '`' + AuthorIEN;
  frmNewExam.FMRequestStatus.Text := 'N';
  frmNewExam.FMClaimFolderRequired.Text := '';
  If IsPatchInstalled('DVBA*2.7*190') then                                      // CodeCR704 JRL 3/26/15
    frmNewExam.FMElectronicClaimFolder.Text := '';                              // CodeCR704 JRL 3/16/15
  frmNewExam.FMOtherDocumentsRequired.Text := '';
  frmNewExam.FMRegionalOfficeNumber.Text := '';
  frmNewExam.FMRegionalOfficeNumber.Enabled := True;
  frmNewExam.FMPriorityOfExam.Text := '';
  frmNewExam.FMPriorityOfExam.Enabled := True;                                  // In case insufficient exam action turned it off
  frmNewExam.FMOtherDisabilities1.Text := '';
  frmNewExam.FMOtherDisabilities2.Text := '';
  frmNewExam.FMOtherDisabilities3.Text := '';
  frmNewExam.FMRoutingLocation.Text := '';
  frmNewExam.FMLastRatingExamDate.Text := '';
  frmNewExam.FMCommentsMemo.Lines.Clear;
  //Setup for new entry
  frmNewExam.FMPatientNameIEN.IENS := '+1';
  frmNewExam.FMRequestDate.IENS := '+1';
  frmNewExam.FMClaimFolderRequiredFake.IENS := '+1';
  If IsPatchInstalled('DVBA*2.7*190') then                                      // CodeCR704 JRL 3/26/15
    frmNewExam.FMElectronicClaimFolderFake.IENS := '+1';                        // CodeCR704 JRL 3/16/15
  frmNewExam.FMOtherDocumentsRequiredFake.IENS := '+1';
  frmNewExam.FMRegionalOfficeNumberIEN.IENS := '+1';
  frmNewExam.FMRequestedByIEN.IENS := '+1';
  frmNewExam.FMRequestStatus.IENS := '+1';
  frmNewExam.FMPriorityOfExamFake.IENS := '+1';
  frmNewExam.FMOtherDisabilities1.IENS := '+1';
  frmNewExam.FMOtherDisabilities2.IENS := '+1';
  frmNewExam.FMOtherDisabilities3.IENS := '+1';
  frmNewExam.FMRoutingLocationFake.IENS := '+1';
  frmNewExam.FMLastRatingExamDate.IENS := '+1';
  frmNewExam.FMCommentsMemo.IENS := '+1';
  frmNewExam.FMOriginal2507Request.IENS := '+1';
  frmNewExam.FMOriginal2507ProcessingTime.IENS := '+1';
  frmNewExam.FMOriginal2507Request.Text := '';
  frmNewExam.FMOriginal2507ProcessingTime.Text := '';

  //Enter request
  frmNewExam.Height := frmMain.Height - 32;
  If frmNewExam.Height > 698 Then
    frmNewExam.Height := 698;
  frmNewExam.Top := 7 + frmMain.Top + ((frmMain.Height - frmNewExam.Height) Div 2);
  frmNewExam.Left := frmMain.Left + ((frmMain.Width - frmNewExam.Width) Div 2);
  frmNewExam.btnSendRequest.Top := frmNewExam.Height - 81;                      //73
  frmNewExam.btnCancel.Top := frmNewExam.Height - 81;                           //73
  frmNewExam.Scrollbox1.Height := frmNewExam.Height - 82;                       //-74
  //frmMain.BorderIcons:=frmMain.BorderIcons-[biSystemMenu];
  frmNewExam.Scrollbox1.VertScrollBar.Position := 0;

  frmNewExam.FMListerCustomExamListDivisionsListBox.GetList;
  //Check for inactive divisions
  If frmNewExam.FMListerCustomExamListDivisionsListBox.Items.Count > 0 Then
    For x := 0 To frmNewExam.FMListerCustomExamListDivisionsListBox.Items.Count - 1 Do
    Begin
      frmNewExam.FMListerCustomExamListDivisionsListBox.ItemIndex := x;
      frmNewExam.CustomExamListDivisions.IENS := frmNewExam.FMListerCustomExamListDivisionsListBox.GetSelectedRecord.IEN;
      frmNewExam.CustomExamListDivisions.GetAndFill;
    End;
  frmNewExam.FMRoutingLocation.ItemIndex := -1;

  //rra 9PORT9 - set Routing Location Information to null until a Routing Location is selected
  frmNewExam.FMMemoDivisionComments.text := '';

  // Set up division...
  searchforstring := UserDivision;
  frmNewExam.FMRegionalOfficeNumberEnter(Application);
  searchforstring := '';
  If frmNewExam.FMRegionalOfficeNumberIEN.Text <> '' Then
    frmNewExam.FMRegionalOfficeNumber.Enabled := False;

  (*
  frmNewExam.FMRegionalOfficeNumber.Enabled:=False;
  frmNewExam.FMRegionalOfficeNumber.Text:=UserDivision;
  frmNewExam.FMRegionalOfficeNumberExit(Application);
  *)
  frmNewExam.Panel1.Visible := False;
  ContextorChangeMessage := 'You are adding an exam request. If you continue, you will lose this work.';
  CCOWBreakLink := True;
  frmNewExam.ShowModal;
  ContextorChangeMessage := '';
  CCOWBreakLink := False;
  frmNewExam.release;
  frmNewExam := Nil;
  Try
    frmROFinder.Hide;
  Except
  End;

  //frmMain.BorderIcons:=frmMain.BorderIcons+[biSystemMenu];
  ExamRequestRefreshClick(Application);
  If ReadOnlyMode = False Then
    btnAddRequest.Enabled := True;
  If FMExamRequestListbox.ItemIndex > -1 Then
  Begin
    btnViewExam.Enabled := True;
    btnExamFinalReport.Enabled := True;
    btnGenerateReport.Enabled := True;
  End;
End;

Procedure TfrmMain.btnViewExamClick(Sender: TObject);
Var
  x, y: integer;
  MyTreeNode: Array[0..50000] Of TTreeNode;
  NodeCount: LongInt;
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;

  NodeCount := 0;

  If frmROFinder.ORListBoxSites.Items.Count = 0 Then
    LoadInstitutions;

  For x := 0 To 1000 Do
    CancelIt[x] := False;
  For x := 0 To 1000 Do
    CancelReason[x] := '';
  If FMExamRequestListbox.ItemIndex = -1 Then
    exit;
  frmMain.RPCBroker1.Results.Clear;
  RPCBroker1.RemoteProcedure := 'DVBAB CHECK CREDENTIALS';
  RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'RPC DVBAB CHECK CREDENTIALS could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('RPC DVBAB CHECK CREDENTIALS could not be accessed!');
    End;
  End;
  If RPCBroker1.Results[0] <> '[OK]' Then
  Begin
    ShowMessageCAPRI(RPCBroker1.Results[0]);
    application.terminate;
    Exit;
  End;

  btnAddRequest.Enabled := False;
  BitBtnVistA.enabled := False;
  btnViewExam.Enabled := False;
  btnExamFinalReport.Enabled := False;
  btnGenerateReport.Enabled := False;
  // Set up form
  frmViewExam := TfrmViewExam.Create(frmMain);
  If ReadOnlyMode = True Then
  Begin
    frmViewExam.btnCancelAllExams.Enabled := False;
    frmViewExam.btnAddExam.Enabled := False;
  End;
  frmViewExam.FMGetsExamRequest.IENS := FMExamRequestListbox.GetSelectedRecord.IEN;
  frmViewExam.FMGetsExamRequest.GetAndFill;
  //FMListerExams.GetList(frmViewExam.FMExamsList.Items);
  frmViewExam.FMExamsList.Items := listExams;
  GetActiveCapriDivisions(listMedicalCenterDivision, frmViewExam.FMRoutingLocation.Items); //CodeCR173 - rpm 4/18/11
  frmViewExam.FMListBoxBodySystems.GetList;

  frmViewExam.TreeViewExams.Items.Clear;
  If frmViewExam.FMListBoxBodySystems.Items.Count > 0 Then
    For x := 0 To frmViewExam.FMListBoxBodySystems.Items.Count - 1 Do
    Begin
      MyTreeNode[x] := frmViewExam.TreeViewExams.Items.Add(Nil, frmViewExam.FMListBoxBodySystems.Items[x]);
      nodecount := nodecount + 1;
      frmViewExam.FMListBoxBodySystems.ItemIndex := x;
      For y := 0 To frmViewExam.FMExamsList.Items.Count - 1 Do
        If Pos('  I  ', frmViewExam.FMExamsList.Items[y]) = 0 Then
          If Pos('  ' + frmViewExam.FMListBoxBodySystems.GetSelectedRecord.IEN + '  ', frmViewExam.FMExamsList.Items[y] + '  ') > 0 Then
          Begin
            MyTreeNode[NodeCount] := frmViewExam.TreeViewExams.Items.AddChild(MyTreeNode[x], Copy(frmViewExam.FMExamsList.Items[y], 1, Pos('  A', frmViewExam.FMExamsList.Items[y]) - 3));
            inc(nodecount);
          End;
      If MyTreeNode[x].getFirstChild = Nil Then
        MyTreeNode[x].Delete;
    End;

  //FMListerInstitutionFile.GetList(frmViewExam.FMRegionalOfficeNumber.Items);
(*
  frmViewExam.FMRegionalOfficeNumber.Items.Clear;
  If lstInstitutions.Items.Count>0 then
    For x:=0 to lstInstitutions.Items.Count-1 do
        frmViewExam.FMRegionalOfficeNumber.Items.Add(Copy(lstInstitutions.Items[x],1,Pos('^',lstInstitutions.Items[x])-1));
*)
(*
  frmViewExam.FMRegionalOfficeNumber.Items:=lstInstitutions.Items;
  If frmViewExam.FMRegionalOfficeNumber.Items.Count>0 then
    For x:=frmViewExam.FMRegionalOfficeNumber.Items.Count-1 downto 0 do
      If Pos('-RO ',frmViewExam.FMRegionalOfficeNumber.Items[x])=0 then
        frmViewExam.FMRegionalOfficeNumber.Items.Delete(x) else
          frmViewExam.FMRegionalOfficeNumber.Items[x]:=Copy(frmViewExam.FMRegionalOfficeNumber.Items[x],1,Pos('  ',frmViewExam.FMRegionalOfficeNumber.Items[x])-1);
*)
  // If credentials are ok, then continue
  frmViewExam.Height := frmMain.Height - 32;
  If frmViewExam.Height > 1020 Then
    frmViewExam.Height := 1020;
  frmViewExam.btnInsufficientExam.Top := frmViewExam.Height - 81;
//  frmViewExam.btnCancel.Top := frmViewExam.Height - 81;
  frmViewExam.btnClose.Top := frmViewExam.Height - 81;                          // rpk 11/17/2014
  frmViewExam.Scrollbox1.Height := frmViewExam.Height - 82;
  frmViewExam.Top := 7 + frmMain.Top + ((frmMain.Height - frmViewExam.Height) Div 2);
  frmViewExam.Left := frmMain.Left + ((frmMain.Width - frmViewExam.Width) Div 2);
  frmViewExam.edExamReferenceNumber.Text := '';                                 //Force Save Flag to be tripped
  frmViewExam.edExamReferenceNumber.Text := FMExamRequestListbox.GetSelectedRecord.IEN;
  // Find Exams
  frmMain.RPCBroker1.Results.Clear;
  RPCBroker1.RemoteProcedure := 'DVBAB FIND EXAMS';
  RPCBroker1.Param[0].Value := FMExamRequestListbox.GetSelectedRecord.IEN;
  RPCBroker1.Param[0].PType := literal;
  RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'RPC DVBAB FIND EXAMS could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('RPC DVBAB FIND EXAMS could not be accessed!');
    End;
  End;
  frmViewExam.lstExamsRequestedHidden.Items := RPCBroker1.Results;
  frmViewExam.lstExamsRequested.Clear;
  If frmViewExam.lstExamsRequestedHidden.Items.Count > 0 Then
    For x := 0 To frmViewExam.lstExamsRequestedHidden.Items.Count - 1 Do
      frmViewExam.lstExamsRequested.Items.Add(Copy(frmViewExam.lstExamsRequestedHidden.Items[x], Pos('^', frmViewExam.lstExamsRequestedHidden.Items[x]) + 1, 254));
  //
  frmViewExam.btnViewSelectedExam.Enabled := False;                             // Reset this button on reload
  //frmMain.BorderIcons:=frmMain.BorderIcons-[biSystemMenu];
  frmViewExam.ScrollBox1.VertScrollBar.Position := 0;

  frmViewExam.FMRegionalOfficeNumber.Enabled := False;

  ContextorChangeMessage := 'You are viewing/changing an exam request. If you continue, CAPRI will drop out of the clinical context.';
  CCOWBreakLink := True;
  frmViewExam.ShowModal;
  ContextorChangeMessage := '';
  CCOWBreakLink := False;

  //frmMain.BorderIcons:=frmMain.BorderIcons+[biSystemMenu];
  frmViewExam.release;
  frmViewExam := Nil;
  ExamRequestRefreshClick(Application);

  if ESSOVersion then
    BitBtnVistA.enabled := True;                                                //only remote connections - rpm 3/17/09
  If ReadOnlyMode = False Then
    btnAddRequest.Enabled := True;
  If fmExamRequestListbox.ItemIndex > -1 Then
  Begin
    btnViewExam.Enabled := True;
    btnExamFinalReport.Enabled := True;
    btnGenerateReport.Enabled := True;
  End;
End;

Procedure TfrmMain.FMExamRequestListboxClick(Sender: TObject);
Begin
  btnViewExam.Enabled := True;
  btnExamFinalReport.Enabled := True;
  btnGenerateReport.Enabled := True;
End;

Procedure TfrmMain.FMExamRequestListboxDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
Begin
  If FMExamRequestListbox.ItemIndex > -1 Then
  Begin
    btnViewExam.Enabled := True;
    btnExamFinalReport.Enabled := True;
  End
  Else
  Begin
    btnViewExam.Enabled := False;
    btnExamFinalReport.Enabled := False;
  End;

  If FMExamRequestListbox.ItemIndex > -1 Then
    btnGenerateReport.Enabled := True
  Else
    btnGenerateReport.Enabled := False;
End;

Procedure TfrmMain.FormResize(Sender: TObject);
Var
  x: integer;
Begin
  //Buttons
  btnAddRequest.font := Panel1.Font;
  btnGenerateReport.font := Panel1.Font;
  btnViewExam.font := Panel1.Font;
  btnAdd7131.font := Panel1.Font;
  btnGenerate7131Report.font := Panel1.Font;
  btnView7131.font := Panel1.Font;

  //ReportTab
  panelreportchoice.left := page95control1.Left + (frmMain.width Div 2) - (panelreportchoice.width Div 2);
  panelreportchoice.top := page95control1.top + (frmMain.height Div 2) - (panelreportchoice.height Div 2) - 40;
  panelreportchoice2.left := page95control1.Left + (frmMain.width Div 2) - (panelreportchoice2.width Div 2);
  panelreportchoice2.top := page95control1.top + (frmMain.height Div 2) - (panelreportchoice2.height Div 2) - 40;
  panelsurgeryreports.left := page95control1.Left + (frmMain.width Div 2) - (panelsurgeryreports.width Div 2);
  panelsurgeryreports.top := page95control1.top + (frmMain.height Div 2) - (panelsurgeryreports.height Div 2) - 40;

  //Clinical Documents Tab
  btnGraphVS.Height := Panel1.Height;
  panelGraphVS.Width := panelDocs.Width - 2;
  panelGraphVS.Height := btnGraphVS.height + 8;
  btnGraphVS.Width := PanelGraphVS.Width - 16;
  buttonClinDocDateRange.Font := Panel1.Font;
  buttonClinDocDateRange.Height := Panel1.Height;
  buttonClinDocDateRange.Left := Round(Tab95Control1.Width * 0.63);
  ButtonClinDocDateRange.Width := PanelDocs.Width + PanelDocs.Left - ButtonClinDocDateRange.Left;
  btnMulti.Height := (Panel1.Font.Height * -1) + 8;
  btnMulti2.Height := (Panel1.Font.Height * -1) + 8;
  btnMulti.font := Panel1.Font;
  btnMulti2.font := Panel1.Font;
  label15.caption := '0000000 Items';
  btnMulti.Left := LabelDocsFound.Left + Label15.Width + 16;
  btnMulti2.Left := btnMulti.Left + btnMulti.Width + 1;
  label15.caption := 'Find:';
  btnMulti.Height := Panel1.Height;
  btnMulti2.Height := Panel1.Height;
  label15.caption := btnMulti.Caption;
  btnMulti.Width := Label15.Width + 40;
  label15.caption := btnMulti2.Caption;
  btnMulti2.Width := Label15.Width + 40;
  label15.caption := 'Find:';
  paneldocs.top := btnMulti.Top + btnMulti.Height + 4;
  paneldocs.height := tab95control1.DisplayRect.BottomRight.y - tab95control1.DisplayRect.TopLeft.y - 1 - panelDocs.Top;
  PanelDocs.Width := Page95Control1.Width - 32;
  LabelCurrentView.Left := buttonClinDocDateRange.Left - LabelCurrentView.width - 8;
  btndivisions.height := Panel1.Height;
  btnGraphVS.height := Panel1.Height;
  panelcount.top := paneldocs.top + paneldocs.height - panelcount.height * 2 - 8;
  //panelGraphVS.top:=paneldocs.top+paneldocs.height-panelGraphVS.height*2-8;
  panelsearch.top := panelcount.top;
  label15.caption := btnDivisions.Caption;
  btnDivisions.Width := Label15.Width + 8;
  btnDivisions.Height := Panel1.Height;
  label15.caption := btnGraphVS.Caption;
  btnGraphVS.Width := Label15.Width + 8;
  btnGraphVS.Height := Panel1.Height;
  label15.caption := buttonSearch.Caption;
  buttonSearch.Width := Label15.Width + 8;
  buttonSearch.Height := Panel1.Height - 2;
  Label15.Caption := 'Search terms here';
  EditSearchPN.Width := label15.width;
  label15.caption := 'Find:';
  PanelCount.Height := btnDivisions.Height + btnDivisions.top;
  PanelCount.Width := btnDivisions.Width + 8;
  //PanelGraphVS.Height:=btnGraphVS.Height+btnGraphVS.top;
  //PanelGraphVS.Width:=btnGraphVS.Width+8;
  panelSearch.Height := editsearchPN.Height + 3;
  splitter2.height := panelcount.height + 6;
  Panelsearch.Width := Label15.Width + 8 + EditSearchPN.Width + 8 + buttonsearch.width + 8;
  Label15.Left := 4;
  EditSearchPN.Left := Label15.Left + Label15.Width + 8;
  ButtonSearch.Left := EditSearchPN.Left + EditSearchPN.Width + 8;
  PanelSearch.Left := PanelDocs.Width - PanelSearch.Width - 8;

  //Address tab
  FMEditStreet2.Top := FMEditStreet1.Top + FMEditStreet1.Height + 4;
  FMEditStreet3.Top := FMEditStreet2.Top + FMEditStreet2.Height + 4;
  FMEditCity.Top := FMEditStreet3.Top + FMEditStreet3.Height + 4;
  StateFake.Top := FMEditCity.Top + FMEditCity.Height + 4;
  FMStatesList.Top := StateFake.Top;
  ButtonStateAccept.Top := FMStatesList.Top + FMStatesList.Height + 1;
  FMEditState.Top := FMEditCity.Top + FMEditCity.Height + 4;
  FMEditZip.Top := FMEditState.Top + FMEditState.Height + 4;
  CountyFake.Top := FMEditZip.Top + FMEditZip.Height + 4;
  FMCountiesList.Top := CountyFake.Top;
  ButtonCountyAccept.Top := FMCountiesList.Top + FMCountiesList.Height + 1;
  FMEditCounty.Top := FMEditZip.Top + FMEditZip.Height + 4;
  FMEditPhone.Top := FMEditCounty.Top + FMEditCounty.Height + 4;
  FMEditOffice.Top := FMEditPhone.Top + FMEditPhone.Height + 4;
  FMEditCountry.Top := FMEditCity.Top;                                          //Country
  FMEditProvince.Top := FMEditState.Top;                                        //Province
  FMEditPostalCode.Top := FMEditZip.Top;                                        //Postal Code
  FMEditLastUpdate.Top := FMEditCounty.Top;                                     //Last Update
  FMEditUpdateSite.Top := FMEditPhone.Top;                                      //Update Site

  lblAddress.Top := FMEditStreet1.Top + 3;
  lblCity.Top := FMEditCity.Top + 3;
  lblState.Top := FMEditState.Top + 3;
  lblZip.Top := FMEditZip.Top + 3;
  lblCounty.Top := FMEditCounty.Top + 3;
  lblPhone.Top := FMEditPhone.Top + 3;
  lblOffice.Top := FMEditOffice.Top + 3;
  lblCountry.Top := lblCity.Top;                                                //Country
  lblProvince.Top := lblState.Top;                                              //Province
  lblPostalCode.Top := lblZip.Top;                                              //Postal Code
  lblLastUpdate.Top := lblCounty.Top;                                           //Last Update
  lblUpdateSite.Top := lblPhone.Top;                                            //Update Site

  FMEditStreet1.Left := lblOffice.Width + lblOffice.Left + 30;
  FMEditStreet2.Left := lblOffice.Width + lblOffice.Left + 30;
  FMEditStreet3.Left := lblOffice.Width + lblOffice.Left + 30;
  FMEditCity.Left := lblOffice.Width + lblOffice.Left + 30;
  StateFake.Left := lblOffice.Width + lblOffice.Left + 30;
  FMEditState.Left := lblOffice.Width + lblOffice.Left + 30;
  FMEditZip.Left := lblOffice.Width + lblOffice.Left + 30;
  CountyFake.Left := lblOffice.Width + lblOffice.Left + 30;
  FMEditCounty.Left := lblOffice.Width + lblOffice.Left + 30;
  FMEditPhone.Left := lblOffice.Width + lblOffice.Left + 30;
  FMEditOffice.Left := lblOffice.Width + lblOffice.Left + 30;
  FMStatesList.Left := lblOffice.Width + lblOffice.Left + 30;
  ButtonStateAccept.Left := lblOffice.Width + lblOffice.Left + 30;
  FMCountiesList.Left := lblOffice.Width + lblOffice.Left + 30;
  ButtonCountyAccept.Left := lblOffice.Width + lblOffice.Left + 30;
  lblCountry.Left := FMEditCity.Left + FMEditCity.Width + 30;                   //Country
  FMEditCountry.Left := lblCountry.Left + lblCountry.Width + 30;
  lblProvince.Left := lblCountry.Left;                                          //Province
  FMEditProvince.Left := FMEditCountry.Left;
  lblPostalCode.Left := lblCountry.Left;                                        //Postal Code
  FMEditPostalCode.Left := FMEditCountry.Left;
  lblLastUpdate.Left := lblCountry.Left;                                        //LastUpdate
  FMEditLastUpdate.Left := FMEditCountry.Left;
  lblUpdateSite.Left := lblCountry.Left;                                        //UpdateSite
  FMEditUpdatesite.Left := FMEditCountry.Left;

  x := ScrollBoxAddress.Width - FMEditStreet1.Left - FMEditStreet1.Width - lblAddress.Left - lblAddress.Left;
  FMEditStreet1.Width := FMEditStreet1.Width + x;
  FMEditStreet2.Width := FMEditStreet1.Width;
  FMEditStreet3.Width := FMEditStreet1.Width;
  FMEditCity.Width := FMEditCity.Width + x Div 2;
  StateFake.Width := StateFake.Width + x Div 2;
  FMStatesList.Width := StateFake.Width;
  ButtonStateAccept.Width := StateFake.Width;
  FMEditState.Width := StateFake.Width;
  FMEditZip.Width := StateFake.Width;
  CountyFake.Width := StateFake.Width;
  FMCountiesList.Width := StateFake.Width;
  ButtonCountyAccept.Width := StateFake.Width;
  FMEditCounty.Width := StateFake.Width;
  FMEditPhone.Width := StateFake.Width;
  FMEditOffice.Width := StateFake.Width;
  FMEditCountry.Width := StateFake.Width;                                       //Country
  FMEditProvince.Width := StateFake.Width;                                      //Province
  FMEditPostalCode.Width := StateFake.Width;                                    //Postal Code
  FMEditLastUpdate.Width := StateFake.Width;                                    //Last Update
  FMEditUpdateSite.Width := StateFake.Width;                                    //Update Site

  btnEditAddress.Height := Panel1.Height;
  btnRefreshAddress.Height := btnEditAddress.Height;
  btnSaveAddress.Height := btnEditAddress.Height;
  buttonStateAccept.Height := btnEditAddress.Height;
  buttonCountyAccept.Height := btnEditAddress.Height;

  btnEditAddress.Top := FMEditOffice.Top + FMEditOffice.Height + 8;
  btnRefreshAddress.Top := btnEditAddress.Top;
  btnSaveAddress.Top := btnEditAddress.Top;
  Shape1.Top := btnEditAddress.Top + btnEditAddress.Height + 8;

  Label1.Font := Panel1.Font;
  Label1.Font.Style := [fsbold];
  Label1.Top := Shape1.Top + Shape1.Height + 8;
  FMEdit1.Top := Label1.Top + Label1.Height + 4;
  FMEdit10.Top := FMEdit1.Top + FMEdit1.Height + 4;
  FMEdit11.Top := FMEdit10.Top;
  FMEdit2.Top := FMEdit10.Top + FMEdit10.Height + 4;
  FMEdit3.Top := FMEdit2.Top + FMEdit2.Height + 4;
  FMEdit4.Top := FMEdit3.Top + FMEdit3.Height + 4;
  FMEdit5.Top := FMEdit4.Top + FMEdit4.Height + 4;
  FMEdit6.Top := FMEdit5.Top + FMEdit5.Height + 4;
  FMEdit7.Top := FMEdit6.Top + FMEdit6.Height + 4;
  FMEdit8.Top := FMEdit7.Top + FMEdit7.Height + 4;
  FMEdit9.Top := FMEdit8.Top + FMEdit8.Height + 4;
  FMEditTempCountry.Top := FMEdit5.Top;                                         //Temp Country
  FMEditTempProvince.Top := FMEdit6.Top;                                        //Temp Province
  FMEditTempPostalCode.Top := FMEdit7.Top;                                      //Temp Postal Code
  FMEditTempLastUpdate.Top := FMEdit8.Top;                                      //Temp Last Update
  FMEditTempUpdateSite.Top := FMEdit9.Top;                                      //Temp Update Site

  Label3.Top := FMEdit1.Top + 3;
  Label10.Top := FMEdit10.Top + 3;
  Label11.Top := Label10.Top;
  Label4.Top := FMEdit2.Top + 3;
  Label7.Top := FMEdit5.Top + 3;
  Label5.Top := FMEdit6.Top + 3;
  Label6.Top := FMEdit7.Top + 3;
  Label8.Top := FMEdit8.Top + 3;
  Label9.Top := FMEdit9.Top + 3;
  lblTempCountry.Top := Label7.Top;                                             //Temp Country
  lblTempProvince.Top := Label5.Top;                                            //Temp Province
  lblTempPostalCode.Top := Label6.Top;                                          //Temp Postal Code
  lblTempLastUpdate.Top := Label8.Top;                                          //Temp Last Update
  lblTempUpdateSite.Top := Label9.Top;                                          //Temp Update Site

  FMEdit1.Left := Label3.Left + Label3.Width + 30;
  FMEdit10.Left := lblOffice.Width + lblOffice.Left + 30;
  Label11.Left := FMEdit10.Left + FMEdit10.Width + 30;
  FMEdit11.Left := Label11.Left + Label11.Width + 30;
  FMEdit2.Left := FMEdit10.Left;
  FMEdit3.Left := FMEdit10.Left;
  FMEdit4.Left := FMEdit10.Left;
  FMEdit5.Left := FMEdit10.Left;
  FMEdit6.Left := FMEdit10.Left;
  FMEdit7.Left := FMEdit10.Left;
  FMEdit8.Left := FMEdit10.Left;
  FMEdit9.Left := FMEdit10.Left;
  lblTempCountry.Left := FMEdit5.Left + FMEdit5.Width + 30;                     //TempCountry
  FMEditTempCountry.Left := lblTempCountry.Left + lblTempCountry.Width + 30;
  lblTempProvince.Left := lblTempCountry.Left;                                  //TempProvince
  FMEditTempProvince.Left := FMEditTempCountry.Left;
  lblTempPostalCode.Left := lblTempCountry.Left;                                //TempPostalCode
  FMEditTempPostalCode.Left := FMEditTempCountry.Left;
  lblTempLastUpdate.Left := lblTempCountry.Left;                                //TempLastUpdate
  FMEditTempLastUpdate.Left := FMEditTempCountry.Left;
  lblTempUpdateSite.Left := lblTempCountry.Left;                                //TempUpdateSite
  FMEditTempUpdateSite.Left := FMEditTempCountry.Left;

  x := ScrollBoxAddress.Width - FMEdit2.Left - FMEdit2.Width - label4.Left - Label4.Left;
  FMEdit1.Width := FMEdit1.Width + x;
  FMEdit2.Width := FMEdit2.Width + x;
  FMEdit3.Width := FMEdit3.Width + x;
  FMEdit4.Width := FMEdit4.Width + x;
  FMEdit5.Width := FMEdit5.Width + x Div 2;
  FMEdit6.Width := FMEdit5.Width;
  FMEdit7.Width := FMEdit5.Width;
  FMEdit8.Width := FMEdit5.Width;
  FMEdit9.Width := FMEdit5.Width;
  FMEditTempCountry.Width := FMEdit5.Width;                                     //TempCountry
  FMEditTempProvince.Width := FMEdit5.Width;                                    //TempProvince
  FMEditTempPostalCode.Width := FMEdit5.Width;                                  //TempPostalCode
  FMEditTempLastUpdate.Width := FMEdit5.Width;                                  //TempLastUpdate
  FMEditTempUpdateSite.Width := FMEdit5.Width;                                  //TempUpdateSite

  x := ScrollBoxAddress.Width - FMEdit11.Left - FMEdit11.Width - label10.Left - Label10.Left - Label11.Width;
  FMEdit10.Width := FMEdit10.Width + x Div 2;
  FMEdit11.Width := FMEdit11.Width + x Div 2;

  ScrollBoxAddress.VertScrollBar.Range := FMEditStreet1.Height * 28;
  ScrollBoxAddress.HorzScrollBar.Range := FMEditStreet1.Left + FMEditStreet1.Width;
  Shape1.Width := ScrollBoxAddress.HorzScrollBar.Range - Shape1.Left;
  btnEditAddress.Width := Shape1.Width Div 3;
  btnRefreshAddress.Width := btnEditAddress.Width;
  btnSaveAddress.Width := Shape1.Width - btnRefreshAddress.Width - btnEditAddress.Width;
  btnEditAddress.Left := Shape1.Left;
  btnRefreshAddress.Left := btnEditAddress.Left + btnEditAddress.Width;
  btnSaveAddress.Left := btnRefreshAddress.Left + btnRefreshAddress.Width;

  //Main Folder, Patient Caption Bar, Status Bar at bottom
  Panel1.Width := frmMain.Width - 13;
  Panel1.Height := (Panel1.Font.Height * -1) + 8 + 3;
  Page95Control1.Top := Panel1.Height + Panel1.Top + 1;
  Page95Control1.Height := frmMain.Clientheight - Panel2.height - Panel1.Height -
    ActionMainMenuBar1.Height - 4;

  //Exam Request Panel and buttons
  GroupBox1.Height := TabCPExams.Height - GroupBox1.Top - 30;
  GroupBox1.Left := 56;
  GroupBox1.Width := Page95Control1.Width - 56 * 2;
  Label2.Top := (Panel1.Font.Height * -1) + 8;
  btnExamFinalReport.height := (Panel1.Font.Height * -1) + 8;
  btnAddRequest.height := (Panel1.Font.Height * -1) + 8;
  btnAddRequest.width := GroupBox1.Width - (FMExamRequestListbox.Left * 2);
  btnGenerateReport.height := (Panel1.Font.Height * -1) + 8;
  btnViewExam.height := (Panel1.Font.Height * -1) + 8;
  btnExamFinalReport.top := GroupBox1.Height - (Panel1.Font.Height * -1) - 20;
  btnAddRequest.Top := btnExamFinalReport.Top - btnAddRequest.Height - 0;
  btnGenerateReport.top := GroupBox1.Height - (Panel1.Font.Height * -1) - 20;
  btnViewExam.top := GroupBox1.Height - (Panel1.Font.Height * -1) - 20;
  FMExamRequestListbox.Top := Panel1.Font.Height * -2 + 16;
  FMExamRequestListbox.Height := btnAddRequest.Top - FMExamRequestListbox.Top - 2;
  FMExamRequestListbox.Width := GroupBox1.Width - (FMExamRequestListbox.Left * 2);
  btnAddRequest.width := GroupBox1.Width - (FMExamRequestListbox.Left * 2);
  btnExamFinalReport.width := FMExamRequestListbox.Width Div 3;
  btnGenerateReport.width := FMExamRequestListbox.Width Div 3;
  btnViewExam.Width := FMExamRequestListbox.Width - btnGenerateReport.width - btnExamFinalReport.width;
  btnGenerateReport.Left := btnExamFinalReport.Left + btnExamFinalReport.width + 1;
  btnViewExam.Left := btnGenerateReport.Left + btnGenerateReport.Width + 1;
  btnAddRequest.width := btnExamFinalReport.width + btnGenerateReport.width + btnViewExam.Width + 2;

  //7131 Request Panel and buttons
  GroupBox2.Height := TabCPExams.Height - GroupBox2.Top - 30;
  GroupBox2.Left := 56;
  GroupBox2.Width := Page95Control1.Width - 56 * 2;
  Label12.Top := (Panel1.Font.Height * -1) + 8;
  btnAdd7131.height := (Panel1.Font.Height * -1) + 8;
  btnGenerate7131Report.height := (Panel1.Font.Height * -1) + 8;
  btnView7131.height := (Panel1.Font.Height * -1) + 8;
  btnAdd7131.top := GroupBox2.Height - (Panel1.Font.Height * -1) - 20;
  btnGenerate7131Report.top := GroupBox2.Height - (Panel1.Font.Height * -1) - 20;
  btnView7131.top := GroupBox2.Height - (Panel1.Font.Height * -1) - 20;
  FMSeventyOne31RequestListbox.Top := Panel1.Font.Height * -2 + 16;
  FMSeventyOne31RequestListbox.Height := btnView7131.Top - FMSeventyOne31RequestListbox.Top - 2;
  FMSeventyOne31RequestListbox.Width := GroupBox2.Width - (FMSeventyOne31RequestListbox.Left * 2);
  btnAdd7131.width := FMSeventyOne31RequestListbox.Width Div 3;
  btnGenerate7131Report.width := FMSeventyOne31RequestListbox.Width Div 3;
  btnView7131.Width := FMSeventyOne31RequestListbox.Width - btnGenerate7131Report.width - btnAdd7131.width;
  btnGenerate7131Report.Left := btnAdd7131.Left + btnAdd7131.width + 1;
  btnView7131.Left := btnGenerate7131Report.Left + btnGenerate7131Report.Width + 1;

  //Report Tab
  //PanelReportChoice.Top:=(ReportMemo.Height div 2)-(PanelReportChoice.Height div 2);
  //PanelReportChoice.Width:=frmMain.width div 2;
  //PanelReportChoice.Left:=(frmMain.Width div 2)-(PanelReportChoice.Width div 2);
  labelReportChoice.Font := Panel1.Font;
  labelReportChoice.Height := (LabelReportChoice.Font.Height * -1) + 2;
  buttonCancelReportAdmission.Height := (Panel1.Font.Height * -1) + 8;
  buttonOKReportAdmission.Height := (Panel1.Font.Height * -1) + 8;
  buttonCancelReportAdmission.Top := PanelReportChoice.Height - buttonCancelReportAdmission.Height - 12;
  buttonOKReportAdmission.Top := PanelReportChoice.Height - buttonCancelReportAdmission.Height - 12;
  FMListBoxAdmission.Top := LabelReportChoice.Top + LabelReportChoice.Height + 8;
  FMListBoxAdmission.Height := buttonCancelReportAdmission.Top - FMListBoxAdmission.Top - 8;
  FMListBoxAdmission.Width := PanelReportChoice.Width - (FMListBoxAdmission.Left * 2);
  labelReportChoice.Width := FMListBoxAdmission.Width;
  buttonOKReportAdmission.Left := FMListBoxAdmission.Left + (fmlistboxAdmission.width Div 2);
  buttonOKReportAdmission.Width := fmlistboxAdmission.width Div 2;
  buttonCancelReportAdmission.Width := buttonOKReportAdmission.Left - buttonCancelReportAdmission.Left;

  //Appointments tab
  lblApptStatus.Font := Panel1.Font;
  lblApptStatus.Height := (Panel1.Font.Height * -1) + 2;
  MemoAppointments.Top := lblApptStatus.Height + lblApptStatus.top + 8;
  btnAll.Height := (Panel1.Font.Height * -1) + 8;
  btnFuture.Height := (Panel1.Font.Height * -1) + 8;
  btnPast.Height := (Panel1.Font.Height * -1) + 8;
  btnAdmissions.Height := (Panel1.Font.Height * -1) + 8;
  btnAll.Top := Tab95Control3.Height - btnAll.Height * 3 - 12;
  btnFuture.Top := btnAll.Top;
  btnPast.Top := btnAll.top;
  btnAdmissions.Top := btnAll.top;
  MemoAppointments.Height := btnAll.Top - MemoAppointments.Top - 12;
  btnAll.Width := MemoAppointments.Width Div 5;
  btnFuture.Width := MemoAppointments.Width Div 5;
  btnPast.Width := MemoAppointments.Width Div 5;
  btnAdmissions.Width := MemoAppointments.Width Div 5;
  btnFuture.Left := btnAll.Left + btnAll.Width + 1;
  btnPast.Left := btnFuture.Left + btnFuture.Width + 1;
  btnAdmissions.Left := btnPast.Left + (btnAdmissions.Width * 2) + 1;

  //health Summaries
  Label18.Font := Panel1.Font;
  Label18.Height := (Panel1.Font.Height * -1) + 2;
  ButtonRDV.Height := (Panel1.Font.Height * -1) + 8;
  ButtonRDV.Top := PanelHSReport.Height - ButtonRDV.Height;
  ComboBoxHSSections.Font := Panel1.Font;
  ComboBoxHSSections.Height := (Panel1.Font.Height * -1) + 8;
  ComboBoxHSSections.Left := Label18.Left + Label18.Width + 8;
  ComboBoxHSSections.Width := PanelHSReport.Width - ComboBoxHSSections.Left - 8;
  Tab95Control2.Top := ComboBoxHSSections.Top + ComboBoxHSSections.Height + 8;
  Tab95Control2.Height := ButtonRDV.Top - Tab95Control2.Top - 1;
  //ORHealthSummaryUserList.Height:=Panel4.Height-btnAdHoc.Height-4;
  panel9.height := panel4.height - 26;

  //Other Stuff
  PanelReportChoice2.Top := ((frmMain.Height - PanelReportChoice2.Height) Div 2) - 32;
  PanelReportChoice2.Left := (frmMain.Width - PanelReportChoice2.Width) Div 2;

  //This was the CAPRI logo on the desktop
  Panel3.Top := ((frmMain.Height - Panel3.Height) Div 2) - 32;
  Panel3.Left := (frmMain.Width - Panel3.Width) Div 2;

  PanelRemoteData.Top := ((frmMain.Height - PanelRemoteData.Height) Div 2) - 32;
  PanelRemoteData.Left := (frmMain.Width - PanelRemoteData.Width) Div 2;

  //DemoGraphicMemo.Left:=(frmMain.Width-636) div 2;
  //DemoGraphicMemo.Height:=TabbedNotebook1.Height-28;

  //Button3.Top:=TabbedNotebook1.Height-72;
  //Button3.Top:=Page95Control1.Height-80;
  //Button4.Top:=Page95Control1.Height-80;
  //Button5.Top:=Page95Control1.Height-80;
  //Button1.Top:=Page95Control1.Height-80;
  //Button6.Top:=Page95Control1.Height-80;
  //Button11.Top:=Page95Control1.Height-80;
  //Button12.Top:=Page95Control1.Height-80;
  //PanelDocs.Height:=Page95Control1.Height-104;
  //Button10.Top:=Page95Control1.Height-56;
  //Button2.Top:=Page95Control1.Height-56;
  //Button12a.Top:=Page95Control1.Height-56;
  //Button4a.Top:=Page95Control1.Height-56;
  //Button3a.Top:=Page95Control1.Height-56;
End;

Procedure TfrmMain.btnAllClick(Sender: TObject);
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;

  AnimateLogo(True);
  StatusBarLoadPt.Caption := 'Download all appointments.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
  lblApptStatus.Caption := 'All Appointments';
  frmMain.RPCBroker1.Results.Clear;
  RPCBroker1.RemoteProcedure := 'DVBAB APPOINTMENT LIST';
  RPCBroker1.Param[0].Value := PatientIEN;
  RPCBroker1.Param[0].PType := literal;
  RPCBroker1.Param[1].Value := 'A';                                             //A=All appt. F=Future appt. P=Past appt.
  RPCBroker1.Param[1].PType := literal;
  RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'RPC DVBAB APPOINTMENT LIST could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('DVBAB APPOINTMENT LIST could not be accessed!');
    End;
  End;

  //Begin Build Report
  ANURemoteProcedureCallInProgress := true;
  MemoAppointments.Lines.Clear;
  screen.cursor := crHourglass;

  MemoAppointments.SetSelTextBuf(RPCBroker1.Results.GetText);

  screen.cursor := crDefault;
  MemoAppointments.Visible := True;
  MemoAppointments.SelStart := 0;
  MemoAppointments.SelLength := 0;

  if IsSetFocusValid(MemoAppointments) then
    MemoAppointments.SetFocus;

  ANURemoteProcedureCallinProgress := False;
  AnimateLogo(False);
  StatusBarLoadPt.Caption := 'Ready.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
  //End Of Build Report

End;

Procedure TfrmMain.btnFutureClick(Sender: TObject);
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;

  AnimateLogo(True);
  StatusBarLoadPt.Caption := 'Download future appointments.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
  lblApptStatus.Caption := 'Future Appointments';
  frmMain.RPCBroker1.Results.Clear;
  RPCBroker1.RemoteProcedure := 'DVBAB APPOINTMENT LIST';
  RPCBroker1.Param[0].Value := PatientIEN;
  RPCBroker1.Param[0].PType := literal;
  RPCBroker1.Param[1].Value := 'F';                                             //A=All appt. F=Future appt. P=Past appt.
  RPCBroker1.Param[1].PType := literal;
  RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'RPC DVBAB APPOINTMENT LIST could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('DVBAB APPOINTMENT LIST could not be accessed!');
    End;
  End;
  //Begin Build Report
  ANURemoteProcedureCallInProgress := true;
  MemoAppointments.Lines.Clear;
  screen.cursor := crHourglass;

  MemoAppointments.SetSelTextBuf(RPCBroker1.Results.GetText);

  screen.cursor := crDefault;
  MemoAppointments.Visible := True;
  MemoAppointments.SelStart := 0;
  MemoAppointments.SelLength := 0;
  Try
  MemoAppointments.SetFocus Except
  End;
  ANURemoteProcedureCallinProgress := False;
  AnimateLogo(False);
  StatusBarLoadPt.Caption := 'Ready.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
  //End Of Build Report

End;

Procedure TfrmMain.btnDocsRefreshClick(Sender: TObject);
Begin
  MemoDocs.Lines.Add('Please select the type of document you wish to browse...');
  lstDocs.Items.Clear;
End;

Procedure TfrmMain.lstDocsClick(Sender: TObject);
const
  STR_MultipleSelected = 'Multiple documents are selected.';                    //-MER CodeCR126 7/2010
Var
  anuapptpointer: String;
  anudivision: String;
  anuinstitution: String;
  counter: integer;
  drugbuffer: String;
  drugclass: String;
  drugcount: integer;
  druglines: integer;
  druglookup: String;
  dt: String;
  fmdatenow: String;
  fmdatepast: String;
  foundreportflag: boolean;
  inX: longint;
  line: String;
  medbuffer: ansistring;
  name: String;
  quicklookup: tstringlist;
  resultsbuffer: tstringlist;
  RPCParams: TParams;
  whichline: integer;
  x: longint;
  xx: integer;
  yy: integer;
  zz: integer;
  DisplayGrpIEN: String;
Begin
  // if multiple documents are selected, don't display a document -MER CodeCR126 7/2010
  if (lstDocs.SelCount > 1) then begin
    if (Pos(STR_MultipleSelected, memoDocs.Lines[0]) = 0) then begin
      memoDocs.Lines.Clear;
      memoDocs.Lines.Add(STR_MultipleSelected);
    end;
    exit;
  end;
  inX := 0;
  If ANURemoteProcedureCallInProgress = True Then
    exit;
{  RPCBroker1.RemoteProcedure := 'ORWU DT';
  RPCBroker1.Param[1].Value := 'NOW';
  RPCBroker1.Param[1].PType := literal;
  Try
    RPCBroker1.Call;}
  //test dynamic RPC parameters
  RPCParams := TParams.Create(nil);
  RPCParams[1].Value := 'NOW';
  RPCParams[1].PType := literal;
  try
    try
      if RPCBroker1.CallServer('ORWU DT', RPCParams) and
        (RPCBroker1.Results.Count > 0) then
        fmdatenow := RPCBroker1.Results[0];
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        AnimateLogo(False);
        StatusBarLoadPt.Caption := 'RPC ORWU DT could not be accessed!';
        StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('ORWU DT could not be accessed!');
      End;
    End;
  finally
    FreeAndNil(RPCParams);
  end;

  If formReportBuilder <> Nil Then
    If dvbaz = 0 Then
      FormReportBuilder.ORbtnAddCurrent.Enabled := True;

  AnimateLogo(True);
  StatusBarLoadPt.Caption := 'Downloading clinical document.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
  If (DocType = 'PROBLEM LIST') Then
  Begin
    RPCBroker1.RemoteProcedure := 'ORQQPL PROBLEM LIST';
    RPCBroker1.Param[1].Value := PatientIEN;                                    // Patient IEN
    RPCBroker1.Param[1].PType := literal;
    If lstDocs.ItemIndex = 0 Then
      RPCBroker1.Param[2].Value := 'A';                                         // Both Active and Inactive
    If lstDocs.ItemIndex = 1 Then
      RPCBroker1.Param[2].Value := 'I';                                         // Both Active and Inactive
    If lstDocs.ItemIndex = 2 Then
      RPCBroker1.Param[2].Value := 'B';                                         // Both Active and Inactive
    RPCBroker1.Param[2].PType := literal;
    Try
      RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        AnimateLogo(False);
        StatusBarLoadPt.Caption := 'ORQQPL PROBLEM LIST could not be accessed!';
        StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('ORQQPL PROBLEM LIST could not be accessed!');
      End
    End;
    memoDocs.Visible := False;
    memoDocs.Lines.Clear;
    If RPCBroker1.Results.Count = 0 Then
    Begin
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'Ready.';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      exit;
    End;
    If RPCBroker1.Results[0] = '0' Then
    Begin
      MemoDocs.Lines.Add('');
      MemoDocs.Lines.Add('No problems found.');
    End;
    For x := 1 To StrToInt(RPCBroker1.Results[0]) Do
    Begin
      line := RPCBroker1.Results[x];
      name := Piece(line, '^', 12);
      dt := Piece(line, '^', 5);
      If name <> '' Then
        Name := Copy(name, pos(';', name) + 1, 20);
      If dt <> '' Then
        memoDocs.Lines.Add(Piece(line, '^', 2) + '  ' + Piece(line, '^', 3) + '  ' + name + '  Onset: ' + fmDatetimeConvert(dt));
      If dt = '' Then
        memoDocs.Lines.Add(Piece(line, '^', 2) + '  ' + Piece(line, '^', 3) + '  ' + name);
    End;
    MemoDocs.Visible := True;
    MemoDocs.SelStart := 0;
    MemoDocs.SelLength := 0;                                                    // ET 060329 try lstDocs.SetFocus except end;
  End;
  If (DocType = 'ORDERS') Then // Order Summary
  Begin
    frmMain.RPCBroker1.Results.Clear;
    RPCBroker1.RemoteProcedure := 'ORWRP REPORT TEXT';
    RPCBroker1.Param[1].Value := PatientIEN;                                    // Patient IEN
    RPCBroker1.Param[1].PType := literal;
    RPCBroker1.Param[2].Value := '11';                                          // Order Summary
    RPCBroker1.Param[2].PType := literal;
    RPCBroker1.Param[3].Value := '';
    RPCBroker1.Param[3].PType := literal;
    If lstDocs.ItemIndex = 0 Then
      RPCBroker1.Param[4].Value := '0';
    If lstDocs.ItemIndex = 1 Then
      RPCBroker1.Param[4].Value := '7';
    If lstDocs.ItemIndex = 2 Then
      RPCBroker1.Param[4].Value := '14';
    If lstDocs.ItemIndex = 3 Then
      RPCBroker1.Param[4].Value := '30';
    If lstDocs.ItemIndex = 4 Then
      RPCBroker1.Param[4].Value := '180';
    If lstDocs.ItemIndex = 5 Then
      RPCBroker1.Param[4].Value := '365';
    If lstDocs.ItemIndex = 6 Then
      RPCBroker1.Param[4].Value := '730';
    If lstDocs.ItemIndex = 7 Then
      RPCBroker1.Param[4].Value := '1825';
    If lstDocs.ItemIndex = 8 Then
      RPCBroker1.Param[4].Value := '99999';
    RPCBroker1.Param[4].PType := literal;
    RPCBroker1.Param[5].Value := '';
    RPCBroker1.Param[5].PType := literal;
    Try
      RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        AnimateLogo(False);
        StatusBarLoadPt.Caption := 'RPC ORWRP REPORT TEXT could not be accessed!';
        StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('RPC ORWRP REPORT TEXT could not be accessed!');
      End
    End;
    memoDocs.Visible := False;
    memoDocs.Lines.Clear;
    MemoDocs.SetSelTextBuf(RPCBroker1.Results.GetText);
    If MemoDocs.Lines.Count = 0 Then
    Begin
      MemoDocs.Lines.Add('');
      MemoDocs.Lines.Add('No orders found.');
    End;
    MemoDocs.Lines.Add('');
    MemoDocs.Visible := True;
    MemoDocs.SelStart := 0;
    MemoDocs.SelLength := 0;                                                    // ET 060329 try lstDocs.SetFocus except end;
  End;
  If (DocType = 'NUTASSESS') Then // Nutritional Assessment
  Begin
    If CPRSVersion = 'V16' Then
    Begin
      RPCBroker1.RemoteProcedure := 'ORWRP REPORT TEXT';
      RPCBroker1.Param[1].Value := PatientIEN;                                  // Patient IEN
      RPCBroker1.Param[1].PType := literal;
      RPCBroker1.Param[2].Value := '17:NUTRITIONAL ASSESSMENT~DIETNS;ORDV08';   // Nutrition assessment
      RPCBroker1.Param[2].PType := literal;
      RPCBroker1.Param[3].Value := '';
      RPCBroker1.Param[3].PType := literal;
      RPCBroker1.Param[4].Value := '99999';
      RPCBroker1.Param[4].PType := literal;
      RPCBroker1.Param[5].Value := '';                                          //lstDocs.Items[lstDocs.ItemIndex];
      RPCBroker1.Param[5].PType := literal;
      RPCBroker1.Param[6].Value := '0';
      RPCBroker1.Param[6].PType := literal;
      RPCBroker1.Param[7].Value := '0';
      RPCBroker1.Param[7].PType := literal;
      Try
        RPCBroker1.Call;
      Except
        On EBrokerError Do
        Begin
          ANURemoteProcedureCallInProgress := False;
          AnimateLogo(False);
          StatusBarLoadPt.Caption := 'RPC ORWRP REPORT TEXT could not be accessed!';
          StatusBarLoadPt.Repaint;
          Application.Processmessages;
          ShowMessageCAPRI('RPC ORWRP REPORT TEXT could not be accessed!');
        End
      End;
      memoDocs.Lines.Clear;
      MemoDocs.Visible := False;
      Counter := -1;

      // if not searching, then use existing code to bring up data for each
      // document selected
      If EditSearchPN.Text = '' Then                                            // CodeCR696 JRL 4/10/15
      begin                                                                     // CodeCR696 JRL 4/10/15
        If RPCBroker1.Results.Count > 0 Then
          For yy := 0 To RPCBroker1.Results.Count - 1 Do
          Begin
            If Piece(RPCBroker1.Results[yy], '^', 1) = '1' Then
              inc(counter);       
            If Counter = lstDocs.ItemIndex Then
              If Piece(RPCBroker1.Results[yy], '^', 1) = '3' Then
                memoDocs.Lines.Add(Piece(RPCBroker1.Results[yy], '^', 2));
          End;
      end                                                                       // CodeCR696 JRL 4/10/15
      else // if searching, then check the values of the original listbox       // CodeCX696 JRL 4/10/15
           // containing all documents against the ones left in the smaller
           // search results.  This is needed because this particular RPC
           // returns all text results in one call versus returning one document
           // as it is selected on the left.
      begin                                                                     // CodeCX696 JRL 4/10/15
        If RPCBroker1.Results.Count > 0 Then                                    // CodeCX696 JRL 4/10/15
          For yy := 0 To RPCBroker1.Results.Count - 1 Do                        // CodeCX696 JRL 4/10/15
          Begin                                                                 // CodeCX696 JRL 4/10/15
            If Piece(RPCBroker1.Results[yy], '^', 1) = '1' Then                 // CodeCX696 JRL 4/10/15
              inc(counter);                                                     // CodeCX696 JRL 4/10/15
            if lstDocs.Items[lstDocs.ItemIndex] = lbNUTASSESSSearchIndex.Items[Counter] then // CodeCX696 JRL 4/10/15
              If Piece(RPCBroker1.Results[yy], '^', 1) = '3' Then               // CodeCX696 JRL 4/10/15
                memoDocs.Lines.Add(Piece(RPCBroker1.Results[yy], '^', 2));      // CodeCX696 JRL 4/10/15
          End;                                                                  // CodeCX696 JRL 4/10/15
      end;                                                                      // CodeCX696 JRL 4/10/15
      MemoDocs.Lines.Add('');
      MemoDocs.Visible := True;
      MemoDocs.SelStart := 0;
      MemoDocs.SelLength := 0;                                                  // ET 060329 try lstDocs.SetFocus except end;
      If SearchRunning = 0 Then                                                 //CodeCR696 JRL 4/8/15
        If EditSearchPN.Text <> '' Then                                         //CodeCR696 JRL 4/8/15
        Begin                                                                   //CodeCR696 JRL 4/8/15
          LastSearchFoundAt := 0;                                               //CodeCR696 JRL 4/8/15
          buttonSearchClick(application);                                       //CodeCR696 JRL 4/8/15
        End;                                                                    // end of V15 CPRS
    End;                                                                        // end of V16 CPRS
    If CPRSVersion = 'V15' Then
    Begin
      RPCBroker1.RemoteProcedure := 'ORWRP REPORT TEXT';
      RPCBroker1.Param[1].Value := PatientIEN;                                  // Patient IEN
      RPCBroker1.Param[1].PType := literal;
      RPCBroker1.Param[2].Value := '17';                                        // Nutrition assessment
      RPCBroker1.Param[2].PType := literal;
      RPCBroker1.Param[3].Value := '';
      RPCBroker1.Param[3].PType := literal;
      RPCBroker1.Param[4].Value := '';
      RPCBroker1.Param[4].PType := literal;
      RPCBroker1.Param[5].Value := lstDocs.Items[lstDocs.ItemIndex];
      RPCBroker1.Param[5].PType := literal;
      Try
        RPCBroker1.Call;
      Except
        On EBrokerError Do
        Begin
          ANURemoteProcedureCallInProgress := False;
          AnimateLogo(False);
          StatusBarLoadPt.Caption := 'RPC ORWRP REPORT TEXT could not be accessed!';
          StatusBarLoadPt.Repaint;
          Application.Processmessages;
          ShowMessageCAPRI('RPC ORWRP REPORT TEXT could not be accessed!');
        End
      End;
      memoDocs.Visible := False;
      memoDocs.Lines.Clear;
      MemoDocs.SetSelTextBuf(RPCBroker1.Results.GetText);
      MemoDocs.Lines.Add('');
      MemoDocs.Visible := True;
      MemoDocs.SelStart := 1;  //??
      MemoDocs.SelLength := 1; //??                                             // ET 060329 try lstDocs.SetFocus except end;
      MemoDocs.SelStart := 0;
      MemoDocs.SelLength := 0;                                                  // ET 060329 try lstDocs.SetFocus except end;
      If SearchRunning = 0 Then                                                 //CodeCR696 JRL 4/8/15
        If EditSearchPN.Text <> '' Then                                         //CodeCR696 JRL 4/8/15
        Begin                                                                   //CodeCR696 JRL 4/8/15
          LastSearchFoundAt := 0;                                               //CodeCR696 JRL 4/8/15
          buttonSearchClick(application);                                       //CodeCR696 JRL 4/8/15
        End;                                                                    // end of V15 CPRS
    End;
  End;
  If (DocType = 'PROCEDURES') Then
  Begin
    RPCBroker1.RemoteProcedure := 'ORWRP REPORT TEXT';
    RPCBroker1.Param[1].Value := PatientIEN;                                    // Patient IEN
    RPCBroker1.Param[1].PType := literal;
    RPCBroker1.Param[2].Value := '19';                                          // Procedures
    RPCBroker1.Param[2].PType := literal;
    RPCBroker1.Param[3].Value := '';
    RPCBroker1.Param[3].PType := literal;
    RPCBroker1.Param[4].Value := '';
    RPCBroker1.Param[4].PType := literal;
    RPCBroker1.Param[5].Value := Piece(lstDocs.Items[lstDocs.ItemIndex], '^', 2);
    RPCBroker1.Param[5].PType := literal;
    RPCBroker1.Param[6].Value := '0';
    RPCBroker1.Param[6].PType := literal;
    RPCBroker1.Param[7].Value := '0';
    RPCBroker1.Param[7].PType := literal;
    Try
      RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        AnimateLogo(False);
        StatusBarLoadPt.Caption := 'RPC ORWRP REPORT TEXT could not be accessed!';
        StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('RPC ORWRP REPORT TEXT could not be accessed!');
      End
    End;
    memoDocs.Visible := False;
    memoDocs.Lines.Clear;
    MemoDocs.SetSelTextBuf(RPCBroker1.Results.GetText);
    MemoDocs.Lines.Add('');
    MemoDocs.Visible := True;
    MemoDocs.SelStart := 0;
    MemoDocs.SelLength := 0;                                                    // ET 060329  try lstDocs.SetFocus except end;
    If SearchRunning = 0 Then                                                   //CodeCR696 JRL 4/8/15
      If EditSearchPN.Text <> '' Then                                           //CodeCR696 JRL 4/8/15
      Begin                                                                     //CodeCR696 JRL 4/8/15
        LastSearchFoundAt := 0;                                                 //CodeCR696 JRL 4/8/15
        buttonSearchClick(application);                                         //CodeCR696 JRL 4/8/15
      End;                                                                      //CodeCR696 JRL 4/8/15
  End;
  If (DocType = 'DIET') Then
  Begin
    RPCBroker1.RemoteProcedure := 'ORWRP REPORT TEXT';
    RPCBroker1.Param[1].Value := PatientIEN;                                    // Patient IEN
    RPCBroker1.Param[1].PType := literal;
    RPCBroker1.Param[2].Value := '4';                                           // Dietetic Report
    RPCBroker1.Param[2].PType := literal;
    RPCBroker1.Param[3].Value := '';
    RPCBroker1.Param[3].PType := literal;
    RPCBroker1.Param[4].Value := '';
    RPCBroker1.Param[4].PType := literal;
    RPCBroker1.Param[5].Value := '';
    RPCBroker1.Param[5].PType := literal;
    RPCBroker1.Param[6].Value := '0';
    RPCBroker1.Param[6].PType := literal;
    RPCBroker1.Param[7].Value := '0';
    RPCBroker1.Param[7].PType := literal;
    Try
      RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        AnimateLogo(False);
        StatusBarLoadPt.Caption := 'RPC ORWRP REPORT TEXT could not be accessed!';
        StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('RPC ORWRP REPORT TEXT could not be accessed!');
      End
    End;
    memoDocs.Visible := False;
    memoDocs.Lines.Clear;
    MemoDocs.SetSelTextBuf(RPCBroker1.Results.GetText);
    MemoDocs.Lines.Add('');
    MemoDocs.Visible := True;
    MemoDocs.SelStart := 1;
    MemoDocs.SelLength := 1;                                                    // ET 060329 try lstDocs.SetFocus except end;
    MemoDocs.SelStart := 0;
    MemoDocs.SelLength := 0;                                                    // ET 060329 try lstDocs.SetFocus except end;
  End;
  If (DocType = 'MEDS') Then
  Begin
    (*
        If Pos('DATE',Uppercase(lstDocs.Items[lstDocs.ItemIndex]))>0 then begin
          AnimateLogo(False);
          StatusBarLoadPt.Caption:='Ready.'; StatusBarLoadPt.Repaint; Application.Processmessages;
          ShowMessageCAPRI('UNDER CONSTRUCTION:  The date range option will be available in the next version of CAPRI.');
          exit;
        end;
        *)
    If lstDocs.ItemIndex = 0 Then
    Begin                                                                       // Action Profile
      RPCBroker1.RemoteProcedure := 'ORWRP REPORT TEXT';
      RPCBroker1.Param[1].Value := PatientIEN;                                  // Patient IEN
      RPCBroker1.Param[1].PType := literal;
      RPCBroker1.Param[2].Value := '13:OUTPATIENT RX PROFILE~;;0';              // Outpatient Med Profile
      RPCBroker1.Param[2].PType := literal;
      RPCBroker1.Param[3].Value := '';
      RPCBroker1.Param[3].PType := literal;
      RPCBroker1.Param[4].Value := '';
      RPCBroker1.Param[4].PType := literal;
      RPCBroker1.Param[5].Value := '';
      RPCBroker1.Param[5].PType := literal;
      RPCBroker1.Param[6].Value := '0';
      RPCBroker1.Param[6].PType := literal;
      RPCBroker1.Param[7].Value := '0';
      RPCBroker1.Param[7].PType := literal;
      Try
        RPCBroker1.Call;
      Except
        On EBrokerError Do
        Begin
          ANURemoteProcedureCallInProgress := False;
          AnimateLogo(False);
          StatusBarLoadPt.Caption := 'RPC ORWRP REPORT TEXT could not be accessed!';
          StatusBarLoadPt.Repaint;
          Application.Processmessages;
          ShowMessageCAPRI('RPC ORWRP REPORT TEXT could not be accessed!');
        End
      End;
      memoDocs.Visible := False;
      memoDocs.Lines.Clear;
      MemoDocs.SetSelTextBuf(RPCBroker1.Results.GetText);
      MemoDocs.Lines.Add('');
      MemoDocs.Visible := True;
      MemoDocs.SelStart := 0;
      MemoDocs.SelLength := 0;                                                  // ET 060329 try lstDocs.SetFocus except end;
    End
    Else
      If lstDocs.ItemIndex = 13 Then
      Begin
        // BCMA Report
        formDateRangeShort := TFormDateRangeShort.Create(nil);
        RPCParams := TParams.Create(nil);
        RPCParams[1].Value := PatientIEN;                                       // Patient IEN
        RPCParams[1].PType := literal;
        RPCParams[2].Value := '22:MED ADMIN HISTORY (BCMA)~;;0;10';
        RPCParams[2].PType := literal;
        RPCParams[3].Value := '';
        RPCParams[3].PType := literal;
        RPCParams[4].Value := '';
        RPCParams[4].PType := literal;
        RPCParams[5].Value := '';
        RPCParams[5].PType := literal;
        Try
          If formDateRangeShort.ShowModal = mrCancel Then exit;
          RPCParams[6].Value := FloatToStr(FormDateRangeshort.ORDateComboStart.FMDate); // Date Range
          RPCParams[6].PType := literal;
          RPCParams[7].Value := FloatToStr(FormDateRangeshort.ORDateComboStop.FMDate); // Date Range
          RPCParams[7].PType := literal;
          try
            //RPCBroker1.Call;
            RPCBroker1.CallServer('ORWRP REPORT TEXT', RPCParams, True);
          Except
            On EBrokerError Do
            Begin
              ANURemoteProcedureCallInProgress := False;
              AnimateLogo(False);
              StatusBarLoadPt.Caption := 'RPC ORWRP REPORT TEXT could not be accessed!';
              StatusBarLoadPt.Repaint;
              Application.Processmessages;
              ShowMessageCAPRI('RPC ORWRP REPORT TEXT could not be accessed!');
            End;
          End;
        Finally
          FreeAndNil(formDateRangeShort);
          FreeAndNil(RPCParams);
        End;
        If RPCBroker1.Results.Count = 0 Then
        Begin
          AnimateLogo(False);
          StatusBarLoadPt.Caption := 'Ready.';
          StatusBarLoadPt.Repaint;
          Application.Processmessages;
          If MemoDocs.Lines.Count = 0 Then
          Begin
            MemoDocs.Lines.Add('');
            MemoDocs.Lines.Add('There is no data for the requested search criteria.');
          End;
          exit;
        End;
        memoDocs.Visible := False;
        memoDocs.Lines.Clear;
        MemoDocs.SetSelTextBuf(RPCBroker1.Results.GetText);
      End
      Else
      Begin                                                                     // Pull from Orders
        RPCParams := TParams.Create(nil);
        try
          RPCParams[1].Value := PatientIEN;                                     // Patient IEN
          RPCParams[1].PType := literal;

          case lstDocs.ItemIndex of
            9..12: RPCParams[2].Value := '2^0';                                 // Active Orders
          else
            RPCParams[2].Value := '1^0';                                        // All orders
          end;
          RPCParams[2].PType := literal;

          case lstDocs.ItemIndex of                                             //CodeCR178 - rpm 4/18/11
            1, 2, 9: begin                                                      // All Outpatient
                DisplayGrpIEN := GetDisplayGrpIEN('OUTPATIENT MEDICATIONS');
                if (DisplayGrpIEN = '0') or (DisplayGrpIEN = '') then
                  DisplayGrpIEN := '4';                                         //default to std release value
              end;
            3, 4, 10: begin                                                     // All Inpatient
                DisplayGrpIEN := GetDisplayGrpIEN('INPATIENT MEDICATIONS');
                if (DisplayGrpIEN = '0') or (DisplayGrpIEN = '') then
                  DisplayGrpIEN := '3';                                         //default to std release value
              end;
            5, 6, 11: begin                                                     // All Inpatient Unit Dose
                DisplayGrpIEN := GetDisplayGrpIEN('UNIT DOSE MEDICATIONS');
                if (DisplayGrpIEN = '0') or (DisplayGrpIEN = '') then
                  DisplayGrpIEN := '23';                                        //default to std release value
              end;
            7, 8, 12: begin                                                     // Active Inpatient IV
                DisplayGrpIEN := GetDisplayGrpIEN('IV MEDICATIONS');
                if (DisplayGrpIEN = '0') or (DisplayGrpIEN = '') then
                  DisplayGrpIEN := '24';                                        //default to std release value
              end;
          end;
          RPCParams[3].Value := DisplayGrpIEN;
          RPCParams[3].PType := literal;

          case lstDocs.ItemIndex of
            2, 4, 6, 8:
              begin
                formDateRangeShort := TFormDateRangeShort.Create(nil);
                try
                  formDateRangeShort.ShowModal;
                  RPCParams[4].Value := FloatToStr(FormDateRangeshort.ORDateComboStart.FMDate); // Date Range
                  RPCParams[4].PType := literal;
                  RPCParams[5].Value := FloatToStr(FormDateRangeshort.ORDateComboStop.FMDate); // Date Range
                  RPCParams[5].PType := literal;
                finally
                  FreeAndNil(formDateRangeShort);
                end;
              end
          else
            begin
              RPCParams[4].Value := '0';                                        //Start date
              RPCParams[4].PType := literal;
              RPCParams[5].Value := '0';                                        //Stop Date
              RPCParams[5].PType := literal;
            end;
          end;
          Try
            //RPCBroker1.Call;
            RPCBroker1.CallServer('ORWORR AGET', RPCParams, True);
          Except
            On EBrokerError Do
            Begin
              ANURemoteProcedureCallInProgress := False;
              AnimateLogo(False);
              StatusBarLoadPt.Caption := 'RPC ORWORR AGET could not be accessed!';
              StatusBarLoadPt.Repaint;
              Application.Processmessages;
              ShowMessageCAPRI('RPC ORWORR AGET could not be accessed!');
            End
          End;
        finally
          FreeAndNil(RPCParams);
        end;

        memoDocs.Lines.Clear;
        // Order list retrieved.  Now grab order text for each item
        If Piece(RPCBroker1.Results[0], '^', 1) = '0' Then
        Begin
          AnimateLogo(False);
          StatusBarLoadPt.Caption := 'Ready.';
          StatusBarLoadPt.Repaint;
          Application.Processmessages;
          If MemoDocs.Lines.Count = 0 Then
          Begin
            MemoDocs.Lines.Add('');
            MemoDocs.Lines.Add('There is no data for the requested search criteria.');
          End;
          exit;
        End;
        memoDocs.Lines.Clear;

        RPCParams := TParams.Create(nil);
        try
          //RPCBroker1.RemoteProcedure := 'ORWORR GET4LST';
          RPCParams[1].Value := PatientIEN;                                     // Patient IEN
          RPCParams[1].PType := literal;
          RPCParams[2].Value := '-1';
          RPCParams[2].PType := literal;
          medbuffer := '';
          druglines := StrToInt(Piece(RPCBroker1.Results[0], '^', 1));
          For x := 1 To druglines Do
          Begin
            // Set up for broker call
            RPCParams[3].Mult[IntToStr(x)] := Piece(RPCBroker1.Results[x], '^', 1);
            medbuffer := medbuffer + Piece(RPCParams[3].Mult[IntToStr(x)], ';', 1) + '^';
          End;
          RPCParams[3].PType := list;
          Try
            //RPCBroker1.Call;
            RPCBroker1.CallServer('ORWORR GET4LST', RPCParams, True);
          Except
            On EBrokerError Do
            Begin
              ANURemoteProcedureCallInProgress := False;
              AnimateLogo(False);
              StatusBarLoadPt.Caption := 'RPC ORWORR AGET could not be accessed!';
              StatusBarLoadPt.Repaint;
              Application.Processmessages;
              ShowMessageCAPRI('RPC ORWORR AGET could not be accessed!');
            End
          End;
        finally
          FreeAndNil(RPCParams);
        end;
        If RPCBroker1.Results.Count = 0 Then
        Begin
          AnimateLogo(False);
          StatusBarLoadPt.Caption := 'Ready.';
          StatusBarLoadPt.Repaint;
          Application.Processmessages;
          If MemoDocs.Lines.Count = 0 Then
          Begin
            MemoDocs.Lines.Add('');
            MemoDocs.Lines.Add('There is no data for the requested search criteria.');
          End;
          exit;
        End;
        MemoDocs.Visible := False;
        resultsbuffer := tstringlist.Create;
        quicklookup := tstringlist.create;
        resultsbuffer.Clear;
        quicklookup.clear;
        For x := 0 To RPCBroker1.Results.Count - 1 Do
          resultsbuffer.add(RPCBroker1.Results[x]);

        drugcount := druglines;
        druglines := 1;
        whichline := 0;
        druglookup := '';

        For x := 0 To resultsbuffer.Count - 1 Do
        Begin
          inX := x;
          Line := resultsbuffer[x];
          If Line[1] = '~' Then
          Begin                                                                 // Order Stuff
            If (lstDocs.ItemIndex = 1) Or (lstDocs.ItemIndex = 2) Then
            Begin                                                               // Only do this for outpatient
              If druglookup <> '' Then
              Begin
                // Take off "DISCONTINUE" if applicable
                If Pos('DISCONTINUE ', Uppercase(Druglookup)) = 1 Then
                Begin
                  DrugLookup := Copy(DrugLookup, Pos(' ', DrugLookup) + 1, 99);
                End;
                // Strip off everything after "Quantity:"
                If Pos('QUANTITY: ', Uppercase(Druglookup)) > 1 Then
                Begin
                  DrugLookup := Copy(DrugLookup, 1, Pos('QUANTITY: ', Uppercase(DrugLookup)) - 2);
                End;
                drugbuffer := '';
                (*
                //Look for a numeral in character 11 or higher and strip everything after that.
                xx:=0;
                for zz:=1 to length(drugLookup) do
                  if xx=0 then
                    if (druglookup[zz]='1') or (druglookup[zz]='2') or (druglookup[zz]='3') or
                      (druglookup[zz]='4') or (druglookup[zz]='5') or (druglookup[zz]='6') or
                      (druglookup[zz]='7') or (druglookup[zz]='8') or (druglookup[zz]='9') or
                      (druglookup[zz]='0') then
                        xx:=zz;
                // Always take the first 20 characters
                // INTERFERON BETA-1B is in class IM900. The other interferons are in IM700.
                if xx>20 then DrugLookup:=Copy(DrugLookup,1,xx-2);
                *)
                // check buffer first
                For zz := 0 To resultsbuffer.count - 1 Do
                  If piece(resultsbuffer[zz], '^', 1) = druglookup Then
                  Begin
                    drugbuffer := piece(resultsbuffer[zz], '^', 2);
                  End;
                If drugbuffer = '' Then
                Begin
                  //Not found in buffer
                  FMListerOrderInfo.IENS := ',' + Piece(medbuffer, '^', druglines);
                  FMListboxOrderInfo.GetList;
                  If FMListboxOrderInfo.Items.Count > 0 Then
                    For xx := 0 To FMListboxOrderInfo.Items.Count - 1 Do
                      If pos('OR GTX DISPENSE DRUG  ', FMListboxOrderInfo.Items[xx]) = 1 Then
                      Begin
                        //Found it do call to do lookup
                        FMGetsDrugFile.IENS := Copy(FMListboxOrderInfo.Items[xx], pos('  ', FMListboxOrderInfo.Items[xx]) + 4, 99);
                        FMGetsDrugFile.GetData;
                        drugclass := '';
                        For yy := 0 To FMListBoxVADrugClass.Items.Count - 1 Do
                          If pos(fmgetsdrugfile.getfield('2').fmdbexternal + '  ', FMListBoxVADrugClass.Items[yy]) = 1 Then
                            drugclass := FMListBoxVADrugClass.Items[yy];
                        resultsbuffer.add(druglookup + '^' + drugclass);
                        drugbuffer := Piece(resultsbuffer[resultsbuffer.count - 1], '^', 2);
                      End;
                End;
                MemoDocs.Lines.Add('VA DRUG CLASS - ' + drugbuffer);
                inc(druglines);
                Statusbarloadpt.caption := 'Loading drug class for ' + inttostr(druglines) + ' of ' + inttostr(drugcount);
                Statusbarloadpt.repaint;
              End;
            End;
            MemoDocs.Lines.Add('');
            MemoDocs.Lines.Add('PROVIDER: ' + Piece(Line, '^', 11) + '  START: ' + FMDateTimeConvert(Piece(Line, '^', 4)) + '  STOP: ' + FMDateTimeConvert(Piece(Line, '^', 5)));
            whichline := 1;
          End
          Else
          Begin                                                                 // Text Stuff
            MemoDocs.Lines.Add(Copy(Line, 2, Length(Line) - 1));
            If whichline = 1 Then
            Begin
              druglookup := MemoDocs.Lines[MemoDocs.Lines.Count - 1];
              whichline := 0;
            End;
          End;
        End;
        If (lstDocs.ItemIndex = 1) Or (lstDocs.ItemIndex = 2) Then
        Begin                                                                   // Only do this for outpatient
          drugbuffer := piece(resultsbuffer[inX], '^', 2);
          MemoDocs.Lines.Add('VA DRUG CLASS - ' + drugbuffer);
        End;
        resultsbuffer.free;
        quicklookup.free;
        MemoDocs.Visible := True;
        MemoDocs.SelStart := 0;
        MemoDocs.SelLength := 0;                                                // ET 060329 try lstDocs.SetFocus except end;
      End;
    MemoDocs.visible := True;
    If MemoDocs.Lines.Count = 0 Then
    Begin
      MemoDocs.Lines.Add('');
      MemoDocs.Lines.Add('There is no data for the requested search criteria.');
    End;
  End;
  If (DocType = 'IMAGING') Then
  Begin
    frmMain.RPCBroker1.Results.Clear;
    RPCBroker1.RemoteProcedure := 'ORWRP REPORT TEXT';
    RPCBroker1.Param[1].Value := PatientIEN;                                    // Patient IEN
    RPCBroker1.Param[1].PType := literal;
    RPCBroker1.Param[2].Value := '18';                                          // Imaging Report
    RPCBroker1.Param[2].PType := literal;
    RPCBroker1.Param[3].Value := '';
    RPCBroker1.Param[3].PType := literal;
    RPCBroker1.Param[4].Value := '';
    RPCBroker1.Param[4].PType := literal;
    RPCBroker1.Param[5].Value := Piece(lstDocs.Items[lstDocs.ItemIndex], '^', 2);
    RPCBroker1.Param[5].PType := literal;
    RPCBroker1.Param[6].Value := '0';
    RPCBroker1.Param[6].PType := literal;
    RPCBroker1.Param[7].Value := '0';
    RPCBroker1.Param[7].PType := literal;
    Try
      RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        AnimateLogo(False);
        StatusBarLoadPt.Caption := 'RPC ORWRP REPORT TEXT could not be accessed!';
        StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('RPC ORWRP REPORT TEXT could not be accessed!');
      End
    End;
    memoDocs.Visible := False;
    memoDocs.Lines.Clear;
    MemoDocs.SetSelTextBuf(RPCBroker1.Results.GetText);
    MemoDocs.Lines.Add('');
    MemoDocs.Visible := True;
    MemoDocs.SelStart := 0;
    MemoDocs.SelLength := 0;                                                    // ET 060329 try lstDocs.SetFocus except end;
    If SearchRunning = 0 Then                                                   //CodeCR696 JRL 4/8/15
      If EditSearchPN.Text <> '' Then                                           //CodeCR696 JRL 4/8/15
      Begin                                                                     //CodeCR696 JRL 4/8/15
        LastSearchFoundAt := 0;                                                 //CodeCR696 JRL 4/8/15
        buttonSearchClick(application);                                         //CodeCR696 JRL 4/8/15
      End;                                                                      //CodeCR696 JRL 4/8/15
  End;
  If (DocType = 'VS') Then // Vitals
  Begin
  (*  Defect #2199 - rpm 4/21/09 - Following code failed when the ItemIndex
      was -1 as a result of forcing the ItemIndex to 9 with only 8 items in
      Tab95Control1Change.
    If Pos('DATE', Uppercase(lstDocs.Items[lstDocs.ItemIndex])) > 0 Then
    Begin
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'Ready.';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('UNDER CONSTRUCTION:  The date range option will be available in the next version of CAPRI.');
      exit;
    End;
  *)
    frmMain.RPCBroker1.Results.Clear;
    RPCBroker1.RemoteProcedure := 'ORWRP REPORT TEXT';
    RPCBroker1.Param[1].Value := PatientIEN;                                    // Patient IEN
    RPCBroker1.Param[1].PType := literal;
    RPCBroker1.Param[2].Value := '5';                                           // Vitals Report
    RPCBroker1.Param[2].PType := literal;
    RPCBroker1.Param[3].Value := '';
    RPCBroker1.Param[3].PType := literal;
    RPCBroker1.Param[4].Value := '';
    RPCBroker1.Param[4].PType := literal;
    If lstDocs.ItemIndex = 0 Then
      RPCBroker1.Param[4].Value := '0';
    If lstDocs.ItemIndex = 1 Then
      RPCBroker1.Param[4].Value := '7';
    If lstDocs.ItemIndex = 2 Then
      RPCBroker1.Param[4].Value := '14';
    If lstDocs.ItemIndex = 3 Then
      RPCBroker1.Param[4].Value := '30';
    If lstDocs.ItemIndex = 4 Then
      RPCBroker1.Param[4].Value := '180';
    If lstDocs.ItemIndex = 5 Then
      RPCBroker1.Param[4].Value := '365';
    If lstDocs.ItemIndex = 6 Then
      RPCBroker1.Param[4].Value := '730';
    If lstDocs.ItemIndex = 7 Then
      RPCBroker1.Param[4].Value := '1825';
    If lstDocs.ItemIndex = 8 Then
      RPCBroker1.Param[4].Value := '99999';
    RPCBroker1.Param[5].Value := '';
    RPCBroker1.Param[5].PType := literal;
    RPCBroker1.Param[6].Value := '0';
    RPCBroker1.Param[6].PType := literal;
    RPCBroker1.Param[7].Value := '0';
    RPCBroker1.Param[7].PType := literal;
  (* Defect #2199 - rpm 4/21/09 - ItemIndex should never be 9.  Appears to be
     an incomplete future enhancement.
    If lstDocs.ItemIndex = 9 Then
    Begin
      RPCBroker1.Param[6].Value := FloatToStr(FormDateRange.ORDateComboStart.FMDate); // Date Range
      RPCBroker1.Param[6].PType := literal;
      RPCBroker1.Param[7].Value := FloatToStr(FormDateRange.ORDateComboStop.FMDate); // Date Range
      RPCBroker1.Param[7].PType := literal;
    End;
  *)
    Try
      RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        AnimateLogo(False);
        StatusBarLoadPt.Caption := 'RPC ORWRP REPORT TEXT could not be accessed!';
        StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('RPC ORWRP REPORT TEXT could not be accessed!');
      End
    End;
    memoDocs.Visible := False;
    memoDocs.Lines.Clear;
    MemoDocs.SetSelTextBuf(RPCBroker1.Results.GetText);
    If MemoDocs.Lines.Count > 4 Then
      If Uppercase(MemoDocs.Lines[5]) = 'NO CUMULATIVE VITALS DATA FOR THIS PATIENT' Then
      Begin
        MemoDocs.Lines.Insert(6, 'within the selected date range.');
      End;
    If MemoDocs.Lines.Count > 5 Then
      If Uppercase(MemoDocs.Lines[6]) = 'NO CUMULATIVE VITALS DATA FOR THIS PATIENT' Then
      Begin
        MemoDocs.Lines.Insert(7, 'within the selected date range.');
      End;
    MemoDocs.Lines.Add('');
    MemoDocs.SelStart := 1;
    MemoDocs.SelLength := 1;                                                    // ET 060329 try lstDocs.SetFocus except end;
    MemoDocs.SelStart := 0;
    MemoDocs.SelLength := 0;                                                    // ET 060329 try lstDocs.SetFocus except end;
    MemoDocs.Visible := True;
  End;
  If (DocType = 'LAB') Then
  Begin
    If lstDocs.ItemIndex = 11 Then
    Begin                                                                       // Graph labs
      if VaUtils.ScreenReaderActive then begin
        ShowMessageCAPRI('The graphing interface is not suitable for screen reader use.  ' +
          'Please use the text reports to obtain the equivalent information.');
      end else begin
        If ListLabTestNames.Count = 0 Then
        Begin
          TGifImage(GifImageVistaYellow.picture.Graphic).Animate := True;
          StatusBarLoadPt.Caption := 'Loading lab test names.';
          StatusBarLoadPt.Repaint;
          Application.Processmessages;

          RPCBroker1.RemoteProcedure := 'DVBAB LABLIST';
          RPCBrokerCall;
          Try
            RPCBroker1.Call;
          Except
            On EBrokerError Do
            Begin
              ANURemoteProcedureCallInProgress := False;
              AnimateLogo(False);
              StatusBarLoadPt.Caption := 'RPC DVBAB LABLIST could not be accessed!';
              StatusBarLoadPt.Repaint;
              Application.Processmessages;
              ShowMessageCAPRI('DVBAB LABLIST could not be accessed!');
            End;
          End;
          If RPCBroker1.Results.Count > 0 Then
            For xx := 0 To RPCBroker1.Results.Count - 1 Do
              listLabTestNames.Add(RPCBroker1.Results[xx]);
          frmLabGraph.chartLab.AllowZoom := False;
          frmLabGraph.ButtonGraph.Visible := True;
          frmLabGraph.DateTimePicker1.Visible := True;
          frmLabGraph.DateTimePicker2.Visible := True;
          frmLabGraph.DateTimePicker1.Date := Now - 7;
          frmLabGraph.DateTimePicker2.Date := Now;
          AnimateLogo(False);
          StatusBarLoadPt.Caption := 'Ready.';
          StatusBarLoadPt.Repaint;
          Application.Processmessages;
        End;
        frmLabGraph.Top := 7 + frmMain.Top + ((frmMain.Height - frmLabGraph.Height) Div 2);
        frmLabGraph.Left := frmMain.Left + ((frmMain.Width - frmLabGraph.Width) Div 2);
        frmLabGraph.ListBoxLabs.Items.Clear;
        screen.cursor := crhourglass;
        For xx := 0 To listLabTestNames.Count - 1 Do
          frmLabGraph.ListBoxLabs.Items.Add(Piece(listLabTestNames[xx], '^', 1));
        For xx := frmLabGraph.ListBoxLabs.Items.Count - 1 Downto 1 Do
        Begin
          application.processmessages;
          If frmLabGraph.ListBoxLabs.Items[xx] = frmLabGraph.ListBoxLabs.Items[xx - 1] Then
            frmLabGraph.ListBoxLabs.Items.Delete(xx);
          If frmLabGraph.ListBoxLabs.Items[xx] = '' Then
            frmLabGraph.ListBoxLabs.Items.Delete(xx);
        End;
        screen.cursor := crdefault;
        AnimateLogo(False);
        StatusBarLoadPt.Caption := 'Ready.';
        StatusBarLoadPt.Repaint;
        Application.Processmessages;
        frmLabGraph.ShowModal;
      end;
      exit;
    End;
    frmMain.RPCBroker1.Results.Clear;
    RPCBroker1.RemoteProcedure := 'ORWLR CUMULATIVE REPORT';
    RPCBroker1.Param[1].Value := PatientIEN;                                    // Patient IEN
    RPCBroker1.Param[1].PType := literal;
    If lstDocs.ItemIndex = 0 Then
      RPCBroker1.Param[2].Value := '8';
    If lstDocs.ItemIndex = 1 Then
      RPCBroker1.Param[2].Value := '15';
    If lstDocs.ItemIndex = 2 Then
      RPCBroker1.Param[2].Value := '32';
    If lstDocs.ItemIndex = 3 Then
      RPCBroker1.Param[2].Value := '180';
    If lstDocs.ItemIndex = 4 Then
      RPCBroker1.Param[2].Value := '365';
    If lstDocs.ItemIndex = 5 Then
      RPCBroker1.Param[2].Value := '730';
    If lstDocs.ItemIndex = 6 Then
      RPCBroker1.Param[2].Value := '1825';
    If lstDocs.ItemIndex = 7 Then
      RPCBroker1.Param[2].Value := '99999';
    If (lstDocs.ItemIndex = 0) Or (lstDocs.ItemIndex = 1) Or (lstDocs.ItemIndex = 2) Or
      (lstDocs.ItemIndex = 3) Or (lstDocs.ItemIndex = 4) Or (lstDocs.ItemIndex = 5) Or
      (lstDocs.ItemIndex = 6) Or (lstDocs.ItemIndex = 7) Then
    Begin
      RPCBroker1.Param[2].PType := literal;
      RPCBroker1.Param[3].Value := Copy(fmdatenow, 1, Pos('.', fmdatenow) - 1) + '.2359';
      RPCBroker1.Param[3].PType := literal;
      fmdatepast := FMDateTimeConvert2(fmdatenow);
      fmdatepast := Copy(FMDatePast, 1, Pos('@', FmDatePast) - 1);
      RPCBroker1.Param[4].Value := FMToDateConvert(FormatDateTime('mm/dd/yyyy', StrToDate(FMDatePast) - StrToInt(RPCBroker1.Param[2].Value)));
      RPCBroker1.Param[4].PType := literal;
    End;
    //ShowMessageCAPRI(RPCBroker1.Param[1].Value);
    //ShowMessageCAPRI(RPCBroker1.Param[2].Value);
    //ShowMessageCAPRI(RPCBroker1.Param[3].Value);
    //ShowMessageCAPRI(RPCBroker1.Param[4].Value);
    //
    If lstDocs.ItemIndex = 8 Then
    Begin
      RPCBroker1.RemoteProcedure := 'ORWRP REPORT TEXT';
      RPCBroker1.Param[1].Value := PatientIEN;                                  // Patient IEN
      RPCBroker1.Param[1].PType := literal;
      RPCBroker1.Param[2].Value := '20';                                        // Anatomic Path
      RPCBroker1.Param[2].PType := literal;
      RPCBroker1.Param[3].Value := '0';                                         // Anatomic Path
      RPCBroker1.Param[3].PType := literal;
      RPCBroker1.Param[4].Value := '9999';                                      // Anatomic Path
      RPCBroker1.Param[4].PType := literal;
      RPCBroker1.Param[5].Value := '1';                                         // Anatomic Path
      RPCBroker1.Param[5].PType := literal;
      RPCBroker1.Param[6].Value := '0';
      RPCBroker1.Param[6].PType := literal;
      RPCBroker1.Param[7].Value := '0';
      RPCBroker1.Param[7].PType := literal;
    End;
    If lstDocs.ItemIndex = 9 Then
    Begin
      RPCBroker1.RemoteProcedure := 'ORWRP REPORT TEXT';
      RPCBroker1.Param[1].Value := PatientIEN;                                  // Patient IEN
      RPCBroker1.Param[1].PType := literal;
      RPCBroker1.Param[2].Value := '2';                                         // Blood Bank
      RPCBroker1.Param[2].PType := literal;
      RPCBroker1.Param[3].Value := '0';                                         // Anatomic Path
      RPCBroker1.Param[3].PType := literal;
      RPCBroker1.Param[4].Value := '9999';                                      // Anatomic Path
      RPCBroker1.Param[4].PType := literal;
      RPCBroker1.Param[5].Value := '1';                                         // Anatomic Path
      RPCBroker1.Param[5].PType := literal;
      RPCBroker1.Param[6].Value := '0';
      RPCBroker1.Param[6].PType := literal;
      RPCBroker1.Param[7].Value := '0';
      RPCBroker1.Param[7].PType := literal;
    End;
    If lstDocs.ItemIndex = 10 Then
    Begin
      RPCBroker1.RemoteProcedure := 'ORWLRR MICRO';
      RPCBroker1.Param[1].Value := PatientIEN;                                  // Patient IEN
      RPCBroker1.Param[1].PType := literal;
      //ShowMessageCAPRI(FormatDateTime('mm/dd/yyyy',date));
      RPCBroker1.Param[2].Value := '5000101.2359';                              // Stop Date
      RPCBroker1.Param[2].PType := literal;
      RPCBroker1.Param[3].Value := '1171021';                                   // Start Date
      RPCBroker1.Param[3].PType := literal;
    End;
    Try
      RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        AnimateLogo(False);
        StatusBarLoadPt.Caption := 'RPC ORWRP REPORT TEXT could not be accessed!';
        StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('RPC ORWRP REPORT TEXT could not be accessed!');
      End
    End;
    memoDocs.Visible := False;
    memoDocs.Lines.Clear;
    MemoDocs.SetSelTextBuf(RPCBroker1.Results.GetText);
    MemoDocs.Lines.Add('');
    MemoDocs.Visible := True;
    MemoDocs.SelStart := 0;
    MemoDocs.SelLength := 0;                                                    // ET 060329 try lstDocs.SetFocus except end;
    If RPCBroker1.RemoteProcedure = 'ORWLRR MICRO' Then
    Begin
      If MemoDocs.Lines.Count = 0 Then
      Begin
        MemoDocs.Lines.Add('');
        MemoDocs.Lines.Add('No microbiology data found in the date range specified...');
      End;
    End;
    foundreportflag := false;                                                   // Do this to strip the report header
    MemoDocs.Visible := False;
    If MemoDocs.Lines.Count > 0 Then
      For xx := 0 To MemoDocs.Lines.Count - 1 Do
        If MemoDocs.Lines[xx] = '[REPORT TEXT]' Then
          foundreportflag := true;
    If foundreportflag = true Then
    Begin
      Repeat
        MemoDocs.Lines.Delete(0);
      Until (MemoDocs.Lines[0] = '[REPORT TEXT]') Or (MemoDocs.Lines.Count = 0);
      MemoDocs.Lines.Delete(0);
    End;
    MemoDocs.Visible := True;
    MemoDocs.SelStart := 0;
    MemoDocs.SelLength := 0;                                                    // ET 060329 try lstDocs.SetFocus except end;
    If MemoDocs.Lines.Count = 0 Then
    Begin
      MemoDocs.Lines.Add('');
      MemoDocs.Lines.Add('No data found in the date range specified...');
    End;
    If MemoDocs.Lines.Count > 1 Then
      If MemoDocs.Lines[1] = 'No Data Found' Then
        MemoDocs.Lines[1] := 'No data found in the date range specified...';
  End;
  If (DocType = 'PN') Or (DocType = 'DS') Then // Notes and Discharge Summaries
  Begin
    // Get Epsiode Date/Time
    FMGetsTIU.IENS := Piece(lstDocs.Items[lstDocs.ItemIndex], '^', 2);
    FMGetsTIU.GetAndFill;
    Try
    anuapptpointer := FMGetsTIU.GetField('1205').FMDBInternal Except anuapptpointer := ''
    End;                                                                        // Pointer to visit
    anuinstitution := '';
    anudivision := '';
    If anuapptpointer <> '' Then
    Begin
      FMGetsHospitalLocation.IENS := anuapptpointer;
      FMGetsHospitalLocation.GetData;
      Try
      anuinstitution := FMGetsHospitalLocation.GetField('3').FMDBExternal Except
      End;
      Try
      anudivision := FMGetsHospitalLocation.GetField('3.5').FMDBExternal Except
      End;
    End;
    //
    frmMain.RPCBroker1.Results.Clear;
    RPCBroker1.RemoteProcedure := 'TIU GET RECORD TEXT';
    RPCBroker1.Param[1].Value := Piece(lstDocs.Items[lstDocs.ItemIndex], '^', 2);
    RPCBroker1.Param[1].PType := literal;
    Try
      RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        AnimateLogo(False);
        StatusBarLoadPt.Caption := 'RPC TIU GET RECORD TEXT could not be accessed!';
        StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('RPC TIU GET RECORD TEXT could not be accessed!');
      End
    End;
    memoDocs.Visible := False;
    memoDocs.Lines.Clear;
    If DocType = 'DS' Then
      RPCBroker1.Results.Insert(4, '    DIVISION: ' + anudivision);
    If DocType = 'DS' Then
      RPCBroker1.Results.Insert(4, ' INSTITUTION: ' + anuinstitution);
    If DocType = 'DS' Then
      RPCBroker1.Results.Insert(4, '  EPSIODE END DATE/TIME: ' + FMEditEpisodeEndDateTime.Text);
    If DocType = 'DS' Then
      RPCBroker1.Results.Insert(4, 'EPSIODE BEGIN DATE/TIME: ' + FMEditEpisodeBeginDateTime.Text);
    If DocType = 'PN' Then
      RPCBroker1.Results.Insert(4, '    DIVISION: ' + anudivision);
    If DocType = 'PN' Then
      RPCBroker1.Results.Insert(4, ' INSTITUTION: ' + anuinstitution);
    RPCBroker1.Results.Add('');
    MemoDocs.SetSelTextBuf(RPCBroker1.Results.GetText);
    MemoDocs.SelStart := 1;
    MemoDocs.SelLength := 1;                                                    // ET 060329 try lstDocs.SetFocus except end;
    MemoDocs.SelStart := 0;
    MemoDocs.SelLength := 0;                                                    // ET 060329 try lstDocs.SetFocus except end;
    MemoDocs.Visible := True;
    If SearchRunning = 0 Then
      If EditSearchPN.Text <> '' Then
      Begin
        LastSearchFoundAt := 0;
        buttonSearchClick(application);
      End;
  End;
  If DocType = 'CN' Then  // Consults
  Begin
    frmMain.RPCBroker1.Results.Clear;
    RPCBroker1.RemoteProcedure := 'ORQQCN DETAIL';
    RPCBroker1.Param[1].Value := Piece(lstDocs.Items[lstDocs.ItemIndex], '^', 2);
    RPCBroker1.Param[1].PType := literal;
    Try
      RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        AnimateLogo(False);
        StatusBarLoadPt.Caption := 'RPC ORQQCN DETAIL could not be accessed!';
        StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('RPC ORQQCN DETAIL could not be accessed!');
      End
    End;
    memoDocs.Visible := False;
    memoDocs.Lines.Clear;
    MemoDocs.SetSelTextBuf(RPCBroker1.Results.GetText);
    MemoDocs.Lines.Add('');
    MemoDocs.Visible := True;
    MemoDocs.SelStart := 0;
    MemoDocs.SelLength := 0;                                                    // ET 060329 try lstDocs.SetFocus except end;
    If SearchRunning = 0 Then                                                   //CodeCR696 JRL 4/8/15
      If EditSearchPN.Text <> '' Then                                           //CodeCR696 JRL 4/8/15
      Begin                                                                     //CodeCR696 JRL 4/8/15
        LastSearchFoundAt := 0;                                                 //CodeCR696 JRL 4/8/15
        buttonSearchClick(application);                                         //CodeCR696 JRL 4/8/15
      End;                                                                      //CodeCR696 JRL 4/8/15
  End;
  AnimateLogo(False);
  StatusBarLoadPt.Caption := 'Ready.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
  If SearchRunning <> 99 Then
  Begin
    MemoDocs.SelStart := 0;
    MemoDocs.SelLength := 0;                                                    // ET 060329 Try lstDocs.SetFocus except end;
  End
  Else
  Begin
    SearchRunning := 0;
  End;
  // Highlight if just searched
End;

Procedure TfrmMain.LoadReportsOptions;
Begin
  ORReportsAvailable.Clear;
  ORReportsAvailable.Items.Add('Pt. Inquiry');
  ORReportsAvailable.Items.Add('Detailed Inpt. Inquiry');
  ORReportsAvailable.Items.Add('C&P Exam Detail');
  ORReportsAvailable.Items.Add('7131 Detail');
  ORReportsAvailable.Items.Add('Additional Treating Facilities');
  ORReportsAvailable.Items.Add('View Registration Data');
  ORReportsAvailable.Items.Add('Patient Profile MAS (Full)');
  ORReportsAvailable.Items.Add('Surgery Report');
  ORReportsAvailable.ItemIndex := 0;
  ORReportsAvailableClick(Application);
End;

Procedure TfrmMain.ORReportsAvailableClick(Sender: TObject);
Var
  x: integer;
  TypeOfMovement: String;
  a, b: String;

  Function buildreport: boolean;
  Begin
    //Build Report
    StatusBarLoadPt.Caption := 'Downloading report.';
    StatusBarLoadPt.Repaint;
    Application.Processmessages;
    ANURemoteProcedureCallInProgress := true;
    ReportMemo.Lines.Clear;
    screen.cursor := crHourglass;

    ReportMemo.SetSelTextBuf(RPCBroker1.Results.GetText);

    screen.cursor := crDefault;
    ReportMemo.Visible := True;
    ReportMemo.SelStart := 1;
    ReportMemo.SelLength := 1;

    If IsSetFocusValid(ReportMemo) then

      ReportMemo.SelStart := 0;
    ReportMemo.SelLength := 0;

    If IsSetFocusValid(ReportMemo) then
      ReportMemo.SetFocus;

    ANURemoteProcedureCallinProgress := False;
    AnimateLogo(False);
    StatusBarLoadPt.Caption := 'Ready.';
    StatusBarLoadPt.Repaint;
    Application.Processmessages;
    //End Of Build Report
    Result := True;
  End;
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;

  StatusBarLoadPt.Caption := 'Downloading report.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
  AnimateLogo(True);

  PanelSurgeryReports.Visible := False;
  ReportMemo.Lines.Clear;
  PanelReportChoice.Visible := False;
  panelReportChoice2.Visible := False;
  fmRegionalOfficeNumber.Visible := False;
  label16.Visible := False;
  checkboxMailman.Visible := False;
  If ORReportsAvailable.ItemIndex = 0 Then
  Begin                                                                         // Pt. Inquiry
    frmMain.RPCBroker1.Results.Clear;

    RPCBroker1.RemoteProcedure := 'DVBAB PTINQ';
    RPCBroker1.Param[0].Value := PatientIEN;
    RPCBroker1.Param[0].PType := literal;
    RPCBrokerCall;
    Try
      RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        AnimateLogo(False);
        StatusBarLoadPt.Caption := 'RPC DVBAB PTINQ could not be accessed!';
        StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('RPC DVBAB PTINQ could not be accessed!');
      End
    End;
    BuildReport;
    exit;
  End;
  If ORReportsAvailable.ItemIndex = 2 Then
  Begin
    StatusBarLoadPt.Caption := 'Ready.';
    StatusBarLoadPt.Repaint;
    Application.Processmessages;
    ANURemoteProcedureCallInProgress := false;
    AnimateLogo(False);
    ShowMessageCapri('To run this report, go to the C&&P Exams tab, click an exam and click the "Status Inquiry" button.');
  End;
  If ORReportsAvailable.ItemIndex = 3 Then
  Begin
    StatusBarLoadPt.Caption := 'Ready.';
    StatusBarLoadPt.Repaint;
    Application.Processmessages;
    ANURemoteProcedureCallInProgress := false;
    AnimateLogo(False);
    ShowMessageCapri('To run this report, go to the 7131 Request tab, click a request and click the "Status Inquiry" button.');
    exit;
  End;
  If ORReportsAvailable.ItemIndex = 4 Then
  Begin                                                                         // Other Sites
    AnimateLogo(True);
    StatusBarLoadPt.Caption := 'Generating report.';
    StatusBarLoadPt.Repaint;
    Application.Processmessages;
    RPCBroker1.RemoteProcedure := 'ORWCIRN FACLIST';
    RPCBroker1.Param[0].Value := PatientIEN;
    RPCBroker1.Param[0].PType := literal;
    RPCBrokerCall;
    Try
      RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        AnimateLogo(False);
        StatusBarLoadPt.Caption := 'RPC ORWCIRN FACLIST could not be accessed!';
        StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('ORWCIRN FACLIST could not be accessed!');
      End
    End;
    If Piece(RPCBroker1.Results[0], '^', 1) = '-1' Then
    Begin
      // Only local data or other problem
      ReportMemo.Lines.Add('Sites could not be loaded.');
    End
    Else
    Begin
      ReportMemo.Lines.Add('Sites visited:');
      For x := 0 To RPCBroker1.Results.Count - 1 Do
      Begin
        a := Copy(Piece(RPCBroker1.Results[x], '^', 1) + '        ', 1, 8);
        b := Copy(Piece(RPCBroker1.Results[x], '^', 2) + '                         ', 1, 25);
        ReportMemo.Lines.Add(a + b + FMDateTimeConvert(Piece(RPCBroker1.Results[x], '^', 3)));
      End;
    End;
    AnimateLogo(False);
    StatusBarLoadPt.Caption := 'Ready.';
    StatusBarLoadPt.Repaint;
    Application.Processmessages;
  End;
  If ORReportsAvailable.ItemIndex = 5 Then
  Begin                                                                         // View Registration
    If patientIEN = '' Then
    Begin
      ShowMessageCAPRI('Please select a patient first.');
      exit;
    End;
    frmMain.RPCBroker1.Results.Clear;
    frmMain.RPCBroker1.RemoteProcedure := 'DVBAB REPORTS';                      //VIEW REGISTRATION
    frmMain.RPCBroker1.Param[0].Value := '9';
    frmMain.RPCBroker1.Param[0].PType := literal;
    frmMain.RPCBroker1.Param[1].Value := PatientIEN;
    frmMain.RPCBroker1.Param[1].PType := literal;
    //frmMain.RPCBroker1.Call;
    AnimateLogo(True);
    StatusBarLoadPt.Caption := 'Generating report.';
    StatusBarLoadPt.Repaint;
    Application.Processmessages;
    RPCBrokerCall;
    Try
      frmMain.RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        //ShowMessageCAPRI('RPC DVBAB REPORTS could not be accessed!');
        ReportMemo.Lines.Add('There was a problem running the call RPC DVBAB REPORTS.');
        //If RPCBroker1.Connected = False Then  BSE mod - rpm 1/8/09
        //  RPCBroker1.Connected := True;  BSE mod - rpm 1/8/09
        If Not ConnectToServer('DVBA CAPRI GUI') Then
        Begin
          ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
          application.terminate;
        End;
        If RPCBroker1.Connected = False Then
        Begin
          ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
          application.terminate;
        End;
        exit;
      End;
    End;
    QuickCopy(frmMain.RPCBroker1.Results, ReportMemo);
    If ReportMemo.Lines.Count > 0 Then
      For x := Reportmemo.Lines.Count - 1 Downto 0 Do
        If ReportMemo.Lines[x] = '<RET> to CONTINUE, ^N for screen N or ''^'' to QUIT: ' Then
          ReportMemo.Lines.Delete(x);
    If ReportMemo.Lines.count = 0 Then
      ReportMemo.Lines.Add('No data found for requested report criteria.');
    ReportMemo.SelStart := 0;
    ReportMemo.SelLength := 0;
    AnimateLogo(False);
    StatusBarLoadPt.Caption := 'Ready.';
    StatusBarLoadPt.Repaint;
    Application.Processmessages;
  End;
  If ORReportsAvailable.ItemIndex = 6 Then
  Begin                                                                         // Patient Profile MAS (Full)
    AnimateLogo(False);
    StatusBarLoadPt.Caption := 'Ready.';
    StatusBarLoadPt.Repaint;
    Application.Processmessages;
    If PatientIEN = '' Then
    Begin
      ShowMessageCAPRI('Please select a patient first.');
      exit;
    End;

    //CodeCR85 - rpm 4/13/10
    frmPatientProfileMAS := TfrmPatientProfileMAS.Create(nil);
    try
      if (frmPatientProfileMAS.ShowModal = mrOK) then
      begin
        GetPatientProfileMAS(PatientIEN);
      end;
    finally
      FreeAndNil(frmPatientProfileMAS);
    end;
  End;
  If ORReportsAvailable.ItemIndex = 7 Then
  Begin                                                                         // Surgery reports;
    If AllowSurgeryReport = False Then
    Begin
      ShowMessageCAPRI('Surgery reports require release of patch SR*3*100.  Expected date that this report type will be available is approximately December 1, 2003.');
      StatusBarLoadPt.Caption := 'Ready.';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ANURemoteProcedureCallInProgress := false;
      AnimateLogo(False);
      exit;
    End;
    PanelSurgeryReports.Visible := True;
    PanelSurgeryReports.BringToFront;
    if MemoCPTCopyright.Visible then begin                                      // -MER CodeCR119 12/10
      MemoCPTCopyright.SetFocus;                                                // -MER CodeCR119 8/2010
      MemoCPTCopyright.SelStart := 0;                                           // -MER CodeCR119 8/2010
    end;
    ButtonOKSurgeryReports.Enabled := False;
    RPCBroker1.RemoteProcedure := 'DVBAB SURGERY CASE';
    RPCBroker1.Param[0].Value := PatientIEN;
    RPCBroker1.Param[0].PType := literal;
    Try
      RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        AnimateLogo(False);
        StatusBarLoadPt.Caption := 'DVBAB SURGERY CASE could not be accessed!';
        StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('DVBAB SURGERY CASE could not be accessed!');
      End;
    End;
    SurgeryReports.Clear;
    QuickCopy(RPCBroker1.Results, SurgeryReports);
    QuickCopy(RPCBroker1.Results, ORListBoxSurgeryReports.Items);
    If ORListBoxSurgeryReports.Items.Count > 0 Then
      For x := 0 To ORListBoxSurgeryReports.Items.Count - 1 Do
      Begin
        //ShowMessageCAPRI(ORListBoxSurgeryReports.Items[x]);
//        ORListBoxSurgeryReports.Items[x]:=Piece(ORListBoxSurgeryReports.Items[x],'^',2)+'^'+
//          FMDateTimeConvert(Piece(ORListBoxSurgeryReports.Items[x],'^',3))+'  '+
//          Piece(ORListBoxSurgeryReports.Items[x],'^',4)+' ('+
//          Piece(ORListBoxSurgeryReports.Items[x],'^',5)+')';
        ORListBoxSurgeryReports.Items[x] := Piece(ORListBoxSurgeryReports.Items[x], '^', 1) + '^' +
          FMDateTimeConvert(Piece(ORListBoxSurgeryReports.Items[x], '^', 2)) + '  ' +
          Piece(ORListBoxSurgeryReports.Items[x], '^', 3) + ' ' +
          Piece(ORListBoxSurgeryReports.Items[x], '^', 4) + '';
      End;
  End;
  If ORReportsAvailable.ItemIndex = 1 Then
  Begin                                                                         // Detailed Inpt. Inquiry
    LabelReportChoice.Caption := 'Detailed Inpatient Inquiry';
    PanelReportChoice.Visible := True;
    PanelReportChoice.BringToFront;
    FMListerAdmissions.PartList.Clear;
    FMListerAdmissions.PartList.Add(PatientIEN);
    //FMListerAdmissions.GetList(FMListBoxAdmission.Items);
    FMListBoxAdmission.GetList;
    If FMListBoxAdmission.Items.Count > 0 Then
    Begin                                                                       //strip off pt ien and anything not belonging to pt.
      For x := FMListBoxAdmission.Items.Count - 1 Downto 0 Do
      Begin
        If Pos(patientien + '  ', FMListBoxAdmission.Items[x]) <> 1 Then
          FMListBoxAdmission.Items.Delete(x)
        Else
          FMListBoxAdmission.Items[x] := Copy(FMListBoxAdmission.Items[x], Pos('  ', FMListBoxAdmission.Items[x]) + 4, 999);
      End;
    End;
    If FMListBoxAdmission.Items.Count > 0 Then
    Begin
      FMListBoxAdmission.Visible := False;
      For x := FMListBoxAdmission.Items.Count - 1 Downto 0 Do
      Begin
        FMListBoxAdmission.ItemIndex := x;
        TypeOfMovement := Copy(FMListBoxAdmission.Items[x], Pos('  ', FMListBoxAdmission.Items[x]) + 4, 255);
        FMGetsMovementType.IENS := Copy(TypeOfMovement, Pos('  ', TypeOfMovement) + 4, 255);
        TypeOfMovement := Copy(TypeOfMovement, 1, Pos('  ', TypeOfMovement) - 1);
        FMGetsMovementType.GetAndFill;
        If Uppercase(FMEditMovementType.Text) = 'ADMISSION' Then
        Begin
          FMEditMovementWardLocation.Text := 'UNKNOWN';
          FMEditFacilityMovementType.Text := 'UNKNOWN';
          FMGetsFacilityMovementType.IENS := TypeOfMovement;
          Try
          FMGetsFacilityMovementType.GetAndFill Except
          End;
          FMGetsPatientMovement.IENS := FMListBoxAdmission.GetSelectedRecord.IEN;
          Try
          FMGetsPatientMovement.GetAndFill Except
          End;
          If FMEditMovementWardLocation.Text = '' Then
            FMEditMovementWardLocation.Text := 'UNKNOWN';
          FMListBoxAdmission.Items[x] := FMDateTimeConvert(Copy(FMListBoxAdmission.Items[x], 1, Pos('  ', FMListBoxAdmission.Items[x]) - 1)) + '  ' + FMEditFacilityMovementType.Text + '    TO:  ' +
            FMEditMovementWardLocation.Text;
        End
        Else
        Begin
          FMListBoxAdmission.Items.Delete(x);
        End;
      End;
      FMListBoxAdmission.ItemIndex := 0;                                        // These two lines force the list to the top
      FMListBoxAdmission.ItemIndex := -1;
      FMListBoxAdmission.Visible := True;
      FMListBoxAdmission.SetFocus;
    End
    Else
    Begin
      FMListBoxAdmission.Items.Add('No admissions found');
    End;
    If FMListBoxAdmission.Items.Count > 0 Then
    Begin
      FMListBoxAdmission.ItemIndex := 0;
      FMListBoxAdmission.SetFocus;
    End;
    (*
    {Use CPRS Visit Loader ORWPT ADMITLST}
    RPCBroker1.RemoteProcedure := 'ORWPT ADMITLST';
    RPCBroker1.Param[0].Value := PatientIEN;
    RPCBroker1.Param[0].PType := literal;
    RPCBrokerCall; try RPCBroker1.Call;
      except
    On EBrokerError do
      ShowMessageCAPRI('Connection to server for ORWPT ADMITLST could not be established!');
    end;
    ListBoxReportChoice.Items.Clear;
    ListBoxReportChoiceHidden.Items.Clear;
    ListBoxReportChoiceHidden.Items:=RPCBroker1.Results;
    If ListBoxReportChoiceHidden.Items.Count=0 then
      ListBoxReportChoice.Items.Add('No admissions found');
    If listboxReportChoiceHidden.Items.Count>0 then for x:=0 to listboxReportChoiceHidden.Items.Count-1 do begin
        listboxReportChoice.Items.Add(Copy(listboxReportChoiceHidden.Items[x],Pos('^',listboxReportChoiceHidden.Items[x])+1,254));
        listboxReportChoice.Items[x]:=Copy(listboxReportChoice.Items[x],Pos('^',listboxReportChoice.Items[x])+1,254);
        listboxReportChoice.Items[x]:=FMDateTimeConvert(Copy(listboxReportChoiceHidden.Items[x],1,Pos('^',listboxReportChoiceHidden.Items[x])-1))+'  '+Copy(listboxReportChoice.Items[x],1,Pos('^',listboxReportChoice.Items[x])-1);
    end;
*)
  End;
  StatusBarLoadPt.Caption := 'Ready.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
  ANURemoteProcedureCallInProgress := false;
  AnimateLogo(False);
End;

Procedure TfrmMain.ShowHIAUserDownloadWebsite;
Var
  HIAURL: String;
  tempserver: String;
  tempport: integer;
Begin
  tempServer := RPCBroker1.Server;
  tempPort := RPCBroker1.ListenerPort;
  RPCBroker1.Connected := False;
  RPCBroker1.Server := HomeServer;
  RPCBroker1.ListenerPort := StrToInt(HomePort);
  //RPCBroker1.Connected := true;  BSE mod - rpm 1/8/09
  ConnectToServer('DVBA CAPRI GUI');

  //Get URL
  //CAPRI_CodeCR95  - jcs - 05/20/2010
  if not CallRPC(RPCBroker1, 'DVBAB GET URL', ['5'], nil) then
    exit;
  try
    if RPCBroker1.Results.Count > 0 then
      if RPCBroker1.Results[0] <> '' then
      begin
        HIAURL := RPCBroker1.Results[0];
        //Code161 - rpm 2/14/11 - changed text as requested by Brian Olinger email 2/2/11
        Showmessage('You have been identified as a Health Information Access (HIA) user.'
          + #13#10 + 'You will now be redirected to the HIA site to download the latest version of CAPRI.');
        if Assigned(frmSplashScreen) then
          frmSplashScreen.Repaint;
        ShellExecute(Handle, 'open', PAnsiChar(HIAURL), nil, nil, SW_SHOWNORMAL);
      end;
  except
    ShowMessageCAPRI('Unable to access the Health Information Access download site.');
  End;

  RPCBroker1.Connected := False;
  RPCBroker1.Server := TempServer;
  RPCBroker1.ListenerPort := TempPort;
  //RPCBroker1.Connected := true;  BSE mod - rpm 1/8/09
  ConnectToServer('DVBA CAPRI GUI');
End;

procedure TfrmMain.actCapriHelpExecute(Sender: TObject);
begin
  // launch help CODE CR 381 -MER 6/2012
  Application.HelpContext(1);
end;

procedure TfrmMain.actCCRLaunchExecute(Sender: TObject);
begin
  try
    frmCntrctdExmMain := TfrmCntrctdExmMain.Create(nil);
    frmCntrctdExmMain.ShowModal;

    Application.ProcessMessages;
    ExamRequestRefreshClick(Application);                                       // DONE: LMS 61SQA in case we made changes to exams/requests, main form's request list should be updated.
  finally
    FreeAndNil(frmCntrctdExmMain);
  end;
end;

procedure TfrmMain.actDevEditUserKeysExecute(Sender: TObject);
begin
  UserKeysEditDialog();
end;

procedure TfrmMain.actDevThrowExceptExecute(Sender: TObject);
Var
  sgNotNumber: String;
  inNumber: Integer;
Begin
  sgNotNumber := '1abc2';
  inNumber := StrToInt(sgNotNumber);
  ShowMessage(IntToStr(inNumber));
end;

procedure TfrmMain.actDevUserKeysExecute(Sender: TObject);
begin
  UserKeysDialog;
end;

procedure TfrmMain.actEditCopyExecute(Sender: TObject);
begin
  FEditCtrl.CopyToClipboard;
end;

procedure TfrmMain.actEditCutExecute(Sender: TObject);
begin
  FEditCtrl.CutToClipboard;
end;

procedure TfrmMain.actEditPasteExecute(Sender: TObject);
begin
  FEditCtrl.SelText := Clipboard.AsText;
end;

procedure TfrmMain.actEditSelectAllExecute(Sender: TObject);
begin
  FEditCtrl.SelectAll;
end;

procedure TfrmMain.actEditUndoExecute(Sender: TObject);
begin
  FEditCtrl.Perform(EM_UNDO, 0, 0);
end;

procedure TfrmMain.actEditUpdate(Sender: TObject);
Var
  tempTMemoBox: TMemo;
  tempTEdit: TEdit;
  tempTRichEdit: TRichEdit;
Begin
  FEditCtrl := Nil;
  If Screen.ActiveControl Is TCustomEdit Then
    FEditCtrl := TCustomEdit(Screen.ActiveControl);
  If Screen.ActiveControl Is TRichEdit Then
    FEditCtrlRichEdit := TRichEdit(Screen.ActiveControl);
  If FEditCtrl <> Nil Then
  Begin
    actEditUndo.Enabled := FEditCtrl.Perform(EM_CANUNDO, 0, 0) <> 0;
    actEditCut.Enabled := FEditCtrl.SelLength > 0;
    actEditCopy.Enabled := actEditCut.Enabled;
    actPopReadOnlyCopy.Enabled := actEditCut.Enabled;
    actPopReadOnlySelectAll.Enabled := True;
    actEditSelectAll.Enabled := True;
    actEditPaste.Enabled := Clipboard.HasFormat(CF_TEXT);
  End
  Else
  Begin
    actEditUndo.Enabled := False;
    actEditCut.Enabled := False;
    actEditCopy.Enabled := False;
    actPopReadOnlyCopy.Enabled := False;
    actPopReadOnlySelectAll.Enabled := False;
    actEditSelectAll.Enabled := False;
    actEditPaste.Enabled := False;
  End;
  // Don't let read only memos accept paste function
  If FEditCtrl = Nil Then
    exit;
  If (Uppercase(FEditCtrl.ClassName) = 'TMEMO') Then
  Begin
    tempTMemoBox := FEditCtrl As TMemo;
    If (tempTMemoBox.Readonly = True) Then
    Begin
      actEditUndo.Enabled := False;
      actEditCut.Enabled := False;
      actEditPaste.Enabled := False;
    End;
  End;
  If (Uppercase(FEditCtrl.ClassName) = 'TRICHEDIT') Then
  Begin
    tempTRichEdit := FEditCtrl As TRichEdit;
    If (tempTRichEdit.Readonly = True) Then
    Begin
      actEditUndo.Enabled := False;
      actEditCut.Enabled := False;
      actEditPaste.Enabled := False;
    End;
  End;
  If (Uppercase(FEditCtrl.ClassName) = 'TEDIT') Then
  Begin
    tempTEdit := FEditCtrl As TEdit;
    If (tempTEdit.Readonly = True) Then
    Begin
      actEditUndo.Enabled := False;
      actEditCut.Enabled := False;
      actEditPaste.Enabled := False;
    End;
  End;
end;

procedure TfrmMain.actFileConnectExecute(Sender: TObject);
Var
  boReviewerKey: Boolean;
  Flag: Boolean;
  FoundCPWMKey: String;
  IsOldVersionAllowed: Boolean;
  ManifestCnt: Integer;                                                         // rpk 7/2/2014
  tempflag: boolean;
  TempPort: Integer;
  TempSender: TAction;
  TempServer: String;
  tempstring: String;
  TempString2: String;
  TempStrPort: String;
  TempStrServer: String;
  versiona: real;
  versionb: real;
  versionrevisionst: String;
  versionshown: boolean;
  VistAVersion: String;
  x: integer;
  xversiona: real;
  xversionb: real;
  xversionrevisionst: String;
  xx: integer;
  yy: integer;
  zz: integer;
  tempClientItem: TActionClientItem;
  aStream: TMemoryStream;
  authToken: string;
  VDUrl: string;
  edtstr: String;
  actnItemSeparator: TActionClientItem;                                         // CodeCR668 rpk 1/21/2015
Begin

  // Code "1892890Dhdoy*(@hDH28y(#*yUHKJDH"

  If ANURemoteProcedureCallInProgress = True Then
    exit;

  If CCOWMode = False Then
  Try
    If RPCBroker1.Contextor <> Nil Then
      RPCBroker1.Contextor := Nil;
  Except
  End;

  If Essoversion = false Then
    labelDivision.visible := False;

  If Assigned(formTIUDisplay) Then
  Begin
    Try
      formTIUDisplay.Visible := False;
      formTIUDisplay.Release;
      formTIUDisplay := Nil;
    Except
    End;
  End;
  If (actFileConnect.caption = '&Disconnect...') And
    Assigned(PNCSForm) Then
  Begin
    ShowMessage('Please close the open Template.');
    PNCSForm.Show;
    Exit;
  End;

  //AnimateLogo(True);
  TempSender := Nil;

  If Uppercase(Sender.Classname) = 'TACTION' Then
  Begin
    TempSender := Sender As TAction;
  End;
  versionshown := false;

  If (actFileConnect.Caption = '&Connect...') Or ((Assigned(TempSender)) And (TempSender = actFileSwitchSites)) Then
  Begin                                                                         //connect

    // Dec 2005 Chuck Sener Reports that the GUI sometimes hangs at this spot and never
    // shuts down
    // Put in a 60 second timer and close CAPRI if no connection in that time.
    TimerInitialConnection.Enabled := True;

    If SwitchToSite = '' Then
      If Not ConnectToServer('DVBA CAPRI GUI') Then
      Begin
        ShuttingDown := True;
        timerhalt.enabled := true;
        application.terminate;
        exit;
      End;

    // If it gets to this spot, the connection worked, so turn off the timer.
    TimerInitialConnection.Enabled := False;

    If SwitchToSite = '' Then
      If RPCBroker1.Connected = False Then
      Begin
        ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
        //timerhalt.enabled:=true;
        application.terminate;
        exit;
      End;
    If formESSOSelect = Nil Then
    Begin
      formESSOSelect := TformESSOSelect.Create(frmMain);
      HomeServer := RPCBroker1.Server;
      HomePort := InttoStr(RPCBroker1.ListenerPort);
      //CodeCR353 - rpm 5/14/12
      //Populate Virtual VA URL value on initial connection to home server
      if CallRPC(RPCBroker1, 'DVBAB GET URL', ['6'], nil) then
      begin
        if RPCBroker1.Results.Count > 0 then
        begin
          FVirtualVAURL := RPCBroker1.Results[0];
         //CodeCR353 - rpm 5/31/12
         //A URL result indicates that we can populate the Virtual VA TOKEN
         //value because the server patch is loaded at the site.
          if (FVirtualVAURL <> '') then
          begin
            if CallRPC(RPCBroker1, 'DVBAB GET VVA TOKEN', [], nil) then
              if RPCBroker1.Results.Count > 0 then
                FVirtualVAToken := RPCBroker1.Results[0];
          end;
        end;
      end;
      if CallRPC(RPCBroker1, 'DVBAB GET URL', ['7'], nil) then                  // CodeCR440 (AMIS290) JRL 11/15/12
      begin                                                                     // CodeCR440 (AMIS290) JRL 11/15/12
        if RPCBroker1.Results.Count > 0 then                                    // CodeCR440 (AMIS290) JRL 11/15/12
        begin                                                                   // CodeCR440 (AMIS290) JRL 11/15/12
          FAMIS290URL := RPCBroker1.Results[0];                                 // CodeCR440 (AMIS290) JRL 11/15/12
         //If an URL exists, this indicates that the AMIS290        // CodeCR440 (AMIS290) JRL 11/15/12
         //reports have been replaced.  New AMIS290 functionality   // CodeCR440 (AMIS290) JRL 11/15/12
         //is found at the URL location                             // CodeCR440 (AMIS290) JRL 11/15/12
        end;                                                                    // CodeCR440 (AMIS290) JRL 11/15/12
      end;                                                                      // CodeCR440 (AMIS290) JRL 11/15/12

      if TIdHTTPVler.GetVlerDasURL() = '' then                                  //could have been set via command line param     //CodeCR500 JRL 9/10/13
      begin                                                                     //CodeCR500 JRL 9/10/13
        if CallRPC(RPCBroker1, 'DVBAB GET URL', ['8'], nil) then                //CodeCR500 JRL 08/27/13
        begin                                                                   //CodeCR500 JRL 08/27/13
          if RPCBroker1.Results.Count > 0 then                                  //CodeCR500 JRL 08/27/13
          begin                                                                 //CodeCR500 JRL 08/27/13
            TIdHTTPVler.SetVlerDasURL(RPCBroker1.Results[0]);                   //CodeCR??? LMS 2014-07-21  Moving from main form field. Needs to be available App wide in all units that need VLER access
          end;                                                                  //CodeCR500 JRL 08/27/13
        end;                                                                    //CodeCR500 JRL 08/27/13
      end;
    End;

    TempServer := RPCBroker1.Server;
    TempPort := RPCBroker1.ListenerPort;

    SetFont;

    If frmMailMessage = Nil Then
      frmMailMessage := TfrmMailMessage.Create(frmMain);

    If ESSOVersion = True Then
    Begin
      TimeOutTimer.Enabled := True;

      //CAPRI_CodeCR95  - jcs - 05/20/2010
      if not CallRPC(RPCBroker1, 'XWB GET VARIABLE VALUE', ['DTIME'], nil, True) then
        exit;

      If TimeOutVal < 0 Then                                                    // Need this to keep value from getting  reset when switching sites
        TimeOutVal := StrToInt(RPCBroker1.Results[0]);
      If TimeOutVal < 600 Then
        TimeOutVal := 600;

      If frmMailMan = Nil Then
      Begin
        // Only check mail on home server once at start-up
        frmMailMan := TfrmMailMan.Create(frmMain);

        {Get User DUZ}
        //CAPRI_CodeCR95  - jcs - 05/20/2010 - Why are we making this call?
        if not CallRPC(RPCBroker1, 'XWB GET VARIABLE VALUE', ['DUZ'], nil, True) then
          exit;

        If frmMailMan = Nil Then
          frmMailMan := TfrmMailMan.Create(frmMain);
        setfont;
      End;

      setfont;
      formEssoSelect.StaticText1.Caption := 'Select a site.';
      ContextorChangeMessage := 'The application is in the process of switching VistA accounts. If you continue, CAPRI will drop out of the clinical context.';
      CCOWBreakLink := True;
      FormEssoSelect.formstyle := fsStayOnTop;

      If FormEssoSelect.Showmodal = mrcancel Then
      Begin                                                                     // Check for cancel button and exit
        If ESSOInitialized = True Then
          If RPCBroker1.Connected = True Then
            exit;
        ShuttingDown := True;
        ContextorChangeMessage := '';
        CCOWBreakLink := False;
        actFileQuitExecute(Application);
      End;
      // CodeCR185 -MER 04/2011
      if Assigned(ReflectionWrapper) then
        ReflectionWrapper.TerminateEmulator;
      // Drop telnet connection if one exists
      If assigned(frmTelnet) Then
        If frmTelnet.bitbtnDisconnect.Visible = True Then
        Begin
          frmTelnet.DisconnectBtnClick(Self);
        End;

      ESSOConnecting := True;
      ESSOInitialized := True;

      If (TempServer = RPCBroker1.Server) And (TempPort = RPCBroker1.ListenerPort) Then
      Begin
        exit;
      End;

      TimerRemoteData.Enabled := False;
      ListBoxRemoteDataPending.Items.Clear;
      If frmMain.RPCBroker1.Server = '' Then
      Begin
        application.terminate;
      End;

      tempClientItem := ActionManMain.FindItemByCaption('Ex&ternal Applications');
      If Assigned(tempClientItem) Then
        tempClientItem.Visible := True;

      //Set HIA Search menu Item under Tools menu to enable true
      // MNJ - 09/10/2012
      actHIASearch.Enabled := True;
    End
    else
    begin
      tempClientItem := ActionManMain.FindItemByCaption('Ex&ternal Applications');
      If Assigned(tempClientItem) Then
        tempClientItem.Visible := False;
    end;

    If Not ConnectToServer('DVBA CAPRI GUI') Then
    Begin
      ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
      application.terminate;
    End;

    If RPCBroker1.Connected = False Then
    Begin
      ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
      application.terminate;
    End;

    ESSOConnecting := False;

    If RPCBroker1.Connected = True Then
    Begin
      TimeOutTimer.Enabled := True;
      PatientIEN := '';
      patientIENDOD := '';

      frmMain.Caption := ProgramNameCaption;
      ClearForm;                                                                //CodeCR248 - rpm 3/8/12 - clear the header and tab set
      If CCOWMode = True Then
      Begin
        //If ESSOVersion<>True then begin
        // Get local station number
        RPCBroker1.RemoteProcedure := 'DVBAB CCOW';
        RPCBroker1.Param[0].Value := '1';
        RPCBroker1.Param[0].PType := literal;
        RPCBrokerCall;
        Try
          RPCBroker1.Call;
        Except
          On EBrokerError Do
          Begin
            ANURemoteProcedureCallInProgress := False;
            AnimateLogo(False);
            StatusBarLoadPt.Caption := 'DVBAB CCOW could not be accessed!';
            ProgressBarLoadPt.Repaint;
            frmMain.Repaint;
            ShowMessageCAPRI('DVBAB CCOW could not be accessed!');
            application.terminate;
            application.terminate;
          End;
        End;
        LocalStationNumber := Piece(RPCBroker1.Results[0], '^', 3);

        // Get Test system status
        RPCBroker1.RemoteProcedure := 'DVBAB CCOW';
        RPCBroker1.Param[0].Value := '2';
        RPCBroker1.Param[0].PType := literal;
        RPCBrokerCall;
        Try
          RPCBroker1.Call;
        Except
          On EBrokerError Do
          Begin
            ANURemoteProcedureCallInProgress := False;
            AnimateLogo(False);
            StatusBarLoadPt.Caption := 'DVBAB CCOW could not be accessed!';
            ProgressBarLoadPt.Repaint;
            frmMain.Repaint;
            ShowMessageCAPRI('DVBAB CCOW could not be accessed!');
            application.terminate;
            application.terminate;
          End;
        End;
        TestSystemLogin := RPCBroker1.Results[0];
        //End;
      End;

      {Reload Divisions and Institutions on New System}
      frmSPlashScreen := TfrmSplashScreen.Create(frmMain);
      frmSplashScreen.PanelVersion.Height := Panel1.Height;
      frmSplashScreen.PanelVersion.Caption := VersionUser;
      frmSplashScreen.PanelVersion.Left := (frmSPlashScreen.Width Div 2) - (frmSPlashScreen.PanelVersion.Width Div 2);
      frmSPlashScreen.StatusLabel.Height := Panel1.Height;
      frmSPlashScreen.Shape1.Height := Panel1.Height;
      frmSPlashScreen.GaugeLoadSite.Progress := 0;
      frmSPlashScreen.GaugeLoadSite.ForeColor := clRed;
      frmSPlashScreen.GaugeLoadSite.Top := frmSPlashScreen.Shape1.Top + frmSPlashScreen.Shape1.Height;
      frmSPlashScreen.Height := frmSPlashScreen.GaugeLoadSite.Top + 32;
      frmSPlashScreen.Panel1.Height := frmSPlashScreen.GaugeLoadSite.Top + 33;
      frmSPlashScreen.StatusLabel.Font := panel1.font;
      frmSplashScreen.Show;
      frmSplashScreen.Repaint;                                                  //added - rpm 3/18/09

      // Pull up file from central directory, if exists.
      // Allows user to be notified of upgrades, etc.

      // Get Home System Data for Restricted Pt List
      If (EssoLoginYet <> True) And (ESSOVersion = true) And (listRestrictedPatients.count = 0) Then
      Begin

        EssoLoginYet := True;

        frmSplashScreen.StatusLabel.Caption := 'Checking for restrictions...';
        frmSplashScreen.Repaint;
        TempStrServer := Uppercase(RPCBroker1.ANUStrServer);
        TempStrPort := RPCBroker1.ANUStrPort;
        RPCBroker1.Connected := False;
        RPCBroker1.Server := RPCBroker1.ANUStrServerHome;
        RPCBroker1.ListenerPort := StrtoInt(RPCBroker1.ANUStrPortHome);
        //RPCBroker1.Connected := True;  BSE mod - rpm 1/8/09
        //If Not AuthorizedOption('DVBA CAPRI GUI') then begin  BSE mod - rpm 1/8/09
        If Not ConnectToServer('DVBA CAPRI GUI') Then
        Begin
          ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
          application.terminate;
        End;

        //Populate Tools
        FMListBoxCAPRITools.GetList;

        If FMListBoxCAPRITools.Items.Count > 0 Then
        Begin
          For xx := 0 To FMListBoxCAPRITools.Items.Count - 1 Do
          Begin
            TempAction[xx] := TAction.Create(ActionManMain);
            TempAction[xx].OnExecute := frmMain.tempToolClick;
            TempAction[xx].Caption := Piece(FMListBoxCAPRITools.Items[xx], ';', 2);
            TempAction[xx].Name := 'NewTool' + inttostr(xx);
            TempAction[xx].Category := 'External Applications';
            //Add weblink URL, if appropriate
            If (pos('HTTP://', uppercase(FMListBoxCAPRITools.Items[xx])) > 0) or
              (pos('HTTPS://', uppercase(FMListBoxCAPRITools.Items[xx])) > 0) Then
              TempAction[xx].ImageIndex := 15
            else
              TempAction[xx].ImageIndex := -1;

            tempAction[xx].ActionList := ActionManMain;
            with ActionManMain.ActionBars[0].Items[2].Items[6].Items.Add do
              Action := tempAction[xx];
          End;
        End;

        frmSPlashScreen.GaugeLoadSite.Progress := 5;
        {Get User DUZ}
        //CAPRI_CodeCR95  - jcs - 05/20/2010
        if not CallRPC(RPCBroker1, 'XWB GET VARIABLE VALUE', ['DUZ'], nil, True) then
          exit;

        UserDUZHomeServer := RPCBroker1.Results[0];
        //Get Security Keys
        UserKeys.Clear;
        FMListerUserKeys.IENS := ',' + UserDUZHomeServer;
        FMListerUserKeys.GetList(UserKeys);

        FMGets1.IENS := UserDUZHomeServer;
        FMGets1.GetData;
        homeemailaddress := lowercase(fmgets1.GetField('.151').FMDBExternal);
        //Make sure .151 in the new person file has an entry
        If Homeemailaddress = '' Then
        Begin
          {Init Mail}
          {Get User E-Mail Address on Home Server}
          RPCBroker1.RemoteProcedure := 'DVBAB MAIL INIT';
          RPCBrokerCall;
          Try
            RPCBroker1.Call;
            homeemailaddress := lowercase(Piece(RPCBroker1.Results[0], '^', 1));

            frmForwardingAddress := TfrmForwardingAddress.Create(frmMain);
            frmForwardingAddress.Edit1.text := 'NONE SPECIFIED';
            frmForwardingAddress.RadioButton3.Visible := False;
            frmForwardingAddress.RadioButton1.Caption := lowercase(homeemailaddress);
            frmForwardingAddress.ShowModal;
            If frmForwardingAddress.RadioButton1.Checked = True Then
            Begin
              homeemailaddress := lowercase(frmForwardingAddress.RadioButton1.Caption);
            End;
            If frmForwardingAddress.RadioButton2.Checked = True Then
            Begin
              homeemailaddress := lowercase(frmForwardingAddress.editOtherEmailAddress.text);
              // Use specified e-mail address
            End;
            // Update .151 field next
            FMFiler2.AddFDA('200', UserDUZHomeServer, '.151', HomeEMailAddress);
            If Not fmfiler2.Update Then
            Begin
              fmfiler2.DisplayErrors;
            End;
            frmForwardingAddress.Release;
            frmForwardingAddress := Nil;
          Except On EBrokerError Do
            Begin
              ANURemoteProcedureCallInProgress := False;
              AnimateLogo(False);
              StatusBarLoadPt.Caption := 'Mail Init not completed.';
              StatusBarLoadPt.Repaint;
              Application.Processmessages;
            End;
          End;
        End;

        {Get User FilemanCode}
        //CAPRI_CodeCR95  - jcs - 05/20/2010
        if not CallRPC(RPCBroker1, 'XWB GET VARIABLE VALUE', ['DUZ(0)'], nil, True) then
          exit;

        If RPCBroker1.Results.Count > 0 Then
          UserFilemanCode := RPCBroker1.Results[0]
        Else
          UserFilemanCode := '';

        //Check for restricted
        ListRestrictedPatients.Clear;
        {Get Division}
        RPCBroker1.RemoteProcedure := 'DVBAB DIVISION';
        RPCBrokerCall;
        Try
          RPCBroker1.Call;
        Except
          On EBrokerError Do
          Begin
            ANURemoteProcedureCallInProgress := False;
            AnimateLogo(False);
            StatusBarLoadPt.Caption := 'RPC DVBAB DIVISION could not be accessed!';
            StatusBarLoadPt.Repaint;
            Application.Processmessages;
            ShowMessageCAPRI('DVBAB DIVISION could not be accessed!');
          End;
        End;
        If RPCBroker1.Results.Count = 0 Then
        Begin
          ShowMessageCAPRI('You have not been given a division.  Please contact IRM for assistance.');
          application.terminate;
        End;

        frmSPlashScreen.GaugeLoadSite.Progress := 10;
        UserDivision := RPCBroker1.Results[0];


        //CAPRI_CodeCR95  - jcs - 05/20/2010
        if not CallRPC(RPCBroker1, 'XWB GET VARIABLE VALUE', ['DUZ("2")'], nil, True) then
          exit;

        RemoteUserDivisionNumber := '';
        FMGetsInstitution.IENS := RPCBroker1.Results[0];
        // Check to be sure division doesn't come back as "1".
        // If it does, read local field 999000, which is an override value
        // for division.
        FMGetsCAPRIDivision.IENS := UserDUZHomeServer;
        FMGetsCAPRIDivision.GetData;
        tempflag := false;
        Try
          If fmgetsCAPRIDivision.GetField('999000').FMDBExternal <> '' Then
        tempflag := true Except tempflag := false;
        End;
        If tempflag = true Then
        Begin
          UserDivision := Piece(uppercase(fmgetsCAPRIDivision.GetField('999000').FMDBExternal), ';', 2);
          UserDivisionNumber := Piece(uppercase(fmgetsCAPRIDivision.GetField('999000').FMDBExternal), ';', 1);
          RemoteUserDivisionNumber := Piece(uppercase(fmgetsCAPRIDivision.GetField('999000').FMDBExternal), ';', 1);
        End
        Else
        Begin
          // Convert RPCBroker results to field 99 of institution file
          FMGetsInstitution.GetData;
          UserDivisionNumber := FMGetsInstitution.GetField('99').FMDBExternal;
          RemoteUserDivisionNumber := FMGetsInstitution.GetField('99').FMDBExternal;
        End;

        If (RemoteUserDivisionNumber = '') Or (RemoteUserDivisionNumber = '1') Then
        Begin
          Showmessage('There was a problem detecting your division.  Please notify IT support.');
          application.terminate;
        End;

        // Strip "-" off end
        TempString := '';
        If Length(UserDivision) > 0 Then
          For x := length(userdivision) Downto 1 Do
            If Userdivision[x] = '-' Then
              If (tempstring = '') Or (pos('-BVA/VBA', tempstring) > 0) Then
                tempstring := Copy(Userdivision, 1, x - 1);
        If TempString <> '' Then
          UserDivision := TempString;
        // --HERE--*********************


        //CAPRI_CodeCR95  - jcs - 05/20/2010
        if not CallRPC(RPCBroker1, 'XWB GET VARIABLE VALUE', ['DUZ'], nil, True) then
          exit;

        FMGetsNewPerson.IENS := RPCBroker1.Results[0];
        frmSPlashScreen.GaugeLoadSite.Progress := 15;
        FMGetsNewPerson.GetAndFill;

        UserHomePrimaryMenu := FMGetsNewPerson.GetField('201').FMDBExternal;
        FPrimaryMenuAssignable := IsPrimaryMenuAssignable(UserHomePrimaryMenu); //CodeCR109 - rpm 8/4/10
        RestrictedPtSelection := FMGetsNewPerson.GetField('101.01').FMDBExternal;
        PatientSelectionList := FMGetsNewPerson.GetField('101.02').FMDBInternal;
        If RestrictedPtSelection = '' Then
          RestrictedPtSelection := 'N';
        If (RestrictedPtSelection[1] = 'Y') And (Uppercase(PatientSelectionList) = '') Then
        Begin
          ShowMessageCAPRI('You are restricted to a set of patients but have no patient selection list.');
          application.terminate;
        End;

        // 1/11/06
        RestrictedPtSelection := 'N';
        If RestrictedPtSelection[1] = 'Y' Then
        Begin

          frmSplashScreen.StatusLabel.Caption := 'Getting restricted patient list...';
          frmSPlashScreen.GaugeLoadSite.Progress := 18;
          frmSplashScreen.Repaint;
          {Get User DUZ on Home System}
          RPCBroker1.RemoteProcedure := 'DVBAB TEAM PATIENTS';
          RPCBroker1.Param[0].Value := PatientSelectionList;
          RPCBroker1.Param[0].PType := literal;
          RPCBrokerCall;
          Try
            RPCBroker1.Call;
          Except
            On EBrokerError Do
            Begin
              ANURemoteProcedureCallInProgress := False;
              AnimateLogo(False);
              StatusBarLoadPt.Caption := 'RPC DVBAB TEAM PATIENTS could not be accessed!';
              StatusBarLoadPt.Repaint;
              Application.Processmessages;
              ShowMessageCAPRI('DVBAB TEAM PATIENTS could not be accessed!');
            End;
          End;
          QuickCopy(frmMain.RPCBroker1.Results, listRestrictedPatients);
          If RPCBroker1.Results.Count = 0 Then
          Begin
            ShowMessageCAPRI('Your restricted patient list is empty.');
            application.terminate;
          End;
          If Uppercase(listRestrictedPatients[0]) = '^NO PATIENTS FOUND.' Then
          Begin
            ShowMessageCAPRI('You are restricted to a set of patients but have no patients on your list.');
            application.terminate;
          End;
        End;

        RPCBroker1.Connected := False;
        RPCBroker1.Server := TempStrServer;
        RPCBroker1.ListenerPort := StrtoInt(TempStrPort);
        //RPCBroker1.Connected := True;  BSE mod - rpm 1/8/09
        //If Not AuthorizedOption('DVBA CAPRI GUI') Then  BSE mod - rpm 1/8/09
        if not ConnectToServer('DVBA CAPRI GUI') then
        Begin
          ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
          application.terminate;
        End;
      End;

      {Get User DUZ}

      //CAPRI_CodeCR95  - jcs - 05/20/2010
      if not CallRPC(RPCBroker1, 'XWB GET VARIABLE VALUE', ['DUZ'], nil, True) then
        exit;

      AuthorIEN := '';
      If RPCBroker1.Results.Count > 0 Then
        AuthorIEN := RPCBroker1.Results[0];
      If ESSOVersion = False Then
      Begin
        //Get Security Keys
        UserKeys.Clear;
        If AuthorIEN <> '' Then
          FMListerUserKeys.IENS := ',' + AuthorIEN;
        FMListerUserKeys.GetList(UserKeys);
      End;
      UserKeysStr := UserKeys.Text;
      FMGets1.IENS := AuthorIEN;
      FMGets1.GetAndFill;
      localemailaddress := fmgets1.GetField('.151').FMDBExternal;
      AuthorSSN := FMGets1.GetField('9').FMDBInternal;
      AuthorName := FMGets1.GetField('.01').FMDBExternal;

      If ESSOVersion = False Then
      Begin
        {Get Division}
        RPCBroker1.RemoteProcedure := 'DVBAB DIVISION';
        RPCBrokerCall;
        Try
          RPCBroker1.Call;
        Except
          On EBrokerError Do
          Begin
            ANURemoteProcedureCallInProgress := False;
            AnimateLogo(False);
            StatusBarLoadPt.Caption := 'RPC DVBAB DIVISION could not be accessed!';
            StatusBarLoadPt.Repaint;
            Application.Processmessages;
            ShowMessageCAPRI('DVBAB DIVISION could not be accessed!');
          End;
        End;
        If RPCBroker1.Results.Count = 0 Then
        Begin
          ShowMessageCAPRI('You have not been given a division.  Please contact IRM for assistance.');
          application.terminate;
        End;
        frmSPlashScreen.GaugeLoadSite.Progress := 22;
        UserDivision := RPCBroker1.Results[0];


        //CAPRI_CodeCR95  - jcs - 05/20/2010
        if not CallRPC(RPCBroker1, 'XWB GET VARIABLE VALUE', ['DUZ(2)'], nil, True) then
          exit;

        // Convert RPCBroker results to field 99 of institution file
        FMGetsInstitution.IENS := RPCBroker1.Results[0];
        FMGetsInstitution.GetData;
        UserDivisionNumber := FMGetsInstitution.GetField('99').FMDBExternal;

        // Strip "-" off end
        TempString := '';
        If Length(UserDivision) > 0 Then
          For x := length(userdivision) Downto 1 Do
            If Userdivision[x] = '-' Then
              If (tempstring = '') Or (pos('-BVA/VBA', tempstring) > 0) Then
                tempstring := Copy(Userdivision, 1, x - 1);
        If TempString <> '' Then
          UserDivision := TempString;

        {Get User FilemanCode}
        //CAPRI_CodeCR95  - jcs - 05/20/2010
        if not CallRPC(RPCBroker1, 'XWB GET VARIABLE VALUE', ['DUZ(0)'], nil, True) then
          exit;

        If RPCBroker1.Results.Count > 0 Then
          UserFilemanCode := RPCBroker1.Results[0]
        Else
          UserFilemanCode := '';
      end;

      {telnet stuff -----------------------------------------------------}
      // Used only in CAPRI Remote
      // 201 = Primary Menu
      // 7 = DISUSER - User not allowed to log on
      // 9.2 = Termination date
      UserRemoteDISUSER := '';
      UserRemoteTerminationDate := '';
      UserRemotePrimaryMenu := '';

      If essoversion = true Then
      Begin
        FMGetsNewPerson.IENS := AuthorIEN;
        FMGetsNewPerson.GetData;

        // If error reading this, let the user in the system anyway
        UserRemoteDISUSER := FMGetsNewPerson.GetField('7').FMDBInternal;
        UserRemoteTerminationDate := FMGetsNewPerson.GetField('9.2').FMDBInternal;
        UserRemotePrimaryMenu := FMGetsNewPerson.GetField('201').FMDBExternal;

        // Check is user is HIA User.
        // The essoselector controls populating the FMGetsComponent
        try                                                                     //protect against missing field #4 in file #396.96 - rpm 10/22/08
          if formESSOSelect.FMGetsUserSites.GetField('4').FMDBInternal = 'Y' Then
            UserRemoteHIAUser := True
          else
            UserRemoteHIAUser := False;

          if formEssoSelect.FMGetsUserSites.GetField('5').FMDBInternal = 'Y' then
            FIsDoDUser := True
          else
            FIsDoDUser := False;
        except
          //do nothing
        end;
      End;
      {------------------------------------------------------------------}

      frmSplashScreen.StatusLabel.Caption := 'Checking version...';
//      frmSPlashScreen.GaugeLoadSite.Progress := 25;
      frmSPlashScreen.GaugeLoadSite.Progress := 20;
      frmSplashScreen.Repaint;
      RPCBroker1.RemoteProcedure := 'DVBAB VERSION';
      RPCBroker1.Param[0].Value := VersionUser;
      RPCBroker1.Param[0].PType := literal;
      RPCBrokerCall;
      Try
        RPCBroker1.Call;
      Except
        On EBrokerError Do
        Begin
          ANURemoteProcedureCallInProgress := False;
          AnimateLogo(False);
          StatusBarLoadPt.Caption := 'RPC DVBAB VERSION could not be accessed!';
          StatusBarLoadPt.Repaint;
          Application.Processmessages;
          ShowMessageCAPRI('DVBAB VERSION could not be accessed!');
          application.terminate;
        End;
      End;
      If RPCBroker1.Results.Count > 0 Then
      Begin
        VistAVersion := Piece(RPCBroker1.Results[0], '^', 1);
        VersionA := StrToFloat(Piece(VistAVersion, '*', 2));
        VersionB := StrToFloat(Piece(VistAVersion, '*', 3));
        VersionRevisionSt := Piece(VistAVersion, '*', 4);
        XVersionA := StrToFloat(Piece(Version, '*', 2));
        XVersionB := StrToFloat(Piece(Version, '*', 3));
        XVersionRevisionSt := Piece(Version, '*', 4);

        if Uppercase(Piece(RPCBroker1.Results[0], '^', 2)) = 'NOOLD' then
          IsOldVersionAllowed := False
        else
          IsOldVersionAllowed := True;

        If Piece(RPCBroker1.Results[0], '^', 3) = 'SURGERY' Then
          AllowSurgeryReport := True
        Else
          AllowSurgeryReport := False;
        // Go ahead and hardcode this
        AllowSurgeryReport := True;
        // Make 45*1 compatible with 41*1 too
        // 12/5/02 - Turn off compatibility.  Require newest patch.
        //ShowMessageCAPRI(floattostr(xversiona)+' '+floattostr(xversionb));
        If FloatToStr(VersionA) = '41' Then
          If FloatToStr(VersionB) = '1' Then
            XVersionA := 41;
        If XVersionA < VersionA Then
        Begin
          If VersionShown = False Then
            ShowMessageCAPRI('Your client software is older than the server on VistA.  Please contact IRM for assistance.  VistA is running ' + VistAVersion);
          if NOT IsOldVersionAllowed then
          begin
            //ShowMessageCAPRI('Old versions of CAPRI will not run from this server.');
            ShowMessageCAPRI(
              'Versions of CAPRI prior to DVBA*2.7*' + FloatToStr(VersionA) + ' will not run from this server.' + #13 + #10 +
              'You are currently running DVBA*2.7*' + FloatToStr(XVersionA) + '.');
            if Assigned(frmSplashScreen) then
              frmSplashScreen.Repaint;
            if UserRemoteHIAUser = True then
              ShowHIAUserDownloadWebsite;
            application.terminate;
          end;
          VersionShown := True;
        End;
        If XVersionA = VersionA Then
          If XVersionB < VersionB Then
          Begin
            If VersionShown = False Then
              ShowMessageCAPRI('Your client software is older than the server on VistA.  Please contact IRM for assistance.  VistA is running ' + VistAVersion);
            if NOT IsOldVersionAllowed then
            begin
              //ShowMessageCAPRI('Old versions of CAPRI will not run from this server.');
              ShowMessageCAPRI(
                'Versions of CAPRI prior to DVBA*2.7*' + FloatToStr(VersionA) + ' will not run from this server.' + #13 + #10 +
                'You are currently running DVBA*2.7*' + FloatToStr(XVersionA) + '.');
              if UserRemoteHIAUser = True Then
                ShowHIAUserDownloadWebsite;
              application.terminate;
            end;
            VersionShown := True;
          End;
        If (VersionShown = False) And (XVersionRevisionSt < VersionRevisionSt) Then
        Begin
          If VersionShown = False Then
            ShowMessageCAPRI('Your client software is older than the server on VistA.  Please contact IRM for assistance.  VistA is running ' + VistAVersion);
          if NOT IsOldVersionAllowed then
          begin
            //ShowMessageCAPRI('Old versions of CAPRI will not run from this server.');
            ShowMessageCAPRI(
              'Versions of CAPRI prior to DVBA*2.7*' + FloatToStr(VersionA) + ' will not run from this server.' + #13 + #10 +
              'You are currently running DVBA*2.7*' + FloatToStr(XVersionA) + '.');
            if UserRemoteHIAUser = True Then
              ShowHIAUserDownloadWebsite;
            application.terminate;
          end;
        End;
      End
      Else
      Begin
        If VersionShown = False Then
          ShowMessageCAPRI('The version loaded in VistA is corrupt or old.  Please contact IRM for assistance.  You may continue using CAPRI, but there could be problems while logged into this system.');
      End;

      // Restricted patient list for non-remote version
      If EssoVersion = False Then
      Begin
        FMGetsNewPerson.IENS := AuthorIEN;
        FMGetsNewPerson.GetAndFill;
        RestrictedPtSelection := FMGetsNewPerson.GetField('101.01').FMDBExternal;
        PatientSelectionList := FMGetsNewPerson.GetField('101.02').FMDBInternal;
        If RestrictedPtSelection = '' Then
          RestrictedPtSelection := 'N';
        If (RestrictedPtSelection[1] = 'Y') And (Uppercase(PatientSelectionList) = '') Then
        Begin
          ShowMessageCAPRI('You are restricted to a set of patients but have no patient selection list.');
          application.terminate;
        End;
        If RestrictedPtSelection[1] = 'Y' Then
        Begin
          frmSplashScreen.StatusLabel.Caption := 'Getting restricted patient list...';
          frmSPlashScreen.GaugeLoadSite.Progress := 30;
          frmSplashScreen.Repaint;
          RPCBroker1.RemoteProcedure := 'DVBAB TEAM PATIENTS';
          RPCBroker1.Param[0].Value := PatientSelectionList;
          RPCBroker1.Param[0].PType := literal;
          RPCBrokerCall;
          Try
            RPCBroker1.Call;
          Except
            On EBrokerError Do
            Begin
              ANURemoteProcedureCallInProgress := False;
              AnimateLogo(False);
              StatusBarLoadPt.Caption := 'RPC DVBAB TEAM PATIENTS could not be accessed!';
              StatusBarLoadPt.Repaint;
              Application.Processmessages;
              ShowMessageCAPRI('DVBAB TEAM PATIENTS could not be accessed!');
            End;
          End;
          If RPCBroker1.Results.Count > 0 Then
            For xx := 0 To RPCBroker1.Results.Count - 1 Do
              listRestrictedPatients.Add(RPCBroker1.Results[xx]);
          If RPCBroker1.Results.Count = 0 Then
          Begin
            ShowMessageCAPRI('Your restricted patient list is empty.');
            application.terminate;
          End;
          If Uppercase(listRestrictedPatients[0]) = '^NO PATIENTS FOUND.' Then
          Begin
            ShowMessageCAPRI('You are restricted to a set of patients but have no patients on your list.');
            application.terminate;
          End;
        End;
        If Not AuthorizedOption('DVBA CAPRI GUI') Then
        Begin
          ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
          application.terminate;
        End;
      End;

      BitBtnNewForm.Visible := False;
      // QC #2016 - jcs - Ensure button is always enabled to match right click delete.
      // Delete event will validate.
      // ButtonIPRDelete.Visible := False;
      // QC #2016 - jcs - Variable no longer needed
      // ANUCanEditCPWM := False;

      // CodeCR668 - JRL 2/23/15
      // It was discovered that there may be times when NO security keys are
      // assigned and that allows some menu options to display that shouldn't.
      // To avoid code and testing impact, I'm modifying the test from:
      //    If UserKeys.Count > 0 Then
      // to
      //    If UserKeys.Count >= 0 Then
      // This mimizes code changes late in the testing cycle.  The test will
      // always succeed and all code in the loop below will always be executed.
      If UserKeys.Count >= 0 Then
      Begin
        ReadOnlyMode := IsUserKeyInList('DVBA CAPRI READ ONLY,DVBA CAPRI READ O');
        actToolsExamListParameters.Visible := IsUserKeyInList('DVBA CAPRI EXAM LIST EDIT,DVBA CAPRI EXAM LIST E,DVBA C SUPERVISOR');
        If IsUserKeyInList('DVBA CAPRI WORKSHEET TAB,DVBA CAPRI WORKSHEET ') Then
        Begin
          TabCPWorksheets.Visible := True;
          TabCPWorksheets.Enabled := True;
          TabCPWorksheets.TabVisible := True;
          actToolsUnsignedWorksheets.Visible := True;
        End;
        // Check Patch Number for defensive coding
        if IsPatchInstalled('DVBA*2.7*181') then                                // CodeCR347 - JRL 6/12/12
        begin                                                                   // CodeCR347 - JRL 6/12/12
          // Make the vocational rehab tab visible only if the user             // CodeCR347 - JRL 6/12/12
          // has VocRehab userkeys                                              // CodeCR347 - JRL 6/12/12
          TabVocRehab.TabVisible := IsUserKeyInList('DVBA CAPRI VRE_COUNSELOR,DVBA CAPRI VRE_COUNSELOR'); // CodeCR347 - JRL 6/12/12
          if TabVocRehab.TabVisible then                                        // CodeCR347 - JRL 6/12/12
          begin                                                                 // CodeCR347 - JRL 6/12/12
            if not Assigned(VocRehab) then                                      // CodeCR347 - JRL 6/12/12
              VocRehab := TVocRehab.Create;                                     // CodeCR347 - JRL 6/12/12
            // assign access if user has VHA VocRehab privileges                // CodeCR347 - JRL 6/12/12
            // (used for assigning consults)                                    // CodeCR347 - JRL 6/12/12
            VocRehab.VHAAccess := IsUserKeyInList('DVBA CAPRI VHA_COORDINATOR,DVBA CAPRI VHA_COORDINATOR'); // CodeCR347 - JRL 6/12/12
          end;                                                                  // CodeCR347 - JRL 6/12/12
        end                                                                     // CodeCR347 - JRL 6/12/12
        else                                                                    // CodeCR347 - JRL 6/12/12
          TabVocRehab.TabVisible := FALSE;                                      // CodeCR347 - JRL 6/12/12
        // DVBA CAPRI DENY GETVBADOCS was added in patch 186.  VBA users could
        // be assigned this key.  If this key was assigned, then the menu option
        // 'Get Docs from VVA' would not be visible.  After implementation, this
        // was determined to be hard to administrate, so this key is being
        // deprecated and a new key will be added in patch 187 to all users
        // to allow them access to 'Get Docs from VVA'.  VBA users not allowed
        // to see VVA docs here will not get this key. -JRL 5/15/14
        if IsPatchInstalled('DVBA*2.7*186') AND                                 // CodeCR577 - JRL 5/15/14 //Only execute this code if
          NOT IsPatchInstalled('DVBA*2.7*187') then                             // CodeCR577 - JRL 5/15/14 //Patch 186 is installed and
        begin                                                                   // CodeCR577 - JRL 5/15/14 //Patch 187 is not installed
          if IsUserKeyInList('DVBA CAPRI DENY_GETVBADOCS') then                 // CodeCR497 - JRL 6/07/13
            actFileRetrieveVirtualVA.Visible := FALSE                           // CodeCR497 - JRL 6/07/13
          else                                                                  // CodeCR577 - JRL 5/15/14
            actFileRetrieveVirtualVA.Visible := TRUE;                           // CodeCR577 - JRL 5/15/14
        end;                                                                    // CodeCR577 - JRL 5/15/14
        if IsPatchInstalled('DVBA*2.7*187') then                                // CodeCR577 - JRL 5/15/14 //Only execute this code if
        begin                                                                   // CodeCR577 - JRL 5/15/14 //if Patch 187 is installed
          if IsUserKeyInList('DVBA CAPRI GETVBADOCS') then                      // CodeCR577 - JRL 5/15/14
            actFileRetrieveVirtualVA.Visible := TRUE                            // CodeCR577 - JRL 5/15/14
          else                                                                  // CodeCR577 - JRL 5/15/14
            actFileRetrieveVirtualVA.Visible := FALSE;                          // CodeCR577 - JRL 5/15/14
        end;                                                                    // CodeCR577 - JRL 5/15/14
//        if IsUserKeyInList('DVBA GetDocsfromVLER') then                         // CodeCR567 - JRL 5/18/14
//           actFileRetrieveDocsVLERDAS.Visible := TRUE                           // CodeCR567 - JRL 5/18/14
//        else                                                                    // CodeCR567 - JRL 5/18/14
//           actFileRetrieveDocsVLERDAS.Visible := FALSE;                         // CodeCR567 - JRL 5/18/14
        // Add in security key for retrieving documents from VLER/DAS           // CodeCR567 - JRL 5/22/14
        // You must have this key to see the menu option Get Docs from VLER     // CodeCR567 - JRL 5/22/14
        if IsPatchInstalled('DVBA*2.7*187') then                                // CodeCR567 - JRL 5/22/14
        begin                                                                   // CodeCR567 - JRL 5/22/14
           // get the separator between Get Docs from Virtual VA and Get Docs from DAS
          try
            actnItemSeparator := ActionManMain.ActionBars[0].Items[0].Items[11]; // CodeCR668 - RPK 1/21/2015
          except
            actnItemSeparator := nil;
          end;
          if IsUserKeyInList('DVBA CAPRI GETDOCSFROMVLER') then                 // CodeCR567 - JRL 5/18/14
          begin                                                                 // CodeCR567 - JRL 5/22/14
            actFileRetrieveDocsVLERDAS.Visible := TRUE;                         // CodeCR567 - JRL 5/18/14
//              actFileSeparatorBarVisible.Visible := TRUE;                       // CodeCR567 - JRL 5/22/14
            if actnItemSeparator <> nil then                                    // CodeCR668 - RPK 1/21/2015
              actnItemSeparator.Visible := True;                                // CodeCR668 - RPK 1/21/2015
          end                                                                   // CodeCR567 - JRL 5/22/14
          else                                                                  // CodeCR567 - JRL 5/18/14
          begin                                                                 // CodeCR567 - JRL 5/22/14
            actFileRetrieveDocsVLERDAS.Visible := FALSE;                        // CodeCR567 - JRL 5/18/14
//              actFileSeparatorBarVisible.Visible := FALSE;                      // CodeCR567 - JRL 5/22/14
            if actnItemSeparator <> nil then                                    // CodeCR668 - RPK 1/21/2015
              actnItemSeparator.Visible := False;                               // CodeCR668 - RPK 1/21/2015
          end                                                                   // CodeCR567 - JRL 5/22/14
        end;                                                                    // CodeCR567 - JRL 5/22/14
        if IsPatchInstalled('DVBA*2.7*190') then                                // CodeCR698 - RPK 3/30/2015
        begin                                                                   // CodeCR698 - RPK 3/30/2015
          if ESSOVersion then // If remotely logged in, then check security key // CodeCR698 - JRL 4/20/2015
          begin                                                                 // CodeCR698 - JRL 4/20/2015
            actHelpEdtCancelReasons.Visible := IsUserKey('DVBA CAPRI EXAMCANC');  // CodeCR698 - RPK 3/30/2015
            actHelpEdtInsuffReasons.Visible := IsUserKey('DVBA CAPRI EXAMINSUFF'); // CodeCR698 - RPK 3/30/2015
          end                                                                   // CodeCR698 - JRL 4/20/2015
          else                                                                  // CodeCR698 - JRL 4/20/2015
          begin                                                                 // CodeCR698 - JRL 4/20/2015
            actHelpEdtCancelReasons.Visible := FALSE;                           // CodeCR698 - JRL 4/20/2015
            actHelpEdtInsuffReasons.Visible := FALSE;                           // CodeCR698 - JRL 4/20/2015
          end;                                                                  // CodeCR698 - JRL 4/20/2015
        end;                                                                    // CodeCR698 - RPK 3/30/2015
        FoundCPWMKey := '';
        If IsUserKeyInList('DVBAB CPWM REQUIRE REVIEW,DVBAB CPWM REQUIRE REV') Then
          FoundCPWMKey := FoundCPWMKey + 'DVBAB CPWM REQUIRE REVIEW,';
        If IsUserKeyInList('DVBAB CPWM DISALLOW REVIEW,DVBAB CPWM DISALLOW REV') Then
          FoundCPWMKey := FoundCPWMKey + 'DVBAB CPWM DISALLOW REVIEW,';
        If IsUserKeyInList('DVBAB CPWM OPTIONAL REVIEW,DVBAB CPWM OPTIONAL REV') Then
          FoundCPWMKey := FoundCPWMKey + 'DVBAB CPWM OPTIONAL REVIEW,';
        boReviewerKey := IsUserKeyInList('DVBAB CPWM REVIEWER,DVBAB CPWM REVIE');
        If (FoundCPWMKey <> '') Or boReviewerKey Then
        Begin
          BitBtnNewForm.Visible := True;
          // QC #2016 - jcs - Ensure button is always enabled to match right click delete.
          // Delete event will validate.
          //ButtonIPRDelete.Visible := True;
          TabCPWorksheets.Enabled := True;
          TabCPWorksheets.TabVisible := True;
          TabCPWorksheets.Visible := True;
          actToolsCPRSCosigUtil.Visible := True;
          actToolsUnsignedWorksheets.Visible := True;
        End;
        If Piece(FoundCPWMKey, ',', 2) <> '' Then
        Begin
          ShowmessageCAPRI('You have conflicting CAPRI security keys.  Please notify IRM there is a problem with keys: ' + char(13) + Copy(FoundCPWMKey, 1, length(FoundCPWMKey) - 1));
        End;
      End;

      // Enable C&P Worksheets tab for CLAIMS users with FileMan access "@", "U", and "u".
      if (TabCPWorksheets.TabVisible = False) and (EssoVersion) then
      begin
        if (Pos('@', userfilemancode) > 0) or
          (Pos('u', userfilemancode) > 0) or
          (Pos('U', userfilemancode) > 0) then
        begin
          TabCPWorksheets.Visible := True;
          TabCPWorksheets.Enabled := True;
          TabCPWorksheets.TabVisible := True;
        end;
      end;

      //Loading Lab tests used to be here...
      ListLabTestNames.Clear;

      frmSplashScreen.StatusLabel.Caption := 'Loading drug classes...';
      fmlistboxvadrugclass.getlist;
      If fmlistervadrugclass.more = true Then
        Repeat fmlistboxvadrugclass.getmore
        Until fmlistervadrugclass.more = false;
      frmSplashScreen.StatusLabel.Caption := 'Loading medical center divisions...';
      frmSPlashScreen.GaugeLoadSite.Progress := 65;
      frmSplashScreen.Repaint;
      // Get divisions and force them in the order they are in the file
      GetAllDivisions(ListMedicalCenterDivision);                               //CodeCR186 - rpm 4/18/11

      frmSplashScreen.StatusLabel.Caption := 'Loading exam list...';
      frmSPlashScreen.GaugeLoadSite.Progress := 75;
      frmSplashScreen.Repaint;
      FMListerExams.GetList(listExams);                                         // Get Exams

      //Load Institutions Used to be here...
      lstInstitutions.Items.Clear;
      frmROFinder.ORListBoxSites.Items.Clear;

      frmSPlashScreen.GaugeLoadSite.Progress := 100;
      frmSplashScreen.Repaint;

      {Load lab tests}
      //frmLabGraph.FMListBoxLabs.GetList;
      //timerLoadLabs.Enabled:=True;

      If ESSOVersion = False Then
      Begin
        {Get DTime}
        //CAPRI_CodeCR95  - jcs - 05/20/2010
        if not CallRPC(RPCBroker1, 'XWB GET VARIABLE VALUE', ['DTIME'], nil, True) then
          exit;

        TimeOutVal := StrToInt(RPCBroker1.Results[0]);
        If TimeOutVal < 600 Then
          TimeOutVal := 600;
      End;

      TimeOutTimer.Enabled := True;

      //If Pos('@',userfilemancode)>0 then EditelectronicSignatureCode1.Visible:=True;

      If Pos('@', userfilemancode) > 0 Then
      Begin
        actToolsExamListParameters.Visible := True;
        actToolsCPRSCosigUtil.Visible := True;
        //TabCPWorksheets.Visible:=True;
        //TabCPWorksheets.Enabled:=True;
        //TabCPWorksheets.TabVisible:=True;
        //UnsignedCPWorksheets1.Visible:=True;
      End;

          //Check for mail
      If frmMailMan = Nil Then
        frmMailMan := TfrmMailMan.Create(frmMain);
      frmMailMan.StringGridMailboxMessages.RowCount := 0;
      frmMailMan.StringGridMailboxMessages.Cells[0, 0] := '';                   // Clear these in case no messages are in the mailbox
      frmMailMan.StringGridMailboxMessages.Cells[1, 0] := '';
      frmMailMan.StringGridMailboxMessages.Cells[2, 0] := '';
      frmMailMan.StringGridMailboxMessages.Cells[3, 0] := '';
      frmMailMan.StringGridMailboxMessages.Cells[4, 0] := '';
      frmMailMan.StringGridMailboxMessages.Cells[5, 0] := '';                   // Not used for now
      frmMailMan.StringGridMailboxMessages.Cells[6, 0] := '';

      frmMailMan.btnRefreshClick(Application);
      //Now check to see if they have a forwarding e-mail address in
      //file 200.  If not, prompt them.
      If ESSOVersion = True Then
        If lowercase(localemailaddress) <> lowercase(homeemailaddress) Then
        Begin
          FMFiler2.AddFDA('200', AuthorIEN, '.151', HomeEMailAddress);
          LocalEMailAddress := lowercase(homeemailaddress);
          Try
            If Not fmfiler2.Update Then
            Begin
              fmfiler2.DisplayErrors;
            End;
            ShowMessageCAPRI('Remote e-mail address for this system has been' + char(13) + 'updated to match your home server preference:' + char(13) + HomeEmailAddress);
          Except
            Begin
              ShowmessageCAPRI('Couldn''t set remote e-mail address.');
              If RPCBroker1.Connected = False Then
              Begin
                ShowmessageCAPRI('Not connected to a server due to data transmission failure.  Exiting application.');
                application.Terminate;
                application.terminate;
              End;
            End;
          End;

        End;

      frmSPlashScreen.GaugeLoadSite.ForeColor := clYellow;
      frmAlerts := TfrmAlerts.Create(frmMain);
      if IsCCRUser then begin
        frmSplashScreen.StatusLabel.Caption := 'Checking Alert: Manifests available for Pending / Under Review...';
        frmSPlashScreen.GaugeLoadSite.Progress := 20;
        frmSplashScreen.Repaint;
        frmAlerts.btnManifests.Show;
        frmAlerts.edtManifests.Show;
        frmAlerts.shpManifests.Show;                                            // rpk 11/5/2014
        frmManifests := TfrmManifests.Create(frmMain);
        try
          ManifestCnt := frmManifests.getManifestCnt;
          edtstr := 'Unable to retrieve vendor exam requests pending review.';
          if ManifestCnt >= 0 then begin
            case ManifestCnt of
              0: edtstr := 'You have no vendor exam requests pending review.';
              1: edtstr := 'You have 1 vendor exam requests pending review.';
            else
              edtstr := 'You have ' + IntToStr(ManifestCnt) + ' vendor exam requests pending review.';
            end;
          end;
          frmAlerts.edtManifests.Text := edtstr;
          frmAlerts.btnManifests.Enabled := ManifestCnt > 0;
          frmAlerts.edtManifests.Enabled := ManifestCnt > 0;
        finally
          FreeAndNil(frmManifests);                                             // rpk 7/11/2014
        end;
      end
      else begin
        frmAlerts.btnManifests.Hide;
        frmAlerts.edtManifests.Hide;
        frmAlerts.shpManifests.Hide;                                            // rpk 11/5/2014
      end;

      frmSplashScreen.StatusLabel.Caption := 'Checking Alert: CPRS co-signature status...';
      frmSPlashScreen.GaugeLoadSite.Progress := 40;
      frmSplashScreen.Repaint;
      // Check for documents ready to be transferred from TIU to AMIE
      If actToolsCPRSCosigUtil.visible = true Then
      Begin
        frmAlerts.buttonResolve.Show;                                           // rpk 11/6/2014
        frmAlerts.editResolve.Show;                                             // rpk 11/6/2014
//        frmAlerts.shape4.Visible := false;
        frmAlerts.shpResolve.Show;                                              // rpk 11/6/2014
        frmUncosigned := TfrmUncosigned.Create(frmMain);
        frmUncosigned.buttonSearchClick(Application);
        If piece(frmUncosigned.labelReady.caption, ' ', 1) = '0' Then
        Begin
          frmAlerts.editResolve.Text := 'There are no CPRS co-signed documents ready for transfer to AMIE.';
          frmAlerts.editResolve.Enabled := False;
          frmAlerts.ButtonResolve.Enabled := False;
        End
        Else
          If piece(frmUncosigned.labelReady.caption, ' ', 1) = '1' Then
          Begin
            frmAlerts.editResolve.Text := 'There is 1 CPRS co-signed document ready for transfer to AMIE.';
            frmAlerts.editResolve.Enabled := True;
            frmAlerts.ButtonResolve.Enabled := True;
          End
          Else
          Begin
            frmAlerts.editResolve.Text := 'There are ' + piece(frmUncosigned.labelReady.caption, ' ', 1) + ' CPRS co-signed documents ready for transfer to AMIE.';
            frmAlerts.editResolve.Enabled := True;
            frmAlerts.ButtonResolve.Enabled := True;
          End;
      End
      Else
      Begin
        // Hide this one
        frmAlerts.buttonResolve.Visible := false;
        frmAlerts.editResolve.Visible := false;
//        frmAlerts.shape4.Visible := false;
        frmAlerts.shpResolve.Visible := false;
//        frmAlerts.BitBtnContinue.top := 162;
//        frmAlerts.Height := 240;
// have stopped moving Continue button and resizing Alerts form; just leave Resolve row hidden; rpk 11/6/2014
//        frmAlerts.BitBtnContinue.top := frmAlerts.BitBtnContinue.top - 50;  // rpk 11/5/2014
//        frmAlerts.Height := frmAlerts.Height - 44;
        //frmAlerts.height:=frmAlerts.bitBtnContinue.Top+frmAlerts.bitBtnContinue.Height+16;
      End;

      frmSplashScreen.StatusLabel.Caption := 'Checking Alert: Unsigned templates...';
//      frmSPlashScreen.GaugeLoadSite.Progress := 50;
      frmSPlashScreen.GaugeLoadSite.Progress := 60;
      frmSplashScreen.Repaint;

      // Check for forms needing signature
      timeouttimer.enabled := true;
      UnsignedView := TUnsignedView.Create(frmMain);
      UnsignedView.Button5Click(Application);

      If ((UnsignedView.FMListBoxIPR1.Items.Count > 0) And (ReadOnlyMode = False)) Then
      Begin
        // Duplicate check for documents needing signature, same as in alerts
        frmAlerts.ButtonUnsignedClick(frmMain);
      End;

      // Check for forms needing signature if user has access to the worksheet tab
      For xx := 0 To UserKeys.Count - 1 Do
        If (UserKeys[xx] = 'DVBA CAPRI WORKSHEET TAB') Or
          (UserKeys[xx] = 'DVBA CAPRI WORKSHEET ') Then
        Begin

          Flag := False;
          //For xx:=0 to UserKeys.Count-1 do ShowMessageCAPRI(userkeys[xx]);
          If UserKeys.Count > 0 Then
          Begin
            //For xx:=0 to UserKeys.Count-1 do  ShowMessageCAPRI(UserKeys[xx]);
            For yy := 0 To UserKeys.Count - 1 Do
              If (UserKeys[yy] = 'DVBAB CPWM REVIEWER') Or
                (UserKeys[yy] = 'DVBAB CPWM REVIE') Then
              Begin
                flag := true;
              End;
          End;
          If Flag = True Then
          Begin
            frmSplashScreen.Show;
            frmSplashScreen.StatusLabel.Caption := 'Checking Alert: Templates ready for review...';
//            frmSPlashScreen.GaugeLoadSite.Progress := 75;
            frmSPlashScreen.GaugeLoadSite.Progress := 80;
            frmSplashScreen.Repaint;

            UnsignedView.Button4Click(frmMain);
            If ((UnsignedView.FMListBoxIPR1.Items.Count > 0) And (ReadOnlyMode = False)) Then
            Begin
              If UnsignedView.FMListBoxIPR1.Items.Count = 1 Then
                frmAlerts.editReview.Text := 'There is 1 template requiring review.'
              Else
              Begin
                zz := 0;
                For x := 0 To UnsignedView.FMListBoxIPR1.Items.Count - 1 Do
                  If Copy(UnsignedView.FMListBoxIPR1.Items[x], 1, 1) <> '!' Then
                    inc(zz);
                If zz > 1 Then
                  frmAlerts.editReview.Text := 'There are ' + inttostr(zz) + ' templates requiring review.';
                If zz = 1 Then
                  frmAlerts.EditReview.Text := 'There is 1 template requiring review.';
              End;
              frmAlerts.buttonReview.enabled := True;
              frmAlerts.editReview.enabled := True;
            End
            Else
            Begin
              frmAlerts.editReview.enabled := false;
              frmAlerts.editReview.text := 'There are no templates requiring review.';
              frmAlerts.buttonReview.enabled := False;
            End;
          End
          Else
          Begin
            frmAlerts.editReview.enabled := false;
            frmAlerts.editReview.text := 'You do not have template "reviewer" privileges.';
            frmAlerts.buttonReview.enabled := False;
          End;
        End;

      frmSplashScreen.StatusLabel.Caption := 'Checking Alert: CPRS un-cosigned documents...';
      frmSPlashScreen.GaugeLoadSite.Progress := 100;
      frmSplashScreen.Repaint;
      frmTIUCosign := TfrmTIUCosign.Create(Nil);
      frmTIUCosign.GetCosignatureAlerts;

    End;

    If ScreenReaderActive = True Then
      frmMain.Caption := 'CAPRI'
    Else
      frmMain.Caption := ProgramNameCaption + ' Connected To ' + Uppercase(RPCBroker1.ANUStrServer) + ' (Server:' + RPCBroker1.ANURPCServer + '  Volume:' + RPCBroker1.ANURPCVolume + '  UCI:' + RPCBroker1.ANURPCUCI + '  Port:' + RPCBroker1.ANURPCPort +
        ')';

    labeldivision.caption := '';
    If ESSOVersion = True Then
    Begin
      labeldivision.visible := true;
      RPCBroker1.RemoteProcedure := 'DVBAB SET DIVISION';
      RPCBroker1.Param[1].Value := RemoteUserDivisionNumber;
      RPCBroker1.Param[1].PType := literal;

      Try
        RPCBroker1.Call;
      Except
        On EBrokerError Do
        Begin
          ANURemoteProcedureCallInProgress := False;
          AnimateLogo(False);
          StatusBarLoadPt.Caption := 'RPC DVBAB SET DIVISION could not be accessed!';
          StatusBarLoadPt.Repaint;
          Application.Processmessages;
          ShowMessageCAPRI('DVBAB SET DIVISION could not be accessed!');
        End;
      End;
      Try
        If piece(rpcbroker1.results[0], '^', 1) = '0' Then
        Begin
          LabelDivision.Caption := 'Division: Set division failed!';
          ShowmessageCAPRI('WARNING:  There was a problem setting the user''s division.  Some reports may not function correctly.  ' + piece(rpcbroker1.results[0], '^', 2));
        End
        Else
        Begin
          // User's division IEN is in piece 1, but we don't need it right now.
          LabelDivision.caption := 'Division: ' + piece(rpcbroker1.results[0], '^', 2);
        End;
      Except
        Begin
        End;
      End;
    End
    Else
    Begin
      // Non-remote mode
      labelDivision.Caption := 'Division: ' + UserDivision;
    End;
    PanelDivision.Width := labelDivision.Width + 8;

    If labelDivision.Caption = '' Then
    Begin
      ShowmessageCAPRI('WARNING:  There was a problem setting the user''s division.  Please check the host system and log in again.  If the problem continues, notify your IT support service.');
      timerhalt.enabled := true;
    End;

    Panel1.Visible := True;
    SwitchToSite := '';                                                         //Clear this, just in case it was previously set
    AnimateLogo(False);

    If RPCBroker1.Connected = False Then
    Begin
      frmMain.Caption := 'CAPRI not Connected'
    End;
  End
  Else
  Begin
    TimeOutVal := 0;
    TimeOutTimer.Enabled := False;
    RPCBroker1.Connected := False;
    ClearForm;                                                                  //CodeCR248 - rpm 3/8/12 - clear the header and tab set
    Panel1.Visible := False;
    AnimateLogo(False);
  End;
  If Assigned(frmSplashScreen) Then
  Begin
    frmSplashScreen.Hide;
    frmSplashScreen.release;
    frmSplashScreen := Nil;
  End;
  If Assigned(frmAlerts) Then
  Begin
    If (frmAlerts.buttonUnsigned.enabled = true) Or (frmAlerts.buttonReview.enabled = true)
      Or (frmAlerts.buttonUncosigned.enabled = true) Or (frmAlerts.buttonResolve.enabled = true)
      Or (frmAlerts.btnManifests.enabled = true)                                // 2014-11-03 LMS Fix bug to show alert dialog when manifests are available
      Then
    Begin
      frmAlerts.ShowModal;
    End;
    frmAlerts.Hide;
    frmAlerts.release;
    frmAlerts := Nil;
  End;

  If frmMain.Visible Then
    //SelectPatient1Click(Sender);
    actFileSelectPatientExecute(Sender);

  For x := 1 To 100 Do
    application.processmessages;

  If Assigned(frmTIUCosign) Then
  Begin
    FreeAndNil(frmTIUCosign);
  End;
  If Assigned(frmUncosigned) Then
  Begin
    frmUncosigned.Hide;
    Try
      frmUncosigned.release;
    Except
    End;
    frmUncosigned := Nil;
  End;
  If UnsignedView <> Nil Then
  Begin
    Try
      UnsignedView.Release;
    Except
    End;
    UnsignedView := Nil;
  End;
  switchtosite := '';
  ContextorChangeMessage := '';
  CCOWBreakLink := False;

  // Check if CPEP has been notified that this used has used this version before
  // Only do it one time.
  tempstring2 := version;
  If pos('*', tempstring2) > 0 Then
    Repeat
      tempstring2 := copy(tempstring2, 1, pos('*', tempstring2) - 1) + '_' + copy(tempstring2, pos('*', tempstring2) + 1, 255);
    Until pos('*', tempstring2) = 0;
  If Not fileexists(tempdir + tempstring2 + '.validated') Then
  Begin
    tempstring := '';
    tempstring := authorname + '^' + UserDivision + '^' + UserDivisionNumber + '^' + version;
    aStream := TMemoryStream.Create;
    formNews.GetURL('http://vhatvhcpepa/cgi-bin/capri_track.pl?' + tempstring, aStream);
    formNews.RichEditNews.Lines.LoadFromStream(aStream);
    formNews.RichEditNews.Lines.SaveToFile(tempdir + tempstring2 + '.validated');
    formNews.RichEditNews.Lines.Clear;
    formNews.GetURL('http://' + newsURL + 'NewsHeaders.txt', aStream);
    formNews.RichEditNews.Lines.LoadFromStream(aStream);
    aStream := nil;
  End;
End;

procedure TfrmMain.actFileConnectUpdate(Sender: TObject);
begin
  {jcs - CAPRI_CodeCR61 - Rearranged code, since the 'connect' menu option
  has a dependancy on the state of the 'switch sites' menu, which in turn as a
  dependancy on the 'connect' menu, set the caption of the 'connect' menu first,
  then update the 'switch sites' menu (added line of code), then set 'connect'
  menu accordingly.
  }
  If RPCBroker1.Connected = True Then
    actFileConnect.caption := '&Disconnect...'
  else
    actFileConnect.caption := '&Connect...';

  actFileSwitchSitesUpdate(application);

  If (assigned(frmNewExam)) or (assigned(frmViewExam)) or (assigned(frmNew7131)) or
    (assigned(frmView7131)) or (actFileSwitchSites.Enabled = True) then
    actFileConnect.Enabled := False
  else
    actFileConnect.Enabled := True;

end;

procedure TfrmMain.actFilePrinterSetupExecute(Sender: TObject);
begin
  formPrint.ButtonPrinterSetupClick(application);
end;

procedure TfrmMain.actFilePrinterSetupUpdate(Sender: TObject);
begin
  If noprinting = true Then actFilePrinterSetup.Enabled := False
  else
    actFilePrinterSetup.Enabled := True;
end;

procedure TfrmMain.actFilePrintExecute(Sender: TObject);
Var
  vIn, vOut: OleVariant;
begin
  if ANURemoteProcedureCallInProgress = True Then
    exit;

  if Page95Control1.ActivePage = TabVistAWeb Then
  begin
    WebBrowser1.ControlInterface.ExecWB(OLECMDID_PRINTPREVIEW, OLECMDEXECOPT_DONTPROMPTUSER, vIn, vOut);
    exit;
  end;

  if FormatReport(Sender) then                                                  //CodeCR353 - rpm 5/8/12
  begin
    // Send to print preview or printer, depending on how the procedure
    // is called
    if sender = actFilePrintPreview then
    begin
      formPrint.buttonPreviewClick(Application);
    end
    else
    begin
      formPrint.buttonPrintClick(Application);
    end;

    CleanupAfterReport(Sender);                                                 //CodeCR353 - rpm 5/8/12
  end;
end;

{========================================================================
 GetServerDateTime
 This function retrieves the current date/time from the connected
 remote system in "HH:MM:SS am/pm" format. Refactored from
 actPrintFileExecute for reuse.

 Input: none
 Output:  returns formatted date/time on success;
          otherwise, returns empty string

 CodeCR353 - rpm 4/30/12
 ========================================================================}

function TfrmMain.GetServerDateTime(): String;
begin
  RPCBroker1.RemoteProcedure := 'DVBAB DATETIME';
  try
    RPCBroker1.Call;
  except
    on EBrokerError do
    begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'RPC DVBAB DATETIME could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('DVBAB DATETIME could not be accessed!');
    end;
  end;
  if (RPCBroker1.Results.Count > 0) then
    Result := RPCBroker1.Results[0]
  else
    Result := '';
end;

{=========================================================================
 GetFooterDescription
 This function evaluates the selected tab or form and returns footer
 description text for reporting.  This code refactored from
 actFilePrintExecute and contains a number of short-circuits.

 Input: Sender - form object
 Output: footDescrip - footer description passed by reference
         ErrorText - error message text
         function result returns True on success; otherwise, returns False

 CodeCR353 - rpm 4/30/12
 ========================================================================}

function TfrmMain.GetFooterDescription(Sender: TObject; var footDescrip: String; var ErrorText: String): Boolean;
begin
  if Assigned(Sender) and (Sender = PNCSForm) then
  begin                                                                         {PNCS Exam report}
    Page95Control1.ActivePage := TabCPWorksheets;
    footDescrip := 'UNSIGNED/DRAFT C&P Template';
  end                                                                           {PNCS Exam report}
  else if Assigned(Sender) and ((Sender = FormTIUDisplay) OR (Sender = TIUSignForm)) Then // CodeCR425 JRL 11/13/12 -- added TIUSignForm option
  begin                                                                         {CPRS Document view}
    Page95Control1.ActivePage := TabCPWorksheets;
    footdescrip := 'CLIN DOC: Progress Note';
  end                                                                           {CPRS Document view}
  else If Assigned(Sender) and (Sender = frmExamDetails) Then
  Begin                                                                         {Exam Details form}
    If frmExamDetails.RichEditExamReport.Visible = False Then
      ErrorText := 'This exam cannot be printed yet.'
    else
      footdescrip := 'C&P Exam Results: ' + frmExamDetails.FMExamType.Text;
  End                                                                           {Exam Details form}
  else If Assigned(Sender) and (Sender = frmGenerateBlankTemplate) Then
  Begin                                                                         {Blank Template form}
    footdescrip := 'Blank Template: ' + Piece(frmGenerateBlankTemplate.ListBoxTemplates.Items[frmGenerateBlankTemplate.ListBoxTemplates.ItemIndex], '^', 1);
  End                                                                           {Blank Template form}
  else
  begin                                                                         {All other senders}
    if Page95Control1.ActivePage = TabReports Then
    begin
      if ORReportsAvailable.ItemIndex = -1 Then
      begin
        ErrorText := 'Please select a report type first.';
      end
      else
        footdescrip := 'REPORT: ' + ORReportsAvailable.Items[OrReportsAvailable.ItemIndex];
    end
    else if Page95Control1.ActivePage = TabDoD then
    begin
      if ORListBoxDoDReportTypes.ItemIndex = -1 then
      begin
        ErrorText := 'Please select a report type first.';
      end
      else
        footdescrip := 'FHIE: ' + Piece(ORListBoxDoDReportTypes.Items[ORListBoxDoDReportTypes.ItemIndex], '^', 1);
    end
    else if (Page95Control1.ActivePage = AdminDocuments) then
    begin
      if (Tab95Control3.Tabs[Tab95Control3.TabIndex] = '&V)  Address') then
        footdescrip := 'Address';

      if (Tab95Control3.Tabs[Tab95Control3.TabIndex] = '&W)  Appointments') Then
        footdescrip := lblApptStatus.Caption;
    end
    else if Page95Control1.ActivePage = TabClinicalDocuments Then
    begin                                                                       {Clinical Documents}
      if ((lstDocs.ItemIndex = -1) And (DocType <> 'DIET')) And (DocType <> 'MULTI') Then
      begin
        ErrorText := 'Please select a clinical document to print.';
      end
      else
      begin                                                                     {Clinical Document Types}
        If DocType = 'PN' Then
          footdescrip := 'CLIN DOC: Progress Note'
        else If DocType = 'DS' Then
          footdescrip := 'CLIN DOC: Discharge Summary'
        else If DocType = 'CN' Then
          footdescrip := 'CLIN DOC: Consult'
        else If DocType = 'VS' Then
          footdescrip := 'CLIN DOC: Vital Signs (' + lstDocs.Items[lstDocs.ItemIndex] + ')'
        else If DocType = 'MEDS' Then
          footdescrip := 'CLIN DOC: Medications (' + lstDocs.Items[lstDocs.ItemIndex] + ')'
        else If DocType = 'LAB' Then
          footdescrip := 'CLIN DOC: Labs (' + lstDocs.Items[lstDocs.ItemIndex] + ')'
        else If DocType = 'IMAGING' Then
          footdescrip := 'CLIN DOC: Imaging'
        else If DocType = 'DIET' Then
          footdescrip := 'CLIN DOC: Diet'
        else If DocType = 'NUTASSESS' Then
          footdescrip := 'CLIN DOC: Nutritional Assessment (' + lstDocs.Items[lstDocs.ItemIndex] + ')'
        else If DocType = 'ORDERS' Then
          footdescrip := 'CLIN DOC: Orders (' + lstDocs.Items[lstDocs.ItemIndex] + ')'
        else If DocType = 'PROCEDURES' Then
          footdescrip := 'CLIN DOC: Procedure'
        else If DocType = 'PROBLEM LIST' Then
          footdescrip := 'CLIN DOC: Problem List (' + lstDocs.Items[lstDocs.ItemIndex] + ')'
        else If DocType = 'MULTI' Then
          footdescrip := 'CLIN DOC: Multi-Document';
      end;                                                                      {Clinical Document Types}
    End                                                                         {Clinical Documents}
    else If Page95Control1.ActivePage = TabHealthSummaries Then
    Begin                                                                       {Health Summaries}
      if (ORHealthSummaryUserList.ItemIndex = -1) and
        (HSMemoLocal.Lines.Count = 0) Then
      begin
        ErrorText := 'Please select a health summary type first.';
      end
      else
      begin
        If (ORHealthSummaryUserList.ItemIndex > -1) Then
          footdescrip := 'HEALTH SUMMARY (' + Tab95Control2.Tabs[Tab95Control2.TabIndex] + '): ' + ORHealthSummaryUserList.Items[OrHealthSummaryUserList.ItemIndex]
        Else
          footdescrip := 'HEALTH SUMMARY (' + Tab95Control2.Tabs[Tab95Control2.TabIndex] + '): Adhoc Report';
      end;
    End;                                                                        {Health Summaries}
  End;                                                                          {All other senders}

  if (ErrorText <> '') then
    Result := False
  else
    Result := True;
end;

{========================================================================
 FormatReport
 This overloaded function acts as a wrapper and sets the reference
 parameters required to allow normal reporting to use the refactored
 FormatReport function.
 Input:  Sender - object making the call
 Output: function result returns True on success; otherwise returns False.

 CodeCR353 - rpm 5/8/12
 ========================================================================}

function TfrmMain.FormatReport(Sender: TObject): Boolean;
var
  footdescrip: String;
  DtTm: String;
  Division: String;
begin
  footdescrip := '';
  DtTm := '';
  Division := '';
  Result := FormatReport(Sender, footDescrip, DtTm, Division);
end;

{========================================================================
 FormatReport
 This overloaded function formats text into report format.  Refactored from
 actFilePrintExecute for re-use for Virtual VA transmission.
 Input:
   Sender - object making the call
   footDescrip - passed by reference: description retrieved from GetFooterDescription
   DtTm - passed by reference: current server Date/Time
   Division - passed by reference: user's DUZ(2) value

 Output: function result returns True on success; otherwise returns False.

 CodeCR353 - rpm 5/8/12
 ========================================================================}

function TfrmMain.FormatReport(Sender: TObject; var footdescrip: String;
  var DtTm: String;
  var Division: String): Boolean;
const
  REPORT_NOTCODED = 'Printing has not yet been coded for this page.';
var
  errorText: String;
begin
  //Get footer text and validate tab selections
  if GetFooterDescription(Sender, footdescrip, errorText) then                  //CodeCR353 - rpm 4/30/12
  begin                                                                         {GetFooter OK}
    if footdescrip <> '' Then
    begin                                                                       {FooterText defined}
      {Get Date}
      DtTm := GetServerDateTime();                                              //CodeCR353 - rpm 4/30/12
      {Get Division}
      if CallRPC(RPCBroker1, 'XWB GET VARIABLE VALUE', ['DUZ("2")'], nil, True) then
        Division := RPCBroker1.Results[0];

      //Format Footer
      FormatReportFooter(Sender, footdescrip, DtTm, Division);

      AnimateLogo(True);
      StatusBarLoadPt.Caption := 'Printing...';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;

      //Format Report
      FormatReportBody(Sender);

      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'Sending...';
      StatusBarLoadPt.Repaint;
      Result := True;
    end                                                                         {FooterText defined}
    else
    begin                                                                       {FooterText undefined}
      ShowMessageCAPRI(REPORT_NOTCODED);
      Result := False;
    end;                                                                        {FooterText undefined}
  end                                                                           {GetFooter OK}
  else
  begin                                                                         {GetFooter failed}
    if errorText <> '' then
    begin
      ShowMessageCAPRI(errorText);
    end;
    Result := False;
  end;                                                                          {GetFooter failed}
end;

{========================================================================
 FormatReportBody
 This procedure populates the QuickReport memo control with the report
 text.  Refactored from actFilePrintExecute.
 Input:  Sender - form
 Output: none

 //CodeCR353 - rpm 4/30/12
 =========================================================================}

procedure TfrmMain.FormatReportBody(Sender: TObject);
var
  x, y: Integer;
begin
  formPrint.QRMemoReport.ParentRichEdit := Nil;
  formPrint.QRMemoReport.Lines.Clear;
  formPrint.QRMemoReport.Font.Size := 11;                                       //default font size

  if Assigned(Sender) and (Sender = PNCSForm) Then
  begin                                                                         {PNCS Exam report}
    formPrint.QRMemoReport.ParentRichEdit := PNCSForm.xSampleReportOutput;
  end                                                                           {PNCS Exam report}
  else if Assigned(Sender) and (Sender = FormTIUDisplay) Then
  begin                                                                         {CPRS Document view}
    If formTIUDisplay.SpeedButtonCAPRI.Down = True Then
    Begin
      formPrint.QRMemoReport.ParentRichEdit := formTIUDisplay.MemoDocs;
    End
    Else
      If formTIUDisplay.MemoDocs.Lines.Count > 0 Then
      Begin
        For y := 0 To formTIUDisplay.MemoDocs.Lines.Count - 1 Do
        Begin
          formPrint.QRMemoReport.Lines.Add(formTIUDisplay.MemoDocs.Lines[y]);
        End;
      End;
  end                                                                           {CPRS Document view}
  else If Assigned(Sender) and (Sender = frmExamDetails) Then
  Begin                                                                         {Exam Details form}
    If frmExamDetails.FMExamDetailsCommentsMemo.FMField = '70' Then
    Begin
      // Check for proper font on printer for 132 column printouts
      If frmExamDetails.RichEditExamReport.Lines.Count > 0 Then
        For y := 0 To frmExamDetails.RichEditExamReport.Lines.Count - 1 Do
        Begin
          If Length(frmExamDetails.RichEditExamReport.Lines[y]) > 80 Then
          Begin
            formPrint.QRMemoReport.Font.Size := 7;
          End;
        End;
      //
      formPrint.QRMemoReport.Lines.Add('DATE OF EXAM:        ' + frmExamDetails.FMDateOfExam.Text);
      formPrint.QRMemoReport.Lines.Add('EXAMINING PHYSICIAN: ' + frmExamDetails.FMPhysician.Text);
      formPrint.QRMemoReport.Lines.Add('STATUS:              ' + frmExamDetails.FMExamStatus.Text);
      formPrint.QRMemoReport.Lines.Add(' ');
      For y := 0 To frmExamDetails.RichEditExamReport.Lines.Count - 1 Do
      Begin
        formPrint.QRMemoReport.Lines.Add(frmExamDetails.RichEditExamReport.Lines[y]);
      End;
    End;
    If frmExamDetails.FMExamDetailsCommentsMemo.FMField = '71' Then
    Begin
      formPrint.QRMemoReport.ParentRichEdit := frmExamDetails.RichEditExamReport;
      frmExamDetails.RichEditExamReport.Lines.Insert(0, ' ');
      frmExamDetails.RichEditExamReport.Lines.Insert(0, 'STATUS:              ' + frmExamDetails.FMExamStatus.Text);
      frmExamDetails.RichEditExamReport.Lines.Insert(0, 'EXAMINING PHYSICIAN: ' + frmExamDetails.FMPhysician.Text);
      frmExamDetails.RichEditExamReport.Lines.Insert(0, 'DATE OF EXAM:        ' + frmExamDetails.FMDateOfExam.Text);
    End;
  End                                                                           {Exam Details form}
  else If Assigned(Sender) and (Sender = frmGenerateBlankTemplate) Then
  Begin                                                                         {Blank Template form}
    If frmGenerateBlankTemplate.xSampleReportOutput.Lines.Count > 0 Then
      For y := 0 To frmGenerateBlankTemplate.xSampleReportOutput.Lines.Count - 1 Do
      Begin
        formPrint.QRMemoReport.Lines.Add(frmGenerateBlankTemplate.xSampleReportOutput.Lines[y]);
      End;
  End                                                                           {Blank Template form}
  else if (Page95Control1.ActivePage = AdminDocuments) then                     {Admin tab}
  begin                                                                         {Admin Tab}
    if (Tab95Control3.Tabs[Tab95Control3.TabIndex] = '&V)  Address') then
    begin                                                                       {Address subtab}
      formPrint.QRMemoReport.Lines.Add('PATIENT: ' + Panel1.Caption);
      formPrint.QRMemoReport.Lines.Add(' ');
      formPrint.QRMemoReport.Lines.Add('** PERMANENT ADDRESS **');
      formPrint.QRMemoReport.Lines.Add('ADDRESS: ' + fmEditStreet1.text);
      formPrint.QRMemoReport.Lines.Add('         ' + fmEditStreet2.text);
      formPrint.QRMemoReport.Lines.Add('         ' + fmEditStreet3.text);
      formPrint.QRMemoReport.Lines.Add('   CITY: ' + fmEditCity.text);
      formPrint.QRMemoReport.Lines.Add('  STATE: ' + fmEditState.text);
      formPrint.QRMemoReport.Lines.Add('    ZIP: ' + fmEditZip.text);
      formPrint.QRMemoReport.Lines.Add(' COUNTY: ' + CountyFake.text);
      formPrint.QRMemoReport.Lines.Add('  PHONE: ' + fmEditPhone.text);
      formPrint.QRMemoReport.Lines.Add('OFFICE PHONE: ' + fmEditOffice.text);
      formPrint.QRMemoReport.Lines.Add(' ');
      formPrint.QRMemoReport.Lines.Add('** TEMPORARY ADDRESS **');
      formPrint.QRMemoReport.Lines.Add('TEMP ADDRESS ACTIVE? ' + fmEdit1.text);
      formPrint.QRMemoReport.Lines.Add('START DATE: ' + fmEdit10.text);
      formPrint.QRMemoReport.Lines.Add(' STOP DATE: ' + fmEdit11.text);
      formPrint.QRMemoReport.Lines.Add('ADDRESS: ' + fmEdit2.text);
      formPrint.QRMemoReport.Lines.Add('         ' + fmEdit3.text);
      formPrint.QRMemoReport.Lines.Add('         ' + fmEdit4.text);
      formPrint.QRMemoReport.Lines.Add('   CITY: ' + fmEdit5.text);
      formPrint.QRMemoReport.Lines.Add('  STATE: ' + fmEdit6.text);
      formPrint.QRMemoReport.Lines.Add('    ZIP: ' + fmEdit7.text);
      formPrint.QRMemoReport.Lines.Add(' COUNTY: ' + fmEdit8.text);
      formPrint.QRMemoReport.Lines.Add('  PHONE: ' + fmEdit9.text);
    end                                                                         {Address subtab}
    else if (Tab95Control3.Tabs[Tab95Control3.TabIndex] = '&W)  Appointments') then
    begin                                                                       {Appointments subtab}
      for y := 0 to MemoAppointments.Lines.Count - 1 do
      begin
        formPrint.QRMemoReport.Lines.Add(MemoAppointments.Lines[y]);
      end;
    end;                                                                        {Appointments subtab}
  end                                                                           {Admin Tab}
  else If Page95Control1.ActivePage = TabClinicalDocuments Then
  Begin                                                                         {Clinical Documents}
    For y := 0 To MemoDocs.Lines.Count - 1 Do
    Begin
      formPrint.QRMemoReport.Lines.Add(MemoDocs.Lines[y]);
    End;
  End                                                                           {Clinical Documents}
  else If Page95Control1.ActivePage = TabReports Then
  Begin                                                                         {Reports Tab}
    If ORReportsAvailable.Items[ORReportsAvailable.ItemIndex] = 'C&P Exam Detail' Then
    Begin
      For y := 0 To ReportMemo.Lines.Count - 1 Do
      Begin
        formPrint.QRMemoReport.Lines.Add(ReportMemo.Lines[y]);
      End;
    End
    Else
      For y := 0 To ReportMemo.Lines.Count - 1 Do
      Begin
        formPrint.QRMemoReport.Lines.Add(ReportMemo.Lines[y]);
      End;
  End                                                                           {Reports Tab}
  else If Page95Control1.ActivePage = TabDoD Then
  Begin                                                                         {DoD Tab}
    For y := 0 To RichEditDODReport.Lines.Count - 1 Do
    Begin
      formPrint.QRMemoReport.Lines.Add(RichEditDODReport.Lines[y]);
    End;
  End                                                                           {DoD Tab}
  else If Page95Control1.ActivePage = TabHealthSummaries Then
  Begin                                                                         {Health Summaries}
    TempHSMemo.Clear;
    // Determine local or remote health summary
    If Tab95Control2.TabIndex = 0 Then
    Begin
      If HSMemoLocal.Lines.Count > 0 Then
        For x := 0 To HSMemoLocal.Lines.Count - 1 Do
          TempHSMemo.Add(removetrailingspaces(HSMemoLocal.Lines[x]));
    End
    Else
    Begin
      If HSMemo.Lines.Count > 0 Then
        For x := 0 To HSMemo.Lines.Count - 1 Do
          TempHSMemo.Add(removetrailingspaces(HSMemo.Lines[x]));
    End;

    For y := 0 To TempHSMemo.Count - 1 Do
    Begin
      formPrint.QRMemoReport.Lines.Add(TempHSMemo[y]);
    End;
  End                                                                           {Health Summaries}
  else If Assigned(Sender) and (Sender = TIUSignForm) Then                      // CodeCR423 JRL 11/13/12
  Begin {TIUSign Form}                                                          // CodeCR423 JRL 11/13/12
    For y := 0 To TIUSignForm.TIUtoVVAProgressNotes.Count - 1 Do                // CodeCR423 JRL 11/13/12
    Begin                                                                       // CodeCR423 JRL 11/13/12
      formPrint.QRMemoReport.Lines.Add(TIUSignForm.TIUtoVVAProgressNotes[y]);   //   11/13/12
    End;                                                                        // CodeCR423 JRL 11/13/12
  End; {TIUSign Form}                                                           // CodeCR423 JRL 11/13/12

end;

{========================================================================
 FormatReportFooter
 This procedure populates the QuickReport footer labels.  Refactored
 from actFilePrintExecute.
 Input:  Sender - form
         footDescrip - document description
         DtTm - current server date/time
         Division
 Output: none

 //CodeCR353 - rpm 4/30/12
 =========================================================================}

procedure TfrmMain.FormatReportFooter(Sender: TObject; footDescrip, DtTm,
  Division: String);
begin

  //rra 959449 if coming in through pncs form use patient info from that form
  {Patient Name}
  if PNCSForm <> Nil then
    formPrint.QRLabel3.Caption := Copy(PNCSForm.xFMPatientName.Caption + ' SSN#' + PNCSForm.xFMSSN.Caption + '                                                                                ', 1, 51)
  else
    formPrint.QRLabel3.Caption := Copy(Panel1.Caption + '                                                                                ', 1, 51);
  formPrint.QRLabel1.Caption := footdescrip;
  formPrint.QRLabel4.Caption := 'Printed on: ' + DtTm;
  formPrint.QRLabel6.Caption := 'Division: ' + Division;
  formPrint.QRLabel5.Caption := 'System: ' + Uppercase(RPCBroker1.ANUStrServer);
end;

{========================================================================
 CleanupAfterReport
 This procedure is refactored from actFilePrintExecute and performs any
 cleanup required following report production.
 Input:  Sender - object that called actPrintFileExecute

 //CodeCR353 - rpm 4/30/12
 =========================================================================}

procedure TfrmMain.CleanupAfterReport(Sender: TObject);
begin
  formPrint.QRMemoReport.Lines.Clear;

  {Remove the 4 lines inserted into the original text of
   the Exam Details by FormatReportBody}
  if Assigned(Sender) and
    (Sender = frmExamDetails) and
    (frmExamDetails.FMExamDetailsCommentsMemo.FMField = '71') then
  begin
    frmExamDetails.RichEditExamReport.Lines.Delete(0);
    frmExamDetails.RichEditExamReport.Lines.Delete(0);
    frmExamDetails.RichEditExamReport.Lines.Delete(0);
    frmExamDetails.RichEditExamReport.Lines.Delete(0);
  end;
end;

procedure TfrmMain.actFilePrintPreviewExecute(Sender: TObject);
begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;
  actFilePrintExecute(actFilePrintPreview);
  //Print1Click(PrinterSetup1);
  //formPrint.buttonPreviewClick(Application);
  exit;
end;

procedure TfrmMain.actFilePrintPreviewUpdate(Sender: TObject);
begin
  If (noprinting = true) or (GifImageVistaYellow.Visible = True) or (frmPatientList <> nil) then
    actFilePrintPreview.Enabled := false
  else
    actFilePrintPreview.Enabled := true;

end;

procedure TfrmMain.actFilePrintUpdate(Sender: TObject);
begin
  If (noprinting = true) or (GifImageVistaYellow.Visible = True) or (frmPatientList <> nil) then
    actFilePrint.Enabled := False
  else
    actFilePrint.Enabled := True;
end;

procedure TfrmMain.actFileQuitExecute(Sender: TObject);
Var
  boCanClose: Boolean;
Begin
  boCanClose := False;
  FormCloseQuery(Sender, boCanClose);
  If boCanClose Then Close();
end;

procedure TfrmMain.actFileReportsExecute(Sender: TObject);
Var
  x: integer;
  foundflag: boolean;
Begin

  If ANURemoteProcedureCallInProgress = True Then
    exit;

  If ReadOnlyMode = True Then
  Begin
    ShowMessageCAPRI('Access to reports is not allowed in read only mode.');
    exit;
  End;

  If assigned(frmReports) = false Then
    frmReports := TfrmReports.Create(self);

  If essoversion = true Then
  Begin
    // Make sure user can be on current site before running a report
    foundflag := false;
    If formESSOSelect.slUserSites.Count > 0 Then                                //CodeCR77
      For x := 0 To formESSOSelect.slUserSites.Count - 1 Do
        If uppercase(piece(formESSOSelect.slUserSites[x], '^', 2)) = uppercase(RPCBroker1.Server) Then
          foundflag := true;
    If foundflag <> true Then
    Begin
      ShowmessageCAPRI('You do not have direct access to this site.  Please use FILE | SWITCH SITES and pick a different site prior to running a report.');
      exit;
    End;
  End;

  frmReports.FormResize(application);
  If frmROFinder.ORListBoxSites.Items.Count = 0 Then
    LoadInstitutions;
  frmReports.FMRoutingLocation.Items := listmedicalCenterDivision;
  frmReports.FMRoutingLocation2.Items := listmedicalCenterDivision;
  frmReports.FMRegionalOfficeNumber.Items.Clear;
  // Set up division...
  searchforstring := UserDivision;
  frmReports.FMRegionalOfficeNumberEnter(Application);
  searchforstring := '';

  (*
  If frmMain.lstInstitutions.Items.Count>0 then
    For x:=0 to frmMain.lstInstitutions.Items.Count-1 do
      frmReports.FMRegionalOfficeNumber.Items.Add(Copy(frmMain.lstInstitutions.Items[x],1,Pos('^',frmMain.lstInstitutions.Items[x])-1));
  frmReports.FMRegionalOfficeNumber.Text:=UserDivision;
  frmReports.FMRegionalOfficeNumberExit(Application);
*)
  frmReports.Height := frmMain.Height - 32;
  frmReports.Top := 7 + frmMain.Top + ((frmMain.Height - frmReports.Height) Div 2);
  frmReports.Width := frmMain.Width - 75;
  frmReports.Left := frmMain.Left + ((frmMain.Width - frmReports.Width) Div 2);

  ContextorChangeMessage := 'You are viewing reports.  If you continue, CAPRI will drop out of the clinical context.';
  CCOWBreakLink := True;

  frmReports.ReportMemo.Lines.Clear;
  frmReports.ORReportsAvailable.ItemIndex := -1;
  frmReports.ORReportsAvailable2.ItemIndex := -1;
  frmReports.ShowModal;
  ContextorChangeMessage := '';
  CCOWBreakLink := False;
  Try
    frmROFinder.Hide;
  Except
  End;

  //frmReports := nil;

end;

procedure TfrmMain.actFileReportsUpdate(Sender: TObject);
begin
  If (UserHasNewStyleRestrictedList > 0) or (GifImageVistaYellow.Visible = True) or (frmPatientList <> nil) then
    actFileReports.Enabled := False
  else
    actFileReports.Enabled := True;
end;

{========================================================================
 actFileRetrieveVirtualVAExecute
 This action handler processes the Retrieve from Virtual VA option.

 CodeCR424 - rpm 11/13/12
 ========================================================================}

procedure TfrmMain.actFileRetrieveVirtualVAExecute(Sender: TObject);
var
  frmVVAGetDocs: TfrmVVARetrieval;
const
  {security key mimics the VBA Common Security User Management (CSUM)
   credential 'VA Hospital' role used to control access to restricted
   Virtual VA documents}
  VAHospitalRoleKey = 'DVBA VVA HOSPITAL ROLE';
begin
  frmVVAGetDocs := TfrmVVARetrieval.Create(self);
  try
    frmVVAGetDocs.edbClaimNum.Text := patientSSN;
    frmVVAGetDocs.edbPatientName.Text := patientName;
//  frmVVAGetDocs.edbDOB.Text := LabelDOB.Caption;
    frmVVAGetDocs.edbDOB.Text := StringReplace(LabelDOB.Caption, 'DOB: ', ' ', [rfReplaceAll]); // remove the DOB portion of the caption
    //replace comma in name with underscore, because comma is a delimiter in web service
    frmVVAGetDocs.VVAUserID := StringReplace(RPCBroker1.User.Name, ',', '_', [rfReplaceAll]);
    frmVVAGetDocs.VVASecToken := FVirtualVAToken;
    frmVVAGetDocs.VVAURL := FVirtualVAURL;
    frmVVAGetDocs.VVADocDir := GetTempDir;
    frmVVAGetDocs.IsVAHospitalRole := IsUserKeyInList(VAHospitalRoleKey);
    if frmVVAGetDocs.GetAndFormatDocumentList then
      frmVVAGetDocs.ShowModal;
  finally
    FreeAndNil(frmVVAGetDocs);
  end;
end;

{========================================================================
 actFileRetrieveVirtualVAUpdate
 This action handler disables Retrieve from Virtual VA when no Virtual VA
 URL or Security token is available.

 CodeCR424 - rpm 11/13/12
 ========================================================================}

procedure TfrmMain.actFileRetrieveVirtualVAUpdate(Sender: TObject);
begin
  if (FVirtualVAURL = '') or
    (FVirtualVAToken = '') Then
    actFileRetrieveVirtualVA.Enabled := False
  else
    actFileRetrieveVirtualVA.Enabled := True;
end;

{========================================================================
 actFileRetrieveDocsVLERDASExecute
 This action handler processes the Retrieve from Virtual VA option.

 CodeCR567 - Security Keys JRL 05/18/14
 CodeCRXXX - Retrieve Docs xxx 00/00/00
 ========================================================================}

procedure TfrmMain.actFileRetrieveDocsVLERDASExecute(Sender: TObject);
var
  frmVlerGetExams: TfrmVlerGetExams;
begin
     // Update Execute method for "Get Docs from VLER DAS"
  // ShowMessageCAPRI('Get Docs from VLER DAS window goes here');                 // Stub testing code - remove

  frmVlerGetExams := TfrmVlerGetExams.Create(self);
  try

    frmVlerGetExams.ShowModal;
  finally
    FreeAndNil(frmVlerGetExams);
  end;
end;                                                                            // when procedure gets written

{========================================================================
 actFileRetrieveDocsVLERDASUpdate
 This action handler disables Retrieve from VLER DAS when no VLER DAS
 URL or Security token is available.

 CodeCR567 - Security Keys JRL 05/18/14
 ========================================================================}

procedure TfrmMain.actFileRetrieveDocsVLERDASUpdate(Sender: TObject);
begin
   // Update Execute method for "Get Docs from VLER DAS"
//  if (TIdHTTPVler.GetVlerDasURL() = '') then                   // CodeCR566 LMS No longer Main form member.
//    actFileRetrieveVirtualVA.Enabled := False
//  else
//    actFileRetrieveVirtualVA.Enabled := True;
  actFileRetrieveDocsVLERDAS.Enabled := (TIdHTTPVler.GetVlerDasURL() <> '');    // rpk 1/7/2015
end;

procedure TfrmMain.actFileSelectPatientExecute(Sender: TObject);
var
  lastIEN: String;
begin
  if IsPNCSOpen() then                                                          //CodeCR197 - rpm 11/2/11 - don't allows patient switch when template open
    Exit;

  lastIEN := PatientIEN;                                                        // CodeCR571 - LMS if patient changed, then refresh PatientInfoBucket

  if FIsDoDUser then                                                            //CodeCR131 - rpm 10/26/10 - add DoD User check
    ShowPatientList(Sender, pfDoD)
  else
    ShowPatientList(Sender, pfNormal);                                          //CodeCR124 -MER 07/2010

  If (PatientIEN <> lastIEN) Then
    If assigned(FPatientInfoBucket) Then
      FreeAndNil(FPatientInfoBucket);                                           // DONE: // LMS - Release old patient info. New one will be selected as needed.
end;

procedure TfrmMain.actFileSelectPatientUpdate(Sender: TObject);
begin
  If (GifImageVistaYellow.Visible = True) or (frmNewExam <> nil) or (frmViewExam <> nil) or
    (frmPatientList <> nil) or (frmNew7131 <> nil) or (frmView7131 <> nil) then
    actFileSelectPatient.Enabled := False
  else
    actFileSelectPatient.Enabled := True;

end;

procedure TfrmMain.actFileSwitchSitesUpdate(Sender: TObject);
begin
  if (GifImageVistaYellow.Visible = True) or (actFileConnect.Caption = '&Connect...') or
    (EssoVersion = False) then
    actFileSwitchSites.Enabled := False
  else
    actFileSwitchSites.Enabled := True;
end;

{========================================================================
 actFileTransmitVirtualVAExecute
 This action handler processes text into a PDF file and transmits the
 PDF file to the Virtual VA claims systems at the VBA.

 CodeCR353 - rpm 5/1/12
 ========================================================================}

procedure TfrmMain.actFileTransmitVirtualVAExecute(Sender: TObject);
var
  DtTm: String;
  currentDivision, localStation: String;
  footDescrip: String;
  SendVVA: TfrmVirtualVA;
  fileSizeBytes: LongInt;
  SendFile: Boolean;
  buffer: string;
const
  MAX_SIZE = 15728640;                                                          //The maximum file size in bytes to prevent exceeding 15 mb files.
  DOC_TYPE = 344;                                                               //CAPRI
  DOC_TYPE_CP = 356;                                                            //C&P Exams    // CodeCR539 JRL 09/27/13
  DOC_CATEGORY = 44;                                                            //Medical Records
  DOC_SUBJECT = 'Clinical Documents';
  DOC_SOURCE = 'CAPRIVISTA';
  DOC_TYPE_DOD = 89;                                                            // DoD Tab                 // CodeCR425 JRL 10/19/12
  DOC_CATEGORY_DOD = 51;                                                        // DoD Category       // CodeCR425 JRL 10/19/12
  DOC_SOURCE_COMMENT_DOD = 'BHIE FHIE';                                         // CodeCR425 JRL 11/13/12
  DOC_DOD_SUBJECT = 'DoD Documents';                                            // CodeCR425 JRL 01/0/12
begin
  DtTm := '';
  currentDivision := '';
  localStation := '';
  footdescrip := '';
  SendVVA := TfrmVirtualVA.Create(self);
  SendVVA.Position := poOwnerFormCenter;
  //do we want to delete the temporary PDF file after transmission?
  SendVVA.vvaWSC.IsDeleteFile := NOT FNoDeleteVVA;
  try
    if FormatReport(Sender, footdescrip, DtTm, currentDivision) then
    try                                                                         {ReportOK}
      if (formprint.QRMemoReport.Lines.Count > 0) then
      begin                                                                     {Report Text available}
        SendVVA.vvaWSC.LoadText(formPrint.QRMemoReport);
        //Create PDF file
        with SendVVA.vvaWSC.VVAReport do
        begin
          FooterDesc := footDescrip;
          if (formPRint.QRMemoReport.Font.Size = 7) then
            FontSize := 7
          else
            FontSize := 10;
          FontName := 'Courier New';
          PrintDate := DtTm;
          SystemName := Uppercase(RPCBroker1.ANUStrServer);
          Division := currentDivision;
          Patient.FullName := patientName;
          Patient.SSN := patientSSN;
        end;
        fileSizeBytes := SendVVA.vvaWSC.CreateXmitFile(SendVVA.vvaWSC.vvaReport);

        // copy the file to the heap for vler das use
        if fileSizeBytes > 0 then
        begin
          PdfMemoryStream := TMemoryStream.Create;
          try
            if Sender is TForm then                                             // CodeCR565 JRL 07/31/14
            begin                                                               // CodeCR565 JRL 07/31/14
              if (Sender as TForm).Name = 'TIUSignForm' then                    // CodeCR565 JRL 07/31/14
              begin                                                             // CodeCR565 JRL 07/31/14
                TIUSignForm.FinalReport := TMemoryStream.Create;                // CodeCR565 JRL 7/20/14
                TIUSignForm.FinalReport.LoadFromFile(SendVVA.vvaWSC.vvaReport.VVADoc.OutputFilePath + 'c' + SendVVA.vvaWSC.vvaReport.VVADoc.OutputFileName); // CodeCR565 JRL 7/20/14  (Save report for cosigned exams)
              end;
            end;                                                                // CodeCR538 JRL 07/31/14

//          PdfMemoryStream.LoadFromFile(SendVVA.vvaWSC.vvaReport.VVADoc.OutputFilePath + SendVVA.vvaWSC.vvaReport.VVADoc.OutputFileName);
            // Read compressed PDF into memory to send to VLER/DAS.
            PdfMemoryStream.LoadFromFile(SendVVA.vvaWSC.vvaReport.VVADoc.OutputFilePath + 'c' + SendVVA.vvaWSC.vvaReport.VVADoc.OutputFileName); // CodeCR559 JRL 3/17/14
             // Save final report - it may be needed for cosignature report
          except
            on E: Exception do
            begin
              MessageDlg('PDF report could not be copied and will NOT be sent to VLER.', mtError, [mbOK], 0);
              FreeAndNil(PdfMemoryStream);
            end;
          end;
        end;

        (*  The requirements limit Virtual VA PDF format files to 15 MB. *)
        if (fileSizeBytes < MAX_SIZE) then
        begin                                                                   {Does not exceed size limit}

          // CodeCR538: If coming from TIUSign form, don't ask for confirmation
          // for the automatic transmission to VVA.  Coming from any other form
          // or control is manual so confirm sending
          SendFile := FALSE;                                                    // CodeCR538 JRL 11/18/13
          if Sender is TForm then                                               // CodeCR538 JRL 11/18/13
          begin                                                                 // CodeCR538 JRL 11/18/13
            if (Sender as TForm).Name = 'TIUSignForm' then                      // CodeCR538 JRL 11/18/13
              SendFile := TRUE                                                  // CodeCR538 JRL 11/18/13
          end;                                                                  // CodeCR538 JRL 11/18/13

          if SendFile = FALSE then                                              // CodeCR538 JRL 11/18/13
          begin                                                                 // CodeCR538 JRL 11/18/13
            if SendVVA.vvaWSC.IsConfirmedToSend(patientName) then               // CodeCR538 JRL 11/18/13
              SendFile := TRUE                                                  // CodeCR538 JRL 11/18/13
            else                                                                // CodeCR538 JRL 11/18/13
              SendFile := FALSE                                                 // CodeCR538 JRL 11/18/13
          end;                                                                  // CodeCR538 JRL 11/18/13

          if SendFile then                                                      // CodeCR538 JRL 11/18/13
          begin                                                                 // CodeCR538 JRL 11/15/13
            {Get Local Station name and number}
            localStation := GetDivision(False, RPCBroker1);

            {Populate fields required to transmit to the Virtual VA web
            service}
            with SendVVA.vvaWSC.VVAReport do
            begin
              VVADoc.DocCategory := DOC_CATEGORY;
              VVADoc.Source := DOC_SOURCE;
              buffer := Piece(localStation, '^', 2) + ' (' + Piece(localStation, '^', 3) + ')';
              VVADoc.SourceComment := RemoveSpecialCharacters(buffer);          // CodeCR522 JRL 11/21/13
              VVADoc.User := RPCBroker1.User.Name;
              VVADoc.URL := FVirtualVAURL;
              VVADoc.SecToken := FVirtualVAToken;
              {Use C&P Document type and Exam as subject for C&P Exams}
              if (Sender = frmExamDetails) then
              begin
                VVADoc.DocType := DOC_TYPE_CP;
                buffer := frmExamDetails.FMExamType.Text;
                VVADoc.Subject := RemoveSpecialCharacters(buffer);              // CodeCR522 JRL 11/21/13
              end
              else if Page95Control1.ActivePage = TabDOD then                   // CodeCR425 JRL 10/19/12
              begin                                                             // CodeCR425 JRL 10/19/12
                VVADoc.DocType := DOC_TYPE_DOD;                                 // CodeCR425 JRL 10/19/12
                VVADoc.DocCategory := DOC_CATEGORY_DOD;                         // CodeCR425 JRL 10/19/12
                VVADoc.Subject := DOC_DOD_SUBJECT;                              // CodeCR425 JRL 10/19/12
                VVADoc.SourceComment := DOC_SOURCE_COMMENT_DOD;                 // CodeCR425 JRL 11/9/12
              end                                                               // CodeCR425 JRL 10/19/12
              else if (Sender = TIUSignForm) then                               // CodeCR539 JRL 09/27/13 C&P Exam Title
              begin                                                             // CodeCR539 JRL 09/27/13
                VVADoc.DocType := DOC_TYPE_CP;                                  // CodeCR539 JRL 09/27/13
                buffer := TIUSignForm.ParentExamTitle;                          // CodeCR522 JRL 11/21/13
                VVADoc.Subject := RemoveSpecialCharacters(buffer);              // CodeCR522 JRL 11/21/13
              end                                                               // CodeCR539 JRL 09/27/13
              else                                                              {Default to CAPRI (344) and 'Clinical Documents'}
              begin
                VVADoc.DocType := DOC_TYPE;
                VVADoc.Subject := DOC_SUBJECT;
              end;
            end;
            if VAUtils.ScreenReaderActive then                                  //508 compliance
              SendVVA.ActiveControl := SendVVA.edVirtualVATitle;
            SendVVA.ShowModal;
          end; {OKToSend}                                                       // CodeCR538 JRL 11/15/13
        end                                                                     {Does not exceed line count limit}
        else                                                                    {Exceeds line count limit}
        begin
          ShowMessageCAPRI('The document file contains '
            + SendVVA.vvaWSC.FormatByteSize(fileSizeBytes)
            + ', which exceeds the 15 MB'
            + ' maximum file size allowed.');
        end;
      end                                                                       {Report Text available}
      else                                                                      {NO Report Text available}
      begin
        ShowMessageCAPRI('No text to send to Virtual VA.');
      end;
    finally
      CleanupAfterReport(Sender);
    end;                                                                        {ReportOK}
  finally
    FreeAndNil(SendVVA);
    AnimateLogo(False);                                                         // rra 998063 change status back to ready
    StatusBarLoadPt.Caption := 'Ready.';                                        // rra 998063
    StatusBarLoadPt.Repaint;                                                    // rra 998063
    Application.Processmessages;                                                // rra 998063

  end;
end;

{========================================================================
 actFileTransmitVirtualVAUpdate
 This action handler disables Transmit to Virtual VA when the VistaWeb
 tab is the active tab or no Virtual VA URL is available.

 CodeCR353 - rpm 5/7/12
 ========================================================================}

procedure TfrmMain.actFileTransmitVirtualVAUpdate(Sender: TObject);
begin
  if (FVirtualVAURL = '') or
    (FVirtualVAToken = '') or
    (Page95Control1.ActivePage = TabVistAWeb) Then
    actFileTransmitVirtualVA.Enabled := False
  else
    actFileTransmitVirtualVA.Enabled := True;
end;

procedure TfrmMain.actHelpAboutExecute(Sender: TObject);
begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;
  frmAboutForm := TfrmAboutForm.Create(frmMain);
  frmAboutForm.button1.Font := Panel1.Font;
  frmAboutForm.button1.Height := Panel1.Height;
  frmAboutForm.button1.Top := frmAboutForm.height - panel1.height * 2 - 16;
  frmAboutForm.Top := 7 + frmMain.Top + ((frmMain.Height - frmAboutForm.Height) Div 2);
  frmAboutForm.Left := frmMain.Left + ((frmMain.Width - frmAboutForm.Width) Div 2);
  frmAboutForm.Edit1.Text := VersionUser;
  frmAboutForm.ShowModal;
  frmAboutForm.release;
  frmAboutForm := Nil;
end;

procedure TfrmMain.actHelpAboutUpdate(Sender: TObject);
begin
  If (GifImageVistaYellow.Visible = true) or (frmNewExam <> nil) or
    (frmViewExam <> nil) or (frmPatientList <> nil) then
    actHelpAbout.Enabled := false
  else
    actHelpAbout.Enabled := True;
end;

procedure TfrmMain.actHelpAuditUtilExecute(Sender: TObject);
Var
  tempstrserver, tempstrport: String;
  tempUserIEN: String;
Begin
  TempStrServer := Uppercase(RPCBroker1.ANUStrServer);
  TempStrPort := RPCBroker1.ANUStrPort;
  TempUserIEN := AuthorIEN;
  AuthorIEN := UserDUZHomeServer;

  ESSOConnecting := True;
  AuditInProgress := True;
  RPCBroker1.Connected := False;
  RPCBroker1.Server := RPCBroker1.ANUStrServerHome;
  RPCBroker1.ListenerPort := StrtoInt(RPCBroker1.ANUStrPortHome);
  //RPCBroker1.Connected := True;   BSE mod - rpm 1/8/09
  //If Not AuthorizedOption('DVBA CAPRI GUI AUDIT TRAIL') Then   BSE mod - rpm 1/8/09
  if not ConnectToServer('DVBA CAPRI GUI AUDIT TRAIL') then
  Begin
    ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI AUDIT TRAIL!"');
    application.terminate;
  End;
  ESSOConnecting := False;

  If ANURemoteProcedureCallInProgress = True Then
    exit;

  frmAuditTrail := TfrmAuditTrail.create(frmMain);
  frmAuditTrail.Show;
  frmAuditTrail.BringToFront;
  frmAuditTrail.Hide;

  ContextorChangeMessage := 'You are running an audit report.  If you continue, CAPRI will drop out of the clinical context.';
  CCOWBreakLink := True;
  frmAuditTrail.ShowModal;
  ContextorChangeMessage := '';
  CCOWBreakLink := False;

  frmAuditTrail.release;
  frmAuditTrail := Nil;

  //Connect back to remote here
  AuthorIEN := TempUserIEN;
  ESSOConnecting := True;
  RPCBroker1.Connected := False;
  RPCBroker1.Server := TempStrServer;
  RPCBroker1.ListenerPort := StrtoInt(TempStrPort);
  //RPCBroker1.Connected := True;  BSE mod - rpm 1/8/09
  //If Not AuthorizedOption('DVBA CAPRI GUI') Then  BSE mod - rpm 1/8/09
  if not ConnectToServer('DVBA CAPRI GUI') then
  Begin
    ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
    application.terminate;
  End;
  ESSOConnecting := False;
  AuditInProgress := False;
end;

procedure TfrmMain.actHelpAuditUtilUpdate(Sender: TObject);
begin
//FYI, this code will get triggered regardless of the state of THIS menu item,
//enabled, disabled, visible or not. The update events trigger for each menu option, in
//the order displayed, top - down. Thus, this code will work for all menus that fall
//under this one.
//UserFilemanCode should have been set when we connected

  If (ESSOVersion = True) and (frmPatientList = nil) and ((Pos('@', userfilemancode) > 0) Or
    (Pos('u', userfilemancode) > 0) Or (Pos('U', userfilemancode) > 0)) Then
  Begin
    actHelpCheckConnections.Visible := True;
    actHelpEditRemoteUser.Visible := True;
    actHelpEditPatientLists.Visible := True;
    actHelpConsReports.Visible := True;
    actHelpAuditUtil.Visible := True;
  End
  else
  begin
    actHelpCheckConnections.Visible := false;
    //N8.Visible := false;
    actHelpEditRemoteUser.Visible := false;
    actHelpEditPatientLists.Visible := false;
    actHelpConsReports.Visible := false;
    actHelpAuditUtil.Visible := false;
  end;
end;

procedure TfrmMain.actHelpCAPRITrainingExecute(Sender: TObject);
begin
  //CAPRI_CodeCR95  - jcs - 05/20/2010
  if not CallRPC(RPCBroker1, 'DVBAB GET URL', ['2'], nil) then
    exit;

  If RPCBroker1.Results.Count > 0 Then
  Begin
    xHyperlinkLabel1.targetURL := RPCBroker1.Results[0];
    xHyperlinkLabel1.Navigate;
  End;
end;

procedure TfrmMain.actHelpCheckConnectionsExecute(Sender: TObject);
Var
  TempStrServer: String;
  TempStrPort: Integer;
  RemoteDataTimer: Boolean;
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;
  RemoteDataTimer := TimerRemoteData.Enabled;
  TimerRemoteData.Enabled := false;
  timeouttimer.enabled := false;

  //Store connection date
  TempStrServer := RPCBroker1.Server;
  TempStrPort := RPCBroker1.ListenerPort;

  frmCheckRemoteConnections := TfrmCheckRemoteConnections.Create(frmMain);
  ContextorChangeMessage := 'You are checking remote connections.  If you continue, CAPRI will drop out of the clinical context.';
  CCOWBreakLink := True;
  frmCheckRemoteConnections.Showmodal;                                          // Check for cancel button and exit
  ContextorChangeMessage := '';
  CCOWBreakLink := False;

  //Reconnect to original host
  RPCBroker1.Server := TempStrServer;
  RPCBroker1.ListenerPort := TempStrPort;

  If Not ConnectToServer('DVBA CAPRI GUI') Then
  Begin
    ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
    application.terminate;
  End;
  If RPCBroker1.Connected = False Then
  Begin
    ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
    application.terminate;
  End;

  frmCheckRemoteConnections.release;
  frmCheckRemoteConnections := Nil;
  timeouttimer.enabled := true;
  TimerRemoteData.Enabled := RemoteDataTimer;
end;

procedure TfrmMain.actHelpConsReportsExecute(Sender: TObject);
Var
  TempStrServer: String;
  TempStrPort: Integer;
  RemoteDataTimer: Boolean;
Begin

  If ANURemoteProcedureCallInProgress = True Then
    exit;
  RemoteDataTimer := TimerRemoteData.Enabled;
  TimerRemoteData.Enabled := false;
  timeouttimer.enabled := false;

  //Store connection data
  TempStrServer := RPCBroker1.Server;
  TempStrPort := RPCBroker1.ListenerPort;

  frmRemoteReports := TfrmRemoteReports.Create(frmMain);
  ContextorChangeMessage := 'You are running consolidated reports.  If you continue, CAPRI will drop out of the clinical context.';
  CCOWBreakLink := True;
  frmRemoteReports.Showmodal;                                                   // Check for cancel button and exit
  ContextorChangeMessage := '';
  CCOWBreakLink := False;

  ESSOConnecting := True;
  //Reconnect to original host
  RPCBroker1.Server := TempStrServer;
  RPCBroker1.ListenerPort := TempStrPort;

  If Not ConnectToServer('DVBA CAPRI GUI') Then
  Begin
    ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
    application.terminate;
  End;
  If RPCBroker1.Connected = False Then
  Begin
    ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
    application.terminate;
  End;
  ESSOConnecting := False;

  frmRemoteReports.release;
  frmRemoteReports := Nil;
  timeouttimer.enabled := true;
  TimerRemoteData.Enabled := RemoteDataTimer;
end;

procedure TfrmMain.actHelpEditPatientListsExecute(Sender: TObject);
Var
  TempStrServer: String;
  TempStrPort: Integer;
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;

  timeouttimer.enabled := false;

  ESSOConnecting := True;

  TempStrServer := RPCBroker1.Server;
  TempStrPort := RPCBroker1.ListenerPort;
  RPCBroker1.Connected := False;
  RPCBroker1.Server := homeserver;
  RPCBroker1.ListenerPort := StrToInt(homeport);
  //RPCBroker1.Connected := True;  BSE mod - rpm 1/8/09

  If Not ConnectToServer('DVBA CAPRI GUI') Then
  Begin
    ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
    application.terminate;
  End;
  If RPCBroker1.Connected = False Then
  Begin
    ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
    application.terminate;
  End;
  ESSOConnecting := False;

  If Not assigned(frmEditPatientLists) Then
    frmEditPatientLists := tfrmEditPatientLists.Create(frmmain);

  frmEditPatientLists.Timer1.Enabled := True;
  ContextorChangeMessage := 'You are editing user site access.  If you continue, CAPRI will drop out of the clinical context.';

  CCOWBreakLink := True;

  frmEditPatientLists.Showmodal;

  ContextorChangeMessage := '';
  CCOWBreakLink := False;

  ESSOConnecting := True;
  RPCBroker1.Connected := False;
  RPCBroker1.Server := TempStrServer;
  RPCBroker1.ListenerPort := TempStrPort;
  //RPCBroker1.Connected := True;  BSE mod - rpm 1/8/09

  If Not ConnectToServer('DVBA CAPRI GUI') Then
  Begin
    ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
    application.terminate;
  End;
  If RPCBroker1.Connected = False Then
  Begin
    ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
    application.terminate;
  End;

  ESSOConnecting := False;
  timeouttimer.enabled := true;
end;

procedure TfrmMain.actHelpEditRemoteUserExecute(Sender: TObject);
Var
  TempStrServer: String;
  TempStrPort: Integer;
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;
  frmRemoteUserSitesEditor := tfrmRemoteUserSitesEditor.Create(frmmain);
  timeouttimer.enabled := false;

  //Store connection data
  TempStrServer := RPCBroker1.Server;
  TempStrPort := RPCBroker1.ListenerPort;
  ESSOConnecting := True;
  RPCBroker1.Connected := False;
  RPCBroker1.Server := homeserver;
  RPCBroker1.ListenerPort := StrToInt(homeport);
  //RPCBroker1.Connected := True;   BSE mod - rpm 1/8/09
  If Not ConnectToServer('DVBA CAPRI GUI') Then
  Begin
    ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
    application.terminate;
  End;
  If RPCBroker1.Connected = False Then
  Begin
    ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
    application.terminate;
  End;
  ESSOConnecting := False;

  frmCheckRemoteConnections := TfrmCheckRemoteConnections.Create(frmMain);
  frmRemoteUserSitesEditor.Timer1.Enabled := True;
  ContextorChangeMessage := 'You are editing user site access.  If you continue, CAPRI will drop out of the clinical context.';
  CCOWBreakLink := True;
  frmRemoteUserSitesEditor.Showmodal;
  ContextorChangeMessage := '';
  CCOWBreakLink := False;

  ESSOConnecting := True;
  //Reconnect to original host
  RPCBroker1.Connected := False;
  RPCBroker1.Server := TempStrServer;
  RPCBroker1.ListenerPort := TempStrPort;
  //RPCBroker1.Connected := True;  BSE mod - rpm 1/8/09

  If Not ConnectToServer('DVBA CAPRI GUI') Then
  Begin
    ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
    application.terminate;
  End;
  If RPCBroker1.Connected = False Then
  Begin
    ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
    application.terminate;
  End;
  ESSOConnecting := False;

  timeouttimer.enabled := true;
  frmRemoteUserSitesEditor.Release;
  frmRemoteUserSitesEditor := Nil;
end;

procedure TfrmMain.actHelpEdtCancelReasonsExecute(Sender: TObject);             // CodeCR698 - RPK 3/24/2015
begin
  frmEdtCancelReasons := TfrmEdtCancelReasons.Create(Application);
  try
    frmEdtCancelReasons.ShowModal;
  finally
    FreeAndNil(frmEdtCancelReasons);
  end;
end;                                                                            // CodeCR698 - RPK 3/24/2015

{ procedure TfrmMain.actHelpEdtCancelReasonsUpdate(Sender: TObject);              // CodeCR698 - RPK 3/24/2015
var
  bret: Boolean;
begin
  if IsPatchInstalled('DVBA*2.7*190') then begin
    bret := IsUserKey('DVBA CAPRI EXAMCANC');
    actHelpEdtCancelReasons.Enabled := bret;
    actHelpEdtCancelReasons.Visible := bret;
  end;
end; }                                                                           // CodeCR698 - RPK 3/24/2015

procedure TfrmMain.actHelpEdtInsuffReasonsExecute(Sender: TObject);             // CodeCR698 - RPK 3/30/2015
begin
  frmEdtInsuffReasons := TfrmEdtInsuffReasons.Create(Application);
  try
    frmEdtInsuffReasons.ShowModal;
  finally
    FreeAndNil(frmEdtInsuffReasons);
  end;
end;                                                                            // CodeCR698 - RPK 3/30/2015

{ procedure TfrmMain.actHelpEdtInsuffReasonsUpdate(Sender: TObject);              // CodeCR698 - RPK 3/30/2015
var
  bret: Boolean;
begin
  if IsPatchInstalled('DVBA*2.7*190') then begin
    bret := IsUserKey('DVBA CAPRI EXAMINSUFF');
    actHelpEdtInsuffReasons.Enabled := bret;
    actHelpEdtInsuffReasons.Visible := bret;
  end;
end; }                                                                            // CodeCR698 - RPK 3/30/2015

procedure TfrmMain.actHelpRPCBrokerHistoryExecute(Sender: TObject);
begin
  frmBrokerHistoryBuffer.showmodal;
end;

procedure TfrmMain.actHelpRPCBrokerHistoryUpdate(Sender: TObject);
begin
  If (Pos('@', userfilemancode) > 0) then
    actHelpRPCBrokerHistory.visible := true
  else
    actHelpRPCBrokerHistory.visible := false;
end;

procedure TfrmMain.ActionMainMenuBar1EnterMenuLoop(Sender: TObject);
begin
  {The following is a workaround for a couple of defects in the TActionMainMenuBar.
   When the Windows setting is checkd to 'Hide underline letters for keyboard
   naviation until I press the Alt key' (windows XP), for some reason, when the
   mouse is used to navigate the menu, any menu option that contains an '&', such
   as 'C&P', displays as 'CP_'. When using the keyboard, everything is fine.
   The obvious solution was to enable PersistentHotKeys on the control, to always
   force the shortcut keys to display, which bypasses the defect. However,
   PersistentHotKeys keeps getting disabled at run time after each display of a
   menu. So, the workaround to both problems is to keep resetting PersistentHotKeys
   to true each time the menu is accessed, now when the Windows option is checked,
   the '&' in a menu option displays as it is suppose to via th mouse, AND, the
   shortcut keys only display when the ALT key s pressed (go figured?)
   jcs - CAPRI_CodeCR60
  }
  ActionMainMenuBar1.PersistentHotKeys := True;
end;

procedure TfrmMain.actPopEditCheckSpellingExecute(Sender: TObject);
Var
  msg: TMsg;
  handled: Boolean;
Begin
  handled := false;
  msg.message := WM_KEYUP;
  msg.wParam := VK_F7;
  AppMessage(msg, handled);

end;

procedure TfrmMain.actPopEditCopyExecute(Sender: TObject);
begin
  Sender := screen.ActiveControl;

  If Sender.ClassType = TMemo Then
  Begin
    (Sender As TMemo).CopyToClipboard;
  End
  Else
    If Sender.ClassType = TEdit Then
    Begin
      (Sender As TEdit).CopyToClipboard;
    End
    Else
      If Sender.ClassType = TRichEdit Then
      Begin
        (Sender As TRichEdit).CopyToClipboard;
      End
      Else
        Sleep(1);                                                               //Showmessage('Unknown class type: '+Sender.ClassName);
end;

procedure TfrmMain.actPopEditCutExecute(Sender: TObject);
begin
  Sender := screen.ActiveControl;

  If Sender.ClassType = TMemo Then
  Begin
    (Sender As TMemo).CutToClipboard;
  End
  Else
    If Sender.ClassType = TEdit Then
    Begin
      (Sender As TEdit).CutToClipboard;
    End
    Else
      If Sender.ClassType = TRichEdit Then
      Begin
        (Sender As TRichEdit).CutToClipboard;
      End
      Else
        Sleep(1);                                                               //Showmessage('Unknown class type: '+Sender.ClassName);
end;

procedure TfrmMain.actPopEditLoadExamExecute(Sender: TObject);
Var
  x: integer;
  date1, date2, date3: String;
Begin
  frmExamRequestComments := TfrmExamRequestComments.create(pncsform);

  { Get AMIE Exam Requests}
  frmExamRequestComments.FMExamRequestLister1.PartList.Clear;
  frmExamRequestComments.FMExamRequestLister1.PartList.Add(PNCSForm.xPatientIENS.Caption);
  frmExamRequestComments.FMExamRequestListbox.GetList;
  // Make sure data is correct for PatientIEN
  If frmExamRequestComments.FMExamRequestListbox.Items.Count > 0 Then
    For x := frmExamRequestComments.FMExamRequestListbox.Items.Count - 1 Downto 0 Do
    Begin
      If Pos(PNCSForm.xPatientIENS.Caption + '  ', frmExamRequestComments.FMExamRequestListbox.Items[x]) <> 1 Then
        frmExamRequestComments.FMExamRequestListbox.Items.Delete(x);
    End;
  // Reformat data
  // Don't show complete or cancelled exams
  If frmExamRequestComments.FMExamRequestListbox.Items.Count > 0 Then
    For x := frmExamRequestComments.FMExamRequestListbox.Items.Count - 1 Downto 0 Do
    Begin
      frmExamRequestComments.FMExamRequestListbox.Items[x] := Copy(frmExamRequestComments.FMExamRequestListbox.Items[x], Pos('  ', frmExamRequestComments.FMExamRequestListbox.Items[x]) + 4, 255);
        // Strip patient IEN;
      Date1 := Copy(frmExamRequestComments.FMExamRequestListbox.Items[x], 1, Pos('  ', frmExamRequestComments.FMExamRequestListbox.Items[x]) - 1);
      frmExamRequestComments.FMExamRequestListbox.Items[x] := Copy(frmExamRequestComments.FMExamRequestListbox.Items[x], Pos('  ', frmExamRequestComments.FMExamRequestListbox.Items[x]) + 4, 500);
      Date2 := Copy(frmExamRequestComments.FMExamRequestListbox.Items[x], 1, Pos('  ', frmExamRequestComments.FMExamRequestListbox.Items[x]) - 1);
      frmExamRequestComments.FMExamRequestListbox.Items[x] := Copy(frmExamRequestComments.FMExamRequestListbox.Items[x], Pos('  ', frmExamRequestComments.FMExamRequestListbox.Items[x]) + 4, 500);
      Date3 := Copy(frmExamRequestComments.FMExamRequestListbox.Items[x], 1, 254);
      If Date2 <> '' Then
        frmExamRequestComments.FMExamRequestListbox.Items[x] := Copy(FMDateTimeConvert(Date1) + '                    ', 1, 20) + '  |  ' + FMDateTimeConvert(Date2)
      Else
        If Date3 <> '' Then
          frmExamRequestComments.FMExamRequestListbox.Items[x] := Copy(FMDateTimeConvert(Date1) + '                    ', 1, 20) + '  |  ' + FMDateTimeConvert(Date3) + ' [EXAM CANCELED]'
        Else
          frmExamRequestComments.FMExamRequestListbox.Items[x] := Copy(FMDateTimeConvert(Date1) + '                    ', 1, 20) + '    ';
      //Fix single digit date and move over
      If Copy(frmExamRequestComments.FMExamRequestListbox.Items[x], 6, 1) = ',' Then
        frmExamRequestComments.FMExamRequestListbox.Items[x] := Copy(frmExamRequestComments.FMExamRequestListbox.Items[x], 1, 4) + ' ' + Copy(frmExamRequestComments.FMExamRequestListbox.Items[x], 5,
          15) + Copy(frmExamRequestComments.FMExamRequestListbox.Items[x], 21, 99);
      If (Date2 <> '') Or (Date3 <> '') Then
        frmExamRequestComments.FMExamRequestListbox.Items.Delete(x);
    End;

  If frmExamRequestComments.FMExamRequestListbox.Items.Count > 0 Then
  Begin
    frmExamRequestComments.FMExamRequestListbox.ItemIndex := 0;
    frmExamRequestComments.FMExamRequestListboxClick(Application);
  End;

  If frmExamRequestComments.ShowModal = mrOK Then
  Begin
    clipboard.SetTextBuf(pchar(frmExamRequestComments.FMCommentsMemo.Text));
    Sender := screen.ActiveControl;
    If Sender.ClassType = TMemo Then
    Begin
      (Sender As TMemo).PasteFromClipboard;
    End
    Else
      If Sender.ClassType = TEdit Then
      Begin
        (Sender As TEdit).PasteFromClipboard;
      End
      Else
        If Sender.ClassType = TRichEdit Then
        Begin
          (Sender As TRichEdit).PasteFromClipboard;
        End
        Else
          Showmessage('Cannot load the comments into this control class type: ' + Sender.ClassName);
  End;

  frmExamRequestComments.Release;

end;

procedure TfrmMain.actPopEditPasteExecute(Sender: TObject);
begin
  Sender := screen.ActiveControl;

  If Sender.ClassType = TMemo Then
  Begin
    (Sender As TMemo).PasteFromClipboard;
  End
  Else
    If Sender.ClassType = TEdit Then
    Begin
      (Sender As TEdit).PasteFromClipboard;
    End
    Else
      If Sender.ClassType = TRichEdit Then
      Begin
        (Sender As TRichEdit).PasteFromClipboard;
      End
      Else
        Sleep(1);                                                               //Showmessage('Unknown class type: '+Sender.ClassName);
end;

procedure TfrmMain.actPopEditSelectAllExecute(Sender: TObject);
begin
  Sender := screen.ActiveControl;

  If Sender.ClassType = TMemo Then
  Begin
    (Sender As TMemo).SelectAll;
  End
  Else
    If Sender.ClassType = TEdit Then
    Begin
      (Sender As TEdit).SelectAll;
    End
    Else
      If Sender.ClassType = TRichEdit Then
      Begin
        (Sender As TRichEdit).SelectAll;
      End
      Else
        Sleep(1);                                                               //Showmessage('Unknown class type: '+Sender.ClassName);
end;

procedure TfrmMain.actPopEditUndoExecute(Sender: TObject);
begin
  Sender := screen.ActiveControl;

  If Sender.ClassType = TMemo Then
  Begin
    (Sender As TMemo).Undo;
  End
  Else
    If Sender.ClassType = TEdit Then
    Begin
      (Sender As TEdit).Undo;
    End
    Else
      If Sender.ClassType = TRichEdit Then
      Begin
        (Sender As TRichEdit).Undo;
      End
      Else
        Sleep(1);                                                               //Showmessage('Unknown class type: '+Sender.ClassName);
end;

procedure TfrmMain.actPopEditUndoUpdate(Sender: TObject);
Var
  tempcontrol: tcontrol;
Begin
  tempcontrol := Nil;
  Sender := screen.ActiveControl;

  //PopupEditmenu.DrawModule := BcCustomDrawModule1;
  If Sender.ClassType = TMemo Then
  Begin
  End
  Else
    If Sender.ClassType = TEdit Then
    Begin
    End
    Else
      If Sender.ClassType = TRichEdit Then
      Begin
      End
      Else
      Begin
        actPopEditCut.Enabled := False;
        actPopEditCopy.Enabled := False;
        actPopEditDelete.Enabled := False;
        actPopEditSelectAll.Enabled := False;
        actPopEditCheckSpelling.Enabled := False;
        actPopEditPaste.Enabled := False;
        actPopEditUndo.Enabled := False;
        actPopEditLoadExam.Enabled := False;
        exit;
      End;

  Try
    actPopEditCut.Enabled := True;
    actPopEditCopy.Enabled := True;
    actPopEditDelete.Enabled := True;
    actPopEditSelectAll.Enabled := True;
    actPopEditCheckSpelling.Enabled := True;
    actPopEditPaste.Enabled := True;
    actPopEditUndo.Enabled := True;
    actPopEditLoadExam.Enabled := True;

    If clipboard.AsText = '' Then
      actPopEditPaste.Enabled := False;

    tempcontrol := FindDragTarget(mouse.cursorpos, true);

    If Not assigned(tempcontrol) Then
      Exit;

    If ((Assigned(tempcontrol.owner)) And (uppercase(tempcontrol.owner.name) = 'XPANELBASECONTROL')) Then // ET 060531
      actPopEditLoadExam.Enabled := True
    Else
      actPopEditLoadExam.Enabled := False;

    If tempControl.ClassType = TMemo Then
    Begin
      If (tempControl As TMemo).Seltext = '' Then
      Begin
        actPopEditCut.Enabled := False;
        actPopEditCopy.Enabled := False;
        actPopEditDelete.Enabled := False;
      End;
      If (tempControl As TMemo).Text = '' Then
        actPopEditSelectAll.Enabled := False;
      If (tempControl As TMemo).Text = '' Then
        actPopEditCheckSpelling.Enabled := False;
    End
    Else
      If tempControl.ClassType = TEdit Then
      Begin
        If (tempControl As TEdit).Seltext = '' Then
        Begin
          actPopEditCut.Enabled := False;
          actPopEditCopy.Enabled := False;
          actPopEditDelete.Enabled := False;
        End;
        If (tempControl As TEdit).Text = '' Then
          actPopEditSelectAll.Enabled := False;
        If (tempControl As TEdit).Text = '' Then
          actPopEditCheckSpelling.Enabled := False;
      End
      Else
        If sender.classtype = TPopupActionBar Then
        Begin
          If (tempControl As TRichEdit).Seltext = '' Then
          Begin
            actPopEditCut.Enabled := False;
            actPopEditCopy.Enabled := False;
            actPopEditDelete.Enabled := False;
          End;
          If (tempControl As TRichEdit).SelText = '' Then
            actPopEditSelectAll.Enabled := False;
          If (tempControl As TRichEdit).Text = '' Then
            actPopEditCheckSpelling.Enabled := False
          Else
            actPopEditCheckSpelling.Enabled := True;

          actPopEditSelectAll.Enabled := True;

          If (tempControl As TRichEdit).ReadOnly = True Then
          Begin
            actPopEditCut.Enabled := False;
            actPopEditCopy.Enabled := False;
            actPopEditDelete.Enabled := False;
            actPopEditSelectAll.Enabled := False;
            actPopEditCheckSpelling.Enabled := False;
            actPopEditPaste.Enabled := False;
          End;

        End
        Else
  Except
    On E: Exception Do
      ShowMessage(tempControl.Name + ' has issues');
  End;
end;

procedure TfrmMain.actPopTempDeleteExecute(Sender: TObject);
begin
  ButtonIPRDeleteClick(Application);
end;

procedure TfrmMain.actPopTempDeleteUpdate(Sender: TObject);
begin
  If ListBoxIPR1.ItemIndex = -1 Then
  Begin
    actPopTempDelete.Enabled := False;
    actPopTempTogNew.Enabled := False;
    actPopTempTogGreen.Enabled := False;
    actPopTempTogExclamation.Enabled := False;
  End
  Else
  Begin
    actPopTempDelete.Enabled := True;
    actPopTempTogNew.Enabled := True;
    actPopTempTogGreen.Enabled := True;
    actPopTempTogExclamation.Enabled := True;
  End;
  FMListboxIPR1.ItemIndex := FMListBoxIPR1.Items.Count - 1 - ListBoxIPR1.ItemIndex;
end;

procedure TfrmMain.actPopTempTogExclamationExecute(Sender: TObject);
Var
  temptext: String;
  item: integer;
  tempstring: String;
  tempID: String;
Begin
  tempID := '';
  item := FMListBoxIPR1.ItemIndex;
  temptext := FMListBoxIPR1.Items[item];
  If TempText[1] = '*' Then
  Begin
    TempID := '*';
    TempText := Copy(TempText, 2, length(temptext));
  End;
  If (TempText[37] = 'Y') Then
  Begin
    tempstring := 'N';
  End
  Else
  Begin
    tempstring := 'Y';
  End;
  temptext[37] := tempstring[1];
  FMListBoxIPR1.Items[item] := tempid + temptext;
  ListBoxIPR1.Items[ListBoxIPR1.Items.Count - item - 1] := tempid + temptext;
  ListBoxIPR1DrawItem(ListBoxIPR1, ListBoxIPR1.ItemIndex, ListBoxIPR1.ItemRect(ListBoxIPR1.ItemIndex), [odSelected]);
  If tempstring = 'Y' Then
    tempstring := '1'
  Else
    tempstring := '0';
  frmmain.fmfiler1.AddFDA('396.17', FMListBoxIPR1.GetSelectedRecord.IEN, '21', tempstring);
  If Not frmmain.fmfiler1.Update Then
  Begin
    frmmain.fmfiler1.DisplayErrors;
    ShowMessageCAPRI('There was an error setting the flag.');
  End;
end;

procedure TfrmMain.actPopTempTogGreenExecute(Sender: TObject);
Var
  temptext: String;
  item: integer;
  tempstring: String;
  tempID: String;
Begin
  tempID := '';
  item := FMListBoxIPR1.ItemIndex;
  temptext := FMListBoxIPR1.Items[item];
  If TempText[1] = '*' Then
  Begin
    TempID := '*';
    TempText := Copy(TempText, 2, length(temptext));
  End;
  If (TempText[36] = 'Y') Then
  Begin
    tempstring := 'N';
  End
  Else
  Begin
    tempstring := 'Y';
  End;
  temptext[36] := tempstring[1];
  FMListBoxIPR1.Items[item] := tempid + temptext;
  ListBoxIPR1.Items[ListBoxIPR1.Items.Count - item - 1] := tempid + temptext;
  ListBoxIPR1DrawItem(ListBoxIPR1, ListBoxIPR1.ItemIndex, ListBoxIPR1.ItemRect(ListBoxIPR1.ItemIndex), [odSelected]);
  If tempstring = 'Y' Then
    tempstring := '1'
  Else
    tempstring := '0';
  frmmain.fmfiler1.AddFDA('396.17', FMListBoxIPR1.GetSelectedRecord.IEN, '20', tempstring);
  If Not frmmain.fmfiler1.Update Then
  Begin
    frmmain.fmfiler1.DisplayErrors;
    ShowMessageCAPRI('There was an error setting the flag.');
  End;
end;

procedure TfrmMain.actPopTempTogNewExecute(Sender: TObject);
Var
  temptext: String;
  item: integer;
  tempchar: char;
  tempid: String;
Begin
  tempid := '';
  item := FMListBoxIPR1.ItemIndex;
  temptext := FMListBoxIPR1.Items[item];
  If TempText[1] = '*' Then
  Begin
    TempID := '*';
    TempText := Copy(TempText, 2, length(temptext));
  End;
  If (TempText[35] = 'Y') Or (TempText[35] = ' ') Or (TempText[35] = '') Then
  Begin
    tempchar := 'N';
  End
  Else
  Begin
    tempchar := 'Y';
  End;
  temptext[35] := tempchar;
  FMListBoxIPR1.Items[item] := tempid + temptext;
  ListBoxIPR1.Items[ListBoxIPR1.Items.Count - item - 1] := tempid + temptext;
  ListBoxIPR1DrawItem(ListBoxIPR1, ListBoxIPR1.ItemIndex, ListBoxIPR1.ItemRect(ListBoxIPR1.ItemIndex), [odSelected]);
  If tempchar = 'Y' Then
    tempchar := '1'
  Else
    tempchar := '0';
  frmmain.fmfiler1.AddFDA('396.17', FMListBoxIPR1.GetSelectedRecord.IEN, '19', tempchar);
  If Not frmmain.fmfiler1.Update Then
  Begin
    frmmain.fmfiler1.DisplayErrors;
    ShowMessageCAPRI('There was an error setting the flag.');
  End;
end;


procedure TfrmMain.actToolsAMIEExecute(Sender: TObject);
begin
  //CAPRI_CodeCR95  - jcs - 05/20/2010
  if not CallRPC(RPCBroker1, 'DVBAB GET URL', ['1'], nil) then
    exit;

  If RPCBroker1.Results.Count > 0 Then
  Begin
    xHyperlinkLabel1.targetURL := RPCBroker1.Results[0];
    // Override bad URL in VistA code for the time being
    If xHyperlinkLabel1.targetURL = 'http://152.124.238.193/bl/21/rating/Medical/exams/index.htm' Then
      xHyperlinkLabel1.targetURL := 'http://serv.domain.ext/bl/21/rating/Medical/exams/index.htm';
    xHyperlinkLabel1.Navigate;
  End;
end;

procedure TfrmMain.actToolsBringExamToFrontExecute(Sender: TObject);
begin
  PNCSForm.WindowState := wsNormal;
  PNCSForm.BringToFront;
end;

procedure TfrmMain.actToolsBringExamToFrontUpdate(Sender: TObject);
begin
  if (PNCSForm <> nil) then
    actToolsBringExamToFront.Enabled := True
  else
    actToolsBringExamToFront.Enabled := False;
end;

procedure TfrmMain.actToolsChangeAddressExecute(Sender: TObject);
Var
  tempstrserver, tempstrport: String;
  tempaddress: String;
Begin
  If EssoVersion = False Then
  Begin
    {Get User E-Mail Address on Local Server}
    RPCBroker1.RemoteProcedure := 'DVBAB MAIL INIT';
    RPCBrokerCall;
    Try
      RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        AnimateLogo(False);
        StatusBarLoadPt.Caption := 'RPC DVBAB MAIL INIT could not be accessed!';
        StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('DVBAB MAIL INIT could not be accessed!');
      End;
    End;

    //Modify Dialog For Local System Forwarding Info
    frmForwardingAddress := TfrmForwardingAddress.Create(frmMain);
    frmForwardingAddress.Edit1.text := localemailaddress;

    //jcs - this doesn't make too much sense, when you exit and renenter CAPRI, this menu option
    //will be enabled again? Likewise, there are a couple of other events that will enable the
    //men also, and LocalEmailAddress may be changed below also?

    //If LocalEmailAddress = '' Then
    //  ChangeForwardingAddress1.Enabled := False;

    frmForwardingAddress.Edit1.text := 'NONE SPECIFIED';
    frmForwardingAddress.RadioButton3.Checked := True;
    frmForwardingAddress.RadioButton1.Caption := lowercase(Piece(RPCBroker1.Results[0], '^', 1));
    frmForwardingAddress.label4.Visible := False;
    frmForwardingAddress.ShowModal;
    If frmForwardingAddress.RadioButton3.Checked = True Then
    Begin
      frmForwardingAddress.Release;
      frmForwardingAddress := Nil;
      exit;
    End;
    If frmForwardingAddress.RadioButton1.Checked = True Then
    Begin
      // Use home server address
      localemailaddress := frmForwardingAddress.radiobutton1.caption
    End;
    If frmForwardingAddress.RadioButton2.Checked = True Then
    Begin
      // Use specified e-mail address
      localemailaddress := frmForwardingAddress.editOtherEmailAddress.text;
    End;
    If frmForwardingAddress.RadioButton4.Checked = True Then
    Begin
      localemailaddress := '';
    End;
    // Update .151 field next
    FMFiler2.AddFDA('200', AuthorIEN, '.151', lowercase(localemailaddress));
    If Not fmfiler2.Update Then
    Begin
      fmfiler2.DisplayErrors;
    End;
    frmForwardingAddress.Release;
    frmForwardingAddress := Nil;
    exit;
  End;
  If EssoVersion = True Then
  Begin
    //Connect to Home Server
    TempStrServer := Uppercase(RPCBroker1.ANUStrServer);
    TempStrPort := RPCBroker1.ANUStrPort;
    RPCBroker1.Connected := False;
    RPCBroker1.Server := RPCBroker1.ANUStrServerHome;
    RPCBroker1.ListenerPort := StrtoInt(RPCBroker1.ANUStrPortHome);
    AuditInProgress := True;
    //RPCBroker1.Connected := True;  BSE mod - rpm 1/8/09
    //If Not AuthorizedOption('DVBA CAPRI GUI') Then  BSE mod - rpm 1/8/09
    if not ConnectToServer('DVBA CAPRI GUI') then
    Begin
      ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
      application.terminate;
    End;
    RPCBroker1.RemoteProcedure := 'DVBAB MAIL INIT';
    RPCBrokerCall;
    Try
      RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        AnimateLogo(False);
        StatusBarLoadPt.Caption := 'RPC DVBAB MAIL INIT could not be accessed!';
        StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('DVBAB MAIL INIT could not be accessed!');
      End;
    End;
    tempaddress := lowercase(Piece(RPCBroker1.Results[0], '^', 1));

    //Connect back to local server
    RPCBroker1.Connected := False;
    RPCBroker1.Server := TempStrServer;
    RPCBroker1.ListenerPort := StrtoInt(TempStrPort);
    //RPCBroker1.Connected := True;  BSE mod - rpm 1/8/09
    //If Not AuthorizedOption('DVBA CAPRI GUI') Then  BSE mod - rpm 1/8/09
    if not ConnectToServer('DVBA CAPRI GUI') then
    Begin
      ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
      application.terminate;
    End;

    AuditInProgress := False;

    //Modify Dialog For Remote System Forwarding
    frmForwardingAddress := TfrmForwardingAddress.Create(frmMain);
    frmForwardingAddress.Edit1.text := localemailaddress;
    frmForwardingAddress.RadioButton4.Visible := False;
    frmForwardingAddress.RadioButton3.Checked := True;
    frmForwardingAddress.RadioButton1.Caption := tempaddress;
    frmForwardingAddress.ShowModal;
    If frmForwardingAddress.RadioButton3.Checked = True Then
    Begin
      frmForwardingAddress.Release;
      frmForwardingAddress := Nil;
      exit;
    End;
    If frmForwardingAddress.RadioButton1.Checked = True Then
    Begin
      // Use home server address
      localemailaddress := frmForwardingAddress.radiobutton1.caption
    End;
    If frmForwardingAddress.RadioButton2.Checked = True Then
    Begin
      // Use specified e-mail address
      localemailaddress := frmForwardingAddress.editOtherEmailAddress.text;
    End;
    // Update .151 field next
    FMFiler2.AddFDA('200', AuthorIEN, '.151', lowercase(localemailaddress));
    Try
      If Not fmfiler2.Update Then
      Begin
        fmfiler2.DisplayErrors;
      End;
      ShowMessageCAPRI('Remote e-mail address for this system has been' + char(13) + 'updated to match your home server preference:' + char(13) + localemailaddress);
    Except
      Begin
        ShowmessageCAPRI('Couldn''t set remote e-mail address on this system.');
        If RPCBroker1.Connected = False Then
        Begin
          ShowmessageCAPRI('Not connected to a server due to data transmission failure.  Exiting application.');
          application.Terminate;
          application.terminate;
        End;
      End;
    End;
    //Now update home server too
    TempStrServer := Uppercase(RPCBroker1.ANUStrServer);
    TempStrPort := RPCBroker1.ANUStrPort;
    AuditInProgress := True;
    RPCBroker1.Connected := False;
    RPCBroker1.Server := RPCBroker1.ANUStrServerHome;
    RPCBroker1.ListenerPort := StrtoInt(RPCBroker1.ANUStrPortHome);
    //RPCBroker1.Connected := True;  BSE mod - rpm 1/8/09
    //If Not AuthorizedOption('DVBA CAPRI GUI') Then  BSE mod - rpm 1/8/09
    if not ConnectToServer('DVBA CAPRI GUI') then
    Begin
      ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
      application.terminate;
    End;
    // Update .151 field
    FMFiler2.AddFDA('200', UserDUZHomeServer, '.151', lowercase(localemailaddress));
    If Not fmfiler2.Update Then
    Begin
      fmfiler2.DisplayErrors;
    End;
    homeemailaddress := localemailaddress;
    // Connect back to local server
    RPCBroker1.Connected := False;
    RPCBroker1.Server := TempStrServer;
    RPCBroker1.ListenerPort := StrtoInt(TempStrPort);
    //RPCBroker1.Connected := True;  BSE mod - rpm 1/8/09
    //If Not AuthorizedOption('DVBA CAPRI GUI') Then  BSE mod -  rpm 1/8/09
    if not ConnectToServer('DVBA CAPRI GUI') then
    Begin
      ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
      application.terminate;
    End;
    FMGets1.IENS := AuthorIEN;
    FMGets1.GetData;
    frmForwardingAddress.Release;
    frmForwardingAddress := Nil;
    AuditInProgress := False;
    exit;
  End;
end;

procedure TfrmMain.actToolsChangeAddressUpdate(Sender: TObject);
begin
  if (GifImageVistaYellow.Visible) or (frmPatientList <> nil) then
    actToolsChangeAddress.Enabled := False
  else
    actToolsChangeAddress.Enabled := true;
end;

procedure TfrmMain.actToolsCPRSCosigUtilExecute(Sender: TObject);
begin
  frmUncosigned := TfrmUncosigned.Create(frmMain);
  frmUncosigned.Show;
  frmUncosigned.buttonSearchClick(Application);
  frmUncosigned.Hide;
  frmUncosigned.ShowModal;
  ContextorChangeMessage := 'You are managing cosigned worksheets.  If you continue, CAPRI will drop out of the clinical context.';
  CCOWBreakLink := True;
  frmUncosigned.Release;
  ContextorChangeMessage := '';
  CCOWBreakLink := False;
end;

procedure TfrmMain.actToolsCPRSCosigUtilUpdate(Sender: TObject);
begin
  if (GifImageVistaYellow.Visible = True) or (frmPatientList <> nil) then
    actToolsCPRSCosigUtil.Enabled := False
  else
    actToolsCPRSCosigUtil.Enabled := True;
end;

procedure TfrmMain.actToolsEditCPReportsExecute(Sender: TObject);
begin
  frmManageReports := tFrmManageReports.create(frmMain);
  frmManageReports.ExamRequestRefreshClick(application);
  frmManageReports.ShowModal;
  frmManageReports.Release;
  frmManageReports := Nil;
  ExamRequestRefreshClick(Application);
end;

procedure TfrmMain.actToolsEditCPReportsUpdate(Sender: TObject);
Var
  x: integer;
  showedit: boolean;
Begin
  showedit := false;

  actToolsEditCPReports.Visible := False;
  actToolsManageTemplateDef.Visible := False;

  If UserKeys.Count > 0 Then
  Begin
    For x := 0 To UserKeys.Count - 1 Do
      If (UserKeys[x] = 'DVBA CAPRI EXAM LIST EDIT') Or
        (UserKeys[x] = 'DVBA CAPRI EXAM LIST E') Then
        showedit := true;
    For x := 0 To UserKeys.Count - 1 Do
      If (UserKeys[x] = 'DVBAB CPWM REVIEWER') Or
        (UserKeys[x] = 'DVBAB CPWM REVIE') Then
        showedit := true;
    For x := 0 To UserKeys.Count - 1 Do
      If (UserKeys[x] = 'DVBA C SUPERVISOR') Then
        showedit := true;
  End;
  If showedit = true Then
    actToolsManageTemplateDef.Visible := True;
  If Pos('@', userfilemancode) > 0 Then
  Begin
    ShowEdit := true;
  End;
  If PatientIEN <> '' Then
    If ShowEdit = True Then
    Begin
      actToolsEditCPREports.Visible := True;
      //jcs - FYI, the original caption can not contain '&&', if it does, the setting
      //of the caption below will fail for some reason.
      actToolsEditCPReports.Caption := 'Manage C&&P Exam Requests for ' + PatientName;
    End;

  if (GifImageVistaYellow.Visible = True) or (frmPatientList <> nil) then
    actToolsEditCPReports.Enabled := False
  else
    actToolsEditCPReports.Enabled := True;
end;

procedure TfrmMain.actToolsEditEsigExecute(Sender: TObject);
begin
  ContextorChangeMessage := 'You are editing signature code.  If you continue, CAPRI will drop out of the clinical context.';
  CCOWBreakLink := True;
  frmElectronicSignatureCode := TfrmElectronicSignatureCode.Create(frmMain);
  frmElectronicSignatureCode.Showmodal;
  frmElectronicSignatureCode.Release;
  ContextorChangeMessage := '';
  CCOWBreakLink := False;
end;

procedure TfrmMain.actToolsExamListParametersExecute(Sender: TObject);
Var
  x, y, z: integer;
  xx, yy, zz: integer;
  foundflag: boolean;
  tempSites: TStringList;
  IEN, ZIEN: String;
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;
  AnimateLogo(True);
  StatusBarLoadPt.Caption := 'Populating exam assignment dialog.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
  tempSites := TStringList.Create;
  tempSites.Clear;
  frmSiteExamList := TfrmSiteExamList.Create(frmMain);
  //Set up exams list
  frmSiteExamList.FMExamsList.Items := ListExams;
  If frmSiteExamList.FMExamsList.Items.Count > 0 Then
    For x := frmSiteExamList.FMExamsList.Items.Count - 1 Downto 0 Do
      If Pos('  I', frmSiteExamList.FMExamsList.Items[x]) > 0 Then
        frmSiteExamList.FMExamsList.Items.Delete(x);

  // Make sure CAPRI DIVISION EXAM LIST FILE contains an entry in .01 for each division
  // The site may have added a new division.
  frmSiteExamList.FMListerCustomExamListDivisionsListBox.FMLister := FMListerMedicalCenterDivision;
  frmSiteExamList.FMListerCustomExamListDivisionsListBox.GetList;
  If frmSiteExamList.FMListerCustomExamListDivisionsListBox.Items.Count = 0 Then
  Begin
    ShowMessageCAPRI('No divisions can be located in VistA.  Exiting this function.');
    frmSiteExamList.Release;
    frmSiteExamList := Nil;
    TempHSMemo.Free;
    exit;
  End;
  // Get current list of divisions
  For x := 0 To frmSiteExamList.FMListerCustomExamListDivisionsListBox.Items.Count - 1 Do
  Begin
    frmSiteExamList.FMListerCustomExamListDivisionsListBox.ItemIndex := x;
    tempSites.Add(frmSiteExamList.FMListerCustomExamListDivisionsListBox.GetSelectedRecord.IEN);
  End;
  // Now get list of divisions defined in the CAPRI DIVISION EXAM LIST FILE
  frmSiteExamList.FMListerCustomExamListDivisionsListBox.FMLister := frmSiteExamList.FMListerCustomExamListDivisions;
  frmSiteExamList.FMListerCustomExamListDivisionsListBox.GetList;
  // Find IEN and show that in the list
  If frmSiteExamList.FMListerCustomExamListDivisionsListBox.Items.Count > 0 Then
    For y := 0 To frmSiteExamList.FMListerCustomExamListDivisionsListBox.Items.Count - 1 Do
    Begin
      frmSiteExamList.FMListerCustomExamListDivisionsListBox.ItemIndex := y;
      frmSiteExamList.CustomExamListDivisions.IENS := frmSiteExamList.FMListerCustomExamListDivisionsListBox.GetSelectedRecord.IEN;
      frmSiteExamList.CustomExamListDivisions.GetData;
      frmSiteExamList.FMListerCustomExamListDivisionsListBox.Items[y] := frmSiteExamList.CustomExamListDivisions.GetField('.01').FMDBInternal;
    End;
  // Compare the two lists and add medical center divisions that are missing
  For x := 0 To tempSites.Count - 1 Do
  Begin
    foundflag := false;
    If frmSiteExamList.FMListerCustomExamListDivisionsListBox.Items.Count > 0 Then
      For y := 0 To frmSiteExamList.FMListerCustomExamListDivisionsListBox.Items.Count - 1 Do
      Begin
        If foundflag = false Then
        Begin
          If tempSites[x] = frmSiteExamList.FMListerCustomExamListDivisionsListBox.Items[y] Then
          Begin
            foundflag := true;
          End;
        End;
      End;
    If FoundFlag = False Then
    Begin
      StatusBarLoadPt.Caption := 'Setting up new division: IEN ' + tempSites[x];
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      frmSiteExamList.FMEditCAPRIDivisionExamList.Text := '`' + tempSites[x];
      frmSiteExamList.FMEditCAPRIDivisionExamList.IENS := '+1,';
      If frmSiteExamList.FMEditCAPRIDivisionExamList.Validate Then
      Begin
        FMFiler1.AddChgdControl(frmSiteExamList.FMEditCAPRIDivisionExamList);
        frmSiteExamList.FMEditCAPRIDivisionExamList.Text := frmSiteExamList.FMEditCAPRIDivisionExamList.FMCtrlExternal;
      End
      Else
      Begin
        frmMain.FMValidator1.DisplayErrors;
        frmSiteExamList.FMEditCAPRIDivisionExamList.Text := frmSiteExamList.FMEditCAPRIDivisionExamList.FMTag;
        exit;
      End;
      If Not frmMain.FMValidator1.Validate Then
      Begin
        FMFiler1.DisplayErrors;
        exit;
      End
      Else
        If Not FMFiler1.Update Then
        Begin
          ShowMessageCAPRI('There was a problem populating new divisions.');
          exit;
        End;
      IEN := FMFiler1.FindIEN('+1,') + ',';
      FMFiler1.AddFDA('396.151', '+1,' + IEN, '.01', 'DEFAULT LIST');
      FMFiler1.AddFDA('396.151', '+1,' + IEN, '2', 'Y');
      For zz := 1 To 50 Do
      Begin
        sleep(1);                                                               // Need this to deal with Broker calls clicked quickly in succession.
        application.processmessages;
      End;
      //fmfile;
      If Not frmMain.FMFiler1.Update Then
      Begin
        ShowmessageCAPRI('Problem updating exam specs.  Please try again.');
        application.terminate;
        application.terminate;
      End;
      ZIEN := FMFiler1.FindIEN('+1,') + ',' + IEN;
      For z := 0 To frmSiteExamList.FMExamsList.Items.Count - 1 Do
      Begin
        StatusBarLoadPt.Caption := 'Setting up new division: IEN ' + tempSites[x] + ', Exam: ' + frmSiteExamList.FMExamsList.Items[z];
        StatusBarLoadPt.Repaint;
        Application.Processmessages;
        frmSiteExamList.FMExamsList.ItemIndex := z;
        frmSiteExamList.FMEditCAPRIExamListDefinition.Text := '`' + frmSiteExamList.FMExamsList.GetSelectedRecord.IEN;
        frmSiteExamList.FMEditCAPRIExamListDefinition.IENS := '+1,' + ZIEN;
        If frmSiteExamList.FMEditCAPRIExamListDefinition.Validate Then
        Begin
          FMFiler1.AddChgdControl(frmSiteExamList.FMEditCAPRIExamListDefinition);
          frmSiteExamList.FMEditCAPRIExamListDefinition.Text := frmSiteExamList.FMEditCAPRIExamListDefinition.FMCtrlExternal;
        End
        Else
        Begin
          frmMain.FMValidator1.DisplayErrors;
          frmSiteExamList.FMEditCAPRIExamListDefinition.Text := frmSiteExamList.FMEditCAPRIExamListDefinition.FMTag;
          exit;
        End;
        FMFiler1.AddFDA('396.1514', '+1,' + ZIEN, '2', 'Y');
        If Not frmMain.FMValidator1.Validate Then
        Begin
          FMValidator1.DisplayErrors;
          exit;
        End
        Else
          If Not FMFiler1.Update Then
          Begin
            ShowMessageCAPRI('There was a problem populating the exam list.');
            exit;
          End;
      End;                                                                      // end of exam list population

    End;
  End;

  //Reload division list in case it changed
  frmSiteExamList.FMListerCustomExamListDivisionsListBox.GetList;

  // Now evaluate for exams that have been inactivated or exams that have been added
  StatusBarLoadPt.Caption := 'Validating list consistency.';
  For y := 0 To frmSiteExamList.FMListerCustomExamListDivisionsListBox.Items.Count - 1 Do
  Begin
    frmSiteExamList.FMListerCustomExamListDivisionsListBox.ItemIndex := y;
    // Get list for division
    frmSiteExamList.FMListerCustomExamListDivisionsListBoxClick(Application);
    // Load up the list and see what exams are in it.
    If frmSiteExamList.FMListBoxAvailableExamLists.Items.Count > 0 Then
      frmSiteExamList.FMListerExamSetup.ListerFlags := [lfInternal];
    For z := 0 To frmSiteExamList.FMListBoxAvailableExamLists.Items.Count - 1 Do
    Begin
      frmSiteExamList.FMListBoxAvailableExamLists.ItemIndex := z;
      StatusBarLoadPt.Caption := 'Validating ' + frmSiteExamList.FMListerCustomExamListDivisionsListBox.Items[frmSiteExamList.FMListerCustomExamListDivisionsListBox.ItemIndex] + ':  ' +
        frmSiteExamList.FMListBoxAvailableExamLists.Items[frmSiteExamList.FMListBoxAvailableExamLists.ItemIndex];
      frmSiteExamList.buttonEditClick(Application);
      // Check for exams now inactive
      For xx := frmSiteExamList.FMListBoxExamSetup.Items.Count - 1 Downto 0 Do
      Begin
        frmSiteExamList.FMListBoxExamSetup.ItemIndex := xx;
        foundflag := false;
        For yy := frmSiteExamList.FMExamsList.Items.Count - 1 Downto 0 Do
        Begin
          frmSiteExamList.FMExamsList.ItemIndex := yy;
          If frmSiteExamList.FMExamsList.GetSelectedRecord.IEN = Copy(frmSiteExamList.FMListBoxExamSetup.Items[xx], 1, Pos('  ', frmSiteExamList.FMListBoxExamSetup.Items[xx]) - 1) Then
            foundflag := true;
        End;
        If foundflag = false Then
        Begin
          StatusBarLoadPt.Caption := 'Removing ' + frmSiteExamList.FMListerCustomExamListDivisionsListBox.Items[frmSiteExamList.FMListerCustomExamListDivisionsListBox.ItemIndex] + ':  ' +
            frmSiteExamList.CheckListBoxExamList.Items[xx];
          frmSiteExamList.FMEditExamNameInList.Text := '@';
          frmSiteExamList.FMEditExamNameInList.IENS := frmSiteExamList.FMListBoxExamSetup.GetSelectedRecord.IEN + ',' + frmSiteExamList.FMListBoxAvailableExamLists.GetSelectedRecord.IEN + ',' +
            frmSiteExamList.FMListerCustomExamListDivisionsListBox.GetSelectedRecord.IEN;
          If frmSiteExamList.FMEditExamNameInList.Validate Then
          Begin
            frmMain.FMFiler1.AddChgdControl(frmSiteExamList.FMEditExamNameInList);
            frmSiteExamList.FMEditExamNameInList.Text := frmSiteExamList.FMEditExamNameInList.FMCtrlExternal;
          End
          Else
          Begin
            frmMain.FMValidator1.DisplayErrors;
            exit;
          End;
          For zz := 1 To 50 Do
          Begin
            sleep(1);                                                           // Need this to deal with Broker calls clicked quickly in succession.
            application.processmessages;
          End;
          //fmfile;
          If Not frmMain.FMFiler1.Update Then
          Begin
            ShowmessageCAPRI('Problem updating exam specs.  Please try again.');
            application.terminate;
            application.terminate;
          End;
        End;
      End;
      For xx := 0 To frmSiteExamList.FMExamsList.Items.Count - 1 Do
      Begin
        foundflag := false;
        frmSiteExamList.FMExamsList.ItemIndex := xx;
        For yy := 0 To frmSiteExamList.FMListBoxExamSetup.Items.Count - 1 Do
        Begin
          If frmSiteExamList.FMExamsList.GetSelectedRecord.IEN = Copy(frmSiteExamList.FMListBoxExamSetup.Items[yy], 1, Pos('  ', frmSiteExamList.FMListBoxExamSetup.Items[yy]) - 1) Then
            foundflag := true;
        End;
        If foundflag = false Then
        Begin
          //ShowMessageCAPRI('turn on '+frmSiteExamList.FMExamsList.Items[xx]);
          StatusBarLoadPt.Caption := 'Adding ' + frmSiteExamList.FMListerCustomExamListDivisionsListBox.Items[frmSiteExamList.FMListerCustomExamListDivisionsListBox.ItemIndex] + ':  ' +
            frmSiteExamList.FMExamsList.Items[xx];
          ZIEN := frmSiteExamList.FMListBoxAvailableExamLists.GetSelectedRecord.IEN + ',' + frmSiteExamList.FMListerCustomExamListDivisionsListBox.GetSelectedRecord.IEN;
          FMFiler1.AddFDA('396.1514', '+1,' + ZIEN, '.01', frmSiteExamList.FMExamsList.GetSelectedRecord.IEN);
          FMFiler1.AddFDA('396.1514', '+1,' + ZIEN, '2', 'Y');
          For zz := 1 To 50 Do
          Begin
            sleep(1);                                                           // Need this to deal with Broker calls clicked quickly in succession.
            application.processmessages;
          End;
          //fmfile;
          If Not frmMain.FMFiler1.Update Then
          Begin
            ShowmessageCAPRI('Problem updating exam specs.  Please try again.');
            application.terminate;
            application.terminate;
          End;
        End;
      End;
    End;
    frmSiteExamList.FMListerExamSetup.ListerFlags := [];
  End;

  frmSiteExamList.FMListerCustomExamListDivisionsListBox.ItemIndex := 0;
  frmSiteExamList.FMListerCustomExamListDivisionsListBoxClick(Application);
  frmSiteExamList.top := frmMain.Top + ((frmMain.Height - frmSiteExamList.Height) Div 2);
  frmSiteExamList.left := frmMain.left + ((frmMain.Width - frmSiteExamList.Width) Div 2);
  AnimateLogo(False);
  StatusBarLoadPt.Caption := 'Ready.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
  frmSiteExamList.Panel1.BringToFront;
  // Set Up Institutions
  If frmROFinder.ORListBoxSites.Items.Count = 0 Then
    LoadInstitutions;
  (*
    If lstInstitutions.Items.Count>0 then
      For x:=0 to lstInstitutions.Items.Count-1 do
        frmSiteExamList.FMListBoxUserGroup.Items.Add(Copy(lstInstitutions.Items[x],1,Pos('^',lstInstitutions.Items[x])-1));
  *)
  frmSiteExamList.FMMemoDivisionComments.Enabled := True;
  ContextorChangeMessage := 'You are editing site parameters.  If you continue, CAPRI will drop out of the clinical context.';
  CCOWBreakLink := True;
  frmSiteExamList.ShowModal;
  ContextorChangeMessage := '';
  CCOWBreakLink := False;
  frmSiteExamList.Release;
  frmSiteExamList := Nil;
  tempSites.Free;
end;

procedure TfrmMain.actToolsExamListParametersUpdate(Sender: TObject);
begin
  If (GifImageVistaYellow.Visible = true) or (frmPatientList <> nil) then
    actToolsExamListParameters.Enabled := false
  else
    actToolsExamListParameters.Enabled := true;

end;

procedure TfrmMain.actToolsMacroEditorExecute(Sender: TObject);
begin
  frmMacroEditor.Show;
end;

procedure TfrmMain.actToolsManageTemplateDefExecute(Sender: TObject);
begin
  frmManageTemplateDefinitions := tFrmManageTemplateDefinitions.create(frmMain);
  frmManageTemplateDefinitions.Show;
  AnimateLogo(True);
  StatusBarLoadPt.Caption := 'Loading template list...';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
  frmManageTemplateDefinitions.ButtonReloadListClick(Application);
  AnimateLogo(False);
  StatusBarLoadPt.Caption := 'Ready.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
  frmManageTemplateDefinitions.Hide;
  frmManageTemplateDefinitions.ShowModal;
  frmManageTemplateDefinitions.Release;
  frmManageTemplateDefinitions := Nil;
end;

procedure TfrmMain.actToolsPrintBlankExamExecute(Sender: TObject);
Var
  x: integer;
  includeflag: boolean;
  sdate, edate: String;
  showuser: String;
  objectcount: integer;
  prefix: String;
  nowdt: String;
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;

  WaitForm.Visible := True;
  WaitForm.BringToFront;
  WaitForm.Label1.Caption := 'Loading template list...';
  WaitForm.Label1.Repaint;
  WaitForm.Repaint;

  RPCBroker1.RemoteProcedure := 'ORWU DT';
  RPCBroker1.Param[1].Value := 'NOW';
  RPCBroker1.Param[1].PType := literal;
  frmMain.RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'RPC ORWU DT could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('ORWU DT could not be accessed!');
    End;
  End;
  nowdt := Piece(RPCBroker1.Results[0], '.', 1);

  frmGenerateBlankTemplate := tfrmGenerateBlankTemplate.create(frmmain);
  frmGenerateBlankTemplate.FMListboxTemplates.Items.Clear;
  RPCBroker1.RemoteProcedure := 'DVBAB TEMPLATE LIST';
  frmMain.RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'RPC DVBAB TEMPLATE LIST could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('DVBAB TEMPLATE LIST could not be accessed!');
    End;
  End;
  QuickCopy(RPCBroker1.Results, frmGenerateBlankTemplate.FMListboxTemplates.Items);
  QuickCopy(RPCBroker1.Results, frmGenerateBlankTemplate.FMListboxAllTemplates.Items);

  If frmGenerateBlankTemplate.FMListboxTemplates.Items.Count > 0 Then
    For x := frmGenerateBlankTemplate.FMListboxTemplates.Items.Count - 1 Downto 0 Do
    Begin
      frmGenerateBlankTemplate.FMListboxTemplates.ItemIndex := x;
      includeflag := false;
      sdate := Piece(frmGenerateBlankTemplate.FMListboxTemplates.Items[x], '^', 2);
      edate := Piece(frmGenerateBlankTemplate.FMListboxTemplates.Items[x], '^', 3);
      showuser := Piece(frmGenerateBlankTemplate.FMListboxTemplates.Items[x], '^', 4);
      Try
      objectcount := strtoint(Piece(frmGenerateBlankTemplate.FMListboxTemplates.Items[x], '^', 5))Except
        objectcount := 0;
      End;                                                                      // The exception catches null values

      //ShowMessageCAPRI(sdate+'*'+edate+'*'+showuser);
      prefix := '';
      If (ShowUser = '1') Or (Showuser = '') Then
      Begin
        If sdate = '' Then
          includeflag := false;
        If sdate <> '' Then
          If (sdate <= nowdt) And (edate = '') Then
            IncludeFlag := true
          Else
            If edate <> '' Then
              If (sdate <= nowdt) And (Edate > nowdt) Then
                includeflag := true;
        If (Pos('@', userfilemancode) > 0) And (includeflag <> true) Then
        Begin
          prefix := 'ZZ_INACTIVE: ';
          includeflag := true;
        End;
      End;
      If IncludeFlag = true Then
      Begin
        frmGenerateBlankTemplate.ListboxTemplates.Items.Add(prefix + Piece(Piece(frmGenerateBlankTemplate.FMListboxTemplates.Items[x], '^', 1), '~', 1) + '^' +
          Piece(frmGenerateBlankTemplate.FMListboxTemplates.Items[x], '^', 6) + '^' + inttostr(objectcount));
      End;
    End;

  // Reformat list to make templatename~version^ien into
  // templatename^ien
  // Strip off version info
  // Piece 3 is the object count

  WaitForm.Visible := False;

  If frmGenerateBlankTemplate.ShowModal = mrCancel Then
  Begin
    frmGenerateBlankTemplate.Release;
    frmGenerateBlankTemplate := Nil;
    exit;
  End;

  frmGenerateBlankTemplate.Release;
  frmGenerateBlankTemplate := Nil;
end;

procedure TfrmMain.actToolsPropertiesExecute(Sender: TObject);
begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;
  frmProperties.lablesample.font := panel1.font;
  frmProperties.Top := 7 + frmMain.Top + ((frmMain.Height - frmProperties.Height) Div 2);
  frmProperties.Left := frmMain.Left + ((frmMain.Width - frmProperties.Width) Div 2);
  frmProperties.ShowModal;
end;

procedure TfrmMain.actToolsPropertiesUpdate(Sender: TObject);
begin
  If (GifImageVistaYellow.Visible = true) or (frmPatientList <> nil) then
    actToolsProperties.Enabled := False
  else
    actToolsProperties.Enabled := true;
end;

{========================================================================
 actToolsSearchExecute
 This action event handler method is called from the Tools/Enterprise
 Search for a Patient option, the Enterprise Search button on the Patient
 Selector dialog box and the Enterprise Search button on the Patient
 Selector (Restricted Lists) dialog box.

 The method performs an MVI Enterprise Search by default.  The method
 continues to support the Legacy RPCBroker style search, which will be
 performed when the sender is a TButton with the Tag property set to '1'.

 CodeCR267 - rpm 8/30/12
 ========================================================================}

procedure TfrmMain.actToolsSearchExecute(Sender: TObject);
Var
  TempStrServer: String;
  TempStrPort: Integer;

Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;

  //Store connection date
  TempStrServer := RPCBroker1.Server;
  TempStrPort := RPCBroker1.ListenerPort;

  if IsButtonTagOne(Sender) then                                                //execute Legacy search
  begin
    //Restricted Patient List treated differently based on Sender
    if (UserHasNewStyleRestrictedList = 1) then
      DoLegacyEnterpriseSearch(frmPatientListRestricted.btnSearch)
    else
      DoLegacyEnterpriseSearch(Sender);                                         //do legacy search
  end
  else                                                                          //Execute MVI search
  begin
    frmMVIEnterpriseSearch := TfrmMVIEnterpriseSearch.Create(Self);
    try
      RPCBroker1.Connected := False;
      if RPCBroker1.Connect2HomeServer(RPCBroker1.ANUAccessCodeHome,
        RPCBroker1.ANUVerifyCodeHome,
        RPCBroker1.ANUstrServerHome,
        RPCBroker1.ANUstrPortHome,
        False) then
      begin
        RPCBroker1.CreateContext('DVBA CAPRI GUI');
        //Restricted Patient List treated differently
        if (UserHasNewStyleRestrictedList = 1) then
          LoadRestrictedSearchTraits;
        frmMVIEnterpriseSearch.ShowModal;
      end;
    finally
      FreeAndNil(frmMVIEnterpriseSearch);
    end;
  end;

  //Reconnect to original host
  RPCBroker1.Server := TempStrServer;
  RPCBroker1.ListenerPort := TempStrPort;

  If Not ConnectToServer('DVBA CAPRI GUI') Then
  Begin
    ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
    application.terminate;
  End;
  If RPCBroker1.Connected = False Then
  Begin
    ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
    application.terminate;
  End;

  //MVI Enterprise search sets site with site list itemindex and SSN
  //when user wants to switch to a different treating facility.
  if (SwitchToSite <> '') and (SwitchToPatientSSN <> '') then
  begin
    DoMVISiteSwitch(Sender);
  end;
end;

procedure TfrmMain.actToolsSearchUpdate(Sender: TObject);
begin
  If (ESSOVersion = True) and (frmPatientList = nil) and ((Pos('@', userfilemancode) > 0) Or
    (Pos('u', userfilemancode) > 0) Or (Pos('U', userfilemancode) > 0)) Then
    actToolsSearch.Visible := True
  else
    actToolsSearch.Visible := false;

  If (GifImageVistaYellow.Visible = True) then
    actToolsSearch.Enabled := false
  else
    actToolsSearch.Enabled := true;
end;

procedure TfrmMain.actToolsUncosignedDocsExecute(Sender: TObject);
begin
  frmTIUCosign := TfrmTIUCosign.Create(frmMain);
  frmTIUCosign.GetCosignatureAlerts;
  frmTIUCosign.showModal;
  frmTIUCosign.Release;
  frmTIUCosign := Nil;
end;

procedure TfrmMain.actToolsUncosignedDocsUpdate(Sender: TObject);
begin
  If (GifImageVistaYellow.Visible = True) or (frmPatientList <> nil) then
    actToolsUncosignedDocs.Enabled := false
  Else
    actToolsUncosignedDocs.Enabled := True
end;

procedure TfrmMain.actToolsUnsignedWorkSheetsUpdate(Sender: TObject);
begin
  if (GifImageVistaYellow.Visible = true) or (frmPatientList <> nil) then
    actToolsUnsignedWorkSheets.Enabled := False
  else
    actToolsUnsignedWorkSheets.Enabled := True;
end;

procedure TfrmMain.actToolsVistaUpdate(Sender: TObject);
begin
  If (GifImageVistaYellow.Visible = true) or (frmPatientList <> nil) then
    actToolsVista.Enabled := false
  else
    actToolsVista.Enabled := True;
end;

Procedure TfrmMain.BitBtnVistAClick(Sender: TObject);
Var
  nowdt: String;
  sgScreenWas: String;
  tempcode: String;
  tempDUZ: String;
  tempflag: boolean;
  x: integer;
  lUseReflection: boolean;
Begin
  If ANURemoteProcedureCallInProgress Then
    exit;

  // CAPRI_CodeCR104 - jcs - 04/23/10 - Prevent re-entry into code if
  // form is already visible, which prevents error if a user clicks
  // VistA button twice while a connection is arleady being established.
  // If the user already has the telnet window open, just bring it to the front.
  If frmTelnet.visible = True then
  begin
    frmTelnet.BringToFront;
    exit;
  end;

  // CodeCR185 -MER 05/2011
  if (MessageDlg('Do you wish to use Reflection to launch a secure shell session?', mtConfirmation, [mbYes, mbNo], 0) = mrYes)
    then
    lUseReflection := TRUE
  else
    lUseReflection := FALSE;

  // Check for DISUSER and don't continue if it's true
  If UserRemoteDISUSER = '1' Then
  Begin
    ShowmessageCAPRI('The active DISUSER flag for this account will be removed so that log-in can occur normally.');

    FMFiler1.AddFDA('200', AuthorIEN, '7', '');
    If frmMain.FMFiler1.AnythingToFile Then
      If frmMain.FMFiler1.Update Then
      Begin
        //Do Stuff here if need to
        UserRemoteTerminationDate := '';
      End;

    //ShowmessageCAPRI('Your account has been temporarily blocked with DISUSER on this system.  You will need to contact IRM at the site.  The telnet function cannot be activated.');
    //exit;
  End;

  tempflag := false;

  {Get User DUZ}

  //CAPRI_CodeCR95  - jcs - 05/20/2010
  if not CallRPC(RPCBroker1, 'XWB GET VARIABLE VALUE', ['DUZ'], nil, True) then
    exit;

  tempDUZ := RPCBroker1.Results[0];

  // Check User's Verify Code to make sure it's not blank.
  // A blank code can happen during a remote connection.
  frmTelnet.fmGetsNewPersonFile.IENS := TempDUZ;
  frmTelnet.fmGetsNewPersonFile.GetData;

  If frmTelnet.fmGetsNewPersonFile.GetField('11').FMDBInternal = '' Then
  Begin
    // Use access code as base for verify code but reverse it to scramble it.
    tempcode := encrypt(RPCBroker1.anuverifycode);                              // Use VistA hash to scramble the code;
    // Showmessage('Verify code is blank: '+tempcode);
    FMValidator1.Setup('200', tempDUZ, '11', tempcode);
    If Not FMValidator1.Validate Then
    Begin
      FMValidator1.DisplayErrors;
      ShowMessageCAPRI('There was an error setting up verify code.');
      application.terminate;
    End;                                                                        {file}
    fmfiler1.AddFDA('200', tempDUZ, '11', tempcode);
    If Not fmfiler1.Update Then
    Begin
      fmfiler1.DisplayErrors;
      ShowMessageCAPRI('There was an error setting a remote verify code.');
      application.terminate;
    End;
  End;

  // ************************************************************************
      // If the new CAPRI HRC menu patch fixed the VT-100 problem at Amarillo,
      // this code can be deleted.
  // ************************************************************************

   // Load list of terminal types
   // Find VT100
  sgScreenWas := frmTelnet.FMListerTerminalType.Screen;
  frmTelnet.FMListerTerminalType.Screen := 'I $P(^(0),U,2)';
  frmTelnet.FMListerTerminalType.GetList(frmTelnet.FMListBoxTerminalType.Items);
  If frmTelnet.FMListBoxTerminalType.Items.count > 0 Then
    For x := 0 To frmTelnet.FMListBoxTerminalType.Items.count - 1 Do
      If (uppercase(frmTelnet.FMListBoxTerminalType.Items[x]) = 'C-VT100') Or
        (uppercase(frmTelnet.FMListBoxTerminalType.Items[x]) = 'VT100') Then
      Begin
        tempflag := true;
        frmTelnet.FMListBoxTerminalType.ItemIndex := x;
      End;
  frmTelnet.FMListerTerminalType.Screen := sgScreenWas;
  If tempflag = false Then
  Begin
    //ShowmessageCAPRI('Cannot locate VT100 terminal type.  Please notify IRM.');
  End
  Else
  Begin
    // Set user's account in the NEW PERSON FILE so that "last terminal type"
    // is VT100
    FMValidator1.Setup('200', tempDUZ, '9.3', '`' + frmTelnet.FMListBoxTerminalType.GetSelectedRecord.IEN);
    If Not FMValidator1.Validate Then
    Begin
      FMValidator1.DisplayErrors;
      ShowMessageCAPRI('There was an error setting up terminal type.');
      application.terminate;
    End;                                                                        {file}
    fmfiler1.AddFDA('200', tempDUZ, '9.3', frmTelnet.FMListBoxTerminalType.GetSelectedRecord.IEN);
    fmfiler1.AddFDA('200', tempDUZ, '8983.13', frmTelnet.FMListBoxTerminalType.GetSelectedRecord.IEN);
    // Force "ask terminal type at login" from New Person File
    fmfiler1.AddFDA('200', tempDUZ, '8983.12', 'Y');
    If Not fmfiler1.Update Then
    Begin
      fmfiler1.DisplayErrors;
      ShowMessageCAPRI('There was an error setting terminal type to VT-100.');
      application.terminate;
    End;
  End;

  // ************************************************************************

    // Check for termination date.  If found and earlier or equal to current date,
    // then clear it.  The user has access on central authentication server,
    // so the date can be cleared.

  If UserRemoteTerminationDate <> '' Then
  Begin
    If ANURemoteProcedureCallInProgress = True Then
      exit;
    RPCBroker1.RemoteProcedure := 'ORWU DT';
    RPCBroker1.Param[1].Value := 'NOW';
    RPCBroker1.Param[1].PType := literal;
    Try
      RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        AnimateLogo(False);
        StatusBarLoadPt.Caption := 'RPC ORWU DT could not be accessed!';
        StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('ORWU DT could not be accessed!');
      End;
    End;
    nowdt := Piece(RPCBroker1.Results[0], '.', 1);
    If UserRemoteTerminationDate <= NowDt Then
    Begin
      // User has access, so remove term date here
      FMFiler1.AddFDA('200', AuthorIEN, '9.2', '');
      If frmMain.FMFiler1.AnythingToFile Then
        If frmMain.FMFiler1.Update Then
        Begin
          //Do Stuff here if need to
          UserRemoteTerminationDate := '';
        End;
    End;
  End;

  If UserHomePrimaryMenu = 'EVE' Then
    UserHomePrimaryMenu := '';

  // Only allow changing the primary menu when the user's primary menu exists
  // in the CAPRI PRIMARY MENU OPTIONS (#396.8) file. Otherwise set the
  // user's menu as a secondary option.
  if FPrimaryMenuAssignable then                                                //CodeCR109 - rpm 8/4/10
  Begin
    kernel_AssignMenuToPrimary(RPCBroker1, AuthorIEN, UserHomePrimaryMenu);
    kernel_AssignMenuToSecondary(RPCBroker1, AuthorIEN, 'XMUSER');

    // Check multiple sign-ins and set to allowed, if necessary
    If frmTelnet.fmGetsNewPersonFile.GetField('200.04').FMDBInternal <> '1' Then
    Begin
      FMValidator1.Setup('200', tempDUZ, '200.04', '1');
      If Not FMValidator1.Validate Then
      Begin
        FMValidator1.DisplayErrors;
        ShowMessageCAPRI('There was an error setting multiple log-ins.');
        application.terminate;
      End;                                                                      {file}
      fmfiler1.AddFDA('200', tempDUZ, '200.04', '1');
      If Not fmfiler1.Update Then
      Begin
        fmfiler1.DisplayErrors;
        ShowMessageCAPRI('There was an error setting multiple log-ins.');
        application.terminate;
      End;
    End;
    // End of multiple sign-in block

  End
  Else
  Begin
    If UserHomePrimaryMenu <> '' Then
    Begin
      kernel_AssignMenuToSecondary(RPCBroker1, AuthorIEN, UserHomePrimaryMenu);
      kernel_AssignMenuToSecondary(RPCBroker1, AuthorIEN, 'XMUSER');
    End;
  End;

  (*
    // Check menu to be sure it's the same as the one on the central authentication server
    // If not, then change it.
    If UserHomePrimaryMenu<>'' then
      If UserRemotePrimaryMenu<>UserHomePrimaryMenu then begin
        frmTelnet.FMListerOption.PartList.Clear;
        frmTelnet.FMListerOption.PartList.Add(UserHomePrimaryMenu);
        frmTelnet.FMListBoxOption.GetList;
        if frmTelnet.FMListBoxOption.Items.Count=0 then begin
          ShowmessageCapri('Couldn''t find menu '+UserHomePrimaryMenu+' on the remote system.');
          exit;
        end;
        y:=-1;
        if frmTelnet.FMListBoxOption.Items.Count>0 then
          for x:=0 to frmTelnet.FMListBoxOption.Items.Count-1 do
            if frmTelnet.FMListBoxOption.Items[x]=UserHomePrimaryMenu then y:=x;
        if (frmTelnet.FMListBoxOption.Items.Count=0) or (y=-1) then begin
          ShowmessageCapri('Couldn''t find menu '+UserHomePrimaryMenu+' on the remote system.  You will be allowed to continue, but may have the wrong menu.');
          // If no menu, then set to XMUSER (mailman);
          If UserRemotePrimaryMenu='' then begin
            frmTelnet.FMListerOption.PartList.Clear;
            frmTelnet.FMListerOption.PartList.Add('XMUSER');
            frmTelnet.FMListBoxOption.GetList;
            y:=-1;
            If frmTelnet.FMListboxOption.Items.Count>0 then
              for x:=0 to frmTelnet.FMListboxOption.Items.Count-1 do
                If frmTelnet.FMListboxOption.Items[x]='XMUSER' then y:=x;
            If (frmTelnet.FMListboxOption.Items.Count=0) or (y=-1) then begin
              ShowmessageCAPRI('Couldn''t find XMUSER on this system.  You have no menu.');
              exit;
            end;
            frmTelnet.FMListBoxOption.ItemIndex:=y;
            FMFiler1.AddFDA('200',AuthorIEN,'201',frmTelnet.FMListBoxOption.GetSelectedRecord.IEN);
            if frmMain.FMFiler1.AnythingToFile then
              if frmMain.FMFiler1.Update then begin
                //Do Stuff here if need to
                UserRemotePrimaryMenu:=frmTelnet.FMListBoxOption.items[y];
              end;
          end;
        end else begin
          // set menu here
          frmTelnet.FMListBoxOption.ItemIndex:=y;
          FMFiler1.AddFDA('200',AuthorIEN,'201',frmTelnet.FMListBoxOption.GetSelectedRecord.IEN);
          if frmMain.FMFiler1.AnythingToFile then
            if frmMain.FMFiler1.Update then begin
              //Do Stuff here if need to
              UserRemotePrimaryMenu:=frmTelnet.FMListBoxOption.items[y];
            end;
        end;
      end;
  *)

    //UserRemoteTerminationDate:=FMGetsNewPerson.GetField('9.2').FMDBInternal;

    // Need to check primary menu and assign correct menu if one doesn't exist.

    //if assigned(frmTelnet)=false then begin
      //frmTelnet:=TfrmTelnet.Create(frmMain);
  //end;
  frmTelnet.ServerEdit.Text := RPCBroker1.ANUStrServer;
  //frmTelnet.ExplodeForm1.SetSourceRect(BitBtnVistA);

  // CAPRI_CodeCR104 - jcs - 04/23/10 - Supplemental fix, moved following line
  // to frmTelnet.ConnectBtnClick(Application) so the caption is updated when the
  // user uses the connect button on the telnet form. The caption of the main
  // form may change if the user switched sites.
  // frmTelnet.caption := Copy(frmMain.Caption, 19, length(frmMain.caption));

  // CodeCR185 -MER 04/2011
  if (lUseReflection) then begin
    if not (ReflectionWrapper.IsRunning) then begin
      ReflectionWrapper.Host := RPCBroker1.ANUStrServer;
      ReflectionWrapper.AccessToken := '~~TOK~~' + GetAppHandle(RPCBroker1);
      ReflectionWrapper.UserName := ANUTelnetLoginName;
    end;
    ReflectionWrapper.LaunchEmulator;
  end else begin
    frmTelnet.Show;
    If frmTelnet.ConnectBtn.Enabled = True Then
      frmTelnet.ConnectBtnClick(Application)
    Else
    Begin
      frmTelnet.DisconnectBtnClick(Application);
      frmTelnet.ConnectBtnClick(Application);
    End;
  end;
End;

Procedure TfrmMain.buttonCancelReportAdmissionClick(Sender: TObject);
Begin
  PanelReportChoice.Visible := False;
  PanelReportChoice2.Visible := False;
End;

Procedure TfrmMain.buttonOKReportAdmissionClick(Sender: TObject);
Var
  whichindex: integer;
  x, y: integer;
  typeofmovement: String;
Begin
  whichindex := fmlistBoxAdmission.ItemIndex;
  If FMListBoxAdmission.ItemIndex > -1 Then
    If Pos('UNKNOWN', fmListBoxAdmission.Items[fmListBoxAdmission.ItemIndex]) > 0 Then
    Begin
      ShowMessageCAPRI('CAPRI cannot display this event due to unknown data.');
      exit;
    End;
  If FMListBoxAdmission.ItemIndex = -1 Then
  Begin
    Showmessage('Please select an admission event.');
    exit;
  End;
  If FMListBoxAdmission.ItemIndex = 0 Then
    If FMListBoxAdmission.Items[0] = 'No admissions found' Then
    Begin
      Showmessage('There are no admission events to view.');
      exit;
    End;
  AnimateLogo(True);
  StatusBarLoadPt.Caption := 'Downloading Admission Info.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
  PanelReportChoice.Visible := False;
  PanelReportChoice2.Visible := False;
  FMListerAdmissions.PartList.Clear;
  FMListerAdmissions.PartList.Add(PatientIEN);
  //FMListerAdmissions.GetList(FMListBoxAdmission.Items);
  FMListBoxAdmission.GetList;
  If FMListBoxAdmission.Items.Count > 0 Then
  Begin                                                                         //strip off pt ien and anything not belonging to pt.
    For x := FMListBoxAdmission.Items.Count - 1 Downto 0 Do
    Begin
      If Pos(patientien + '  ', FMListBoxAdmission.Items[x]) <> 1 Then
        FMListBoxAdmission.Items.Delete(x)
      Else
        FMListBoxAdmission.Items[x] := Copy(FMListBoxAdmission.Items[x], Pos('  ', FMListBoxAdmission.Items[x]) + 4, 999);
    End;
  End;
  For x := FMListBoxAdmission.Items.Count - 1 Downto 0 Do
  Begin
    FMListBoxAdmission.ItemIndex := x;
    TypeOfMovement := Copy(FMListBoxAdmission.Items[x], Pos('  ', FMListBoxAdmission.Items[x]) + 4, 255);
    FMGetsMovementType.IENS := Copy(TypeOfMovement, Pos('  ', TypeOfMovement) + 4, 255);
    TypeOfMovement := Copy(TypeOfMovement, 1, Pos('  ', TypeOfMovement) - 1);
    FMGetsMovementType.GetAndFill;
    FMGetsFacilityMovementType.IENS := TypeOfMovement;
    //FMEditMovementType.Text:='UNKNOWN';
    //FMEditMovementWardLocation.Text:='UNKNOWN';
    //FMEditFacilityMovementType.Text:='UNKNOWN';
    Try
    FMGetsFacilityMovementType.GetAndFill Except
    End;
    FMGetsPatientMovement.IENS := FMListBoxAdmission.GetSelectedRecord.IEN;
    Try
    FMGetsPatientMovement.GetAndFill Except
    End;
    FMListBoxAdmission.Items[x] := FMEditMovementType.Text + '  ' + FMDateTimeConvert(Copy(FMListBoxAdmission.Items[x], 1, Pos('  ', FMListBoxAdmission.Items[x]) - 1)) + '  ' +
      FMEditFacilityMovementType.Text + '    TO:  ' + FMEditMovementWardLocation.Text;
  End;

  // Find the selected admission in the full list
  FMListBoxAdmission.ItemIndex := 0;
  y := 0;
  x := 0;
  If whichindex > 0 Then
  Begin
    Repeat
      If pos('ADMISSION', FMListBoxAdmission.Items[x]) = 1 Then
        inc(y);
      inc(x);
      If x > fmlistboxadmission.items.count - 1 Then
      Begin
        Showmessage('Couldn''t find the admission due to a program error!');
        exit;
      End;
    Until y = whichindex + 1;
    FMListBoxAdmission.ItemIndex := x - 1;
  End
  Else
    FMListBoxAdmission.ItemIndex := 0;
  // End of find admission

  WhichIndex := FMListBoxAdmission.ItemIndex;
  ReportMemo.Lines.Clear;
  ReportMemo.Visible := False;
  Try
    If FMListBoxAdmission.Items[0] = 'No admissions found' Then
  exit Except
    Begin
      exit;
    End;
  End;
  If LabelReportChoice.Caption = 'Detailed Inpatient Inquiry' Then
  Begin

    //Admission
    FMListBoxAdmission.ItemIndex := WhichIndex;
    FMGetsPatientMovement.IENS := FMListBoxAdmission.GetSelectedRecord.IEN;
    FMGetsPatientMovement.GetAndFill;
    ReportMemo.Lines.Add('ADMISSION:');
    ReportMemo.Lines.Add('     ' + FMEditMovementDateTime.Text + '  ' + FMEditMovementTypeofMovement.Text + '    TO: ' + FMEditMovementWardLocation.Text + '  [' + FMEditMovementRoomBed.Text + ']');
    ReportMemo.Lines.Add(' ');

    //Transfers
    ReportMemo.Lines.Add('TRANSFERS:');
    FMListBoxAdmission.ItemIndex := WhichIndex;
    x := whichindex - 1;
    Repeat
      Begin
        inc(x);
        If x <= fmlistboxadmission.items.count - 1 Then
          If pos('TRANSFER', FMListBoxAdmission.Items[x]) = 1 Then
          Begin
            FMListBoxAdmission.ItemIndex := x;
            FMGetsPatientMovement.IENS := FMListBoxAdmission.GetSelectedRecord.IEN;
            FMGetsPatientMovement.GetAndFill;
            ReportMemo.Lines.Add('     ' + FMEditMovementDateTime.Text + '  ' + FMEditMovementTypeofMovement.Text + '    TO: ' + FMEditMovementWardLocation.Text + '  [' + FMEditMovementRoomBed.Text +
              ']');
          End;
    End Until ((x > fmlistboxadmission.items.count - 1) Or (pos('DISCHARGE', FMListBoxAdmission.Items[x]) = 1));
    ReportMemo.Lines.Add(' ');

    //Treating Specialty Changes
    ReportMemo.Lines.Add('TREATING SPECIALTY CHANGES:');
    FMListBoxAdmission.ItemIndex := WhichIndex;
    x := whichindex - 1;
    Repeat
      Begin
        inc(x);
        If x <= fmlistboxadmission.items.count - 1 Then
          If pos('SPECIALTY TRANSFER', FMListBoxAdmission.Items[x]) = 1 Then
          Begin
            FMListBoxAdmission.ItemIndex := x;
            FMGetsPatientMovement.IENS := FMListBoxAdmission.GetSelectedRecord.IEN;
            FMGetsPatientMovement.GetAndFill;
            If FMMemoMovementDiagnosis.Lines.Count = 0 Then
              FMMemoMovementDiagnosis.Lines.Add(' ');
            ReportMemo.Lines.Add('     ' + FMEditMovementDateTime.Text + '    SPECIALTY:  ' + FMEditMovementSpecialty.Text);
            ReportMemo.Lines.Add('       PROVIDER:   ' + FMEditMovementProvider.Text);
            ReportMemo.Lines.Add('       ATTENDING:  ' + FMEditMovementAttending.Text + '    DX:  ' + FMMemoMovementDiagnosis.Lines[0]);
            FMMemoMovementDiagnosis.Lines.Delete(0);
            If FMMemoMovementDiagnosis.Lines.Count > 0 Then
              Repeat
                Begin
                  ReportMemo.Lines.Add('                       DX:  ' + FMMemoMovementDiagnosis.Lines[0]);
                  FMMemoMovementDiagnosis.Lines.Delete(0);
              End Until FMMemoMovementDiagnosis.Lines.Count = 0;
          End;
    End Until ((x > fmlistboxadmission.items.count - 1) Or (pos('DISCHARGE', FMListBoxAdmission.Items[x]) = 1));
    ReportMemo.Lines.Add('');

    //Discharge
    FMListBoxAdmission.ItemIndex := WhichIndex;
    x := whichindex - 1;
    Repeat
      Begin
        inc(x);
    End Until ((x > fmlistboxadmission.items.count - 1) Or (pos('DISCHARGE', FMListBoxAdmission.Items[x]) = 1));
    If x > fmlistboxadmission.items.count - 1 Then
    Begin
      ReportMemo.Lines.Add('DISCHARGE:');
      ReportMemo.SelStart := 0;                                                 // Forces cursor to beginning
      ReportMemo.SelLength := 0;
      ReportMemo.Visible := True;
      exit;                                                                     // patient is still admitted
    End;
    FMListBoxAdmission.ItemIndex := x;
    FMGetsPatientMovement.IENS := FMListBoxAdmission.GetSelectedRecord.IEN;
    FMGetsPatientMovement.GetAndFill;
    ReportMemo.Lines.Add('DISCHARGE:');
    ReportMemo.Lines.Add('     ' + FMEditMovementDateTime.Text + '  ' + FMEditMovementTypeofMovement.Text);
    ReportMemo.Lines.Add('');
  End;
  ReportMemo.SelStart := 0;                                                     // Forces cursor to beginning
  ReportMemo.SelLength := 0;
  ReportMemo.Visible := True;
  AnimateLogo(False);
  StatusBarLoadPt.Caption := 'Ready.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
End;

Procedure TfrmMain.SeventyOne31RequestRefreshClick(Sender: TObject);
Var
  x: integer;
  date1, date2: String;
Begin
  AnimateLogo(True);
  StatusBarLoadPt.Caption := 'Re-populating 7131 requests list...';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
  // Get C&P Exam Dates
  FMSeventyOne31Lister1.PartList.Clear;
  FMSeventyOne31Lister1.PartList.Add(PatientIEN);
  FMSeventyOne31RequestListbox.GetList;
  // Make sure data is correct for PatientIEN
  If FMSeventyOne31RequestListBox.Items.Count > 0 Then
    For x := FMSeventyOne31RequestListBox.Items.Count - 1 Downto 0 Do
    Begin
      If Pos(PatientIEN + '  ', FMSeventyOne31RequestListBox.Items[x]) <> 1 Then
        FMSeventyOne31RequestListBox.Items.Delete(x);
    End;
  // Reformat data
  If FMSeventyOne31RequestListbox.Items.Count > 0 Then
    For x := 0 To FMSeventyOne31RequestListbox.Items.Count - 1 Do
    Begin
      FMSeventyOne31RequestListbox.Items[x] := Copy(FMSeventyOne31RequestListbox.Items[x], Pos('  ', FMSeventyOne31RequestListbox.Items[x]) + 4, 255); // Strip patient IEN;
      Date1 := Copy(FMSeventyOne31RequestListbox.Items[x], 1, Pos('  ', FMSeventyOne31RequestListbox.Items[x]) - 1);
      FMSeventyOne31RequestListbox.Items[x] := Copy(FMSeventyOne31RequestListbox.Items[x], Pos('  ', FMSeventyOne31RequestListbox.Items[x]) + 4, 500);
      Date2 := FMSeventyOne31RequestListbox.Items[x];
      FMSeventyOne31RequestListbox.Items[x] := Copy(FMSeventyOne31RequestListbox.Items[x], Pos('  ', FMSeventyOne31RequestListbox.Items[x]) + 4, 500);
      If Date2 <> '' Then
        FMSeventyOne31RequestListbox.Items[x] := Copy(FMDateTimeConvert(Date1) + '                    ', 1, 20) + '  |  ' + FMDateTimeConvert(Date2)
      Else
        If Date1 <> '' Then
          FMSeventyOne31RequestListbox.Items[x] := Copy(FMDateTimeConvert(Date1) + '                    ', 1, 20) + '  |  '
        Else
          FMSeventyOne31RequestListbox.Items[x] := Copy('OUTPT TREATMENT     ', 1, 20) + '  |  ';
      //Fix single digit date and move over
      If Copy(FMSeventyOne31RequestListbox.Items[x], 6, 1) = ',' Then
        FMSeventyOne31RequestListbox.Items[x] := Copy(FMSeventyOne31RequestListbox.Items[x], 1, 4) + ' ' + Copy(FMSeventyOne31RequestListbox.Items[x], 5, 15) +
          Copy(FMSeventyOne31RequestListbox.Items[x], 21, 99);

    End;
  AnimateLogo(False);
  StatusBarLoadPt.Caption := 'Ready.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
End;

Procedure TfrmMain.btnAdd7131Click(Sender: TObject);
Var
  x, y: integer;
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;

  If frmROFinder.ORListBoxSites.Items.Count = 0 Then
    LoadInstitutions;

  AddRequestIEN := '';
  frmMain.RPCBroker1.Results.Clear;
  RPCBroker1.RemoteProcedure := 'DVBAB CHECK CREDENTIALS';
  RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'RPC DVBAB CHECK CREDENTIALS could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('RPC DVBAB CHECK CREDENTIALS could not be accessed!');
    End;
  End;
  If RPCBroker1.Results[0] <> '[OK]' Then
  Begin
    ShowMessageCAPRI(RPCBroker1.Results[0]);
    application.terminate;
    Exit;
  End;
  AnimateLogo(True);
  StatusBarLoadPt.Caption := 'Loading events.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;

  btnAddRequest.Enabled := False;
  BitBtnVistA.enabled := False;
  btnViewExam.Enabled := False;
  btnExamFinalReport.Enabled := False;
  btnGenerateReport.Enabled := False;

  frmNew7131 := TfrmNew7131.Create(frmMain);
  frmNew7131.Checkbox1.Checked := False;
  frmNew7131.Checkbox2.Checked := False;
  frmNew7131.Checkbox3.Checked := False;
  frmNew7131.Checkbox4.Checked := False;
  frmNew7131.Checkbox5.Checked := False;
  frmNew7131.Checkbox6.Checked := False;
  frmNew7131.Checkbox7.Checked := False;
  frmNew7131.Checkbox8.Checked := False;
  frmNew7131.Checkbox9.Checked := False;
  frmNew7131.Checkbox10.Checked := False;
  frmNew7131.FMChk1.Text := '';
  frmNew7131.FMChk2.Text := '';
  frmNew7131.FMChk3.Text := '';
  frmNew7131.FMChk4.Text := '';
  frmNew7131.FMChk5.Text := '';
  frmNew7131.FMChk6.Text := '';
  frmNew7131.FMChk7.Text := '';
  frmNew7131.FMChk8.Text := '';
  frmNew7131.FMChk9.Text := '';
  frmNew7131.FMChk10.Text := '';
  frmNew7131.FMDocumentType.Text := '';
  frmNew7131.FMRegionalOfficeNumberFake.Text := '';
  frmNew7131.FMRegionalOfficeNumber.ItemIndex := -1;
  frmNew7131.FMRequestDate.Text := '';
  frmNew7131.FMDateStatusChange.Text := '';
  frmNew7131.FMTxReport.Text := '';
  frmNew7131.FMAdmissionDate.Text := '';
  frmNew7131.FMCommentsMemo.Lines.Clear;
  frmNew7131.FMRoutingLocationFake.Text := '';
  frmNew7131.FMRoutingLocation.ItemIndex := -1;
  frmNew7131.ScrollBox1.VertScrollBar.Position := 0;

  // If credentials are ok, then continue
  {Use CPRS Visit Loader ORQQVS VISITS/APPTS}
  RPCBroker1.RemoteProcedure := 'ORQQVS VISITS/APPTS';
  RPCBroker1.Param[0].Value := PatientIEN;
  RPCBroker1.Param[0].PType := literal;
  RPCBroker1.Param[1].Value := 'T-9999';                                        {Date to start}
  RPCBroker1.Param[1].PType := literal;
  RPCBroker1.Param[2].Value := 'T@11:59PM';                                     {Date to stop}
  RPCBroker1.Param[2].PType := literal;
  RPCBroker1.Param[3].Value := '';
  RPCBroker1.Param[3].PType := literal;
  RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'RPC ORQQVS VISITS/APPTS could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('Connection to server for ORQQVS VISITS/APPTS could not be established!');
    End;
  End;
  {Copy to hidden listbox}
  frmNew7131.ListBox2.Items.Clear;                                              {Hidden Box}
  frmNew7131.ListBox4.Items.Clear;                                              {Inpt Box}
  frmNew7131.ListBox5.Items.Clear;                                              {Hidden Box}
  frmNew7131.ListBox2.Items := RPCBroker1.Results;
  // Remove all admission info and do it another way
  If frmNew7131.Listbox2.Items.Count > 0 Then
    For x := frmNew7131.Listbox2.Items.Count - 1 Downto 0 Do
    Begin
      If Pos('^admitted:^', frmNew7131.ListBox2.Items[x]) > 0 Then
        frmNew7131.ListBox2.Items.Delete(x)
    End;
  {Use CPRS Visit Loader ORWPT ADMITLST}
  RPCBroker1.RemoteProcedure := 'ORWPT ADMITLST';
  RPCBroker1.Param[0].Value := PatientIEN;
  RPCBroker1.Param[0].PType := literal;
  RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'RPC ORWPT ADMITLST could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('Connection to server for ORWPT ADMITLST could not be established!');
    End;
  End;
  frmNew7131.ListBox2.Items.Clear;                                              {Hidden Box}
  frmNew7131.ListBox4.Items.Clear;                                              {Inpt Box}
  frmNew7131.ListBox5.Items.Clear;                                              {Hidden Box}
  frmNew7131.ListBox2.Items := RPCBroker1.Results;
  If frmNew7131.Listbox2.Items.Count > 0 Then
    For x := 0 To frmNew7131.Listbox2.Items.Count - 1 Do
    Begin
      frmNew7131.ListBox4.Items.Add(Copy(frmNew7131.ListBox2.Items[x], Pos('^', frmNew7131.ListBox2.Items[x]) + 1, 254));
      frmNew7131.ListBox4.Items[x] := Copy(frmNew7131.ListBox4.Items[x], Pos('^', frmNew7131.ListBox4.Items[x]) + 1, 254);
      frmNew7131.ListBox4.Items[x] := FMDateTimeConvert(Copy(frmNew7131.ListBox2.Items[x], 1, Pos('^', frmNew7131.ListBox2.Items[x]) - 1)) + '  ' + Copy(frmNew7131.ListBox4.Items[x], 1, Pos('^',
        frmNew7131.ListBox4.Items[x]) - 1);
      frmNew7131.ListBox5.Items.Add(Copy(frmNew7131.ListBox2.Items[x], 1, Pos('^', frmNew7131.ListBox2.Items[x]) - 1));
    End;
  //Populate Controls

  (*
  frmNew7131.FMRegionalOfficeNumber.Items.Clear;
  If lstInstitutions.Items.Count>0 then
    For x:=0 to lstInstitutions.Items.Count-1 do
        frmNew7131.FMRegionalOfficeNumber.Items.Add(Copy(lstInstitutions.Items[x],1,Pos('^',lstInstitutions.Items[x])-1));
*)
  frmNew7131.FMPatientName.Text := Copy(Panel1.Caption, 1, Pos('  SSN#', Panel1.Caption));
  frmNew7131.FMPatientNameIEN.Text := '`' + PatientIEN;
  frmNew7131.FMRequestDate.Text := 'TODAY';
  frmNew7131.FMDateStatusChange.Text := 'TODAY';
  frmNew7131.FMRequestedBy.Text := FMUserName.Caption;
  frmNew7131.FMRoutingLocation.Items := listMedicalCenterDivision;
  frmNew7131.FMPatientNameIEN.IENS := '+1';
  frmNew7131.FMRegionalOfficeNumberFake.IENS := '+1';
  frmNew7131.FMRequestedBy.IENS := '+1';
  frmNew7131.FMRequestDate.IENS := '+1';
  frmNew7131.FMDateStatusChange.IENS := '+1';
  frmNew7131.FMDocumentType.IENS := '+1';
  frmNew7131.FMTxReport.IENS := '+1';
  frmNew7131.FMRoutingLocationFake.IENS := '+1';
  frmNew7131.FMAdmissionDate.IENS := '+1';
  frmNew7131.FMCommentsMemo.IENS := '+1';
  frmNew7131.FMChk1.IENS := '+1';
  frmNew7131.FMChk2.IENS := '+1';
  frmNew7131.FMChk3.IENS := '+1';
  frmNew7131.FMChk4.IENS := '+1';
  frmNew7131.FMChk5.IENS := '+1';
  frmNew7131.FMChk6.IENS := '+1';
  frmNew7131.FMChk7.IENS := '+1';
  frmNew7131.FMChk8.IENS := '+1';
  frmNew7131.FMChk9.IENS := '+1';
  frmNew7131.FMChk10.IENS := '+1';

  AnimateLogo(False);
  StatusBarLoadPt.Caption := 'Ready.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;

  //Enter request
  frmNew7131.Height := frmMain.Height - 32;
  If frmNew7131.Height > 850 Then
    frmNew7131.Height := 850;
  frmNew7131.Top := 7 + frmMain.Top + ((frmMain.Height - frmNew7131.Height) Div 2);
  frmNew7131.Left := frmMain.Left + ((frmMain.Width - frmNew7131.Width) Div 2);
  frmNew7131.btnSendRequest.Top := frmNew7131.Height - 81;
  frmNew7131.btnCancel.Top := frmNew7131.Height - 81;
  frmNew7131.Scrollbox1.Height := frmNew7131.Height - 82;
  //frmMain.BorderIcons:=frmMain.BorderIcons-[biSystemMenu];
  frmNew7131.Panel2.Visible := False;

  frmNew7131.FMListerCustomExamListDivisionsListBox.GetList;
  //Check for inactive divisions
  If frmNew7131.FMListerCustomExamListDivisionsListBox.Items.Count > 0 Then
    For x := 0 To frmNew7131.FMListerCustomExamListDivisionsListBox.Items.Count - 1 Do
    Begin
      frmNew7131.FMListerCustomExamListDivisionsListBox.ItemIndex := x;
      frmNew7131.CustomExamListDivisions.IENS := frmNew7131.FMListerCustomExamListDivisionsListBox.GetSelectedRecord.IEN;
      frmNew7131.CustomExamListDivisions.GetAndFill;
      //Inactivate if "YES"
      If frmNew7131.FMEditInactivateDivision.Text = 'YES' Then
      Begin
        If frmNew7131.FMRoutingLocation.Items.Count > 0 Then
          For y := frmNew7131.FMRoutingLocation.Items.Count - 1 Downto 0 Do
          Begin
            frmNew7131.FMRoutingLocation.ItemIndex := y;
            If Piece(frmNew7131.FMRoutingLocation.Items[y], '^', 2) = frmNew7131.FMListerCustomExamListDivisionsListBox.Items[x] Then
            Begin
              frmNew7131.FMRoutingLocation.Items.Delete(y);
            End;
          End;
      End;
    End;
  frmNew7131.FMRoutingLocation.ItemIndex := -1;

  // Set up division...
  searchforstring := UserDivision;
  frmNew7131.FMRegionalOfficeNumber.Text := UserDivision;
  frmNew7131.FMRegionalOfficeNumberFake.Text := UserDivision;
  frmNew7131.FMRegionalOfficeNumberEnter(Application);
  searchforstring := '';

  ContextorChangeMessage := 'You are adding a new 7131 request.  If you continue, you will lose your work.';
  CCOWBreakLink := True;
  frmNew7131.ShowModal;
  ContextorChangeMessage := '';
  CCOWBreakLink := False;
  //frmMain.BorderIcons:=frmMain.BorderIcons+[biSystemMenu];
  SeventyOne31RequestRefreshClick(Application);
  frmNew7131.release;
  frmNew7131 := Nil;
  Try
    frmROFinder.Hide;
  Except
  End;

  if ESSOVersion then
    BitBtnVistA.enabled := True;                                                //only remote connections - rpm 3/17/09
  If ReadOnlyMode = False Then
    btnAddRequest.Enabled := True;
  If FMSeventyOne31RequestListbox.Itemindex > -1 Then
  Begin
    btnGenerate7131Report.Enabled := True;
    btnView7131.Enabled := True;
  End
  Else
  Begin
    btnGenerate7131Report.Enabled := False;
    btnView7131.Enabled := False;
  End;
End;

Procedure TfrmMain.loadInstitutions;
Begin
  If ANURemoteProcedureCallInProgress = True Then
    Repeat application.processmessages Until ANURemoteProcedureCallInProgress = False;

  AnimateLogo(True);
  StatusBarLoadPt.Caption := 'Loading institutions...';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
  frmROFinder.button1Click(Application);
  (*
    {Load Institutions to Listbox}
    lstInstitutions.Items.Clear;
    RPCBroker1.RemoteProcedure := 'DVBAB INST LIST';

    RPCBrokerCall; try RPCBroker1.Call;
      except
    On EBrokerError do begin  ANURemoteProcedureCallInProgress:=False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption:='RPC INST LIST could not be accessed!'; StatusBarLoadPt.Repaint; Application.Processmessages;
      ShowMessageCAPRI('DVBAB INST LIST could not be accessed!');
    end; end;
    lstInstitutions.Items:=RPCBroker1.Results;
    // Load RO #'s...
    If lstInstitutions.Items.Count>0 then
       For yy:=0 to lstInstitutions.Items.Count-1 do
           FMRegionalOfficeNumber.Items.Add(Copy(lstInstitutions.Items[yy],1,Pos('^',lstInstitutions.Items[yy])-1));

    // Determine if fany entries have just -RO and if so, only show those.
    // Also show Central Office
    FoundRO:=False;
    If lstInstitutions.Items.Count>0 then begin
      For yy:=0 to lstInstitutions.Items.Count-1 do
        If Pos('-RO^',lstInstitutions.Items[yy])>0 then
          FoundRO:=True;
       If FoundRO=True then begin
         For yy:=lstInstitutions.Items.Count-1 downto 0 do
          If (Pos('-BVA/VBA-SO^',lstInstitutions.Items[yy])=0) and
             (Pos('-RO^',lstInstitutions.Items[yy])=0) and
             (Pos('-CO^',lstInstitutions.Items[yy])=0) and
             (Pos('CENTRAL OFFICE',lstInstitutions.Items[yy])=0) and
             (Pos('BVA',lstInstitutions.Items[yy])=0) and
             (Pos('-M&ROC',lstInstitutions.Items[yy])=0) and
             (Pos('-RO-OC',lstInstitutions.Items[yy])=0) and
             (Pos('-RO&IC',lstInstitutions.Items[yy])=0) and
             (Pos('VAMROC',lstInstitutions.Items[yy])=0) and
             (Pos('FARGO^',lstInstitutions.Items[yy])=0) and
             (Pos('VAHSRO',lstInstitutions.Items[yy])=0)
            then begin
            lstInstitutions.Items.Delete(yy);
            end;
       end;
    end;
    *)

  AnimateLogo(False);
  StatusBarLoadPt.Caption := 'Ready.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
End;

Procedure TfrmMain.btnView7131Click(Sender: TObject);
Begin
  If frmROFinder.ORListBoxSites.Items.Count = 0 Then
    LoadInstitutions;

  If FMSeventyOne31RequestListBox.ItemIndex = -1 Then
    exit;
  frmMain.RPCBroker1.Results.Clear;
  RPCBroker1.RemoteProcedure := 'DVBAB CHECK CREDENTIALS';
  RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'RPC DVBAB CHECK CREDENTIALS could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('RPC DVBAB CHECK CREDENTIALS could not be accessed!');
    End;
  End;
  If RPCBroker1.Results[0] <> '[OK]' Then
  Begin
    ShowMessageCAPRI(RPCBroker1.Results[0]);
    application.terminate;
    Exit;
  End;

  btnAddRequest.Enabled := False;
  BitBtnVistA.enabled := False;
  btnView7131.Enabled := False;
  btnGenerate7131Report.Enabled := False;
  // Set up form
  frmView7131 := TfrmView7131.Create(frmMain);
  frmView7131.FMGetsExamRequest.IENS := FMSeventyOne31RequestListbox.GetSelectedRecord.IEN;
  frmView7131.FMGetsExamRequest.GetAndFill;
  frmView7131.FMRoutingLocation.Items := listMedicalCenterDivision;
  frmView7131.FMRegionalOfficeNumber.Items.Clear;
  (*
     If lstInstitutions.Items.Count>0 then
       For x:=0 to lstInstitutions.Items.Count-1 do
           frmView7131.FMRegionalOfficeNumber.Items.Add(Copy(lstInstitutions.Items[x],1,Pos('^',lstInstitutions.Items[x])-1));
  *)
     // If credentials are ok, then continue
  frmView7131.Height := frmMain.Height - 32;
  If frmView7131.Height > 805 Then
    frmView7131.Height := 805;
  frmView7131.btnCancel.Top := frmView7131.Height - 81;
  frmView7131.Scrollbox1.Height := frmView7131.Height - 83;
  frmView7131.Top := 7 + frmMain.Top + ((frmMain.Height - frmView7131.Height) Div 2);
  frmView7131.Left := frmMain.Left + ((frmMain.Width - frmView7131.Width) Div 2);
  frmView7131.FMRegionalOfficeNumber.Text := frmView7131.FMRegionalOfficeNumberFake.Text;
  frmView7131.FMRoutingLocation.Text := frmView7131.FMRoutingLocationFake.Text;
  If frmView7131.FMChk1.Text = 'YES' Then
    frmView7131.Checkbox1.Checked := True
  Else
    frmView7131.Checkbox1.Checked := False;
  If frmView7131.FMChk2.Text = 'YES' Then
    frmView7131.Checkbox2.Checked := True
  Else
    frmView7131.Checkbox2.Checked := False;
  If frmView7131.FMChk3.Text = 'YES' Then
    frmView7131.Checkbox3.Checked := True
  Else
    frmView7131.Checkbox3.Checked := False;
  If frmView7131.FMChk4.Text = 'YES' Then
    frmView7131.Checkbox4.Checked := True
  Else
    frmView7131.Checkbox4.Checked := False;
  If frmView7131.FMChk5.Text = 'YES' Then
    frmView7131.Checkbox5.Checked := True
  Else
    frmView7131.Checkbox5.Checked := False;
  If frmView7131.FMChk6.Text = 'YES' Then
    frmView7131.Checkbox6.Checked := True
  Else
    frmView7131.Checkbox6.Checked := False;
  If frmView7131.FMChk7.Text = 'YES' Then
    frmView7131.Checkbox7.Checked := True
  Else
    frmView7131.Checkbox7.Checked := False;
  If frmView7131.FMChk8.Text = 'YES' Then
    frmView7131.Checkbox8.Checked := True
  Else
    frmView7131.Checkbox8.Checked := False;
  If frmView7131.FMChk9.Text = 'YES' Then
    frmView7131.Checkbox9.Checked := True
  Else
    frmView7131.Checkbox9.Checked := False;
  If frmView7131.FMChk10.Text = 'YES' Then
    frmView7131.Checkbox10.Checked := True
  Else
    frmView7131.Checkbox10.Checked := False;
  If ((Copy(FMSeventyOne31RequestListbox.Items[FMSeventyOne31RequestListbox.ItemIndex], 26, 99) = '') And (ReadOnlyMode = False)) Then
  Begin
    //Request not completed yet.  Allow edit of key fields.
    frmView7131.Checkbox4.Enabled := True;
    frmView7131.Checkbox5.Enabled := True;
    frmView7131.Checkbox6.Enabled := True;
    frmView7131.Checkbox7.Enabled := True;
    frmView7131.Checkbox8.Enabled := True;
    frmView7131.Checkbox10.Enabled := True;
    frmView7131.FMRegionalOfficeNumber.Enabled := True;
    frmView7131.FMTxReport.Enabled := True;
    frmView7131.FMRoutingLocation.Enabled := True;
    //frmView7131.FMAdmissionDate.Enabled:=True;
    frmView7131.FMCommentsMemo.ReadOnly := False;
  End
  Else
  Begin
    //Make Read Only.  Request has been completed.
    frmView7131.Checkbox1.Enabled := False;
    frmView7131.Checkbox2.Enabled := False;
    frmView7131.Checkbox3.Enabled := False;
    frmView7131.Checkbox4.Enabled := False;
    frmView7131.Checkbox5.Enabled := False;
    frmView7131.Checkbox6.Enabled := False;
    frmView7131.Checkbox7.Enabled := False;
    frmView7131.Checkbox8.Enabled := False;
    frmView7131.Checkbox9.Enabled := False;
    frmView7131.Checkbox10.Enabled := False;
    frmView7131.FMRegionalOfficeNumber.Enabled := False;
    frmView7131.FMTxReport.Enabled := False;
    frmView7131.FMRoutingLocation.Enabled := False;
    frmView7131.FMAdmissionDate.Enabled := False;
    frmView7131.FMCommentsMemo.ReadOnly := True;
  End;
  frmView7131.ScrollBox1.VertScrollBar.Position := 0;

  frmView7131.FMRegionalOfficeNumber.Enabled := False;

  ContextorChangeMessage := 'You are viewing/changing a 7131 request.  If you continue, you will lose your work.';
  CCOWBreakLink := True;
  Try
  frmView7131.CheckBox1.Setfocus Except
  End;
  frmView7131.ShowModal;
  frmView7131.release;
  frmView7131 := Nil;
  ContextorChangeMessage := '';
  CCOWBreakLink := False;

  SeventyOne31RequestRefreshClick(Application);

  if ESSOVersion then
    BitBtnVistA.enabled := True;                                                //only remote connections - rpm 3/17/09
  If ReadOnlyMode = False Then
    btnAddRequest.Enabled := True;
  If fmExamRequestListbox.ItemIndex > -1 Then
  Begin
    btnViewExam.Enabled := True;
    btnExamFinalReport.Enabled := True;
    btnGenerateReport.Enabled := True;
  End;
End;

Procedure TfrmMain.FMSeventyOne31RequestListboxClick(Sender: TObject);
Begin
  If FMSeventyOne31RequestListbox.ItemIndex > -1 Then
  Begin
    btnView7131.Enabled := True;
    btnGenerate7131Report.Enabled := True;
  End;
End;

Procedure TfrmMain.FMSeventyOne31RequestListboxDrawItem(
  Control: TWinControl; Index: Integer; Rect: TRect;
  State: TOwnerDrawState);
Begin
  If FMSeventyOne31RequestListbox.ItemIndex > -1 Then
  Begin
    btnView7131.Enabled := True;
    btnGenerate7131Report.enabled := true;
  End
  Else
  Begin
    btnView7131.Enabled := False;
    btnGenerate7131Report.enabled := true;
  End;
End;

Procedure TfrmMain.Button9Click(Sender: TObject);
Begin
  (*
    If (DateTimePicker1.Text='') or (ORDateBox2.Text='') then begin
      ShowMessageCAPRI('Please enter both a start and stop date.');
      exit;
    end;
  *)
End;

Procedure TfrmMain.FMRegionalOfficeNumberExit(Sender: TObject);
Var
  x: integer;
Begin
  If FMRegionalOfficeNumber.Text = '' Then
    exit;
  For x := 0 To FMRegionalOfficeNumber.Items.Count - 1 Do
    If Pos(uppercase(FMRegionalOfficeNumber.Text), uppercase(FMRegionalOfficeNumber.Items[x])) = 1 Then
    Begin
      FMRegionalOfficeNumber.ItemIndex := x;
    End;
  If FMRegionalOfficeNumber.ItemIndex = -1 Then
  Begin
    //ShowMessageCAPRI('The Regional Office you have entered is not in the list.');
    FMRegionalOfficeNumber.Text := '';
    Try
    FMRegionalOfficeNumber.Setfocus Except
    End;
    exit;
  End;
  FMRegionalOfficeNumberFake.Text := FMRegionalOfficeNumber.Text;
  (*
    If frmMain.lstInstitutions.Items.Count>0 then
      For x:=0 to frmMain.lstInstitutions.Items.Count-1 do
        If Pos(FMRegionalOfficeNumber.Text+'^',frmMain.lstInstitutions.Items[x])>0 then
          frmNew7131.FMRegionalOfficeNumberFake.Text:='`'+Piece(frmMain.lstInstitutions.Items[x],'^',4);
  *)
End;

Procedure TfrmMain.Splitter3Moved(Sender: TObject);
Begin
  PanelReportChoice2.Left := Splitter3.Left + 63;
End;

Procedure TfrmMain.btnGenerate7131ReportClick(Sender: TObject);
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;

  If btnGenerate7131report.Enabled = False Then
  Begin
    ShowMessageCAPRI('There are no previous 7131 requests on file.  This report cannot be run.');
    exit;
  End;
  If FMSeventyOne31RequestListbox.ItemIndex = -1 Then
  Begin
    ShowMessageCAPRI('Please select a 7131 requests first.  This report cannot be run.');
    exit;
  End;
  frmMain.RPCBroker1.Results.Clear;
  RPCBroker1.RemoteProcedure := 'DVBAB CHECK CREDENTIALS';
  RPCBroker1.Call;
  RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'RPC DVBAB CHECK CREDENTIALS could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('RPC DVBAB CHECK CREDENTIALS could not be accessed!');
    End;
  End;
  If RPCBroker1.Results[0] <> '[OK]' Then
  Begin
    ShowMessageCAPRI(RPCBroker1.Results[0]);
    application.terminate;
    Exit;
  End;
  // Set up form
  RPCBroker1.RemoteProcedure := 'DVBAB REPORT 7131INQ';
  RPCBroker1.Param[0].Value := PatientIEN;
  RPCBroker1.Param[0].PType := literal;
  RPCBroker1.Param[1].Value := FMSeventyOne31RequestListbox.GetSelectedRecord.IEN;
  RPCBroker1.Param[1].PType := literal;
  RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'RPC DVBAB REPORT 7131INQ could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('Connection to server for DVBAB REPORT 7131INQ could not be established!');
    End;
  End;
  ReportMemo.Lines.Clear;
  If frmMain.RPCBroker1.Results.Count > 0 Then
  Begin
    Repeat
      Begin
        Screen.Cursor := crHourglass;
        If Pos('^', frmMain.RPCBroker1.Results[0]) > 0 Then
        Begin
          ReportMemo.Lines.Add(Copy(frmMain.RPCBroker1.Results[0], 1, Pos('^', frmMain.RPCBroker1.Results[0]) - 1));
          frmMain.RPCBroker1.Results[0] := Copy(frmMain.RPCBroker1.Results[0], Pos('^', frmMain.RPCBroker1.Results[0]) + 1, Length(frmMain.RPCBroker1.Results[0]));
        End
        Else
        Begin
          ReportMemo.Lines.Add(frmMain.RPCBroker1.Results[0]);
          frmMain.RPCBroker1.Results[0] := '';
        End;
    End Until frmMain.RPCBroker1.Results[0] = '';
    //If ReportMemo.Lines.Count>0 then begin
    //  ReportMemo.Lines.Add(Copy(ReportMemo.Lines[ReportMemo.Lines.Count-1],Pos('Requested by:',ReportMemo.Lines[ReportMemo.Lines.Count-1]),999));
    //  ReportMemo.Lines[ReportMemo.Lines.Count-2]:=Copy(ReportMemo.Lines[ReportMemo.Lines.Count-2],1,Pos('Date of Request:',ReportMemo.Lines[ReportMemo.Lines.Count-2])+15)+' '+Piece(FMSeventyOne31RequestListbox.Items[FMSeventyOne31RequestListbox.ItemIndex],'@',1);
    //end;
    Screen.Cursor := crDefault;
  End;
  ORReportsAvailable.ItemIndex := 3;
  Page95Control1.ActivePage := TabReports
End;

Procedure TfrmMain.btnGenerateReportClick(Sender: TObject);
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;

  If FMExamRequestListBox.ItemIndex = -1 Then
    exit;
  frmMain.RPCBroker1.Results.Clear;
  RPCBroker1.RemoteProcedure := 'DVBAB CHECK CREDENTIALS';
  RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'RPC DVBAB CHECK CREDENTIALS could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('RPC DVBAB CHECK CREDENTIALS could not be accessed!');
    End;
  End;
  If RPCBroker1.Results[0] <> '[OK]' Then
  Begin
    ShowMessageCAPRI(RPCBroker1.Results[0]);
    application.terminate;
    Exit;
  End;
  // Set up form
  RPCBroker1.RemoteProcedure := 'DVBAB REPORT CPDETAILS';
  RPCBroker1.Param[0].Value := PatientIEN;
  RPCBroker1.Param[0].PType := literal;
  RPCBroker1.Param[1].Value := FMExamRequestListbox.GetSelectedRecord.IEN;
  RPCBroker1.Param[1].PType := literal;
  RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'RPC DVBAB REPORT CPDETAILS could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('Connection to server for DVBAB REPORT CPDETAILS could not be established!');
    End;
  End;

  //Build Report
  StatusBarLoadPt.Caption := 'Downloading report.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
  ANURemoteProcedureCallInProgress := true;
  ReportMemo.Lines.Clear;
  screen.cursor := crHourglass;

  ReportMemo.SetSelTextBuf(RPCBroker1.Results.GetText);

  screen.cursor := crDefault;
  ReportMemo.Visible := True;
  ANURemoteProcedureCallinProgress := False;
  AnimateLogo(False);
  StatusBarLoadPt.Caption := 'Ready.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
  //End Of Build Report
  ORReportsAvailable.ItemIndex := 2;
  ReportMemo.SelStart := 0;
  ReportMemo.SelLength := 0;
  Page95Control1.ActivePage := TabReports;
  Try
  ReportMemo.SetFocus Except
  End;
End;

Procedure TfrmMain.Page95Control1Change(Sender: TObject);
Var
  x: integer;
  StationNo: String;                                                            //required for Local FHIE connections
Begin
  StationNo := '';
  TabDOD.Enabled := True;                                                       // DoD tab is sometimes greying out.  This forces it to normal.

  SetFont;                                                                      // Force update of font just in case
  frmMain.FormResize(Application);

  If Page95Control1.ActivePage = TabCPExams Then
  Begin
    ExamRequestRefreshClick(Application);
  End;

  If Page95Control1.ActivePage = Tab7131Request Then
  Begin
    If FMSeventyOne31RequestListbox.ItemIndex = -1 Then
    Begin
      btnGenerate7131report.Enabled := False;
      btnView7131.Enabled := False;
    End
    Else
    Begin
      btnGenerate7131report.Enabled := True;
      btnView7131.Enabled := True;
    End;
  End;

  If Page95Control1.ActivePage = TabCPWorksheets Then
  Begin
    ButtonIPRRefreshClick(Application);
  End;

  If Page95Control1.ActivePage = TabHealthSummaries Then
  Begin
    If ESSOVersion = True Then
      buttonRDV.Enabled := False;
  End;

  If Page95Control1.ActivePage = TabClinicalDocuments Then
  Begin
    // -MER CodeCR177 3/2011 restore the tabs with hotkeys
    Tab95Control1.Tabs.Clear;
    Tab95Control1.Tabs.Add('&1)  Notes');
    Tab95Control1.Tabs.Add('&2)  Discharge Summaries');
    Tab95Control1.Tabs.Add('&3)  Consults');
    Tab95Control1.Tabs.Add('&4)  Vitals');
    Tab95Control1.Tabs.Add('&5)  Meds');
    Tab95Control1.Tabs.Add('&6)  Labs');
    Tab95Control1.Tabs.Add('&7)  Imaging');
    Tab95Control1.Tabs.Add('&8)  Diet');
    Tab95Control1.Tabs.Add('&9)  Nutritional Assessment');
    Tab95Control1.Tabs.Add('&U)  Order Summary');
    Tab95Control1.Tabs.Add('&Y)  Procedures');
    Tab95Control1.Tabs.Add('&Z)  Problem List');

    If Tab95Control1.TabIndex < 0 Then
      Tab95Control1.TabIndex := 0;
    Tab95Control1Change(Application);
    If ScreenReaderActive = True Then
      Page95Control1.SetFocus;
  end else begin
    // -MER CodeCR177 3/2011 Clear the tabs with hotkeys so they won't trap keystrokes
    Tab95Control1.Tabs.Clear;
  end;

  If Page95Control1.ActivePage <> TabClinicalDocuments Then
  Begin
    If FormReportBuilder <> Nil Then
      FormReportBuilder.Hide;
  End;

  If Page95Control1.ActivePage = TabVistAWeb Then
  Begin
    If VistAWebLoaded <> True Then
    Begin
      btnVistAWebHomeClick(Application);
      VistAWebLoaded := True;
    End;
  End;

  If Page95Control1.ActivePage = TabDOD Then
  Begin
    PanelDODGrids.Visible := False;
    If TabDOD.enabled = False Then
      exit;
    If LabelDoDInfo.Caption = '** NOT CONNECTED **' Then
    Begin
      AnimateLogo(True);
      StatusBarLoadPt.Caption := 'Populating DoD tab.';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      //Set DOD Broker division and get BSE token from home server
      RPCBrokerDOD.ANUstrDivisionHome := RPCBroker1.ANUstrDivisionHome;
      RPCBrokerDOD.Connect2HomeServer(RPCBroker1.ANUAccessCodeHome,
        RPCBroker1.ANUVerifyCodeHome,
        RPCBroker1.ANUstrServerHome,
        RPCBroker1.ANUstrPortHome,
        False);
      if NOT RPCBrokerDOD.CreateContext('DVBA CAPRI GUI') then
      begin
        ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
        application.terminate;
      end;

      RPCBrokerDOD.ANUFHIEConnection := True;
      //determine station number required for local FHIE connections;
      // short-circuit when no station number
      if NOT ESSOVersion then
      begin
        StationNo := Piece(GetDivision(ESSOVersion, RPCBrokerDOD), '^', 3);
        if StationNo = '' then
        begin
          RPCBrokerDOD.ANUFHIEConnection := False;
          RPCBrokerDOD.Connected := False;
          ShowMessageCapri('Could not determine local station number for FHIE connection.');
          Exit;
        end;
      end;
      RPCBrokerDOD.Connected := False;
      sleep(1000);
      RPCBrokerDOD.RPCTimeLimit := 28800;
      RPCBrokerDOD.Server := Piece(FHIESiteLocation, ',', 1);
      RPCBrokerDOD.ListenerPort := StrtoInt(Piece(FHIESiteLocation, ',', 2));
      RPCBrokerDOD.ANUUserSpecs :=
        AuthorSSN + '^' +
        AuthorName + '^' +
        UserDivision + '^' +                                                    // Site
        UserDivisionNumber + '^' +                                              // Site num
        AuthorIEN;

      //connect to remote server with BSE token
      if NOT RPCBrokerDOD.Connect2RemoteServer(RPCBrokerDOD.Server,
        IntToStr(RPCBrokerDOD.ListenerPort),
        False, True, StationNo) then
      begin
        AnimateLogo(False);
        RPCBrokerDOD.Connected := False;
        StatusBarLoadPt.Caption := 'FHIE Server unavailable.';
        StatusBarLoadPt.Repaint;
        Application.Processmessages;
        RPCBrokerDOD.Connected := False;
        ShowMessageCAPRI('FHIE Server cannot be accessed!');
        //RPCBroker1.Connected := true; BSE mod - replace with connecttoserver
        if NOT RPCBroker1.Connected then
          ConnectToServer('DVBA CAPRI GUI');
        RPCBrokerDOD.Connected := False;
        ESSOConnecting := True;
        exit;
      end;

      If Not RPCBrokerDOD.CreateContext('DVBA CAPRI GUI') Then
      Begin
        ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
        application.terminate;
      End;

      //LoadTypesFromServer
      RPCBrokerDOD.RemoteProcedure := 'DVBAB DOD REPORT TYPES';
      RPCBrokerDODCall;
      Try
        RPCBrokerDOD.Call;
      Except
        On EBrokerError Do
        Begin
          ANURemoteProcedureCallInProgress := False;
          AnimateLogo(False);
          StatusBarLoadPt.Caption := 'RPC DVBAB DOD REPORT TYPES could not be accessed!';
          StatusBarLoadPt.Repaint;
          Application.Processmessages;
          ShowMessageCAPRI('DVBAB DOD REPORT TYPES could not be accessed!');
        End;
      End;
      ORListBoxDODReportTypes.Items := RPCBrokerDOD.Results;
      StatusBarLoadPt.Caption := 'Getting info message.';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      RPCBrokerDOD.RemoteProcedure := 'DVBAB DOD INFO';
      RPCBrokerDODCall;
      Try
        RPCBrokerDOD.Call;
      Except
        On EBrokerError Do
        Begin
          ANURemoteProcedureCallInProgress := False;
          AnimateLogo(False);
          StatusBarLoadPt.Caption := 'RPC DVBAB DOD INFO could not be accessed!';
          StatusBarLoadPt.Repaint;
          Application.Processmessages;
          ShowMessageCAPRI('DVBAB DOD INFO could not be accessed!');
          RPCBrokerDOD.Connected := False;
          RPCBrokerDOD.ANUFHIEConnection := False;
          RPCBrokerDOD.Connected := False;
          ESSOConnecting := True;
          exit;
        End;
      End;
      LabelDoDInfo.Caption := RPCBrokerDOD.Results[0];

      screen.cursor := crHourglass;
      RPCBrokerDOD.Connected := False;
      sleep(1000);

      ESSOConnecting := True;
      For x := 1 To 500 Do
        application.processmessages;

      // The following code was changed because Togus was locking after an FHIE call

      RPCBroker1.Connected := False;
      sleep(1000);
      //RPCBroker1.Connected := true;  BSE mod - rpm 3/16/09
      If Not ConnectToServer('DVBA CAPRI GUI') Then
      Begin
        ShowMessageCAPRI('DOD1: Could not use option "DVBA CAPRI GUI!"');
        application.terminate;
      End;
      If RPCBroker1.Connected = False Then
      Begin
        ShowMessageCAPRI('DOD2: Could not use option "DVBA CAPRI GUI!"');
        application.terminate;
      End;

      Screen.cursor := crDefault;

      ESSOConnecting := False;

      //////////////////////////////////////////////////////////////////////////////

      StatusBarLoadPt.Caption := 'Ready.';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
    End;
    RichEditDODReport.Lines.Clear;
    PanelDODGrids.Visible := False;
    ORListBoxDODReportTypes.ItemIndex := -1;
    AnimateLogo(False);
    RPCBrokerDOD.ANUFHIEConnection := False;
  End;
  RPCBrokerDOD.ANUFHIEConnection := False;
  If Page95Control1.ActivePage = TabVocRehab Then                               //CodeCR347 - jrl 5/22/12
  Begin                                                                         //CodeCR347 - jrl 5/22/12
    // create VocRehab class if not done already         //CodeCR347 - jrl 5/22/12
    if not Assigned(VocRehab) then                                              //CodeCR347 - jrl 5/22/12
      VocRehab := TVocRehab.Create;                                             //CodeCR347 - jrl 5/22/12
    // Setup the Medical Services Request list for display on VocRehab tab  //CodeCR347 - jrl 5/22/12
    VocRehab.SetupMedicalServicesList;                                          //CodeCR347 - jrl 5/22/12
    if VAUtils.ScreenReaderActive then
    begin
      edtHeader.TabStop := TRUE;
      edtColumnHeader.TabStop := TRUE;
      edtHeader.SetFocus;
    end
    else
    begin
      edtHeader.TabStop := FALSE;
      edtColumnHeader.TabStop := FALSE;
      lbVocRehab.SetFocus;                                                      //CodeCR347 - jrl 5/22/12
    end;

    if lbVocRehab.ItemIndex <> -1 then                                          //CodeCR347 - jrl 5/22/12
      btnVREditRequest.Enabled := TRUE;                                         //CodeCR347 - jrl 5/22/12
  End;                                                                          //CodeCR347 - jrl 5/22/12

End;

Procedure TfrmMain.Tab95Control1Change(Sender: TObject);
Var
  x: integer;
  authornt: String;
  typ, stat: String;
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;

  Page95Control1.Enabled := False;                                              //CodeCR324 - rpm 3/6/12
  Tab95Control1.Enabled := False;
  buttonClinDocDateRange.Enabled := True;
  LabelDocsFound.Caption := '';
  buttonClinDocDateRange.Visible := True;
  LabelCurrentView.Visible := True;
  DivisionRun := False;
  AnimateLogo(True);
  StatusBarLoadPt.Caption := 'Re-populating choices...';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
  lstDocs.Visible := True;
  LastSearch := '';                                                             //CodeCR340 - jrl 5/01/12
  editSearchPN.Text := '';                                                      //CodeCR340 - jrl 5/01/12
  If Tab95Control1.Tabs[Tab95Control1.TabIndex] = '&1)  Notes' Then
  Begin
    If FormReportBuilder <> Nil Then
      formReportBuilder.ORAlignButtonAddAll.Enabled := True;
    btnDivisions.Enabled := True;
    buttonClinDocDateRange.Visible := True;
    Splitter2.Visible := True;
    PanelCount.Visible := True;
    PanelGraphVS.Visible := False;
    PanelSearch.Visible := True;                                                
    DocType := 'PN';
    memoDocs.Lines.Clear;
    LstDocs.Items.Clear;
    //frmMain.RPCBroker1.Results.Clear;
    RPCBroker1.RemoteProcedure := 'TIU DOCUMENTS BY CONTEXT';
    RPCBroker1.Param[1].Value := '3';                                           // 3= Progress Notes
    RPCBroker1.Param[1].PType := literal;
    RPCBroker1.Param[3].Value := PatientIEN;                                    // Patient IEN
    RPCBroker1.Param[3].PType := literal;
    If ClinDocDateRangeSelected = true Then
    Begin
      // -MER CodeCR122 9/2010
      RPCBroker1.Param[4].Value := FMToDateConvert(FormatDateTime('mm/dd/yyyy', FormDateRange.dtpStartDate.Date)); // start date
      RPCBroker1.Param[4].PType := literal;
      RPCBroker1.Param[5].Value := FMToDateConvert(FormatDateTime('mm/dd/yyyy', FormDateRange.dtpEndDate.Date)); // end date
      RPCBroker1.Param[5].PType := literal;
      RPCBroker1.Param[2].Value := '5';                                         // By date range
      RPCBroker1.Param[2].PType := literal;
    End
    Else
    Begin
      RPCBroker1.Param[4].Value := '-1';                                        // Date Range
      RPCBroker1.Param[4].PType := literal;
      RPCBroker1.Param[5].Value := '-1';                                        // Date Range
      RPCBroker1.Param[5].PType := literal;
      RPCBroker1.Param[2].Value := '1';                                         // All signed Documents
      RPCBroker1.Param[2].PType := literal;
    End;
    RPCBroker1.Param[6].Value := AuthorIEN;                                     // AuthorIEN;
    RPCBroker1.Param[6].PType := literal;
    RPCBroker1.Param[7].Value := IntToStr(NumberClinDocsToRetrieve);
    RPCBroker1.Param[7].PType := literal;
    RPCBroker1.Param[8].Value := 'D';
    RPCBroker1.Param[8].PType := literal;
    RPCBroker1.Param[9].Value := '1';
    RPCBroker1.Param[9].PType := literal;

    RPCBrokerCall;
    Try
      RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        AnimateLogo(False);
        StatusBarLoadPt.Caption := 'RPC TIU DOCUMENTS BY CONTEXT could not be accessed!';
        StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('RPC TIU DOCUMENTS BY CONTEXT could not be accessed!');
      End;
    End;
    listDocs.Clear;
    If RPCBroker1.Results.Count > 0 Then
      For x := 0 To RPCBroker1.Results.Count - 1 Do
        listDocs.add(RPCBroker1.Results[x]);
    If ListDocs.Count > 0 Then
      For x := 0 To ListDocs.Count - 1 Do
      Begin
        AuthorNT := Piece(listdocs[x], '^', 5);
        AuthorNT := Copy(AuthorNT, pos(';', AuthorNT) + 1, 99);
        lstDocs.Items.Add(FMDateTimeConvert(Piece(listdocs[x], '^', 3)) + ', ' + Piece(listdocs[x], '^', 2) + ', ' + authornt + ', ' + Piece(listdocs[x], '^', 7) + ' ^' + Piece(listdocs[x], '^', 1));
      End;
    If ListDocs.Count = 0 Then
    Begin
      MemoDocs.Lines.Add('');
      MemoDocs.Lines.Add('No progress notes found.');
    End;

    If (ScreenReaderActive = False) and IsSetFocusValid(lstDocs) Then
      lstDocs.SetFocus;

    If lstDocs.Items.Count > 0 Then
    Begin
      lstDocs.ItemIndex := 0;
      lstDocs.Selected[0] := TRUE;                                              //-MER CodeCR126 7/2010
      lstDocsClick(Application);
    End;
  End;
  If Tab95Control1.Tabs[Tab95Control1.TabIndex] = '&2)  Discharge Summaries' Then
  Begin
    If FormReportBuilder <> Nil Then
      formReportBuilder.ORAlignButtonAddAll.Enabled := True;
    buttonClinDocDateRange.Visible := True;
    Splitter2.Visible := True;
    PanelCount.Visible := False;
    PanelGraphVS.Visible := False;
    PanelSearch.Visible := True;                                                
    DocType := 'DS';
    memoDocs.Lines.Clear;
    LstDocs.Items.Clear;
    frmMain.RPCBroker1.Results.Clear;
    RPCBroker1.RemoteProcedure := 'TIU DOCUMENTS BY CONTEXT';
    RPCBroker1.Param[1].Value := '244';                                         // 244= Discharge Summaries
    RPCBroker1.Param[1].PType := literal;
    RPCBroker1.Param[3].Value := PatientIEN;                                    // Patient IEN
    RPCBroker1.Param[3].PType := literal;
    If ClinDocDateRangeSelected = true Then
    Begin
      // -MER CodeCR122 9/2010
      RPCBroker1.Param[4].Value := FMToDateConvert(FormatDateTime('mm/dd/yyyy', FormDateRange.dtpStartDate.Date)); // start date
      RPCBroker1.Param[4].PType := literal;
      RPCBroker1.Param[5].Value := FMToDateConvert(FormatDateTime('mm/dd/yyyy', FormDateRange.dtpEndDate.Date)); // end date
      RPCBroker1.Param[5].PType := literal;
      RPCBroker1.Param[2].Value := '5';                                         // By date range
      RPCBroker1.Param[2].PType := literal;
    End
    Else
    Begin
      RPCBroker1.Param[4].Value := '0';                                         // Date Range
      RPCBroker1.Param[4].PType := literal;
      RPCBroker1.Param[5].Value := '0';                                         // Date Range
      RPCBroker1.Param[5].PType := literal;
      RPCBroker1.Param[2].Value := '1';                                         // All signed Documents
      RPCBroker1.Param[2].PType := literal;
    End;
    RPCBroker1.Param[6].Value := AuthorIEN;                                     // AuthorIEN;
    RPCBroker1.Param[6].PType := literal;
    RPCBroker1.Param[7].Value := '9999999';
    RPCBroker1.Param[7].PType := literal;
    RPCBroker1.Param[8].Value := 'D';
    RPCBroker1.Param[8].PType := literal;
    Try
      RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        AnimateLogo(False);
        StatusBarLoadPt.Caption := 'RPC TIU DOCUMENTS BY CONTEXT could not be accessed!';
        StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('RPC TIU DOCUMENTS BY CONTEXT could not be accessed!');
      End
    End;
    listDocs.Clear;
    If RPCBroker1.Results.Count > 0 Then
      For x := 0 To RPCBroker1.Results.Count - 1 Do
        listDocs.add(RPCBroker1.Results[x]);
    If ListDocs.Count > 0 Then
      For x := 0 To ListDocs.Count - 1 Do
      Begin
        AuthorNT := Piece(listdocs[x], '^', 5);
        AuthorNT := Copy(AuthorNT, pos(';', AuthorNT) + 1, 99);
        lstDocs.Items.Add(FMDateTimeConvert(Piece(listdocs[x], '^', 3)) + ', ' + Piece(listdocs[x], '^', 2) + ', ' + authornt + ', ' + Piece(listdocs[x], '^', 7) + ' ^' + Piece(listdocs[x], '^', 1));
      End;
    If ListDocs.Count = 0 Then
    Begin
      MemoDocs.Lines.Add('');
      MemoDocs.Lines.Add('No discharge summaries found.');
    End;
    Try
      If ScreenReaderActive = False Then
    lstDocs.SetFocus Except
    End;
    If lstDocs.Items.Count > 0 Then
    Begin
      lstDocs.ItemIndex := 0;
      lstDocs.Selected[0] := TRUE;                                              //-MER CodeCR126 7/2010
      lstDocsClick(Application);
    End;
  End;
  If Tab95Control1.Tabs[Tab95Control1.TabIndex] = '&3)  Consults' Then
  Begin
    If FormReportBuilder <> Nil Then
      formReportBuilder.ORAlignButtonAddAll.Enabled := True;
    buttonClinDocDateRange.Visible := True;
//  Splitter2.Visible := False;
    Splitter2.Visible := True;                                                  //CodeCR696 JRL 4/8/15
    PanelCount.Visible := False;
    PanelGraphVS.Visible := False;
    PanelSearch.Visible := TRUE;                                                //CodeCR696 JRL 4/8/15
    DocType := 'CN';
    memoDocs.Lines.Clear;
    LstDocs.Items.Clear;
    frmMain.RPCBroker1.Results.Clear;
    RPCBroker1.RemoteProcedure := 'ORQQCN LIST';
    RPCBroker1.Param[1].Value := PatientIEN;                                    // Patient IEN
    RPCBroker1.Param[1].PType := literal;
    If ClinDocDateRangeSelected = true Then
    Begin
      // -MER CodeCR122 9/2010
      RPCBroker1.Param[2].Value := FMToDateConvert(FormatDateTime('mm/dd/yyyy', FormDateRange.dtpStartDate.Date)); // start date
      RPCBroker1.Param[2].PType := literal;
      RPCBroker1.Param[3].Value := FMToDateConvert(FormatDateTime('mm/dd/yyyy', FormDateRange.dtpEndDate.Date)); // end date
      RPCBroker1.Param[3].PType := literal;
    End;

    Try
      RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        AnimateLogo(False);
        StatusBarLoadPt.Caption := 'RPC ORQQCN LIST could not be accessed!';
        StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('RPC ORQQCN LIST could not be accessed!');
      End
    End;
    listDocs.Clear;
    If RPCBroker1.Results.Count > 0 Then
      For x := 0 To RPCBroker1.Results.Count - 1 Do
        listDocs.add(RPCBroker1.Results[x]);
    If ListDocs.Count > 0 Then
      For x := 0 To ListDocs.Count - 1 Do
      Begin
        lstDocs.Items.Add(FMDateTimeConvert(Piece(listdocs[x], '^', 2)) + ' (' + Piece(listdocs[x], '^', 3) + ') ' + Piece(listdocs[x], '^', 4) + ' ^' + Piece(listdocs[x], '^', 1));
      End;
    If ListDocs.Count = 0 Then
    Begin
      MemoDocs.Lines.Add('');
      MemoDocs.Lines.Add('No consults found.');
    End;
    If (lstDocs.Items.Count > 0) And (Pos('PATIENT DOES NOT HAVE ANY', lstDocs.Items[0]) > 0) Then
    Begin
      MemoDocs.Lines.Add('');
      MemoDocs.Lines.Add('No consults found.');
      lstDocs.Items.Clear;
    End;

    If (ScreenReaderActive = False) and IsSetFocusValid(lstDocs) Then
      lstDocs.SetFocus;

    If lstDocs.Items.Count > 0 Then
    Begin
      lstDocs.ItemIndex := 0;
      lstDocs.Selected[0] := TRUE;                                              //-MER CodeCR126 7/2010
      lstDocsClick(Application);
    End;
  End;
  If Tab95Control1.Tabs[Tab95Control1.TabIndex] = '&4)  Vitals' Then
  Begin
    If FormReportBuilder <> Nil Then
      formReportBuilder.ORAlignButtonAddAll.Enabled := False;
    buttonClinDocDateRange.Visible := False;
    LabelCurrentView.Visible := False;
    Splitter2.Visible := False;
    PanelCount.Visible := False;
    PanelGraphVS.Visible := True;
    btnGraphVS.enabled := True;
    PanelSearch.Visible := False;                                               
    DocType := 'VS';
    memoDocs.Lines.Clear;
    LstDocs.Items.Clear;
    LstDocs.Items.Add('Today');
    LstDocs.Items.Add('One Week Back');
    LstDocs.Items.Add('Two Weeks Back');
    LstDocs.Items.Add('One Month Back');
    LstDocs.Items.Add('Six Months Back');
    LstDocs.Items.Add('One Year Back');
    LstDocs.Items.Add('Two Years Back');
    LstDocs.Items.Add('Five Years Back');
    LstDocs.Items.Add('ALL Vitals');
    //LstDocs.Items.Add('Graph');
  (* Defect #2199 - rpm 4/21/09 - Exceeding the Items array count by setting
     the ItemIndex to 9 causes the listbox to set the ItemIndex to -1.  Appears
     to be an incomplete future enhancement.
    If ClinDocDateRangeSelected = true Then
      LstDocs.ItemIndex := 9
    Else
  *)
    lstDocs.ItemIndex := 0;
    lstDocs.Selected[0] := TRUE;                                                //-MER CodeCR126 7/2010
    Try
      If ScreenReaderActive = False Then
        lstDocs.SetFocus;
    Except
    End;
    LstDocsClick(Application);
  End;
  If Tab95Control1.Tabs[Tab95Control1.TabIndex] = '&5)  Meds' Then
  Begin
    If FormReportBuilder <> Nil Then
      formReportBuilder.ORAlignButtonAddAll.Enabled := False;
    buttonClinDocDateRange.Visible := False;
    LabelCurrentView.Visible := False;
    Splitter2.Visible := False;
    PanelCount.Visible := False;
    PanelGraphVS.Visible := False;
    PanelSearch.Visible := False;                                               
    DocType := 'MEDS';
    memoDocs.Lines.Clear;
    LstDocs.Items.Clear;
    LstDocs.Items.Add('Outpatient Rx Action Profile');
    LstDocs.Items.Add('Outpatient History All');
    LstDocs.Items.Add('Outpatient History By Date Range');
    LstDocs.Items.Add('Inpatient History All');
    LstDocs.Items.Add('Inpatient History By Date Range');
    LstDocs.Items.Add('Inpatient Unit Dose History All');
    LstDocs.Items.Add('Inpatient Unit Dose History By Date Range');
    LstDocs.Items.Add('Inpatient IV History All');
    LstDocs.Items.Add('Inpatient IV History By Date Range');
    LstDocs.Items.Add('Active Outpatient');
    LstDocs.Items.Add('Active Inpatient');
    LstDocs.Items.Add('Active Inpatient Unit Dose');
    LstDocs.Items.Add('Active Inpatient IV');
    LstDocs.Items.Add('Med Admin History (BCMA) By Date Range');
    lstDocs.ItemIndex := 0;
    lstDocs.Selected[0] := TRUE;                                                //-MER CodeCR126 7/2010
    Try
      If ScreenReaderActive = False Then
    lstDocs.SetFocus Except
    End;
    LstDocsClick(Application);
  End;
  If Tab95Control1.Tabs[Tab95Control1.TabIndex] = '&6)  Labs' Then
  Begin
    If FormReportBuilder <> Nil Then
      formReportBuilder.ORAlignButtonAddAll.Enabled := False;
    buttonClinDocDateRange.Visible := False;
    LabelCurrentView.Visible := False;
    Splitter2.Visible := False;
    PanelCount.Visible := False;
    PanelGraphVS.Visible := False;
    PanelSearch.Visible := False;                                               
    DocType := 'LAB';
    memoDocs.Lines.Clear;
    LstDocs.Items.Clear;
    LstDocs.Items.Add('Cumulative 1 week');
    LstDocs.Items.Add('Cumulative 2 weeks');
    LstDocs.Items.Add('Cumulative 1 month');
    LstDocs.Items.Add('Cumulative 6 months');
    LstDocs.Items.Add('Cumulative 1 year');
    LstDocs.Items.Add('Cumulative 2 years');
    LstDocs.Items.Add('Cumulative 5 years');
    LstDocs.Items.Add('Cumulative ALL');
    LstDocs.Items.Add('Anatomic Pathology');
    LstDocs.Items.Add('Blood Bank');
    LstDocs.Items.Add('Microbiology');
    LstDocs.Items.Add('Graph');
    lstDocs.ItemIndex := 0;
    lstDocs.Selected[0] := TRUE;                                                //-MER CodeCR126 7/2010
    frmMain.Repaint;
    Try
      If ScreenReaderActive = False Then
    lstDocs.SetFocus Except
    End;
    LstDocsClick(Application);
  End;
  If Tab95Control1.Tabs[Tab95Control1.TabIndex] = '&7)  Imaging' Then
  Begin
    If FormReportBuilder <> Nil Then
      formReportBuilder.ORAlignButtonAddAll.Enabled := True;
    buttonClinDocDateRange.Visible := False;
    LabelCurrentView.Visible := False;
//  Splitter2.Visible := False;
    Splitter2.Visible := True;                                                  //CodeCR696 JRL 4/8/15
    PanelCount.Visible := False;
    PanelGraphVS.Visible := False;
//  PanelSearch.Visible := False;                                             
    PanelSearch.Visible := True;                                                //CodeCR696 JRL 4/8/15
    DocType := 'IMAGING';
    memoDocs.Lines.Clear;
    LstDocs.Items.Clear;
    //frmMain.RPCBroker1.Results.Clear;
    RPCBroker1.RemoteProcedure := 'ORWRA IMAGING EXAMS';
    RPCBroker1.Param[1].Value := PatientIEN;                                    // Patient IEN
    RPCBroker1.Param[1].PType := literal;
    Try
      RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        AnimateLogo(False);
        StatusBarLoadPt.Caption := 'RPC DVBAB ORWRA IMAGING EXAMS could not be accessed!';
        StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('RPC DVBAB ORWRA IMAGING EXAMS could not be accessed!');
      End
    End;
    listDocs.Clear;
    If RPCBroker1.Results.Count > 0 Then
      For x := 0 To RPCBroker1.Results.Count - 1 Do
        listDocs.add(RPCBroker1.Results[x]);
    If ListDocs.Count > 0 Then
      For x := 0 To ListDocs.Count - 1 Do
      Begin
        typ := Piece(listdocs[x], '^', 3);
        stat := Piece(listdocs[x], '^', 5);
        lstDocs.Items.Add(FMDateTimeConvert(Piece(listdocs[x], '^', 2)) + '  ' + typ + '  ' + stat + ' ^' + Piece(listdocs[x], '^', 1) + '#' + Piece(listdocs[x], '^', 4));
      End;
    If ListDocs.Count = 0 Then
    Begin
      MemoDocs.Lines.Add('');
      MemoDocs.Lines.Add('No images found...');
    End;
    Try
      If ScreenReaderActive = False Then
    lstDocs.SetFocus Except
    End;
    If lstDocs.Items.Count > 0 Then
    Begin
      lstDocs.ItemIndex := 0;
      lstDocs.Selected[0] := TRUE;                                              //-MER CodeCR126 7/2010
      lstDocsClick(Application);
    End;
  End;
  If Tab95Control1.Tabs[Tab95Control1.TabIndex] = '&8)  Diet' Then
  Begin
    If FormReportBuilder <> Nil Then
      formReportBuilder.ORAlignButtonAddAll.Enabled := False;
    buttonClinDocDateRange.Visible := False;
    LabelCurrentView.Visible := False;
    Splitter2.Visible := False;
    PanelCount.Visible := False;
    PanelGraphVS.Visible := False;
    PanelSearch.Visible := False;                                               
    DocType := 'DIET';
    memoDocs.Lines.Clear;
    LstDocs.Items.Clear;
    LstDocs.ItemIndex := -1;
    Try
      If ScreenReaderActive = False Then
    lstDocs.SetFocus Except
    End;
    LstDocsClick(Application);
  End;
  If Tab95Control1.Tabs[Tab95Control1.TabIndex] = '&9)  Nutritional Assessment' Then
  Begin
    If FormReportBuilder <> Nil Then
      formReportBuilder.ORAlignButtonAddAll.Enabled := True;
    buttonClinDocDateRange.Visible := False;
    LabelCurrentView.Visible := False;
//  Splitter2.Visible := False;
    Splitter2.Visible := True;                                                  //CodeCR696 JRL 4/8/15
    PanelCount.Visible := False;
    PanelGraphVS.Visible := False;
//  PanelSearch.Visible := False;                                             
    PanelSearch.Visible := True;                                                //CodeCR696 JRL 4/8/15
    DocType := 'NUTASSESS';
    memoDocs.Lines.Clear;
    LstDocs.Items.Clear;
    lbNUTASSESSSearchIndex.Items.Clear; // CodeCR696 JRL 4/10/15
    frmMain.RPCBroker1.Results.Clear;
    RPCBroker1.RemoteProcedure := 'ORWRP1 LISTNUTR';
    RPCBroker1.Param[1].Value := PatientIEN;                                    // Patient IEN
    RPCBroker1.Param[1].PType := literal;
    Try
      RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        AnimateLogo(False);
        StatusBarLoadPt.Caption := 'RPC ORWRP1 LISTNUTR could not be accessed!';
        StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('RPC ORWRP1 LISTNUTR could not be accessed!');
      End
    End;
    listDocs.Clear;

    If RPCBroker1.Results.Count > 0 Then
      For x := 0 To RPCBroker1.Results.Count - 1 Do
        listDocs.add(RPCBroker1.Results[x]);
    If ListDocs.Count > 0 Then
      For x := 0 To ListDocs.Count - 1 Do
      Begin
        If Piece(RPCBroker1.Results[x], '^', 3) <> '' Then
        Begin
          CPRSVersion := 'V16';
          lstDocs.Items.Add(Piece(RPCBroker1.Results[x], '^', 3));
          lbNUTASSESSSearchIndex.Items.Add(Piece(RPCBroker1.Results[x], '^', 3));  // CodeCR696 JRL 4/10/15
        End
        Else
        Begin
          CPRSVersion := 'V15';
          lstDocs.Items.Add(RPCBroker1.Results[x]);
        End;
      End;
    Try
      If ScreenReaderActive = False Then
    lstDocs.SetFocus Except
    End;
    If ListDocs.Count = 0 Then
    Begin
      MemoDocs.Lines.Add('');
      MemoDocs.Lines.Add('No nutritional assessments found.');
    End;
    If lstDocs.Items.Count > 0 Then
    Begin
      lstDocs.ItemIndex := 0;
      lstDocs.Selected[0] := TRUE;                                              //-MER CodeCR126 7/2010
      lstDocsClick(Application);
    End;
  End;
  If Tab95Control1.Tabs[Tab95Control1.TabIndex] = '&U)  Order Summary' Then
  Begin
    If FormReportBuilder <> Nil Then
      formReportBuilder.ORAlignButtonAddAll.Enabled := False;
    buttonClinDocDateRange.Visible := False;
    LabelCurrentView.Visible := False;
    Splitter2.Visible := False;
    PanelCount.Visible := False;
    PanelGraphVS.Visible := False;
    PanelSearch.Visible := False;                                               
    DocType := 'ORDERS';
    memoDocs.Lines.Clear;
    LstDocs.Items.Clear;
    LstDocs.Items.Add('Today');
    LstDocs.Items.Add('One Week Back');
    LstDocs.Items.Add('Two Weeks Back');
    LstDocs.Items.Add('One Month Back');
    LstDocs.Items.Add('Six Months Back');
    LstDocs.Items.Add('One Year Back');
    LstDocs.Items.Add('Two Years Back');
    LstDocs.Items.Add('Five Years Back');
    LstDocs.Items.Add('ALL Orders');
    lstDocs.ItemIndex := 0;
    lstDocs.Selected[0] := TRUE;                                                //-MER CodeCR126 7/2010
    Try
      If ScreenReaderActive = False Then
    lstDocs.SetFocus Except
    End;
    LstDocsClick(Application);
  End;
  If Tab95Control1.Tabs[Tab95Control1.TabIndex] = '&Y)  Procedures' Then
  Begin
    If FormReportBuilder <> Nil Then
      formReportBuilder.ORAlignButtonAddAll.Enabled := True;
    buttonClinDocDateRange.Visible := False;
//  Splitter2.Visible := False;
    Splitter2.Visible := True;                                                  //CodeCR696 JRL 4/8/15
    PanelCount.Visible := False;
    PanelGraphVS.Visible := False;
//  PanelSearch.Visible := False;                                            
    PanelSearch.Visible := True;                                                //CodeCR696 JRL 4/8/15
    DocType := 'PROCEDURES';
    memoDocs.Lines.Clear;
    LstDocs.Items.Clear;
    frmMain.RPCBroker1.Results.Clear;

    RPCBroker1.RemoteProcedure := 'ORWMC PATIENT PROCEDURES';
    RPCBroker1.Param[1].Value := PatientIEN;                                    // Patient IEN
    RPCBroker1.Param[1].PType := literal;
    Try
      RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        AnimateLogo(False);
        StatusBarLoadPt.Caption := 'RPC ORWMC PATIENT PROCEDURES could not be accessed!';
        StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('RPC ORWMC PATIENT PROCEDURES could not be accessed!');
      End
    End;
    listDocs.Clear;
    If RPCBroker1.Results.Count > 0 Then
      For x := 0 To RPCBroker1.Results.Count - 1 Do
        listDocs.add(RPCBroker1.Results[x]);
    If ListDocs.Count > 0 Then
      For x := 0 To ListDocs.Count - 1 Do
      Begin
        lstDocs.Items.Add(Piece(listdocs[x], '^', 7) + '  ' + Piece(listdocs[x], '^', 2) + '  (' + Piece(listdocs[x], '^', 8) + ') ^' + Piece(listdocs[x], '^', 1));
      End;
    If ListDocs.Count = 0 Then
    Begin
      MemoDocs.Lines.Add('');
      MemoDocs.Lines.Add('No procedures found.');
    End;
    If (lstDocs.Items.Count > 0) And (Pos('PATIENT DOES NOT HAVE ANY', lstDocs.Items[0]) > 0) Then
    Begin
      MemoDocs.Lines.Add('');
      MemoDocs.Lines.Add('No procedures found.');
      lstDocs.Items.Clear;
    End;
    Try
      If ScreenReaderActive = False Then
    lstDocs.SetFocus Except
    End;
    If lstDocs.Items.Count > 0 Then
    Begin
      lstDocs.ItemIndex := 0;
      lstDocs.Selected[0] := TRUE;                                              //-MER CodeCR126 7/2010
      lstDocsClick(Application);
    End;
  End;
  If Tab95Control1.Tabs[Tab95Control1.TabIndex] = '&Z)  Problem List' Then
  Begin
    If FormReportBuilder <> Nil Then
      formReportBuilder.ORAlignButtonAddAll.Enabled := False;
    buttonClinDocDateRange.Visible := False;
    LabelCurrentView.Visible := False;
    Splitter2.Visible := False;
    PanelCount.Visible := False;
    PanelGraphVS.Visible := False;
    PanelSearch.Visible := False;                                               
    DocType := 'PROBLEM LIST';
    memoDocs.Lines.Clear;
    LstDocs.Items.Clear;
    LstDocs.Items.Add('Active');
    LstDocs.Items.Add('Inactive');
    LstDocs.Items.Add('Both Active and Inactive');
    lstDocs.ItemIndex := 0;
    lstDocs.Selected[0] := TRUE;                                                //-MER CodeCR126 7/2010
    Try
      If ScreenReaderActive = False Then
    lstDocs.SetFocus Except
    End;
    LstDocsClick(Application);
  End;
  Tab95Control1.Enabled := True;
  Page95Control1.Enabled := True;                                               //CodeCR324 - rpm 3/6/12
  //rpm 3/31/09 - Defect #2178: prevent error when quickly switching tabs
  if IsSetFocusValid(Tab95Control1) then
    Tab95Control1.SetFocus;
  AnimateLogo(False);
  StatusBarLoadPt.Caption := 'Ready.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
  //zz
End;

Procedure TfrmMain.TimeoutTimerTimer(Sender: TObject);
Var
  TabReOrder: boolean;
  x: integer;
  tempIEN: String;
  temp2IEN: integer;
  tempFMListBox: TFMListBox;
Begin

  If ESSOVersion = False Then
    If CCOWMode = True Then
      If ContextorControl.State = 3 Then
      Begin
        CCOWSuspended := True;
        BitBtnCCOWLinkBroken.Visible := True;
        BitBtnCCOWLink.Visible := False;
        BitBtnCCOWLinkChanging.Visible := False;
      End;

  // 2 = connected
  // 3 = Suspended

  // Make sure everything is shut down before turning off the flag
  If ShutdownCAPRIModalDialogs = true Then
  Begin
    // Don't need to check forms that force CAPRI to exit context
    If frmBrowseTemplates = Nil Then
      If frmAboutForm = Nil Then
        If UnsignedView = Nil Then
          If frmPatientList = Nil Then
            If frmNewExam = Nil Then
              If frmView7131 = Nil Then
                ShutDownCAPRIModalDialogs := false
  End;

  If ANURemoteProcedureCallInProgress = True Then
    exit;

  TimeOutTimer.Enabled := False;
  Inc(TimeSinceLastBrokerCall);

  If SendPNCSEvent <> '' Then
  Begin
    inc(SendPNCSCounter);
    If SendPNCSCounter = 2 Then
    Begin
      // This keeps keyclicks from sending so many PNCSEvent messages and
      // sends one every 1 second instead.  This helps long scripts in PNCS
      // from making the app feel sluggish.
        //PNCSEvent:=SendPNCSEvent;
      PauseScript := False;
      PNCSEventControl := SendPNCSEvent;
      PNCSEvent := True;
      SendPNCSCounter := 0;
      SendPNCSEvent := '';
    End;
  End;

  If PNCSform = Nil Then
    If haltflag = true Then
    Begin
      If appstarted = true Then
      Begin
        frmMain.Close;
      End;
    End;

  If (ANURefreshCPWMTitles = True) And (Page95Control1.ActivePage = TabCPWorksheets) Then
  Begin
    ANURefreshCPWMTitles := False;
    ButtonIPRRefreshClick(Application);
  End;

  If (TimeSinceLastBrokerCall = 30) And (ANURemoteProcedureCallInProgress = False) Then
  Begin
    SaveCAPRISettings;                                                          // Save window position and such for next session
    screen.cursor := crArrow;
    // This call is only used as a keep alive function.
    // Nothing is done with the returned data.

    //CAPRI_CodeCR95  - jcs - 05/20/2010
    // left original (commented out) code, for now...

    if not CallRPC(RPCBroker1, 'XWB GET VARIABLE VALUE', ['DUZ'], nil, True) then
      exit;

//    RPCBroker1.RemoteProcedure := 'XWB GET VARIABLE VALUE';
//    RPCBroker1.Param[0].Value := 'DUZ';
//    RPCBroker1.Param[0].PType := reference;
//    RPCBrokerCall;
//    Try
//      RPCBroker1.Call;
//    Except
//      On EBrokerError Do
//      Begin
//        ANURemoteProcedureCallInProgress := False;
//        AnimateLogo(False);
//        If Not RPCBroker1.Connected Then
//          If PNCSForm <> Nil Then
//          Begin
//            StatusBarLoadPt.Caption := 'No connection to VistA!';
//            ProgressBarLoadPt.Repaint;
//            frmMain.Repaint;
//            ShowMessageCAPRI('The connection to VistA has been lost!');
//          End
//          Else
//            If PNCSForm <> Nil Then
//            Begin
//              StatusBarLoadPt.Caption := 'RPC XWB GET VARIABLE VALUE could not be accessed!';
//              ProgressBarLoadPt.Repaint;
//              frmMain.Repaint;
//              ShowMessageCAPRI('XWB GET VARIABLE VALUE could not be accessed!');
//            End;
//      End; { on }
//    End; { try/except }
    screen.cursor := crdefault;
    TimeSinceLastBrokerCall := 0;
  End;

  If TimeOutVal > 0 Then
    Inc(TimeOutCount);
  If TimeOutVal = 0 Then
    TimeOutCount := 0;
  { DEFECT #1965 - rpm 12/11/08 - moved closereview to PNCSMain.ReviewEventsDialog
  If PNCSForm <> Nil Then // SPH 10/19/2007
    If FormReviewerUtility <> Nil Then
    Begin
      If formReviewerUtility.Caption = '~CLOSE~' Then
      Begin
        formReviewerUtility.Caption := 'Review Events';
        formReviewerUtility.Visible := False;
        pncsform.CloseReview;
      End;
    End;
  }
  If pncsform <> Nil Then
  Begin
    If (Piece(PNCSForm.TemplateAction, '~', 2) = 'CLOSE') Then                  //CodeCR107 - rpm 5/12/10
    Begin

      // Handle unlocking the node
      If (RPCBroker1.Connected) And (PNCSForm.xFMEdit2.IENS <> '') Then
      Begin
        If LockNode(frmmain.RPCBroker1, '^DVB(396.17,' + Piece(PNCSForm.xFMEdit2.IENS, ',', 1) + ',8)', UnLock, 5) = true Then
        Begin
          //
        End
        Else
        Begin
          ShowmessageCAPRI('The form could not be unlocked.  There may be problems opening it for you or other users until this CAPRI session is closed.');
        End;
      End;

      If PNCSForm.xCCOWTimer.Enabled = True Then
        PNCSForm.xCCOWTimer.Enabled := False;
      If UnsignedView <> Nil Then
      Begin
        If UnsignedView.Label1.Caption = '1' Then
          UnsignedView.button5Click(Application);
        If UnsignedView.Label1.Caption = '2' Then
          UnsignedView.button3Click(Application);
        If UnsignedView.Label1.Caption = '3' Then
          UnsignedView.button6Click(Application);
        If UnsignedView.Label1.Caption = '4' Then
          UnsignedView.button4Click(Application);
      End;

      { Release FormReviewerUtility first - reverse order of creation }
      If FormReviewerUtility <> nil Then
      Begin
        If FormReviewerUtility.Owner = Nil Then
          FreeAndNil(FormReviewerUtility)
        Else
        Begin
          FormReviewerUtility.Owner.RemoveComponent(FormReviewerUtility);
          FreeAndNil(FormReviewerUtility);
        End;
      End;
      If PNCSForm <> nil Then
      Begin
        If PNCSForm.Owner = Nil Then
          FreeAndNil(PNCSForm)
        Else
        Begin
          PNCSForm.Owner.RemoveComponent(PNCSForm);
          If assigned(PNCSForm) Then
            FreeAndNil(PNCSForm);
        End;
      End;

      formRunning := False;
      If (Page95Control1.Visible = true) And (RPCBroker1.Connected) Then
        buttonIPRRefreshClick(Application);
    End
    Else
      If (Piece(PNCSForm.TemplateAction, '~', 2) = 'RELOAD') Then               //CodeCR107 - rpm 5/12/10
      Begin

        // Handle unlocking the node
        If PNCSForm.xFMEdit2.IENS <> '' Then
        Begin
          If LockNode(frmmain.RPCBroker1, '^DVB(396.17,' + Piece(PNCSForm.xFMEdit2.IENS, ',', 1) + ',8)', UnLock, 5) = true Then
          Begin
          End
          Else
          Begin
            ShowmessageCAPRI('The form could not be unlocked.  There may be problems opening it for you or other users until this CAPRI session is closed.');
          End;
        End;

        TabReOrder := Pos('TAB', UpperCase(PNCSForm.SaveName)) > 0;
        tempIEN := Piece(PNCSForm.TemplateAction, '~', 3);                      //CodeCR107 - rpm 5/12/10
        If PNCSForm.xCCOWTimer.Enabled = True Then
          PNCSForm.xCCOWTimer.Enabled := False;

        { WLM 3/6/08 CHANGING HOW TO FREE PNCS }
          { Release FormReviewerUtility first - reverse order of creation }
        If FormReviewerUtility <> nil Then
        Begin
          If FormReviewerUtility.Owner = Nil Then
          Begin
            FreeAndNil(FormReviewerUtility);
          End
          Else
          Begin
            FormReviewerUtility.Owner.RemoveComponent(FormReviewerUtility);
            FreeAndNil(FormReviewerUtility);
          End;
        End;
        If PNCSForm <> nil Then
        Begin
          If PNCSForm.Owner = Nil Then
            FreeAndNil(PNCSForm)
          Else
          Begin
            PNCSForm.Owner.RemoveComponent(PNCSForm);
            FreeAndNil(PNCSForm);
          End;
        End;

        formRunning := false;
        If UnsignedView = Nil Then
          buttonIPRRefreshClick(Application);
        tempFMListBox := FMListBoxIPR1;
        If UnsignedView <> Nil Then
        Begin
          If UnsignedView.Label1.Caption = '1' Then
            UnsignedView.button5Click(Application);
          If UnsignedView.Label1.Caption = '2' Then
            UnsignedView.button3Click(Application);
          If UnsignedView.Label1.Caption = '3' Then
            UnsignedView.button6Click(Application);
          If UnsignedView.Label1.Caption = '4' Then
            UnsignedView.button4Click(Application);
          tempFMListBox := UnsignedView.FMListBoxIPR1;
        End;
        temp2IEN := -1;
        If tempIEN <> '' Then
          If tempFMListBox.Items.Count > 0 Then
          Begin
            tempFMListBox.ItemIndex := -1;
            For x := 0 To tempFMListBox.Items.Count - 1 Do
            Begin
              tempFMListBox.ItemIndex := x;
              If Copy(tempFMListBox.Items[x], 1, 1) <> '!' Then
                If tempFMListBox.GetSelectedRecord.IEN = tempIEN Then
                Begin
                  temp2ien := x;
                End;
            End;
            If temp2IEN > -1 Then
            Begin
              tempFMListBox.ItemIndex := temp2ien;
              If UnsignedView <> Nil Then
              Begin
                If tempFMListBox = UnsignedView.FMListBoxIPR1 Then
                Begin
                  UnsignedView.Button1Click(Application);
                End
                Else
                  If tempFMListBox = FMListBoxIPR1 Then
                  Begin
                    ListBoxIPR1.ItemIndex := ListBoxIPR1.Items.Count - 1 - FMListBoxIPR1.ItemIndex;
                    ButtonIPRDisplayClick(Application);
                  End;
              End
              Else
                If tempFMListBox = FMListBoxIPR1 Then
                Begin
                  ListBoxIPR1.ItemIndex := ListBoxIPR1.Items.Count - 1 - FMListBoxIPR1.ItemIndex;
                  ButtonIPRDisplayClick(Application);
                  { WLM 4/21 }
                  If TabReOrder Then
                    PNCSForm.SaveName := ' Tab ReOrder - Save after Reorder';
                End;
            End;                                                                {temp2IEN > -1}
          End;                                                                  {tempFMListBox.Items.Count > 0}
      End;
  End;
  // timeoutval:=5;
  If PNCSForm <> Nil Then
    TimeOutCount := 0;
  If TimeOutCount > TimeOutVal Then
  Begin
    timeouttimer.enabled := false;
    //Set up form
    frmStayConnected := TfrmStayConnected.Create(frmMain);
    frmStayConnected.Top := 7 + frmMain.Top + ((frmMain.Height - frmStayConnected.Height) Div 2);
    frmStayConnected.Left := frmMain.Left + ((frmMain.Width - frmStayConnected.Width) Div 2);
    frmStayConnected.font := panel1.font;
    //frmStayConnected.Label1.Font:=panel1.font;
    frmStayConnected.button1.height := panel1.Height;
    frmStayConnected.button2.height := panel1.Height;
    frmStayConnected.panelCountdown.top := frmStayConnected.Label1.Top + frmStayConnected.label1.height + 8;
    frmStayConnected.button2.top := frmStayConnected.panelCountdown.top;
    frmStayConnected.button1.top := frmStayConnected.button2.top + frmStayConnected.button2.height;
    frmStayConnected.panelCountdown.height := frmStayConnected.button1.height + frmStayConnected.button2.height;
    frmStayConnected.height := frmStayConnected.button1.top + frmStayConnected.button1.height * 2 + (frmStayConnected.height - frmStayConnected.ClientHeight);
    //
    frmStayConnected.Top := 7 + frmMain.Top + ((frmMain.Height - frmStayConnected.Height) Div 2);
    frmStayConnected.Left := frmMain.Left + ((frmMain.Width - frmStayConnected.Width) Div 2);
    //
    ContextorChangeMessage := 'The application is in the process of timing out. If you continue, CAPRI will drop out of the clinical context.';
    CCOWBreakLink := True;
    If frmStayConnected.ShowModal = mrOK Then
    Begin
      TimeOutCount := 0;
      timeouttimer.enabled := True;
    End
    Else
    Begin
      RPCBrokerCall;
      If PNCSForm = Nil Then
        If appstarted = true Then
        Begin
          frmMain.close;
        End
        Else
          application.terminate;
      Haltflag := true;
    End;
    ContextorChangeMessage := '';
    CCOWBreakLink := False;
    frmStayConnected.release;
    frmStayConnected := Nil;
  End;
  TimeOutTimer.Enabled := True;
End;

Procedure TfrmMain.ButtonStateAcceptClick(Sender: TObject);
Begin
  // Reload Counties
  FMListerCounties.IENS := ',' + FMStatesList.GetSelectedRecord.IEN;
  fmListerCounties.GetList(FMCountiesList.Items);
  If TempIEN <> FMStatesList.GetSelectedRecord.IEN Then
  Begin
    // State has changed, so clear county
    FMEditCounty.Text := '';
    CountyFake.Text := '';
    FMCountiesList.ItemIndex := -1;
  End;

  FMEditState.Text := '`' + FMStatesList.GetSelectedRecord.IEN;
  StateFake.Text := FMStatesList.Items[FMStatesList.ItemIndex];
  FMStatesList.Visible := False;
  ButtonStateAccept.Visible := False;

  If (StateFake.Text = 'CANADA') Or (StateFake.Text = 'PHILIPPINES') Or
    (StateFake.Text = 'QUEBEC') Or
    (Uppercase(Trim(StateFake.Text)) = 'NEWFOUNDLAND') Or (Uppercase(Trim(StateFake.text)) = 'LABRADOR') Or (Uppercase(Trim(StateFake.text)) = 'NOVA SCOTIA') Or
    (Uppercase(Trim(StateFake.Text)) = 'PRINCE EDWARD ISLAND') Or (Uppercase(Trim(StateFake.text)) = 'NEW BRUNSWICK') Or (Uppercase(Trim(StateFake.text)) = 'ONTARIO') Or
    (Uppercase(Trim(StateFake.Text)) = 'MANITOBA') Or (Uppercase(Trim(StateFake.text)) = 'SASKATCHEWAN') Or (Uppercase(Trim(StateFake.text)) = 'ALBERTA') Or
    (Uppercase(Trim(StateFake.text)) = 'BRITISH COLUMBIA') Or (Uppercase(Trim(StateFake.text)) = 'YUKON TERRITORY') Or (Uppercase(Trim(StateFake.text)) = 'NORTHWEST TERRITORIES') Or
    (Uppercase(Trim(StateFake.text)) = 'NUNAVUT') Then
  Begin
    FMEditZip.Text := '@';
    FMEditZip.Visible := False;
  End
  Else
  Begin
    FMEditZip.Visible := True;
    If FMEditZip.Text = '@' Then
      FMEditZip.Text := '';
  End;

End;

Procedure TfrmMain.ButtonCountyAcceptClick(Sender: TObject);
Begin
  FMEditCounty.Text := '`' + FMCountiesList.GetSelectedRecord.IEN;
  CountyFake.Text := FMCountiesList.Items[FMCountiesList.ItemIndex];
  FMCountiesList.Visible := False;
  ButtonCountyAccept.Visible := False;
End;

Procedure TfrmMain.ButtonSearchClick(Sender: TObject);
Var
  xx, yy: integer;
  foundflag: boolean;
  foundat: integer;
  tempstring, tempstring2: String;
Begin
  If EditSearchPN.Text = '' Then
  Begin
    Tab95Control1Change(Application);
    exit;
  End;
  If lstDocs.ItemIndex = -1 Then
  Begin
    exit;
  End;
  If (SearchRunning = 0) Or (SearchRunning = 99) Then
    If EditSearchPN.Text = LastSearch Then
    Begin
      foundat := memoDocs.FindText(editSearchPN.Text, lastSearchFoundAt, length(memoDocs.Text), []);
      If FoundAt <> -1 Then
      Begin
        Try
        memoDocs.SetFocus Except
        End;
        //First jump to bottom.
        memoDocs.SelStart := length(memoDocs.Text) - 2;
        memoDocs.SelLength := 2;
        tempString := memoDocs.SelText;
        memoDocs.SelText := '';
        memoDocs.seltext := tempstring;
        //Now find text
        memoDocs.SelStart := FoundAt;
        memoDocs.SelLength := Length(editSearchPN.Text);
        tempstring2 := memoDocs.SelText;
        // Force jump to section
        memoDocs.SelText := tempString2;
        // Re-Highlight
        memoDocs.SelStart := FoundAt;
        memoDocs.SelLength := Length(editSearchPN.Text);
        // Scroll down a few lines
        lastSearchFoundAt := foundat + length(editSearchPN.Text);
        SearchRunning := 99;
        //SearchRunning:=99; // Force selection of text
      End
      Else
      Begin                                                                     // Go to next record
        If lstDocs.ItemIndex < lstDocs.Items.Count - 1 Then
        Begin
          SearchRunning := 0;
          lstDocs.ItemIndex := lstDocs.ItemIndex + 1;
          lstDocsClick(Application);
          //ButtonSearchClick(Application);
          //exit;
        End
        Else
        Begin
          editSearchPN.Text := '';
          ShowMessageCAPRI('No more records to search.  Click "SEARCH" again to re-load the previous list of documents.');
        End;
      End;
      exit;
    End;
  Tab95Control1.Enabled := False;
  Page95Control1.Enabled := False;
  ButtonClinDocDateRange.Enabled := False;
  ButtonClinDocDateRange.Caption := 'Searched Documents';
  //Maskedit1.Text:='1000000';
  //MaskEdit1Change(Application);
  
  // Cycle through all documents to see which have the search term in them.
  // Delete the ones without the search term from the list on the left.
  If lstDocs.Items.Count > 0 Then
  Begin
    For xx := lstDocs.Items.Count - 1 Downto 0 Do
    Begin
      SearchRunning := 1;
      lstDocs.ItemIndex := xx;
      lstDocsClick(Application);
      foundflag := false;
      If memoDocs.Lines.Count > 0 Then
        For yy := 0 To memoDocs.Lines.Count - 1 Do
          If Pos(uppercase(EditSearchPN.Text), uppercase(memoDocs.Lines[yy])) > 0 Then
            foundflag := true;
      If foundflag = false Then
        lstDocs.Items.Delete(xx);
      application.ProcessMessages;
      memoDocs.Repaint;
      lstDocs.Repaint;
      application.ProcessMessages;
    End;
  End
  Else
  Begin
    memoDocs.Lines.Clear;
    memoDocs.Lines.Add('No items found!');
    Tab95Control1.Enabled := True;
    Page95Control1.Enabled := True;
    ButtonClinDocDateRange.Enabled := True;
    LastSearch := editSearchPN.Text;
    SearchRunning := 0;
    exit;
  End;
  SearchRunning := 0;
  Tab95Control1.Enabled := True;
  Page95Control1.Enabled := True;
  ButtonClinDocDateRange.Enabled := True;
  LastSearch := editSearchPN.Text;
  If lstdocs.Items.Count = 0 Then
  Begin
    memoDocs.Lines.Clear;
    memoDocs.Lines.Add('No items found that meet search criteria!');
    exit;
  End;
  lstdocs.ItemIndex := 0;
  lstDocs.Selected[0] := TRUE;                                                  //-MER CodeCR126 7/2010
  lstDocsClick(Application);
End;

Procedure TfrmMain.ReportMemoEnter(Sender: TObject);
Begin
  actEditUpdate(Application);
//  Edit1Click(Application);
End;

Procedure TfrmMain.HSMemoEnter(Sender: TObject);
Begin
  actEditUpdate(Application);
//  Edit1Click(Application);
End;

Procedure TfrmMain.memoDocsChange(Sender: TObject);
Begin
  SetFont;
  actEditUpdate(Application);
  //  Edit1Click(Application);
End;

Procedure TfrmMain.MemoAppointmentsEnter(Sender: TObject);
Begin
  actEditUpdate(Application);
//  Edit1Click(Application);
End;

Procedure TfrmMain.memoDocsEnter(Sender: TObject);
Begin
  actEditUpdate(Application);
//  Edit1Click(Application);
End;

Procedure TfrmMain.PopupReadonlyRicheditPopup(Sender: TObject);
Begin
  actEditUpdate(Application);
//  Edit1Click(Application);
End;

{=========================================================================
 GetPatientProfileMAS
 This procedure retrieves the patient profile MAS report data.
 Input: aDFN - patient IEN

 CodeCR85 - rpm 4/13/10
 =========================================================================}

procedure TfrmMain.GetPatientProfileMAS(aDFN: String);
var
  x: integer;
begin
  AnimateLogo(True);
  StatusBarLoadPt.Caption := 'Downloading report.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;

  frmMain.RPCBroker1.RemoteProcedure := 'DVBAB REPORTS';                        //PATIENT PROFILE
  frmMain.RPCBroker1.Param[1].PType := literal;
  frmMain.RPCBroker1.Param[1].Value := '7';
  frmMain.RPCBroker1.Param[2].PType := literal;
  frmMain.RPCBroker1.Param[2].Value := aDFN + '^'
    + frmPatientProfileMAS.GetDateRange + '^'
    + IntToStr(Ord(frmPatientProfileMAS.IsShowAppts)) + '^'
    + IntToStr(Ord(frmPatientProfileMAS.IsShowEdits)) + '^'
    + IntToStr(Ord(frmPatientProfileMAS.IsShowEnrollment)) + '^'
    + IntToStr(Ord(frmPatientProfileMAS.IsShowDispositions)) + '^'
    + IntToStr(Ord(frmPatientProfileMAS.IsShowTeam)) + '^'
    + IntToStr(Ord(frmPatientProfileMAS.IsShowMeansTest));

  frmMain.RPCBrokerCall;
  try
    frmMain.RPCBroker1.Call;
  except
    On EBrokerError Do
    begin
      ANURemoteProcedureCallinProgress := False;
      ShowMessageCAPRI('RPC DVBAB REPORTS (Patient Profile) could not be accessed!');
    end;
  end;
  QuickCopy(frmMain.RPCBroker1.Results, ReportMemo);
  if ReportMemo.Lines.Count > 0 then
    for x := Reportmemo.Lines.Count - 1 downto 0 do
      if ReportMemo.Lines[x] = '------------------------------------------------------------------------------------------------------------------------------------' Then
        ReportMemo.Lines[x] := Copy(ReportMemo.Lines[x], 1, 78);

  if ReportMemo.Lines.count = 0 then
    ReportMemo.Lines.Add('No data found for requested report criteria.');
  ReportMemo.SelStart := 0;
  ReportMemo.SelLength := 0;
  AnimateLogo(False);
  StatusBarLoadPt.Caption := 'Done.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
  ReportMemo.Setfocus;
end;

Procedure TfrmMain.MyTempExceptionHandler(Sender: TObject; E: Exception);
Begin
  (*
   if (pos('Read of address',e.message)>0) and (   ugSQA=True) then begin
     ShowmessageCAPRI('SQA Error Trap: '+e.message);
     exit;
   end;
   if (pos('Read of address',e.message)>0) and (   ugSQA<>True) then begin
     exit;
   end;
   *)

    // Set cursor to default whenever there's an exception
  screen.cursor := crDefault;
  // Do nothing
//  If ShuttingDown=True then exit;
  //clipbrd.Clipboard.SetTextBuf(Pchar(E.message));
  (*
  If (Pos('XMEMOCODE',uppercase(E.message))=0) and
     (Pos('XMEMOERRORS',uppercase(E.message))=0) and
     (Pos('ACCESS VIOLATION',uppercase(E.message))=0) and
     (Pos('Access violation at address 004034F2 in module',E.message)<1) and
     (E.message<>'Access violation at address 00000000. Read of address 00000000') and
     (E.message<>'Cannot change Visible in OnShow or OnHide') and
     (E.message<>'Cannot focus a disabled or invisible window')
    // (E.message<>'Cannot make a visible window modal')
   then
*)
  ShowMessageCAPRI(E.message);
End;

Procedure KillProcess(hWindowHandle: integer);
Var
  hprocessID: INTEGER;
  processHandle: THandle;
  //DWResult: DWORD;
Begin
  //SendMessageTimeout(hWindowHandle, WM_CLOSE, 0, 0,
  //  SMTO_ABORTIFHUNG Or SMTO_NORMAL, 5000, DWResult);

  If isWindow(hWindowHandle) Then
  Begin
    // PostMessage(hWindowHandle, WM_QUIT, 0, 0);

    { Get the process identifier for the window}
    GetWindowThreadProcessID(hWindowHandle, @hprocessID);
    If hprocessID <> 0 Then
    Begin
      { Get the process handle }
      processHandle := OpenProcess(PROCESS_TERMINATE Or PROCESS_QUERY_INFORMATION,
        False, hprocessID);
      If processHandle <> 0 Then
      Begin
        { Terminate the process }
        TerminateProcess(processHandle, 0);
        CloseHandle(ProcessHandle);
      End;
    End;
  End;
End;

Procedure TfrmMain.FormClose(Sender: TObject; Var Action: TCloseAction);
Var
  AppExceptionFilename: String;
  fileList: TStringList;
  fileListDateCreated: TStringList;
  FileName: String;
  i: integer;
  j: integer;
  SaveHistoryFilename: String;
  tempstring: String;
  x: integer;

  Procedure ListFileDir(Path: String; FileList: TStrings; FileListDateCreated: TStrings);
  Var
    SR: TSearchRec;
    lft: TFileTime;
  Begin
    If FindFirst(Path + '*.*', faAnyFile, SR) = 0 Then
    Begin
      Repeat
        Try
          If (SR.Attr <> faDirectory) Then
          Begin
            FileList.Add(SR.Name);
            FileTimeToLocalFileTime(SR.FindData.ftCreationTime, lft);
            FileListDateCreated.Add(FloatToStr(FileTimeToDateTime(SR.FindData.ftLastWriteTime)));
          End;
        Except
          messagebeep(0);
        End;
      Until FindNext(SR) <> 0;
      FindClose(SR);
    End;
  End;
Begin
  RecordAudit('Shutting down CAPRI', 'Audit');
  Action := caFree;
  frmMain.Visible := false;
  Try If frmMain.Tag = 12613 Then frmMain.OnCloseQuery := nil; Except End;
  // Clean up old form files. Delete any over 120 days old.
  FileList := TStringList.Create;
  FileListDateCreated := TStringList.Create;
  ListFileDir(tempdir, FileList, FileListDateCreated);
  Try
    If FileList.Count > 0 Then
      For x := 0 To FileList.Count - 1 Do
      Begin
        { get file names with dates greater than 14 days through 30 days old }
        For j := 14 To 180 Do                                                   { Iterate }
        Begin
          FileCreateNameForApplicationExceptionLog(AppExceptionFilename, j);
          FileName := FileList.Strings[x];
          { CAPRI REPORT BACKUPS }
          If Pos('CAPRI_REPORT', UpperCase(FileName)) > 0 Then
            If (StrToFloat(FileListDateCreated[x]) < date - 14) Then
              DeleteFile(tempdir + FileList.Strings[x]);
          { SAVE HISTORY FILE }
          If (StrComp(PChar(UpperCase(FileList.Strings[x])), PChar(UpperCase(AppExceptionFilename))) = 0) Then
            If (StrToFloat(FileListDateCreated[x]) < date - 14) Then
              DeleteFile(tempdir + FileList.Strings[x]);
          FileCreateNameForSaveHistoryLog(SaveHistoryFilename, j);
          FileDeleteOldSaveHistory(FileList.Strings[x], FileListDateCreated[x], SaveHistoryFilename);
        End;                                                                    { for }
        // if third piece is "zip then it's probably a form file
        If (uppercase(piece(FileList.Strings[x], '.', 3)) = 'ZIP') And (piece(FileList.Strings[x], '.', 4) = '') Then
        Begin
          //get filename without extension
          tempstring := piece(FileList.Strings[x], '.', 1);
          // Check for existence of "~" and "^" just to be sure it's a form file
          If (pos('~', tempstring) > 0) And (pos('^', tempstring) > 0) Then
          Begin
            // Check if older than 90 days.
            If StrToFloat(FileListDateCreated[x]) < date - 90 Then
            Begin
              Try
              DeleteFile(tempdir + FileList.Strings[x])Except
              End;
              Try
              DeleteFile(tempdir + FileList.Strings[x] + '.pnl.cde')Except
              End;
              Try
              DeleteFile(tempdir + FileList.Strings[x] + '.pnl.frm')Except
              End;
              Try
              DeleteFile(tempdir + FileList.Strings[x] + '.pnl.rep')Except
              End;
            End
            Else
            Begin
              // Newer file found
            End;

          End;
        End;
      End;                                                                      { FOR  }
  Finally
    frmMain.windowstate := wsNormal;                                            // restore if minimized or maximized
    SaveCAPRISettings;
    ShuttingDown := True;
    //Release all the voice descriptors
    If assigned(frmProperties) Then
      For I := 0 To frmProperties.comboboxVoice.Items.Count - 1 Do
        ISpeechObjectToken(Pointer(frmProperties.comboboxVoice.Items.Objects[I]))._Release;
    Try
    SPVoice1.Disconnect Except End;
    Try If assigned(FPatientInfoBucket) Then FreeAndNil(FPatientInfoBucket)Except End;
    Try If assigned(FileList) Then FreeAndNil(FileList)Except End;
    Try If assigned(FileListDateCreated) Then FreeAndNil(FileListDateCreated)Except End;
    Try If assigned(frmEditPatientLists) Then FreeAndNil(frmEditPatientLists)Except End;
    Try If assigned(frmTelnet) Then FreeAndNil(frmTelnet)Except End;
    Try If assigned(frmMacroEditor) Then FreeAndNil(frmMacroEditor)Except End;
    Try If assigned(formPrintConfirm) Then FreeAndNil(formPrintConfirm)Except End;
    Try If assigned(formPrint) Then FreeAndNil(formPrint)Except End;
    Try If assigned(formNews) Then FreeAndNil(formNews)Except End;
    Try If assigned(frmSpellCheck) Then FreeAndNil(frmSpellCheck)Except End;
    Try If assigned(frm508Messages) Then FreeAndNil(frm508Messages)Except End;
    Try If assigned(frmLabGraph) Then FreeAndNil(frmLabGraph)Except End;
    Try If assigned(formEssoSelect) Then FreeAndNil(formEssoSelect)Except End;
    Try If assigned(frmProperties) Then FreeAndNil(frmProperties)Except End;
    Try If assigned(frmROFinder) Then FreeAndNil(frmROFinder)Except End;
    Try If assigned(frmZipCodes) Then FreeAndNil(frmZipCodes)Except End;
    Try If assigned(FormTIUDisplay) Then FreeAndNil(FormTIUDisplay)Except End;
    Try If assigned(FormReportBuilder) Then FreeAndNil(FormReportBuilder)Except End;
    Try If assigned(frmMailMan) Then FreeAndNil(frmMailMan)Except End;
    Try If assigned(ContextorControl) Then FreeAndNil(ContextorControl)Except End;
    Try If assigned(uHSComponents) Then FreeAndNil(uHSComponents)Except End;
    Try If assigned(TempHSMemo) Then FreeAndNil(TempHSMemo)Except End;
    Try If assigned(listMedicalCenterDivision) Then FreeAndNil(listMedicalCenterDivision)Except End;
    Try If assigned(listlabTestNames) Then FreeAndNil(listlabTestNames)Except End;
    Try If assigned(UserKeys) Then FreeAndNil(UserKeys)Except End;
    Try If assigned(listDocs) Then FreeAndNil(listDocs)Except End;
    Try If assigned(listExams) Then FreeAndNil(listExams)Except End;
    Try If assigned(ListRestrictedPatients) Then FreeAndNil(ListRestrictedPatients)Except End;
    Try If assigned(SurgeryReports) Then FreeAndNil(SurgeryReports)Except End;
    Try If assigned(uLocalReportData) Then FreeAndNil(uLocalReportData)Except End;
    Try If assigned(frmReports) Then FreeAndNil(frmReports)Except End;
    Try If assigned(frmSearchText) then FreeAndNil(frmSearchText)Except End;    //CodeCR696 JRL 4/8/15
    Try
      If assigned(frmReports) Then
      Begin
        FreeAndNil(frmReports);
      End;
    Except
    End;
    try                                                                         // CodeCR185 -MER 04/2011
      if Assigned(ReflectionWrapper) then begin
        try
          if ReflectionWrapper.IsRunning then
            ReflectionWrapper.TerminateEmulator;
        finally
          ReflectionWrapper.Free;
        end;
      end;
    except
      // do nothing
    end;
    Try If assigned(VocRehab) Then FreeAndNil(VocRehab)Except End;              //CodeCR347 - JRL 5/22/12
  End;
  Try KillProcess(Application.Handle); Except End;
End;

Procedure TfrmMain.SaveCAPRISettings;
Var
  maxFlag: Boolean;
  x: integer;
  lslConfig: TStringList;                                                       // CodeCR168 -MER 04/2011

  {
    Return TColor value in XXXXXX format
    (X being a hex digit)
  }

  Function
      TColorToHex(Color: TColor)
      : String;
  Begin
    Result :=
      { red value }
    IntToHex(GetRValue(Color), 2) +
      { green value }
    IntToHex(GetGValue(Color), 2) +
      { blue value }
    IntToHex(GetBValue(Color), 2);
  End;

Begin
  If frmMain.WindowState = wsMaximized Then
    maxflag := true
  Else
    maxflag := false;
  // CodeCR168 -MER 04/2011  Previously, a memoBox was used to save the config
  // information.  This resulted in problems when the line width was greater
  // than what the control could contain.  The memoBox has been replaced with
  // a stringlist
  lslConfig := TStringList.Create;
  try
    lslConfig.Clear;
    lslConfig.Add(IntToStr(frmMain.Top));
    lslConfig.Add(IntToStr(frmMain.Left));
    lslConfig.Add(IntToStr(frmMain.Width));
    lslConfig.Add(IntToStr(frmMain.Height));
    If maxflag = true Then
      lslConfig.Add('WSMAXIMIZED')
    Else
      lslConfig.Add('WSNORMAL');
    lslConfig.Add(IntToStr(lstdocs.width));                                     //Clinical docs slider size
    lslConfig.Add(IntToStr(ORHealthSummaryUserList.width));                     //Health Summary slider size
    lslConfig.Add(IntToStr(ORReportsAvailable.width));                          //Reports Tab slider size
    //Font size
    lslConfig.Add(FontDialog1.Font.Name);                                       //Font
    lslConfig.Add(IntToStr(FontDialog1.Font.Size));                             //Size
    If FontDialog1.Font.style = [fsBold] Then
      lslConfig.Add('TRUE')
    Else
      lslConfig.Add('FALSE');
    If FontDialog1.Font.style = [fsitalic] Then
      lslConfig.Add('TRUE')
    Else
      lslConfig.Add('FALSE');
    If FontDialog1.Font.style = [fsUnderline] Then
      lslConfig.Add('TRUE')
    Else
      lslConfig.Add('FALSE');
    If FontDialog1.Font.style = [fsStrikeout] Then
      lslConfig.Add('TRUE')
    Else
      lslConfig.Add('FALSE');
    //application.processmessages;
    //Keyboard Sensitivity
    If assigned(frmProperties) Then
      lslConfig.Add(IntToStr(frmProperties.ScrollBarKeyboardSensitivity.Position));
    // Last selected
    //application.processmessages;
    If EssoVersion = True Then
    Begin
      lslConfig.Add(Uppercase(RemoteSiteName));
    End
    Else
      lslConfig.Add('');
    //application.processmessages;
    //Address Info
    If MemoNameAddressHolder.Lines.Count > 0 Then
    Begin
      For x := 0 To MemoNameAddressHolder.Lines.Count - 1 Do
        lslConfig.Add('~' + MemoNameAddressHolder.Lines[x]);
    End
    Else
      lslConfig.Add('^NONE^');

    // Telnet Window Settings
    If assigned(frmTelnet) Then
    Begin
      lslConfig.Add(inttostr(frmTelnet.Width));
      lslConfig.Add(inttostr(frmTelnet.Height));
      lslConfig.Add(inttostr(frmTelnet.Left));
      lslConfig.Add(inttostr(frmTelnet.Top));
      lslConfig.Add(inttostr(frmTelnet.IPTerminal1.Font.Size));
      lslConfig.Add(frmTelnet.IPTerminal1.Font.Name);
      lslConfig.Add(TColorToHex(ipc_TermBufForeColor));
      lslConfig.Add(TColorToHex(ipc_TermBufBackColor));
    End;

    // Speech Settings
    If assigned(frmProperties) Then
    Begin
      lslConfig.Add(frmProperties.ComboboxVoice.Items[frmProperties.ComboboxVoice.ItemIndex]);
      lslConfig.Add(IntToStr(frmProperties.TrackBarSpeechRate.Position));
      lslConfig.Add(IntToStr(frmProperties.TrackBarSpeechVolume.Position));
      If frmProperties.CheckBoxActivateSpeechPrompts.Checked = True Then
        lslConfig.Add('TRUE')
      Else
        lslConfig.Add('FALSE');
    End;

    Try
    lslConfig.SaveToFile('c:\capri.cfg')Except
    End;
  finally
    lslConfig.Free;
  end;
End;

Procedure TfrmMain.FormActivate(Sender: TObject);
var tempClientItem: TActionClientItem;
Begin
  StatusBarLoadPt.Caption := 'Ready.';
  Invalidate;
  If Not AuditInProgress Then
    If SwitchToSite = '' Then
      If ESSOConnecting <> True Then
        AppStarted := True;


  tempClientItem := ActionManMain.FindItemByCaption('&Developer');
  If (FileExists(TempDir + 'capriqrzdev.txt')) and (Assigned(tempClientItem)) Then
    tempClientItem.Visible := True
  else if Assigned(tempClientItem) then
    tempClientItem.Visible := False;
  UpdateEditBoxesForScreenReader(self);                                         // -MER CodeCR120 8/2010
End;

Procedure TfrmMain.btnLoadHSNamesRemoteDataClick(Sender: TObject);
Var
  x: integer;
  deleteflag: integer;
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;

  HSMemo.Lines.Clear;
  HSMemoLocal.Lines.Clear;
  frmMain.RPCBroker1.Results.Clear;

  {Get HEALTH SUMMARY TYPES using ORWRP REPORT LISTS CPRS Broker Call}
  RPCBroker1.RemoteProcedure := 'ORWRP REPORT LISTS';
  Try
  RPCBroker1.Call Except On EBrokerError Do
    Try
    RPCBroker1.Call Except On EBrokerError Do
      Try
      RPCBroker1.Call Except On EBrokerError Do
        Begin
          ANURemoteProcedureCallInProgress := False;
          frmMain.Show;
          Application.BringToFront;
          ShowMessageCAPRI('RPC Broker connection error!');
        End;
      End;
    End;
  End;

  Repeat
    RPCBroker1.Results.Delete(0);
  Until RPCBroker1.Results[0] = '[HEALTH SUMMARY TYPES]';
  RPCBroker1.Results.Delete(0);
  DeleteFlag := -1;
  If RPCBroker1.Results.Count > 0 Then
  Begin
    For x := 0 To RPCBroker1.Results.Count - 1 Do
    Begin
      If (RPCBroker1.Results[x] = '$$END') And (DeleteFlag = -1) Then
        DeleteFlag := x;
    End;
    For x := RPCBroker1.Results.Count - 1 Downto DeleteFlag Do
      RPCBroker1.Results.Delete(x);

    ORHealthSummaryUserList.Items.Clear;
    lbHealthSummaryList.Items.Clear;
    If RPCBroker1.Results.Count > 0 Then
      For x := 0 To RPCBroker1.Results.Count - 1 Do
      Begin
        If Pos('ADHOC REPORT', UpperCase(Piece(RPCBroker1.Results[x], '^', 2))) <> 1 Then
        Begin
          lbHealthSummaryList.Items.Add(Copy(Piece(RPCBroker1.Results[x], '^', 1), 2, 99)); // Strip off the first character of "h"
          ORHealthSummaryUserList.Items.Add(Piece(RPCBroker1.Results[x], '^', 2));
          //ShowMessageCAPRI(RPCBroker1.Results[x]+'  '+(Copy(Piece(RPCBroker1.Results[x],'^',1),2,99))+'  '+(Piece(RPCBroker1.Results[x],'^',2)));
        End;
      End;
  End;

End;

Procedure TfrmMain.Button4Click(Sender: TObject);
Var
  x: integer;
Begin
  If CheckListBoxRemoteData.Items.Count > 0 Then
    For x := 0 To CheckListBoxRemoteData.Items.Count - 1 Do
      CheckListBoxRemoteData.Checked[x] := True;
End;

Procedure TfrmMain.Button3Click(Sender: TObject);
Var
  x: integer;
  flag: boolean;

Begin
  flag := false;
  If checklistboxRemoteData.Items.Count > 0 Then
    For x := 0 To checklistboxRemoteData.Items.Count - 1 Do
      If checkListboxRemoteData.Checked[x] Then
        If Piece(ListBoxRemoteData.Items[x], '^', 1) = '200' Then
          flag := true;
  If flag = true Then
  Begin
    ShowMessageCAPRI('RDV cannot be run on DoD/FHIE systems!');
    exit;
  End;

  Tab95Control2.Tabs.Clear;
  Tab95Control2.Tabs.Add('Local');
  PanelRemoteData.Visible := False;
  flag := False;
  If checklistboxRemoteData.Items.Count > 0 Then
    For x := 0 To checklistboxRemoteData.Items.Count - 1 Do
      If checkListboxRemoteData.Checked[x] Then
      Begin
        flag := true;
        Tab95Control2.Tabs.Add(Piece(ListBoxRemoteData.Items[x], '^', 2));
      End;
  If flag = true Then
    btnLoadHSNamesRemoteDataClick(Application)
  Else
    btnLoadHSNamesClick(Application);
End;

Procedure TfrmMain.ButtonRDVClick(Sender: TObject);
Var
  x: integer;
  a, b: String;
Begin
  If ListBoxRemoteDataPending.Items.Count > 0 Then
  Begin
    ShowMessageCAPRI('This option cannot be selected while remote reports are pending.');
    exit;
  End;
  PanelRemoteData.Visible := True;
  PanelRemoteData.BringToFront;
  RPCBroker1.RemoteProcedure := 'ORWCIRN FACLIST';
  RPCBroker1.Param[0].Value := PatientIEN;
  RPCBroker1.Param[0].PType := literal;
  RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'RPC ORWCIRN FACLIST could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('ORWCIRN FACLIST could not be accessed!');
    End
  End;
  CheckListBoxRemoteData.Items.Clear;
  ListBoxRemoteData.Items.Clear;
  Tab95Control2.Tabs.Clear;
  Tab95Control2.Tabs.Add('Local');
  If Piece(RPCBroker1.Results[0], '^', 1) = '-1' Then
  Begin
    // Only local data or other problem
    ShowMessageCAPRI(Piece(RPCBroker1.Results[0], '^', 2));
    PanelRemoteData.Visible := False;
    btnLoadHSNamesClick(Application);
  End
  Else
  Begin
    // Other sites found
    For x := 0 To RPCBroker1.Results.Count - 1 Do
    Begin
      ListBoxRemoteData.Items.Add(RPCBroker1.Results[x]);
      a := Copy(Piece(RPCBroker1.Results[x], '^', 1) + '        ', 1, 8);
      b := Copy(Piece(RPCBroker1.Results[x], '^', 2) + '                         ', 1, 25);
      CheckListBoxRemoteData.Items.Add(a + b + FMDateTimeConvert(Piece(RPCBroker1.Results[x], '^', 3)));
    End;
  End;
End;

Procedure TfrmMain.TimerRemoteDataTimer(Sender: TObject);
Var
  x, y: integer;
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;
  If ListBoxRemoteDataPending.Items.Count = 0 Then
  Begin
    TimerRemoteData.Enabled := False;
    ShowMessageCAPRI('All remote data has been retrieved.');
    exit;
  End;
  For x := ListBoxRemoteDataPending.Items.Count - 1 Downto 0 Do
  Begin
    // * = Communication Problem
    If ListBoxRemoteDataPending.Items[x] <> '*' Then
    Begin
      RPCBroker1.RemoteProcedure := 'XWB REMOTE STATUS CHECK';
      RPCBroker1.Param[1].Value := ListBoxRemoteDataPending.Items[x];
      RPCBroker1.Param[1].PType := literal;
      RPCBrokerCall;
      Try
        RPCBroker1.Call;
      Except
        On EBrokerError Do
        Begin
          ANURemoteProcedureCallInProgress := False;
          AnimateLogo(False);
          StatusBarLoadPt.Caption := 'RPC XWB REMOTE STATUS CHECK could not be accessed!';
          StatusBarLoadPt.Repaint;
          Application.Processmessages;
          ShowMessageCAPRI('RPC XWB REMOTE STATUS CHECK could not be accessed!');
        End
      End;
    End
    Else
    Begin
      RPCBroker1.Results.Clear;
      RPCBroker1.Results.Add('1^DONE');
      //ListBoxRemoteData.Items.Add(^^^^^'+ListBoxRemoteDataPending.Items[x]);
    End;
    If Uppercase(RPCBroker1.Results[0]) = '1^DONE' Then
    Begin
      For y := 0 To listboxremotedata.items.count - 1 Do
        If Piece(ListBoxRemoteData.Items[y], '^', 6) = ListBoxRemoteDataPending.Items[x] Then
        Begin
          ListBoxRemoteData.Items[y] := ListBoxRemoteData.Items[y] + '^' + 'DONE';
          //ShowMessageCAPRI('OK:'+ListBoxRemoteData.Items[y]);
        End;
      ListBoxRemoteDataPending.Items.Delete(x);
    End;
    If Piece(Uppercase(RPCBroker1.Results[0]), '^', 1) = '-1' Then
    Begin
      ShowMessageCAPRI(RPCBroker1.Results[0]);
      For y := 0 To listboxremotedata.items.count - 1 Do
        If Piece(ListBoxRemoteData.Items[y], '^', 6) = ListBoxRemoteDataPending.Items[x] Then
        Begin
          ListBoxRemoteData.Items[y] := ListBoxRemoteData.Items[y] + '^' + 'DONE';
          //ShowMessageCAPRI('OOPS:'+ListBoxRemoteData.Items[y]);
        End;
      ListBoxRemoteDataPending.Items.Delete(x);
    End;
  End;

End;

Procedure TfrmMain.Tab95Control2Change(Sender: TObject);
Var
  SiteName: String;
  y: integer;

  Procedure UpdateComboBoxHSSections;
  Var
    tempRichEdit: TRichEdit;
    x: integer;
  Begin
    screen.cursor := crHourglass;
    ComboBoxHSSections.Items.Clear;
    tempRichEdit := Nil;
    If HSMemo.Visible = True Then
      tempRichEdit := HSMemo As TRichEdit;
    If HSMemoLocal.Visible = True Then
      tempRichEdit := HSMemoLocal As TRichEdit;
    If tempRichEdit.Lines.Count = 0 Then
      exit;
    ProgressBarLoadPt.Position := 0;
    ProgressBarLoadPt.Max := tempRichEdit.Lines.Count - 1;
    ProgressBarLoadPt.Visible := True;
    For x := 1 To tempRichEdit.Lines.Count - 1 Do
    Begin
      ProgressBarLoadPt.Position := x;
      If x / 1000 = trunc(x / 1000) Then
        StatusBarLoadPt.Caption := 'Scanning ' + InttoStr(x) + ' of ' + inttoStr(tempRichEdit.Lines.Count);
      Application.ProcessMessages;
      If tempRichEdit.Lines[x - 1] = '' Then
        If Copy(tempRichEdit.Lines[x], 1, 5) = '-----' Then
          ComboBoxHSSections.Items.Add(tempRichEdit.Lines[x]);
    End;
    ProgressBarLoadPt.Visible := False;
    screen.cursor := crDefault;
  End;
Begin
  ComboBoxHSSections.Items.Clear;
  If Tab95Control2.TabIndex = 0 Then
  Begin
    ANURemoteProcedureCallInProgress := true;
    StatusBarLoadPt.Caption := 'Downloading Health Summary.';
    StatusBarLoadPt.Repaint;
    Application.Processmessages;
    AnimateLogo(True);
    HSMemo.Visible := False;
    HSMemoLocal.BringToFront;
    HSMemoLocal.Visible := True;
    UpdateComboBoxHSSections;
    AnimateLogo(False);
    StatusBarLoadPt.Caption := 'Ready.';
    StatusBarLoadPt.Repaint;
    Application.Processmessages;
    ANURemoteProcedureCallInProgress := False;
    exit;
  End;
  AnimateLogo(True);
  StatusBarLoadPt.Caption := 'Checking for Report.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
  SiteName := Tab95Control2.Tabs[Tab95Control2.TabIndex];
  HSMemo.Lines.Clear;
  HSMemo.Lines.Add('');
  HSMemo.Lines.Add('Waiting for data...');
  HSMemoLocal.Visible := False;
  HSMemo.Visible := True;
  For y := 0 To listboxremotedata.items.count - 1 Do
    If SiteName = Piece(ListBoxRemoteData.Items[y], '^', 2) Then
      If ((Piece(ListBoxRemoteData.Items[y], '^', 6) <> '') And (Piece(ListBoxRemoteData.Items[y], '^', 7) = 'DONE')) Or (Piece(ListBoxRemoteData.Items[y], '^', 6) = '*') Then
      Begin
        // * = Communication Problem
        If Piece(ListBoxRemoteData.Items[y], '^', 6) <> '*' Then
        Begin
          RPCBroker1.RemoteProcedure := 'XWB REMOTE GETDATA';
          RPCBroker1.Param[1].Value := Piece(ListBoxRemoteData.Items[y], '^', 6); // Remote transaction id
          RPCBroker1.Param[1].PType := literal;
          RPCBrokerCall;
          Try
            RPCBroker1.Call;
          Except
            On EBrokerError Do
            Begin
              ANURemoteProcedureCallInProgress := False;
              AnimateLogo(False);
              HSMemo.Visible := True;
              StatusBarLoadPt.Caption := 'RPC REMOTE GETDATA could not be accessed!';
              StatusBarLoadPt.Repaint;
              Application.Processmessages;
              ShowMessageCAPRI('RPC REMOTE GETDATA could not be accessed!');
            End;
          End;
        End
        Else
        Begin
          RPCBroker1.Results.Clear;
          HSMemo.Lines.Clear;
          HSMemo.Lines.Add('Remote data transmission error: Communication error');
          AnimateLogo(False);
          StatusBarLoadPt.Caption := 'Ready.';
          StatusBarLoadPt.Repaint;
          Application.Processmessages;
          screen.cursor := crDefault;
          exit;
        End;

        //Build Report
        ANURemoteProcedureCallInProgress := true;
        HSMemo.Lines.Clear;
        ComboBoxHSSections.Items.Clear;
        screen.cursor := crHourglass;

        HSMemo.SetSelTextBuf(RPCBroker1.Results.GetText);

        screen.cursor := crDefault;
        If ListBoxRemoteDataPending.Items.Count > 0 Then
          TimerRemoteData.Enabled := True;
        //End Of Build Report
      End;
  HSMemo.BringToFront;
  HSMemo.Visible := True;
  HSMemo.SelStart := 1;
  HSMemo.SelLength := 1;
  Try
  HSMemo.SetFocus Except
  End;
  HSMemo.SelStart := 0;
  HSMemo.SelLength := 0;
  Try
  HSMemo.SetFocus Except
  End;
  UpdateComboBoxHSSections;
  ANURemoteProcedureCallinProgress := False;
  AnimateLogo(False);
  StatusBarLoadPt.Caption := 'Ready.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
End;

Procedure TfrmMain.Button5Click(Sender: TObject);
Begin
  PanelRemoteData.Visible := False;
End;

Procedure TfrmMain.btnDivisionsClick(Sender: TObject);
Var
  anuapptpointer: String;
  anudivision: String;
  x: integer;
Begin
  AnimateLogo(True);
  StatusBarLoadPt.Caption := 'Finding divisions...';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
  If lstDocs.Items.Count > 0 Then
  Begin
    btnDivisions.Enabled := False;
    DivisionRun := True;
    ButtonSearch.Enabled := False;
    For x := 0 To lstDocs.Items.Count - 1 Do
    Begin
      // Get Divison and Add at Front of List
      If DivisionRun = False Then
        exit;                                                                   // In case list changes
      FMGetsTIU.IENS := Piece(lstDocs.Items[x], '^', 2);
      FMGetsTIU.GetData;
      Try
      anuapptpointer := FMGetsTIU.GetField('1205').FMDBInternal Except anuapptpointer := ''
      End;                                                                      // Pointer to visit
      anudivision := '';
      If anuapptpointer <> '' Then
      Begin
        FMGetsHospitalLocation.IENS := anuapptpointer;
        FMGetsHospitalLocation.GetData;
        Try
        anudivision := FMGetsHospitalLocation.GetField('3.5').FMDBExternal Except
        End;
      End;
      anudivision := anudivision + '   ';
      anudivision := Copy(anudivision, 1, 3);
      lstDocs.Items[x] := anudivision + '  ' + lstdocs.items[x];
      application.processmessages;
      application.processmessages;
      application.processmessages;
      //
    End;
  End;
  ButtonSearch.Enabled := True;
  AnimateLogo(False);
  StatusBarLoadPt.Caption := 'Ready.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
End;

Procedure TfrmMain.btnMultiClick(Sender: TObject);
Begin
  If FormReportbuilder = Nil Then
    formReportBuilder := TformReportBuilder.Create(frmMain);
  FormReportBuilder.Left := frmMain.Left + frmMain.width - formreportBuilder.Width - 16;
  FormReportBuilder.Top := frmMain.Top + frmMain.height - formreportBuilder.Height - 84;
  SetWindowPos(formReportBuilder.Handle, hwnd_TopMost, 0, 0, 0, 0,
    SWP_NOACTIVATE Or SWP_NOMOVE Or
    SWP_NOSIZE Or SWP_NOSENDCHANGING);
  FormReportBuilder.Show;
End;

Procedure TfrmMain.lstDocsChange(Sender: TObject);
Begin
  LabelDocsFound.Caption := IntToStr(lstDocs.Items.Count) + ' Items';
End;

Procedure TfrmMain.buttonClinDocDateRangeClick(Sender: TObject);
Var
  inE: Integer;
  ProcName: String;
Begin
  ProcName := 'TfrmMain.buttonClinDocDateRangeClick';
  inE := 0;
  Try
    If FormDateRange = Nil Then
      FormDateRange := TFormDateRange.Create(Application);
    // -MER CodeCR122 9/2010 start change block
    inE := 1;
    FormDateRange.Font := panel1.font;
    FormDateRange.rbtnByDate.Font := panel1.font;
    FormDateRange.rbtnNumber.Font := panel1.font;
    FormDateRange.rbtnAll.Font := panel1.font;
    FormDateRange.btnOK.Font := panel1.font;
    FormDateRange.btnCancel.Font := panel1.font;
    FormDateRange.grpStartDate.Font := panel1.font;
    FormDateRange.grpEndDate.Font := panel1.font;
    FormDateRange.grbMaxNumber.Font := panel1.font;
    FormDateRange.dtpStartDate.Font := panel1.font;
    FormDateRange.dtpEndDate.Font := panel1.font;
    FormDateRange.edbNumber.Font := panel1.font;
    FormDateRange.btnOK.Height := Panel1.Height;
    FormDateRange.btnCancel.Height := Panel1.Height;
    inE := 2;
    if FormDateRange.ShowModal = mrOK then begin
      inE := 3;
      if (FormDateRange.rbtnByDate.Checked) then begin
        inE := 4;
        buttonClinDocDateRange.Caption := FormatDateTime('mmm d, yyyy', FormDateRange.dtpStartDate.Date)
          + ' to ' + FormatDateTime('mmm d, yyyy', FormDateRange.dtpEndDate.Date);
        ClinDocDateRangeSelected := True;
      end else if (FormDateRange.rbtnNumber.Checked) then begin
        inE := 5;
        NumberClinDocsToRetrieve := StrToInt(FormDateRange.edbNumber.Text);
        buttonClinDocDateRange.Caption := IntToStr(NumberClinDocsToRetrieve) + ' Documents';
        ClinDocDateRangeSelected := False;
      end else begin
        inE := 6;
        buttonClinDocDateRange.Caption := 'All Documents';
        NumberClinDocsToRetrieve := 32767;                                      // this constitutes "show all"
        ClinDocDateRangeSelected := False;
      end;
      inE := 7;
      DivisionRun := False;
      Tab95Control1Change(Application);
    end;                                                                        // -MER CodeCR122 9/2010 end change block
    buttonsearch.enabled := true;
  Except
    ShowMessage('Error at ' + UnitName + '.' + ProcName + ' line=' + IntToStr(inE));
  End;
End;

Procedure TfrmMain.ComboBoxHSSectionsChange(Sender: TObject);
Var
  tempRichEdit: TRichEdit;
  foundat: longint;
  tempstring: String;
Begin
  tempRichEdit := Nil;
  If ANURemoteProcedureCallInProgress = True Then
    exit;
  If ComboBoxHSSections.Text = '' Then
    exit;
  If HSMemo.Visible = True Then
    tempRichEdit := HSMemo As TRichEdit;
  If HSMemoLocal.Visible = True Then
    tempRichEdit := HSMemoLocal As TRichEdit;
  If tempRichEdit.Lines.Count = 0 Then
    exit;
  foundat := tempRichEdit.FindText(ComboBoxHSSections.Text, 0, length(temprichEdit.Text), []);
  If FoundAt <> -1 Then
  Begin
    Try
    tempRichEdit.SetFocus Except
    End;
    //First jump to bottom.
    tempRichEdit.SelStart := length(tempRichEdit.Text) - 2;
    tempRichEdit.SelLength := 2;
    tempString := tempRichEdit.SelText;
    tempRichEdit.SelText := '';
    temprichedit.seltext := tempstring;
    //Now find text
    tempRichEdit.SelStart := FoundAt;
    tempRichEdit.SelLength := Length(ComboBoxHSSections.Text);
    // Force jump to section
    tempRichEdit.SelText := ComboBoxHSSections.Text;
    // Re-Highlight
    tempRichEdit.SelStart := FoundAt;
    tempRichEdit.SelLength := Length(ComboBoxHSSections.Text);
    // Scroll down a few lines

  End;
  //end;
End;

Procedure TfrmMain.FMEditStreet1Exit(Sender: TObject);
Var
  x: integer;
  tempEdit: TEdit;
Begin
  tempEdit := Sender As TEdit;
  // Remove trailing spaces
  If Length(TempEdit.Text) > 0 Then
  Begin
    x := length(TempEdit.text);
    Repeat
      Begin
        If Copy(TempEdit.Text, x, 1) = ' ' Then
          TempEdit.Text := copy(TempEdit.text, 1, x - 1)
        Else
          x := 1;
        dec(x);
    End Until x = 0;
  End;
  // Remove leading spaces
  If Length(TempEdit.Text) > 0 Then
  Begin
    x := 0;
    Repeat
      Begin
        If Copy(TempEdit.Text, 1, 1) = ' ' Then
        Begin
          TempEdit.Text := copy(TempEdit.text, 2, length(TempEdit.text) - 1);
          dec(x);
        End
        Else
          x := length(TempEdit.text);
        inc(x);
    End Until x > length(TempEdit.text);
  End;
  TempEdit.Text := Uppercase(TempEdit.Text);
End;

Procedure TfrmMain.HSMemoChange(Sender: TObject);
Begin
  SetFont;
End;

Procedure TfrmMain.HSMemoLocalChange(Sender: TObject);
Begin
  SetFont;
End;

Procedure TfrmMain.ReportMemoChange(Sender: TObject);
Begin
  SetFont;
End;

Procedure TfrmMain.MemoAppointmentsChange(Sender: TObject);
Begin
  SetFont;
End;

Procedure TfrmMain.btnGraphVSClick(Sender: TObject);
Var
  x, y: integer;
  line: String;
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;
  If memodocs.Lines.Count > 0 Then
  Begin
    AnimateLogo(True);
    StatusBarLoadPt.Caption := 'Analyzing values.';
    StatusBarLoadPt.Repaint;
    Application.Processmessages;

    formGraphVS := TformGraphVS.Create(frmMain);
    formGraphVS.ChartVS.Series[0].Clear;
    formGraphVS.ChartVS.Series[1].Clear;
    formGraphVS.ChartVS.Series[2].Clear;
    formGraphVS.ChartVS.Title.Text.Clear;
    formGraphVS.ChartVS.Title.Text.Add('Vitals/Measurements Report');
    formGraphVS.ListBoxVS.Clear;
    // Search for vitals types
    For x := 0 To memodocs.lines.count - 1 Do
    Begin
      line := memodocs.lines[x];
      //
      //
      //  Find vital types first
      If (pos(':', line) > 3) And (length(line) > 4) Then
      Begin                                                                     // Found a vital type?
        // Check to be sure 4 spaces and then a character.  If so, it's a line with a vital
        If (line[1] = ' ') And (line[2] = ' ') And (line[3] = ' ') And (line[4] = ' ') And (line[5] <> ' ') Then
        Begin
          line := removespaces(line);
          line := Copy(line, 1, pos(':', line) - 1);
          If uppercase(Line) = 'T' Then
            line := 'TEMPERATURE' + '^' + Line
          Else
            If uppercase(Line) = 'P' Then
              line := 'PULSE' + '^' + Line
            Else
              If uppercase(Line) = 'R' Then
                line := 'RESPIRATION' + '^' + Line
              Else
                If uppercase(Line) = 'B/P' Then
                  line := 'BLOOD PRESSURE' + '^' + Line
                Else
                  If uppercase(Line) = 'WT' Then
                    line := 'WEIGHT' + '^' + Line
                  Else
                    If uppercase(Line) = 'HT' Then
                      line := 'HEIGHT' + '^' + Line
                    Else
                      Line := Uppercase(Line) + '^' + Line;                     // All others, just use whatever it is
          If formGraphVS.ListBoxVS.Items.Count > 0 Then
            For y := 0 To formGraphVS.ListBoxVS.Items.Count - 1 Do
              If formGraphVS.ListBoxVS.Items[y] = Line Then
                Line := '';
          If Line <> '' Then
            formGraphVS.ListBoxVS.Items.Add(Line);
        End;
      End;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'Ready.';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
    End;
    //
    If formGraphVS.listBoxVS.Items.Count = 0 Then
    Begin
      ShowMessageCAPRI('Nothing found to graph in the current report.');
      exit;
    End;
    formGraphVS.ShowModal;
    formGraphVS.release;
    formGraphVS := Nil;
  End;
End;

Procedure TfrmMain.btnExamFinalReportClick(Sender: TObject);
Var
  labonly: String;
Begin
  labonly := '0';
  If Application.MessageBox('Do you want just the lab/x-ray results?', 'Reprint Final Report', 4) = 6 Then
  Begin
    labonly := '1';
  End;

  If FMExamRequestListBox.ItemIndex = -1 Then
    exit;

  {CodeCR180 - rpm 4/11/11 - use TfrmReports.FormActivate logic that forces
                             DUZ(2) to CLAIMS login division}
  if EssoVersion then
  begin
    RPCBroker1.RemoteProcedure := 'DVBAB SET DIVISION';
    RPCBroker1.Param[1].Value := RemoteUserDivisionNumber;
    RPCBroker1.Param[1].PType := literal;

    Try
      RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        AnimateLogo(False);
        StatusBarLoadPt.Caption := 'RPC DVBAB SET DIVISION could not be accessed!';
        StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('DVBAB SET DIVISION could not be accessed!');
      End;
    End;
  end;

  RPCBroker1.Results.Clear;
  RPCBroker1.RemoteProcedure := 'DVBAB REPORTS';                                // RE-PRINT C&P FINAL';
  RPCBroker1.Param[1].Value := '4';
  RPCBroker1.Param[1].PType := literal;
  RPCBroker1.Param[2].Value := 'V^^R^' + labonly + '^' + FMExamRequestListBox.GetSelectedRecord.IEN + '^' + PatientIEN;
  RPCBroker1.Param[2].PType := literal;

  RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      // DVBAB REPRINT C&P FINAL
      StatusBarLoadPt.Caption := 'RPC DVBAB REPORTS could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('Connection to server for DVBAB REPORTS could not be established!');
    End;
  End;

  //Build Report
  StatusBarLoadPt.Caption := 'Downloading report.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
  ANURemoteProcedureCallInProgress := true;
  ReportMemo.Lines.Clear;
  screen.cursor := crHourglass;

  ReportMemo.SetSelTextBuf(RPCBroker1.Results.GetText);

  screen.cursor := crDefault;
  ReportMemo.Visible := True;
  ReportMemo.SelStart := 0;
  ReportMemo.SelLength := 0;
  Try
  ReportMemo.SetFocus Except
  End;
  ANURemoteProcedureCallinProgress := False;
  AnimateLogo(False);
  StatusBarLoadPt.Caption := 'Ready.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
  //End Of Build Report

  ORReportsAvailable.ItemIndex := 2;
  Page95Control1.ActivePage := TabReports
End;

Procedure TfrmMain.btnAdmissionsClick(Sender: TObject);
Var
  x: integer;
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;
  AnimateLogo(True);
  StatusBarLoadPt.Caption := 'Downloading past appointments.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;

  lblApptStatus.Caption := 'Admissions';

  {Use CPRS Visit Loader ORWPT ADMITLST}
  RPCBroker1.RemoteProcedure := 'ORWPT ADMITLST';
  RPCBroker1.Param[0].Value := PatientIEN;
  RPCBroker1.Param[0].PType := literal;
  RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'RPC ORWPT ADMITLST could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('Connection to server for ORWPT ADMITLST could not be established!');
    End;
  End;

  MemoAppointments.Lines.Clear;
  If RPCBroker1.Results.Count > 0 Then
  Begin
    For x := 0 To RPCBroker1.Results.Count - 1 Do
    Begin
      memoappointments.lines.add(Copy(FMDateTimeConvert(Piece(RPCBroker1.Results[x], '^', 1)) + '                    ', 1, 20) + ' ' +
        Copy('  Ward: ' + Piece(RPCBroker1.Results[x], '^', 3) + '                         ', 1, 25) + ' ' +
        Copy('  Source: ' + Piece(RPCBroker1.Results[x], '^', 4) + '                    ', 1, 20));
    End;
    memoappointments.lines.add('');
    memoappointments.lines.add('NOTE: Detailed descriptions of admissions are available on the CAPRI reports tab.');
  End
  Else
  Begin
    MemoAppointments.Lines.Add('No admissions found.');
  End;
  AnimateLogo(False);
  MemoAppointments.Setfocus;
  StatusBarLoadPt.Caption := 'Ready.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
End;

Procedure TfrmMain.btnMulti2Click(Sender: TObject);
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;
  formReportBuilderAuto := TformReportBuilderAuto.Create(frmMain);
  formReportBuilderAuto.buttonClinDocDateRange.Caption := frmMain.buttonClinDocDateRange.Caption;
  formReportBuilderAuto.ShowModal;
  formReportBuilderAuto.release;
  formReportBuilderAuto := Nil;
End;

Procedure TfrmMain.TimerInfoBoxTimer(Sender: TObject);
Begin
  inc(dvbatimerinfobox);
  //5 seconds, 250ms each)
  If dvbatimerinfobox >= 5 Then
  Begin
    TimerInfoBox.Enabled := False;
    TimerInfoBox.Interval := 500;                                               // Reset back to default in case code changed it
    frmInfoBox.release;
    frmInfoBox := Nil;
  End
  Else
  Begin
    (*
        If frmInfoBox.Label1.Visible=true then
          frmInfoBox.Label1.Visible:=False
        Else frmInfoBox.Label1.Visible:=True;
        frmInfoBox.BringToFront;
        *)
  End;
End;

//Provide a horizontal scrollbar for a list box
{***********************************************************************
 Listbox with horizontal scrollbar
 MaxWidth < 0 : adapt automatically to largest item
 MaxWidth >= 0: use value of MaxWidth for width of scrollable area
 ***********************************************************************}

Procedure TfrmMain.HorScrollBar(ListBox: TListBox; MaxWidth: integer);
Var
  i, w: integer;
Begin
  If MaxWidth >= 0 Then
    SendMessage(ListBox.Handle, LB_SETHORIZONTALEXTENT, MaxWidth, 0)
  Else
  Begin
    { get largest item }
    For i := 0 To ListBox.Items.Count - 1 Do
      With ListBox Do
      Begin
        w := Canvas.TextWidth(Items[i]);
        If w > MaxWidth Then
          MaxWidth := w;
      End;
    SendMessage(ListBox.Handle, LB_SETHORIZONTALEXTENT,
      MaxWidth + GetSystemMetrics(SM_CXFRAME), 0);
  End;
End;

Procedure TfrmMain.btnAdHocClick(Sender: TObject);
Begin
  Tab95Control2.TabIndex := 0;
  Tab95Control2.Tabs.Clear;
  Tab95Control2.Tabs.Add('Local');

  frmReportsAdhocComponent1 := tfrmReportsAdhocComponent1.create(frmMain);
  uListState := GetAdhocLookup();
  ListBoxRemoteDataPending.Items.Clear;                                         // Clear remote report retrieval

  uHSComponents.Clear;
  frmReportsAdhocComponent1.Showmodal;
  ANURemoteProcedureCallInProgress := true;
  frmReportsAdhocComponent1.Release;
  frmReportsAdhocComponent1 := Nil;
  HSMemoLocal.Lines.Clear;
  ComboBoxHSSections.Items.Clear;
  screen.cursor := crHourglass;

  HSMemoLocal.SetSelTextBuf(uLocalReportData.GetText);
  ORHealthSummaryUserList.ItemIndex := -1;

  screen.cursor := crDefault;
  HSMemoLocal.BringToFront;
  HSMemoLocal.Visible := True;
  HSMemoLocal.SelStart := 0;
  HSMemoLocal.SelLength := 0;
  Try
  HSMemoLocal.SetFocus Except
  End;

  Tab95Control2Change(Application);
  ANURemoteProcedureCallinProgress := False;
  AnimateLogo(False);
  StatusBarLoadPt.Caption := 'Ready.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
  screen.cursor := crDefault;
End;

Procedure TfrmMain.tempToolClick(Sender: TObject);
Var
  TempMenuItem: TAction;
  xx: integer;
  TempProgramName: Array[0..1024] Of char;
Begin
  if not (Sender.ClassName = 'TAction') then exit;
  TempMenuItem := Sender As TAction;
  xx := strToInt(Piece(tempMenuItem.Name, 'l', 2));
  StrPCopy(TempProgramName, pChar(Piece(FMListBoxCAPRITools.Items[xx], ';', 3)));
  WinExec(TempProgramName, SW_SHOWNORMAL);
End;

Procedure TfrmMain.ButtonOKSurgeryReportsClick(Sender: TObject);
Begin
  PanelSurgeryReports.Visible := False;
  RPCBroker1.RemoteProcedure := 'DVBAB REPORTS';                                //OPERATION REPORT
  RPCBroker1.Param[1].Value := '8';
  RPCBroker1.Param[1].PType := literal;
  RPCBroker1.Param[2].PType := literal;
  RPCBroker1.Param[2].Value := PatientIEN + '^' +
    Piece(SurgeryReports[ORListBoxSurgeryReports.ItemIndex], '^', 1);
  RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'DVBAB REPORTS could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('DVBAB OPERATION REPORT could not be accessed!');
    End;
  End;
  QuickCopy(RPCBroker1.Results, ReportMemo);
  If ReportMemo.Lines.Count = 0 Then
  Begin
    ReportMemo.Lines.Add('No data found for requested surgery report.  This is normally because the report is not yet completed.');
  End;
End;

Procedure TfrmMain.ButtonCancelSurgeryReportsClick(Sender: TObject);
Begin
  PanelSurgeryReports.Visible := False;
End;

Procedure TfrmMain.ORListBoxSurgeryReportsChange(Sender: TObject);
Begin
  ButtonOKSurgeryReports.Enabled := True;
End;

Procedure TfrmMain.ButtonGCPRGoClick(Sender: TObject);
Var
  x, xx, y: integer;
  reporttype: String;
  laststring: String;
  space: String;
  ReportShown: Boolean;
  StationNo: String;                                                            //required for local FHIE connections
Begin
  StationNo := '';
  If ANURemoteProcedureCallInProgress Then
    exit;

  If (UserDivisionNumber = '') Or (UserDivision = '') Then
  Begin
    ShowMessageCAPRI('Cannot identify your division.  This function is cancelled.');
    ORListBoxDODReportTypes.ItemIndex := -1;
    exit;
  End;

  x := 0;

  If dtpDODStartDate.Date > dtpDODEndDate.Date Then                             //CodeCR102 - rpm 4/12/10
  Begin
    ShowMessageCAPRI('Start must not be greater than end date.');
    ORListBoxDODReportTypes.ItemIndex := -1;
    exit;
  End;

  // Allow @ sign FM access to run the blocked reports
  // for development purposes.
  If Copy(ORListBoxDODReportTypes.Items[ORListBoxDODReportTypes.ItemIndex], 1, 1) = '~' Then
    If Pos('@', userfilemancode) < 0 Then
    Begin
      ShowMessageCAPRI('That report type is not available right now.');
      ORListBoxDODReportTypes.ItemIndex := -1;
      exit;
    End;

  If RPCBrokerDOD.Connected Then
  Begin
    ShowMessageCAPRI('A broker call is already in progress.  Cannot execute this report request');
    exit;
  End;

  ORListBoxDODReportTypes.enabled := false;
  sleep(500);                                                                   // Need this to deal with Broker calls clicked quickly in succession.

  Button1.Enabled := False;

  Try
    For xx := 0 To 4 Do
      For y := 0 To 4 Do
        VAWrapGridDOD.Cells[xx, y] := '';
  Except
  End;

  RPCBrokerDOD.ANUFHIEConnection := True;
  RPCBrokerDOD.Connected := False;
  RPCBrokerDOD.RPCTimeLimit := 28800;

  // Save ESSO version
  AnimateLogo(True);
  StatusBarLoadPt.Caption := 'Connecting to DoD server.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
  //Set DOD Broker division and get BSE token from home server
  RPCBrokerDOD.ANUstrDivisionHome := RPCBroker1.ANUstrDivisionHome;
  RPCBrokerDOD.Connect2HomeServer(RPCBroker1.ANUAccessCodeHome,
    RPCBroker1.ANUVerifyCodeHome,
    RPCBroker1.ANUstrServerHome,
    RPCBroker1.ANUstrPortHome,
    False);
  If Not RPCBrokerDOD.CreateContext('DVBA CAPRI GUI') Then
  Begin
    ShowMessageCAPRI('FHIE: Could not use option "DVBA CAPRI GUI!"');
    application.terminate;
  End;

  //determine station number required for local FHIE connections;
  // short-circuit when no station number
  if NOT ESSOVersion then
  begin
    StationNo := Piece(GetDivision(ESSOVersion, RPCBrokerDOD), '^', 3);
    if StationNo = '' then
    begin
      RPCBrokerDOD.ANUFHIEConnection := False;
      RPCBrokerDOD.Connected := False;
      ShowMessageCapri('Could not determine local station number for FHIE connection.');
      Exit;
    end;
  end;
  RPCBrokerDOD.Connected := False;
  sleep(1000);
  RPCBrokerDOD.Server := Piece(FHIESiteLocation, ',', 1);
  RPCBrokerDOD.ListenerPort := StrtoInt(Piece(FHIESiteLocation, ',', 2));
  RPCBrokerDOD.ANUUserSpecs :=
    AuthorSSN + '^' +
    AuthorName + '^' +
    UserDivision + '^' +                                                        // Site
    UserDivisionNumber + '^' +                                                  // Site num
    AuthorIEN;

  //Connect to remote server with BSE token
  RPCBrokerDOD.Connect2RemoteServer(RPCBrokerDOD.Server,
    IntToStr(RPCBrokerDOD.ListenerPort),
    False, True, StationNo);
  If Not RPCBrokerDOD.CreateContext('DVBA CAPRI GUI') Then
  Begin
    ShowMessageCAPRI('FHIE: Could not use option "DVBA CAPRI GUI!"');
    application.terminate;
  End;
  If RPCBrokerDOD.Connected = False Then
  Begin
    ShowMessageCAPRI('FHIE: Could not use option "DVBA CAPRI GUI!"');
    application.terminate;
  End;

  If PatientIENDoD = '' Then
  Begin
    //ShowMessageCAPRI('icn: '+patienticn);
    StatusBarLoadPt.Caption := 'Matching patient on FHIE.';
    StatusBarLoadPt.Repaint;
    Application.Processmessages;
    RPCBrokerDOD.RemoteProcedure := 'DVBAB FIND DFN BY ICN';
    RPCBrokerDOD.Param[0].Value := patientICN;
    RPCBrokerDOD.Param[0].PType := literal;
    RPCBrokerCall;
    Try
      RPCBrokerDOD.Call;
    Except
      On E: EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        AnimateLogo(False);
        StatusBarLoadPt.Caption := 'RPC DVBAB FIND DFN BY ICN could not be accessed!';
        StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('XWB DVBAB FIND DFN BY ICN could not be accessed!'
          + #13#10 + #13#10 + 'Error: ' + E.Message);
        // Set back ESSO version
        RPCBrokerDOD.Connected := False;
        RPCBrokerDOD.ANUFHIEConnection := False;
        ORListBoxDODReportTypes.enabled := true;
        RPCBrokerDOD.Connected := False;
        sleep(1000);
        exit;
      End;
    End;
    If RPCBrokerDOD.Results[0] = 'NOT A VALID ICN' Then
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'Could not match patient on FHIE.';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('Unable to find patient on FHIE.');
      RPCBrokerDOD.Connected := False;
      RPCBrokerDOD.ANUFHIEConnection := False;
      ORListBoxDODReportTypes.enabled := true;
      RPCBrokerDOD.Connected := False;
      sleep(1000);
      exit;
    End
    Else
      PatientIENDoD := RPCBrokerDOD.Results[0];
    RPCBrokerDOD.ANUFHIEConnection := False;
  End;


  PanelFHIEOptions.Visible := False;
  RPCBrokerDOD.ANUFHIEConnection := True;
  StatusBarLoadPt.Caption := 'Querying DoD report.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
  RPCBrokerDOD.RemoteProcedure := 'DVBAB DOD REPORT';
  RPCBrokerDOD.Param[1].Value := PatientIENDoD;                                 // IEN on remote system
  RPCBrokerDOD.Param[1].PType := literal;
  RPCBrokerDOD.Param[2].Value := Piece(ORListBoxDODReportTypes.Items[ORListBoxDODReportTypes.ItemIndex], '^', 2); // Report Type
  reporttype := RPCBrokerDOD.Param[2].Value;
  RPCBrokerDOD.Param[2].PType := literal;
  RPCBrokerDOD.Param[3].Value := FMToDateConvert(FormatDateTime('mm/dd/yyyy', dtpDODStartDate.DateTime)); //Begin Date //CodeCR102 - rpm 4/12/10
  RPCBrokerDOD.Param[3].PType := literal;
  RPCBrokerDOD.Param[4].Value := FMToDateConvert(FormatDateTime('mm/dd/yyyy', dtpDODEndDate.DateTime)); // End Date //CodeCR102 - rpm 4/12/10
  RPCBrokerDOD.Param[4].PType := literal;
  RPCBrokerDOD.Param[5].Value := EditDODMaxItems.Text;
  RPCBrokerDOD.Param[5].PType := literal;
  RPCBrokerDOD.Param[6].Value := Piece(ORListBoxDODReportTypes.Items[ORListBoxDODReportTypes.ItemIndex], '^', 3); // Temp Global Name
  RPCBrokerDOD.Param[6].PType := literal;
  HeaderControlDODAllergies.Visible := False;
  HeaderControlDODConsults.Visible := False;
  HeaderControlDODLRC.Visible := False;
  HeaderControlDODDCS.Visible := False;
  HeaderControlDODLRCY.Visible := False;
  HeaderControlDODPNs.Visible := False;
  HeaderControlDODMI.Visible := False;
  HeaderControlDODRR.Visible := False;
  RichEditDODReport.Lines.Clear;
  PanelDODGrids.Visible := False;
  RichEditDODTempReport.Lines.Clear;
  //ShowMessageCAPRI(RPCBrokerDOD.Param[3].Value+'     '+RPCBrokerDOD.Param[4].Value);

  ProgressBarLoadPt.Position := 0;
  ProgressBarLoadPt.Visible := True;
  ProgressBarLoadPt.Max := 100;
  TimerFHIERunning.Enabled := True;

  RPCBrokerCall;
  Try
    RPCBrokerDOD.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'RPC DVBAB DOD REPORT could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      // Set back ESSO version
      RPCBrokerDOD.Connected := False;
      ProgressBarLoadPt.Visible := False;
      ProgressBarLoadPt.Position := 0;
      TimerFHIERunning.Enabled := False;
      ShowMessageCAPRI('RPC DVBAB DOD REPORT could not be accessed!');
      RPCBrokerDOD.ANUFHIEConnection := False;
      ORListBoxDODReportTypes.enabled := true;
      RPCBrokerDOD.Connected := False;
      sleep(1000);
      exit;
    End;
  End;
  RichEditDODTempReport.SetSelTextBuf(RPCBrokerDOD.Results.GetText);
  PanelDODGrids.Visible := False;

  //ProgressBarLoadPt.Visible:=False;
  ProgressBarLoadPt.Position := 0;
  TimerFHIERunning.Enabled := False;
  RPCBrokerDOD.ANUFHIEConnection := True;
  If RPCBrokerDOD.Results.Count = 0 Then
  Begin
    RichEditDODReport.Lines.Add('No data was returned for the selected report type.');
  End
  Else
    If RPCBrokerDOD.results.Count > 0 Then
    Begin

      ReportShown := False;

      If ReportType = 'ADT' Then
      Begin
        ReportShown := True;
        //RichEditDodReport.Lines:=RichEditDoDTempReport.Lines;
        If TabDOD.PageIndex = 8 Then
        Begin
          RichEditDODReport.Visible := True;
          RichEditDODReport.SetSelTextBuf(RichEditDODTempReport.Lines.GetText);
        End;
      End;

      If ReportType = 'DS' Then
      Begin
        If RPCBrokerDOD.Results.Count > 0 Then
        Begin
          ReportShown := True;
          If TabDOD.PageIndex = 8 Then
          Begin
            PanelDODGrids.Visible := True;
            HeaderControlDODDCS.Visible := True;
          End;
          HeaderControlDODDCSSectionResize(HeaderControlDODDCS, HeaderControlDODDCS.Sections[0]);
          VAWrapGridDOD.RowCount := 1;
          y := 0;
          x := 0;
          Repeat
            Begin
              If Pos('^', RPCBrokerDOD.Results[x]) > 0 Then
              Begin
                //If RPCBrokerDOD.Results[x]='1^No
                VAWrapGridDOD.Cells[0, y] := Piece(Piece(RPCBrokerDOD.Results[x], '^', 2), ';', 1);
                inc(x);
                If Piece(Piece(RPCBrokerDOD.Results[x - 1], '^', 2), ';', 1) <> 'No remote patient data found for these request parameters.' Then
                Begin
                  VAWrapGridDOD.Cells[1, y] := Piece(RPCBrokerDOD.Results[x], '^', 2);
                  inc(x);
                  VAWrapGridDOD.Cells[2, y] := Piece(RPCBrokerDOD.Results[x], '^', 2);
                  inc(x);
                  VAWrapGridDOD.Cells[3, y] := Piece(RPCBrokerDOD.Results[x], '^', 2);
                  inc(x);
                  VAWrapGridDOD.Cells[4, y] := Piece(RPCBrokerDOD.Results[x], '^', 2);
                  inc(x);
                  VAWrapGridDOD.Cells[5, y] := Piece(RPCBrokerDOD.Results[x], '^', 2);
                  inc(x);
                  VAWrapGridDOD.Cells[6, y] := Piece(RPCBrokerDOD.Results[x], '^', 2);
                  inc(x);
                End
                Else
                Begin
                  inc(x);
                  inc(x);
                  inc(x);
                  inc(x);
                  inc(x);
                  inc(x);
                End;
                inc(y);
                VAWrapGridDOD.RowCount := y;
              End
              Else
              Begin
              End;
              Repeat inc(x)Until (x >= RPCBrokerDOD.Results.Count) Or (Piece(RPCBrokerDOD.Results[x], '^', 1) = '1');
          End Until x >= RPCBrokerDOD.Results.Count;
          VAWrapGridDODClick(Application);
          //RichEditDODReport.Visible:=True;
          //RichEditDODReport.SetSelTextBuf(RichEditDODTempReport.Lines.GetText);
        End;
      End;

      If ReportType = 'LRC' Then
      Begin                                                                     // chem/hem
        Button1.Enabled := True;
        ReportShown := True;
        If TabDOD.PageIndex = 8 Then
        Begin
          PanelDODGrids.Visible := True;
          HeaderControlDODLRC.Visible := True;
          PanelFHIEOptions.Visible := True;
        End;
        HeaderControlDODLRCSectionResize(HeaderControlDODLRC, HeaderControlDODLRC.Sections[0]);
        VAWrapGridDOD.RowCount := 1;
        y := 0;
        x := 0;
        ProgressBarLoadPt.Max := RPCBrokerDOD.Results.Count;
        Repeat
          Begin
            If Pos('^', RPCBrokerDOD.Results[x]) > 0 Then
            Begin
              VAWrapGridDOD.Cells[0, y] := Piece(RPCBrokerDOD.Results[x], '^', 1);
              VAWrapGridDOD.Cells[1, y] := Piece(RPCBrokerDOD.Results[x], '^', 3);
              VAWrapGridDOD.Cells[2, y] := Piece(RPCBrokerDOD.Results[x], '^', 4);
              VAWrapGridDOD.Cells[3, y] := Piece(RPCBrokerDOD.Results[x], '^', 6);
              VAWrapGridDOD.Cells[4, y] := Piece(RPCBrokerDOD.Results[x], '^', 5);
              VAWrapGridDOD.Cells[5, y] := Piece(RPCBrokerDOD.Results[x], '^', 2);
              VAWrapGridDOD.Cells[6, y] := Piece(RPCBrokerDOD.Results[x], '^', 7);
              VAWrapGridDOD.Cells[7, y] := Piece(RPCBrokerDOD.Results[x], '^', 8);
              inc(y);
              VAWrapGridDOD.RowCount := y;
            End
            Else
            Begin
            End;
            inc(x);
            ProgressBarLoadPt.Position := x;
            ProgressBarLoadPt.Repaint;
            StatusBarLoadPt.Repaint;
        End Until x >= RPCBrokerDOD.Results.Count;
        VAWrapGridDODClick(Application);
      End;
      If ReportType = 'RXOP' Then
      Begin                                                                     // Outpatient Pharmacy
        ReportShown := True;
        If RichEditDODTempReport.Lines.Count > 0 Then
          x := RichEditDODTempReport.Lines.Count - 1;
        anuremoteprocedurecallinprogress := true;
        cursor := crHourglass;
        RichEditDODReport.Visible := False;
        ProgressBarLoadPt.Max := RPCBrokerDOD.Results.Count;
        Repeat
          Begin
            If Piece(RichEditDODTempReport.Lines[x], ';', 1) <> 'No remote patient data found for these request parameters.' Then
            Begin
              RichEditDODTempReport.Lines.Insert(x + 1, '');
              RichEditDODTempReport.Lines[x] := 'Site: ' + Piece(RichEditDODTempReport.Lines[x], ';', 1);
              dec(x);
              RichEditDODTempReport.Lines[x] := 'SIG:  ' + RichEditDODTempReport.Lines[x];
              dec(x);
              RichEditDODTempReport.Lines.Insert(x, 'PROVIDER: ' + Piece(Piece(RichEditDODTempReport.Lines[x], '^', 4), ';', 2) + '  DATE: ' + FMDateTimeConvert(Piece(RichEditDODTempReport.Lines[x],
                '^', 2)));
              RichEditDODTempReport.Lines[x + 1] := Piece(Piece(RichEditDODTempReport.Lines[x + 1], '^', 3), ';', 2) + '  Quantity: ' + Piece(RichEditDODTempReport.Lines[x + 1], '^', 7) + '  Status: '
                + Piece(Piece(RichEditDODTempReport.Lines[x + 1], '^', 5), ';', 2);
              dec(x);
            End
            Else
            Begin
              //RichEditDODTempReport.Lines.Add('No remote patient data found for these request parameters.');
              x := -1;
            End;
            ProgressBarLoadPt.Position := x;
            ProgressBarLoadPt.Repaint;
            StatusBarLoadPt.Repaint;
        End Until x < 0;
        anuremoteprocedurecallinprogress := False;
        cursor := crDefault;
        RichEditDODReport.Visible := True;
        RichEditDODReport.SetSelTextBuf(RichEditDODTempReport.Lines.GetText);
      End;
      If ReportType = 'MI' Then
      Begin                                                                     // Microbiology
        ReportShown := True;
        PanelDODGrids.Visible := True;
        HeaderControlDODMI.Visible := True;
        HeaderControlDODMISectionResize(HeaderControlDODMI, HeaderControlDODMI.Sections[0]);
        VAWrapGridDOD.RowCount := 1;
        y := 0;
        x := 0;
        ProgressBarLoadPt.Max := RPCBrokerDOD.Results.Count;
        Repeat
          Begin
            If Pos('^', RPCBrokerDOD.Results[x]) > 0 Then
            Begin
              //Line 1
              VAWrapGridDOD.Cells[0, y] := Piece(RPCBrokerDOD.Results[x], '^', 1); //Collect Date/Time
              VAWrapGridDOD.Cells[1, y] := Piece(RPCBrokerDOD.Results[x], '^', 6); //Report Status
              VAWrapGridDOD.Cells[2, y] := Piece(RPCBrokerDOD.Results[x], '^', 5); //Lab Test
              inc(x);
              If Pos('^', RPCBrokerDOD.Results[x]) = 0 Then
                Repeat
                  Begin
                    //Text Line
                    inc(x);
                End Until Pos('^', RPCBrokerDOD.Results[x]) > 0;
              //Smear Results?
              inc(x);
              VAWrapGridDOD.Cells[3, y] := Piece(RPCBrokerDOD.Results[x], '^', 3); //Result
              inc(x);
              //Site
              inc(x);
            End;
            inc(y);
            ProgressBarLoadPt.Position := x;
            ProgressBarLoadPt.Repaint;
            StatusBarLoadPt.Repaint;

        End Until (x >= RPCBrokerDOD.Results.Count) Or (y >= RPCBrokerDOD.Results.Count);
        VAWrapGridDOD.RowCount := y;
        VAWrapGridDODClick(Application);
      End;
      If ReportType = 'RR' Then
      Begin                                                                     // Radiology
        ReportShown := True;
        PanelDODGrids.Visible := True;
        HeaderControlDODRR.Visible := True;
        HeaderControlDODRRSectionResize(HeaderControlDODRR, HeaderControlDODRR.Sections[0]);
        VAWrapGridDOD.RowCount := 1;
        y := 0;
        x := 0;
        ProgressBarLoadPt.Max := RPCBrokerDOD.Results.Count;
        Repeat
          Begin
            If Pos('^', RPCBrokerDOD.Results[x]) > 0 Then
            Begin
              //Line 1
              VAWrapGridDOD.Cells[0, y] := FMDateTimeConvert(Piece(RPCBrokerDOD.Results[x], '^', 1)); //Date/Time
              VAWrapGridDOD.Cells[1, y] := Piece(RPCBrokerDOD.Results[x], '^', 2); //Test Type
              VAWrapGridDOD.Cells[2, y] := Piece(RPCBrokerDOD.Results[x], '^', 4); //Status
              inc(x);
              If Pos('^', RPCBrokerDOD.Results[x]) = 0 Then
                Repeat
                  Begin
                    //Text Line
                    inc(x);
                End Until (Pos('^', RPCBrokerDOD.Results[x]) > 0) Or (x >= RPCBrokerDOD.Results.Count - 1);
            End;
            inc(y);
            ProgressBarLoadPt.Position := x;
            ProgressBarLoadPt.Repaint;
            StatusBarLoadPt.Repaint;
        End Until (x >= RPCBrokerDOD.Results.Count - 1) Or (y > RPCBrokerDOD.Results.Count - 1);
        VAWrapGridDOD.RowCount := y;
        VAWrapGridDODClick(Application);
      End;

      If ReportType = 'LRO' Then
      Begin                                                                     // Lab Orders
        ReportShown := True;
        y := 0;
        space := '                                                                                '; // 80 spaces
        anuremoteprocedurecallinprogress := true;
        cursor := crHourglass;
        RichEditDODReport.Visible := False;
        ProgressBarLoadPt.Max := RPCBrokerDOD.Results.Count;
        Repeat
          Begin
            If Piece(RichEditDODTempReport.Lines[y], ';', 1) <> '^^^^^^^^^' Then
            Begin
              RichEditDODReport.Lines.Add(
                Copy(Piece(RichEditDODTempReport.Lines[y], '^', 1) + space, 1, 18) + '  ' + // Date/Time
                Copy(Piece(Piece(RichEditDODTempReport.Lines[y], '^', 2), ';', 2) + space, 1, 32) + // Test Type
                'Specimen: ' + Piece(Piece(RichEditDODTempReport.Lines[y], '^', 3), ';', 2) // Specimen Type
                );
              RichEditDODReport.Lines.Add(
                Copy(Piece(RichEditDODTempReport.Lines[y], '^', 5) + space, 1, 17) + // Status
                'Urgency: ' + Copy(Piece(RichEditDODTempReport.Lines[y], '^', 4) + space, 1, 26) + // Urgency
                'Collect Type: ' + Piece(RichEditDODTempReport.Lines[y], '^', 10) // Lab/Ward collect
                );
              RichEditDODReport.Lines.Add('                 Provider: ' + Piece(Piece(RichEditDODTempReport.Lines[y], '^', 6), ';', 2)); // Site
              RichEditDODReport.Lines.Add('                 Date/Time Lab Ordered:       ' + Piece(RichEditDODTempReport.Lines[y], '^', 7)); // Date/Time Lab Ordered
              RichEditDODReport.Lines.Add('                 Date/Time Results Available: ' + Piece(RichEditDODTempReport.Lines[y], '^', 9)); // Date/Time Results Available
              RichEditDODReport.Lines.Add('                 Accession #:' + Piece(RichEditDODTempReport.Lines[y], '^', 8)); // Accession #
              inc(y);
              RichEditDODReport.Lines.Add('                 Site: ' + Piece(RichEditDODTempReport.Lines[y], ';', 1)); // Site
              RichEditDODReport.Lines.Add('');                                  // Separator line
            End
            Else
            Begin
              inc(y);
              RichEditDODReport.Lines.Add(Piece(RichEditDODTempReport.Lines[y], ';', 1));
            End;
            inc(y);
            ProgressBarLoadPt.Position := y;
            ProgressBarLoadPt.Repaint;
            StatusBarLoadPt.Repaint;
            statusbarloadpt.caption := 'Line ' + inttostr(y) + ' of ' + inttostr(RPCBrokerDOD.Results.Count) + '             ';

        End Until y >= RPCBrokerDOD.Results.Count;
        RichEditDODReport.Visible := True;
        cursor := crDefault;
        anuremoteprocedurecallinprogress := false;
      End;
      If (ReportType = 'CY') Or (ReportType = 'SP') Then
      Begin                                                                     // Surgical Pathology/Cytology
        ReportShown := True;
        PanelDODGrids.Visible := True;
        HeaderControlDODLRCY.Visible := True;
        HeaderControlDODLRCYSectionResize(HeaderControlDODLRC, HeaderControlDODLRC.Sections[0]);
        VAWrapGridDOD.RowCount := 1;
        y := -1;
        x := 0;
        laststring := '';
        ProgressBarLoadPt.Max := RPCBrokerDOD.Results.Count;
        Repeat
          Begin
            Try
              If RPCBrokerDOD.Results[1] = '' Then
              Begin
                VAWrapGridDod.Cells[0, 0] := 'No remote patient data found for these request parameters.'
              End;
            Except
            End;
            If Pos('^', RPCBrokerDOD.Results[x]) > 0 Then
            Begin
              If laststring <> '' Then
                VAWrapGridDOD.Cells[3, y] := Piece(laststring, ';', 1);         // Site
              inc(y);
              VAWrapGridDOD.Cells[0, y] := Piece(RPCBrokerDOD.Results[x], '^', 1); // Collect Date
              inc(x);
              VAWrapGridDOD.Cells[2, y] := FMDateTimeConvert(Piece(RPCBrokerDOD.Results[x], '^', 2)); // Report Date/Time
              inc(x);
              VAWrapGridDOD.Cells[1, y] := RPCBrokerDOD.Results[x];             // Specimen Type
              inc(x);
              VAWrapGridDOD.RowCount := y + 1;
            End
            Else
            Begin
              LastString := RPCBrokerDOD.Results[x];
            End;
            inc(x);
            ProgressBarLoadPt.Position := x;
            ProgressBarLoadPt.Repaint;
            StatusBarLoadPt.Repaint;
        End Until x >= RPCBrokerDOD.Results.Count;
        If (laststring <> '') And (laststring <> 'No remote patient data found for these request parameters.') Then
          VAWrapGridDOD.Cells[3, y] := Piece(laststring, ';', 1);               // Site
        VAWrapGridDODClick(Application);
      End;

      // Progress Notes

      If (ReportType = 'PN') Then
      Begin                                                                     // Progress Notes
        ReportShown := True;
        PanelDODGrids.Visible := True;
        HeaderControlDODPNs.Visible := True;
        HeaderControlDODPNsSectionResize(HeaderControlDODPNs, HeaderControlDODPNs.Sections[0]);
        VAWrapGridDOD.RowCount := 1;
        y := 0;
        x := 0;
        laststring := '';
        ProgressBarLoadPt.Max := RPCBrokerDOD.Results.Count;
        QuickCopy(RPCBrokerDoD.Results, RichEditDoDTempReport);
        Repeat
          Begin
            // CodeCR179 -MER 04/2011 The record returned is not always as the
            //   following code expected it to be.  As a result x was being
            //   incremented beyond the last item of RPCBrokerDOD.Results.  This
            //   exception handling block was added to protect against the
            //   resulting index out of bounds exceptions
            try
              VAWrapGridDOD.Cells[0, y] := Piece(RPCBrokerDOD.Results[x], '^', 2);
              inc(x);
              inc(x);                                                           // Skip 2nd field, not sure what it's for
              VAWrapGridDOD.Cells[1, y] := Piece(RPCBrokerDOD.Results[x], '^', 2);
              inc(x);
              VAWrapGridDOD.Cells[2, y] := Piece(RPCBrokerDOD.Results[x], '^', 2);
              inc(x);
              VAWrapGridDOD.Cells[3, y] := Piece(RPCBrokerDOD.Results[x], '^', 2);
              inc(x);
              If (Piece(RPCBrokerDOD.Results[x], '^', 1) <> '7') Then
                Repeat inc(x);
                Until (Piece(RPCBrokerDOD.Results[x], '^', 1) = '7');
              VAWrapGridDOD.Cells[4, y] := Piece(RPCBrokerDOD.Results[x], '^', 2);
              inc(x);
              If (Piece(RPCBrokerDOD.Results[x], '^', 1) <> '8') Then
                Repeat inc(x);
                Until (Piece(RPCBrokerDOD.Results[x], '^', 1) = '8');
              inc(x);
            except
              x := RPCBrokerDOD.Results.Count;
            end;
            VAWrapGridDOD.RowCount := y + 1;
            inc(y);
            ProgressBarLoadPt.Position := x;
            ProgressBarLoadPt.Repaint;
            StatusBarLoadPt.Repaint;
        End Until x >= RPCBrokerDOD.Results.Count;
        VAWrapGridDOD.RowCount := y;
        If (laststring <> '') And (laststring <> 'No remote patient data found for these request parameters.') Then
          VAWrapGridDOD.Cells[3, y] := Piece(laststring, ';', 1);               // Site
        VAWrapGridDODClick(Application);
      End;

      // Consult Reports
      If (ReportType = 'CONS') Then
      Begin                                                                     // Surgical Pathology/Cytology
        ReportShown := True;
        PanelDODGrids.Visible := True;
        HeaderControlDODConsults.Visible := True;
        PanelFHIEOptions.Visible := True;
        HeaderControlDODConsultsSectionResize(HeaderControlDODConsults, HeaderControlDODConsults.Sections[0]);
        VAWrapGridDOD.RowCount := 1;
        y := 0;
        x := 0;
        ProgressBarLoadPt.Max := RPCBrokerDOD.Results.Count;
        Repeat
          Begin
            If Pos('1^', RPCBrokerDOD.Results[x]) = 1 Then
            Begin
              VAWrapGridDOD.Cells[0, y] := Piece(Piece(RPCBrokerDOD.Results[x], '^', 2), ';', 1);
              inc(x);
              VAWrapGridDOD.Cells[1, y] := Piece(RPCBrokerDOD.Results[x], '^', 2);
              inc(x);
              VAWrapGridDOD.Cells[2, y] := Piece(RPCBrokerDOD.Results[x], '^', 2);
              inc(x);
              VAWrapGridDOD.Cells[3, y] := Piece(RPCBrokerDOD.Results[x], '^', 2);
              inc(x);
              VAWrapGridDOD.Cells[4, y] := Piece(RPCBrokerDOD.Results[x], '^', 2);
              inc(x);
              VAWrapGridDOD.Cells[5, y] := Piece(RPCBrokerDOD.Results[x], '^', 2);
              // inc(x);
              inc(y);
              Repeat
                Begin
                  inc(x);
              End Until ((x = RPCBrokerDOD.Results.Count - 1) Or (Pos('1^', RPCBrokerDOD.Results[x]) = 1));
              VAWrapGridDOD.RowCount := y;
            End
            Else
            Begin
              inc(x);
            End;
            ProgressBarLoadPt.Position := x;
            ProgressBarLoadPt.Repaint;
            StatusBarLoadPt.Repaint;
        End Until x >= RPCBrokerDoD.Results.Count;
        VAWrapGridDODClick(Application);
        If (laststring <> '') And (laststring <> 'No remote patient data found for these request parameters.') Then
          VAWrapGridDOD.Cells[3, y] := Piece(laststring, ';', 1);               // Site
        VAWrapGridDODClick(Application);
      End;

      // Allergies
      If (ReportType = 'ALRG') Then
      Begin                                                                     // Allergies
        ReportShown := True;
        PanelDODGrids.Visible := True;
        HeaderControlDODAllergies.Visible := True;
        PanelFHIEOptions.Visible := True;
        HeaderControlDODAllergiesSectionResize(HeaderControlDODAllergies, HeaderControlDODAllergies.Sections[0]);
        VAWrapGridDOD.RowCount := 1;
        y := 0;
        x := 0;
        ProgressBarLoadPt.Max := RPCBrokerDoD.Results.Count;
        Repeat
          Begin
            If Pos('1^', RPCBrokerDoD.Results[x]) = 1 Then
            Begin
              VAWrapGridDOD.Cells[0, y] := Piece(Piece(RPCBrokerDoD.Results[x], '^', 2), ';', 1);
              //VAWrapGridDOD.Cells[0,y]:=Piece(RPCBrokerDoD.Results[x],'^',2);
              inc(x);
              VAWrapGridDOD.Cells[1, y] := Piece(RPCBrokerDoD.Results[x], '^', 2);
              inc(x);
              VAWrapGridDOD.Cells[2, y] := Piece(RPCBrokerDoD.Results[x], '^', 2);
              inc(x);
              inc(x);                                                           // Not used
              inc(y);
              If x < RPCBrokerDoD.Results.Count - 1 Then
                Repeat
                  Begin
                    inc(x);
                End Until ((x = RPCBrokerDoD.Results.Count - 1) Or (Pos('1^', RPCBrokerDoD.Results[x]) = 1));
              VAWrapGridDOD.RowCount := y;
            End
            Else
            Begin
              inc(x);
            End;
            ProgressBarLoadPt.Position := x;
            ProgressBarLoadPt.Repaint;
            StatusBarLoadPt.Repaint;
        End Until x >= RPCBrokerDoD.Results.Count;
        VAWrapGridDODClick(Application);
        If (laststring <> '') And (laststring <> 'No remote patient data found for these request parameters.') Then
          VAWrapGridDOD.Cells[3, y] := Piece(laststring, ';', 1);               // Site
        VAWrapGridDODClick(Application);
      End;

      // Report type not coded, so use standard display
      // Ambulatory Data report will use this
      If ReportShown = False Then
      Begin
        PanelDODGrids.Visible := False;
        x := 0;
        ProgressBarLoadPt.Max := RPCBrokerDoD.Results.Count;
        If RPCBrokerDoD.Results.Count > 0 Then
          Repeat
            Begin
              RichEditDODReport.Lines.Add(RPCBrokerDoD.Results[x]);
              inc(x);
              ProgressBarLoadPt.Position := x;
              ProgressBarLoadPt.Repaint;
              StatusBarLoadPt.Repaint;
          End Until x >= RPCBrokerDoD.Results.Count;
      End;

    End;

  RPCBrokerDoD.Connected := False;
  sleep(1000);

  // Set back ESSO version
  // The following code was changed because Togus was locking after an FHIE call
  ESSOConnecting := true;
  RPCBroker1.Connected := False;
  sleep(1000);
  //RPCBroker1.Connected := true;  BSE mod - rpm 4/8/09
  If Not ConnectToServer('DVBA CAPRI GUI') Then
  Begin
    ShowMessageCAPRI('FHIE1: Could not use option "DVBA CAPRI GUI!"');
    application.terminate;
  End;
  If RPCBroker1.Connected = False Then
  Begin
    ShowMessageCAPRI('FHIE2: Could not use option "DVBA CAPRI GUI!"');
    application.terminate;
  End;
  ESSOConnecting := False;
  //////////////////////////////////////////////////////////////////////////////

  ProgressBarLoadPt.Visible := False;
  //RPCBrokerDoD.Connected:=False;
  TimeSinceLastBrokerCall := 29;                                                //Force pulse
  RPCBrokerDOD.ANUFHIEConnection := False;

  AnimateLogo(False);
  StatusBarLoadPt.Caption := 'Ready.';
  StatusBarLoadPt.Repaint;
  Application.Processmessages;
  ORListBoxDODReportTypes.enabled := true;
End;

Procedure TfrmMain.HeaderControlDODLRCSectionResize(
  HeaderControl: THeaderControl; Section: THeaderSection);
Begin
  VAWrapGridDOD.ColCount := 8;
  VAWrapGridDOD.ColWidths[0] := HeaderControlDODLRC.Sections[0].Width - 2;
  VAWrapGridDOD.ColWidths[1] := HeaderControlDODLRC.Sections[1].Width - 2;
  VAWrapGridDOD.ColWidths[2] := HeaderControlDODLRC.Sections[2].Width - 1;
  VAWrapGridDOD.ColWidths[3] := HeaderControlDODLRC.Sections[3].Width - 1;
  VAWrapGridDOD.ColWidths[4] := HeaderControlDODLRC.Sections[4].Width - 1;
  VAWrapGridDOD.ColWidths[5] := HeaderControlDODLRC.Sections[5].Width - 1;
  VAWrapGridDOD.ColWidths[6] := HeaderControlDODLRC.Sections[6].Width - 1;
  VAWrapGridDOD.ColWidths[7] := HeaderControlDODLRC.Sections[7].Width - 1;
End;

Procedure TfrmMain.EditDODMaxItemsExit(Sender: TObject);
Begin
  Try
    If StrToInt(EditDODMaxItems.Text) < 1 Then
  EditDODMaxItems.Text := '100' Except
  End;
  Try
  EditDODMaxItems.Text := IntToStr(StrToInt(EditDODMaxItems.Text))Except EditDODMaxItems.Text := '100'
  End;
End;

Procedure TfrmMain.Tab95Control3Change(Sender: TObject);
Begin
  ScrollBoxAddress.Visible := False;
  PanelAppointments.Visible := False;
  If Tab95Control3.Tabs[Tab95Control3.TabIndex] = '&V)  Address' Then
  Begin
    ScrollBoxAddress.Visible := True;
  End;
  If Tab95Control3.Tabs[Tab95Control3.TabIndex] = '&W)  Appointments' Then
  Begin
    PanelAppointments.Visible := True;
  End;
End;

{==============================================================================
  ca508ListBoxIPR1ValueQuery
    ca508ListBoxIPR1ValueQuery is a method that will build a string to be
      annunciated by a screen reader for ListBoxIPR1 items.  The problem this
      method corrects is the inability of a screen reader to list the component
      forms (sub-items) listed below a merged form item.
      Note: Sub-items start with '!'.  The '!' is a flag to format differently
      and prevent selection.  The '!' character is stripped out on display.

  Modification History:
    CodeCR117 - 11/2010 Method created -MER
 ==============================================================================}

procedure TfrmMain.ca508ListBoxIPR1ValueQuery(Sender: TObject;
  var Text: string);
var
  lText: string;
  lNdx: integer;
begin
  lNdx := ListBoxIPR1.ItemIndex;
  lText := '';
  if (lNdx > -1) then begin
    lText := Copy(ListBoxIPR1.Items[lNdx], 2, Length(ListBoxIPR1.Items[lNdx]) - 1);
    Inc(lNdx);
    while (lNdx <= (ListBoxIPR1.Items.Count - 1)) and                           // not out of range
      (Copy(ListBoxIPR1.Items[lNdx], 1, 1) = '!')                               // this item is a sub-item
      do begin
      lText := lText + ',  Includes form ' + Copy(ListBoxIPR1.Items[lNdx], 2, Length(ListBoxIPR1.Items[lNdx]) - 1);
      Inc(lNdx);
    end;
  end;
  Text := lText;
end;

Procedure TfrmMain.VAWrapGridDODClick(Sender: TObject);
Var
  x, y, z: integer;
  reporttype: String;
  labdata: String;
Begin
  If VAWrapGridDOD.Row < 0 Then
    exit;
  ReportType := Piece(ORListBoxDODReportTypes.Items[ORListBoxDODReportTypes.ItemIndex], '^', 2); // Report Type
  RichEditDODReport.Lines.Clear;
  If ReportType = 'PN' Then
  Begin
    x := 0;
    y := 0;
    RichEditDODReport.Visible := False;
    Repeat
      Begin
        Repeat
          inc(x);
        Until Piece(RichEditDODTempReport.Lines[x], '^', 1) = '6';
        If VAWrapGridDOD.Row = y Then
        Begin
          Repeat
            RichEditDODReport.Lines.Add(Piece(RichEditDODTempReport.Lines[x], '^', 2));
            inc(x);
          Until Piece(RichEditDODTempReport.Lines[x], '^', 1) <> '6';
          // Force cursor to top
          RichEditDODReport.Lines.Insert(0, '');
          RichEditDODReport.Lines.Delete(0);
          RichEditDODReport.Visible := True;
          exit;
        End
        Else
        Begin
          Repeat
            inc(x);
          Until Piece(RichEditDODTempReport.Lines[x], '^', 1) <> '6';
        End;
        Repeat
          inc(x);
        Until Piece(RichEditDODTempReport.Lines[x], '^', 1) = '8';
        inc(x);
        inc(y);
    End Until x >= RichEditDODTempReport.Lines.Count;
    // Force cursor to top
    RichEditDODReport.Lines.Insert(0, '');
    RichEditDODReport.Lines.Delete(0);
    RichEditDODReport.Visible := True;
  End;
  If ReportType = 'CONS' Then
  Begin
    x := 0;
    y := 0;
    If RichEditDODTempReport.Lines.Count = 0 Then
      exit;

    // Search for the right report chunk in the returned data
    If VAWrapGridDOD.Row > y Then
      Repeat
        Begin
          inc(x);
          If Pos('1^', RichEditDODTempReport.Lines[x]) = 1 Then
            inc(y);
      End Until y = VAWrapGridDOD.Row;

    // Find report at 7th piece
    Repeat
      Begin
        inc(x);
    End Until Pos('7^', RichEditDODTempReport.Lines[x]) = 1;

    // Add the report and force exit at end
    RichEditDODReport.Visible := False;
    Repeat
      Begin
        RichEditDODReport.Lines.Add(Piece(RichEditDODTempReport.Lines[x], '^', 2));
        inc(x);
        If x < RichEditDODTempReport.Lines.Count - 1 Then
          If Pos('7^', RichEditDODTempReport.Lines[x]) <> 1 Then
            x := RichEditDODTempReport.Lines.Count + 1;
    End Until x > RichEditDODTempReport.Lines.Count - 1;
    // Force to top
    RichEditDoDReport.Lines.Insert(0, '');
    RichEditDoDReport.Lines.Delete(0);
    RichEditDODReport.Visible := True;

  End;

  If ReportType = 'ALRG' Then
  Begin
    x := 0;
    y := 0;
    If RichEditDODTempReport.Lines.Count = 0 Then
      exit;

    // Search for the right report chunk in the returned data
    If VAWrapGridDOD.Row > y Then
      Repeat
        Begin
          inc(x);
          If Pos('1^', RichEditDODTempReport.Lines[x]) = 1 Then
            inc(y);
      End Until y = VAWrapGridDOD.Row;

    // Find report at 6th piece
    If Piece(RichEditDODTempReport.Lines[x], '^', 2) = 'No remote patient data found for these request parameters.' Then
      exit;
    RichEditDODReport.Lines.Add('Facility:  ' + Piece(Piece(RichEditDODTempReport.Lines[x], '^', 2), ';', 1));
    inc(x);
    RichEditDODReport.Lines.Add('Characteristic (Allergy Reactant):  ' + Piece(RichEditDODTempReport.Lines[x], '^', 2));
    inc(x);
    RichEditDODReport.Lines.Add('Type:  ' + Piece(RichEditDODTempReport.Lines[x], '^', 2));
    inc(x);
    RichEditDODReport.Lines.Add('Comments:  ');
    RichEditDODReport.Visible := False;
    Repeat
      Begin
        inc(x);
    End Until Pos('6^', RichEditDODTempReport.Lines[x]) = 1;

    // Add the report and force exit at end
    RichEditDODReport.Visible := False;
    Repeat
      Begin
        RichEditDODReport.Lines.Add(Piece(RichEditDODTempReport.Lines[x], '^', 2));
        inc(x);
        If x < RichEditDODTempReport.Lines.Count - 1 Then
          If Pos('6^', RichEditDODTempReport.Lines[x]) <> 1 Then
            x := RichEditDODTempReport.Lines.Count + 1;
    End Until x > RichEditDODTempReport.Lines.Count - 1;
    // Force to top
    RichEditDoDReport.Lines.Insert(0, '');
    RichEditDoDReport.Lines.Delete(0);
    RichEditDODReport.Visible := True;

  End;

  If ReportType = 'LRC' Then
  Begin
    x := 0;
    y := 0;
    Try
      If Piece(RichEditDODTempReport.Lines[1], ';', 1) = 'No remote patient data found for these request parameters.' Then
      Begin
        VAWrapGridDOD.Cells[0, 0] := Piece(RichEditDODTempReport.Lines[1], ';', 1);
        exit;
      End;
    Except
    End;
    If VAWrapGridDOD.Row <> x Then
      Repeat
        Begin
          inc(y);
          If Pos('^', RichEditDODTempReport.Lines[y]) > 0 Then
            inc(x);
      End Until x = VAWrapGridDOD.Row;
    //General Info
    RichEditDODReport.Lines.Add('** Lab Test Details **');
    labdata := RichEditDODTempReport.Lines[y];
    RichEditDODReport.Lines.Add('Date:     ' + Piece(labdata, '^', 1));
    RichEditDODReport.Lines.Add('Test:     ' + Piece(labdata, '^', 3));
    RichEditDODReport.Lines.Add('Specimen: ' + Piece(labdata, '^', 2));
    RichEditDODReport.Lines.Add('Result:   ' + Piece(labdata, '^', 4) + ' ' + Piece(labdata, '^', 6));
    RichEditDODReport.Lines.Add('Flag:     ' + Piece(labdata, '^', 5));
    RichEditDODReport.Lines.Add('Ref Low:  ' + Piece(labdata, '^', 7));
    RichEditDODReport.Lines.Add('Ref High: ' + Piece(labdata, '^', 8));
    inc(y);
    //Location
    RichEditDODReport.Lines.Add('Site:     ' + Piece(RichEditDODTempReport.Lines[y], ';', 1));
    inc(y);
    // Get comments, if any
    If (Pos('^', RichEditDODTempReport.Lines[y]) = 0) Then
    Begin
      RichEditDODReport.Lines.Add('Comments:');
      Repeat
        Begin
          RichEditDODReport.Lines.Add(RichEditDODTempReport.Lines[y]);
          inc(y);
      End Until (y > RichEditDODTempReport.Lines.Count - 1) Or (Pos('^', RichEditDODTempReport.Lines[y]) > 0);
    End;
  End;
  If ReportType = 'DS' Then
  Begin
    RichEditDoDReport.Lines.Clear;
    x := -1;
    y := -1;
    Repeat
      Begin
        inc(x);
        If piece(RichEditDODTempReport.Lines[x], '^', 1) = '1' Then
          inc(y);
        If y = VAWrapGridDod.Row Then
          y := -2;
    End Until y = -2;
    //Report
    Repeat
      Begin
        inc(x);
        If x > RichEditDODTempReport.Lines.Count Then
          exit;
    End Until Piece(RichEditDODTempReport.Lines[x], '^', 1) = '9';
    dec(x);
    Repeat
      inc(x);
      RichEditDoDReport.Lines.Add(Piece(RichEditDODTempReport.Lines[x], '^', 2));
    Until (x >= RichEditDodTempReport.Lines.Count) Or (Piece(RichEditDodTempReport.Lines[x], '^', 1) <> '9');
  End;
  If ReportType = 'MI' Then
  Begin
    x := 0;
    y := 0;
    If VAWrapGridDOD.Row <> x Then
      Repeat
        Begin
          inc(y);
          If Pos('^', RichEditDODTempReport.Lines[y]) > 0 Then
          Begin
            inc(x);
            Repeat
              inc(y);
            Until Pos('^', RichEditDODTempReport.Lines[y]) > 0;
            inc(y);                                                             //Results line
            inc(y);                                                             //Site Line
          End;
      End Until (x = VAWrapGridDOD.Row) Or (y > VAWrapGridDOD.Row);
    //Report
    inc(y);                                                                     // Skip first line that's used to populate the grid
    Repeat
      Begin
        inc(y);
        If Pos('^', RichEditDODTempReport.Lines[y]) = 0 Then
          RichEditDODReport.Lines.Add(RichEditDODTempReport.Lines[y]);
    End Until (Pos('^', RichEditDODTempReport.Lines[y]) > 0) Or (y > RichEditDODReport.Lines.Count);
    inc(y);
    inc(y);                                                                     // Results Line
    If Piece(RichEditDODTempReport.Lines[y], ';', 1) <> '' Then
      RichEditDODReport.Lines.Add('Site: ' + Piece(RichEditDODTempReport.Lines[y], ';', 1)); // Site Line
  End;
  If ReportType = 'RR' Then
  Begin                                                                         // Radiology
    x := 0;
    y := 0;
    z := 0;                                                                     // Used as backup counter to force exit
    If VAWrapGridDOD.Row <> x Then
      Repeat
        Begin
          If Pos('^', RichEditDODTempReport.Lines[y]) > 0 Then
          Begin
            inc(x);
            Repeat
              inc(y);
            Until (Pos('^', RichEditDODTempReport.Lines[y]) > 0) Or (y > RichEditDODTempReport.Lines.Count - 1);
          End;
          inc(z);
      End Until (x = VAWrapGridDOD.Row) Or (x > VAWrapGridDOD.Row) Or ((z > 10000) And ((x = 0) And (y = 0)));
    RichEditDoDReport.visible := False;
    //Report
    Repeat
      Begin
        inc(y);
        If Pos('^', RichEditDODTempReport.Lines[y]) = 0 Then
          RichEditDODReport.Lines.Add(RichEditDODTempReport.Lines[y]);
    End Until (y > RichEditDODTempReport.Lines.Count - 1) Or (Pos('^', RichEditDODTempReport.Lines[y]) > 0);
    If x = VAWrapGridDOD.RowCount - 1 Then
    Begin
      If Piece(RichEditDODReport.Lines[RichEditDODReport.Lines.Count - 2], ';', 1) <> '' Then
        RichEditDODReport.Lines[RichEditDODReport.Lines.Count - 2] := ('Site: ' + Piece(RichEditDODReport.Lines[RichEditDODReport.Lines.Count - 2], ';', 1)) // Site Line
    End
    Else
    Begin
      If Piece(RichEditDODReport.Lines[RichEditDODReport.Lines.Count - 1], ';', 1) <> '' Then
        RichEditDODReport.Lines[RichEditDODReport.Lines.Count - 1] := ('Site: ' + Piece(RichEditDODReport.Lines[RichEditDODReport.Lines.Count - 1], ';', 1)); // Site Line
    End;
    RichEditDoDReport.Lines.Insert(0, '');
    RichEditDoDReport.Lines.Delete(0);
    RichEditDoDReport.visible := True;
  End;
  If (ReportType = 'CY') Or (ReportType = 'SP') Then
  Begin                                                                         // Surgical Pathology/Cytology    x:=0;
    y := -1;
    x := 0;
    If VAWrapGridDod.Cells[0, 0] = 'No remote patient data found for these request parameters.' Then
      exit;
    If VAWrapGridDOD.Row <> x Then
      Repeat
        Begin
          inc(y);
          If Pos('^', RichEditDODTempReport.Lines[y]) > 0 Then
          Begin                                                                 // Skip 2 lines
            inc(x);
            inc(y);
          End;
          Repeat
            inc(y);
          Until (Pos('^', RichEditDODTempReport.Lines[y]) > 0) Or (y > RichEditDODTempReport.Lines.Count - 1)
      End Until x = VAWrapGridDOD.Row;
    inc(y);                                                                     //  Jan 10, 2001^010111 CG 192
    inc(y);                                                                     //  Site/Specimen^3010123.091025
    inc(y);                                                                     //  999&UNKNOWN&99LRP/
    If x = 0 Then
      inc(y);                                                                   // Need to do this for 1st entry to get the pointer to the right spot;
    // Add report
    Repeat
      Begin
        RichEditDODReport.Lines.Add(RichEditDODTempReport.Lines[y]);
        inc(y);
      End;
    Until (y > RichEditDODTempReport.Lines.Count - 1) Or (Pos('^', RichEditDODTempReport.Lines[y]) > 0);
    RichEditDODReport.Lines[RichEditDODReport.Lines.Count - 1] := 'Site: ' + Piece(RichEditDODReport.Lines[RichEditDODReport.Lines.Count - 1], ';', 1);
  End;
End;

Procedure TfrmMain.HeaderControlDODLRCYSectionResize(
  HeaderControl: THeaderControl; Section: THeaderSection);
Begin
  VAWrapGridDOD.ColCount := 4;
  VAWrapGridDOD.ColWidths[0] := HeaderControlDODLRCY.Sections[0].Width - 2;
  VAWrapGridDOD.ColWidths[1] := HeaderControlDODLRCY.Sections[1].Width - 2;
  VAWrapGridDOD.ColWidths[2] := HeaderControlDODLRCY.Sections[2].Width - 1;
  VAWrapGridDOD.ColWidths[3] := HeaderControlDODLRCY.Sections[3].Width - 1;
End;

Procedure TfrmMain.HeaderControlDODMISectionResize(
  HeaderControl: THeaderControl; Section: THeaderSection);
Begin
  VAWrapGridDOD.ColCount := 4;
  VAWrapGridDOD.ColWidths[0] := HeaderControlDODMI.Sections[0].Width - 2;
  VAWrapGridDOD.ColWidths[1] := HeaderControlDODMI.Sections[1].Width - 2;
  VAWrapGridDOD.ColWidths[2] := HeaderControlDODMI.Sections[2].Width - 1;
  VAWrapGridDOD.ColWidths[3] := HeaderControlDODMI.Sections[3].Width - 1;
End;

Procedure TfrmMain.HeaderControlDODRRSectionResize(
  HeaderControl: THeaderControl; Section: THeaderSection);
Begin
  VAWrapGridDOD.ColCount := 3;
  VAWrapGridDOD.ColWidths[0] := HeaderControlDODRR.Sections[0].Width - 2;
  VAWrapGridDOD.ColWidths[1] := HeaderControlDODRR.Sections[1].Width - 2;
  VAWrapGridDOD.ColWidths[2] := HeaderControlDODRR.Sections[2].Width - 1;
End;

Procedure TfrmMain.Button1Click(Sender: TObject);
Var
  x, y: integer;
  foundflag: boolean;
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;
  frmGraphFHIE := TfrmGraphFHIE.Create(frmMain);
  frmGraphFHIE.ChartFHIEData.Series[0].Clear;
  frmGraphFHIE.ChartFHIEData.Series[1].Clear;
  frmGraphFHIE.ChartFHIEData.Series[2].Clear;
  frmGraphFHIE.ChartFHIEData.Title.Text.Clear;
  frmGraphFHIE.ChartFHIEData.Title.Text.Add('Select a Test to Graph');
  frmGraphFHIE.ListBoxTests.Items.Clear;
  // Add tests, only once though
  If VAWrapGridDOD.RowCount > 0 Then
    For y := 0 To VAWrapGridDOD.RowCount - 1 Do
    Begin
      foundflag := false;
      If frmGraphFHIE.ListBoxTests.Items.Count > 0 Then
      Begin
        Try
          For x := 0 To frmGraphFHIE.ListBoxTests.Items.Count - 1 Do
            If frmGraphFHIE.ListBoxTests.Items[x] = VAWrapGridDOD.Cells[1, y] Then
              foundflag := true;
          If FoundFlag = False Then
            frmGraphFHIE.ListBoxTests.Items.Add(VAWrapGridDOD.Cells[1, y]);
        Except
        End;
      End
      Else
      Try
        frmGraphFHIE.ListBoxTests.Items.Add(VAWrapGridDOD.Cells[1, y]);
      Except
      End;
    End;

  frmGraphFHIE.ShowModal;
  frmGraphFHIE.release;
  frmGraphFHIE := Nil;
End;

Procedure TfrmMain.ButtonCPTCopyrightClick(Sender: TObject);
Begin
  buttonCPTCopyright.Visible := False;
  MemoCPTCopyright.Visible := False;
End;

Procedure TfrmMain.TimerFHIERunningTimer(Sender: TObject);
Begin
  // Updates progress meter so that it is at 100% after 3 minutes
  ProgressBarLoadPt.Position := ProgressBarLoadPt.Position + 1;
  If ProgressBarLoadPt.Position >= 100 Then
  Begin
    TimerFHIERunning.Enabled := False;
    RPCBrokerDOD.Connected := False;
    ProgressBarLoadPt.Visible := False;
    ANURemoteProcedureCallInProgress := False;
    ShowMessageCAPRI('DoD report is taking a long time to run.  It will continue to run in the background, but you must re-run this report later to retrieve all of the results.');
    ANURemoteProcedureCallInProgress := False;
    ORListBoxDoDReportTypes.Enabled := True;
    StatusBarLoadPt.Caption := 'FHIE report did not finish.';
    frmMain.AnimateLogo(False);
  End;
End;

Procedure TfrmMain.TimerHaltTimer(Sender: TObject);
Var
  x: integer;
Begin
  messagebeep(0);
  timerhalt.enabled := false;
  For x := 1 To 500 Do
    application.processmessages;
  frmMain.show;
  frmMain.activate;
  application.terminate;
End;

Procedure TfrmMain.HeaderControlDODDCSSectionResize(
  HeaderControl: THeaderControl; Section: THeaderSection);
Begin
  //
  VAWrapGridDOD.ColCount := 6;
  VAWrapGridDOD.ColWidths[0] := HeaderControlDODDCS.Sections[0].Width - 2;
  VAWrapGridDOD.ColWidths[1] := HeaderControlDODDCS.Sections[1].Width - 2;
  VAWrapGridDOD.ColWidths[2] := HeaderControlDODDCS.Sections[2].Width - 1;
  VAWrapGridDOD.ColWidths[3] := HeaderControlDODDCS.Sections[3].Width - 1;
  VAWrapGridDOD.ColWidths[4] := HeaderControlDODDCS.Sections[4].Width - 1;
  VAWrapGridDOD.ColWidths[5] := HeaderControlDODDCS.Sections[5].Width - 1;
End;

Procedure TfrmMain.ButtonIPRDisplayClick(Sender: TObject);
Var
  SenderName: String;
Begin
  Inherited;
  SenderName := 'frmmain.buttoniprdisplay';
  PNCSShowModal(
    FMCommentsMemo,                                                             //FMCommentsMemo      : TFMMemo;   //FMCommentsMemo: TFMMemo;
    FMEditIPR10,                                                                //FMEditIPR10         : TFMEdit;   //FMEditIPR10: TFMEdit;
    FMEditIPR11,                                                                //FMEditIPR11         : TFMEdit;   //FMEditIPR11: TFMEdit;
    FMEditIPR2,                                                                 //FMEditIPR2          : TFMEdit;   //FMEditIPR2: TFMEdit;
    FMEditIPR6,                                                                 //FMEditIPR6          : TFMEdit;   //FMEditIPR6: TFMEdit;
    FMEditIPR7,                                                                 //FMEditIPR7          : TFMEdit;   //FMEditIPR7: TFMEdit;
    FMEditIPR8,                                                                 //FMEditIPR8          : TFMEdit;   //FMEditIPR8: TFMEdit;
    FMEditReviewStatus,                                                         //FMEditReviewStatus  : TFMEdit;   //FMEditReviewStatus: TFMEdit;
    FMGetsIPRFile,                                                              //FMGetsIPRFile       : TFMGets;   //FMGetsIPRFile: TFMGets;
    FMGetsIPRFile3,                                                             //FMGetsIPRFile3      : TFMGets;   //FMGetsIPRFile3: TFMGets;
    FMGetsTemplateInfo,                                                         //FMGetsTemplateInfo  : TFMGets;   //FMGetsTemplateInfo: TFMGets;
    FMListboxIPR1,                                                              //FMListBox           : TFMListBox;//FMListboxIPR1 : TFMListBox;
    ListBoxIPR1,                                                                //ListBoxIPR1         : TListBox;  //ListBoxIPR1: TListBox;
    MiniZip1,                                                                   //MiniZip1            : TMiniZip;  //MiniZip1: TMiniZip;
    FMMemoFormDefinition,                                                       //mmoFormDefinition   : TRichEdit; //FMMemoFormDefinition: TRichEdit;
    RichEditReport,                                                             //mmoReport           : TRichEdit; //RichEditReport: TRichEdit;
    FMMemoReportDefinition,                                                     //mmoReportDefinition : TRichEdit; //FMMemoReportDefinition: TRichEdit;
    FMMemoScriptDefinition,                                                     //mmoScriptDefinition : TRichEdit; //FMMemoScriptDefinition: TRichEdit;
    Sender,                                                                     //Sender              : TObject;
    SenderName,                                                                 //SenderName          : String;
    StatusBarLoadPt,                                                            //StatusMsg           : TLabel;    //StatusBarLoadPt: TLabel;
    xFMEditObjectCount,                                                         //xFMEditObjectCount  : TFMEdit;   //xFMEditObjectCount: TFMEdit;
    xFMTemplatesUtilized                                                        //xFMTemplatesUtilized: TFMMemo    //xFMTemplatesUtilized: TFMMemo;
    );
End;

Procedure TfrmMain.ButtonIPRDeleteClick(Sender: TObject);
Var
  TempFMListbox: TFMListbox;
  //tempAuthorIEN: String;
  tempTranscriberIEN: String;
  x: integer;
  s: String;
Begin
  Inherited;
  If PNCSForm <> Nil Then
  Begin
    ShowmessageCAPRI('You have an exam template open.  Delete cannot be performed until the template is closed.');
    actToolsBringExamToFront.Execute;
    exit;
  End;

  If ANURemoteProcedureCallInProgress = True Then
    exit;

  If buttonIPRDelete.enabled = false Then
    exit;

  FMListboxIPR1.ItemIndex := FMListBoxIPR1.Items.Count - 1 - ListBoxIPR1.ItemIndex;
  TempFMListbox := FMListboxIPR1 As TFMListBox;

  FMGetsIPRFile.IENS := TempFMListBox.GetSelectedRecord.IEN;
  FMGetsIPRFile.GetAndFill;
  FMGetsIPRFile3.IENS := FMGetsIPRFile.IENS;
  FMGetsIPRFile3.GetAndFill;
  If (FMEditIPR8.Text <> '') And (FMEditIPR8.Text <> 'JAN 01, 1980') And (FMEditIPR8.Text <> 'JAN 1, 1980') And
    (FMEditIPR8.Text <> 'JAN 1,1980') Then
    Locked := True
  Else
    Locked := False;                                                            {If there is a saved date, lock the record}
  If Locked = True Then
  Begin
    ShowMessageCAPRI('You can''t delete a signed form!');
    exit;
  End;
  tempAuthorIEN := FMGetsIPRFile3.GetField('2').FMDBInternal;
  tempTranscriberIEN := FMGetsIPRFile3.GetField('10').FMDBInternal;

  // QC #2016 - jcs - Prevent unauthorized user from deleting an 'unlocked' exam
  // Commented out original code to make this check the same as the one on the unsigned
  //form
  if not frmMain.IsAllowed2OpenExam(FMGetsIPRFile.IENS) then
  begin
    ShowMessageCAPRI('You must be author, transcriber, or hold advanced security privileges to delete this incomplete template.');
    Exit;
  end;

  //If AuthorIEN <> tempAuthorIEN Then
  //  If AuthorIEN <> tempTranscriberIEN Then
  //    If Pos('@', userfilemancode) = 0 Then
  //    Begin
  //      ShowMessageCAPRI('You must be author, transcriber, or hold advanced security privileges to delete this incomplete template.');
  //      exit;
  //    End;

  //If Locked=False then if Application.MessageBox('CAUTION!!!  Are you really sure you want to delete this unsigned form?','Cancel?',4)=IDYes then

  frmDeleteTemplate := TfrmDeleteTemplate.Create(self);
  frmDeleteTemplate.memoTemplateInfo.Lines.Clear;
  frmDeletetemplate.memoTemplateInfo.Lines.Add('  Name: ' + Uppercase(Copy(frmMain.Panel1.caption, 1, Pos('  SSN#', frmMain.Panel1.Caption))) + '   SSN: ' + PatientSSN + '   C-Number: ' +
    frmMain.CNumber.Caption);
  frmDeletetemplate.memoTemplateInfo.Lines.Add('');
  frmDeleteTemplate.memoTemplateInfo.Lines.Add(ListBoxIPR1.Items[ListBoxIPR1.ItemIndex]);
  x := 1;
  If ListBoxIPR1.ItemIndex < ListBoxIPR1.Items.Count - 1 Then
    If Copy(ListBoxIPR1.Items[ListBoxIPR1.ItemIndex + 1], 1, 1) = '!' Then
      Repeat
        s := ListBoxIPR1.Items[ListBoxIPR1.ItemIndex + x];
        s := copy(s, 2, length(s) - 1);
        frmDeleteTemplate.memoTemplateInfo.Lines.Add(s);
        inc(x);
        If x + ListBoxIPR1.ItemIndex > ListBoxIPR1.Items.Count - 1 Then
          x := 0;                                                               // Need to do this to prevent range check error after last item
      Until (x = 0) Or (Copy(ListBoxIPR1.Items[ListBoxIPR1.ItemIndex + x], 1, 1) <> '!');

  If Locked = False Then
    If frmDeleteTemplate.ShowModal = mrOK Then
    Begin
      DeleteRecord(frmMain.RPCBroker1, '396.17', FMGetsIPRFile3.IENS);
      ButtonIPRRefreshClick(Application);                                       {Refresh}
    End;
  frmDeleteTemplate.release;
  ButtonIPRDelete.Enabled := False;
  ButtonIPRCopy.Enabled := False;
End;

Procedure TfrmMain.DimMenuOptions;
Begin
//  UnsignedCPWorksheets1.Enabled := False;
//  UnCosignedTIUDocuments1.enabled := false;
//  SelectPatient1.Enabled := False;
//  BitBtnVistA.enabled := False;
//  Reports1.Enabled := False;
//  ChangeForwardingAddress1.Enabled := False;
//  SearchforaPatientGlobal1.Enabled := False;
//  EditelectronicSignatureCode1.Enabled := False;
//  EditExamListParametersMAS1.Enabled := False;
//  EditCPExamReports1.enabled := false;
//  UncosignedCPWorksheetUtility1.Enabled := False;
//  CheckRemoteConnections1.Enabled := False;
//  RPCBrokerCallHistoryBuffer1.enabled := false;
//  EditRemoteUserSiteAccess1.Enabled := False;
//  EditPatientLists1.Enabled := False;
//  AuditTrail1.Enabled := False;
//  ConsolidatedReports1.Enabled := False;
//  Properties1.Enabled := False;
//  Vista1.Enabled := False;
//  Print1.Enabled := False;
//  PrinterSetup1.Enabled := False;
//  SwitchSites1.Enabled := False;
//  About1.Enabled := False;
//  CheckRemoteConnections1.Enabled := False;
//  EditRemoteUserSiteAccess1.Enabled := False;
//  AuditTrail1.Enabled := False;
//  ConsolidatedReports1.Enabled := False;
End;

Procedure TfrmMain.RestoreMenuOptions;
Begin
//  UnsignedCPWorksheets1.Enabled := True;
//  UnCosignedTIUDocuments1.enabled := True;
//  SelectPatient1.Enabled := True;
//  if ESSOVersion then
//    BitBtnVistA.enabled := True;   //only remote connections - rpm 3/17/09
//  Reports1.Enabled := True;
//  ChangeForwardingAddress1.Enabled := True;
//  SearchforaPatientGlobal1.Enabled := True;
//  EditelectronicSignatureCode1.Enabled := True;
//  EditExamListParametersMAS1.Enabled := True;
//  EditCPExamReports1.enabled := true;
//  UncosignedCPWorksheetUtility1.Enabled := True;
//  CheckRemoteConnections1.Enabled := True;
//  RPCBrokerCallHistoryBuffer1.enabled := true;
//  EditRemoteUserSiteAccess1.Enabled := True;
//  EditPatientLists1.Enabled := True;
//  AuditTrail1.Enabled := True;
//  ConsolidatedReports1.Enabled := True;
//  Properties1.Enabled := True;
//  Vista1.Enabled := True;
//  Print1.Enabled := True;
//  PrinterSetup1.Enabled := True;
//  If EssoVersion = True Then
//    SwitchSites1.Enabled := True;
//  About1.Enabled := true;
//  CheckRemoteConnections1.Enabled := true;
//  EditRemoteUserSiteAccess1.Enabled := true;
//  AuditTrail1.Enabled := true;
//  ConsolidatedReports1.Enabled := true;
End;

Procedure TfrmMain.ButtonIPRRefreshClick(Sender: TObject);
Var
  x: longint;
  xx: integer;
  ListPoint: LongInt;
Begin
  Inherited;
  If ANURemoteProcedureCallInProgress = True Then
    exit;
  DimMenuOptions;

  Page95Control1.ActivePage := TabCPWorksheets;


  if VaUtils.ScreenReaderActive then                                            // -MER CodeCR117 10/2010
    LabelGridHeader.Caption := 'Template Name, column 1 of 4.  Date Signed, column 2 of 4. Author, column 3 of 4.  Status, column 4 of 4'
  else
    LabelGridHeader.Caption := Format('%-33s %-4s%-19s  %-19s  %-6s', ['Template Name', '', 'Date Signed', 'Author', 'Status']);

  ListBoxIPR1.Items.Clear;
  ButtonIPRCopy.Enabled := False;
  ButtonIPRDelete.Enabled := False;
  ButtonIPRCopy.Enabled := False;
  ButtonIPRDisplay.Enabled := False;

  {CodeCR174 - rpm 4/12/11 - streamlined the following section by retrieving
                             the entire list at once and screening on the
                             patient's IEN.  This eliminated the need for
                             FMListerIPR2 and FMListBoxIPR2. }
  FMListerIPR1.ListerFlags := [];                                               //return external values
  FMListerIPR1.Number := '*';                                                   //don't restrict number of records returned
  FMListerIPR1.PartList.Clear;                                                  //PartList improves selection efficiency
  FMListerIPR1.PartList.Add(PatientName);
  FMListerIPR1.Screen := 'I $P(^(0),U,1)=' + PatientIEN;                        //return only this patient's records
  ListPoint := ListBoxIPR1.ItemIndex;

  FMListBoxIPR1.GetList;

  If ANURemoteProcedureCallInProgress = True Then
    exit;

  // Now get rid of name at beginning of list since we already know
  // the patient we're accessing
  For x := FMListBoxIPR1.Items.Count - 1 Downto 0 Do
    FMListBoxIPR1.Items[x] := Copy(FMListBoxIPR1.Items[x], Pos('  ', FMListBoxIPR1.Items[x]) + 4, 255);

  //figure out merged forms and expand
  If FMListBoxIPR1.Items.Count > 0 Then
  Begin
    For x := FMListBoxIPR1.Items.Count - 1 Downto 0 Do
    Begin
      If (Copy(FMListBoxIPR1.Items[x], 1, Length('*MERGED FORM  ')) = '*MERGED FORM  ') Or
        (Copy(FMListBoxIPR1.Items[x], 1, Length('MERGED FORM  ')) = 'MERGED FORM  ') Then
      Begin
        // Replace the text but keep the rest of the line
        If Copy(FMListBoxIPR1.Items[x], 1, 1) = '*' Then
          FMListBoxIPR1.Items[x] := '*MERGED FORMS - LISTED BELOW:  ' + Copy(FMListBoxIPR1.Items[x], pos('  ', FMListBoxIPR1.Items[x]) + 2, length(FMListBoxIPR1.Items[x]))
        Else
          FMListBoxIPR1.Items[x] := 'MERGED FORMS - LISTED BELOW:  ' + Copy(FMListBoxIPR1.Items[x], pos('  ', FMListBoxIPR1.Items[x]) + 2, length(FMListBoxIPR1.Items[x]));
        // Insert individual merge form names here
        FMListBoxIPR1.ItemIndex := x;
        FMGetsIPRFile3.IENS := FMListBoxIPR1.GetSelectedRecord.IEN;
        FMGetsIPRFile3.GetAndFill;
        For xx := 0 To xFMTemplatesUtilized.Lines.Count - 1 Do
        Begin
          Try
            FMListBoxIPR1.Items.Insert(x, '!' + Piece(xFMTemplatesUtilized.Lines[xx], '^', 2));
          Except;
            FMListBoxIPR1.Items.Add('!' + Piece(xFMTemplatesUtilized.Lines[xx], '^', 2));
          End;
        End;
      End;
      //ShowmessageCAPRI('*'+FMListBoxIPR1.Items[x]);
    End;
  End;

  FormatIPRList1;
  ListBoxIPR1.Items.Clear;
  For x := FMListBoxIPR1.Items.Count - 1 Downto 0 Do
  Begin
    ListBoxIPR1.Items.Add(FMListBoxIPR1.Items[x]);
  End;

  ListBoxIPR1.ItemIndex := ListPoint;
  ListBoxIPR1Click(Application);
  ListBoxIPR1.Repaint;
  RestoreMenuOptions;
End;

Procedure TfrmMain.BitBtnNewFormClick(Sender: TObject);
Var
  x, y: Integer;
  nowdt: String;
  sdate, edate, showuser: String;
  includeflag: boolean;
  prefix: String;
  objectcount: integer;
Begin

  If Not IsRPCBrokerConnected() Then Exit;

  StatusBarLoadPt.Caption := '';
  StatusBarLoadPt.Update;

  If ANURemoteProcedureCallInProgress Then
    exit;
  If Sender <> PNCSForm Then
    If IsPNCSOpen() Then Exit;
  If ANURemoteProcedureCallInProgress = True Then
    exit;
  RPCBroker1.RemoteProcedure := 'ORWU DT';
  RPCBroker1.Param[1].Value := 'NOW';
  RPCBroker1.Param[1].PType := literal;
  frmMain.RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'RPC ORWU DT could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('ORWU DT could not be accessed!');
    End;
  End;
  nowdt := Piece(RPCBroker1.Results[0], '.', 1);

  If Sender <> PNCSForm Then
    PNCSForm := tPNCSForm.Create(application);

  WaitForm.Visible := True;
  WaitForm.BringToFront;
  WaitForm.Label1.Caption := 'Loading template list...';
  WaitForm.Label1.Repaint;
  WaitForm.Repaint;

  If Sender <> PNCSForm Then
    FormReviewerUtility := TFormReviewerUtility.Create(PNCSForm);

  frmBrowseTemplates := TfrmBrowseTemplates.Create(frmMain);
  //frmBrowseTemplates.FMListboxTemplates.GetList;

  RPCBroker1.RemoteProcedure := 'DVBAB TEMPLATE LIST';
  frmMain.RPCBrokerCall;
  Try
    RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      AnimateLogo(False);
      StatusBarLoadPt.Caption := 'RPC DVBAB TEMPLATE LIST could not be accessed!';
      StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('DVBAB TEMPLATE LIST could not be accessed!');
    End;
  End;
  frmBrowseTemplates.FMListboxTemplates.Items.Clear;
  QuickCopy(RPCBroker1.Results, frmBrowseTemplates.FMListboxTemplates.Items);
  QuickCopy(RPCBroker1.Results, frmBrowseTemplates.FMListboxAllTemplates.Items);

  tempAuthorIEN := AuthorIEN;
  (*
    frmBrowseTemplates.ListboxTemplates.Items.Clear;
    If frmBrowseTemplates.FMListboxTemplates.Items.Count>0 then
      for x:=0 to frmBrowseTemplates.FMListboxTemplates.Items.Count-1 do
        frmBrowseTemplates.ListboxTemplates.Items.Add(frmBrowseTemplates.FMListboxTemplates.Items[x]);
  *)
  If frmBrowseTemplates.FMListboxTemplates.Items.Count > 0 Then
    For x := frmBrowseTemplates.FMListboxTemplates.Items.Count - 1 Downto 0 Do
    Begin
      frmBrowseTemplates.FMListboxTemplates.ItemIndex := x;
      includeflag := false;
      sdate := Piece(frmBrowseTemplates.FMListboxTemplates.Items[x], '^', 2);
      edate := Piece(frmBrowseTemplates.FMListboxTemplates.Items[x], '^', 3);
      showuser := Piece(frmBrowseTemplates.FMListboxTemplates.Items[x], '^', 4);
      objectcount := StrToIntDef(Piece(frmBrowseTemplates.FMListboxTemplates.Items[x], '^', 5), 0);

      //ShowMessageCAPRI(sdate+'*'+edate+'*'+showuser);
      prefix := '';
      If (ShowUser = '1') Or (Showuser = '') Then
      Begin
        If sdate = '' Then
          includeflag := false;
        If sdate <> '' Then
          If (sdate <= nowdt) And (edate = '') Then
            IncludeFlag := true
          Else
            If edate <> '' Then
              If (sdate <= nowdt) And (Edate > nowdt) Then
                includeflag := true;
        If (Pos('@', userfilemancode) > 0) And (includeflag <> true) Then
        Begin
          prefix := 'ZZ_INACTIVE: ';
          includeflag := true;
        End;
      End;
      If IncludeFlag = true Then
      Begin
        //frmBrowseTemplates.FMGetsTemplateInfo.IENS:=frmBrowseTemplates.FMListboxTemplates.GetSelectedRecord.IEN;
        //frmBrowseTemplates.FMGetsTemplateInfo.GetData;
        frmBrowseTemplates.ListboxTemplates.Items.Add(prefix + Piece(Piece(frmBrowseTemplates.FMListboxTemplates.Items[x], '^', 1), '~', 1) + '^' +
          Piece(frmBrowseTemplates.FMListboxTemplates.Items[x], '^', 6) + '^' + inttostr(objectcount));
      End;
    End;

  WaitForm.Visible := False;
  If Sender <> PNCSForm Then
    If frmBrowseTemplates.ShowModal = mrCancel Then
    Begin
      frmBrowseTemplates.Release;
      frmBrowseTemplates := Nil;
      //      try
      //        tempFormObjectList.Clear;
      //      except
      //      end;
      //      try
      //        tempMergeScripts.Clear;
      //      except
      //      end;

      PNCSform.Release;
      If FormReviewerUtility <> Nil Then
        FormReviewerUtility.release;
      FormReviewerUtility := Nil;
      PNCSForm := Nil;
      exit;
    End;

  If Sender = PNCSForm Then
    exit;

  x := 0;
  If frmBrowseTemplates.FMListBoxTemplates.ItemIndex <> -1 Then
  Begin
    PNCSForm.xEditMode.Text := 'NEW';
    PNCSForm.xEditFormNum.text := inttostr(whichmergeform);
    For y := 0 To frmBrowseTemplates.RichEditTemplatesUtilized.Lines.Count - 1 Do
      PNCSForm.xFMTemplatesUtilized.Lines.Add(frmBrowseTemplates.RichEditTemplatesUtilized.Lines[y]);
    PNCSForm.xDateTimeOfNote.Text := 'NEW FORM';
    PNCSForm.xPatientIENS.Caption := PatientIEN;
    PNCSForm.xFMPatientName.Caption := PatientName;
    PNCSForm.xFMSSN.Caption := PatientSSN;
    PNCSForm.xAuthorButton.Caption := AuthorName;

    screen.cursor := crHourglass;

    If FoundMergeFlag > 1 Then
      pncsform.caption := 'MERGED FORM'
    Else
      pncsform.caption := frmBrowseTemplates.SelectedTemplates[0];

    PNCSForm.ShowExam;
    QuickCopy(PNCSForm.localExam.Code.Script, PNCSForm.xMemoCode);
    PNCSForm.SetupForm(Sender);
    If frmBrowseTemplates.richEditPScript.Lines.Count > 0 Then
    Begin
      Quickcopy(frmBrowseTemplates.richEditPScript, PNCSForm.xMemoCode);
      PNCSForm.zzzzEditScriptStyle.text := 'PASCAL SCRIPT';
    End;
    PNCSForm.xTimerGo.Enabled := True;
    screen.cursor := crdefault;
  End;
  If x > 20 Then
  Begin
    ShowMessageCAPRI('You can have a maximum of 20 templates open at a time.');
    exit;
  End;
End;

Procedure TfrmMain.BitBtnUnsignedFormsClick(Sender: TObject);
Begin
  If Not IsRPCBrokerConnected() Then Exit;

  StatusBarLoadPt.Caption := '';
  StatusBarLoadPt.Update;

  If PNCSForm <> Nil Then
  Begin
    ShowMessageCAPRI('You have an open template.  Please close it before trying to perform this function.');
    exit;
  End;
  If Not Assigned(UnsignedView) Then
    UnsignedView := TUnsignedView.Create(frmMain);
  UnsignedView.Button5Click(Application);
  UnsignedView.ShowModal;
  UnsignedView.Release;
  UnsignedView := Nil;
  // Only refresh if a patient has been selected.
  If Panel1.Caption <> '' Then
    ButtonIPRRefreshClick(Application);
End;

Procedure TfrmMain.FMListBoxIPR1DrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
Var
  TempText: String;
Begin
  Inherited;
  If ANULocalMods = False Then
    exit;

  If Panel1.Visible = False Then
    exit;
  With (Control As TListBox).Canvas Do                                          { draw on control canvas, not on the form }
  Begin
    Font.Color := clWindowText;                                                 {Set to default color}
    TempText := (Control As TListBox).Items[Index];
    If Copy((Control As TListBox).Items[Index], 1, 1) = '*' Then
    Begin
      Font.Color := clRed;                                                      {Change color to show unsigned}
      TempText := Copy((Control As TListBox).Items[Index], 2, Length((Control As TListBox).Items[Index]) - 1)
    End;
    If Copy((Control As TListBox).Items[Index], 1, 1) = '!' Then
    Begin
      Font.Color := clOlive;                                                    {Change color to show unsigned}
      TempText := Copy((Control As TListBox).Items[Index], 2, Length((Control As TListBox).Items[Index]) - 1)
    End;
    Brush.Color := clWindow;
    FillRect(Rect);                                                             { clear the rectangle }
    TextOut(Rect.Left, Rect.Top, TempText);                                     { display the text }
  End;
End;

Procedure TfrmMain.ListBoxIPR1Click(Sender: TObject);
Var
  x: integer;
Begin
  If ListBoxIPR1.ItemIndex < 0 Then
    exit;
  If ANURemoteProcedureCallInProgress = True Then
    exit;
  If ListBoxIPR1.ItemIndex > -1 Then
  Begin
    ButtonIPRCopy.Enabled := True;
    ButtonIPRDisplay.Enabled := True;
    ButtonIPRDelete.Enabled := True;
    ButtonIPRCopy.Enabled := True;
  End;
  // Deal with a sub-form component being clicked
  If Copy(ListBoxIPR1.Items[ListBoxIPR1.ItemIndex], 1, 1) = '!' Then
  Begin
    x := ListBoxIPR1.ItemIndex;
    Repeat
      dec(x);
    Until Copy(ListBoxIPR1.Items[x], 1, 1) <> '!';
    ListBoxIPR1.ItemIndex := x;
  End;
End;

Procedure TfrmMain.ListBoxIPR1DblClick(Sender: TObject);
Begin
  If ANURemoteProcedureCallInProgress = True Then
    exit;
  ListBoxIPR1Click(Application);
  FMListboxIPR1.ItemIndex := FMListBoxIPR1.Items.Count - 1 - ListBoxIPR1.ItemIndex;
  ButtonIPRDisplayClick(Application);
End;

Procedure TfrmMain.ListBoxIPR1DrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
Var
  TempText: String;
  x: integer;
  lastindex: integer;
  itemcount: integer;
  mergemode: boolean;
  RectHeight: integer;
  tempString: String;
  tempx: integer;
  BitmapFlagRect: tRect;

Begin
  Inherited;
  lastindex := -1;
  RectHeight := 0;
  With (Control As TListBox).Canvas Do                                          { draw on control canvas, not on the form }
  Begin
    Font.Color := clWindowText;                                                 {Set to default color}
    Font.Style := [];
    Brush.Color := clWindow;
    TempText := (Control As TListBox).Items[Index];
    TempString := TempText;
    MergeMode := False;
    If Copy(TempText, 1, 1) = '*' Then
    Begin
      Font.Color := clRed;                                                      {Change color to show unsigned}
      TempText := Copy((Control As TListBox).Items[Index], 2, Length((Control As TListBox).Items[Index]) - 1)
    End;
    If Copy(TempText, 1, 1) = '!' Then
    Begin
      Font.Color := clOlive;                                                    {Change color to show unsigned}
      //brush.Color:=$00CFFCFE;
      Font.Style := [fsItalic];
      TempText := '  ' + Piece(Temptext, '!', 2);                               // Get rid of the '!' at the beginning and indent;
    End;
    // Deal with flags

    If (TempString[1] <> '!') And (TempText[1] <> ' ') Then
      If Length(tempText) > 36 Then
      Begin
        If (TempText[35] = 'Y') Or ((TempText[35] = ' ') And (copy(Temptext, length(Temptext) - 8, 8) <> 'COMPLETE')) Then
          TempText[35] := #128
        Else
          TempText[35] := ' ';                                                  // Flag New
        If TempText[36] = 'Y' Then
          TempText[36] := #129
        Else
          TempText[36] := ' ';                                                  // Flag Green Flag
        If TempText[37] = 'Y' Then
          TempText[37] := #130
        Else
          TempText[37] := ' ';                                                  // Flag Exclamation
      End;
    //ShowmessageCAPRI('*'+Copy(TempString,28,Length('MERGED FORM  '))+'*');
    If Copy(TempString, 28, Length('MERGED FORM  ')) = 'MERGED FORM  ' Then
    Begin
      lastindex := index;
      Repeat
        inc(lastindex)
      Until (lastindex = (Control As TListBox).Items.Count - 1) Or (Copy((Control As TListBox).Items[lastindex], 1, 1) <> '!');
      // Check last item, in case this is the end of the list
      If Copy((Control As TListBox).Items[lastindex], 1, 1) <> '!' Then
        dec(lastindex);
      ItemCount := Lastindex - Index + 1;
      RectHeight := Rect.bottom - Rect.Top;
      Rect.Bottom := Rect.Top + (RectHeight * ItemCount);                       // Need this for the highlighting
      Rect.BottomRight.y := Rect.Top + (RectHeight * ItemCount);
      MergeMode := True;
    End;
    If state = [odSelected, odFocused] Then
      Brush.Color := clBtnFace;
    FillRect(rect);                                                             { clear the rectangle }
    TextOut(Rect.Left, Rect.Top, TempText);                                     { display the text }
    // Insert flag images if special codes are found
    If length(temptext) > 0 Then
      For x := 1 To length(temptext) Do
      Begin
        If temptext[x] = #128 Then
        Begin
          tempx := TextWidth('Z') * (x - 1);
          //TextOut(Rect.Left+tempx,Rect.Top,'>');
          BitmapFlagRect.Left := Rect.Left + tempx;
          BitmapFlagRect.Top := Rect.Top;
          BitmapFlagRect.Right := BitmapFlagRect.Left + TextWidth('Z');
          BitmapFlagRect.Bottom := BitmapFlagRect.Top + TextHeight('Z');
          StretchDraw(BitmapFlagRect, ImageFlagNew.Picture.Graphic);
          //TextOut(BitmapFlagRect.Left, BitmapFlagRect.Top, '#');
        End;
        If temptext[x] = #129 Then
        Begin
          tempx := TextWidth('Z') * (x - 1);
          //TextOut(Rect.Left+tempx,Rect.Top,'>');
          BitmapFlagRect.Left := Rect.Left + tempx;
          BitmapFlagRect.Top := Rect.Top;
          BitmapFlagRect.Right := BitmapFlagRect.Left + TextWidth('Z');
          BitmapFlagRect.Bottom := BitmapFlagRect.Top + TextHeight('Z');
          StretchDraw(BitmapFlagRect, ImageFlagFlag.Picture.Graphic);
        End;
        If temptext[x] = #130 Then
        Begin
          tempx := TextWidth('Z') * (x - 1);
          //TextOut(Rect.Left+tempx,Rect.Top,'>');
          BitmapFlagRect.Left := Rect.Left + tempx;
          BitmapFlagRect.Top := Rect.Top;
          BitmapFlagRect.Right := BitmapFlagRect.Left + TextWidth('Z');
          BitmapFlagRect.Bottom := BitmapFlagRect.Top + TextHeight('Z');
          StretchDraw(BitmapFlagRect, ImageFlagExclamation.Picture.Graphic);
        End;
      End;

    // Draw the individual items under the merge form
    If MergeMode = True Then
    Begin
      Pen.Color := clYellow;
      FrameRect(Rect);
      For x := index + 1 To lastindex Do
      Begin
        Font.Color := clOlive;                                                  {Change color to show unsigned}
        Font.Style := [fsItalic];
        temptext := '  ' + Piece((Control As TListBox).Items[x], '!', 2);
        Rect.Top := Rect.Top + RectHeight;
        TextOut(Rect.Left, Rect.Top, TempText);                                 { display the text }
      End;
    End;
  End;
End;

Procedure TfrmMain.FormatIPRList1;
Var
  x: Integer;
  Line: String;
  patientName, examName, examinerName, status, F1, F2, F3: String;
  examNameLen, examinerNameLen, statusLen, F1Len, F2Len: integer;
Begin
  For x := 1 To 100 Do
    application.processmessages;                                                // to solve xmemocode has no parent window issue;

  FMListBoxIPR1.Visible := False;

  If FMListBoxIPR1.Items.Count > 0 Then
  Begin
    For x := 0 To FMListBoxIPR1.Items.Count - 1 Do
    Begin

      Line := FMListBoxIPR1.Items[x];
      patientName := Copy(Line, 1, pos('  ', Line));
      Line := Copy(Line, length(patientname) + 1, Length(Line));

      (*
      If Copy(line,1,1)<>'!' then begin
        // Get 1st letter last name + last 4 digits of SSN
        FMListBoxIPR1.ItemIndex:=x;
        FMGetsIPRFile.IENS:=FMListBoxIPR1.GetSelectedRecord.IEN;
        FMGetsIPRFile.GetData;
        FMGetsPatientFile.IENS:=FMGetsIPRFile.GetField('.01').FMDBInternal;
        FMGetsPatientFile.GetData;
        patientName:=patientName+'('+FMGetsPatientFile.GetField('.0905').FMDBExternal+')';
      end;
      *)

      Line := TrimLeft(Line);

      // Actually, this is date
      examName := Copy(Line, 1, pos('  ', Line));
      examNameLen := Length(examName);
      Line := Copy(Line, examNameLen + 1, Length(Line));
      Line := TrimLeft(Line);
      If examName = 'JAN 01, 1980 ' Then
        examName := '            ';

      examinerName := Copy(Line, 1, pos('  ', Line));
      examinerNameLen := Length(examinerName);
      Line := Copy(Line, examinerNameLen + 1, Length(Line));
      Line := TrimLeft(Line);

      Status := Copy(Line, 1, pos('  ', Line));
      StatusLen := Length(Status);
      Line := Copy(Line, StatusLen + 1, Length(Line));
      Line := TrimLeft(Line);

      F1 := Copy(Line, 1, pos('  ', Line));
      F1Len := Length(F1);
      Line := Copy(Line, F1Len + 1, Length(Line));
      Line := TrimLeft(Line);
      F1 := Trim(F1);
      If F1 = '' Then
        F1 := ' ';

      F2 := Copy(Line, 1, pos('  ', Line));
      F2Len := Length(F2);
      Line := Copy(Line, F2Len + 1, Length(Line));
      Line := TrimLeft(Line);
      F2 := Trim(F2);
      If F2 = '' Then
        F2 := ' ';

      F3 := trim(line);
      If F3 = '' Then
        F3 := ' ';

      // !=Individual item in a merged exam
      If Copy(Line, 1, 1) <> '!' Then

        //%-33s %-4s%-19s  %-19s  %-6s
        If Length(PatientName) > 32 Then
          PatientName := Copy(PatientName, 1, 32);
      If Length(ExamName) > 19 Then
        ExamName := Copy(ExamName, 1, 19);
      If Length(ExaminerName) > 19 Then
        ExaminerName := Copy(ExaminerName, 1, 19);
      If Copy(FMListBoxIPR1.Items[x], 1, 1) = '!' Then
      Begin
        FMListBoxIPR1.Items[x] := FMListBoxIPR1.Items[x];
      End
      Else
      Begin
        // Insert 2 spaces
        If F1 = '' Then
          F1 := 'Y';
        If F2 = '' Then
          F2 := ' ';
        If F3 = '' Then
          F3 := ' ';
        FMListBoxIPR1.Items[x] := Format('%-33s %-4s%-19s  %-19s  %-6s', [PatientName, F1 + F2 + F3, examname, examinername, status]);
        If examName = '            ' Then
          FMListBoxIPR1.Items[x] := '*' + FMListBoxIPR1.Items[x];
      End;
    End;

  End;
  //self.BorderIcons:=[biSystemMenu];
  FMListBoxIPR1.Enabled := True;
  FMListBoxIPR1.ItemIndex := -1;
  If FMListBoxIPR1.Items.Count > 0 Then
  Begin
    FMListBoxIPR1.ItemIndex := 0;
    FMListBoxIPR1.ItemIndex := -1;
  End;

  If FMListBoxIPR1.Items.Count > 0 Then
  Begin
    // Brings list to the top
    FMListBoxIPR1.ItemIndex := 0;
    FMListBoxIPR1.ItemIndex := -1;
  End;
End;

Procedure TfrmMain.Splitter7CanResize(Sender: TObject;
  Var NewSize: Integer; Var Accept: Boolean);
Begin
  Accept := False;
End;

Procedure TfrmMain.FMMemoFormDefinitionChange(Sender: TObject);
Var
  x: integer;
  tempfmmemo: trichedit;
  foundflag: boolean;
Begin
  tempfmmemo := sender As trichedit;
  //ShowMessageCAPRI(sender.ClassName);
    // merge lines split by ~
  Repeat
    Begin
      foundflag := false;
      If tempFMMemo.Lines.Count > 0 Then
        For x := tempFMMemo.Lines.Count - 1 Downto 0 Do
          If Copy(tempFMMemo.Lines[x], 1, 1) = '~' Then
          Begin
            tempFMMemo.Lines[x - 1] := tempFMMemo.Lines[x - 1] + Copy(tempFMMemo.Lines[x], 2, length(tempFMMemo.lines[x]));
            tempFMMemo.Lines.Delete(x);
          End;
      If tempFMMemo.Lines.Count > 0 Then
        For x := tempFMMemo.Lines.Count - 1 Downto 0 Do
          If Copy(tempFMMemo.Lines[x], 1, 1) = '~' Then
            foundflag := true;
  End Until FoundFlag = False;
End;

Procedure TfrmMain.FormPaint(Sender: TObject);
Begin
  FormResize(Application);
End;

Procedure TfrmMain.FormCloseQuery(Sender: TObject; Var CanClose: Boolean);
Begin
  CanClose := False;

  If ANURemoteProcedureCallInProgress = True Then
  Begin
    messagebeep(0);
    exit;
  End;
  //check if a template is currently open - kcl 1/3/2008
  If Assigned(PNCSForm) Then
  Begin
    ShowMessage('Please close the open Template.');
    //CodeCR367 - rpm 8/21/12 - prevent potential AVs
    try
      //re-check because state may have changed during ShowMessage
      if Assigned(PNCSForm) then
        PNCSForm.Show;
    except
      {Do nothing as form may be in the process of closing or
       closed before dialog acknowledged}
    end;
    Exit;
  End;
  frmMain.Tag := 12613;
  RPCBroker1.Connected := False;
  CanClose := True;
End;

Procedure TfrmMain.HeaderControlDODConsultsSectionResize(
  HeaderControl: THeaderControl; Section: THeaderSection);
Begin
  VAWrapGridDOD.ColCount := 6;
  VAWrapGridDOD.ColWidths[0] := HeaderControlDODConsults.Sections[0].Width - 2;
  VAWrapGridDOD.ColWidths[1] := HeaderControlDODConsults.Sections[1].Width - 2;
  VAWrapGridDOD.ColWidths[2] := HeaderControlDODConsults.Sections[2].Width - 1;
  VAWrapGridDOD.ColWidths[3] := HeaderControlDODConsults.Sections[3].Width - 1;
  VAWrapGridDOD.ColWidths[4] := HeaderControlDODConsults.Sections[4].Width - 1;
  VAWrapGridDOD.ColWidths[5] := HeaderControlDODConsults.Sections[5].Width - 1;
End;

Procedure TfrmMain.HeaderControlDoDAllergiesSectionResize(
  HeaderControl: THeaderControl; Section: THeaderSection);
Begin
  VAWrapGridDOD.ColCount := 3;
  VAWrapGridDOD.ColWidths[0] := HeaderControlDODAllergies.Sections[0].Width - 2;
  VAWrapGridDOD.ColWidths[1] := HeaderControlDODAllergies.Sections[1].Width - 2;
  VAWrapGridDOD.ColWidths[2] := HeaderControlDODAllergies.Sections[2].Width - 1;
End;

Procedure TfrmMain.ContextorControlCanceled(Sender: TObject);
Begin
  If RPCBroker1.Connected = False Then
    exit;
  // We don't care about cancellations right now
End;

Procedure TfrmMain.ContextorControlCommitted(Sender: TObject);
Begin
  // Only force change if CAPRI has finished starting up
  If AppStarted = False Then
    exit;

  // Need to check all open dialogs, cancel them out, and make the change anyway
  //If ContextorChangeMessage='' then begin
  If CCOWForceCloseOfAllDialogs = false Then
  Begin
    ANURemoteProcedureCallInProgress := False;                                  // Allow user to click the "OK" button
    ShowmessageCAPRI('WARNING:  The clinical patient context has changed but CAPRI was unable to comply.' + char(13) +
      'CAPRI has dropped out of the clinical context.  You may re-join by clicking the CCOW' + char(13) + 'button on the main CAPRI form.');
    CCOWSuspended := True;
    BitBtnCCOWLinkBroken.Visible := True;
    BitBtnCCOWLink.Visible := False;
    BitBtnCCOWLinkChanging.Visible := False;
    ContextorControl.Suspend;
    exit;
  End;
  //end;
  // -----------------------

  // Check for user subject null
  // If null, need to force shutdown
  (*
  If RPCBroker1.WasUserDefined=True then
    If RPCBroker1.IsUserCleared then begin
      frmMain.Quit2Click(Application);
    end;
  *)
  CCOWInitialized := False;
  BitBtnCCOWLinkBroken.Visible := False;
  BitBtnCCOWLink.Visible := False;
  BitBtnCCOWLinkChanging.Visible := True;
  ShutdownCAPRIModalDialogs := True;                                            // Just to be sure
  actFileSelectPatientExecute(ContextorControl)
End;

Procedure TfrmMain.ContextorControlPending(Sender: TObject;
  Const aContextItemCollection: IDispatch);
Begin
  //ShowMessageCAPRI('Contextor Pending');
  // Need to check if logged in with RPC broker yet
  // Check if it's ok to change context

  If RPCBroker1.Connected = False Then
    exit;

  // Check for dialogs on screen and send message to close them

  // This forces all modal dialogs to shut down

  If ContextorChangeMessage <> '' Then
  Begin
    ContextorControl.SetSurveyResponse(ContextorChangeMessage);
  End;

End;

Procedure TfrmMain.BitBtnCCOWLinkClick(Sender: TObject);
Begin
  If Application.MessageBox('Are you sure you want to suspend the clinical link?', 'CAPRI CCOW Link', 4) = 6 Then
  Begin
    CCOWSuspended := True;
    BitBtnCCOWLinkBroken.Visible := True;
    BitBtnCCOWLink.Visible := False;
    ContextorControl.Suspend;
  End;
End;

Function TfrmMain.CCOWForceCloseOfAllDialogs: boolean;
Var
  x: integer;
Begin
  ShutdownCAPRIModalDialogs := True;
  For x := 1 To 10000 Do
    application.processmessages;

  If CCOWBreakLink = True Then
    result := False
  Else
    result := true;

  CCOWBreakLink := False;

End;

Procedure TfrmMain.BitBtnCCOWLinkBrokenClick(Sender: TObject);
Begin
  // Check if ok to switch to new patient
  // Will lose any work?
  dvbatimerinfobox := 0;
  frmInfoBox := TfrmInfoBox.Create(frmMain);
  frmInfoBox.Label1.Caption := 'Your patient is being changed to match the clinical context.';
  frmInfoBox.Show;
  frmInfoBox.BringToFront;
  frmInfoBox.Left := (frmMain.Left + (frmMain.width Div 2)) - (frmInfoBox.width Div 2);
  frmInfoBox.Top := (frmMain.top + (frmMain.height Div 2)) - (frmInfoBox.height Div 2);
  frmInfoBox.BringToFront;
  frmInfoBox.Repaint;
  frmMain.Repaint;
  timerInfoBox.Interval := 1000;
  timerInfoBox.Enabled := True;

  ContextorControl.Resume;
  CCOWInitialized := False;                                                     // Force re-load of patient
  BitBtnCCOWLinkBroken.Visible := False;
  BitBtnCCOWLink.Visible := True;
  BitBtnCCOWLinkChanging.Visible := False;
  CCOWPatientName := '';
  CCOWPatientIEN := '';
  CCOWSuspended := False;
  actFileSelectPatient.Execute;
End;

Procedure TfrmMain.ButtonOtherSitesClick(Sender: TObject);
Var
  a, b: String;
  x: integer;

  Procedure RemoveHDRFromList;
  Var
    x: integer;
  Begin
    // Remove HDR entry, if found
    If frmMain.Piece(frmMain.RPCBroker1.Results[0], '^', 1) <> '-1' Then
      For x := frmMain.RPCBroker1.Results.Count - 1 Downto 0 Do
        If frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 1) = '200HD' Then
          frmMain.RPCBroker1.Results.Delete(x);
    // If the list is empty, make sure this is reflected.
    If frmMain.RPCBroker1.Results.Count = 0 Then
      frmMain.RPCBroker1.Results.Add('-1^No Sites Found');
  End;
Begin
  frmRemoteSitePick := TfrmRemoteSitePick.Create(frmPatientList);
  frmMain.AnimateLogo(True);
  frmMain.StatusBarLoadPt.Caption := 'Generating report.';
  frmMain.StatusBarLoadPt.Repaint;
  Application.Processmessages;
  frmMain.RPCBroker1.RemoteProcedure := 'ORWCIRN FACLIST';
  frmMain.RPCBroker1.Param[0].Value := frmMain.Piece(PatientIEN, ',', 1);
  frmMain.RPCBroker1.Param[0].PType := literal;
  frmMain.RPCBrokerCall;
  Try
    frmMain.RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      frmMain.AnimateLogo(False);
      frmMain.StatusBarLoadPt.Caption := 'RPC ORWCIRN FACLIST could not be accessed!';
      frmMain.StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('ORWCIRN FACLIST could not be accessed!');
    End
  End;
  RemoveHDRFromList;
  If frmMain.Piece(frmMain.RPCBroker1.Results[0], '^', 1) = '-1' Then
  Begin
    // Only local data or other problem
    frmRemoteSitePick.ORListBoxSites.Items.Add('Sites could not be loaded.');
  End
  Else
  Begin
    For x := 0 To frmMain.RPCBroker1.Results.Count - 1 Do
    Begin
      a := Copy(frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 1) + '        ', 1, 8);
      b := Copy(frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 2) + '                         ', 1, 25);
      sitenum := frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 1);
      frmRemoteSitePick.ORListBoxSites.Items.Add(a + b + '  ' + FMDateTimeConvert(frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 3)) + '^' + sitenum);
    End;
  End;
  frmMain.AnimateLogo(False);
  frmMain.StatusBarLoadPt.Caption := 'Ready.';
  frmMain.StatusBarLoadPt.Repaint;
  Application.Processmessages;
  If frmRemoteSitePick.ShowModal = mrok Then
  Begin
    If SiteNum = '200' Then
    Begin
      Try
        frmRemoteSitePick.Release;
      Except
      End;
      frmRemoteSitePick := Nil;
      switchtosite := '';
      ShowMessageCAPRI('Switching to DoD is not allowed.  Instead, use the DOD RECORDS tab to view DOD data.');
      exit;
    End;

    If switchtosite <> '' Then
    Begin
      For x := 0 To formEssoSelect.slUserSites.Count - 1 Do                     //CodeCR77
      Begin
        If (Pos(SwitchToSite, frmMain.Piece(formESSOSelect.slUserSites[x], '^', 8)) > 0) Or // CodeCR191 -MER 05/2011
          (Pos(SwitchToSite, frmMain.Piece(formESSOSelect.slUserSites[x], '^', 4)) > 0) Then
        Begin
          switchtosite := inttostr(x);
          SwitchToPatientSSN := PatientSSN;
          Try
            frmRemoteSitePick.Release;
            frmRemoteSitePick.Release;
          Except
          End;
          frmRemoteSitePick := Nil;
          actFileSelectPatientExecute(contextorcontrol);
          exit;
        End;
        // User doesn't have authorized access, so look for site an alternate way
      End;

      For x := 0 To formEssoSelect.ORListBox2.Items.Count - 1 Do
        If (Pos(SwitchToSite, frmMain.Piece(formESSOSelect.ORListBox2.Items[x], '^', 1)) > 0) Or
          (Pos(SwitchToSite, frmMain.Piece(formESSOSelect.ORListBox2.Items[x], '^', 4)) > 0) Then
        Begin
          switchtosite := '*' + inttostr(x);
          SwitchToPatientSSN := PatientSSN;
          Try
            frmRemoteSitePick.Release;
            frmRemoteSitePick.Release;
          Except
          End;
          frmRemoteSitePick := Nil;
          actFileSelectPatientExecute(contextorcontrol);
          exit;
        End;
      switchtosite := '';
      ShowMessageCAPRI('+You either do not have access to the remote site or some other problem prevented connection.  Try connecting manually instead using FILE | SWITCH SITES.');
    End
    Else
    Begin
      SwitchToSite := '';
      ShowMessageCAPRI('*You either do not have access to the remote site or some other problem prevented connection.  Try connecting manually instead using FILE | SWITCH SITES.');
    End;
  End;
  If assigned(frmRemoteSitePick) Then
  Try
    frmRemoteSitePick.Release;
  Except
  End;
  frmRemoteSitePick := Nil;
End;

Procedure TfrmMain.ORListBoxSurgeryReportsClick(Sender: TObject);
Begin
  ButtonOKSurgeryReports.Enabled := True;
End;

Procedure TfrmMain.StateFakeChange(Sender: TObject);
Begin
  If (StateFake.Text = 'CANADA') Or (StateFake.Text = 'PHILIPPINES') Or
    (StateFake.Text = 'QUEBEC') Or
    (Uppercase(Trim(StateFake.Text)) = 'NEWFOUNDLAND') Or (Uppercase(Trim(StateFake.text)) = 'LABRADOR') Or (Uppercase(Trim(StateFake.text)) = 'NOVA SCOTIA') Or
    (Uppercase(Trim(StateFake.Text)) = 'PRINCE EDWARD ISLAND') Or (Uppercase(Trim(StateFake.text)) = 'NEW BRUNSWICK') Or (Uppercase(Trim(StateFake.text)) = 'ONTARIO') Or
    (Uppercase(Trim(StateFake.Text)) = 'MANITOBA') Or (Uppercase(Trim(StateFake.text)) = 'SASKATCHEWAN') Or (Uppercase(Trim(StateFake.text)) = 'ALBERTA') Or
    (Uppercase(Trim(StateFake.text)) = 'BRITISH COLUMBIA') Or (Uppercase(Trim(StateFake.text)) = 'YUKON TERRITORY') Or (Uppercase(Trim(StateFake.text)) = 'NORTHWEST TERRITORIES') Or
    (Uppercase(Trim(StateFake.text)) = 'NUNAVUT') Then
  Begin
    lblCounty.Visible := False;
    CountyFake.Text := '';
    CountyFake.Visible := False;
    If FMEditCounty.Text <> '' Then
      FMEditCounty.Text := '@';
    FMEditCounty.Visible := False;
    FMCountiesList.Visible := False;
    ButtonCountyAccept.Visible := False;
    lblZip.Visible := False;
    If FMEditZip.Text <> '' Then
      FMEditZip.Text := '@';
    FMEditZip.Visible := False;
    FMStatesList.Visible := False;
    ButtonStateAccept.Visible := False;
  End
  Else
  Begin
    lblCounty.Visible := True;
    CountyFake.Visible := True;
    lblZip.Visible := True;
    FMEditZip.Visible := True;
  End;
End;

Procedure TfrmMain.ButtonIPRCopyClick(Sender: TObject);
Var
  tempIEN: String;
  x: integer;
Begin
  If MessageDlgCAPRI('Would you like to make a NEW copy of the selected template and assign it to yourself?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes Then
  Begin
    FMListboxIPR1.ItemIndex := FMListBoxIPR1.Items.Count - 1 - ListBoxIPR1.ItemIndex;
    If FMListboxIPR1.ItemIndex < 0 Then
    Begin
      MessageDlgCAPRI('You must select a record first!', mtInformation, [mbOk], 0);
      Exit;
    End;
    RPCBroker1.RemoteProcedure := 'DVBAB FORM COPY';
    RPCBroker1.Param[1].Value := FMListBoxIPR1.GetSelectedRecord.IEN;
    RPCBroker1.Param[1].PType := literal;
    frmMain.RPCBrokerCall;
    Try
      RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        AnimateLogo(False);
        StatusBarLoadPt.Caption := 'RPC DVBAB FORM COPY could not be accessed!';
        StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('ORWU DT could not be accessed!');
      End;
    End;
    tempIEN := RPCBroker1.Results[0];
    If piece(tempIEN, '^', 1) = '-1' Then
    Begin
      // error happened
      ShowMessageCAPRI(piece(tempIEN, '^', 2));
      exit;
    End;
    ButtonIPRRefreshClick(Application);
    x := 0;
    If ListBoxIPR1.Items.Count > 0 Then
      Repeat
        ListBoxIPR1.ItemIndex := x;
        ListBoxIPR1Click(Application);
        FMListboxIPR1.ItemIndex := FMListBoxIPR1.Items.Count - 1 - ListBoxIPR1.ItemIndex;
        If FMListBoxIPR1.GetSelectedRecord.IEN = tempIEN Then
        Begin
          x := -1;
          buttonIPRDisplayClick(application);
        End;
      Until (x > ListBoxIPR1.Items.Count - 1) Or (x = -1);
    // Form should've been loaded at this point or it couldn't
    // be found for some reason
  End;

End;

{==============================================================================
  ListBoxIPR1KeyDown
    ListBoxIPR1KeyDown is a method that will process key presses to check for a
      particular condition.  The problem this method corrects is an inability to
      use the cursor keys to select the item focus in the listbox ListBoxIPR1.
      The reason there is a problem is that the OnClick event handler prevents
      'sub-items' from being selected.  It does this by forcing focus to the sub-items
      parent item.  As a result using the down arrow appears to have no effect.
      Note: Sub-items start with '!'.  The '!' is a flag to format differently
      and prevent selection.  The '!' character is stripped out on display.
      In order to correct the problem, this detects if a condition exists where
      a down arrow key event would fail to act correctly, it then handles the
      item selection and sets the key to 0 to prevent it from being handled twice.

  Modification History:
    CodeCR117 - 8/2010 Method created -MER
 ==============================================================================}

procedure TfrmMain.ListBoxIPR1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);                                                          // -MER CodeCR117 8/2010
var
  lNdx: integer;
begin
  if (Key = 40) and                                                             // down cursor key
    (ListBoxIPR1.ItemIndex < (ListBoxIPR1.Items.Count - 1)) and                 // not last item
    (Copy(ListBoxIPR1.Items[ListBoxIPR1.ItemIndex + 1], 1, 1) = '!')            // next item is a sub-item
    then begin
    lNdx := ListBoxIPR1.ItemIndex + 1;
    while (lNdx < (ListBoxIPR1.Items.Count - 1)) and
      (Copy(ListBoxIPR1.Items[lNdx], 1, 1) = '!')
      do
      Inc(lNdx);
    if (lNdx < (ListBoxIPR1.Items.Count)) and
      (Copy(ListBoxIPR1.Items[lNdx], 1, 1) <> '!')
      then begin
      ListBoxIPR1.ItemIndex := lNdx;
      Key := 0;                                                                 // prevent the key press from being acted on further
    end;
  end;
end;

Procedure TfrmMain.ListBoxIPR1KeyUp(Sender: TObject; Var Key: Word;
  Shift: TShiftState);
Begin
  // Delete key
  If key = 46 Then
    If buttonIPRDelete.visible = true Then
      buttonIPRDeleteclick(application);
  // Enter key
  If key = 13 Then
    buttonIPRDisplayclick(application);
End;

Procedure TfrmMain.buttonNewsClick(Sender: TObject);
Begin
  If formNews = nil Then formNews := TformNews.Create(frmMain);
  formNews.BringToFront;
  TimerNews.Enabled := False;
  formNews.Edit1.Setfocus;
  formNews.ShowModal;
  Try
    formNews.Hide;
  Except End;
  Try
    TimerNews.Enabled := True;
  Except End;
  Try
    TimerNewsTimer(buttonNews);
  Except End;
  Try
    If RPCBroker1.Connected = True Then
      buttonNews.SetFocus;
  Except End;
End;

Procedure TfrmMain.TimerNewsTimer(Sender: TObject);
Var
  temptext: String;
  x: integer;
  priorityfound: boolean;
  regularfound: boolean;
  aStream: TMemoryStream;
Begin
  // Check news every 30 minutes
  // 1000ms * 60 seconds * 30 mins = 600000ms
  Cursor := crHourglass;
  temptext := StatusBarLoadPt.Caption;
  StatusBarLoadPt.Caption := 'Checking news...';
  formNews.RichEditNews.Lines.Clear;
  formNews.RichEditNewsViewed.Lines.Clear;
  If frmMain.Visible = False Then
  Begin
    frmEstablishingNetworkConnection := tfrmEstablishingNetworkConnection.Create(application);
    frmEstablishingNetworkConnection.Show;
    frmEstablishingNetworkConnection.Repaint;
  End
  Else
  Begin
    buttonNews.Enabled := False;
  End;

  formNews.RichEditNews.Lines.Clear;

  aStream := TMemoryStream.Create;
  formNews.GetURL('http://' + newsURL + 'NewsHeaders.txt', aStream);
  formNews.RichEditNews.Lines.LoadFromStream(aStream);
  aStream := nil;

  If (formNews.RichEditNews.Lines.Count > 0) And (formNews.RichEditNews.Lines[0] <> ';CAPRI NEWS') Then
    formNews.RichEditNews.Lines.Clear
  Else
    formNews.RichEditNews.Lines.Delete(0);                                      // Get rid of header line
  //Try formNews.RichEditNews.Lines.LoadFromFile(newsfolder+'NewsHeaders.txt') except end;
  Try
  formNews.RichEditNewsViewed.Lines.LoadFromFile(tempDir + 'CAPRINewsReadInfo.txt')Except
  End;
  If frmMain.Visible = False Then
  Begin
    frmEstablishingNetworkConnection.Release;
    frmEstablishingNetworkConnection := Nil;
  End
  Else
  Begin
    buttonNews.Enabled := True;
  End;
  StatusBarLoadPt.Caption := temptext;
  If formNews.RichEditNews.Lines.Count = 0 Then
  Begin
    buttonNews.BringToFront;
    buttonNews.Enabled := False;
    buttonNewsFlash.Enabled := False;
    exit;
  End
  Else
  Begin
  End;
  // Check for unread priority news
  // 0=Low Priority
  // 1=Regular Priority
  // 2=High Priority
  priorityfound := false;
  regularfound := false;
  If formNews.RichEditNews.Lines.Count > 0 Then
    For x := 0 To formNews.RichEditNews.Lines.Count - 1 Do
    Begin
      If (Piece(formNews.RichEditNews.Lines[x], '^', 1) = '2') Then
      Try
        If formNews.RichEditNewsViewed.Lines[strtoint(piece(formNews.RichEditNews.Lines[x], '^', 2))] <> 'Y' Then
          priorityfound := true;
      Except
        priorityfound := true;
      End;
      If (Piece(formNews.RichEditNews.Lines[x], '^', 1) = '1') Then
      Try
        If formNews.RichEditNewsViewed.Lines[strtoint(piece(formNews.RichEditNews.Lines[x], '^', 2))] <> 'Y' Then
          regularfound := true;
      Except
        regularfound := true;
      End;
    End;

  cursor := crDefault;

  // First make icon for low priority or all news read
  buttonNews.BringToFront;
  buttonNews.Enabled := True;
  buttonNewsFlash.Enabled := False;

  // Set icons for news if new regular mail is found
  If RegularFound = True Then
  Begin
    buttonNews.Enabled := False;
    buttonNewsFlash.BringToFront;
    buttonNewsFlash.Enabled := True;
    // Don't call reader for regular mail at startup
  End;

  // Set Icons and call newsreader if priority is found
  If PriorityFound = True Then
  Begin
    buttonNews.Enabled := False;
    buttonNewsFlash.BringToFront;
    buttonNewsFlash.Enabled := True;
    If sender = RPCBroker1 Then
      buttonNewsClick(Application);                                             // call reader for priority mail at startup
  End;

End;

Procedure TfrmMain.DeleteText(Sender: TObject);
Begin
  Sender := screen.ActiveControl;

  If Sender.ClassType = TMemo Then
  Begin
    (Sender As TMemo).SelText := '';
  End
  Else
    If Sender.ClassType = TEdit Then
    Begin
      (Sender As TEdit).SelText := '';
    End
    Else
      If Sender.ClassType = TRichEdit Then
      Begin
        (Sender As TRichEdit).SelText := '';
      End
      Else
        Sleep(1);                                                               //Showmessage('Unknown class type: '+Sender.ClassName);
End;

Procedure TfrmMain.DeleteTemplateClick(Sender: TObject);
Begin
  ButtonIPRDeleteClick(Application);
End;

Procedure TfrmMain.BitBtn1Click(Sender: TObject);
Begin
  WebBrowser1.GoBack;
End;

Procedure TfrmMain.BitBtn2Click(Sender: TObject);
Begin
  Try
  WebBrowser1.GoForward Except
  End;
End;

Procedure TfrmMain.BitBtnLaunchVistaWebClick(Sender: TObject);
Begin
  btnVistAWebHomeClick(bitbtnLaunchVistAWeb);
End;

Procedure TfrmMain.WebBrowser1DocumentComplete(Sender: TObject;
  Const pDisp: IDispatch; Var URL: OleVariant);
Begin
  cursor := crDefault;
  progressBarLoadPt.visible := False;
End;

Procedure TfrmMain.WebBrowser1ProgressChange(Sender: TObject; Progress,
  ProgressMax: Integer);
Begin
  If Page95Control1.ActivePage <> TabVistAWeb Then
    progressBarLoadPt.Visible := False
  Else
    progressBarLoadPt.Visible := True;
  progressBarLoadPt.Position := Progress;
  progressBarLoadPt.Max := ProgressMax;
  If progressBarLoadPt.Max < ProgressMax Then
    cursor := crHourglass;
  If progressBarLoadPt.Max = ProgressMax Then
    progressBarLoadPt.Visible := False;
End;

//CodeCR187 - rpm 5/25/11 Prevent browser from being closed, which generates OLE errors

procedure TfrmMain.WebBrowser1WindowClosing(ASender: TObject;
  IsChildWindow: WordBool; var Cancel: WordBool);
begin
  Cancel := True;
end;

Procedure TfrmMain.WebBrowser1NavigateComplete2(Sender: TObject;
  Const pDisp: IDispatch; Var URL: OleVariant);
Begin
  cursor := crDefault;
  ProgressBarLoadPt.Visible := False;
End;

Procedure TfrmMain.WebBrowser1BeforeNavigate2(Sender: TObject;
  Const pDisp: IDispatch; Var URL, Flags, TargetFrameName, PostData,
  Headers: OleVariant; Var Cancel: WordBool);
Begin
  cursor := crHourglass;
End;

Procedure TfrmMain.BitBtn4Click(Sender: TObject);
Begin
  actFilePrint.Execute;
End;

Procedure TfrmMain.TimerInitialConnectionTimer(Sender: TObject);
Begin
  Application.Terminate;
End;

Procedure TfrmMain.HeaderControlDoDPNsSectionResize(
  HeaderControl: THeaderControl; Section: THeaderSection);
Begin
  VAWrapGridDOD.ColCount := 5;
  VAWrapGridDOD.ColWidths[0] := HeaderControlDODPNs.Sections[0].Width - 2;
  VAWrapGridDOD.ColWidths[1] := HeaderControlDODPNs.Sections[1].Width - 2;
  VAWrapGridDOD.ColWidths[2] := HeaderControlDODPNs.Sections[2].Width - 1;
  VAWrapGridDOD.ColWidths[3] := HeaderControlDODPNs.Sections[3].Width - 1;
  VAWrapGridDOD.ColWidths[4] := HeaderControlDODPNs.Sections[4].Width - 1;
End;

Procedure TfrmMain.RPCBroker1AfterCall(Sender: TObject);
Var
  tempstring: String;
  x: integer;
Begin
  tempstring := 'RESULTS:' + char(13) + char(10);
  If (Sender As TRPCBroker).Results.Count > 0 Then
    For x := 0 To (Sender As TRPCBroker).Results.Count - 1 Do
    Begin
      tempstring := tempstring + inttostr(x) + ': ' + (Sender As TRPCBroker).Results[x] + char(13) + char(10);
    End
  Else
    tempstring := tempstring + 'No results were returned.' + char(13) + char(10);

  If assigned(frmBrokerHistoryBuffer) Then
  Begin
    frmBrokerHistoryBuffer.RichEditBrokerCalls.Lines.Add(tempstring);
    frmBrokerHistoryBuffer.SaveNewCall;
  End;

End;

Procedure TfrmMain.RPCBroker1BeforeCall(Sender: TObject);
Var
  tempstring: String;
  x, y: integer;
Begin
  tempstring := 'COMPONENT: ' + (Sender As TRPCBroker).name + char(13) + char(10) + char(13) + char(10);
  tempstring := tempstring + 'REMOTE PROCEDURE:' + (Sender As TRPCBroker).RemoteProcedure + char(13) + char(10) + char(13) + char(10);
  tempstring := tempstring + 'PARAMETERS:' + char(13) + char(10);
  If (Sender As TRPCBroker).Param.Count > 0 Then
  Begin
    For x := 0 To (Sender As TRPCBroker).Param.Count - 1 Do
    Begin
      tempstring := tempstring + inttostr(x) + ': ' + (Sender As TRPCBroker).Param.ParamArray[x].Value + char(13) + char(10);
      If (Sender As TRPCBroker).Param.ParamArray[x].Mult.Count > 0 Then
        For y := 0 To (Sender As TRPCBroker).Param.ParamArray[x].Mult.Count - 1 Do
        Begin
          tempstring := tempstring + '  MULT ' + inttostr(y) + ': ' + (Sender As TRPCBroker).Param.ParamArray[x].Mult.Subscript(y) + char(13) + char(10);
        End;
    End;
    tempstring := tempstring + char(13) + char(10);
  End
  Else
    tempstring := tempstring + 'No parameters specified.' + char(13) + char(10) + char(13) + char(10);

  tempstring := tempstring + '----------------------------------------' + char(13) + char(10);

  If assigned(frmBrokerHistoryBuffer) Then
  Begin
    frmBrokerHistoryBuffer.RichEditBrokerCalls.Lines.Add(tempstring);
  End;

End;

Procedure TfrmMain.FMListBoxAdmissionEnter(Sender: TObject);
Begin
  FMListBoxAdmission.color := clYellow;
End;

Procedure TfrmMain.FMListBoxAdmissionExit(Sender: TObject);
Begin
  FMListBoxAdmission.color := clWindow;
End;

Procedure TfrmMain.ButtonIPRRefreshEnter(Sender: TObject);
Begin
  If Page95Control1.ActivePage <> TabCPWorksheets Then
  Try
    Page95Control1.SetFocus;
  Except
  End;

End;

Procedure TfrmMain.Page95Control1Changing(Sender: TObject;
  Var AllowChange: Boolean);
Begin
  If ANURemoteProcedureCallInProgress = True Then
    AllowChange := False
  Else
    AllowChange := True;
End;

Procedure TfrmMain.Tab95Control1Changing(Sender: TObject;
  Var AllowChange: Boolean);
Begin
  If ANURemoteProcedureCallInProgress = True Then
    AllowChange := False
  Else
    AllowChange := True;
End;

Function TfrmMain.Piece(Const S: String; Delim: char;
  PieceNum: Integer): String;
Begin
  Result := CapriSupport.Piece(S, Delim, PieceNum);
End;

Function TfrmMain.IsUserKey(KeyName: String): Boolean;
Var
  i: Integer;
Begin
  (*
  CAPRI KEYS
  DVBA CAPRI GUI - This is the option context to the main CAPRI application. All CAPRI users will need this menu option assigned
  DVBA CAPRI WORKSHEET TAB - This security key makes the C&P Worksheets tab visible inside CAPRI. All Veterans Health Administration (VHA) CAPRI users should have this security key
  DVBAB CPWM DISALLOW REVIEW - User does not need their documents reviewed prior to release
  DVBAB CPWM OPTIONAL REVIEW - User can choose to send some documents for review and not other documents
  DVBAB CPWM REQUIRE REVIEW - User must have all documents reviewed by a reviewer prior to upload
  OPTIONAL Key - If the site chooses to use the review process, users designated as a reviewer must be assigned the DVBAB CPWM REVIEWER security key
  DVBA CAPRI VRE_COUNSELOR -  Make the vocational rehab tab visible only if the user has this key assigned (CodeCR347 - JRL 6/21/12)
  DVBA CAPRI VHA_COORDINATOR - Above key must be assigned, too, to have this access - used for assigning consults in VocRehab (CodeCR347 - JRL 6/21/12)
  DVBA CAPRI DENY_GETVBADOCS - This option keeps assigned VBA users from accessing VVA -- obsoleted in patch 187 JRL 5/22/14
  DVBA CAPRI GETVBADOCS - This option is required for any user to "Get Docs from VVA".  This replaced the Deny key above using opposite logic.  JRL 5/22/14
  DVBA CAPRI GETDOCSFROMVLER - This option is required for any user to "Get Docs from VLER".  Patch 187 JRL 5/22/14

  -To activate a CPWM for a particular user, a menu option and several security keys must be assigned:
  -- IRM's will need to coordinate with the C&P clinic to determine what keys a user should receive.
     The majority of users will need 2 new keys. The reviewer type user will need 3 keys
  --Some sites require the exam to be sent to a reviewer when complete.
  --It is imperative that a user not be given every DVBA* key. The keys have conflicting uses
    and unexpected errors will happen.
  *)
  Result := False;
  Try
    KeyName := UpperCase(Trim(KeyName));
    If KeyName = '' Then
      Exit;
    For i := 0 To UserKeys.Count - 1 Do
    Begin
      If UserKeys[i] = KeyName Then
      Begin
        Result := True;
        Break;
      End;
    End;
  Except
  End;
End;

Function TfrmMain.IsUserKeyInList(KeyList: String): Boolean;
Var
  i: Integer;
  lst: TStringList;
Begin
  (*
  CAPRI KEYS
  DVBA CAPRI GUI - This is the option context to the main CAPRI application. All CAPRI users will need this menu option assigned
  DVBA CAPRI WORKSHEET TAB - This security key makes the C&P Worksheets tab visible inside CAPRI. All Veterans Health Administration (VHA) CAPRI users should have this security key
  DVBAB CPWM DISALLOW REVIEW - User does not need their documents reviewed prior to release
  DVBAB CPWM OPTIONAL REVIEW - User can choose to send some documents for review and not other documents
  DVBAB CPWM REQUIRE REVIEW - User must have all documents reviewed by a reviewer prior to upload
  OPTIONAL Key - If the site chooses to use the review process, users designated as a reviewer must be assigned the DVBAB CPWM REVIEWER security key
  DVBA CAPRI VRE_COUNSELOR -  Make the vocational rehab tab visible only if the user has this key assigned (CodeCR347 - JRL 6/21/12)
  DVBA CAPRI VHA_COORDINATOR - Above key must be assigned, too, to have this access - used for assigning consults in VocRehab (CodeCR347 - JRL 6/21/12)
  DVBA CAPRI DENY_GETVBADOCS - This option keeps assigned VBA users from accessing VVA -- obsoleted in patch 187 JRL 5/22/14
  DVBA CAPRI GETVBADOCS - This option is required for any user to "Get Docs from VVA".  This replaced the Deny key above using opposite logic.  JRL 5/22/14
  DVBA CAPRI GETDOCSFROMVLER - This option is required for any user to "Get Docs from VLER".  Patch 187 JRL 5/22/14


  -To activate a CPWM for a particular user, a menu option and several security keys must be assigned:
  -- IRM's will need to coordinate with the C&P clinic to determine what keys a user should receive.
     The majority of users will need 2 new keys. The reviewer type user will need 3 keys
  --Some sites require the exam to be sent to a reviewer when complete.
  --It is imperative that a user not be given every DVBA* key. The keys have conflicting uses
    and unexpected errors will happen.
  *)
  Result := False;
  Try
    lst := TStringList.Create();
    Try
      KeyList := StringReplace(KeyList, ',', #13 + #10, [rfReplaceAll]);
      lst.SetText(PAnsiChar(KeyList));
      For i := 0 To (lst.Count - 1) Do
      Begin
        If IsUserKey(lst[i]) Then
        Begin
          Result := True;
          Exit;
        End;
      End;
    Finally
      FreeAndNil(lst);
    End;
  Except
  End;
End;



Procedure TfrmMain.UserKeysDialog;
Var
  sgKeys: String;
  i: Integer;
Begin
  sgKeys := '';
  For i := 0 To UserKeys.Count - 1 Do
  Begin
    sgKeys := sgKeys + UserKeys[i] + #13 + #10;
  End;
  ShowMessage('Your CAPRI User Keys are:' + #13 + #10 + sgKeys);
End;

Procedure TfrmMain.UserKeys1Click(Sender: TObject);
Begin
  UserKeysDialog;
End;

Procedure TfrmMain.UserKeysEditDialog;
Var
  frm: TfrmUserKeyEditor;
  inMR: Integer;
Begin
  frm := TfrmUserKeyEditor.Create(Nil);
  Try
    frm.mmo.Lines.SetText(PAnsiChar(UserKeys.Text));
    inMR := frm.ShowModal();
    If inMR = mrCancel Then
    Begin
      Exit;
    End;
    If inMR = mrOK Then
    Begin
      UserKeys.SetText(PAnsiChar(frm.mmo.Lines.Text));
    End;
    If inMR = mrRetry Then
    Begin
      UserKeys.SetText(PAnsiChar(UserKeysStr));
    End;
  Finally
    FreeAndNil(frm);
  End;
End;

function TfrmMain.IsPNCSOpen: Boolean;
begin
  Result := False;
  Try
    If PNCSForm <> Nil Then
    Begin
      Result := True;
      PNCSForm.Show;
      PNCSForm.BringToFront;
      ShowMessageCAPRI('You have a template open.  Close it first.');
    End;
  Except
  End;
end;

function TfrmMain.IsRPCBrokerConnected(RPCBroker: TCCOWRPCBrokerCAPRI; ShowMsg: Boolean; Status: TLabel): Boolean;
Var
  Msg: String;
begin
  Result := True;
  Try
    If Not RPCBroker.Connected Then
    Begin
      Msg := 'Connection to VistA has been lost. CAPRI will try to re-Connect.';
      If Status <> nil Then
      Begin
        Status.Caption := 'Trying to re-connect to VistA';
        Status.Update;
      End;
      If ShowMsg Then Application.MessageBox(PChar(Msg), 'No network connection', MB_OK);
      //RPCBroker.Connected := True;  BSE mod - rpm 4/9/09
      RPCBroker.BSEReconnect('DVBA CAPRI GUI');
      Result := RPCBroker.Connected;
      If Not RPCBroker.Connected Then
      Begin
        If Status <> nil Then
        Begin
          Status.Caption := 'Cannot re-connect to VistA';
          Status.Update;
        End;
        Msg := 'Connection to VistA has been lost. You may need to shutdown CAPRI.';
        If ShowMsg Then Application.MessageBox(PChar(Msg), 'No network connection', MB_OK);
      End;
    End;
  Except
    Raise;
  End;
end;

function TfrmMain.IsRPCBrokerConnected(ShowMsg: Boolean;
  Status: TLabel): Boolean;
begin
  Result := IsRPCBrokerConnected(RPCBroker1, ShowMsg, Status);
end;

function TfrmMain.IsRPCBrokerConnected: Boolean;
begin
  Result := IsRPCBrokerConnected(RPCBroker1, True, StatusBarLoadPt);
end;

//QC #2016 - Functionality no longer needed
{*
function TfrmMain.CanAccessReview: Boolean;
begin
  Result:=True;
  // Check key for access to pending review documents
  If FMListBoxIPR1.ItemIndex > -1 Then
  Begin
    If Pos('    REVIEW PENDING', FMListBoxIPR1.Items[FMListBoxIPR1.ItemIndex]) > 0 Then
    Begin
      // Check for @ sign, manager key
      // If not, close out form, otherwise show it.
      If Pos('@', userfilemancode) > 0 Then Result := True;
      If UserKeys.Count>0 Then
      Begin
        Result:=IsUserKeyInList('DVBAB CPWM REVIEWER,DVBAB CPWM REVIE');
      End;
      If Result = false Then
      Begin
        ShowMessageCAPRI('You do not have access to documents waiting for review.  Security key DVBAB CPWM REVIEWER is required for this function.');
      End;
    End;
  End;
end;
*}

function TfrmMain.IsPNCSRecordSelected(FMListBox: TFMListBox): Boolean;
begin
  Result := False;
  Try
    If FMListBox = nil Then Exit;
    If FMListbox.ItemIndex < 0 Then
    Begin
      MessageDlgCAPRI('You must select a record first!', mtInformation, [mbOk], 0);
      Exit;
    End;
    Result := True;
  Except
  End;
end;

{===========================================================================
 IsPrimaryMenuAssignable
 Input:  UserPrimaryMenu - Primary Menu Option assigned to user
 Output:  Return true when option exists in file #396.8; otherwise return
          false

 CodeCR109 - rpm 8/4/10
 ===========================================================================}

function TfrmMain.IsPrimaryMenuAssignable(
  const UserPrimaryMenu: String): Boolean;
var
  FMFind1PrimaryMenu: TFMFindOne;
  IEN: String;
begin
  Result := False;
  if (UserPrimaryMenu <> '') then                                               //CodeCR163 - rpm 4/4/11
  begin
    FMFind1PrimaryMenu := TFMFindOne.Create(nil);
    try
      with FMFind1PrimaryMenu do
      begin
        RPCBroker := RPCBroker1;
        FileNumber := '396.8';
        Value := UserPrimaryMenu;
        FinderFlags := [fnfXactMatch];
        IEN := GetIEN;
        if (IEN <> '') and (IEN <> '0') then
          Result := True;
      end;
    finally
      FreeAndNil(FMFind1PrimaryMenu);
    end;
  end;
end;

function TfrmMain.FileDeleteOldSaveHistory(ExistingFile, ExistingDateCreated, CurrentFile: String): Boolean;
begin
  Result := False;
  Try
    ExistingFile := UpperCase(ExistingFile);
    CurrentFile := UpperCase(CurrentFile);
    If ExistingFile = CurrentFile Then
    Begin
      If (StrToFloat(ExistingDateCreated) < (date() - 14)) Then
      Begin
        DeleteFile(tempdir + ExistingFile);
        Result := True;
      End;
    End;
  Except
  End;
end;

procedure TfrmMain.FileCreateNameForApplicationExceptionLog(var Filename: String; DayCounter: integer);
Var
  DatePart: String;
  VersionPart: String;
  d: TDateTime;
begin
  d := 0.0;
  Try VersionPart := VersionUser; Except End;
  Try d := now(); Except End;
  Try d := d - DayCounter; Except End;
  Try DatePart := FormatDateTime('dd_mm_yy', d); Except DatePart := 'dd_mm_yy'; End;
  //StringReplace has been throwing errors, so I did the following crazy stuff
  Try VersionPart := StringReplace(VersionPart, '*', '_', []); Except End;
  Try VersionPart := StringReplace(VersionPart, '*', '_', []); Except End;
  Try VersionPart := StringReplace(VersionPart, '*', '_', []); Except End;
  Try VersionPart := StringReplace(VersionPart, '*', '_', []); Except End;
  Try VersionPart := StringReplace(VersionPart, '*', '_', [rfReplaceAll]); Except End;
  Filename := VersionPart + '_' + DatePart + '.Txt';
end;



function TfrmMain.TIUShowModal(SenderName: String; FMListBox: TFMListBox): Boolean;
Var
  TempFMListbox: TFMListbox;
begin
  Result := False;
  Try
    SenderName := LowerCase(SenderName);
    If SenderName <> 'frmmain.buttoniprdisplay' Then Exit;
    If FMEditIPR10.Text = '' Then Exit;
    If SenderName = 'formtiudisplay' Then Exit;
    {FormTIUDisplay declared in main.pas implementation var section to
     re-use GetReportHeader and FormatReportBody enabling VirtualVA
     output support for TIUDisplayUnit.pas  //CodeCR353 - rpm 5/7/12}
    FormTIUDisplay := TFormTIUDisplay.Create(nil);
    Try
      TempFMListbox := FMListBox As TFMListBox;
      FormTIUDisplay.editTIUDocumentNumber.Text := frmMain.FMEditIPR10.Text;
      FormTIUDisplay.EditTemplateIEN.Text := TempFMListBox.GetSelectedRecord.IEN;
      FormTIUDisplay.SpeedButtonCAPRI.Down := True;
      FormTIUDisplay.SpeedButtonCAPRIClick(Application);
      FormTIUDisplay.ShowModal;
      Result := True;
    Finally
      FreeAndNil(FormTIUDisplay);
    End;
  Except
  End;
end;

procedure TfrmMain.FileCreateNameForSaveHistoryLog(var Filename: String; DayCounter: integer);
Var
  DatePart: String;
  VersionPart: String;
  d: TDateTime;
begin
  VersionPart := VersionUser;
  d := now();
  d := d - DayCounter;
  Try DatePart := FormatDateTime('dd_mm_yy', d); Except DatePart := 'dd_mm_yy'; End;
  //StringReplace has been throwing errors, so I did the following crazy stuff
  Try VersionPart := StringReplace(VersionPart, '*', '_', []); Except End;
  Try VersionPart := StringReplace(VersionPart, '*', '_', []); Except End;
  Try VersionPart := StringReplace(VersionPart, '*', '_', []); Except End;
  Try VersionPart := StringReplace(VersionPart, '*', '_', []); Except End;
  Try VersionPart := StringReplace(VersionPart, '*', '_', [rfReplaceAll]); Except End;
  Filename := 'SaveHistory' + VersionPart + '_' + DatePart + '.Txt';
end;

function TfrmMain.IsCCRUser(): Boolean;
begin
  Result := IsUserKeyInList(CCRADMINKEY + ',' + CCRUSERKEY);                    // DVBA CONTRACTED EXM SPRVSR,DVBA CONTRACTED EXM CCRUSR');
end;

function TfrmMain.IsCCRSuperVisor(): Boolean;
begin
  Result := IsUserKeyInList(CCRADMINKEY);
end;

{----------------- TfrmMain.IsAllowed2OpenExam -----------------
 This function verifies that the person attempting to open
 and edit a C&P Exam Template is authorized to do so.
 User must match the AUTHOR (#2) field, match the TRANSCRIBER (#10)
 field of the CAPRI TEMPLATES (#396.17) file, possess the
 'DVBA CPWM REVIEWER' security key or have FileMan programmer
 access ('@').
 Returns True when user is authorized; otherwise returns False.
 rpm 1/20/09

 QC 2016 - jcs - This method is now also called to ensure a user
 is authorized to delete a template.
 -------------------------------------------------------------}

function TfrmMain.IsAllowed2OpenExam(anIENS: String): Boolean;
var
  FMGetExam: TFMGets;
begin
  Result := False;
  FMGetExam := TFMGets.Create(nil);
  FMGetExam.FileNumber := '396.17';
  FMGetExam.AddField('2');
  FMGetExam.AddField('10');
  FMGetExam.RPCBroker := RPCBroker1;
  FMGetExam.IENS := anIENS;
  try
    try
      FMGetExam.GetData;
      if (Pos('@', userfilemancode) > 0) or
        (AuthorIEN = FMGetExam.GetField('2').FMDBInternal) or
        (AuthorIEN = FMGetExam.GetField('10').FMDBInternal) or
        IsUserKeyInList('DVBAB CPWM REVIEWER,DVBAB CPWM REVIE') then
        Result := True;
    except
      ShowMessageCAPRI('Failed to retrieve Author and Transcriber');
    end;
  finally
    FreeAndNil(FMGetExam);
  end;
end;

{--------------------- TfrmMain.IsLockedDate -----------------
 This function checks the DATE/TIME LOCKED (#5) field of the
 CAPRI TEMPLATES (#396.17) file for a valid lock date value.
 Returns True when valid; otherwise returns False.
 rpm 1/20/09
 --------------------------------------------------------------}

function TfrmMain.IsLockedDate(anIENS: String): Boolean;
var
  FMGetExam: TFMGets;
  DateTimeLocked: String;
begin
  Result := False;
  FMGetExam := TFMGets.Create(nil);
  FMGetExam.FileNumber := '396.17';
  FMGetExam.AddField('5');
  FMGetExam.RPCBroker := RPCBroker1;
  FMGetExam.IENS := anIENS;
  try
    try
      FMGetExam.GetData;
      DateTimeLocked := FMGetExam.GetField('5').FMDBExternal;
      if DateTimeLocked <> '' then
        if DateTimeLocked <> 'JAN 01, 1980' then
          if DateTimeLocked <> 'JAN 1, 1980' then
            if DateTimeLocked <> 'JAN 1,1980' then
              Result := True;
    except
      ShowMessageCAPRI('Failed to retrieve DATE/TIME LOCKED');
    end;
  finally
    FreeAndNil(FMGetExam);
  end;
end;

{==============================================================================
 GetDivision
 This function retrieves the division of the currently connected site.  When
 connecting through CLAIMS, retrieve the value stored in the User.Division
 property of RPCBroker; otherwise, use results of DVBAB CCOW RPC ($$SITE^VASITE).

 Input:
   aRemoteLogin: Boolean - TRUE when connected through CLAIMS; otherwise FALSE
   aRPCBroker: TCCOWRPCBrokerCAPRI - Broker that makes the RPC call

 Output:
   Site division string IEN^sitename^station# (ex. '521^BIRMINGHAM VAMC^521') on
   success; otherwise return empty string ('');

 rpm 5/12/09
 rpm 8/19/09 modified to add aRPCBroker param to support FHIE BSE connection
 ==============================================================================}

function TfrmMain.GetDivision(aRemoteLogin: Boolean;
  aRPCBroker: TCCOWRPCBrokerCAPRI): String;
begin
  Result := '';

  if aRemoteLogin then                                                          //Remote login (CLAIMS)
    Result := aRPCBroker.User.Division
  else                                                                          //Local login
  begin
    aRPCBroker.RemoteProcedure := 'DVBAB CCOW';
    aRPCBroker.Param[0].Value := '1';                                           //get $$SITE^VASITE value
    aRPCBroker.Param[0].PType := literal;
    RPCBrokerCall;
    try
      aRPCBroker.Call;
    except
      on EBrokerError do
      begin
        ANURemoteProcedureCallInProgress := False;
        AnimateLogo(False);
        StatusBarLoadPt.Caption := 'DVBAB CCOW could not be accessed!';
        StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('DVBAB CCOW could not be accessed!');
        Exit;
      end;
    end;
    if aRPCBroker.Results.Count > 0 Then
      Result := aRPCBroker.Results[0];
  end;
end;

{==============================================================================
 GetCountryName
 Input: aCountryIEN: String - Required pointer to COUNTRY CODE (#779.004) file.
 Output: Returns POSTAL NAME (#1.3) field or DESCRIPTION (#2) field
         if Postal Name is '<NULL>' on success; otherwise returns
         empty string ('').
 rpm 9/21/09
 ==============================================================================}

function TfrmMain.GetCountryName(aCountryIEN: String): String;
var
  aFieldVal: String;
begin
  Result := '';
  if aCountryIEN <> '' then
  begin
    FMGetsCountry.IENS := aCountryIEN;
    try
      FMGetsCountry.GetData;
      if FMGetsCountry.Results.Count > 0 then
      begin
        aFieldVal := FMGetsCountry.GetField('1.3').FMDBExternal;
        if aFieldVal = '<NULL>' then
          aFieldVal := FMGetsCountry.GetField('2').FMDBExternal;
        Result := aFieldVal;
      end;
    except on E: Exception do
        ShowMessageCapri('CAPRI failed to get Country name: ' + E.Message);
    end;
  end;
end;


function TfrmMain.GetCurrentPatientInfo: TPatientInfoBucket;
var
  tbool: Boolean;
begin
  if FPatientInfoBucket = nil then
    if PatientSSN > '' then                                                     // CodeCR701 rpk 2/3/2015
    try
//        FPatientInfoBucket := TPatientInfoBucket.Create(PatientSSN)             // rpk 7/15/2014
      tbool := TPatientInfoBucket.CreatePatientInfoBucket(PatientSSN, FPatientInfoBucket); // CodeCR701 rpk 2/9/2015
    except                                                                      // CodeCR701 rpk 2/9/2015
      FPatientInfoBucket := nil;                                                // CodeCR701 rpk 2/9/2015
    end;                                                                        // CodeCR701 rpk 2/9/2015

  Result := FPatientInfoBucket;
end;

{==============================================================================
 GetVersionUser
 This function builds the VersionUser variable from the FileVersionInfo defined
 using the Project Options FileVersion property.
   Input:  None
  Output:  Returns version information as string (ex. 'DVBA*2.7*149.01') on
           success; otherwise returns 'DVBA*2.7*xxx.xx'
 rpm 2/4/10
 ==============================================================================}

function TfrmMain.GetVersionUser: String;
var
  Build, Version: String;
begin
  Version := GetVersionInfo(FileVersion);
  if Version <> '' then
  begin
    Result := 'DVBA*';
    Result := Result + piece(Version, '.', 1);                                  //Major version
    Result := Result + '.' + piece(Version, '.', 2);                            //Minor version
    Result := Result + '*' + piece(Version, '.', 3);                            //Release
    Build := piece(Version, '.', 4);                                            //Build
    if Length(Build) < 2 then
      Build := '0' + Build;
    Result := Result + '.' + Build;
  end
  else
    Result := 'DVBA*2.7*xxx.xx';
end;

{==============================================================================
  CCOWIconSetup
    CCOWIconSetup is a method that sets some button visibility

  Modification History:
    CodeCR124 7/2010 Method refactored out of actFileSelectPatientExecute -MER
 ==============================================================================}

procedure TfrmMain.CCOWIconSetup;
begin
  if (CCOWMode = True) and (bitbtnCCOWLinkBroken.Visible = False) then begin
    if CCOWSuspended <> true then
    begin
      bitbtnCCOWLink.Visible := True;
      BitBtnCCOWLinkBroken.Visible := False;
      BitBtnCCOWLinkChanging.Visible := false;
    end else begin
      bitbtnCCOWLink.Visible := False;
      BitBtnCCOWLinkBroken.Visible := True;
      BitBtnCCOWLinkChanging.Visible := False;
    end;
  end;
end;

{==============================================================================
  UpdateAuditOnHomeServer
    UpdateAuditOnHomeServer is a method that updates the audit trail.  It then
    reconnects to the original server.

  Modification History:
    CodeCR124 7/2010 Method refactored out of actFileSelectPatientExecute -MER
 ==============================================================================}

procedure TfrmMain.UpdateAuditOnHomeServer;
var
  tempstrserver, tempstrport: string;
  dttm: string;
  zUserDivision: string;
begin
  if (ESSOVersion = true) then begin
    TempStrServer := Uppercase(RPCBroker1.ANUStrServer);
    TempStrPort := RPCBroker1.ANUStrPort;
    AuditInProgress := True;
    RPCBroker1.Connected := False;
    RPCBroker1.Server := RPCBroker1.ANUStrServerHome;
    RPCBroker1.ListenerPort := StrtoInt(RPCBroker1.ANUStrPortHome);
    if not ConnectToServer('DVBA CAPRI GUI') then begin
      ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
      application.terminate;
    end;
    //Do update here...
    FMValidator1.Setup('395.98', '+1,', '5', 'NOW');
    if Not frmMain.FMValidator1.Validate then begin
      FMValidator1.DisplayErrors;
      ShowMessageCAPRI('There was an error creating an audit trail.  CAPRI will now close.');
      application.terminate;
    end;                                                                        {file}
    dttm := fmvalidator1.Results[0];

    zUserDivision := Copy(UserDivision, 1, 30);                                 // Limit to 30 chars

    if Patientname = '' then
      patientName := 'UNKNOWN';

    FMValidator1.Setup('395.98', '+1,', '4', RemoteSiteName);
    //FMValidatr1.Setup('395.98','+1,','4.5',RemoteSiteNamePointer);
    FMValidator1.Setup('395.98', '+1,', '.01', '`' + UserDUZHomeServer);
    FMValidator1.Setup('395.98', '+1,', '1', PatientName);
    FMValidator1.Setup('395.98', '+1,', '3', PatientSSN);
    FMValidator1.Setup('395.98', '+1,', '2', PatientICN);
    FMValidator1.Setup('395.98', '+1,', '6', PatientSensitive);
    FMValidator1.Setup('395.98', '+1,', '7', PatientClaimNumber);
    FMValidator1.Setup('395.98', '+1,', '8', zUserDivision);
    if not frmMain.FMValidator1.Validate then begin
      FMValidator1.DisplayErrors;
      ShowMessageCAPRI('There was an error creating an audit trail.  CAPRI will now close.');
      application.terminate;
    end;

    fmfiler2.AddFDA('395.98', '+1,', '.01', UserDUZHomeServer);
    fmfiler2.AddFDA('395.98', '+1,', '4', RemoteSiteName);
    //fmfiler2.AddFDA('395.98','+1,','4.5',RemoteSiteNamePointer);
    fmfiler2.AddFDA('395.98', '+1,', '5', dttm);
    fmfiler2.AddFDA('395.98', '+1,', '1', PatientName);
    fmfiler2.AddFDA('395.98', '+1,', '3', PatientSSN);
    fmfiler2.AddFDA('395.98', '+1,', '2', PatientICN);
    fmfiler2.AddFDA('395.98', '+1,', '6', PatientSensitive);
    fmfiler2.AddFDA('395.98', '+1,', '7', PatientClaimNumber);
    fmfiler2.AddFDA('395.98', '+1,', '8', zUserDivision);
    if Not fmfiler2.Update then begin
      fmfiler2.DisplayErrors;
      ShowMessageCAPRI('There was an error creating an audit trail.  CAPRI will now close.');
      application.terminate;
    end;

    //Connect back to remote here
    RPCBroker1.Connected := False;
    RPCBroker1.Server := TempStrServer;
    RPCBroker1.ListenerPort := StrToInt(TempStrPort);
    //RPCBroker1.Connected := True;   BSE mod - rpm 1/8/09
    AuditInProgress := False;
    //if not AuthorizedOption('DVBA CAPRI GUI') then   BSE mod - rpm 1/8/09
    if not ConnectToServer('DVBA CAPRI GUI') then begin
      ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
      application.terminate;
    end;
  end;
end;                                                                            // UpdateAuditOnHomeServer

{==============================================================================
  ShowPatientList
    ShowPatientList is a method that will show a patient lookup form.  This
    method was refactored out of actFileSelectPatientExecute to add the
    capability to filter on the patient lookup form.

  Parameters:
    Sender:
      Sender is a TObject used to help identify from where this method was called
    PatientFilterType:
      TPatientFilterType is an enumerated type that represents Normal (no filtering),
      Fee Basis or DOD only.  It is used to specify what type of filtering should
      be employed by frmPatientList

  Modification History:
    7/2010 Method created -MER
 ==============================================================================}

procedure TfrmMain.ShowPatientList(Sender: TObject; PatientFilterType: TPatientFilterType);
var
  lastIEN: String;
  data: IContextItemCollection;
  dataItem1, dataItem2, dataitem3: IContextItem;
  response: UserResponse;
  inWidth, inHeight: integer;
  minwidth, minheight: integer;
  isshowing: boolean;
  x, y: integer;
  foundflag: boolean;
  tempstrserver: String;
  tempstrport: String;
  tempstring: String;
Begin
  inHeight := 50;
  inWidth := 50;
  isshowing := False;
  minheight := 50;
  minwidth := 50;
  If Assigned(formTIUDisplay) Then
  Begin
    formTIUDisplay.Visible := False;
    formTIUDisplay.Release;
    formTIUDisplay := Nil;
  End;

  If Assigned(frmSplashScreen) Then
  Begin
    frmSplashScreen.Hide;
    frmSplashScreen.release;
    frmSplashScreen := Nil;
  End;

  If ANURemoteProcedureCallInProgress = True Then
    exit;

  DimMenuOptions;                                                               // everything is commented out in this method
  If essoversion = true Then
    If SwitchToPatientSSN = '' Then
    Begin
      // Make sure user can be on current site before selecting a new
      // patient
      // But don't execute this if something is in SwitchToPatientSSN
      // because the patient will be forced.
      foundflag := false;
      If formESSOSelect = Nil Then
      Begin
        formESSOSelect := TformESSOSelect.Create(frmMain);
        HomeServer := RPCBroker1.Server;
        HomePort := InttoStr(RPCBroker1.ListenerPort);
      End;
      If formESSOSelect.slUserSites.Count > 0 Then                              //CodeCR77
        For x := 0 To formESSOSelect.slUserSites.Count - 1 Do
          If uppercase(piece(formESSOSelect.slUserSites[x], '^', 2)) = uppercase(RPCBroker1.Server) Then
            foundflag := true;
      If foundflag <> true Then
      Begin
        ShowmessageCAPRI('You do not have direct access to this site.  Please use FILE | SWITCH SITES and pick a different site prior to selecting a patient.');
        RestoreMenuOptions;
        exit;
      End;
    End;
  If frmMain.RPCBroker1.Connected = False Then
  Begin
    //frmMain.button3click(application);
    RestoreMenuOptions;
    exit;
  End;
  lastIEN := PatientIEN;
  // Check if user has restricted list, if so, user other window.
  If EssoVersion = True Then
    If (UserHasNewStyleRestrictedList = -1) Then
    Begin
      //// connect to claims server
      timeouttimer.enabled := false;
      ESSOConnecting := True;
      //Store connection data
      TempStrServer := RPCBroker1.Server;
      TempStrPort := IntToStr(RPCBroker1.ListenerPort);
      RPCBroker1.Connected := False;
      RPCBroker1.Server := homeserver;
      RPCBroker1.ListenerPort := StrToInt(homeport);
      //RPCBroker1.Connected := True;  BSE mod - rpm 1/8/09
      If Not ConnectToServer('DVBA CAPRI GUI') Then
      Begin
        ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
        application.terminate;
      End;
      If RPCBroker1.Connected = False Then
      Begin
        ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
        application.terminate;
      End;
      ESSOConnecting := False;
      /// end of connect to claims server

      //retrieve list of restricted patients for CAPRI when in remote mode
      ListBoxRestrictedPatients.Items.Clear;
      frmMain.RPCBroker1.Results.Clear;
      RPCBroker1.RemoteProcedure := 'DVBAB RESTRICTED LIST PATIENTS';
      RPCBroker1.Param[0].Value := UserDUZHomeServer;
      RPCBroker1.Param[0].PType := literal;
      RPCBrokerCall;
      Try
        RPCBroker1.Call;
      Except
        On EBrokerError Do
        Begin
          //if user's restricted patient list can't be accessed on Claims system, instruct user to contact HIA office for
          //assistance and shut down application to prevent user from accessing unauthorized patient records - kcl 2/5/09
          ANURemoteProcedureCallInProgress := False;
          AnimateLogo(False);
          StatusBarLoadPt.Caption := 'Restricted patient list could not be accessed!';
          StatusBarLoadPt.Repaint;
          Application.Processmessages;
          ShowMessageCAPRI('WARNING: Unable to access the user''s restricted patient list!'
            + #13#10 + #13#10
            + 'The CAPRI application will be shut down to prevent access of unauthorized records.'
            + #13#10
            + 'Please contact the VHA Health Information Access Office for assistance (Email: HIA@domain).');
          Application.Terminate;
        End;
      End;

      If rpcbroker1.results.count = 0 Then
        UserHasNewStyleRestrictedList := 0;
      If rpcbroker1.results.count > 0 Then
        UserHasNewStyleRestrictedList := 1;
      If RPCBroker1.Results.Count > 0 Then
        QuickCopy(frmMain.RPCBroker1.Results, listBoxRestrictedPatients);

      // connect back to remote server
      ContextorChangeMessage := '';
      CCOWBreakLink := False;
      ESSOConnecting := True;
      //Reconnect to original host
      RPCBroker1.Connected := False;
      RPCBroker1.Server := TempStrServer;
      RPCBroker1.ListenerPort := StrToInt(TempStrPort);
      //RPCBroker1.Connected := True;  BSE mod - rpm 1/8/09
      If Not ConnectToServer('DVBA CAPRI GUI') Then
      Begin
        ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
        application.terminate;
      End;
      If RPCBroker1.Connected = False Then
      Begin
        ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
        application.terminate;
      End;
      ESSOConnecting := False;
      timeouttimer.enabled := true;
      // done with connect
    End;
  frmPatientList := TfrmPatientList.Create(frmMain);
  frmPatientList.PatientFilterType := PatientFilterType;                        //CodeCR124 -MER 07/2010
  if (PatientFilterType = pfDod) then                                           //CodeCR131 rpm 12/8/10
    frmPatientList.BHIEInstitutionIEN := GetBHIEInstitutionIEN;
  frmPatientListRestricted := TfrmPatientListRestricted.Create(frmMain);

  //frmPatientList.Show;
  // Set up for font
  frmPatientList.FMCvrNamePt.Font := Panel1.Font;
  frmPatientList.LabelCvrSSN.font := Panel1.Font;
  frmPatientList.FMCvrSSNPt.font := Panel1.Font;
  frmPatientList.FMCvrSexPt.font := Panel1.Font;
  frmPatientList.FMCvrAgePt.font := Panel1.Font;
  frmPatientList.FMCvrRoomBedPt.font := Panel1.Font;
  frmPatientList.FMCvrBirthdatePt.font := Panel1.Font;
  frmPatientList.FMCvrWardPt.font := Panel1.Font;
  frmPatientList.LabelCvrCNumberPt.font := Panel1.Font;
  frmPatientList.FMCvrCNumberPt.font := Panel1.Font;
  frmPatientList.LabelCvrICNPt.font := Panel1.Font;
  frmPatientList.LabelCvrWard.font := Panel1.Font;
  frmPatientList.FMCvrICNPt.font := Panel1.Font;

  frmPatientList.GroupBoxCvr1Pt.Font := Panel1.Font;
  frmPatientList.ScrollBox1.Top := Panel1.Height;
  //frmPatientList.FMCvrNamePt.top:=Panel1.Height div 2;
  frmPatientList.LabelCvrSSN.top := frmPatientList.FMCvrNamePt.top + frmPatientList.FMCvrNamePt.height;
  frmPatientList.FMCvrSSNPt.top := frmPatientList.FMCvrNamePt.top + frmPatientList.FMCvrNamePt.height;
  frmPatientList.FMCvrSexPt.top := frmPatientList.LabelCvrSSN.top + frmPatientList.LabelCvrSSN.height;
  frmPatientList.FMCvrAgePt.top := frmPatientList.FMCvrSexPt.top + frmPatientList.FMCvrSexPt.height;
  frmPatientList.FMCvrBirthdatePt.top := frmPatientList.FMCvrAgePt.top + frmPatientList.FMCvrAgePt.height;
  frmPatientList.LabelCvrWard.top := frmPatientList.FMCvrBirthdatePt.top + frmPatientList.FMCvrBirthdatePt.height;
  frmPatientList.FMCvrWardPt.top := frmPatientList.FMCvrBirthdatePt.top + frmPatientList.FMCvrBirthdatePt.height;
  frmPatientList.FMCvrRoomBedPt.top := frmPatientList.FMCvrBirthdatePt.top + frmPatientList.FMCvrBirthdatePt.height;
  frmPatientList.LabelCvrCNumberPt.top := frmPatientList.FMCvrWardPt.top + frmPatientList.FMCvrWardPt.height;
  frmPatientList.FMCvrCNumberPt.top := frmPatientList.FMCvrWardPt.top + frmPatientList.FMCvrWardPt.height;
  frmPatientList.LabelCvrICNPt.top := frmPatientList.FMCvrCNumberPt.top + frmPatientList.FMCvrCNumberPt.height;
  frmPatientList.FMCvrICNPt.top := frmPatientList.FMCvrCNumberPt.top + frmPatientList.FMCvrCNumberPt.height;

  frmPatientList.font := Panel1.Font;
  frmPatientList.btnCvrMorePt.height := Panel1.Height;
  frmPatientList.btnCvrMorePt.top := frmPatientList.Height - frmPatientList.btnCvrMorePt.Height - 33;
  frmPatientList.btnCvrDemographicsPt.Top := frmPatientList.btnCvrMorePt.Top;
  frmPatientList.btnCvrDemographicsPt.Height := frmPatientList.btnCvrMorePt.height;
  frmPatientList.btnCvrCancelPt.height := Panel1.Height;
  frmPatientList.btnCvrCancelPt.Top := frmPatientList.Height - frmPatientList.btnCvrCancelPt.Height - 33;

  frmPatientList.btnSearch.height := Panel1.Height;
  frmPatientList.btnSearch.Top := frmPatientList.Height - frmPatientList.btnCvrCancelPt.Height - 33;

  frmPatientList.btnCvrSelectPt.height := Panel1.Height;
  frmPatientList.btnCvrSelectPt.top := frmPatientList.Height - frmPatientList.btnCvrSelectPt.Height - 33;
  frmPatientList.btnCvrEnterNewPt.height := Panel1.Height;
  frmPatientList.btnCvrEnterNewPt.Top := frmPatientList.btnCvrSelectPt.Top - frmPatientList.btnCvrEnterNewPt.Height + 1;
  frmPatientList.btnSearch.height := Panel1.Height;
  frmPatientList.btnSearch.Top := frmPatientList.Height - frmPatientList.btnCvrCancelPt.Height - 33;
  frmPatientList.buttonedit.height := Panel1.Height;
  frmPatientList.buttonedit.Top := frmPatientList.btnCvrSelectPt.Top - frmPatientList.buttonedit.Height + 1;
  frmPatientList.FMCvrListBox1Pt.top := frmPatientList.Patient_ID.Top + frmPatientList.Patient_ID.Height + 4;
  frmPatientList.FMCvrListBox2Pt.top := frmPatientList.Patient_ID.Top + frmPatientList.Patient_ID.Height + 4;
  frmPatientList.FMCvrListBox3Pt.top := frmPatientList.Patient_ID.Top + frmPatientList.Patient_ID.Height + 4;
  frmPatientList.FMCvrListBox1Pt.height := frmPatientList.Height - frmPatientList.btnCvrMorePt.Height - 33 - frmPatientList.FMCvrListBox1Pt.top;
  frmPatientList.FMCvrListBox2Pt.height := frmPatientList.Height - frmPatientList.btnCvrMorePt.Height - 33 - frmPatientList.FMCvrListBox2Pt.top;
  frmPatientList.FMCvrListBox3Pt.height := frmPatientList.Height - frmPatientList.btnCvrMorePt.Height - 33 - frmPatientList.FMCvrListBox3Pt.top;
  frmPatientList.btnCvrTimerPt.Interval := frmProperties.ScrollBarKeyboardSensitivity.Position;
  frmPatientList.buttonOtherSites.Top := frmPatientList.groupBoxCVR1Pt.Top + frmPatientList.groupBoxCVR1Pt.Height + 4;
  // Set up for font
  frmPatientListRestricted.FMCvrNamePt.Font := Panel1.Font;
  frmPatientListRestricted.LabelCvrSSN.font := Panel1.Font;
  frmPatientListRestricted.FMCvrSSNPt.font := Panel1.Font;
  frmPatientListRestricted.FMCvrSexPt.font := Panel1.Font;
  frmPatientListRestricted.FMCvrAgePt.font := Panel1.Font;
  frmPatientListRestricted.FMCvrRoomBedPt.font := Panel1.Font;
  frmPatientListRestricted.FMCvrBirthdatePt.font := Panel1.Font;
  frmPatientListRestricted.FMCvrWardPt.font := Panel1.Font;
  frmPatientListRestricted.LabelCvrCNumberPt.font := Panel1.Font;
  frmPatientListRestricted.FMCvrCNumberPt.font := Panel1.Font;
  frmPatientListRestricted.LabelCvrICNPt.font := Panel1.Font;
  frmPatientListRestricted.LabelCvrWard.font := Panel1.Font;
  frmPatientListRestricted.FMCvrICNPt.font := Panel1.Font;

  frmPatientListRestricted.GroupBoxCvr1Pt.Font := Panel1.Font;
  frmPatientListRestricted.ScrollBox1.Top := Panel1.Height;
  //frmPatientListRestricted.FMCvrNamePt.top:=Panel1.Height div 2;
  frmPatientListRestricted.LabelCvrSSN.top := frmPatientListRestricted.FMCvrNamePt.top + frmPatientListRestricted.FMCvrNamePt.height;
  frmPatientListRestricted.FMCvrSSNPt.top := frmPatientListRestricted.FMCvrNamePt.top + frmPatientListRestricted.FMCvrNamePt.height;
  frmPatientListRestricted.FMCvrSexPt.top := frmPatientListRestricted.LabelCvrSSN.top + frmPatientListRestricted.LabelCvrSSN.height;
  frmPatientListRestricted.FMCvrAgePt.top := frmPatientListRestricted.FMCvrSexPt.top + frmPatientListRestricted.FMCvrSexPt.height;
  frmPatientListRestricted.FMCvrBirthdatePt.top := frmPatientListRestricted.FMCvrAgePt.top + frmPatientListRestricted.FMCvrAgePt.height;
  frmPatientListRestricted.LabelCvrWard.top := frmPatientListRestricted.FMCvrBirthdatePt.top + frmPatientListRestricted.FMCvrBirthdatePt.height;
  frmPatientListRestricted.FMCvrWardPt.top := frmPatientListRestricted.FMCvrBirthdatePt.top + frmPatientListRestricted.FMCvrBirthdatePt.height;
  frmPatientListRestricted.FMCvrRoomBedPt.top := frmPatientListRestricted.FMCvrBirthdatePt.top + frmPatientListRestricted.FMCvrBirthdatePt.height;
  frmPatientListRestricted.LabelCvrCNumberPt.top := frmPatientListRestricted.FMCvrWardPt.top + frmPatientListRestricted.FMCvrWardPt.height;
  frmPatientListRestricted.FMCvrCNumberPt.top := frmPatientListRestricted.FMCvrWardPt.top + frmPatientListRestricted.FMCvrWardPt.height;
  frmPatientListRestricted.LabelCvrICNPt.top := frmPatientListRestricted.FMCvrCNumberPt.top + frmPatientListRestricted.FMCvrCNumberPt.height;
  frmPatientListRestricted.FMCvrICNPt.top := frmPatientListRestricted.FMCvrCNumberPt.top + frmPatientListRestricted.FMCvrCNumberPt.height;

  frmPatientListRestricted.font := Panel1.Font;
  frmPatientListRestricted.btnCvrCancelPt.height := Panel1.Height;
  frmPatientListRestricted.btnCvrCancelPt.Top := frmPatientListRestricted.Height - frmPatientListRestricted.btnCvrCancelPt.Height - 33 - 4;
  frmPatientListRestricted.btnCvrSelectPt.height := Panel1.Height;
  frmPatientListRestricted.btnCvrSelectPt.top := frmPatientListRestricted.Height - frmPatientListRestricted.btnCvrSelectPt.Height - 33 - 4;
  frmPatientListRestricted.ORListBox1.top := frmPatientListRestricted.ComboBoxListNames.Top + frmPatientListRestricted.ComboBoxListNames.Height + 4;
  frmPatientListRestricted.ORListBox1.height := frmPatientListRestricted.Height - 33 - frmPatientListRestricted.ORListBox1.top - 4;
  frmPatientListRestricted.buttonOtherSites.Top := frmPatientListRestricted.groupBoxCVR1Pt.Top + frmPatientListRestricted.groupBoxCVR1Pt.Height + 4;
  frmPatientListRestricted.btnSearch.height := Panel1.Height;
  frmPatientListRestricted.btnSearch.Top := frmPatientListRestricted.Height - frmPatientListRestricted.btnCvrCancelPt.Height - 33 - 4;

  // ListRestrictedPatients.Count=0 then
  //   frmPatientList.Height:=288 else
  //   frmPatientList.Height:=386;

  // This code dealing with FormReportBuilder is here because it has to do with
  // preventing CAPRI from coming to the front when a patient is changed using
  // CCOW
  If FormReportBuilder <> Nil Then
  Try
    inWidth := formReportBuilder.width;
    inHeight := formReportBuilder.height;
    minwidth := formReportBuilder.constraints.minwidth;
    minheight := formReportBuilder.constraints.minheight;
    formReportBuilder.constraints.minwidth := 0;
    formReportBuilder.constraints.minheight := 0;
    formReportBuilder.width := 0;
    formReportBuilder.height := 0;
    isshowing := formReportBuilder.visible;
    formreportbuilder.borderStyle := bsNone;
    formreportbuilder.visible := true;
  Except
  End;
  StatusBarLoadPt.Caption := 'Ready.';

  If ((UserHasNewStyleRestrictedList = 1) And (sender <> contextorControl) And (sender <> frmPatientListRestricted.ButtonOtherSites)) Then
  Begin
    frmPatientListRestricted.ComboBoxListNames.Clear;
    frmPatientListRestricted.ComboBoxListNames.Items.Add('Personal List');
    For x := 0 To ListBoxRestrictedPatients.Items.Count - 1 Do
    Begin
      tempString := piece(ListBoxRestrictedPatients.Items[x], '^', 1);
      foundflag := false;
      If tempstring <> '' Then
      Begin
        For y := 0 To frmPatientListRestricted.ComboBoxListNames.Items.Count - 1 Do
          If frmPatientListRestricted.ComboBoxListNames.Items[y] = tempstring Then
            foundflag := true;
        If foundflag = false Then
          frmPatientListRestricted.ComboBoxListNames.Items.Add(tempString);
      End;
    End;
    frmPatientListRestricted.ComboBoxListNames.ItemIndex := 0;
    frmPatientListRestricted.ComboBoxListNamesChange(Application);
    frmPatientListRestricted.Show;
    frmPatientListRestricted.BringToFront;
    frmPatientListRestricted.Hide;
  End
  Else
  Begin
    If (sender <> contextorControl) And (sender <> actFileSwitchSites) Then
    Begin
      frmPatientList.Show;
      frmPatientList.BringToFront;
      frmPatientList.Hide;
    End;
  End;
  //showmessage(sender.classname);
  If (((UserHasNewStyleRestrictedList < 1) Or (sender = contextorControl) Or (sender = actFileSwitchSites)) And (UserHasNewStyleRestrictedList < 1)) Then
  Begin
    frmPatientList.BringToFront;
    frmPatientList.Visible := True;
    frmPatientList.Visible := False;
    frmPatientList.ShowModal
  End
  Else
  Begin
    frmPatientListRestricted.BringToFront;
    frmPatientListRestricted.Visible := True;
    frmPatientListRestricted.Visible := False;
    frmPatientListRestricted.ShowModal;
  End;
  frmMain.btnVistAWebHomeClick(application);

  CCOWIconSetup;
  ContextorChangeMessage := 'The application is changing patients.  If you continue, CAPRI may drop out of the clinical context.';
  CCOWBreakLink := True;
  If FormReportBuilder <> Nil Then
  Try
    formReportBuilder.visible := isshowing;
    formreportbuilder.borderStyle := bsSizeable;
    formReportBuilder.constraints.minwidth := minheight;
    formReportBuilder.constraints.minheight := minwidth;
    formReportBuilder.width := inWidth;
    formReportBuilder.height := inHeight;
  Except
  End;
  (*
      If ((CCOWMode=True) and (ESSOVersion=False)) then
        If CCOWInitialized=False then begin
          frmmain.active:=false;
        end;
  *)
      // Another site was selected

  If SwitchToSite <> '' Then
  Begin
    animatelogo(false);
    frmPatientList.release;
    frmPatientList := Nil;
    frmPatientListRestricted.release;
    frmPatientListRestricted := Nil;

    actFileConnectExecute(actFileSwitchSites);

    CCOWIconSetup;
    ContextorChangeMessage := '';
    CCOWBreakLink := False;
    RestoreMenuOptions;
    Exit;
  End;
  // Patient is changing.  Send CCOW message here

  // Get rid of last report builder form
  // for CCOW compatibility issues with frmMain coming to front during
  // a patient context change
  If FormReportBuilder <> Nil Then
  Try
    formReportBuilder.release;
    formReportBuilder := Nil;
  Except
  End;
  If (PatientIEN <> '') And (PatientIEN <> lastIEN) And (PatientIEN <> '-1') Then
  Begin
    If ESSOVersion = True Then
    Begin
      If ((UserHasNewStyleRestrictedList < 1) Or (sender = contextorControl) Or (sender = actFileSwitchSites)) Then
      Begin
        If frmPatientList.ButtonOtherSites.Enabled = True Then
          ButtonOtherSites.Enabled := True
      End
      Else
      Begin
        If frmPatientListRestricted.ButtonOtherSites.Enabled = True Then
          ButtonOtherSites.Enabled := True
      End;
    End;

    If frmMain.bitbtnCCOWLinkBroken.Visible = False Then
      If CCOWMode = True Then
        If CCOWInitialized = True Then
        Try
          Begin
            ContextorControl.StartContextChange;
            data := CoContextItemCollection.Create;
            dataItem1 := CoContextItem.Create;
            dataItem1.Name := 'Patient.ID.MRN.DFN_' + LocalStationNumber;       // can also use Set_Name
            dataItem1.Value := PatientIEN;                                      // can also use Set_Value
            data.Add(dataItem1);
            dataItem2 := CoContextItem.Create;
            dataItem2.Set_Name('Patient.co.PatientName');
            If ((UserHasNewStyleRestrictedList < 1) Or (sender = contextorControl) Or (sender = actFileSwitchSites)) Then
              dataItem2.Set_Value(frmPatientList.FMCvrNamePt.Caption)
            Else
              dataItem2.Set_Value(frmPatientListRestricted.FMCvrNamePt.Caption);
            data.Add(dataItem2);
            dataItem3 := CoContextItem.Create;
            dataItem3.Set_Name('Patient.ID.MRN.NationalIDNumber');
            If ((UserHasNewStyleRestrictedList < 1) Or (sender = contextorControl) Or (sender = actFileSwitchSites)) Then
              dataItem3.Set_Value(frmPatientList.FMCvrICNPt.Caption)
            Else
              dataItem3.Set_Value(frmPatientListRestricted.FMCvrICNPt.Caption);
            data.Add(dataItem3);
            response := ContextorControl.EndContextChange(true, data);
            If (UrCommit = response) Then
            Begin
                // New context has been committed. This app should change its state to
                // the new context it initiated.
                // ->>>>>>UpdateContextDisplay;
                //ShowMessageCAPRI('Response was Commit');
            End
            Else
              If (UrCancel = response) Then
              Begin
                  // Proposed context change is canceled. Return to the current context.
                  // ->>>>>>UpdateContextDisplay;
                  //ShowMessageCAPRI('Response was Cancel');
                PatientIEN := LastIEN;
                CCOWIconSetup;
                ContextorChangeMessage := '';
                CCOWBreakLink := False;
                RestoreMenuOptions;
                Exit;
              End
              Else
                If (UrBreak = response) Then
                Begin
                    // update the Clinical Link icon, enable the Resume menu item, and
                    // disable the Suspend menu item.
                    // It will not be notified of any context changes until it resumes participation.
                    //ShowMessageCAPRI('Response was Break');

                    // This app should show the selected state, which will be different than
                    // that displayed by other CCOW apps participating in the common context
                    // (until it resumes participation).
                    (*
                    listView.Items.Clear;

                    listItem := listView.Items.Add;
                    listItem.Caption := dataItem1.Name;
                    listItem.SubItems.Add(dataItem1.Value);

                    listItem := listView.Items.Add;
                    listItem.Caption := dataItem2.Name;
                    listItem.SubItems.Add(dataItem2.Value);
                    *)
                End
                Else
                Begin
                    // Unexpected response received
                  ShowMessageCAPRI('Unexpected Response for EndContextChange: ' + IntToStr(response));
                End;
        End Except
          ShowMessageCAPRI('There was a CCOW error setting patient context.');
        End;

    If formReportBuilder <> Nil Then
      If formReportBuilder.ORListBoxItems.Items.Count > 0 Then
        formReportBuilder.ORbtnClearClick(Application);
    If formReportBuilder <> Nil Then
      formReportBuilder.Visible := False;

    Panel1.Caption := 'Setting Up Patient';
    labelICN.Caption := '';
    labelDOB.Caption := '';
    BitBtnVistA.enabled := False;
    //ChangeVerifyCode1.enabled:=False;
    //ShowMessageCAPRI('2');
    //ShowMessageCAPRI('2');
    //ShowMessageCAPRI('2');
//    remoteconnectionsx := CheckRemoteConnections1.Visible;
//    CheckRemoteConnections1.Visible := False;
//    actToolsSearch.Visible := False;
//    // RPCBrokerCallHistoryBuffer1.Visible:=False;
//    N8.Visible := False;
//    EditRemoteUserSiteAccess1.Visible := False;
//    EditPatientLists1.Visible := False;
//    ConsolidatedReports1.Visible := False;
//    actHelpAuditUtil.Visible := False;
    ProgressBarLoadPt.Visible := True;
    ProgressBarLoadPt.Max := 8;
    ProgressBarLoadPt.Position := 1;
    ProgressBarLoadPt.Repaint;
    frmMain.Repaint;
    AnimateLogo(True);
    StatusBarLoadPt.Caption := 'Set variables.';
    ProgressBarLoadPt.Repaint;
    frmMain.Repaint;
    If ((UserHasNewStyleRestrictedList < 1) Or (sender = contextorControl) Or (sender = actFileSwitchSites)) Then
      RemoteDataPtID := frmPatientList.FMCvrICNPt.Caption
    Else
      RemoteDataPtID := frmPatientListRestricted.FMCvrICNPt.Caption;
    Page95Control1.Enabled := False;
    frmLabGraph.memoLabcomments.Lines.Clear;
    frmLabGraph.ChartLab.Series[0].Clear;
    frmLabGraph.ChartLab.Series[1].Clear;
    frmLabGraph.ChartLab.Series[2].Clear;
    frmLabGraph.ChartLab.Title.Text.Clear;
    frmLabGraph.ChartLab.SeriesList[0].Title := ' ';
    MemoDocs.Lines.Clear;
    EditSearchPN.Text := '';
    VistAWebLoaded := False;
    (* //Start Deletion 200806101107
    if ((UserHasNewStyleRestrictedList < 1) or (sender = contextorControl) or (sender = SwitchSites1)) then begin
      patientname := frmPatientList.fmCvrNamePt.caption;
      PatientSSN := frmPatientList.fmCvrSSNPt.caption;
      PatientICN := frmPatientList.fmCvrICNPt.caption;
      PatientClaimNumber := frmPatientList.fmCvrCnumberPt.caption;
      Cnumber.Caption := frmPatientList.fmCvrCnumberPt.caption;
    end
    else begin
      patientname := frmPatientListRestricted.fmCvrNamePt.caption;
      PatientSSN := frmPatientListRestricted.fmCvrSSNPt.caption;
      PatientICN := frmPatientListRestricted.fmCvrICNPt.caption;
      PatientClaimNumber := frmPatientListRestricted.fmCvrCnumberPt.caption;
      Cnumber.Caption := frmPatientListRestricted.fmCvrCnumberPt.caption;
    end;
    //End Deletion 200806101107
    *)

    //Start Addition 200806101108
    If ((UserHasNewStyleRestrictedList < 1) Or (sender = contextorControl) Or (sender = actFileSwitchSites)) Then
    Begin
      If UserHasNewStyleRestrictedList = 1 Then
      Begin
        patientname := frmPatientListRestricted.fmCvrNamePt.caption;
        PatientSSN := frmPatientListRestricted.fmCvrSSNPt.caption;
        PatientICN := frmPatientListRestricted.fmCvrICNPt.caption;
        PatientClaimNumber := frmPatientListRestricted.fmCvrCnumberPt.caption;
        Cnumber.Caption := frmPatientListRestricted.fmCvrCnumberPt.caption;

//        SelectedPatient.IEN := frmPatientListRestricted.
      End
      Else
      Begin
        patientname := frmPatientList.fmCvrNamePt.caption;
        PatientSSN := frmPatientList.fmCvrSSNPt.caption;
        PatientICN := frmPatientList.fmCvrICNPt.caption;
        PatientClaimNumber := frmPatientList.fmCvrCnumberPt.caption;
        Cnumber.Caption := frmPatientList.fmCvrCnumberPt.caption;
      End;
    End
    Else
    Begin
      patientname := frmPatientListRestricted.fmCvrNamePt.caption;
      PatientSSN := frmPatientListRestricted.fmCvrSSNPt.caption;
      PatientICN := frmPatientListRestricted.fmCvrICNPt.caption;
      PatientClaimNumber := frmPatientListRestricted.fmCvrCnumberPt.caption;
      Cnumber.Caption := frmPatientListRestricted.fmCvrCnumberPt.caption;
    End;
    //End Addition 200806101108

    Page95Control1.ActivePage := Tab7131Request;
    Page95Control1.ActivePage := TabCPExams;
    Page95Control1.Visible := True;
    AnimateLogo(True);
    StatusBarLoadPt.Caption := 'Refresh address.';
    ProgressBarLoadPt.Repaint;
    frmMain.Repaint;
    btnRefreshAddressClick(Application);
    ProgressBarLoadPt.Position := 2;
    ProgressBarLoadPt.Repaint;
    frmMain.Repaint;
    AnimateLogo(True);
    StatusBarLoadPt.Caption := 'Refresh exams.';
    ProgressBarLoadPt.Repaint;
    frmMain.Repaint;
    ExamRequestRefreshClick(Application);
    ProgressBarLoadPt.Position := 3;
    ProgressBarLoadPt.Repaint;
    frmMain.Repaint;
    AnimateLogo(True);
    StatusBarLoadPt.Caption := 'Refresh 7131''s.';
    ProgressBarLoadPt.Repaint;
    frmMain.Repaint;
    SeventyOne31RequestRefreshClick(Application);
    RichEditDODReport.Lines.Clear;
    ORListBoxDODReportTypes.ItemIndex := -1;
    ProgressBarLoadPt.Position := 4;
    ProgressBarLoadPt.Repaint;
    frmMain.Repaint;
    Page95Control1.Repaint;
    AnimateLogo(True);
    StatusBarLoadPt.Caption := 'Refresh appointments.';
    ProgressBarLoadPt.Repaint;
    frmMain.Repaint;
    btnAllClick(Application);
    ProgressBarLoadPt.Position := 5;
    ProgressBarLoadPt.Repaint;
    frmMain.Repaint;
    AnimateLogo(True);
    StatusBarLoadPt.Caption := 'Refresh demographics.';
    ProgressBarLoadPt.Repaint;
    frmMain.Repaint;
    btnRefreshPtDemographicsClick(Application);
    ProgressBarLoadPt.Position := 6;
    ProgressBarLoadPt.Repaint;
    frmMain.Repaint;
    btnDocsRefreshClick(Application);
    PanelReportChoice.Visible := False;
    panelReportChoice2.Visible := False;
    LoadReportsOptions;
    AnimateLogo(True);
    StatusBarLoadPt.Caption := 'Load HS types.';
    ProgressBarLoadPt.Repaint;
    frmMain.Repaint;
    btnLoadHSNamesClick(Application);
    ProgressBarLoadPt.Position := 7;
    ProgressBarLoadPt.Repaint;
    frmMain.Repaint;
    Tab95Control2.Tabs.Clear;
    Tab95Control2.Tabs.Add('Local');
    HSMemoLocal.Lines.Clear;
    ComboBoxHSSections.Items.Clear;
    TimerRemoteData.Enabled := False;
    ListBoxRemoteDataPending.Items.Clear;                                       // Clear Remote Data Requests;
    AnimateLogo(True);
    StatusBarLoadPt.Caption := 'Updating audit trail...';
    ProgressBarLoadPt.Repaint;
    frmMain.Repaint;
    ProgressBarLoadPt.Position := 8;
    ProgressBarLoadPt.Repaint;
    frmMain.Repaint;
    UpdateAuditOnHomeServer;
    Page95Control1.Enabled := True;
    ProgressBarLoadPt.Visible := False;
    AnimateLogo(False);
    If ((UserHasNewStyleRestrictedList < 1) Or (sender = contextorControl) Or (sender = actFileSwitchSites)) Then
    Begin
      Panel1.Caption := frmPatientList.fmCvrNamePt.caption + '  SSN#' + frmPatientList.fmCvrSSNPt.caption;
      If frmPatientList.FMCvrICNPt.caption <> '' Then
        labelICN.Caption := 'ICN: ' + frmPatientList.FMCvrICNPt.caption;
      If frmPatientList.FMCvrBirthdatePt.caption <> '' Then
        labelDOB.Caption := 'DOB: ' + frmPatientList.FMCvrBirthdatePt.caption;
    End
    Else
    Begin
      Panel1.Caption := frmPatientListRestricted.fmCvrNamePt.caption + '  SSN#' + frmPatientListRestricted.fmCvrSSNPt.caption;
      If frmPatientListRestricted.FMCvrICNPt.caption <> '' Then
        labelICN.Caption := 'ICN: ' + frmPatientListRestricted.FMCvrICNPt.caption;
      If frmPatientListRestricted.FMCvrBirthdatePt.caption <> '' Then
        labelDOB.Caption := 'DOB: ' + frmPatientListRestricted.FMCvrBirthdatePt.caption;
    End;

    StatusBarLoadPt.Caption := 'Ready.';
    AnimateLogo(False);

    if EssoVersion = False Then
    begin
      BitBtnVistA.Enabled := False;
    end
    else
    begin
      BitBtnVistA.Enabled := True;                                              //only remote connections - rpm 3/17/09
    end;

    //ChangeVerifyCode1.enabled:=True;
//    CheckRemoteConnections1.Visible := remoteconnectionsx;
//    //RPCBrokerCallHistoryBuffer1.Visible:=xxxxxxxx
//    N8.Visible := remoteconnectionsx;
//    EditRemoteUserSiteAccess1.Visible := remoteconnectionsx;
//    EditPatientLists1.Visible := remoteconnectionsx;
//    ConsolidatedReports1.Visible := remoteconnectionsx;
//    actHelpAuditUtil.Visible := remoteconnectionsx;
    ScrollBoxAddress.VertScrollBar.Position := 0;
    ScrollBoxAddress.HorzScrollBar.Position := 0;
  End;
  If (PatientIEN = '') Or (patientname = '') Or (patientSSN = '') Then
  Begin
    ClearForm;                                                                  //CodeCR248 - rpm 3/8/12 - clear the header and tab set
    EditSearchPN.Text := '';
    patientname := '';
    AnimateLogo(False);
    StatusBarLoadPt.Caption := 'Ready.';
  End;

  // DONE: LMS Capture more info here for later use in CCR
  If UserHasNewStyleRestrictedList = 1 Then begin
    PatientAge := frmPatientListRestricted.FMCvrAgePt.Caption;
    PatientSex := frmPatientListRestricted.fmCvrSexPt.caption;
  End Else begin
    PatientAge := frmPatientList.fmCvrAgePt.caption;
    PatientSex := frmPatientList.fmCvrSexPt.caption;
        //PatientName := frmPatientList.FMCvrNamePt.caption;
  end;

  frmPatientList.release;
  frmPatientList := Nil;
  frmPatientListRestricted.release;
  frmPatientListRestricted := Nil;
  If ReadOnlyMode = True Then
  Begin
    btnAddRequest.Enabled := False;
    btnEditAddress.enabled := False;
    btnAdd7131.enabled := False;
    btnView7131.Caption := 'View Selected Request';
    btnViewExam.Caption := 'View Selected Request';
    actToolsChangeAddress.Visible := false;
    actToolsSearch.Visible := False;
    TabCPWorksheets.TabVisible := False;
    actToolsUnsignedWorkSheets.Visible := False;
  End;

  actCCRLaunch.Visible := IsCCRUser and (PatientIEN <> '');                     // DONE: LMS is this the best place?
  actCCRLaunch.Enabled := actCCRLaunch.Visible;

  RestoremenuOptions;                                                           // everything is commented out in this method
  CCOWIconSetup;
  CCOWInitialized := True;
  ContextorChangeMessage := '';
  CCOWBreakLink := False;
end;                                                                            // ShowPatientList

{==========================================================================
 GetActiveCapriDivisions
 This procedure scans a given list of divisions and populates the Target
 list with only divisions that do not have the DISABLE ALL EXAMS? (#4)
 field set to YES in the CAPRI DIVISION EXAM LIST (#396.15) file.

 Input:
   aDivisionList:TStrings in the format 'name  facility#^IEN' (Ex. 'Albany 500^1')
   Target:TStrings - output target list
 Output:
   Target:TStrings - filtered divisionlist in the format 'name  facility#^IEN'
                     on success; otherwise returns the input list.

 CodeCR173 - rpm 4/18/11
             rpm 5/11/11 - add $G to Screen to protect against missing 3 node
 ===========================================================================}

procedure TfrmMain.GetActiveCapriDivisions(aDivisionList, Target: TStrings);
var
  I, MatchIndex: Integer;
  FMlstrCapriDivisions: TFMLister;
  lstActiveDivisions, lstResults: TStringList;
begin
  lstActiveDivisions := TStringList.Create;
  lstResults := TStringList.Create;
  lstActiveDivisions.Sorted := True;

  //setup FMLister to retrieve active CAPRI division IEN's
  FMlstrCapriDivisions := TFMLister.Create(nil);
  FMlstrCapriDivisions.RPCBroker := RPCBroker1;
  FMlstrCapriDivisions.FileNumber := '396.15';                                  //CAPRI DIVISION EXAM LIST
  FMlstrCapriDivisions.FieldNumbers.Add('.01');                                 //DIVISION
  FMlstrCapriDivisions.ListerFlags := [lfInternal];
  FMlstrCapriDivisions.Number := '*';                                           //scan all records
  FMlstrCapriDivisions.Screen := 'I $P($G(^(3)),U,1)''="Y"';                    //return only active

  CAPRIQuickCopy(aDivisionList, Target);                                        //at least return the passed in list
  try
    FMlstrCapriDivisions.GetList(lstActiveDivisions);
    if lstActiveDivisions.Count > 0 Then
    begin
      for I := 0 to aDivisionList.Count - 1 Do
      begin
        MatchIndex := lstActiveDivisions.IndexOf(Piece(aDivisionList.Strings[I], '^', 2));
        if (MatchIndex > -1) then
          lstResults.Add(aDivisionList.Strings[I]);
      end;
      CAPRIQuickCopy(lstResults, Target);
    end;
  finally
    FreeAndNil(lstActiveDivisions);
    FreeAndNil(lstResults);
    FreeAndNil(FMlstrCapriDivisions);
  end;
end;                                                                            //GetActiveCapriDivisions

{==============================================================================
 GetAllDivisions
 This procedure retrieves the NAME and FACILITY NUMBER fields from all
 MEDICAL CENTER DIVISION records and populates each index in the passed list
 with the division Name followed by 2 spaces, the facility number, caret
 delimiter, and record IEN.

 Input:  aDivisionList:TStrings - output target list
 Output: aDivisionList:TStrings - formatted list of divisions
                                  Format:  'NAME  FACILITY#^IEN'

 CodeCR186 - rpm 4/18/11
 ==============================================================================}

procedure TfrmMain.GetAllDivisions(aDivisionList: TStrings);
var
  I: integer;
  aName, aFacilityNumber: String;
  FMlstrDivisions: TFMLister;
  lstDivisions: TStringList;
begin
  //setup FMLister to retrieve active CAPRI division IEN's
  lstDivisions := TstringList.Create;
  FMlstrDivisions := TFMLister.Create(nil);
  FMlstrDivisions.RPCBroker := RPCBroker1;
  FMlstrDivisions.FileNumber := '40.8';                                         //MEDICAL CENTER DIVISION
  FMlstrDivisions.FieldNumbers.Add('.01');                                      //NAME
  FMlstrDivisions.FieldNumbers.Add('1');                                        //FACILITY NUMBER
  FMlstrDivisions.ListerFlags := [];
  FMlstrDivisions.Number := '*';                                                //get all records

  try
    aDivisionList.Clear;
    FMlstrDivisions.GetList(nil);
    if FMlstrDivisions.Results.Count > 0 Then
    begin
      //move IENs to a sortable list
      CAPRIQuickCopy(FMlstrDivisions.Results, lstDivisions);
      //sort in IEN order
      lstDivisions.Sorted := True;
      //build output record: name + 2spaces + facility# + '^' + IEN
      for I := 0 To lstDivisions.Count - 1 Do
      begin
        aName := FMlstrDivisions.GetRecord(lstDivisions[I]).GetField('.01').FMDBExternal;
        aFacilityNumber := FMlstrDivisions.GetRecord(lstDivisions[I]).GetField('1').FMDBExternal;
        aDivisionList.Add(aName + '    ' + aFacilityNumber + '^' + lstDivisions[I]);
      end;
    end;
  finally
    FreeAndNil(FMlstrDivisions);
    FreeAndNil(lstDivisions);
  end;
end;                                                                            //GetAllDivisions

{===========================================================================
 GetDisplayGrpIEN
 This function retrieves the IEN for a given NAME from the DISPLAY GROUP
 (#100.98) file.
 AMIE access to file #100.98 allowed by Controlled Subscription IA# 873.

 Input: aDisplayGroup:String - Display group name value
 Output: function result:String - returns IEN of matching record on success;
                                  otherwise returns '0' on no match or ''
                                  on error.
 CodeCR178 - rpm 4/18/11
 ===========================================================================}

function TfrmMain.GetDisplayGrpIEN(aDisplayGroup: String): String;
var
  FMDisplayGrp: TFMFindOne;
  DGIEN: String;
begin
  DGIEN := '';
  FMDisplayGrp := TFMFindOne.Create(nil);
  FMDisplayGrp.RPCBroker := RPCBroker1;
  FMDisplayGrp.Value := aDisplayGroup;
  FMDisplayGrp.FMIndex := 'B';                                                  //lookup index
  FMDisplayGrp.FileNumber := '100.98';                                          //DISPLAY GROUP
  try
    DGIEN := FMDisplayGrp.GetIEN;
  finally
    FreeAndNil(FMDisplayGrp);
  end;
  Result := DGIEN;
end;                                                                            //GetDisplayGrpIEN

//Merged mnj

procedure TfrmMain.actHIASearchExecute(Sender: TObject);
begin
  try
    frmhiaverifypatientlist := Tfrmhiaverifypatientlist.Create(nil);
    frmhiaverifypatientlist.ShowModal;
  finally
    FreeAndNil(frmhiaverifypatientlist);
  end;
end;

{==========================================================================
 ClearForm
 This procedure initializes the form header and the tab set in preparation
 for an initial patient selection after connecting to a site.  It clears
 the demographics from the main form header, hides the tab set, and sets
 the active tab to "C&P Exam".  The code was refactored out of the
 actFileConnectExecute and ShowPatientList procedures.

 CodeCR248 - rpm 3/8/12
 ==========================================================================}

procedure TfrmMain.ClearForm;
begin
  Page95Control1.ActivePage := TabCPExams;
  Page95Control1.Visible := False;
  Panel1.Caption := '';
  LabelDOB.Caption := '';                                                       //CodeCR201 - rpm 11/2/11
  LabelICN.Caption := '';                                                       //CodeCR201 - rpm 11/2/11
end;                                                                            //ClearForm


//------------------------------------------------------------------------------
// VocRehab - Request listbox clicked
//------------------------------------------------------------------------------
// This button press allows the user to edit a Vocational Rehab Medical Request
// for Services
// CodeCR347 - jrl 6/6/12
//------------------------------------------------------------------------------

procedure TfrmMain.lbVocRehabClick(Sender: TObject);
begin
  // don't enable edit button if "No records found" is displayed
  if lbVocRehab.Count = 1 then
    if lbVocRehab.Items[0] = 'No records found' then
    begin
      btnVREditRequest.Enabled := FALSE;
      exit;
    end;
  // if no medical requests exist, disable edit button
  if lbVocRehab.ItemIndex <> -1 then
    btnVREditRequest.Enabled := TRUE
  else
    btnVREditRequest.Enabled := FALSE;
end;

//------------------------------------------------------------------------------
// VocRehab - Add New Request button clicked
//------------------------------------------------------------------------------
// This button press allows the user to input a new Vocational Rehab Medical
// Request for Services
// CodeCR347 - jrl 5/22/12
//------------------------------------------------------------------------------

procedure TfrmMain.btnVRAddNewRequestClick(Sender: TObject);
begin
  VocRehab.AddExam := TRUE;
  try
    frmVRMedicalRequest := TfrmVRMedicalRequest.Create(Application);
    frmVRMedicalRequest.SelectedMedicalRequestIEN := '+1,';                     // New IEN
    frmVRMedicalRequest.SetupNewExam;
    frmVRMedicalRequest.ShowModal;
  finally
    FreeAndNil(frmVRMedicalRequest);
  end;
  VocRehab.SetupMedicalServicesList;

end;

//------------------------------------------------------------------------------
// VocRehab - Edit Request button clicked
//------------------------------------------------------------------------------
// This button press allows the user to edit a Vocational Rehab Medical Request
// for Services
// CodeCR347 - jrl 5/22/12
//------------------------------------------------------------------------------

procedure TfrmMain.btnVREditRequestClick(Sender: TObject);
var
  buffer: string;
  LenTotal, LenCol2, LenCol3: Integer;
  CompletedDateStr: string;
  CancelledDateStr: string;
begin
  VocRehab.AddExam := FALSE;
  try
    if lbVocRehab.ItemIndex = -1 then                                           // don't allow empty selection
      exit;
    frmVRMedicalRequest := TfrmVRMedicalRequest.Create(Application);
    frmVRMedicalRequest.SelectedMedicalRequestIEN := IntToStr(Integer(lbVocRehab.Items.Objects[lbVocRehab.ItemIndex]));
    buffer := lbVocRehab.Items[lbVocRehab.ItemIndex];
     // if the selected item has either a completed or cancelled date, set a
     // flag so that the medical request can be displayed, but not edited
    frmMain.VocRehab.RequestCompleted := FALSE;                                 // default to No Completed date
    LenTotal := length(buffer);
    if LenTotal > frmMain.VocRehab.FIELD3COL then
    begin
      LenCol2 := frmMain.VocRehab.FIELD3COL - frmMain.VocRehab.FIELD2COL;
      lenCol3 := length(buffer) - frmMain.VocRehab.FIELD3COL;
    end
    else if LenTotal > frmMain.VocRehab.FIELD2COL then
    begin
      LenCol2 := LenTotal - frmMain.VocRehab.FIELD2COL;
      LenCol3 := 0;
    end
    else
    begin
      LenCol2 := 0;
      LenCol3 := 0;
    end;
    if LenCol2 > 0 then
      CompletedDateStr := Copy(buffer, frmMain.VocRehab.FIELD2COL, LenCol2)
    else
      CompletedDateStr := '';
    if LenCol3 > 0 then
      CancelledDateStr := Copy(buffer, frmMain.VocRehab.FIELD3COL + 1, LenCol3 - 1)
    else
      CancelledDateStr := '';
    if CompletedDateStr[3] = ' ' then
      frmMain.VocRehab.RequestCompleted := FALSE
    else if (VAUtils.ScreenReaderActive = TRUE) AND (CompletedDateStr[3] = '[') then // [Not Completed] text displayed for screen reader
      frmMain.VocRehab.RequestCompleted := FALSE
    else
      frmMain.VocRehab.RequestCompleted := TRUE;
    if CancelledDateStr = '' then
      frmMain.VocRehab.RequestCancelled := FALSE
    else
      frmMain.VocRehab.RequestCancelled := TRUE;

    frmVRMedicalRequest.SetupExistingExam;
    frmVRMedicalRequest.ShowModal;
  finally
    FreeAndNil(frmVRMedicalRequest);
  end;
  VocRehab.SetupMedicalServicesList;

end;

{============================================================================
 DoLegacyEnterpriseSearch
 This procedure contains refactored code from the actToolsSearchExecute that
 supports calling the Legacy Enterprise Search that uses the RPCBroker
 connection and patient lookup at a list of remote sites.

 CodeCR267 - rpm 8/28/12
 ============================================================================}

procedure TfrmMain.DoLegacyEnterpriseSearch(Sender: TObject);
var
  RemoteDataTimer: Boolean;
begin
  RemoteDataTimer := TimerRemoteData.Enabled;
  TimerRemoteData.Enabled := false;
  timeouttimer.enabled := false;

  frmFindPatientAnywhere := TfrmFindPatientAnywhere.Create(frmMain);
  frmFindPatientAnywhere.Top := frmMain.Top + ((frmMain.height - frmFindPatientAnywhere.height) Div 2);
  frmFindPatientAnywhere.Left := frmMain.Left + ((frmMain.width - frmFindPatientAnywhere.width) Div 2);
  ContextorChangeMessage := 'You are be searching for patients on other VistA systems.  If you continue, CAPRI will drop out of the clinical context.';
  CCOWBreakLink := True;
  try
    If frmPatientListRestricted <> nil Then
    Begin
      If sender = frmPatientListRestricted.btnSearch Then
      Begin
        frmFindPatientAnywhere.edit1.enabled := false;
        frmFindPatientAnywhere.edit1.text := piece(frmPatientListRestricted.ORListBox1.items[frmPatientListRestricted.ORListbox1.itemindex], '^', 6);
      End;
    End;

    frmFindPatientAnywhere.Showmodal;                                           // Check for cancel button and exit
  finally
    ContextorChangeMessage := '';
    CCOWBreakLink := False;
    frmFindPatientAnywhere.release;
    frmFindPatientAnywhere := Nil;
    timeouttimer.enabled := true;
    TimerRemoteData.Enabled := RemoteDataTimer;
  end;
end;

{=======================================================================
 DoMVISiteSwitch
 This procedure calls the appropriate event handler method to initiate a
 site switch.  Specific methods called are based on the site switching
 functionality used by the Remote Sites dialog and are controlled by the
 source of the MVI Enterprise Search call.  The site switch depends on 2
 global variables being set by the MVI Enterprise Search: SwitchToSite
 and SwitchToPatientSSN.

 CodeCR267 - rpm 8/30/12
 =======================================================================}

procedure TfrmMain.DoMVISiteSwitch(Sender: TObject);
begin
  if (SwitchToSite <> '') and (SwitchToPatientSSN <> '') then
  begin
    if Assigned(frmPatientList) then                                            //MVI search called from Patient Selector
    begin
      if (frmPatientList.Visible) then
        frmPatientList.btnCvrCancelPtClick(Sender);
    end
    else if Assigned(frmPatientListRestricted) then                             //MVI search called from Patient Selector (Restricted Lists)
    begin
      if (frmPatientListRestricted.Visible) then
        frmPatientListRestricted.btnCvrCancelPtClick(Sender);
    end
    else                                                                        //MVI Search called from Tools/Enterprise Search for Patient option
    begin
      actFileSelectPatientExecute(contextorControl);
    end;
  end;
end;

{===========================================================================
 IsButtonTagOne
 This function returns TRUE when the Sender is a TButton with the Tag
 property set to '1'.  Otherwise, FALSE is returned.

 //CodeCR267 - rpm 8/30/12
 ===========================================================================}

function TfrmMain.IsButtonTagOne(Sender: TObject): Boolean;
begin
  Result := False;
  if (Sender is TButton) then
  begin
    if ((Sender as TButton).Tag = 1) then
      Result := True;
  end;
end;

{===========================================================================
 LoadRestrictedSearchTraits
 This procedure populates the public trait properties on the new Enterprise
 Search form from the Patient List Restricted.  The properties will be used
 to control access the the search trait fields.

 //CodeCR267 - rpm 9/13/12
 ===========================================================================}

procedure TfrmMain.LoadRestrictedSearchTraits;
begin
  if Assigned(frmMVIEnterpriseSearch) and
    Assigned(frmPatientListRestricted) then
  begin
    if (frmPatientListRestricted.ORListbox1.itemindex > -1) then
    begin
      frmMVIEnterpriseSearch.FullNameRestricted := piece(frmPatientListRestricted.ORListBox1.items[frmPatientListRestricted.ORListbox1.itemindex], '^', 3);
      frmMVIEnterpriseSearch.SSNRestricted := piece(frmPatientListRestricted.ORListBox1.items[frmPatientListRestricted.ORListbox1.itemindex], '^', 6);
      frmMVIEnterpriseSearch.DOBRestricted := piece(frmPatientListRestricted.ORListBox1.items[frmPatientListRestricted.ORListbox1.itemindex], '^', 7);
      frmMVIEnterpriseSearch.ICNRestricted := piece(frmPatientListRestricted.ORListBox1.items[frmPatientListRestricted.ORListbox1.itemindex], '^', 8);
    end;
  end;
end;

//------------------------------------------------------------------------------
// Remove Special Characters                              CodeCR522 JRL 11/15/13
//------------------------------------------------------------------------------
// VVA cannot handle any special characters in the exam name.  Remove/replace.
// *  Remove exam status [Open] from the name.
// *  Replace "&" with "and".
// *  Replace the following special characters with spaces: ()-=*!@#$%^*[]{}\|?/<>
//    Currently, "&", "(" and ")" are the only characters used but CAPRI doesn't
//    own the exam names - code for future.
//------------------------------------------------------------------------------

function TfrmMain.RemoveSpecialCharacters(InputExamName: string): string;
var
  buffer: string;
//   i : Integer;  // LMS Not needed
begin
  buffer := TrimRight(InputExamName);
  buffer := StringReplace(buffer, '[OPEN]', '', [rfReplaceAll, rfIgnoreCase]);
  buffer := StringReplace(buffer, '&', 'and', [rfReplaceAll, rfIgnoreCase]);
  buffer := StringReplace(buffer, '~', ' ', [rfReplaceAll, rfIgnoreCase]);
  buffer := StringReplace(buffer, '`', ' ', [rfReplaceAll, rfIgnoreCase]);
  buffer := StringReplace(buffer, '!', ' ', [rfReplaceAll, rfIgnoreCase]);
  buffer := StringReplace(buffer, '@', ' ', [rfReplaceAll, rfIgnoreCase]);
  buffer := StringReplace(buffer, '#', ' ', [rfReplaceAll, rfIgnoreCase]);
  buffer := StringReplace(buffer, '$', ' ', [rfReplaceAll, rfIgnoreCase]);
  buffer := StringReplace(buffer, '%', ' ', [rfReplaceAll, rfIgnoreCase]);
  buffer := StringReplace(buffer, '^', ' ', [rfReplaceAll, rfIgnoreCase]);
  buffer := StringReplace(buffer, '*', ' ', [rfReplaceAll, rfIgnoreCase]);
  buffer := StringReplace(buffer, '(', ' ', [rfReplaceAll, rfIgnoreCase]);
  buffer := StringReplace(buffer, ')', ' ', [rfReplaceAll, rfIgnoreCase]);
  buffer := StringReplace(buffer, '_', ' ', [rfReplaceAll, rfIgnoreCase]);
  buffer := StringReplace(buffer, '-', ' ', [rfReplaceAll, rfIgnoreCase]);
  buffer := StringReplace(buffer, '+', ' ', [rfReplaceAll, rfIgnoreCase]);
  buffer := StringReplace(buffer, '=', ' ', [rfReplaceAll, rfIgnoreCase]);
  buffer := StringReplace(buffer, '[', ' ', [rfReplaceAll, rfIgnoreCase]);
  buffer := StringReplace(buffer, ']', ' ', [rfReplaceAll, rfIgnoreCase]);
  buffer := StringReplace(buffer, '{', ' ', [rfReplaceAll, rfIgnoreCase]);
  buffer := StringReplace(buffer, '}', ' ', [rfReplaceAll, rfIgnoreCase]);
  buffer := StringReplace(buffer, '|', ' ', [rfReplaceAll, rfIgnoreCase]);
  buffer := StringReplace(buffer, '\', ' ', [rfReplaceAll, rfIgnoreCase]);
  buffer := StringReplace(buffer, ':', ' ', [rfReplaceAll, rfIgnoreCase]);
  buffer := StringReplace(buffer, ';', ' ', [rfReplaceAll, rfIgnoreCase]);
  buffer := StringReplace(buffer, '"', ' ', [rfReplaceAll, rfIgnoreCase]);
  buffer := StringReplace(buffer, '''', ' ', [rfReplaceAll, rfIgnoreCase]);
  buffer := StringReplace(buffer, '<', ' ', [rfReplaceAll, rfIgnoreCase]);
  buffer := StringReplace(buffer, '>', ' ', [rfReplaceAll, rfIgnoreCase]);
  buffer := StringReplace(buffer, '?', ' ', [rfReplaceAll, rfIgnoreCase]);
  buffer := StringReplace(buffer, ',', ' ', [rfReplaceAll, rfIgnoreCase]);
  buffer := StringReplace(buffer, '.', ' ', [rfReplaceAll, rfIgnoreCase]);
  buffer := StringReplace(buffer, '/', ' ', [rfReplaceAll, rfIgnoreCase]);
  Result := buffer;
end;

//------------------------------------------------------------------------------
// Search Text on Clinical Documents Rich Text field        CodeCR696 JRL 4/8/15
//------------------------------------------------------------------------------
// Search text routine for the Clinical Documents tab -- allows the user to
// right-click and search for text within the rich text field
//------------------------------------------------------------------------------
procedure TfrmMain.RunSearch(SearchString: String);
var
  tempstring,tempstring2 : string;
begin
   SearchText.FoundAt := memoDocs.FindText(SearchString, SearchText.LastSearchFoundAt, length(memoDocs.Text), SearchText.Options);
   if SearchText.FoundAt = -1 then
   begin
      ShowMessageCAPRI('Search reached end of text.');
      MemoDocs.SelStart := 0;
      MemoDocs.SelLength := 0; 
      SearchText.FoundAt := 0;
      SearchText.LastSearchFoundAt := 0;
      Exit;
   end;
   if memoDocs.CanFocus then
      memoDocs.SetFocus;
   //First jump to bottom.
   memoDocs.SelStart := length(memoDocs.Text) - 2;
   memoDocs.SelLength := 2;
   tempString := memoDocs.SelText;
   memoDocs.SelText := '';
   memoDocs.seltext := tempstring;
   //Now find text
   memoDocs.SelStart := SearchText.FoundAt;
   memoDocs.SelLength := Length(SearchString);
   tempstring2 := memoDocs.SelText;
   // Force jump to section
   memoDocs.SelText := tempString2;
   // Re-Highlight
   memoDocs.SelStart := SearchText.FoundAt;
   memoDocs.SelLength := Length(SearchString);
   // Scroll down a few lines
   SearchText.LastSearchFoundAt := SearchText.FoundAt + length(SearchString);
end;


//------------------------------------------------------------------------------
// Find Popup Menu Item Clicked                             CodeCR696 JRL 4/8/15
//------------------------------------------------------------------------------
procedure TfrmMain.Find1Click(Sender: TObject);
begin
   if MemoDocs.CanFocus then
      MemoDocs.SetFocus;
   MemoDocs.SelStart := 0;
   MemoDocs.SelLength := 0; 
   SearchText.FoundAt := 0;
   SearchText.LastSearchFoundAt := 0;
   // Originally, there was a Find Dialog execute here.  But it caused an error
   // on execute "Cannot focus a disabled or invisible window".  Was unable to
   // get past the error so a separate form was created to mimic the search
   // dialog with no issue.  Form is freed in FrmMain.FormClose routine. 
   // CodeCR696 JRL 4/8/15
   frmSearchText := TfrmSearchText.Create(Application);                         
   frmSearchText.Show;                                                          
// FindTextDlg.Execute;                                                         
end;

//------------------------------------------------------------------------------
// Find Next Popup Menu Item Clicked                        CodeCR696 JRL 4/8/15
//------------------------------------------------------------------------------
procedure TfrmMain.FindNext1Click(Sender: TObject);
begin
   RunSearch(SearchText.FindText);
   if MemoDocs.CanFocus then
      MemoDocs.SetFocus;
end;

//------------------------------------------------------------------------------
// FindTextDlg Find button clicked                          CodeCR696 JRL 4/8/15
// Find Dialog box could not be made to work - deleted
//------------------------------------------------------------------------------
//procedure TfrmMain.FindTextDlgFind(Sender: TObject);
//begin
//   SearchText.Options := [];
//   SearchText.FindText := FindTextDlg.FindText;
//   if frMatchCase in FindTextDlg.Options then   // case-sensitive search?
//      SearchText.Options := [stMatchCase];
//   if frWholeWord in FindTextDlg.Options then   // whole word search?        
//      SearchText.Options := [stWholeWord];
//   RunSearch(SearchText.FindText);
//   if MemoDocs.CanFocus then
//      MemoDocs.SetFocus;
//end;

//------------------------------------------------------------------------------
// FindTextDlg Dialog Show                                  CodeCR696 JRL 4/8/15
// Find Dialog box could not be made to work - deleted
//------------------------------------------------------------------------------
// Show the dialog on the left side of the screen so the searched fields are
// clearly visible on the right.
//------------------------------------------------------------------------------
//procedure TfrmMain.FindTextDlgShow(Sender: TObject);
//begin
//   FindTextDlg.Top := 50;
//   FindTextDlg.Left := 50;
//end;

{==============================================================================
 The following initialization and finalization was added to tap into the call
 stack functionality of the JCL   ug unit. The call stack will be included in
 the CAPRI log file.

 CAPRI_CodeCR94 - jcs - 03/02/10
 ==============================================================================}
initialization

  // Enable raw mode (default mode uses stack frames which aren't always generated by the compiler)
  Include(JclStackTrackingOptions, stRawMode);

  // Disable stack tracking in dynamically loaded modules (it makes stack tracking code a bit faster)
  Include(JclStackTrackingOptions, stStaticModuleList);

  // Initialize Exception tracking
  JclStartExceptionTracking;

finalization

  // Uninitialize Exception tracking
  JclStopExceptionTracking;

End.

